/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],_=0,P=G.length;_<P;_++)e[_]=me[G[_]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(P,A){if(!P)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=_}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function P(R){const C=[];for(let g in R)_.call(R,g)&&C.push(R[g]);return C}e.values=P;function A(R,C){for(let g in R)if(_.call(R,g)&&C({key:g,value:R[g]},function(){delete R[g]})===!1)return}e.forEach=A;function I(R,C){const g=Object.create(null);for(const m of R){const s=C(m);let d=g[s];d||(d=g[s]=[]),d.push(m)}return g}e.groupBy=I;function D(R){const C=Object.create(null);return R&&R.forEach((g,m)=>{C[m]=g}),C}e.fromMap=D;function k(R,C){const g=[],m=[];for(let s of R)C.has(s)||g.push(s);for(let s of C)R.has(s)||m.push(s);return{removed:g,added:m}}e.diffSets=k;function y(R,C){const g=[],m=[];for(let[s,d]of R)C.has(s)||g.push(d);for(let[s,d]of C)R.has(s)||m.push(d);return{removed:g,added:m}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(C,g){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(g)}delete(C,g){const m=this.map.get(C);!m||(m.delete(g),m.size===0&&this.map.delete(C))}forEach(C,g){const m=this.map.get(C);!m||m.forEach(g)}}e.SetMap=n}),define(me[69],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(y){return(n,R,C)=>{let g=null,m=null;if(typeof C.value=="function"?(g="value",m=C.value):typeof C.get=="function"&&(g="get",m=C.get),!m)throw new Error("not supported");C[g]=y(m,R)}}e.createDecorator=_;let P=0;function A(){const y=`$memoize${P++}`;let n;const R=function(g,m,s){let d=null,S=null;if(typeof s.value=="function"?(d="value",S=s.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof s.get=="function"&&(d="get",S=s.get),!S)throw new Error("not supported");const w=`${y}:${m}`;s[d]=function(...b){return n=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,b)}),this[w]}};return R.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(C=>{C.indexOf(y)===0&&delete n[C]})},R}e.createMemoizer=A;function I(y,n,R){return A()(y,n,R)}e.memoize=I;function D(y,n,R){return _((C,g)=>{const m=`$debounce$${g}`,s=`$debounce$result$${g}`;return function(...d){this[s]||(this[s]=R?R():void 0),clearTimeout(this[m]),n&&(this[s]=n(this[s],...d),d=[this[s]]),this[m]=setTimeout(()=>{C.apply(this,d),this[s]=R?R():void 0},y)}})}e.debounce=D;function k(y,n,R){return _((C,g)=>{const m=`$throttle$timer$${g}`,s=`$throttle$result$${g}`,d=`$throttle$lastRun$${g}`,S=`$throttle$pending$${g}`;return function(...w){if(this[s]||(this[s]=R?R():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),n&&(this[s]=n(this[s],...w)),!this[S]){const b=this[d]+y;b<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0):(this[S]=!0,this[m]=setTimeout(()=>{this[S]=!1,this[d]=Date.now(),C.apply(this,[this[s]]),this[s]=R?R():void 0},b-Date.now()))}}})}e.throttle=k}),define(me[18],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function P(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=P;function A(l){y(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=A;function I(l){y(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=I;function D(l){if(l instanceof Error){let{name:t,message:i}=l;const a=l.stacktrace||l.stack;return{$isError:!0,name:t,message:i,stack:a}}return l}e.transformErrorForSerialization=D;const k="Canceled";function y(l){return l instanceof Error&&l.name===k&&l.message===k}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=n;function R(){const l=new Error(k);return l.name=l.message,l}e.canceled=R;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function g(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=g;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function s(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=s;function d(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=d;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function v(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function u(l,t=Object.create(null)){const i=new Error(l);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=u}),define(me[14],ge([0,1,18]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P(F,U=0){return F[F.length-(1+U)]}e.tail=P;function A(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=A;function I(F,U,M=(N,O)=>N===O){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let N=0,O=F.length;N<O;N++)if(!M(F[N],U[N]))return!1;return!0}e.equals=I;function D(F,U,M){let N=0,O=F.length-1;for(;N<=O;){const V=(N+O)/2|0,q=M(F[V],U);if(q<0)N=V+1;else if(q>0)O=V-1;else return V}return-(N+1)}e.binarySearch=D;function k(F,U){let M=0,N=F.length;if(N===0)return 0;for(;M<N;){const O=Math.floor((M+N)/2);U(F[O])?N=O:M=O+1}return M}e.findFirstInSorted=k;function y(F,U,M){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let N=U[Math.floor(U.length*Math.random())],O=[],V=[],q=[];for(let X of U){const fe=M(X,N);fe<0?O.push(X):fe>0?V.push(X):q.push(X)}return F<O.length?y(F,O,M):F<O.length+q.length?q[0]:y(F-(O.length+q.length),V,M)}e.quickSelect=y;function n(F,U){const M=[];let N;for(const O of F.slice(0).sort(U))!N||U(N[0],O)!==0?(N=[O],M.push(N)):N.push(O);return M}e.groupBy=n;function R(F,U,M){const N=[];function O(X,fe,ve){if(!(fe===0&&ve.length===0)){const Ae=N[N.length-1];Ae&&Ae.start+Ae.deleteCount===X?(Ae.deleteCount+=fe,Ae.toInsert.push(...ve)):N.push({start:X,deleteCount:fe,toInsert:ve})}}let V=0,q=0;for(;;){if(V===F.length){O(V,0,U.slice(q));break}if(q===U.length){O(V,F.length-V,[]);break}const X=F[V],fe=U[q],ve=M(X,fe);ve===0?(V+=1,q+=1):ve<0?(O(V,1,[]),V+=1):ve>0&&(O(V,0,[fe]),q+=1)}return N}e.sortedDiff=R;function C(F,U,M){const N=R(F,U,M),O=[],V=[];for(const q of N)O.push(...F.slice(q.start,q.start+q.deleteCount)),V.push(...q.toInsert);return{removed:O,added:V}}e.delta=C;function g(F,U,M){if(M===0)return[];const N=F.slice(0,M).sort(U);return s(F,U,N,M,F.length),N}e.top=g;function m(F,U,M,N,O){return M===0?Promise.resolve([]):new Promise((V,q)=>{(async()=>{const X=F.length,fe=F.slice(0,M).sort(U);for(let ve=M,Ae=Math.min(M+N,X);ve<X;ve=Ae,Ae=Math.min(Ae+N,X)){if(ve>M&&await new Promise(Pe=>setTimeout(Pe)),O&&O.isCancellationRequested)throw(0,_.canceled)();s(F,U,fe,ve,Ae)}return fe})().then(V,q)})}e.topAsync=m;function s(F,U,M,N,O){for(const V=M.length;N<O;N++){const q=F[N];if(U(q,M[V-1])<0){M.pop();const X=k(M,fe=>U(q,fe)<0);M.splice(X,0,q)}}}function d(F){return F.filter(U=>!!U)}e.coalesce=d;function S(F){let U=0;for(let M=0;M<F.length;M++)F[M]&&(F[U]=F[M],U+=1);F.length=U}e.coalesceInPlace=S;function w(F,U,M){F.splice(M,0,F.splice(U,1)[0])}e.move=w;function b(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=b;function v(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=v;function u(F,U){if(!U)return F.filter((N,O)=>F.indexOf(N)===O);const M=Object.create(null);return F.filter(N=>{const O=U(N);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=u;function l(F){const U=new Set;return F.filter(M=>U.has(M)?!1:(U.add(M),!0))}e.distinctES6=l;function t(F){const U=Object.create(null);return M=>{const N=F(M);return U[N]?!1:(U[N]=!0,!0)}}e.uniqueFilter=t;function i(F,U){for(let M=F.length-1;M>=0;M--){const N=F[M];if(U(N))return M}return-1}e.lastIndex=i;function a(F,U){return F.length>0?F[0]:U}e.firstOrDefault=a;function r(F,U,M=(N,O)=>N===O){let N=0;for(let O=0,V=Math.min(F.length,U.length);O<V&&M(F[O],U[O]);O++)N++;return N}e.commonPrefixLength=r;function c(F){return[].concat(...F)}e.flatten=c;function o(F,U){let M=typeof U=="number"?F:0;typeof U=="number"?M=F:(M=0,U=F);const N=[];if(M<=U)for(let O=M;O<U;O++)N.push(O);else for(let O=M;O>U;O--)N.push(O);return N}e.range=o;function p(F,U,M){return F.reduce((N,O)=>(N[U(O)]=M?M(O):O,N),Object.create(null))}e.index=p;function E(F,U){return F.push(U),()=>f(F,U)}e.insert=E;function f(F,U){const M=F.indexOf(U);if(M>-1)return F.splice(M,1),U}e.remove=f;function h(F,U,M){const N=F.slice(0,U),O=F.slice(U);return N.concat(M,O)}e.arrayInsert=h;function T(F,U){let M;if(typeof U=="number"){let N=U;M=()=>{const O=Math.sin(N++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let N=F.length-1;N>0;N-=1){const O=Math.floor(M()*(N+1)),V=F[N];F[N]=F[O],F[O]=V}}e.shuffle=T;function L(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.unshift(U))}e.pushToStart=L;function W(F,U){const M=F.indexOf(U);M>-1&&(F.splice(M,1),F.push(U))}e.pushToEnd=W;function ee(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=ee;function j(F){return Array.isArray(F)?F:[F]}e.asArray=j;function x(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=x;function $(F,U){for(const M of F){const N=U(M);if(N!==void 0)return N}}e.mapFind=$}),define(me[70],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(P){const A=this;let I=!1,D;return function(){return I||(I=!0,D=P.apply(A,arguments)),D}}e.once=_}),define(me[71],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(P){function A(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}P.is=A;const I=Object.freeze([]);function D(){return I}P.empty=D;function*k(l){yield l}P.single=k;function y(l){return l||I}P.from=y;function n(l){return!l||l[Symbol.iterator]().next().done===!0}P.isEmpty=n;function R(l){return l[Symbol.iterator]().next().value}P.first=R;function C(l,t){for(const i of l)if(t(i))return!0;return!1}P.some=C;function g(l,t){for(const i of l)if(t(i))return i}P.find=g;function*m(l,t){for(const i of l)t(i)&&(yield i)}P.filter=m;function*s(l,t){for(const i of l)yield t(i)}P.map=s;function*d(...l){for(const t of l)for(const i of t)yield i}P.concat=d;function*S(l){for(const t of l)for(const i of t)yield i}P.concatNested=S;function w(l,t,i){let a=i;for(const r of l)a=t(a,r);return a}P.reduce=w;function*b(l,t,i=l.length){for(t<0&&(t+=l.length),i<0?i+=l.length:i>l.length&&(i=l.length);t<i;t++)yield l[t]}P.slice=b;function v(l,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,l];const a=l[Symbol.iterator]();for(let r=0;r<t;r++){const c=a.next();if(c.done)return[i,P.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return a}}]}P.consume=v;function u(l,t,i=(a,r)=>a===r){const a=l[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const c=a.next(),o=r.next();if(c.done!==o.done)return!1;if(c.done)return!0;if(!i(c.value,o.value))return!1}}P.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function D(t,i=!1){let a=0,r=t.length,c="",o=0,p=16,E=0;function f(x){let $=0,F=0;for(;$<x;){const U=t.charCodeAt(a);if(U>=48&&U<=57)F=F*16+U-48;else if(U>=65&&U<=70)F=F*16+U-65+10;else if(U>=97&&U<=102)F=F*16+U-97+10;else break;a++,$++}return $<x&&(F=-1),F}function h(x){a=x,c="",o=0,p=16,E=0}function T(){const x=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&n(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&n(t.charCodeAt(a)))for(a++;a<t.length&&n(t.charCodeAt(a));)a++;else return E=3,t.substring(x,a);let $=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&n(t.charCodeAt(a))){for(a++;a<t.length&&n(t.charCodeAt(a));)a++;$=a}else E=3;return t.substring(x,$)}function L(){let x="",$=a;for(;;){if(a>=r){x+=t.substring($,a),E=2;break}const F=t.charCodeAt(a);if(F===34){x+=t.substring($,a),a++;break}if(F===92){if(x+=t.substring($,a),a++,a>=r){E=2;break}switch(t.charCodeAt(a++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const M=f(4);M>=0?x+=String.fromCharCode(M):E=4;break;default:E=5}$=a;continue}if(F>=0&&F<=31)if(y(F)){x+=t.substring($,a),E=2;break}else E=6;a++}return x}function W(){if(c="",E=0,o=a,a>=r)return o=r,p=17;let x=t.charCodeAt(a);if(k(x)){do a++,c+=String.fromCharCode(x),x=t.charCodeAt(a);while(k(x));return p=15}if(y(x))return a++,c+=String.fromCharCode(x),x===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),p=14;switch(x){case 123:return a++,p=1;case 125:return a++,p=2;case 91:return a++,p=3;case 93:return a++,p=4;case 58:return a++,p=6;case 44:return a++,p=5;case 34:return a++,c=L(),p=10;case 47:const $=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<r&&!y(t.charCodeAt(a));)a++;return c=t.substring($,a),p=12}if(t.charCodeAt(a+1)===42){a+=2;const F=r-1;let U=!1;for(;a<F;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,U=!0;break}a++}return U||(a++,E=1),c=t.substring($,a),p=13}return c+=String.fromCharCode(x),a++,p=16;case 45:if(c+=String.fromCharCode(x),a++,a===r||!n(t.charCodeAt(a)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),p=11;default:for(;a<r&&ee(x);)a++,x=t.charCodeAt(a);if(o!==a){switch(c=t.substring(o,a),c){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return c+=String.fromCharCode(x),a++,p=16}}function ee(x){if(k(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let x;do x=W();while(x>=12&&x<=15);return x}return{setPosition:h,getPosition:()=>a,scan:i?j:W,getToken:()=>p,getTokenValue:()=>c,getTokenOffset:()=>o,getTokenLength:()=>a-o,getTokenError:()=>E}}e.createScanner=D;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,i){const a=[],r=new Object;let c;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function E(f,h,T,L){o.value=f,o.offset=h,o.length=T,o.type=L,o.colonOffset=void 0,c=o}try{v(t,{onObjectBegin:(f,h)=>{if(i<=f)throw r;c=void 0,p=i>f,a.push("")},onObjectProperty:(f,h,T)=>{if(i<h||(E(f,h,T,"property"),a[a.length-1]=f,i<=h+T))throw r},onObjectEnd:(f,h)=>{if(i<=f)throw r;c=void 0,a.pop()},onArrayBegin:(f,h)=>{if(i<=f)throw r;c=void 0,a.push(0)},onArrayEnd:(f,h)=>{if(i<=f)throw r;c=void 0,a.pop()},onLiteralValue:(f,h,T)=>{if(i<h||(E(f,h,T,l(f)),i<=h+T))throw r},onSeparator:(f,h,T)=>{if(i<=h)throw r;if(f===":"&&c&&c.type==="property")c.colonOffset=h,p=!1,c=void 0;else if(f===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(p=!0,a[a.length-1]=""),c=void 0}}})}catch(f){if(f!==r)throw f}return{path:a,previousNode:c,isAtPropertyKey:p,matches:f=>{let h=0;for(let T=0;h<f.length&&T<a.length;T++)if(f[h]===a[T]||f[h]==="*")h++;else if(f[h]!=="**")return!1;return h===f.length}}}e.getLocation=C;function g(t,i=[],a=I.DEFAULT){let r=null,c=[];const o=[];function p(f){Array.isArray(c)?c.push(f):r!==null&&(c[r]=f)}return v(t,{onObjectBegin:()=>{const f={};p(f),o.push(c),c=f,r=null},onObjectProperty:f=>{r=f},onObjectEnd:()=>{c=o.pop()},onArrayBegin:()=>{const f=[];p(f),o.push(c),c=f,r=null},onArrayEnd:()=>{c=o.pop()},onLiteralValue:p,onError:(f,h,T)=>{i.push({error:f,offset:h,length:T})}},a),c[0]}e.parse=g;function m(t,i=[],a=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){r.type==="property"&&(r.length=f-r.offset,r=r.parent)}function o(f){return r.children.push(f),f}v(t,{onObjectBegin:f=>{r=o({type:"object",offset:f,length:-1,parent:r,children:[]})},onObjectProperty:(f,h,T)=>{r=o({type:"property",offset:h,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:f,offset:h,length:T,parent:r})},onObjectEnd:(f,h)=>{r.length=f+h-r.offset,r=r.parent,c(f+h)},onArrayBegin:(f,h)=>{r=o({type:"array",offset:f,length:-1,parent:r,children:[]})},onArrayEnd:(f,h)=>{r.length=f+h-r.offset,r=r.parent,c(f+h)},onLiteralValue:(f,h,T)=>{o({type:l(f),offset:h,length:T,parent:r,value:f}),c(h+T)},onSeparator:(f,h,T)=>{r.type==="property"&&(f===":"?r.colonOffset=h:f===","&&c(h))},onError:(f,h,T)=>{i.push({error:f,offset:h,length:T})}},a);const E=r.children[0];return E&&delete E.parent,E}e.parseTree=m;function s(t,i){if(!!t){let a=t;for(let r of i)if(typeof r=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const o of a.children)if(Array.isArray(o.children)&&o.children[0].value===r){a=o.children[1],c=!0;break}if(!c)return}else{const c=r;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}}e.findNodeAtLocation=s;function d(t){if(!t.parent||!t.parent.children)return[];const i=d(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;i.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&i.push(a)}return i}e.getNodePath=d;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let a of t.children){const r=a.children[1];r&&(i[a.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,i,a=!1){return i>=t.offset&&i<t.offset+t.length||a&&i===t.offset+t.length}e.contains=w;function b(t,i,a=!1){if(w(t,i,a)){const r=t.children;if(Array.isArray(r))for(let c=0;c<r.length&&r[c].offset<=i;c++){const o=b(r[c],i,a);if(o)return o}return t}}e.findNodeAtOffset=b;function v(t,i,a=I.DEFAULT){const r=D(t,!1);function c(fe){return fe?()=>fe(r.getTokenOffset(),r.getTokenLength()):()=>!0}function o(fe){return fe?ve=>fe(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=c(i.onObjectBegin),E=o(i.onObjectProperty),f=c(i.onObjectEnd),h=c(i.onArrayBegin),T=c(i.onArrayEnd),L=o(i.onLiteralValue),W=o(i.onSeparator),ee=c(i.onComment),j=o(i.onError),x=a&&a.disallowComments,$=a&&a.allowTrailingComma;function F(){for(;;){const fe=r.scan();switch(r.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:x||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(fe){case 12:case 13:x?U(10):ee();break;case 16:U(1);break;case 15:case 14:break;default:return fe}}}function U(fe,ve=[],Ae=[]){if(j(fe),ve.length+Ae.length>0){let Pe=r.getToken();for(;Pe!==17;){if(ve.indexOf(Pe)!==-1){F();break}else if(Ae.indexOf(Pe)!==-1)break;Pe=F()}}}function M(fe){const ve=r.getTokenValue();return fe?L(ve):E(ve),F(),!0}function N(){switch(r.getToken()){case 11:let fe=0;try{fe=JSON.parse(r.getTokenValue()),typeof fe!="number"&&(U(2),fe=0)}catch(ve){U(2)}L(fe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function O(){return r.getToken()!==10?(U(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(W(":"),F(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function V(){p(),F();let fe=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(fe||U(4,[],[]),W(","),F(),r.getToken()===2&&$)break}else fe&&U(6,[],[]);O()||U(4,[],[2,5]),fe=!0}return f(),r.getToken()!==2?U(7,[2],[]):F(),!0}function q(){h(),F();let fe=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(fe||U(4,[],[]),W(","),F(),r.getToken()===4&&$)break}else fe&&U(6,[],[]);X()||U(4,[],[4,5]),fe=!0}return T(),r.getToken()!==4?U(8,[4],[]):F(),!0}function X(){switch(r.getToken()){case 3:return q();case 1:return V();case 10:return M(!0);default:return N()}}return F(),r.getToken()===17?a.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(r.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=v;function u(t,i){let a=D(t),r=[],c,o=0,p;do switch(p=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:o!==p&&r.push(t.substring(o,p)),i!==void 0&&r.push(a.getTokenValue().replace(/[^\r\n]/g,i)),o=a.getPosition();break}while(c!==17);return r.join("")}e.stripComments=u;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(me[131],ge([0,1,54]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(y,n,R){let C,g,m,s,d;if(n){for(s=n.offset,d=s+n.length,m=s;m>0&&!k(y,m-1);)m--;let o=d;for(;o<y.length&&!k(y,o);)o++;g=y.substring(m,o),C=I(g,R)}else g=y,C=0,m=0,s=0,d=y.length;const S=D(R,y);let w=!1,b=0,v;R.insertSpaces?v=A(" ",R.tabSize||4):v="	";const u=(0,_.createScanner)(g,!1);let l=!1;function t(){return S+A(v,C+b)}function i(){let o=u.scan();for(w=!1;o===15||o===14;)w=w||o===14,o=u.scan();return l=o===16||u.getTokenError()!==0,o}const a=[];function r(o,p,E){!l&&p<d&&E>s&&y.substring(p,E)!==o&&a.push({offset:p,length:E-p,content:o})}let c=i();if(c!==17){const o=u.getTokenOffset()+m,p=A(v,C);r(p,m,o)}for(;c!==17;){let o=u.getTokenOffset()+u.getTokenLength()+m,p=i(),E="";for(;!w&&(p===12||p===13);){const h=u.getTokenOffset()+m;r(" ",o,h),o=u.getTokenOffset()+u.getTokenLength()+m,E=p===12?t():"",p=i()}if(p===2)c!==1&&(b--,E=t());else if(p===4)c!==3&&(b--,E=t());else{switch(c){case 3:case 1:b++,E=t();break;case 5:case 12:E=t();break;case 13:w?E=t():E=" ";break;case 6:E=" ";break;case 10:if(p===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?E=" ":p!==5&&p!==17&&(l=!0);break;case 16:l=!0;break}w&&(p===12||p===13)&&(E=t())}const f=u.getTokenOffset()+m;r(E,o,f),c=p}return a}e.format=P;function A(y,n){let R="";for(let C=0;C<n;C++)R+=y;return R}function I(y,n){let R=0,C=0;const g=n.tabSize||4;for(;R<y.length;){const m=y.charAt(R);if(m===" ")C++;else if(m==="	")C+=g;else break;R++}return Math.floor(C/g)}function D(y,n){for(let R=0;R<n.length;R++){const C=n.charAt(R);if(C==="\r")return R+1<n.length&&n.charAt(R+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function k(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=k}),define(me[132],ge([0,1,54,131]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(n,R,C){return I(n,R,void 0,C)}e.removeProperty=A;function I(n,R,C,g,m){const s=R.slice(),d=[],S=(0,_.parseTree)(n,d);let w,b;for(;s.length>0&&(b=s.pop(),w=(0,_.findNodeAtLocation)(S,s),w===void 0&&C!==void 0);)typeof b=="string"?C={[b]:C}:C=[C];if(w)if(w.type==="object"&&typeof b=="string"&&Array.isArray(w.children)){const v=(0,_.findNodeAtLocation)(w,[b]);if(v!==void 0)if(C===void 0){if(!v.parent)throw new Error("Malformed AST");const u=w.children.indexOf(v.parent);let l,t=v.parent.offset+v.parent.length;if(u>0){const i=w.children[u-1];l=i.offset+i.length}else l=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return D(n,{offset:l,length:t-l,content:""},g)}else return D(n,{offset:v.offset,length:v.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const u=`${JSON.stringify(b)}: ${JSON.stringify(C)}`,l=m?m(w.children.map(i=>i.children[0].value)):w.children.length;let t;if(l>0){const i=w.children[l-1];t={offset:i.offset+i.length,length:0,content:","+u}}else w.children.length===0?t={offset:w.offset+1,length:0,content:u}:t={offset:w.offset+1,length:0,content:u+","};return D(n,t,g)}}else if(w.type==="array"&&typeof b=="number"&&Array.isArray(w.children))if(C!==void 0){const v=`${JSON.stringify(C)}`;let u;if(w.children.length===0||b===0)u={offset:w.offset+1,length:0,content:w.children.length===0?v:v+","};else{const l=b===-1||b>w.children.length?w.children.length:b,t=w.children[l-1];u={offset:t.offset+t.length,length:0,content:","+v}}return D(n,u,g)}else{const v=b,u=w.children[v];let l;if(w.children.length===1)l={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===v){const t=w.children[v-1],i=t.offset+t.length,a=w.offset+w.length;l={offset:i,length:a-2-i,content:""}}else l={offset:u.offset,length:w.children[v+1].offset-u.offset,content:""};return D(n,l,g)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(n,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(C)},g)}}e.setProperty=I;function D(n,R,C){let g=k(n,R),m=R.offset,s=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;m>0&&!(0,P.isEOL)(g,m-1);)m--;for(;s<g.length&&!(0,P.isEOL)(g,s);)s++}const d=(0,P.format)(g,{offset:m,length:s-m},C);for(let w=d.length-1;w>=0;w--){const b=d[w];g=k(g,b),m=Math.min(m,b.offset),s=Math.max(s,b.offset+b.length),s+=b.content.length-b.length}const S=n.length-(g.length-s)-m;return[{offset:m,length:S,content:g.substring(m,s)}]}e.withFormatting=D;function k(n,R){return n.substring(0,R.offset)+R.content+n.substring(R.offset+R.length)}e.applyEdit=k;function y(n,R){let C=R.slice(0).sort((m,s)=>{const d=m.offset-s.offset;return d===0?m.length-s.length:d}),g=n.length;for(let m=C.length-1;m>=0;m--){let s=C[m];if(s.offset+s.length<=g)n=k(n,s);else throw new Error("Overlapping edit");g=s.offset}return n}e.applyEdits=y}),define(me[133],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new _(()=>A(this.getValue()))}}e.Lazy=_}),define(me[6],ge([0,1,70,72]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let I=null;function D(v){I=v}if(e.setDisposableTracker=D,A){const v="__is_disposable_tracked__";I=new class{trackDisposable(u){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[v]||console.log(l)},3e3)}markTracked(u){if(u&&u!==d.None)try{u[v]=!0}catch(l){}}}}function k(v){!I||I.markTracked(v)}function y(v){return I&&I.trackDisposable(v),v}e.trackDisposable=y;class n extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=n;function R(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=R;function C(v){if(P.Iterable.is(v)){let u=[];for(const l of v)if(l){k(l);try{l.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new n(u);return Array.isArray(v)?[]:v}else if(v)return k(v),v.dispose(),v}e.dispose=C;function g(...v){return v.forEach(k),m(()=>C(v))}e.combinedDisposable=g;function m(v){const u=y({dispose:()=>{k(u),v()}});return u}e.toDisposable=m;class s{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return k(u),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=s,s.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new s,y(this)}dispose(){k(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var l;this._isDisposed||u===this._value||((l=this._value)===null||l===void 0||l.dispose(),u&&k(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,k(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(u,...l){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...l)},this.references.set(u,t));const{object:i}=t,a=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:i,dispose:a}}}e.ReferenceCollection=w;class b{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=b}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(I){this.element=I,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class P{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,D){const k=new _(I);if(this._first===_.Undefined)this._first=k,this._last=k;else if(D){const n=this._last;this._last=k,k.prev=n,n.next=k}else{const n=this._first;this._first=k,k.next=n,n.prev=k}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(k))}}shift(){if(this._first!==_.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==_.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==_.Undefined&&I.next!==_.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===_.Undefined&&I.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):I.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):I.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==_.Undefined;)yield I.element,I=I.next}}e.LinkedList=P}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,oe){for(var de=0;de<oe.length;de++){var Y=oe[de];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(K,Y.key,Y)}}function e(K,oe,de){return oe&&G(K.prototype,oe),de&&G(K,de),K}function _(K,oe){if(!!K){if(typeof K=="string")return P(K,oe);var de=Object.prototype.toString.call(K).slice(8,-1);if(de==="Object"&&K.constructor&&(de=K.constructor.name),de==="Map"||de==="Set")return Array.from(K);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return P(K,oe)}}function P(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var de=0,Y=new Array(oe);de<oe;de++)Y[de]=K[de];return Y}function A(K,oe){var de;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(de=_(K))||oe&&K&&typeof K.length=="number"){de&&(K=de);var Y=0;return function(){return Y>=K.length?{done:!0}:{done:!1,value:K[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=K[Symbol.iterator](),de.next.bind(de)}function I(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var D=I(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(Y){K.exports.defaults=Y}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:de}}),k=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(oe){return C[oe]};function m(K,oe){if(oe){if(k.test(K))return K.replace(y,g)}else if(n.test(K))return K.replace(R,g);return K}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(K){return K.replace(s,function(oe,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(K,oe){K=K.source||K,oe=oe||"";var de={replace:function(ie,ce){return ce=ce.source||ce,ce=ce.replace(S,"$1"),K=K.replace(ie,ce),de},getRegex:function(){return new RegExp(K,oe)}};return de}var b=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(K,oe,de){if(K){var Y;try{Y=decodeURIComponent(d(de)).replace(b,"").toLowerCase()}catch(ie){return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}oe&&!v.test(de)&&(de=r(oe,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(ie){return null}return de}var l={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(K,oe){l[" "+K]||(t.test(K)?l[" "+K]=K+"/":l[" "+K]=E(K,"/",!0)),K=l[" "+K];var de=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?de?oe:K.replace(i,"$1")+oe:oe.charAt(0)==="/"?de?oe:K.replace(a,"$1")+oe:K+oe}var c={exec:function(){}};function o(K){for(var oe=1,de,Y;oe<arguments.length;oe++){de=arguments[oe];for(Y in de)Object.prototype.hasOwnProperty.call(de,Y)&&(K[Y]=de[Y])}return K}function p(K,oe){var de=K.replace(/\|/g,function(ce,pe,ye){for(var We=!1,Ne=pe;--Ne>=0&&ye[Ne]==="\\";)We=!We;return We?"|":" |"}),Y=de.split(/ \|/),ie=0;if(Y.length>oe)Y.splice(oe);else for(;Y.length<oe;)Y.push("");for(;ie<Y.length;ie++)Y[ie]=Y[ie].trim().replace(/\\\|/g,"|");return Y}function E(K,oe,de){var Y=K.length;if(Y===0)return"";for(var ie=0;ie<Y;){var ce=K.charAt(Y-ie-1);if(ce===oe&&!de)ie++;else if(ce!==oe&&de)ie++;else break}return K.substr(0,Y-ie)}function f(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var de=K.length,Y=0,ie=0;ie<de;ie++)if(K[ie]==="\\")ie++;else if(K[ie]===oe[0])Y++;else if(K[ie]===oe[1]&&(Y--,Y<0))return ie;return-1}function h(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(K,oe){if(oe<1)return"";for(var de="";oe>1;)oe&1&&(de+=K),oe>>=1,K+=K;return de+K}var L={escape:m,unescape:d,edit:w,cleanUrl:u,resolveUrl:r,noopTest:c,merge:o,splitCells:p,rtrim:E,findClosingBracket:f,checkSanitizeDeprecation:h,repeatString:T},W=D.defaults,ee=L.rtrim,j=L.splitCells,x=L.escape,$=L.findClosingBracket;function F(K,oe,de){var Y=oe.href,ie=oe.title?x(oe.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:de,href:Y,title:ie,text:ce}:{type:"image",raw:de,href:Y,title:ie,text:x(ce)}}function U(K,oe){var de=K.match(/^(\s+)(?:```)/);if(de===null)return oe;var Y=de[1];return oe.split(`
`).map(function(ie){var ce=ie.match(/^\s+/);if(ce===null)return ie;var pe=ce[0];return pe.length>=Y.length?ie.slice(Y.length):ie}).join(`
`)}var M=function(){function K(de){this.options=de||W}var oe=K.prototype;return oe.space=function(Y){var ie=this.rules.block.newline.exec(Y);if(ie)return ie[0].length>1?{type:"space",raw:ie[0]}:{raw:`
`}},oe.code=function(Y){var ie=this.rules.block.code.exec(Y);if(ie){var ce=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:ee(ce,`
`)}}},oe.fences=function(Y){var ie=this.rules.block.fences.exec(Y);if(ie){var ce=ie[0],pe=U(ce,ie[3]||"");return{type:"code",raw:ce,lang:ie[2]?ie[2].trim():ie[2],text:pe}}},oe.heading=function(Y){var ie=this.rules.block.heading.exec(Y);if(ie){var ce=ie[2].trim();if(/#$/.test(ce)){var pe=ee(ce,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(ce=pe.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:ce}}},oe.nptable=function(Y){var ie=this.rules.block.nptable.exec(Y);if(ie){var ce={type:"table",header:j(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[],raw:ie[0]};if(ce.header.length===ce.align.length){var pe=ce.align.length,ye;for(ye=0;ye<pe;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(pe=ce.cells.length,ye=0;ye<pe;ye++)ce.cells[ye]=j(ce.cells[ye],ce.header.length);return ce}}},oe.hr=function(Y){var ie=this.rules.block.hr.exec(Y);if(ie)return{type:"hr",raw:ie[0]}},oe.blockquote=function(Y){var ie=this.rules.block.blockquote.exec(Y);if(ie){var ce=ie[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ie[0],text:ce}}},oe.list=function(Y){var ie=this.rules.block.list.exec(Y);if(ie){var ce=ie[0],pe=ie[2],ye=pe.length>1,We={type:"list",raw:ce,ordered:ye,start:ye?+pe.slice(0,-1):"",loose:!1,items:[]},Ne=ie[0].match(this.rules.block.item),Ke=!1,Xe,nt,rt,ot,it,pt,qe,_e,De=Ne.length;rt=this.rules.block.listItemStart.exec(Ne[0]);for(var ae=0;ae<De;ae++){if(Xe=Ne[ae],ce=Xe,ae!==De-1){if(ot=this.rules.block.listItemStart.exec(Ne[ae+1]),this.options.pedantic?ot[1].length>rt[1].length:ot[1].length>rt[0].length||ot[1].length>3){Ne.splice(ae,2,Ne[ae]+`
`+Ne[ae+1]),ae--,De--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==pe[pe.length-1]:ye===(ot[2].length===1))&&(it=Ne.slice(ae+1).join(`
`),We.raw=We.raw.substring(0,We.raw.length-it.length),ae=De-1);rt=ot}nt=Xe.length,Xe=Xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Xe.indexOf(`
 `)&&(nt-=Xe.length,Xe=this.options.pedantic?Xe.replace(/^ {1,4}/gm,""):Xe.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),pt=Ke||/\n\n(?!\s*$)/.test(Xe),ae!==De-1&&(Ke=Xe.charAt(Xe.length-1)===`
`,pt||(pt=Ke)),pt&&(We.loose=!0),this.options.gfm&&(qe=/^\[[ xX]\] /.test(Xe),_e=void 0,qe&&(_e=Xe[1]!==" ",Xe=Xe.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:ce,task:qe,checked:_e,loose:pt,text:Xe})}return We}},oe.html=function(Y){var ie=this.rules.block.html.exec(Y);if(ie)return{type:this.options.sanitize?"paragraph":"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):x(ie[0]):ie[0]}},oe.def=function(Y){var ie=this.rules.block.def.exec(Y);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var ce=ie[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ie[0],href:ie[2],title:ie[3]}}},oe.table=function(Y){var ie=this.rules.block.table.exec(Y);if(ie){var ce={type:"table",header:j(ie[1].replace(/^ *| *\| *$/g,"")),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ie[3]?ie[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ie[0];var pe=ce.align.length,ye;for(ye=0;ye<pe;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(pe=ce.cells.length,ye=0;ye<pe;ye++)ce.cells[ye]=j(ce.cells[ye].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},oe.lheading=function(Y){var ie=this.rules.block.lheading.exec(Y);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1]}},oe.paragraph=function(Y){var ie=this.rules.block.paragraph.exec(Y);if(ie)return{type:"paragraph",raw:ie[0],text:ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1]}},oe.text=function(Y){var ie=this.rules.block.text.exec(Y);if(ie)return{type:"text",raw:ie[0],text:ie[0]}},oe.escape=function(Y){var ie=this.rules.inline.escape.exec(Y);if(ie)return{type:"escape",raw:ie[0],text:x(ie[1])}},oe.tag=function(Y,ie,ce){var pe=this.rules.inline.tag.exec(Y);if(pe)return!ie&&/^<a /i.test(pe[0])?ie=!0:ie&&/^<\/a>/i.test(pe[0])&&(ie=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ie,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):x(pe[0]):pe[0]}},oe.link=function(Y){var ie=this.rules.inline.link.exec(Y);if(ie){var ce=ie[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var pe=ee(ce.slice(0,-1),"\\");if((ce.length-pe.length)%2==0)return}else{var ye=$(ie[2],"()");if(ye>-1){var We=ie[0].indexOf("!")===0?5:4,Ne=We+ie[1].length+ye;ie[2]=ie[2].substring(0,ye),ie[0]=ie[0].substring(0,Ne).trim(),ie[3]=""}}var Ke=ie[2],Xe="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);nt&&(Ke=nt[1],Xe=nt[3])}else Xe=ie[3]?ie[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(ce)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),F(ie,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:Xe&&Xe.replace(this.rules.inline._escapes,"$1")},ie[0])}},oe.reflink=function(Y,ie){var ce;if((ce=this.rules.inline.reflink.exec(Y))||(ce=this.rules.inline.nolink.exec(Y))){var pe=(ce[2]||ce[1]).replace(/\s+/g," ");if(pe=ie[pe.toLowerCase()],!pe||!pe.href){var ye=ce[0].charAt(0);return{type:"text",raw:ye,text:ye}}return F(ce,pe,ce[0])}},oe.emStrong=function(Y,ie,ce){ce===void 0&&(ce="");var pe=this.rules.inline.emStrong.lDelim.exec(Y);if(!!pe&&!(pe[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=pe[1]||pe[2]||"";if(!ye||ye&&(ce===""||this.rules.inline.punctuation.exec(ce))){var We=pe[0].length-1,Ne,Ke,Xe=We,nt=0,rt=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ie=ie.slice(-1*Y.length+We);(pe=rt.exec(ie))!=null;)if(Ne=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ne){if(Ke=Ne.length,pe[3]||pe[4]){Xe+=Ke;continue}else if((pe[5]||pe[6])&&We%3&&!((We+Ke)%3)){nt+=Ke;continue}if(Xe-=Ke,!(Xe>0)){if(Xe+nt-Ke<=0&&!ie.slice(rt.lastIndex).match(rt)&&(Ke=Math.min(Ke,Ke+Xe+nt)),Math.min(We,Ke)%2)return{type:"em",raw:Y.slice(0,We+pe.index+Ke+1),text:Y.slice(1,We+pe.index+Ke)};if(Math.min(We,Ke)%2==0)return{type:"strong",raw:Y.slice(0,We+pe.index+Ke+1),text:Y.slice(2,We+pe.index+Ke-1)}}}}}},oe.codespan=function(Y){var ie=this.rules.inline.code.exec(Y);if(ie){var ce=ie[2].replace(/\n/g," "),pe=/[^ ]/.test(ce),ye=/^ /.test(ce)&&/ $/.test(ce);return pe&&ye&&(ce=ce.substring(1,ce.length-1)),ce=x(ce,!0),{type:"codespan",raw:ie[0],text:ce}}},oe.br=function(Y){var ie=this.rules.inline.br.exec(Y);if(ie)return{type:"br",raw:ie[0]}},oe.del=function(Y){var ie=this.rules.inline.del.exec(Y);if(ie)return{type:"del",raw:ie[0],text:ie[2]}},oe.autolink=function(Y,ie){var ce=this.rules.inline.autolink.exec(Y);if(ce){var pe,ye;return ce[2]==="@"?(pe=x(this.options.mangle?ie(ce[1]):ce[1]),ye="mailto:"+pe):(pe=x(ce[1]),ye=pe),{type:"link",raw:ce[0],text:pe,href:ye,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.url=function(Y,ie){var ce;if(ce=this.rules.inline.url.exec(Y)){var pe,ye;if(ce[2]==="@")pe=x(this.options.mangle?ie(ce[0]):ce[0]),ye="mailto:"+pe;else{var We;do We=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(We!==ce[0]);pe=x(ce[0]),ce[1]==="www."?ye="http://"+pe:ye=pe}return{type:"link",raw:ce[0],text:pe,href:ye,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.inlineText=function(Y,ie,ce){var pe=this.rules.inline.text.exec(Y);if(pe){var ye;return ie?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):x(pe[0]):pe[0]:ye=x(this.options.smartypants?ce(pe[0]):pe[0]),{type:"text",raw:pe[0],text:ye}}},K}(),N=L.noopTest,O=L.edit,V=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=V({},q),q.gfm=V({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=V({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=O(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=O(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=O(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=O(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=O(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=O(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=O(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=O(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=O(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=V({},X),X.pedantic=V({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=V({},X.normal,{escape:O(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),X.gfm.url=O(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=V({},X.gfm,{br:O(X.br).replace("{2,}","*").getRegex(),text:O(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:q,inline:X},ve=D.defaults,Ae=fe.block,Pe=fe.inline,Fe=L.repeatString;function z(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(K){var oe="",de,Y,ie=K.length;for(de=0;de<ie;de++)Y=K.charCodeAt(de),Math.random()>.5&&(Y="x"+Y.toString(16)),oe+="&#"+Y+";";return oe}var te=function(){function K(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ve,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Y={block:Ae.normal,inline:Pe.normal};this.options.pedantic?(Y.block=Ae.pedantic,Y.inline=Pe.pedantic):this.options.gfm&&(Y.block=Ae.gfm,this.options.breaks?Y.inline=Pe.breaks:Y.inline=Pe.gfm),this.tokenizer.rules=Y}K.lex=function(Y,ie){var ce=new K(ie);return ce.lex(Y)},K.lexInline=function(Y,ie){var ce=new K(ie);return ce.inlineTokens(Y)};var oe=K.prototype;return oe.lex=function(Y){return Y=Y.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Y,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Y,ie,ce){ie===void 0&&(ie=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(Y=Y.replace(/^ +$/gm,""));for(var pe,ye,We,Ne;Y;){if(pe=this.tokenizer.space(Y)){Y=Y.substring(pe.raw.length),pe.type&&ie.push(pe);continue}if(pe=this.tokenizer.code(Y)){Y=Y.substring(pe.raw.length),Ne=ie[ie.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+pe.raw,Ne.text+=`
`+pe.text):ie.push(pe);continue}if(pe=this.tokenizer.fences(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.heading(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.nptable(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.hr(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.blockquote(Y)){Y=Y.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],ce),ie.push(pe);continue}if(pe=this.tokenizer.list(Y)){for(Y=Y.substring(pe.raw.length),We=pe.items.length,ye=0;ye<We;ye++)pe.items[ye].tokens=this.blockTokens(pe.items[ye].text,[],!1);ie.push(pe);continue}if(pe=this.tokenizer.html(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(ce&&(pe=this.tokenizer.def(Y))){Y=Y.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.lheading(Y)){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(ce&&(pe=this.tokenizer.paragraph(Y))){Y=Y.substring(pe.raw.length),ie.push(pe);continue}if(pe=this.tokenizer.text(Y)){Y=Y.substring(pe.raw.length),Ne=ie[ie.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+pe.raw,Ne.text+=`
`+pe.text):ie.push(pe);continue}if(Y){var Ke="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return ie},oe.inline=function(Y){var ie,ce,pe,ye,We,Ne,Ke=Y.length;for(ie=0;ie<Ke;ie++)switch(Ne=Y[ie],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},ye=Ne.header.length,ce=0;ce<ye;ce++)Ne.tokens.header[ce]=[],this.inlineTokens(Ne.header[ce],Ne.tokens.header[ce]);for(ye=Ne.cells.length,ce=0;ce<ye;ce++)for(We=Ne.cells[ce],Ne.tokens.cells[ce]=[],pe=0;pe<We.length;pe++)Ne.tokens.cells[ce][pe]=[],this.inlineTokens(We[pe],Ne.tokens.cells[ce][pe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(ye=Ne.items.length,ce=0;ce<ye;ce++)this.inline(Ne.items[ce].tokens);break}}return Y},oe.inlineTokens=function(Y,ie,ce,pe){ie===void 0&&(ie=[]),ce===void 0&&(ce=!1),pe===void 0&&(pe=!1);var ye,We,Ne=Y,Ke,Xe,nt;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)rt.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ke.index)+"["+Fe("a",Ke[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ke.index)+"["+Fe("a",Ke[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ke.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;){if(Xe||(nt=""),Xe=!1,ye=this.tokenizer.escape(Y)){Y=Y.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.tag(Y,ce,pe)){Y=Y.substring(ye.raw.length),ce=ye.inLink,pe=ye.inRawBlock;var ot=ie[ie.length-1];ot&&ye.type==="text"&&ot.type==="text"?(ot.raw+=ye.raw,ot.text+=ye.text):ie.push(ye);continue}if(ye=this.tokenizer.link(Y)){Y=Y.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,pe)),ie.push(ye);continue}if(ye=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(ye.raw.length);var it=ie[ie.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,pe),ie.push(ye)):it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):ie.push(ye);continue}if(ye=this.tokenizer.emStrong(Y,Ne,nt)){Y=Y.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,pe),ie.push(ye);continue}if(ye=this.tokenizer.codespan(Y)){Y=Y.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.br(Y)){Y=Y.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.del(Y)){Y=Y.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,pe),ie.push(ye);continue}if(ye=this.tokenizer.autolink(Y,J)){Y=Y.substring(ye.raw.length),ie.push(ye);continue}if(!ce&&(ye=this.tokenizer.url(Y,J))){Y=Y.substring(ye.raw.length),ie.push(ye);continue}if(ye=this.tokenizer.inlineText(Y,pe,z)){Y=Y.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Xe=!0,We=ie[ie.length-1],We&&We.type==="text"?(We.raw+=ye.raw,We.text+=ye.text):ie.push(ye);continue}if(Y){var pt="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(pt);break}else throw new Error(pt)}}return ie},e(K,null,[{key:"rules",get:function(){return{block:Ae,inline:Pe}}}]),K}(),le=D.defaults,he=L.cleanUrl,Ce=L.escape,Me=function(){function K(de){this.options=de||le}var oe=K.prototype;return oe.code=function(Y,ie,ce){var pe=(ie||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(Y,pe);ye!=null&&ye!==Y&&(ce=!0,Y=ye)}return Y=Y.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+Ce(pe,!0)+'">'+(ce?Y:Ce(Y,!0))+`</code></pre>
`:"<pre><code>"+(ce?Y:Ce(Y,!0))+`</code></pre>
`},oe.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},oe.html=function(Y){return Y},oe.heading=function(Y,ie,ce,pe){return this.options.headerIds?"<h"+ie+' id="'+this.options.headerPrefix+pe.slug(ce)+'">'+Y+"</h"+ie+`>
`:"<h"+ie+">"+Y+"</h"+ie+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Y,ie,ce){var pe=ie?"ol":"ul",ye=ie&&ce!==1?' start="'+ce+'"':"";return"<"+pe+ye+`>
`+Y+"</"+pe+`>
`},oe.listitem=function(Y){return"<li>"+Y+`</li>
`},oe.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Y){return"<p>"+Y+`</p>
`},oe.table=function(Y,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+ie+`</table>
`},oe.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},oe.tablecell=function(Y,ie){var ce=ie.header?"th":"td",pe=ie.align?"<"+ce+' align="'+ie.align+'">':"<"+ce+">";return pe+Y+"</"+ce+`>
`},oe.strong=function(Y){return"<strong>"+Y+"</strong>"},oe.em=function(Y){return"<em>"+Y+"</em>"},oe.codespan=function(Y){return"<code>"+Y+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Y){return"<del>"+Y+"</del>"},oe.link=function(Y,ie,ce){if(Y=he(this.options.sanitize,this.options.baseUrl,Y),Y===null)return ce;var pe='<a href="'+Ce(Y)+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=">"+ce+"</a>",pe},oe.image=function(Y,ie,ce){if(Y=he(this.options.sanitize,this.options.baseUrl,Y),Y===null)return ce;var pe='<img src="'+Y+'" alt="'+ce+'"';return ie&&(pe+=' title="'+ie+'"'),pe+=this.options.xhtml?"/>":">",pe},oe.text=function(Y){return Y},K}(),we=function(){function K(){}var oe=K.prototype;return oe.strong=function(Y){return Y},oe.em=function(Y){return Y},oe.codespan=function(Y){return Y},oe.del=function(Y){return Y},oe.html=function(Y){return Y},oe.text=function(Y){return Y},oe.link=function(Y,ie,ce){return""+ce},oe.image=function(Y,ie,ce){return""+ce},oe.br=function(){return""},K}(),ke=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Y,ie){var ce=Y,pe=0;if(this.seen.hasOwnProperty(ce)){pe=this.seen[Y];do pe++,ce=Y+"-"+pe;while(this.seen.hasOwnProperty(ce))}return ie||(this.seen[Y]=pe,this.seen[ce]=0),ce},oe.slug=function(Y,ie){ie===void 0&&(ie={});var ce=this.serialize(Y);return this.getNextSafeSlug(ce,ie.dryrun)},K}(),Re=D.defaults,Be=L.unescape,Ee=function(){function K(de){this.options=de||Re,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new ke}K.parse=function(Y,ie){var ce=new K(ie);return ce.parse(Y)},K.parseInline=function(Y,ie){var ce=new K(ie);return ce.parseInline(Y)};var oe=K.prototype;return oe.parse=function(Y,ie){ie===void 0&&(ie=!0);var ce="",pe,ye,We,Ne,Ke,Xe,nt,rt,ot,it,pt,qe,_e,De,ae,Z,Oe,Te,Je=Y.length;for(pe=0;pe<Je;pe++)switch(it=Y[pe],it.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(it.tokens),it.depth,Be(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(rt="",nt="",Ne=it.header.length,ye=0;ye<Ne;ye++)nt+=this.renderer.tablecell(this.parseInline(it.tokens.header[ye]),{header:!0,align:it.align[ye]});for(rt+=this.renderer.tablerow(nt),ot="",Ne=it.cells.length,ye=0;ye<Ne;ye++){for(Xe=it.tokens.cells[ye],nt="",Ke=Xe.length,We=0;We<Ke;We++)nt+=this.renderer.tablecell(this.parseInline(Xe[We]),{header:!1,align:it.align[We]});ot+=this.renderer.tablerow(nt)}ce+=this.renderer.table(rt,ot);continue}case"blockquote":{ot=this.parse(it.tokens),ce+=this.renderer.blockquote(ot);continue}case"list":{for(pt=it.ordered,qe=it.start,_e=it.loose,Ne=it.items.length,ot="",ye=0;ye<Ne;ye++)ae=it.items[ye],Z=ae.checked,Oe=ae.task,De="",ae.task&&(Te=this.renderer.checkbox(Z),_e?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Te+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Te+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Te}):De+=Te),De+=this.parse(ae.tokens,_e),ot+=this.renderer.listitem(De,Oe,Z);ce+=this.renderer.list(ot,pt,qe);continue}case"html":{ce+=this.renderer.html(it.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(ot=it.tokens?this.parseInline(it.tokens):it.text;pe+1<Je&&Y[pe+1].type==="text";)it=Y[++pe],ot+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);ce+=ie?this.renderer.paragraph(ot):ot;continue}default:{var Ye='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}return ce},oe.parseInline=function(Y,ie){ie=ie||this.renderer;var ce="",pe,ye,We=Y.length;for(pe=0;pe<We;pe++)switch(ye=Y[pe],ye.type){case"escape":{ce+=ie.text(ye.text);break}case"html":{ce+=ie.html(ye.text);break}case"link":{ce+=ie.link(ye.href,ye.title,this.parseInline(ye.tokens,ie));break}case"image":{ce+=ie.image(ye.href,ye.title,ye.text);break}case"strong":{ce+=ie.strong(this.parseInline(ye.tokens,ie));break}case"em":{ce+=ie.em(this.parseInline(ye.tokens,ie));break}case"codespan":{ce+=ie.codespan(ye.text);break}case"br":{ce+=ie.br();break}case"del":{ce+=ie.del(this.parseInline(ye.tokens,ie));break}case"text":{ce+=ie.text(ye.text);break}default:{var Ne='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return ce},K}(),Ge=L.merge,Q=L.checkSanitizeDeprecation,re=L.escape,be=D.getDefaults,Ue=D.changeDefaults,ze=D.defaults;function $e(K,oe,de){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(de=oe,oe=null),oe=Ge({},$e.defaults,oe||{}),Q(oe),de){var Y=oe.highlight,ie;try{ie=te.lex(K,oe)}catch(We){return de(We)}var ce=function(Ne){var Ke;if(!Ne)try{Ke=Ee.parse(ie,oe)}catch(Xe){Ne=Xe}return oe.highlight=Y,Ne?de(Ne):de(null,Ke)};if(!Y||Y.length<3||(delete oe.highlight,!ie.length))return ce();var pe=0;$e.walkTokens(ie,function(We){We.type==="code"&&(pe++,setTimeout(function(){Y(We.text,We.lang,function(Ne,Ke){if(Ne)return ce(Ne);Ke!=null&&Ke!==We.text&&(We.text=Ke,We.escaped=!0),pe--,pe===0&&ce()})},0))}),pe===0&&ce();return}try{var ye=te.lex(K,oe);return oe.walkTokens&&$e.walkTokens(ye,oe.walkTokens),Ee.parse(ye,oe)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(We.message+"",!0)+"</pre>";throw We}}$e.options=$e.setOptions=function(K){return Ge($e.defaults,K),Ue($e.defaults),$e},$e.getDefaults=be,$e.defaults=ze,$e.use=function(K){var oe=Ge({},K);if(K.renderer&&function(){var Y=$e.defaults.renderer||new Me,ie=function(ye){var We=Y[ye];Y[ye]=function(){for(var Ne=arguments.length,Ke=new Array(Ne),Xe=0;Xe<Ne;Xe++)Ke[Xe]=arguments[Xe];var nt=K.renderer[ye].apply(Y,Ke);return nt===!1&&(nt=We.apply(Y,Ke)),nt}};for(var ce in K.renderer)ie(ce);oe.renderer=Y}(),K.tokenizer&&function(){var Y=$e.defaults.tokenizer||new M,ie=function(ye){var We=Y[ye];Y[ye]=function(){for(var Ne=arguments.length,Ke=new Array(Ne),Xe=0;Xe<Ne;Xe++)Ke[Xe]=arguments[Xe];var nt=K.tokenizer[ye].apply(Y,Ke);return nt===!1&&(nt=We.apply(Y,Ke)),nt}};for(var ce in K.tokenizer)ie(ce);oe.tokenizer=Y}(),K.walkTokens){var de=$e.defaults.walkTokens;oe.walkTokens=function(Y){K.walkTokens(Y),de&&de(Y)}}$e.setOptions(oe)},$e.walkTokens=function(K,oe){for(var de=A(K),Y;!(Y=de()).done;){var ie=Y.value;switch(oe(ie),ie.type){case"table":{for(var ce=A(ie.tokens.header),pe;!(pe=ce()).done;){var ye=pe.value;$e.walkTokens(ye,oe)}for(var We=A(ie.tokens.cells),Ne;!(Ne=We()).done;)for(var Ke=Ne.value,Xe=A(Ke),nt;!(nt=Xe()).done;){var rt=nt.value;$e.walkTokens(rt,oe)}break}case"list":{$e.walkTokens(ie.items,oe);break}default:ie.tokens&&$e.walkTokens(ie.tokens,oe)}}},$e.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ge({},$e.defaults,oe||{}),Q(oe);try{var de=te.lexInline(K,oe);return oe.walkTokens&&$e.walkTokens(de,oe.walkTokens),Ee.parseInline(de,oe)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(Y.message+"",!0)+"</pre>";throw Y}},$e.Parser=Ee,$e.parser=Ee.parse,$e.Renderer=Me,$e.TextRenderer=we,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=M,$e.Slugger=ke,$e.parse=$e;var Ze=$e;return Ze}),define(me[73],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(D,k,y){return Math.min(Math.max(D,k),y)}e.clamp=_;function P(D,k){return(k+D%k)%k}e.rot=P;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class I{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I});"use strict";(function(){function G(A){const I=[];typeof A=="number"&&I.push("code/timeOrigin",A);function D(y){I.push(y,Date.now())}function k(){const y=[];for(let n=0;n<I.length;n+=2)y.push({name:I[n],startTime:I[n+1]});return y}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(A+D.startTime)});return I}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function _(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=_(P))})(),define(me[9],ge([0,1]),function(G,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const P="en";let A=!1,I=!1,D=!1,k=!1,y=!1,n=!1,R=!1,C,g=P,m,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const S=typeof((_=d==null?void 0:d.versions)===null||_===void 0?void 0:_.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=S&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)s=navigator.userAgent,A=s.indexOf("Windows")>=0,I=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=s.indexOf("Linux")>=0,n=!0,C=navigator.language,g=C;else if(typeof d=="object"){A=d.platform==="win32",I=d.platform==="darwin",D=d.platform==="linux",k=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,C=P,g=P;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const c=JSON.parse(r),o=c.availableLanguages["*"];C=c.locale,g=o||P,m=c._translationsConfigFile}catch(c){}y=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let v=0;I?v=1:A?v=3:D&&(v=2),e.isWindows=A,e.isMacintosh=I,e.isLinux=D,e.isLinuxSnap=k,e.isNative=y,e.isWeb=n,e.isIOS=R,e.platform=v,e.userAgent=s,e.language=g;var u;(function(r){function c(){return e.language}r.value=c;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function p(){return e.language==="en"}r.isDefault=p})(u=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let f=0,h=o.length;f<h;f++){const T=o[f];if(T.id===E.data.vscodeSetImmediateId){o.splice(f,1),T.callback();return}}});let p=0;return E=>{const f=++p;o.push({id:f,callback:E}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const c=Promise.resolve();return o=>c.then(o)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:A?1:3;let t=!0,i=!1;function a(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a}),define(me[36],ge([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof _.globals.vscode!="undefined"){const A=_.globals.vscode.process;P={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(I){return(0,_.setImmediate)(I)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:P={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(A){return(0,_.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(me[8],ge([0,1,36]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,A=97,I=90,D=122,k=46,y=47,n=92,R=58,C=63;class g extends Error{constructor(u,l,t){let i;typeof l=="string"&&l.indexOf("not ")===0?(i="must not be",l=l.replace(/^not /,"")):i="must be";const a=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${a} ${i} of type ${l}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(v,u){if(typeof v!="string")throw new g(u,"string",v)}function s(v){return v===y||v===n}function d(v){return v===y}function S(v){return v>=P&&v<=I||v>=A&&v<=D}function w(v,u,l,t){let i="",a=0,r=-1,c=0,o=0;for(let p=0;p<=v.length;++p){if(p<v.length)o=v.charCodeAt(p);else{if(t(o))break;o=y}if(t(o)){if(!(r===p-1||c===1))if(c===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==k||i.charCodeAt(i.length-2)!==k){if(i.length>2){const E=i.lastIndexOf(l);E===-1?(i="",a=0):(i=i.slice(0,E),a=i.length-1-i.lastIndexOf(l)),r=p,c=0;continue}else if(i.length!==0){i="",a=0,r=p,c=0;continue}}u&&(i+=i.length>0?`${l}..`:"..",a=2)}else i.length>0?i+=`${l}${v.slice(r+1,p)}`:i=v.slice(r+1,p),a=p-r-1;r=p,c=0}else o===k&&c!==-1?++c:c=-1}return i}function b(v,u){if(u===null||typeof u!="object")throw new g("pathObject","Object",u);const l=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return l?l===u.root?`${l}${t}`:`${l}${v}${t}`:t}e.win32={resolve(...v){let u="",l="",t=!1;for(let i=v.length-1;i>=-1;i--){let a;if(i>=0){if(a=v[i],m(a,"path"),a.length===0)continue}else u.length===0?a=_.cwd():(a=_.env[`=${u}`]||_.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==u.toLowerCase()&&a.charCodeAt(2)===n)&&(a=`${u}\\`));const r=a.length;let c=0,o="",p=!1;const E=a.charCodeAt(0);if(r===1)s(E)&&(c=1,p=!0);else if(s(E))if(p=!0,s(a.charCodeAt(1))){let f=2,h=f;for(;f<r&&!s(a.charCodeAt(f));)f++;if(f<r&&f!==h){const T=a.slice(h,f);for(h=f;f<r&&s(a.charCodeAt(f));)f++;if(f<r&&f!==h){for(h=f;f<r&&!s(a.charCodeAt(f));)f++;(f===r||f!==h)&&(o=`\\\\${T}\\${a.slice(h,f)}`,c=f)}}}else c=1;else S(E)&&a.charCodeAt(1)===R&&(o=a.slice(0,2),c=2,r>2&&s(a.charCodeAt(2))&&(p=!0,c=3));if(o.length>0)if(u.length>0){if(o.toLowerCase()!==u.toLowerCase())continue}else u=o;if(t){if(u.length>0)break}else if(l=`${a.slice(c)}\\${l}`,t=p,p&&u.length>0)break}return l=w(l,!t,"\\",s),t?`${u}\\${l}`:`${u}${l}`||"."},normalize(v){m(v,"path");const u=v.length;if(u===0)return".";let l=0,t,i=!1;const a=v.charCodeAt(0);if(u===1)return d(a)?"\\":v;if(s(a))if(i=!0,s(v.charCodeAt(1))){let c=2,o=c;for(;c<u&&!s(v.charCodeAt(c));)c++;if(c<u&&c!==o){const p=v.slice(o,c);for(o=c;c<u&&s(v.charCodeAt(c));)c++;if(c<u&&c!==o){for(o=c;c<u&&!s(v.charCodeAt(c));)c++;if(c===u)return`\\\\${p}\\${v.slice(o)}\\`;c!==o&&(t=`\\\\${p}\\${v.slice(o,c)}`,l=c)}}}else l=1;else S(a)&&v.charCodeAt(1)===R&&(t=v.slice(0,2),l=2,u>2&&s(v.charCodeAt(2))&&(i=!0,l=3));let r=l<u?w(v.slice(l),!i,"\\",s):"";return r.length===0&&!i&&(r="."),r.length>0&&s(v.charCodeAt(u-1))&&(r+="\\"),t===void 0?i?`\\${r}`:r:i?`${t}\\${r}`:`${t}${r}`},isAbsolute(v){m(v,"path");const u=v.length;if(u===0)return!1;const l=v.charCodeAt(0);return s(l)||u>2&&S(l)&&v.charCodeAt(1)===R&&s(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let u,l;for(let a=0;a<v.length;++a){const r=v[a];m(r,"path"),r.length>0&&(u===void 0?u=l=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,i=0;if(typeof l=="string"&&s(l.charCodeAt(0))){++i;const a=l.length;a>1&&s(l.charCodeAt(1))&&(++i,a>2&&(s(l.charCodeAt(2))?++i:t=!1))}if(t){for(;i<u.length&&s(u.charCodeAt(i));)i++;i>=2&&(u=`\\${u.slice(i)}`)}return e.win32.normalize(u)},relative(v,u){if(m(v,"from"),m(u,"to"),v===u)return"";const l=e.win32.resolve(v),t=e.win32.resolve(u);if(l===t||(v=l.toLowerCase(),u=t.toLowerCase(),v===u))return"";let i=0;for(;i<v.length&&v.charCodeAt(i)===n;)i++;let a=v.length;for(;a-1>i&&v.charCodeAt(a-1)===n;)a--;const r=a-i;let c=0;for(;c<u.length&&u.charCodeAt(c)===n;)c++;let o=u.length;for(;o-1>c&&u.charCodeAt(o-1)===n;)o--;const p=o-c,E=r<p?r:p;let f=-1,h=0;for(;h<E;h++){const L=v.charCodeAt(i+h);if(L!==u.charCodeAt(c+h))break;L===n&&(f=h)}if(h!==E){if(f===-1)return t}else{if(p>E){if(u.charCodeAt(c+h)===n)return t.slice(c+h+1);if(h===2)return t.slice(c+h)}r>E&&(v.charCodeAt(i+h)===n?f=h:h===2&&(f=3)),f===-1&&(f=0)}let T="";for(h=i+f+1;h<=a;++h)(h===a||v.charCodeAt(h)===n)&&(T+=T.length===0?"..":"\\..");return c+=f,T.length>0?`${T}${t.slice(c,o)}`:(t.charCodeAt(c)===n&&++c,t.slice(c,o))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const u=e.win32.resolve(v);if(u.length<=2)return v;if(u.charCodeAt(0)===n){if(u.charCodeAt(1)===n){const l=u.charCodeAt(2);if(l!==C&&l!==k)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(S(u.charCodeAt(0))&&u.charCodeAt(1)===R&&u.charCodeAt(2)===n)return`\\\\?\\${u}`;return v},dirname(v){m(v,"path");const u=v.length;if(u===0)return".";let l=-1,t=0;const i=v.charCodeAt(0);if(u===1)return s(i)?v:".";if(s(i)){if(l=t=1,s(v.charCodeAt(1))){let c=2,o=c;for(;c<u&&!s(v.charCodeAt(c));)c++;if(c<u&&c!==o){for(o=c;c<u&&s(v.charCodeAt(c));)c++;if(c<u&&c!==o){for(o=c;c<u&&!s(v.charCodeAt(c));)c++;if(c===u)return v;c!==o&&(l=t=c+1)}}}}else S(i)&&v.charCodeAt(1)===R&&(l=u>2&&s(v.charCodeAt(2))?3:2,t=l);let a=-1,r=!0;for(let c=u-1;c>=t;--c)if(s(v.charCodeAt(c))){if(!r){a=c;break}}else r=!1;if(a===-1){if(l===-1)return".";a=l}return v.slice(0,a)},basename(v,u){u!==void 0&&m(u,"ext"),m(v,"path");let l=0,t=-1,i=!0,a;if(v.length>=2&&S(v.charCodeAt(0))&&v.charCodeAt(1)===R&&(l=2),u!==void 0&&u.length>0&&u.length<=v.length){if(u===v)return"";let r=u.length-1,c=-1;for(a=v.length-1;a>=l;--a){const o=v.charCodeAt(a);if(s(o)){if(!i){l=a+1;break}}else c===-1&&(i=!1,c=a+1),r>=0&&(o===u.charCodeAt(r)?--r==-1&&(t=a):(r=-1,t=c))}return l===t?t=c:t===-1&&(t=v.length),v.slice(l,t)}for(a=v.length-1;a>=l;--a)if(s(v.charCodeAt(a))){if(!i){l=a+1;break}}else t===-1&&(i=!1,t=a+1);return t===-1?"":v.slice(l,t)},extname(v){m(v,"path");let u=0,l=-1,t=0,i=-1,a=!0,r=0;v.length>=2&&v.charCodeAt(1)===R&&S(v.charCodeAt(0))&&(u=t=2);for(let c=v.length-1;c>=u;--c){const o=v.charCodeAt(c);if(s(o)){if(!a){t=c+1;break}continue}i===-1&&(a=!1,i=c+1),o===k?l===-1?l=c:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||i===-1||r===0||r===1&&l===i-1&&l===t+1?"":v.slice(l,i)},format:b.bind(null,"\\"),parse(v){m(v,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return u;const l=v.length;let t=0,i=v.charCodeAt(0);if(l===1)return s(i)?(u.root=u.dir=v,u):(u.base=u.name=v,u);if(s(i)){if(t=1,s(v.charCodeAt(1))){let f=2,h=f;for(;f<l&&!s(v.charCodeAt(f));)f++;if(f<l&&f!==h){for(h=f;f<l&&s(v.charCodeAt(f));)f++;if(f<l&&f!==h){for(h=f;f<l&&!s(v.charCodeAt(f));)f++;f===l?t=f:f!==h&&(t=f+1)}}}}else if(S(i)&&v.charCodeAt(1)===R){if(l<=2)return u.root=u.dir=v,u;if(t=2,s(v.charCodeAt(2))){if(l===3)return u.root=u.dir=v,u;t=3}}t>0&&(u.root=v.slice(0,t));let a=-1,r=t,c=-1,o=!0,p=v.length-1,E=0;for(;p>=t;--p){if(i=v.charCodeAt(p),s(i)){if(!o){r=p+1;break}continue}c===-1&&(o=!1,c=p+1),i===k?a===-1?a=p:E!==1&&(E=1):a!==-1&&(E=-1)}return c!==-1&&(a===-1||E===0||E===1&&a===c-1&&a===r+1?u.base=u.name=v.slice(r,c):(u.name=v.slice(r,a),u.base=v.slice(r,c),u.ext=v.slice(a,c))),r>0&&r!==t?u.dir=v.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let u="",l=!1;for(let t=v.length-1;t>=-1&&!l;t--){const i=t>=0?v[t]:_.cwd();m(i,"path"),i.length!==0&&(u=`${i}/${u}`,l=i.charCodeAt(0)===y)}return u=w(u,!l,"/",d),l?`/${u}`:u.length>0?u:"."},normalize(v){if(m(v,"path"),v.length===0)return".";const u=v.charCodeAt(0)===y,l=v.charCodeAt(v.length-1)===y;return v=w(v,!u,"/",d),v.length===0?u?"/":l?"./":".":(l&&(v+="/"),u?`/${v}`:v)},isAbsolute(v){return m(v,"path"),v.length>0&&v.charCodeAt(0)===y},join(...v){if(v.length===0)return".";let u;for(let l=0;l<v.length;++l){const t=v[l];m(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(v,u){if(m(v,"from"),m(u,"to"),v===u||(v=e.posix.resolve(v),u=e.posix.resolve(u),v===u))return"";const l=1,t=v.length,i=t-l,a=1,r=u.length-a,c=i<r?i:r;let o=-1,p=0;for(;p<c;p++){const f=v.charCodeAt(l+p);if(f!==u.charCodeAt(a+p))break;f===y&&(o=p)}if(p===c)if(r>c){if(u.charCodeAt(a+p)===y)return u.slice(a+p+1);if(p===0)return u.slice(a+p)}else i>c&&(v.charCodeAt(l+p)===y?o=p:p===0&&(o=0));let E="";for(p=l+o+1;p<=t;++p)(p===t||v.charCodeAt(p)===y)&&(E+=E.length===0?"..":"/..");return`${E}${u.slice(a+o)}`},toNamespacedPath(v){return v},dirname(v){if(m(v,"path"),v.length===0)return".";const u=v.charCodeAt(0)===y;let l=-1,t=!0;for(let i=v.length-1;i>=1;--i)if(v.charCodeAt(i)===y){if(!t){l=i;break}}else t=!1;return l===-1?u?"/":".":u&&l===1?"//":v.slice(0,l)},basename(v,u){u!==void 0&&m(u,"ext"),m(v,"path");let l=0,t=-1,i=!0,a;if(u!==void 0&&u.length>0&&u.length<=v.length){if(u===v)return"";let r=u.length-1,c=-1;for(a=v.length-1;a>=0;--a){const o=v.charCodeAt(a);if(o===y){if(!i){l=a+1;break}}else c===-1&&(i=!1,c=a+1),r>=0&&(o===u.charCodeAt(r)?--r==-1&&(t=a):(r=-1,t=c))}return l===t?t=c:t===-1&&(t=v.length),v.slice(l,t)}for(a=v.length-1;a>=0;--a)if(v.charCodeAt(a)===y){if(!i){l=a+1;break}}else t===-1&&(i=!1,t=a+1);return t===-1?"":v.slice(l,t)},extname(v){m(v,"path");let u=-1,l=0,t=-1,i=!0,a=0;for(let r=v.length-1;r>=0;--r){const c=v.charCodeAt(r);if(c===y){if(!i){l=r+1;break}continue}t===-1&&(i=!1,t=r+1),c===k?u===-1?u=r:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||t===-1||a===0||a===1&&u===t-1&&u===l+1?"":v.slice(u,t)},format:b.bind(null,"/"),parse(v){m(v,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return u;const l=v.charCodeAt(0)===y;let t;l?(u.root="/",t=1):t=0;let i=-1,a=0,r=-1,c=!0,o=v.length-1,p=0;for(;o>=t;--o){const E=v.charCodeAt(o);if(E===y){if(!c){a=o+1;break}continue}r===-1&&(c=!1,r=o+1),E===k?i===-1?i=o:p!==1&&(p=1):i!==-1&&(p=-1)}if(r!==-1){const E=a===0&&l?1:a;i===-1||p===0||p===1&&i===r-1&&i===a+1?u.base=u.name=v.slice(E,r):(u.name=v.slice(E,i),u.base=v.slice(E,r),u.ext=v.slice(i,r))}return a>0?u.dir=v.slice(0,a-1):l&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[134],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(I,...D){const k=D.reduce((R,C)=>(R[C]=!0,R),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(R=>!k[R]).forEach(R=>{for(let C=0;C<y.length;C++)if(R.search(y[C])!==-1){delete I[R];break}})}e.sanitizeProcessEnvironment=A}),define(me[47],ge([0,1,9]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=_.globals.performance&&typeof _.globals.performance.now=="function";class A{constructor(D){this._highResolution=P&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new A(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=A}),define(me[3],ge([0,1,18,70,6,55,47]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(w){w.None=()=>A.Disposable.None;function b(j){return(x,$=null,F)=>{let U=!1,M;return M=j(N=>{if(!U)return M?M.dispose():U=!0,x.call($,N)},null,F),U&&M.dispose(),M}}w.once=b;function v(j,x){return r(($,F=null,U)=>j(M=>$.call(F,x(M)),null,U))}w.map=v;function u(j,x){return r(($,F=null,U)=>j(M=>{x(M),$.call(F,M)},null,U))}w.forEach=u;function l(j,x){return r(($,F=null,U)=>j(M=>x(M)&&$.call(F,M),null,U))}w.filter=l;function t(j){return j}w.signal=t;function i(...j){return(x,$=null,F)=>(0,A.combinedDisposable)(...j.map(U=>U(M=>x.call($,M),null,F)))}w.any=i;function a(j,x,$){let F=$;return v(j,U=>(F=x(F,U),F))}w.reduce=a;function r(j){let x;const $=new g({onFirstListenerAdd(){x=j($.fire,$)},onLastListenerRemove(){x.dispose()}});return $.event}w.snapshot=r;function c(j,x,$=100,F=!1,U){let M,N,O,V=0;const q=new g({leakWarningThreshold:U,onFirstListenerAdd(){M=j(X=>{V++,N=x(N,X),F&&!O&&(q.fire(N),N=void 0),clearTimeout(O),O=setTimeout(()=>{const fe=N;N=void 0,O=void 0,(!F||V>1)&&q.fire(fe),V=0},$)})},onLastListenerRemove(){M.dispose()}});return q.event}w.debounce=c;function o(j){const x=new Date().getTime();return v(b(j),$=>new Date().getTime()-x)}w.stopwatch=o;function p(j){let x=!0,$;return l(j,F=>{const U=x||F!==$;return x=!1,$=F,U})}w.latch=p;function E(j,x=!1,$=[]){let F=$.slice(),U=j(O=>{F?F.push(O):N.fire(O)});const M=()=>{F&&F.forEach(O=>N.fire(O)),F=null},N=new g({onFirstListenerAdd(){U||(U=j(O=>N.fire(O)))},onFirstListenerDidAdd(){F&&(x?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return N.event}w.buffer=E;class f{constructor(x){this.event=x}map(x){return new f(v(this.event,x))}forEach(x){return new f(u(this.event,x))}filter(x){return new f(l(this.event,x))}reduce(x,$){return new f(a(this.event,x,$))}latch(){return new f(p(this.event))}debounce(x,$=100,F=!1,U){return new f(c(this.event,x,$,F,U))}on(x,$,F){return this.event(x,$,F)}once(x,$,F){return b(this.event)(x,$,F)}}function h(j){return new f(j)}w.chain=h;function T(j,x,$=F=>F){const F=(...O)=>N.fire($(...O)),U=()=>j.on(x,F),M=()=>j.removeListener(x,F),N=new g({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}w.fromNodeEventEmitter=T;function L(j,x,$=F=>F){const F=(...O)=>N.fire($(...O)),U=()=>j.addEventListener(x,F),M=()=>j.removeEventListener(x,F),N=new g({onFirstListenerAdd:U,onLastListenerRemove:M});return N.event}w.fromDOMEventEmitter=L;function W(j){const x=new g;let $=!1;return j.then(void 0,()=>null).then(()=>{$?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),$=!0,x.event}w.fromPromise=W;function ee(j){return new Promise(x=>b(j)(x))}w.toPromise=ee})(k=e.Event||(e.Event={}));class y{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${y._idPool++}`}start(b){this._stopWatch=new D.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function R(w){const b=n;return n=w,{dispose(){n=b}}}e.setGlobalLeakWarningThreshold=R;class C{constructor(b,v=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let v=n;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),!(v<=0||b<v)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(u)||0;if(this._stacks.set(u,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let t,i=0;for(const[a,r]of this._stacks)(!t||i<r)&&(t=a,i=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class g{constructor(b){var v;this._disposed=!1,this._options=b,this._leakageMon=n>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((v=this._options)===null||v===void 0?void 0:v._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(b,v,u)=>{var l;this._listeners||(this._listeners=new I.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(v?[b,v]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,v);const a=(l=this._leakageMon)===null||l===void 0?void 0:l.check(this._listeners.size);let r;return r={dispose:()=>{a&&a(),r.dispose=g._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof A.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(b){var v,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,b]);for((v=this._perfMon)===null||v===void 0||v.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(i){(0,_.onUnexpectedError)(i)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var b,v,u;(b=this._listeners)===null||b===void 0||b.clear(),(v=this._deliveryQueue)===null||v===void 0||v.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=g,g._noop=function(){};class m extends g{constructor(b){super(b);this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=m;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const v={event:b,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const u=()=>{this.hasListeners&&this.unhook(v);const l=this.events.indexOf(v);this.events.splice(l,1)};return(0,A.toDisposable)((0,P.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(v=>this.emitter.fire(v))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class d{constructor(){this.buffers=[]}wrapEvent(b){return(v,u,l)=>b(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(u,t)):v.call(u,t)},void 0,l)}bufferEvents(b){const v=[];this.buffers.push(v);const u=b();return this.buffers.pop(),v.forEach(l=>l()),u}}e.EventBufferer=d;class S{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=A.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(me[21],ge([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(k,y){const n=setTimeout(k.bind(y),0);return{dispose(){clearTimeout(n)}}});var A;(function(k){function y(n){return n===k.None||n===k.Cancelled||n instanceof I?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}k.isCancellationToken=y,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(A=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=A.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=D}),define(me[43],ge([0,1,3]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(R){const C=this._icons.get(R.id);C?R.description?C.description=R.description:console.error(`Duplicate registration of codicon ${R.id}`):(this._icons.set(R.id,R),this._onDidRegister.fire(R))}get(R){return this._icons.get(R)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new P;e.iconRegistry=A;function I(n,R){return new D(n,R)}e.registerCodicon=I;class D{constructor(R,C,g){this.id=R,this.definition=C,this.description=g,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function k(n,R){const C=["codicon","codicon-"+n];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=k;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const R=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function C(s){if(s instanceof D)return["codicon","codicon-"+s.id];const d=R.exec(s.id);if(!d)return C(D.error);let[,S,w]=d;const b=["codicon","codicon-"+S];return w&&b.push("codicon-modifier-"+w.substr(1)),b}n.asClassNameArray=C;function g(s){return C(s).join(" ")}n.asClassName=g;function m(s){return"."+C(s).join(".")}n.asCSSSelector=m})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(me[92],ge([0,1,18,6]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(w){const b=w;return b&&[b.on,b.pause,b.resume,b.destroy].every(v=>typeof v=="function")}e.isReadableStream=A;function I(w){const b=w;return b&&A(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=I;function D(w,b){return new k(w,b)}e.newWriteableStream=D;class k{constructor(b,v){this.reducer=b,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(v=>v(b))}emitError(b){this.listeners.error.length===0?(0,_.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(v=>v(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,v){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(b,v){if(!this.state.destroyed){let u;switch(b){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const l=u.indexOf(v);l>=0&&u.splice(l,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(w,b){const v=[];let u;for(;(u=w.read())!==null;)v.push(u);return b(v)}e.consumeReadable=y;function n(w,b,v){const u=[];let l;for(;(l=w.read())!==null&&u.length<v;)u.push(l);return l===null&&u.length>0?b(u):{read:()=>{if(u.length>0)return u.shift();if(typeof l!="undefined"){const t=l;return l=void 0,t}return w.read()}}}e.peekReadable=n;function R(w,b){return new Promise((v,u)=>{const l=[];C(w,{onData:t=>{b&&l.push(t)},onError:t=>{b?u(t):v(void 0)},onEnd:()=>{v(b?b(l):void 0)}})})}e.consumeStream=R;function C(w,b){w.on("error",v=>b.onError(v)),w.on("end",()=>b.onEnd()),w.on("data",v=>b.onData(v))}e.listenStream=C;function g(w,b){return new Promise((v,u)=>{const l=new P.DisposableStore,t=[],i=c=>{if(t.push(c),t.length>b)return l.dispose(),w.pause(),v({stream:w,buffer:t,ended:!1})},a=c=>u(c),r=()=>v({stream:w,buffer:t,ended:!0});l.add((0,P.toDisposable)(()=>w.removeListener("error",a))),w.on("error",a),l.add((0,P.toDisposable)(()=>w.removeListener("end",r))),w.on("end",r),l.add((0,P.toDisposable)(()=>w.removeListener("data",i))),w.on("data",i)})}e.peekStream=g;function m(w,b){const v=D(b);return v.end(w),v}e.toStream=m;function s(){const w=D(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=s;function d(w){let b=!1;return{read:()=>b?null:(b=!0,w)}}e.toReadable=d;function S(w,b,v){const u=D(v);return C(w,{onData:l=>u.write(b.data(l)),onError:l=>u.error(b.error?b.error(l):l),onEnd:()=>u.end()}),u}e.transform=S}),define(me[10],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=_;const P=/{(\d+)}/g;function A(K,...oe){return oe.length===0?K:K.replace(P,function(de,Y){const ie=parseInt(Y,10);return isNaN(ie)||ie<0||ie>=oe.length?de:oe[ie]})}e.format=A;function I(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function D(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function k(K,oe){let de=0;const Y=oe.charCodeAt(0);for(let ie=K.length-1;ie>=0;ie--)K.charCodeAt(ie)===Y&&de++;return de}e.count=k;function y(K,oe,de="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${de}`}e.truncate=y;function n(K,oe=" "){const de=R(K,oe);return C(de,oe)}e.trim=n;function R(K,oe){if(!K||!oe)return K;const de=oe.length;if(de===0||K.length===0)return K;let Y=0;for(;K.indexOf(oe,Y)===Y;)Y=Y+de;return K.substring(Y)}e.ltrim=R;function C(K,oe){if(!K||!oe)return K;const de=oe.length,Y=K.length;if(de===0||Y===0)return K;let ie=Y,ce=-1;for(;ce=K.lastIndexOf(oe,ie-1),!(ce===-1||ce+de!==ie);){if(ce===0)return"";ie=ce}return K.substring(0,ie)}e.rtrim=C;function g(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(K){return K.replace(/\*/g,"")}e.stripWildcards=m;function s(K,oe,de={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=D(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Y="";return de.global&&(Y+="g"),de.matchCase||(Y+="i"),de.multiline&&(Y+="m"),de.unicode&&(Y+="u"),new RegExp(K,Y)}e.createRegExp=s;function d(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=w;function b(K){return K.split(/\r\n|\r|\n/)}e.splitLines=b;function v(K){for(let oe=0,de=K.length;oe<de;oe++){const Y=K.charCodeAt(oe);if(Y!==32&&Y!==9)return oe}return-1}e.firstNonWhitespaceIndex=v;function u(K,oe=0,de=K.length){for(let Y=oe;Y<de;Y++){const ie=K.charCodeAt(Y);if(ie!==32&&ie!==9)return K.substring(oe,Y)}return K.substring(oe,de)}e.getLeadingWhitespace=u;function l(K,oe=K.length-1){for(let de=oe;de>=0;de--){const Y=K.charCodeAt(de);if(Y!==32&&Y!==9)return de}return-1}e.lastNonWhitespaceIndex=l;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function i(K,oe,de=0,Y=K.length,ie=0,ce=oe.length){for(;de<Y&&ie<ce;de++,ie++){let We=K.charCodeAt(de),Ne=oe.charCodeAt(ie);if(We<Ne)return-1;if(We>Ne)return 1}const pe=Y-de,ye=ce-ie;return pe<ye?-1:pe>ye?1:0}e.compareSubstring=i;function a(K,oe){return r(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=a;function r(K,oe,de=0,Y=K.length,ie=0,ce=oe.length){for(;de<Y&&ie<ce;de++,ie++){let We=K.charCodeAt(de),Ne=oe.charCodeAt(ie);if(We!==Ne){const Ke=We-Ne;if(!(Ke===32&&o(Ne))&&!(Ke===-32&&o(We)))return c(We)&&c(Ne)?Ke:i(K.toLowerCase(),oe.toLowerCase(),de,Y,ie,ce)}}const pe=Y-de,ye=ce-ie;return pe<ye?-1:pe>ye?1:0}e.compareSubstringIgnoreCase=r;function c(K){return K>=97&&K<=122}e.isLowerAsciiLetter=c;function o(K){return K>=65&&K<=90}e.isUpperAsciiLetter=o;function p(K){return c(K)||o(K)}function E(K,oe){return K.length===oe.length&&f(K,oe)}e.equalsIgnoreCase=E;function f(K,oe,de=K.length){for(let Y=0;Y<de;Y++){const ie=K.charCodeAt(Y),ce=oe.charCodeAt(Y);if(ie!==ce){if(p(ie)&&p(ce)){const pe=Math.abs(ie-ce);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(ie).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function h(K,oe){const de=oe.length;return oe.length>K.length?!1:f(K,oe,de)}e.startsWithIgnoreCase=h;function T(K,oe){let de,Y=Math.min(K.length,oe.length);for(de=0;de<Y;de++)if(K.charCodeAt(de)!==oe.charCodeAt(de))return de;return Y}e.commonPrefixLength=T;function L(K,oe){let de,Y=Math.min(K.length,oe.length);const ie=K.length-1,ce=oe.length-1;for(de=0;de<Y;de++)if(K.charCodeAt(ie-de)!==oe.charCodeAt(ce-de))return de;return Y}e.commonSuffixLength=L;function W(K){return 55296<=K&&K<=56319}e.isHighSurrogate=W;function ee(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ee;function j(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=j;function x(K,oe,de){const Y=K.charCodeAt(de);if(W(Y)&&de+1<oe){const ie=K.charCodeAt(de+1);if(ee(ie))return j(Y,ie)}return Y}e.getNextCodePoint=x;function $(K,oe){const de=K.charCodeAt(oe-1);if(ee(de)&&oe>1){const Y=K.charCodeAt(oe-2);if(W(Y))return j(Y,de)}return de}function F(K,oe){const de=$e.getInstance(),Y=oe,ie=K.length,ce=x(K,ie,oe);oe+=ce>=65536?2:1;let pe=de.getGraphemeBreakType(ce);for(;oe<ie;){const ye=x(K,ie,oe),We=de.getGraphemeBreakType(ye);if(Ue(pe,We))break;oe+=ye>=65536?2:1,pe=We}return oe-Y}e.nextCharLength=F;function U(K,oe){const de=$e.getInstance(),Y=oe,ie=$(K,oe);oe-=ie>=65536?2:1;let ce=de.getGraphemeBreakType(ie);for(;oe>0;){const pe=$(K,oe),ye=de.getGraphemeBreakType(pe);if(Ue(ye,ce))break;oe-=pe>=65536?2:1,ce=ye}return Y-oe}e.prevCharLength=U;function M(K,oe){const de=$e.getInstance(),Y=K.length,ie=oe,ce=x(K,Y,oe),pe=de.getGraphemeBreakType(ce);oe+=ce>=65536?2:1;let ye=pe;for(;oe<Y;){const Ne=x(K,Y,oe),Ke=de.getGraphemeBreakType(Ne);if(Ue(ye,Ke))break;oe+=Ne>=65536?2:1,ye=Ke}const We=oe;for(oe=ie,ye=pe;oe>0;){const Ne=$(K,oe),Ke=de.getGraphemeBreakType(Ne);if(Ue(Ke,ye))break;oe-=Ne>=65536?2:1,ye=Ke}return[oe,We]}function N(K,oe){return oe>0&&ee(K.charCodeAt(oe))?M(K,oe-1):M(K,oe)}e.getCharContainingOffset=N;function O(K){const oe=K.length;let de=0,Y=0;for(;Y<oe;){const pe=x(K,oe,Y);Y+=pe>=65536?2:1,pe<128?de+=1:pe<2048?de+=2:pe<65536?de+=3:de+=4}const ie=new Uint8Array(de);Y=0;let ce=0;for(;Y<oe;){const pe=x(K,oe,Y);Y+=pe>=65536?2:1,pe<128?ie[ce++]=pe:pe<2048?(ie[ce++]=192|(pe&1984)>>>6,ie[ce++]=128|(pe&63)>>>0):pe<65536?(ie[ce++]=224|(pe&61440)>>>12,ie[ce++]=128|(pe&4032)>>>6,ie[ce++]=128|(pe&63)>>>0):(ie[ce++]=240|(pe&1835008)>>>18,ie[ce++]=128|(pe&258048)>>>12,ie[ce++]=128|(pe&4032)>>>6,ie[ce++]=128|(pe&63)>>>0)}return ie}e.encodeUTF8=O;function V(K){const oe=K.byteLength,de=[];let Y=0;for(;Y<oe;){const ie=K[Y];let ce;if(ie>=240&&Y+3<oe?ce=(K[Y++]&7)<<18>>>0|(K[Y++]&63)<<12>>>0|(K[Y++]&63)<<6>>>0|(K[Y++]&63)<<0>>>0:ie>=224&&Y+2<oe?ce=(K[Y++]&15)<<12>>>0|(K[Y++]&63)<<6>>>0|(K[Y++]&63)<<0>>>0:ie>=192&&Y+1<oe?ce=(K[Y++]&31)<<6>>>0|(K[Y++]&63)<<0>>>0:ce=K[Y++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)de.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const pe=ce-65536,ye=55296+((pe&1047552)>>>10),We=56320+((pe&1023)>>>0);de.push(String.fromCharCode(ye)),de.push(String.fromCharCode(We))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=V;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(K){return q.test(K)}e.containsRTL=X;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(K){return fe.test(K)}e.containsEmoji=ve;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Pe(K){return Ae.test(K)}e.isBasicASCII=Pe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Fe;function z(K){for(let oe=0,de=K.length;oe<de;oe++)if(J(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=z;function J(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=J;function te(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=te;function le(K,oe){if(K.length<oe)return K;const de=/\b/g;let Y=0;for(;de.test(K)&&!(K.length-de.lastIndex<oe);)Y=de.lastIndex,de.lastIndex+=1;return K.substring(Y).replace(/^\s/,"")}e.lcut=le;const he=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function we(K){return K&&(K=K.replace(he,""),K=K.replace(Ce,""),K=K.replace(Me,"")),K}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Re(K){return ke(K)?K.substr(1):K}e.stripUTF8BOM=Re;function Be(K,oe){if(!K||!oe||K.length<oe.length)return!1;const de=oe.length,Y=K.toLowerCase();let ie=0,ce=-1;for(;ie<de;){const pe=Y.indexOf(oe[ie],ce+1);if(pe<0)return!1;ce=pe,ie++}return!0}e.fuzzyContains=Be;function Ee(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ee;function Ge(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ge;function Q(K,oe=1){if(oe===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),oe--;while(oe>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}e.getNLines=Q;function re(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=re;function be(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=be;function Ue(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ue;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ze()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const de=this._data,Y=de.length/3;let ie=1;for(;ie<=Y;)if(oe<de[3*ie])ie=2*ie;else if(oe>de[3*ie+1])ie=2*ie+1;else return de[3*ie+2];return 0}}$e._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(me[22],ge([0,1,10,92]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let k,y;class n{constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}static alloc(c){return A?new n(Buffer.allocUnsafe(c)):new n(new Uint8Array(c))}static wrap(c){return A&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new n(c)}static fromString(c,o){return!((o==null?void 0:o.dontUseNodeBuffer)||!1)&&A?new n(Buffer.from(c)):I?(k||(k=new TextEncoder),new n(k.encode(c))):new n(_.encodeUTF8(c))}static concat(c,o){if(typeof o=="undefined"){o=0;for(let f=0,h=c.length;f<h;f++)o+=c[f].byteLength}const p=n.alloc(o);let E=0;for(let f=0,h=c.length;f<h;f++){const T=c[f];p.set(T,E),E+=T.byteLength}return p}toString(){return A?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(c,o){return new n(this.buffer.subarray(c,o))}set(c,o){c instanceof n?this.buffer.set(c.buffer,o):this.buffer.set(c,o)}readUInt32BE(c){return g(this.buffer,c)}writeUInt32BE(c,o){m(this.buffer,c,o)}readUInt32LE(c){return s(this.buffer,c)}writeUInt32LE(c,o){d(this.buffer,c,o)}readUInt8(c){return S(this.buffer,c)}writeUInt8(c,o){w(this.buffer,c,o)}}e.VSBuffer=n;function R(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}e.readUInt16LE=R;function C(r,c,o){r[o+0]=c&255,c=c>>>8,r[o+1]=c&255}e.writeUInt16LE=C;function g(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}e.readUInt32BE=g;function m(r,c,o){r[o+3]=c,c=c>>>8,r[o+2]=c,c=c>>>8,r[o+1]=c,c=c>>>8,r[o]=c}e.writeUInt32BE=m;function s(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}e.readUInt32LE=s;function d(r,c,o){r[o+0]=c&255,c=c>>>8,r[o+1]=c&255,c=c>>>8,r[o+2]=c&255,c=c>>>8,r[o+3]=c&255}e.writeUInt32LE=d;function S(r,c){return r[c]}e.readUInt8=S;function w(r,c,o){r[o]=c}e.writeUInt8=w;function b(r){return P.consumeReadable(r,c=>n.concat(c))}e.readableToBuffer=b;function v(r){return P.toReadable(r)}e.bufferToReadable=v;function u(r){return P.consumeStream(r,c=>n.concat(c))}e.streamToBuffer=u;async function l(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=l;function t(r){return P.toStream(r,c=>n.concat(c))}e.bufferToStream=t;function i(r){return P.transform(r,{data:c=>typeof c=="string"?n.fromString(c):n.wrap(c)},c=>n.concat(c))}e.streamToBufferReadableStream=i;function a(r){return P.newWriteableStream(c=>n.concat(c),r)}e.newWriteableBufferStream=a}),define(me[74],ge([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function P(w){return A(w,0)}e.hash=P;function A(w,b){switch(typeof w){case"object":return w===null?I(349,b):Array.isArray(w)?y(w,b):n(w,b);case"string":return k(w,b);case"boolean":return D(w,b);case"number":return I(w,b);case"undefined":return I(937,b);default:return I(617,b)}}e.doHash=A;function I(w,b){return(b<<5)-b+w|0}function D(w,b){return I(w?433:863,b)}function k(w,b){b=I(149417,b);for(let v=0,u=w.length;v<u;v++)b=I(w.charCodeAt(v),b);return b}e.stringHash=k;function y(w,b){return b=I(104579,b),w.reduce((v,u)=>A(u,v),b)}function n(w,b){return b=I(181387,b),Object.keys(w).sort().reduce((v,u)=>(v=k(u,v),A(w[u],v)),b)}class R{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=A(b,this._value),this._value}}e.Hasher=R;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function g(w,b,v=32){const u=v-b,l=~((1<<u)-1);return(w<<b|(l&w)>>>u)>>>0}function m(w,b=0,v=w.byteLength,u=0){for(let l=0;l<v;l++)w[b+l]=u}function s(w,b,v="0"){for(;w.length<b;)w=v+w;return w}function d(w,b=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(v=>v.toString(16).padStart(2,"0")).join(""):s((w>>>0).toString(16),b/4)}e.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const v=b.length;if(v!==0){const u=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,i,a;for(t!==0?(i=t,a=-1,t=0):(i=b.charCodeAt(0),a=0);;){let r=i;if(_.isHighSurrogate(i))if(a+1<v){const c=b.charCodeAt(a+1);_.isLowSurrogate(c)?(a++,r=_.computeCodePoint(i,c)):r=65533}else{t=i;break}else _.isLowSurrogate(i)&&(r=65533);if(l=this._push(u,l,r),a++,a<v)i=b.charCodeAt(a);else break}this._buffLen=l,this._leftoverHighSurrogate=t}}_push(b,v,u){return u<128?b[v++]=u:u<2048?(b[v++]=192|(u&1984)>>>6,b[v++]=128|(u&63)>>>0):u<65536?(b[v++]=224|(u&61440)>>>12,b[v++]=128|(u&4032)>>>6,b[v++]=128|(u&63)>>>0):(b[v++]=240|(u&1835008)>>>18,b[v++]=128|(u&258048)>>>12,b[v++]=128|(u&4032)>>>6,b[v++]=128|(u&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,v=this._buffDV;for(let p=0;p<64;p+=4)b.setUint32(p,v.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)b.setUint32(p,g(b.getUint32(p-12,!1)^b.getUint32(p-32,!1)^b.getUint32(p-56,!1)^b.getUint32(p-64,!1),1),!1);let u=this._h0,l=this._h1,t=this._h2,i=this._h3,a=this._h4,r,c,o;for(let p=0;p<80;p++)p<20?(r=l&t|~l&i,c=1518500249):p<40?(r=l^t^i,c=1859775393):p<60?(r=l&t|l&i|t&i,c=2400959708):(r=l^t^i,c=3395469782),o=g(u,5)+r+a+c+b.getUint32(p*4,!1)&4294967295,a=i,i=t,t=g(l,30),l=u,u=o;this._h0=this._h0+u&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[56],ge([0,1,10]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(P||(P={})),function(A){const I="error",D="warning",k="warn",y="info";function n(R){return R?_.equalsIgnoreCase(I,R)?A.Error:_.equalsIgnoreCase(D,R)||_.equalsIgnoreCase(k,R)?A.Warning:_.equalsIgnoreCase(y,R)?A.Info:A.Ignore:A.Ignore}A.fromValue=n}(P||(P={})),e.default=P}),define(me[15],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(o){return Array.isArray(o)}e.isArray=_;function P(o){return typeof o=="string"}e.isString=P;function A(o){return Array.isArray(o)&&o.every(p=>P(p))}e.isStringArray=A;function I(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=I;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function y(o){return o===!0||o===!1}e.isBoolean=y;function n(o){return typeof o=="undefined"}e.isUndefined=n;function R(o){return!C(o)}e.isDefined=R;function C(o){return n(o)||o===null}e.isUndefinedOrNull=C;function g(o,p){if(!o)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=g;function m(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=m;function s(...o){const p=[];for(let E=0;E<o.length;E++){const f=o[E];if(C(f))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);p.push(f)}return p}e.assertAllDefined=s;const d=Object.prototype.hasOwnProperty;function S(o){if(!I(o))return!1;for(let p in o)if(d.call(o,p))return!1;return!0}e.isEmptyObject=S;function w(o){return typeof o=="function"}e.isFunction=w;function b(...o){return o.length>0&&o.every(w)}e.areFunctions=b;function v(o,p){const E=Math.min(o.length,p.length);for(let f=0;f<E;f++)u(o[f],p[f])}e.validateConstraints=v;function u(o,p){if(P(p)){if(typeof o!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(w(p)){try{if(o instanceof p)return}catch(E){}if(!C(o)&&o.constructor===p||p.length===1&&p.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function l(o){let p=[],E=Object.getPrototypeOf(o);for(;Object.prototype!==E;)p=p.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return p}e.getAllPropertyNames=l;function t(o){const p=[];for(const E of l(o))typeof o[E]=="function"&&p.push(E);return p}e.getAllMethodNames=t;function i(o,p){const E=h=>function(){const T=Array.prototype.slice.call(arguments,0);return p(h,T)};let f={};for(const h of o)f[h]=E(h);return f}e.createProxyObject=i;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function r(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=r;function c(o){return class{constructor(){return new Proxy({},{get(p,E){if(p[E])return p[E];throw new Error(`Not Implemented: ${o}->${String(E)}`)}})}}}e.NotImplementedProxy=c}),define(me[30],ge([0,1,9,10,8,15]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function k(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=k;function y(i,a=A.posix.sep){if(!i)return"";const r=i.length,c=i.charCodeAt(0);if(D(c)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let p=3;const E=p;for(;p<r&&!D(i.charCodeAt(p));p++);if(E!==p&&!D(i.charCodeAt(p+1))){for(p+=1;p<r;p++)if(D(i.charCodeAt(p)))return i.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(S(c)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let o=i.indexOf("://");if(o!==-1){for(o+=3;o<r;o++)if(D(i.charCodeAt(o)))return i.slice(0,o+1)}return""}e.getRoot=y;function n(i){if(!_.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let r=2;const c=r;for(;r<i.length&&(a=i.charCodeAt(r),a!==92);r++);return!(c===r||(a=i.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=n;const R=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,a=_.isWindows){const r=a?R:C;return!(!i||i.length===0||/^\s+$/.test(i)||(r.lastIndex=0,r.test(i))||a&&g.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function s(i,a,r){const c=i===a;return!r||c?c:!i||!a?!1:(0,P.equalsIgnoreCase)(i,a)}e.isEqual=s;function d(i,a,r,c=A.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(r){if(!(0,P.startsWithIgnoreCase)(i,a))return!1;if(a.length===i.length)return!0;let p=a.length;return a.charAt(a.length-1)===c&&p--,i.charAt(p)===c}return a.charAt(a.length-1)!==c&&(a+=c),i.indexOf(a)===0}e.isEqualOrParent=d;function S(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=S;function w(i,a){return _.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(a,i)),i=(0,A.normalize)(i),_.isWindows?(i=(0,P.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,P.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=w;function b(i){const a=(0,A.normalize)(i);return _.isWindows?i.length>3?!1:v(a)&&(i.length===2||a.charCodeAt(2)===92):a===A.posix.sep}e.isRootOrDriveLetter=b;function v(i){return _.isWindows?S(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function u(i){return v(i)?i[0]:void 0}e.getDriveLetter=u;function l(i,a,r){return a.length>i.length?-1:i===a?0:(r&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=l;function t(i){const a=i.split(":");let r,c,o;if(a.forEach(p=>{const E=Number(p);(0,I.isNumber)(E)?c===void 0?c=E:o===void 0&&(o=E):r=r?[r,p].join(":"):p}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:c!==void 0?c:void 0,column:o!==void 0?o:c!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[23],ge([0,1,15]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const d=Array.isArray(s)?[]:{};return Object.keys(s).forEach(S=>{s[S]&&typeof s[S]=="object"?d[S]=P(s[S]):d[S]=s[S]}),d}e.deepClone=P;function A(s){if(!s||typeof s!="object")return s;const d=[s];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const w in S)if(I.call(S,w)){const b=S[w];typeof b=="object"&&!Object.isFrozen(b)&&d.push(b)}}return s}e.deepFreeze=A;const I=Object.prototype.hasOwnProperty;function D(s,d){return k(s,d,new Set)}e.cloneAndChange=D;function k(s,d,S){if((0,_.isUndefinedOrNull)(s))return s;const w=d(s);if(typeof w!="undefined")return w;if((0,_.isArray)(s)){const b=[];for(const v of s)b.push(k(v,d,S));return b}if((0,_.isObject)(s)){if(S.has(s))throw new Error("Cannot clone recursive data-structure");S.add(s);const b={};for(let v in s)I.call(s,v)&&(b[v]=k(s[v],d,S));return S.delete(s),b}return s}function y(s,d,S=!0){return(0,_.isObject)(s)?((0,_.isObject)(d)&&Object.keys(d).forEach(w=>{w in s?S&&((0,_.isObject)(s[w])&&(0,_.isObject)(d[w])?y(s[w],d[w],S):s[w]=d[w]):s[w]=d[w]}),s):d}e.mixin=y;function n(s,d){if(s===d)return!0;if(s==null||d===null||d===void 0||typeof s!=typeof d||typeof s!="object"||Array.isArray(s)!==Array.isArray(d))return!1;let S,w;if(Array.isArray(s)){if(s.length!==d.length)return!1;for(S=0;S<s.length;S++)if(!n(s[S],d[S]))return!1}else{const b=[];for(w in s)b.push(w);b.sort();const v=[];for(w in d)v.push(w);if(v.sort(),!n(b,v))return!1;for(S=0;S<b.length;S++)if(!n(s[b[S]],d[b[S]]))return!1}return!0}e.equals=n;function R(s){const d=new Set;return JSON.stringify(s,(S,w)=>{if((0,_.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=R;function C(s,d,S){const w=d(s);return typeof w=="undefined"?S:w}e.getOrDefault=C;function g(s,d){const S=Object.create(null);return!s||!d||Object.keys(d).forEach(b=>{const v=s[b],u=d[b];n(v,u)||(S[b]=u)}),S}e.distinct=g;function m(s,d){const S=d.toLowerCase(),w=Object.keys(s).find(b=>b.toLowerCase()===S);return w?s[w]:s[d]}e.getCaseInsensitive=m}),define(me[93],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function P(I){return I<0?0:I>255?255:I|0}e.toUint8=P;function A(I){return I<0?0:I>4294967295?4294967295:I|0}e.toUint32=A}),define(me[2],ge([0,1,9,8]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//;function k(a,r){if(!a.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!A.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!I.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,r){return!a&&!r?"file":a}function n(a,r){switch(a){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const R="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(r,c,o,p,E,f=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=y(r,f),this.authority=c||R,this.path=n(this.scheme,o||R),this.query=p||R,this.fragment=E||R,k(this,f))}static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return v(this,!1)}with(r){if(!r)return this;let{scheme:c,authority:o,path:p,query:E,fragment:f}=r;return c===void 0?c=this.scheme:c===null&&(c=R),o===void 0?o=this.authority:o===null&&(o=R),p===void 0?p=this.path:p===null&&(p=R),E===void 0?E=this.query:E===null&&(E=R),f===void 0?f=this.fragment:f===null&&(f=R),c===this.scheme&&o===this.authority&&p===this.path&&E===this.query&&f===this.fragment?this:new d(c,o,p,E,f)}static parse(r,c=!1){const o=g.exec(r);return o?new d(o[2]||R,i(o[4]||R),i(o[5]||R),i(o[7]||R),i(o[9]||R),c):new d(R,R,R,R,R)}static file(r){let c=R;if(_.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const o=r.indexOf(C,2);o===-1?(c=r.substring(2),r=C):(c=r.substring(2,o),r=r.substring(o)||C)}return new d("file",c,r,R,R)}static from(r){return new d(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...c){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return _.isWindows&&r.scheme==="file"?o=m.file(P.win32.join(v(r,!0),...c)).path:o=P.posix.join(r.path,...c),r.with({path:o})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const c=new d(r);return c._formatted=r.external,c._fsPath=r._sep===s?r.fsPath:null,c}}else return r}}e.URI=m;const s=_.isWindows?1:void 0;class d extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=s),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(a,r){let c,o=-1;for(let p=0;p<a.length;p++){const E=a.charCodeAt(p);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||r&&E===47)o!==-1&&(c+=encodeURIComponent(a.substring(o,p)),o=-1),c!==void 0&&(c+=a.charAt(p));else{c===void 0&&(c=a.substr(0,p));const f=S[E];f!==void 0?(o!==-1&&(c+=encodeURIComponent(a.substring(o,p)),o=-1),c+=f):o===-1&&(o=p)}}return o!==-1&&(c+=encodeURIComponent(a.substring(o))),c!==void 0?c:a}function b(a){let r;for(let c=0;c<a.length;c++){const o=a.charCodeAt(c);o===35||o===63?(r===void 0&&(r=a.substr(0,c)),r+=S[o]):r!==void 0&&(r+=a[c])}return r!==void 0?r:a}function v(a,r){let c;return a.authority&&a.path.length>1&&a.scheme==="file"?c=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?r?c=a.path.substr(1):c=a.path[1].toLowerCase()+a.path.substr(2):c=a.path,_.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=v;function u(a,r){const c=r?b:w;let o="",{scheme:p,authority:E,path:f,query:h,fragment:T}=a;if(p&&(o+=p,o+=":"),(E||p==="file")&&(o+=C,o+=C),E){let L=E.indexOf("@");if(L!==-1){const W=E.substr(0,L);E=E.substr(L+1),L=W.indexOf(":"),L===-1?o+=c(W,!1):(o+=c(W.substr(0,L),!1),o+=":",o+=c(W.substr(L+1),!1)),o+="@"}E=E.toLowerCase(),L=E.indexOf(":"),L===-1?o+=c(E,!1):(o+=c(E.substr(0,L),!1),o+=E.substr(L))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const L=f.charCodeAt(1);L>=65&&L<=90&&(f=`/${String.fromCharCode(L+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const L=f.charCodeAt(0);L>=65&&L<=90&&(f=`${String.fromCharCode(L+32)}:${f.substr(2)}`)}o+=c(f,!0)}return h&&(o+="?",o+=c(h,!1)),T&&(o+="#",o+=r?T:w(T,!1)),o}function l(a){try{return decodeURIComponent(a)}catch(r){return a.length>3?a.substr(0,3)+l(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(a){return a.match(t)?a.replace(t,r=>l(r)):a}}),define(me[24],ge([0,1,2,10]),function(G,e,_,P){"use strict";var A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(u,l,t){let i=u.get(l);return i===void 0&&(i=t,u.set(l,i)),i}e.getOrSet=D;function k(u){const l=[];return u.forEach((t,i)=>{l.push(`${i} => ${t}`)}),`Map(${u.size}) {${l.join(", ")}}`}e.mapToString=k;function y(u){const l=[];return u.forEach(t=>{l.push(t)}),`Set(${u.size}) {${l.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const t=l.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class R{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,P.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class C{constructor(l=!0,t=!0){this._splitOnBackslash=l,this._caseSensitive=t}reset(l){return this._value=l.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,P.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var g;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(g||(g={}));class m{constructor(l){this._ignorePathCasing=l,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,P.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class s{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class d{constructor(l){this._iter=l}static forUris(l=()=>!1){return new d(new m(l))}static forPaths(){return new d(new C)}static forStrings(){return new d(new n)}static forConfigKeys(){return new d(new R)}clear(){this._root=void 0}set(l,t){const i=this._iter.reset(l);let a;for(this._root||(this._root=new s,this._root.segment=i.value()),a=this._root;;){const c=i.cmp(a.segment);if(c>0)a.left||(a.left=new s,a.left.segment=i.value()),a=a.left;else if(c<0)a.right||(a.right=new s,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new s,a.mid.segment=i.value()),a=a.mid;else break}const r=a.value;return a.value=t,a.key=l,r}get(l){var t;return(t=this._getNode(l))===null||t===void 0?void 0:t.value}_getNode(l){const t=this._iter.reset(l);let i=this._root;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(l){const t=this._getNode(l);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,t){const i=this._iter.reset(l),a=[];let r=this._root;for(;r;){const c=i.cmp(r.segment);if(c>0)a.push([1,r]),r=r.left;else if(c<0)a.push([-1,r]),r=r.right;else if(i.hasNext())i.next(),a.push([0,r]),r=r.mid;else{for(t?(r.left=void 0,r.mid=void 0,r.right=void 0):r.value=void 0;a.length>0&&r.isEmpty();){let[o,p]=a.pop();switch(o){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}r=p}break}}}findSubstr(l){const t=this._iter.reset(l);let i=this._root,a;for(;i;){const r=t.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(t.hasNext())t.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(l){const t=this._iter.reset(l);let i=this._root;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(l){for(const[t,i]of this)l(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(l){l&&(yield*this._entries(l.left),l.value&&(yield[l.key,l.value]),yield*this._entries(l.mid),yield*this._entries(l.right))}}e.TernarySearchTree=d;class S{constructor(l,t){this[A]="ResourceMap",l instanceof S?(this.map=new Map(l.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=l!=null?l:S.defaultToKey)}set(l,t){return this.map.set(this.toKey(l),t),this}get(l){return this.map.get(this.toKey(l))}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,t){typeof t!="undefined"&&(l=l.bind(t));for(let[i,a]of this.map)l(a,_.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let l of this.map.keys())yield _.URI.parse(l)}*entries(){for(let l of this.map.entries())yield[_.URI.parse(l[0]),l[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let l of this.map)yield[_.URI.parse(l[0]),l[1]]}}e.ResourceMap=S,S.defaultToKey=u=>u.toString();var w;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class b{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var l;return(l=this._head)===null||l===void 0?void 0:l.value}get last(){var l;return(l=this._tail)===null||l===void 0?void 0:l.value}has(l){return this._map.has(l)}get(l,t=0){const i=this._map.get(l);if(!!i)return t!==0&&this.touch(i,t),i.value}set(l,t,i=0){let a=this._map.get(l);if(a)a.value=t,i!==0&&this.touch(a,i);else{switch(a={key:l,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(l,a),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const t=this._map.get(l);if(!!t)return this._map.delete(l),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}}forEach(l,t){const i=this._state;let a=this._head;for(;a;){if(t?l.bind(t)(a.value,a.key,this):l(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const l=this,t=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.key,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return a}values(){const l=this,t=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:i.value,done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return a}entries(){const l=this,t=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(l._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const r={value:[i.key,i.value],done:!1};return i=i.next,r}else return{value:void 0,done:!0}}};return a}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(!(l>=this.size)){if(l===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>l;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const t=l.next,i=l.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}l.next=void 0,l.previous=void 0,this._state++}touch(l,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(l===this._head)return;const i=l.next,a=l.previous;l===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(t===2){if(l===this._tail)return;const i=l.next,a=l.previous;l===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((t,i)=>{l.push([i,t])}),l}fromJSON(l){this.clear();for(const[t,i]of l)this.set(t,i)}}e.LinkedMap=b;class v extends b{constructor(l,t=1){super();this._limit=l,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,t=2){return super.get(l,t)}peek(l){return super.get(l,0)}set(l,t){return super.set(l,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v}),define(me[94],ge([0,1,24,10]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...we){return function(ke,Re){for(let Be=0,Ee=we.length;Be<Ee;Be++){const Ge=we[Be](ke,Re);if(Ge)return Ge}return null}}e.or=A,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(we,ke,Re){if(!Re||Re.length<ke.length)return null;let Be;return we?Be=P.startsWithIgnoreCase(Re,ke):Be=Re.indexOf(ke)===0,Be?ke.length>0?[{start:0,end:ke.length}]:[]:null}function D(we,ke){const Re=ke.toLowerCase().indexOf(we.toLowerCase());return Re===-1?null:[{start:Re,end:Re+we.length}]}e.matchesContiguousSubString=D;function k(we,ke){return y(we.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=k;function y(we,ke,Re,Be){if(Re===we.length)return[];if(Be===ke.length)return null;if(we[Re]===ke[Be]){let Ee=null;return(Ee=y(we,ke,Re+1,Be+1))?w({start:Be,end:Be+1},Ee):null}return y(we,ke,Re,Be+1)}function n(we){return 97<=we&&we<=122}function R(we){return 65<=we&&we<=90}e.isUpper=R;function C(we){return 48<=we&&we<=57}function g(we){return we===32||we===9||we===10||we===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(we=>m.add(we.charCodeAt(0)));function s(we){return g(we)||m.has(we)}function d(we,ke){return we===ke||s(we)&&s(ke)}function S(we){return n(we)||R(we)||C(we)}function w(we,ke){return ke.length===0?ke=[we]:we.end===ke[0].start?ke[0].start=we.start:ke.unshift(we),ke}function b(we,ke){for(let Re=ke;Re<we.length;Re++){const Be=we.charCodeAt(Re);if(R(Be)||C(Be)||Re>0&&!S(we.charCodeAt(Re-1)))return Re}return we.length}function v(we,ke,Re,Be){if(Re===we.length)return[];if(Be===ke.length)return null;if(we[Re]!==ke[Be].toLowerCase())return null;{let Ee=null,Ge=Be+1;for(Ee=v(we,ke,Re+1,Be+1);!Ee&&(Ge=b(ke,Ge))<ke.length;)Ee=v(we,ke,Re+1,Ge),Ge++;return Ee===null?null:w({start:Be,end:Be+1},Ee)}}function u(we){let ke=0,Re=0,Be=0,Ee=0,Ge=0;for(let ze=0;ze<we.length;ze++)Ge=we.charCodeAt(ze),R(Ge)&&ke++,n(Ge)&&Re++,S(Ge)&&Be++,C(Ge)&&Ee++;const Q=ke/we.length,re=Re/we.length,be=Be/we.length,Ue=Ee/we.length;return{upperPercent:Q,lowerPercent:re,alphaPercent:be,numericPercent:Ue}}function l(we){const{upperPercent:ke,lowerPercent:Re}=we;return Re===0&&ke>.6}function t(we){const{upperPercent:ke,lowerPercent:Re,alphaPercent:Be,numericPercent:Ee}=we;return Re>.2&&ke<.8&&Be>.6&&Ee<.2}function i(we){let ke=0,Re=0,Be=0,Ee=0;for(let Ge=0;Ge<we.length;Ge++)Be=we.charCodeAt(Ge),R(Be)&&ke++,n(Be)&&Re++,g(Be)&&Ee++;return(ke===0||Re===0)&&Ee===0?we.length<=30:ke<=5}function a(we,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!i(we)||ke.length>60)return null;const Re=u(ke);if(!t(Re)){if(!l(Re))return null;ke=ke.toLowerCase()}let Be=null,Ee=0;for(we=we.toLowerCase();Ee<ke.length&&(Be=v(we,ke,0,Ee))===null;)Ee=b(ke,Ee+1);return Be}e.matchesCamelCase=a;function r(we,ke,Re=!1){if(!ke||ke.length===0)return null;let Be=null,Ee=0;for(we=we.toLowerCase(),ke=ke.toLowerCase();Ee<ke.length&&(Be=c(we,ke,0,Ee,Re))===null;)Ee=o(ke,Ee+1);return Be}e.matchesWords=r;function c(we,ke,Re,Be,Ee){if(Re===we.length)return[];if(Be===ke.length)return null;if(d(we.charCodeAt(Re),ke.charCodeAt(Be))){let Ge=null,Q=Be+1;if(Ge=c(we,ke,Re+1,Be+1,Ee),!Ee)for(;!Ge&&(Q=o(ke,Q))<ke.length;)Ge=c(we,ke,Re+1,Q,Ee),Q++;return Ge===null?null:w({start:Be,end:Be+1},Ge)}else return null}function o(we,ke){for(let Re=ke;Re<we.length;Re++)if(s(we.charCodeAt(Re))||Re>0&&s(we.charCodeAt(Re-1)))return Re;return we.length}const p=A(e.matchesPrefix,a,D),E=A(e.matchesPrefix,a,k),f=new _.LRUCache(1e4);function h(we,ke,Re=!1){if(typeof we!="string"||typeof ke!="string")return null;let Be=f.get(we);Be||(Be=new RegExp(P.convertSimple2RegExpPattern(we),"i"),f.set(we,Be));const Ee=Be.exec(ke);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Re?E(we,ke):p(we,ke)}e.matchesFuzzy=h;function T(we,ke){const Re=z(we,we.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Re?W(Re):null}e.matchesFuzzy2=T;function L(we,ke,Re,Be,Ee,Ge){const Q=Math.min(13,we.length);for(;Re<Q;Re++){const re=z(we,ke,Re,Be,Ee,Ge,!1);if(re)return re}return[0,Ge]}e.anyScore=L;function W(we){if(typeof we=="undefined")return[];const ke=[],Re=we[1];for(let Be=we.length-1;Be>1;Be--){const Ee=we[Be]+Re,Ge=ke[ke.length-1];Ge&&Ge.end===Ee?Ge.end=Ee+1:ke.push({start:Ee,end:Ee+1})}return ke}e.createMatches=W;const ee=128;function j(){const we=[],ke=[];for(let Re=0;Re<=ee;Re++)ke[Re]=0;for(let Re=0;Re<=ee;Re++)we.push(ke.slice(0));return we}function x(we){const ke=[];for(let Re=0;Re<=we;Re++)ke[Re]=0;return ke}const $=x(2*ee),F=x(2*ee),U=j(),M=j(),N=j(),O=!1;function V(we,ke,Re,Be,Ee){function Ge(re,be,Ue=" "){for(;re.length<be;)re=Ue+re;return re}let Q=` |   |${Be.split("").map(re=>Ge(re,3)).join("|")}
`;for(let re=0;re<=Re;re++)re===0?Q+=" |":Q+=`${ke[re-1]}|`,Q+=we[re].slice(0,Ee+1).map(be=>Ge(be.toString(),3)).join("|")+`
`;return Q}function q(we,ke,Re,Be){we=we.substr(ke),Re=Re.substr(Be),console.log(V(M,we,we.length,Re,Re.length)),console.log(V(N,we,we.length,Re,Re.length)),console.log(V(U,we,we.length,Re,Re.length))}function X(we,ke){if(ke<0||ke>=we.length)return!1;const Re=we.codePointAt(ke);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(Re)}}function fe(we,ke){if(ke<0||ke>=we.length)return!1;switch(we.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function ve(we,ke,Re){return ke[we]!==Re[we]}function Ae(we,ke,Re,Be,Ee,Ge,Q=!1){for(;ke<Re&&Ee<Ge;)we[ke]===Be[Ee]&&(Q&&($[ke]=Ee),ke+=1),Ee+=1;return ke===Re}e.isPatternInWord=Ae;var Pe;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var Fe;(function(we){we.Default=[-100,0];function ke(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}we.isDefault=ke})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function z(we,ke,Re,Be,Ee,Ge,Q){const re=we.length>ee?ee:we.length,be=Be.length>ee?ee:Be.length;if(!(Re>=re||Ge>=be||re-Re>be-Ge)&&!!Ae(ke,Re,re,Ee,Ge,be,!0)){J(re,be,Re,Ge,ke,Ee);let Ue=1,ze=1,$e=Re,Ze=Ge;const K=[!1];for(Ue=1,$e=Re;$e<re;Ue++,$e++){const ce=$[$e],pe=F[$e],ye=$e+1<re?F[$e+1]:be;for(ze=ce-Ge+1,Ze=ce;Ze<ye;ze++,Ze++){let We=Number.MIN_SAFE_INTEGER,Ne=!1;Ze<=pe&&(We=te(we,ke,$e,Re,Be,Ee,Ze,be,Ge,U[Ue-1][ze-1]===0,K));let Ke=0;We!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ke=We+M[Ue-1][ze-1]);const Xe=Ze>ce,nt=Xe?M[Ue][ze-1]+(U[Ue][ze-1]>0?-5:0):0,rt=Ze>ce+1&&U[Ue][ze-1]>0,ot=rt?M[Ue][ze-2]+(U[Ue][ze-2]>0?-5:0):0;if(rt&&(!Xe||ot>=nt)&&(!Ne||ot>=Ke))M[Ue][ze]=ot,N[Ue][ze]=3,U[Ue][ze]=0;else if(Xe&&(!Ne||nt>=Ke))M[Ue][ze]=nt,N[Ue][ze]=2,U[Ue][ze]=0;else if(Ne)M[Ue][ze]=Ke,N[Ue][ze]=1,U[Ue][ze]=U[Ue-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(we,Re,Be,Ge),!(!K[0]&&!Q)){Ue--,ze--;const oe=[M[Ue][ze],Ge];let de=0,Y=0;for(;Ue>=1;){let ce=ze;do{const pe=N[Ue][ce];if(pe===3)ce=ce-2;else if(pe===2)ce=ce-1;else break}while(ce>=1);de>1&&ke[Re+Ue-1]===Ee[Ge+ze-1]&&!ve(ce+Ge-1,Be,Ee)&&de+1>U[Ue][ce]&&(ce=ze),ce===ze?de++:de=1,Y||(Y=ce),Ue--,ze=ce-1,oe.push(ze)}be===re&&(oe[0]+=2);const ie=Y-re;return oe[0]-=ie,oe}}}e.fuzzyScore=z;function J(we,ke,Re,Be,Ee,Ge){let Q=we-1,re=ke-1;for(;Q>=Re&&re>=Be;)Ee[Q]===Ge[re]&&(F[Q]=re,Q--),re--}function te(we,ke,Re,Be,Ee,Ge,Q,re,be,Ue,ze){if(ke[Re]!==Ge[Q])return Number.MIN_SAFE_INTEGER;let $e=1,Ze=!1;return Q===Re-Be?$e=we[Re]===Ee[Q]?7:5:ve(Q,Ee,Ge)&&(Q===0||!ve(Q-1,Ee,Ge))?($e=we[Re]===Ee[Q]?7:5,Ze=!0):X(Ge,Q)&&(Q===0||!X(Ge,Q-1))?$e=5:(X(Ge,Q-1)||fe(Ge,Q-1))&&($e=5,Ze=!0),$e>1&&Re===Be&&(ze[0]=!0),Ze||(Ze=ve(Q,Ee,Ge)||X(Ge,Q-1)||fe(Ge,Q-1)),Re===Be?Q>be&&($e-=Ze?3:5):Ue?$e+=Ze?2:0:$e+=Ze?0:1,Q+1===re&&($e-=Ze?3:5),$e}function le(we,ke,Re,Be,Ee,Ge,Q){return Ce(we,ke,Re,Be,Ee,Ge,!0,Q)}e.fuzzyScoreGracefulAggressive=le;function he(we,ke,Re,Be,Ee,Ge,Q){return Ce(we,ke,Re,Be,Ee,Ge,!1,Q)}e.fuzzyScoreGraceful=he;function Ce(we,ke,Re,Be,Ee,Ge,Q,re){let be=z(we,ke,Re,Be,Ee,Ge,re);if(be&&!Q)return be;if(we.length>=3){const Ue=Math.min(7,we.length-1);for(let ze=Re+1;ze<Ue;ze++){const $e=Me(we,ze);if($e){const Ze=z($e,$e.toLowerCase(),Re,Be,Ee,Ge,re);Ze&&(Ze[0]-=3,(!be||Ze[0]>be[0])&&(be=Ze))}}}return be}function Me(we,ke){if(!(ke+1>=we.length)){const Re=we[ke],Be=we[ke+1];if(Re!==Be)return we.slice(0,ke)+Be+Re+we.slice(ke+2)}}}),define(me[135],ge([0,1,43,94,10]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${I.source}`,"g");function k(d){return d.replace(D,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=k;const y=new RegExp(`\\\\${I.source}`,"g");function n(d){return d.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=n;const R=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function C(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(R,(S,w,b,v)=>b?S:w||v||"")}e.stripIcons=C;function g(d){const S=d.indexOf(e.iconStartMarker);return S===-1?{text:d}:m(d,S)}e.parseLabelWithIcons=g;function m(d,S){const w=[];let b="";function v(o){if(o){b+=o;for(const p of o)w.push(t)}}let u=-1,l="",t=0,i,a,r=S;const c=d.length;for(v(d.substr(0,S));r<c;)i=d[r],a=d[r+1],i===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(u=r,v(l),l=e.iconStartMarker,r++):i===")"&&u!==-1?(t+=r-u+1,u=-1,l=""):u!==-1?/^[a-z0-9\-]$/i.test(i)?l+=i:(v(l),u=-1,l=""):v(i),r++;return v(l),{text:b,iconOffsets:w}}function s(d,S,w=!1){const{text:b,iconOffsets:v}=S;if(!v||v.length===0)return(0,P.matchesFuzzy)(d,b,w);const u=(0,A.ltrim)(b," "),l=b.length-u.length,t=(0,P.matchesFuzzy)(d,u,w);if(t)for(const i of t){const a=v[i.start+l]+l;i.start+=a,i.end+=a}return t}e.matchesFuzzyIconAware=s}),define(me[95],ge([0,1,14,135,18]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",S=!1){var w,b;if(this.value=d,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(w=S.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(b=S.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(d,S=0){return this.value+=C(this.supportThemeIcons?(0,P.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,S){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=D;function k(s){return y(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.isEmptyMarkdownString=k;function y(s){return s instanceof D?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(s,d){return!s&&!d?!0:!s||!d?!1:Array.isArray(s)&&Array.isArray(d)?(0,_.equals)(s,d,R):y(s)&&y(d)?R(s,d):!1}e.markedStringsEquals=n;function R(s,d){return s===d?!0:!s||!d?!1:s.value===d.value&&s.isTrusted===d.isTrusted&&s.supportThemeIcons===d.supportThemeIcons}function C(s){return s.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function g(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function m(s){const d=[],S=s.split("|").map(b=>b.trim());s=S[0];const w=S[1];if(w){const b=/height=(\d+)/.exec(w),v=/width=(\d+)/.exec(w),u=b?b[1]:"",l=v?v[1]:"",t=isFinite(parseInt(l)),i=isFinite(parseInt(u));t&&d.push(`width="${l}"`),i&&d.push(`height="${u}"`)}return{href:s,dimensions:d}}e.parseHrefAndDimensions=m}),define(me[57],ge([0,1,22,10,2]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(n){return JSON.stringify(n,k)}e.stringify=I;function D(n){let R=JSON.parse(n);return R=y(R),R}e.parse=D;function k(n,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,P.regExpFlags)(R)}:R}function y(n,R=0){if(!n||R>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return A.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof _.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let C=0;C<n.length;++C)n[C]=y(n[C],R+1);else for(const C in n)Object.hasOwnProperty.call(n,C)&&(n[C]=y(n[C],R+1))}return n}e.revive=y}),define(me[11],ge([0,1,2,9]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,R){this._hosts[y]=n,this._ports[y]=R}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let R=this._hosts[n];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const C=this._ports[n],g=this._connectionTokens[n];let m=`path=${encodeURIComponent(y.path)}`;return typeof g=="string"&&(m+=`&tkn=${encodeURIComponent(g)}`),_.URI.from({scheme:P.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${R}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new I;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,R){const C=this.toUri(y,n);return C.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(C):P.isNative&&(R||P.isPreferringBrowserCodeLoad)&&C.scheme===A.file?C.with({scheme:A.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,n){const R=this.toUri(y,n);return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==this.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(y,n){return _.URI.isUri(y)?y:_.URI.parse(n.toUrl(y))}}e.FileAccess=new D}),define(me[75],ge([0,1,24]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const P=new _.LRUCache(1e4);function A(n){return y(n,"NFC",P)}e.normalizeNFC=A;const I=new _.LRUCache(1e4);function D(n){return y(n,"NFD",I)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function y(n,R,C){if(!e.canNormalize||!n)return n;const g=C.get(n);if(g)return g;let m;return k.test(n)?m=n.normalize(R):m=n,C.set(n,m),m}e.removeAccents=function(){if(e.canNormalize){const n=/[\u0300-\u036f]/g;return function(R){return D(R).replace(n,"")}}else return function(n){return n}}()}),define(me[25],ge([0,1,30,8,2,10,11,9]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=y;class n{constructor(s){this._ignorePathCasing=s}compare(s,d,S=!1){return s===d?0:(0,I.compare)(this.getComparisonKey(s,S),this.getComparisonKey(d,S))}isEqual(s,d,S=!1){return s===d?!0:!s||!d?!1:this.getComparisonKey(s,S)===this.getComparisonKey(d,S)}getComparisonKey(s,d=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,d,S=!1){if(s.scheme===d.scheme){if(s.scheme===D.Schemas.file)return _.isEqualOrParent(y(s),y(d),this._ignorePathCasing(s))&&s.query===d.query&&(S||s.fragment===d.fragment);if((0,e.isEqualAuthority)(s.authority,d.authority))return _.isEqualOrParent(s.path,d.path,this._ignorePathCasing(s),"/")&&s.query===d.query&&(S||s.fragment===d.fragment)}return!1}joinPath(s,...d){return A.URI.joinPath(s,...d)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return P.posix.basename(s.path)}extname(s){return P.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let d;return s.scheme===D.Schemas.file?d=A.URI.file(P.dirname(y(s))).path:(d=P.posix.dirname(s.path),s.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),d="/")),s.with({path:d})}normalizePath(s){if(!s.path.length)return s;let d;return s.scheme===D.Schemas.file?d=A.URI.file(P.normalize(y(s))).path:d=P.posix.normalize(s.path),s.with({path:d})}relativePath(s,d){if(!(s.scheme!==d.scheme||!(0,e.isEqualAuthority)(s.authority,d.authority))){if(s.scheme===D.Schemas.file){const b=P.relative(y(s),y(d));return k.isWindows?_.toSlashes(b):b}let S=s.path||"/",w=d.path||"/";if(this._ignorePathCasing(s)){let b=0;for(const v=Math.min(S.length,w.length);b<v&&!(S.charCodeAt(b)!==w.charCodeAt(b)&&S.charAt(b).toLowerCase()!==w.charAt(b).toLowerCase());b++);S=w.substr(0,b)+S.substr(b)}return P.posix.relative(S,w)}}resolvePath(s,d){if(s.scheme===D.Schemas.file){const S=A.URI.file(P.resolve(y(s),d));return s.with({authority:S.authority,path:S.path})}return d.indexOf("/")===-1&&(d=_.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),s.with({path:P.posix.resolve(s.path,d)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,d){return s===d||(0,I.equalsIgnoreCase)(s,d)}hasTrailingPathSeparator(s,d=P.sep){if(s.scheme===D.Schemas.file){const S=y(s);return S.length>_.getRoot(S).length&&S[S.length-1]===d}else{const S=s.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,d=P.sep){return(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,d=P.sep){let S=!1;if(s.scheme===D.Schemas.file){const w=y(s);S=w!==void 0&&w.length===_.getRoot(w).length&&w[w.length-1]===d}else{d="/";const w=s.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(s,d)?s.with({path:s.path+"/"}):s}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(m=>m.scheme===D.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new n(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(m,s){const d=[];for(let S=0;S<m.length;S++){const w=s(m[S]);m.some((b,v)=>v===S?!1:(0,e.isEqualOrParent)(w,s(b)))||d.push(m[S])}return d}e.distinctParents=R;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function s(d){const S=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(v=>{const[u,l]=v.split(":");u&&l&&S.set(u,l)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&S.set(m.META_DATA_MIME,b),S}m.parseMetaData=s})(C=e.DataUri||(e.DataUri={}));function g(m,s,d){if(s){let S=m.path;return S&&S[0]!==P.posix.sep&&(S=P.posix.sep+S),m.with({scheme:d,authority:s,path:S})}return m.with({scheme:d})}e.toLocalResource=g}),define(me[19],ge([0,1,21,18,3,6,55,25]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(M){return!!M&&typeof M.then=="function"}e.isThenable=y;function n(M){const N=new _.CancellationTokenSource,O=M(N.token),V=new Promise((q,X)=>{N.token.onCancellationRequested(()=>{X((0,P.canceled)())}),Promise.resolve(O).then(fe=>{N.dispose(),q(fe)},fe=>{N.dispose(),X(fe)})});return new class{cancel(){N.cancel()}then(q,X){return V.then(q,X)}catch(q){return this.then(void 0,q)}finally(q){return V.finally(q)}}}e.createCancelablePromise=n;function R(M,N,O){return Promise.race([M,new Promise(V=>N.onCancellationRequested(()=>V(O)))])}e.raceCancellation=R;async function C(M){let N=-1;const O=M.map((q,X)=>q.then(fe=>(N=X,fe))),V=await Promise.race(O);return M.forEach((q,X)=>{X!==N&&q.cancel()}),V}e.raceCancellablePromises=C;function g(M,N,O){let V;const q=setTimeout(()=>{V==null||V(void 0),O==null||O()},N);return Promise.race([M.finally(()=>clearTimeout(q)),new Promise(X=>V=X)])}e.raceTimeout=g;function m(M){return new Promise((N,O)=>{const V=M();y(V)?V.then(N,O):N(V)})}e.asPromise=m;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(O,O).then(V)})}return new Promise((O,V)=>{this.queuedPromise.then(O,V)})}return this.activePromise=N(),new Promise((O,V)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,V(q)})})}}e.Throttler=s;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class S{constructor(){this.promiseMap=new Map}queue(N,O){var V;const X=((V=this.promiseMap.get(N))!==null&&V!==void 0?V:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(N)===X&&this.promiseMap.delete(N)});return this.promiseMap.set(N,X),X}}e.SequencerByKey=S;class w{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,O=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,q)=>{this.doResolve=V,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,P.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class b{constructor(N){this.delayer=new w(N),this.throttler=new s}trigger(N,O){return this.delayer.trigger(()=>this.throttler.queue(N),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class v{constructor(){this._isOpen=!1,this._promise=new Promise((N,O)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class u extends v{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function l(M,N){return N?new Promise((O,V)=>{const q=setTimeout(O,M);N.onCancellationRequested(()=>{clearTimeout(q),V((0,P.canceled)())})}):n(O=>l(M,O))}e.timeout=l;function t(M,N=0){const O=setTimeout(M,N);return(0,I.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function i(M){return M.then(void 0,N=>{})}e.ignoreErrors=i;function a(M){const N=[];let O=0;const V=M.length;function q(){return O<V?M[O++]():null}function X(fe){fe!=null&&N.push(fe);const ve=q();return ve?ve.then(X):Promise.resolve(N)}return Promise.resolve(null).then(X)}e.sequence=a;function r(M,N=V=>!!V,O=null){let V=0;const q=M.length,X=()=>{if(V>=q)return Promise.resolve(O);const fe=M[V++];return Promise.resolve(fe()).then(Ae=>N(Ae)?Promise.resolve(Ae):X())};return X()}e.first=r;function c(M,N=V=>!!V,O=null){if(M.length===0)return Promise.resolve(O);let V=M.length;const q=()=>{var X,fe;V=-1;for(const ve of M)(fe=(X=ve).cancel)===null||fe===void 0||fe.call(X)};return new Promise((X,fe)=>{for(const ve of M)ve.then(Ae=>{--V>=0&&N(Ae)?(q(),X(Ae)):V===0&&X(O)}).catch(Ae=>{--V>=0&&(q(),fe(Ae))})})}e.firstParallel=c;class o{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((O,V)=>{this.outstandingPromises.push({factory:N,c:O,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const O=N.factory();O.then(N.c,N.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class p extends o{constructor(){super(1)}}e.Queue=p;class E{constructor(){this.queues=new Map}queueFor(N,O=k.extUri){const V=O.getComparisonKey(N);let q=this.queues.get(V);return q||(q=new p,A.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(V)}),this.queues.set(V,q)),q}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=E;class f{constructor(N,O){this._token=-1,typeof N=="function"&&typeof O=="number"&&this.setIfNotSet(N,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},O)}setIfNotSet(N,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},O))}}e.TimeoutTimer=f;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,O){this.cancel(),this._token=setInterval(()=>{N()},O)}}e.IntervalTimer=h;class T{constructor(N,O){this.timeoutToken=-1,this.runner=N,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class L extends T{constructor(N,O){super(N,O);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const O=setTimeout(()=>N(M));let V=!1;return{dispose(){V||(V=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,N)=>{const O=requestIdleCallback(M,typeof N=="number"?{timeout:N}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(O))}}}}();class W{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function ee(M,N,O){let V;for(let q=0;q<O;q++)try{return await M()}catch(X){V=X,await l(N)}throw V}e.retry=ee;class j{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,O,V){return this._pending={taskId:N,cancel:()=>V==null?void 0:V(),promise:O},O.then(()=>this.donePending(N),()=>this.donePending(N)),O}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let O,V;const q=new Promise((X,fe)=>{O=X,V=fe});this._next={run:N,promise:q,promiseResolve:O,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=j;class x{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,O)=>{this.completeCallback=N,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(O=>{this.completeCallback(N),this.resolved=!0,O()})}error(N){return new Promise(O=>{this.errorCallback(N),this.rejected=!0,O()})}cancel(){new Promise(N=>{this.errorCallback((0,P.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=$;class F extends A.Emitter{async fireAsync(N,O,V){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,N]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,X]=this._asyncDeliveryQueue.shift(),fe=[],ve=Object.assign(Object.assign({},X),{waitUntil:Ae=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");V&&(Ae=V(Ae,typeof q=="function"?q:q[0])),fe.push(Ae)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Ae){(0,P.onUnexpectedError)(Ae);continue}Object.freeze(fe),await U.settled(fe).catch(Ae=>(0,P.onUnexpectedError)(Ae))}}}}e.AsyncEmitter=F;var U;(function(M){async function N(X){return typeof Promise.allSettled=="function"?O(X):V(X)}M.allSettled=N;async function O(X){return Promise.allSettled(X)}async function V(X){return Promise.all(X.map(fe=>fe.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(X){let fe;const ve=await Promise.all(X.map(Ae=>Ae.then(Pe=>Pe,Pe=>{fe||(fe=Pe)})));if(typeof fe!="undefined")throw fe;return ve}M.settled=q})(U=e.Promises||(e.Promises={}))}),define(me[96],ge([0,1,8,19]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new P.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),I=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,l,t=!1){const i=u||"",a=l||"",r=A.value.collator.compare(i,a);return A.value.collatorIsNumeric&&r===0&&i!==a?i<a?-1:1:r}e.compareFileNames=k;function y(u,l){const t=I.value.collator;return u=u||"",l=l||"",d(t,u,l)}e.compareFileNamesDefault=y;function n(u,l,t=!1){t||(u=u&&u.toLowerCase(),l=l&&l.toLowerCase());const[i,a]=m(u),[r,c]=m(l);return i!==r?i<r?-1:1:a===c?0:a<c?-1:1}e.noIntlCompareFileNames=n;function R(u,l){const[t,i]=m(u),[a,r]=m(l);let c=A.value.collator.compare(i,r);if(c===0){if(A.value.collatorIsNumeric&&i!==r)return i<r?-1:1;if(c=A.value.collator.compare(t,a),A.value.collatorIsNumeric&&c===0&&t!==a)return t<a?-1:1}return c}e.compareFileExtensions=R;function C(u,l){u=u||"",l=l||"";const t=s(u),i=s(l),a=I.value.collator,r=D.value.collator;let c;return c=d(r,t,i),c!==0?c:d(a,u,l)}e.compareFileExtensionsDefault=C;const g=/^(.*?)(\.([^.]*))?$/;function m(u,l=!1){const t=u?g.exec(u):[];let i=[t&&t[1]||"",t&&t[3]||""];return l&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function s(u){const l=u?g.exec(u):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function d(u,l,t){let i=u.compare(l,t);return i!==0?i:l.length!==t.length?l.length<t.length?-1:1:0}function S(u,l,t=!1){return t||(u=u&&u.toLowerCase(),l=l&&l.toLowerCase()),u===l?0:u<l?-1:1}function w(u,l,t=!1){const i=u.split(_.sep),a=l.split(_.sep),r=i.length-1,c=a.length-1;let o,p;for(let E=0;;E++){if(o=r===E,p=c===E,o&&p)return k(i[E],a[E],t);if(o)return-1;if(p)return 1;const f=S(i[E],a[E],t);if(f!==0)return f}}e.comparePaths=w;function b(u,l,t){const i=u.toLowerCase(),a=l.toLowerCase(),r=v(u,l,t);if(r)return r;const c=i.endsWith(t),o=a.endsWith(t);if(c!==o)return c?-1:1;const p=k(i,a);return p!==0?p:i.localeCompare(a)}e.compareAnything=b;function v(u,l,t){const i=u.toLowerCase(),a=l.toLowerCase(),r=i.startsWith(t),c=a.startsWith(t);if(r!==c)return r?-1:1;if(r&&c){if(i.length<a.length)return-1;if(i.length>a.length)return 1}return 0}e.compareByPrefix=v}),define(me[97],ge([0,1,96,94,8,9,10]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,y=[k,[]];function n(x,$,F,U){if(!x||!$)return y;const M=x.length,N=$.length;if(M<N)return y;const O=x.toLowerCase();return!U&&!O.includes(F)?y:R($,F,N,x,O,M)}e.scoreFuzzy=n;function R(x,$,F,U,M,N){const O=[],V=[];for(let ve=0;ve<F;ve++){const Ae=ve*N,Pe=Ae-N,Fe=ve>0,z=x[ve],J=$[ve];for(let te=0;te<N;te++){const le=te>0,he=Ae+te,Ce=he-1,Me=Pe+te-1,we=le?O[Ce]:0,ke=Fe&&le?O[Me]:0,Re=Fe&&le?V[Me]:0;let Be;!ke&&Fe?Be=0:Be=C(z,J,U,M,te,Re),Be&&ke+Be>=we?(V[he]=Re+1,O[he]=ke+Be):(V[he]=k,O[he]=we)}}const q=[];let X=F-1,fe=N-1;for(;X>=0&&fe>=0;){const ve=X*N+fe;V[ve]===k||(q.push(fe),X--),fe--}return[O[F*N-1],q.reverse()]}function C(x,$,F,U,M,N){let O=0;if(!g($,U[M]))return O;if(O+=1,N>0&&(O+=N*5),x===F[M]&&(O+=1),M===0)O+=8;else{const V=m(F.charCodeAt(M-1));V?O+=V:(0,P.isUpper)(F.charCodeAt(M))&&(O+=2)}return O}function g(x,$){return x===$?!0:x==="/"||x==="\\"?$==="/"||$==="\\":!1}function m(x){switch(x){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const s=[void 0,[]];function d(x,$,F=0,U=0){const M=$;return M.values&&M.values.length>1?S(x,M.values,F,U):w(x,$,F,U)}e.scoreFuzzy2=d;function S(x,$,F,U){let M=0;const N=[];for(const O of $){const[V,q]=w(x,O,F,U);if(typeof V!="number")return s;M+=V,N.push(...q)}return[M,o(N)]}function w(x,$,F,U){const M=(0,P.fuzzyScore)($.original,$.originalLowercase,F,x,x.toLowerCase(),U,!0);return M?[M[0],(0,P.createMatches)(M)]:s}const b=Object.freeze({score:0}),v=1<<18,u=1<<17,l=1<<16;function t(x,$,F,U,M){if(!x||!$.normalized)return b;const N=U.getItemLabel(x);if(!N)return b;const O=U.getItemDescription(x);let V;O?V=`${N}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`:V=`${N}${$.normalized}${Array.isArray($.values)?$.values.length:""}${F}`;const q=M[V];if(q)return q;const X=i(N,O,U.getItemPath(x),$,F);return M[V]=X,X}e.scoreItemFuzzy=t;function i(x,$,F,U,M){const N=!F||!U.containsPathSeparator;return F&&(I.isLinux?U.pathNormalized===F:(0,D.equalsIgnoreCase)(U.pathNormalized,F))?{score:v,labelMatch:[{start:0,end:x.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:U.values&&U.values.length>1?a(x,$,F,U.values,N,M):r(x,$,F,U,N,M)}function a(x,$,F,U,M,N){let O=0;const V=[],q=[];for(const X of U){const{score:fe,labelMatch:ve,descriptionMatch:Ae}=r(x,$,F,X,M,N);if(fe===k)return b;O+=fe,ve&&V.push(...ve),Ae&&q.push(...Ae)}return{score:O,labelMatch:o(V),descriptionMatch:o(q)}}function r(x,$,F,U,M,N){if(M||!$){const[O,V]=n(x,U.normalized,U.normalizedLowercase,N);if(O){const q=(0,P.matchesPrefix)(U.normalized,x);let X;return q?(X=u,X+=Math.round(U.normalized.length/x.length*100)):X=l,{score:X+O,labelMatch:q||c(V)}}}if($){let O=$;F&&(O=`${$}${A.sep}`);const V=O.length,q=`${O}${x}`,[X,fe]=n(q,U.normalized,U.normalizedLowercase,N);if(X){const ve=c(fe),Ae=[],Pe=[];return ve.forEach(Fe=>{Fe.start<V&&Fe.end>V?(Ae.push({start:0,end:Fe.end-V}),Pe.push({start:Fe.start,end:V})):Fe.start>=V?Ae.push({start:Fe.start-V,end:Fe.end-V}):Pe.push(Fe)}),{score:X,labelMatch:Ae,descriptionMatch:Pe}}}return b}function c(x){const $=[];if(!x)return $;let F;for(const U of x)F&&F.end===U?F.end+=1:(F={start:U,end:U+1},$.push(F));return $}function o(x){const $=x.sort((M,N)=>M.start-N.start),F=[];let U;for(const M of $)!U||!p(U,M)?(U=M,F.push(M)):(U.start=Math.min(U.start,M.start),U.end=Math.max(U.end,M.end));return F}function p(x,$){return!(x.end<$.start||$.end<x.start)}function E(x,$,F,U,M,N){const O=t(x,F,U,M,N),V=t($,F,U,M,N),q=O.score,X=V.score;if((q===v||X===v)&&q!==X)return q===v?-1:1;if(q>l||X>l){if(q!==X)return q>X?-1:1;if(q<u&&X<u){const J=h(O.labelMatch,V.labelMatch);if(J!==0)return J}const Fe=M.getItemLabel(x)||"",z=M.getItemLabel($)||"";if(Fe.length!==z.length)return Fe.length-z.length}if(q!==X)return q>X?-1:1;const fe=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,ve=Array.isArray(V.labelMatch)&&V.labelMatch.length>0;if(fe&&!ve)return-1;if(ve&&!fe)return 1;const Ae=f(x,O,M),Pe=f($,V,M);return Ae&&Pe&&Ae!==Pe?Pe>Ae?-1:1:T(x,$,F,M)}e.compareItemsByFuzzyScore=E;function f(x,$,F){let U=-1,M=-1;if($.descriptionMatch&&$.descriptionMatch.length?U=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(U=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(M=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const N=F.getItemDescription(x);N&&(M+=N.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(M=$.descriptionMatch[$.descriptionMatch.length-1].end);return M-U}function h(x,$){if(!x&&!$||(!x||!x.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!x||!x.length)return 1;const F=x[0].start,M=x[x.length-1].end-F,N=$[0].start,V=$[$.length-1].end-N;return M===V?0:V<M?1:-1}function T(x,$,F,U){const M=U.getItemLabel(x)||"",N=U.getItemLabel($)||"",O=U.getItemDescription(x),V=U.getItemDescription($),q=M.length+(O?O.length:0),X=N.length+(V?V.length:0);if(q!==X)return q-X;const fe=U.getItemPath(x),ve=U.getItemPath($);return fe&&ve&&fe.length!==ve.length?fe.length-ve.length:M!==N?(0,_.compareAnything)(M,N,F.normalized):O&&V&&O!==V?(0,_.compareAnything)(O,V,F.normalized):fe&&ve&&fe!==ve?(0,_.compareAnything)(fe,ve,F.normalized):0}const L=" ";function W(x){typeof x!="string"&&(x="");const $=x.toLowerCase(),{pathNormalized:F,normalized:U,normalizedLowercase:M}=ee(x),N=F.indexOf(A.sep)>=0;let O;const V=x.split(L);if(V.length>1)for(const q of V){const{pathNormalized:X,normalized:fe,normalizedLowercase:ve}=ee(q);fe&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:X,normalized:fe,normalizedLowercase:ve}))}return{original:x,originalLowercase:$,pathNormalized:F,normalized:U,normalizedLowercase:M,values:O,containsPathSeparator:N}}e.prepareQuery=W;function ee(x){let $;I.isWindows?$=x.replace(/\//g,A.sep):$=x.replace(/\\/g,A.sep);const F=(0,D.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:F,normalizedLowercase:F.toLowerCase()}}function j(x){return Array.isArray(x)?W(x.map($=>$.original).join(L)):W(x.original)}e.pieceToQuery=j}),define(me[33],ge([0,1,10,30,8,24,19]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const y="**",n="/",R="[/\\\\]",C="[^/\\\\]",g=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}|${R}${C}+)*?`}}function s(O,V){if(!O)return[];const q=[];let X=!1,fe=!1,ve="";for(const Ae of O){switch(Ae){case V:if(!X&&!fe){q.push(ve),ve="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ve+=Ae}return ve&&q.push(ve),q}e.splitGlobAware=s;function d(O){if(!O)return"";let V="";const q=s(O,n);if(q.every(X=>X===y))V=".*";else{let X=!1;q.forEach((fe,ve)=>{if(fe===y){X||(V+=m(2),X=!0);return}let Ae=!1,Pe="",Fe=!1,z="";for(const J of fe){if(J!=="}"&&Ae){Pe+=J;continue}if(Fe&&(J!=="]"||!z)){let te;J==="-"?te=J:(J==="^"||J==="!")&&!z?te="^":J===n?te="":te=_.escapeRegExpCharacters(J),z+=te;continue}switch(J){case"{":Ae=!0;continue;case"[":Fe=!0;continue;case"}":V+=`(?:${s(Pe,",").map(he=>d(he)).join("|")})`,Ae=!1,Pe="";break;case"]":V+="["+z+"]",Fe=!1,z="";break;case"?":V+=C;continue;case"*":V+=m(1);continue;default:V+=_.escapeRegExpCharacters(J)}}ve<q.length-1&&(q[ve+1]!==y||ve+2<q.length)&&(V+=R),X=!1})}return V}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),i=function(){return!1},a=function(){return null};function r(O,V){if(!O)return a;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const X=`${q}_${!!V.trimForExclusions}`;let fe=t.get(X);if(fe)return c(fe,O);let ve;if(S.test(q)){const Ae=q.substr(4);fe=function(Pe,Fe){return typeof Pe=="string"&&Pe.endsWith(Ae)?q:null}}else(ve=w.exec(o(q,V)))?fe=p(ve[1],q):(V.trimForExclusions?v:b).test(q)?fe=E(q,V):(ve=u.exec(o(q,V)))?fe=f(ve[1].substr(1),q,!0):(ve=l.exec(o(q,V)))?fe=f(ve[1],q,!1):fe=h(q);return t.set(X,fe),c(fe,O)}function c(O,V){return typeof V=="string"?O:function(q,X){return P.isEqualOrParent(q,V.base)?O(A.relative(V.base,q),X):null}}function o(O,V){return V.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function p(O,V){const q=`/${O}`,X=`\\${O}`,fe=function(Ae,Pe){return typeof Ae!="string"?null:Pe?Pe===O?V:null:Ae===O||Ae.endsWith(q)||Ae.endsWith(X)?V:null},ve=[O];return fe.basenames=ve,fe.patterns=[V],fe.allBasenames=ve,fe}function E(O,V){const q=N(O.slice(1,-1).split(",").map(Pe=>r(Pe,V)).filter(Pe=>Pe!==a),O),X=q.length;if(!X)return a;if(X===1)return q[0];const fe=function(Pe,Fe){for(let z=0,J=q.length;z<J;z++)if(q[z](Pe,Fe))return O;return null},ve=q.find(Pe=>!!Pe.allBasenames);ve&&(fe.allBasenames=ve.allBasenames);const Ae=q.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return Ae.length&&(fe.allPaths=Ae),fe}function f(O,V,q){const X=A.sep===A.posix.sep,fe=X?O:O.replace(g,A.sep),ve=A.sep+fe,Ae=A.posix.sep+O,Pe=q?function(Fe,z){return typeof Fe=="string"&&(Fe===fe||Fe.endsWith(ve)||!X&&(Fe===O||Fe.endsWith(Ae)))?V:null}:function(Fe,z){return typeof Fe=="string"&&(Fe===fe||!X&&Fe===O)?V:null};return Pe.allPaths=[(q?"*/":"./")+O],Pe}function h(O){try{const V=new RegExp(`^${d(O)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?O:null}}catch(V){return a}}function T(O,V,q){return!O||typeof V!="string"?!1:L(O)(V,void 0,q)}e.match=T;function L(O,V={}){if(!O)return i;if(typeof O=="string"||x(O)){const q=r(O,V);if(q===a)return i;const X=function(fe,ve){return!!q(fe,ve)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return U(O,V)}e.parse=L;function W(O){if(!!O){let V;return q=>(V||(V=(O()||Promise.resolve([])).then(X=>X?j(X):{})),V.then(X=>!!X[q]))}}e.hasSiblingPromiseFn=W;function ee(O){if(!!O){let V;return q=>{if(!V){const X=O();V=X?j(X):{}}return!!V[q]}}}e.hasSiblingFn=ee;function j(O){const V={};for(const q of O)V[q]=!0;return V}function x(O){const V=O;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=x;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function F(O){return O.allPaths||[]}e.getPathTerms=F;function U(O,V){const q=N(Object.getOwnPropertyNames(O).map(Pe=>M(Pe,O[Pe],V)).filter(Pe=>Pe!==a)),X=q.length;if(!X)return a;if(!q.some(Pe=>!!Pe.requiresSiblings)){if(X===1)return q[0];const Pe=function(J,te){for(let le=0,he=q.length;le<he;le++){const Ce=q[le](J,te);if(Ce)return Ce}return null},Fe=q.find(J=>!!J.allBasenames);Fe&&(Pe.allBasenames=Fe.allBasenames);const z=q.reduce((J,te)=>te.allPaths?J.concat(te.allPaths):J,[]);return z.length&&(Pe.allPaths=z),Pe}const fe=function(Pe,Fe,z){let J;for(let te=0,le=q.length;te<le;te++){const he=q[te];he.requiresSiblings&&z&&(Fe||(Fe=A.basename(Pe)),J||(J=Fe.substr(0,Fe.length-A.extname(Pe).length)));const Ce=he(Pe,Fe,J,z);if(Ce)return Ce}return null},ve=q.find(Pe=>!!Pe.allBasenames);ve&&(fe.allBasenames=ve.allBasenames);const Ae=q.reduce((Pe,Fe)=>Fe.allPaths?Pe.concat(Fe.allPaths):Pe,[]);return Ae.length&&(fe.allPaths=Ae),fe}function M(O,V,q){if(V===!1)return a;const X=r(O,q);if(X===a)return a;if(typeof V=="boolean")return X;if(V){const fe=V.when;if(typeof fe=="string"){const ve=(Ae,Pe,Fe,z)=>{if(!z||!X(Ae,Pe))return null;const J=fe.replace("$(basename)",Fe),te=z(J);return(0,D.isThenable)(te)?te.then(le=>le?O:null):te?O:null};return ve.requiresSiblings=!0,ve}}return X}function N(O,V){const q=O.filter(Pe=>!!Pe.basenames);if(q.length<2)return O;const X=q.reduce((Pe,Fe)=>{const z=Fe.basenames;return z?Pe.concat(z):Pe},[]);let fe;if(V){fe=[];for(let Pe=0,Fe=X.length;Pe<Fe;Pe++)fe.push(V)}else fe=q.reduce((Pe,Fe)=>{const z=Fe.patterns;return z?Pe.concat(z):Pe},[]);const ve=function(Pe,Fe){if(typeof Pe!="string")return null;if(!Fe){let J;for(J=Pe.length;J>0;J--){const te=Pe.charCodeAt(J-1);if(te===47||te===92)break}Fe=Pe.substr(J)}const z=X.indexOf(Fe);return z!==-1?fe[z]:null};ve.basenames=X,ve.patterns=fe,ve.allBasenames=X;const Ae=O.filter(Pe=>!Pe.basenames);return Ae.push(ve),Ae}}),define(me[76],ge([0,1,2,8,10,11,9,25,30]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(r,c,o){if(typeof r=="string"&&(r=_.URI.file(r)),o){const E=o.getWorkspaceFolder(r);if(E){const f=o.getWorkspace().folders.length>1;let h;if((0,k.isEqual)(E.uri,r)?h="":h=(0,k.relativePath)(E.uri,r),f){const T=E.name?E.name:(0,k.basename)(E.uri);h=h?T+" \u2022 "+h:T}return h}}if(r.scheme!==I.Schemas.file&&r.scheme!==I.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(r.fsPath))return(0,P.normalize)(C(r.fsPath));let p=(0,P.normalize)(r.fsPath);return!D.isWindows&&(c==null?void 0:c.userHome)&&(p=m(p,c.userHome.fsPath)),p}e.getPathLabel=n;function R(r){if(!!r){typeof r=="string"&&(r=_.URI.file(r));const c=(0,k.basename)(r)||(r.scheme===I.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(c)?C(c):c}}e.getBaseLabel=R;function C(r){return(0,y.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=C;let g=Object.create(null);function m(r,c){if(D.isWindows||!r||!c)return r;let o=g.original===c?g.normalized:void 0;return o||(o=`${(0,A.rtrim)(c,P.posix.sep)}${P.posix.sep}`,g={original:c,normalized:o}),(D.isLinux?r.startsWith(o):(0,A.startsWithIgnoreCase)(r,o))&&(r=`~/${r.substr(o.length)}`),r}e.tildify=m;function s(r,c){return r.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=s;const d="\u2026",S="\\\\",w="~";function b(r,c=P.sep){const o=new Array(r.length);let p=!1;for(let E=0;E<r.length;E++){let f=r[E];if(f===""){o[E]=`.${c}`;continue}if(!f){o[E]=f;continue}p=!0;let h="";f.indexOf(S)===0?(h=f.substr(0,f.indexOf(S)+S.length),f=f.substr(f.indexOf(S)+S.length)):f.indexOf(c)===0?(h=f.substr(0,f.indexOf(c)+c.length),f=f.substr(f.indexOf(c)+c.length)):f.indexOf(w)===0&&(h=f.substr(0,f.indexOf(w)+w.length),f=f.substr(f.indexOf(w)+w.length));const T=f.split(c);for(let L=1;p&&L<=T.length;L++)for(let W=T.length-L;p&&W>=0;W--){p=!1;let ee=T.slice(W,W+L).join(c);for(let j=0;!p&&j<r.length;j++)if(j!==E&&r[j]&&r[j].indexOf(ee)>-1){const x=W+L===T.length,$=W>0&&r[j].indexOf(c)>-1?c+ee:ee,F=r[j].endsWith($);p=!x||F}if(!p){let j="";(T[0].endsWith(":")||h!=="")&&(W===1&&(W=0,L++,ee=T[0]+c+ee),W>0&&(j=T[0]+c),j=h+j),W>0&&(j=j+d+c),j=j+ee,W+L<T.length&&(j=j+c+d),o[E]=j}}p&&(o[E]=f)}return o}e.shorten=b;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function u(r,c=Object.create(null)){const o=[];let p=!1,E="";for(const f of r)if(f==="$"||p&&f==="{")E&&o.push({value:E,type:v.TEXT}),E="",p=!0;else if(f==="}"&&p){const h=c[E];if(typeof h=="string")h.length&&o.push({value:h,type:v.VARIABLE});else if(h){const T=o[o.length-1];(!T||T.type!==v.SEPARATOR)&&o.push({value:h.label,type:v.SEPARATOR})}E="",p=!1}else E+=f;return E&&!p&&o.push({value:E,type:v.TEXT}),o.filter((f,h)=>{if(f.type===v.SEPARATOR){const T=o[h-1],L=o[h+1];return[T,L].every(W=>W&&(W.type===v.VARIABLE||W.type===v.TEXT)&&W.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=u;function l(r,c){return D.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(r,c){return D.isMacintosh||c?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,o=>o==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(r){const c=r.indexOf("/")!==-1?P.posix:P.win32,o=c.basename(r),p=c.dirname(r);return o.length?{name:o,parentPath:p}:{name:p,parentPath:""}}e.splitName=a}),define(me[98],ge([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(R){return R.toJSON()}class A{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:P(_.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:P(_.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:_.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function I(R,C,g){if(!R||g>200)return null;if(typeof R=="object"){if(R instanceof _.URI)return C.transformOutgoing(R);for(let m in R)if(Object.hasOwnProperty.call(R,m)){const s=I(R[m],C,g+1);s!==null&&(R[m]=s)}}return null}function D(R,C){const g=I(R,C,0);return g===null?R:g}e.transformOutgoingURIs=D;function k(R,C,g,m){if(!R||m>200)return null;if(typeof R=="object"){if(R.$mid===1)return g?_.URI.revive(C.transformIncoming(R)):C.transformIncoming(R);for(let s in R)if(Object.hasOwnProperty.call(R,s)){const d=k(R[s],C,g,m+1);d!==null&&(R[s]=d)}}return null}function y(R,C){const g=k(R,C,!1,0);return g===null?R:g}e.transformIncomingURIs=y;function n(R,C){const g=k(R,C,!0,0);return g===null?R:g}e.transformAndReviveIncomingURIs=n}),define(me[28],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(y){return _.test(y)}e.isUUID=P;const A=new Uint8Array(16),I=[];for(let y=0;y<256;y++)I.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function k(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,n="";return n+=I[A[y++]],n+=I[A[y++]],n+=I[A[y++]],n+=I[A[y++]],n+="-",n+=I[A[y++]],n+=I[A[y++]],n+="-",n+=I[A[y++]],n+=I[A[y++]],n+="-",n+=I[A[y++]],n+=I[A[y++]],n+="-",n+=I[A[y++]],n+=I[A[y++]],n+=I[A[y++]],n+=I[A[y++]],n+=I[A[y++]],n+=I[A[y++]],n}e.generateUuid=k}),define(me[136],ge([0,1,99]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class P{constructor(I="utf8"){this.stringDecoder=new _.StringDecoder(I),this.remaining=null}write(I){const D=[],k=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(k.length<1)return D;let y=0,n,R=y;for(;R<k.length;)if(n=k.charCodeAt(R),n===13||n===10){if(D.push(k.substring(y,R)),R++,R<k.length){const C=n;n=k.charCodeAt(R),(C===13&&n===10||C===10&&n===13)&&R++}y=R}else R++;return this.remaining=y<k.length?k.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=P}),define(me[26],ge([0,1,37,48,8,19,9,30,28,75,25,2]),function(G,e,_,P,A,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function m($,F=g.UNLINK){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return F===g.UNLINK?d($):s($)}e.rimraf=m;async function s($){try{const F=(0,A.join)((0,P.tmpdir)(),(0,y.generateUuid)());try{await _.promises.rename($,F)}catch(U){return d($)}d(F).catch(U=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function d($){return _.promises.rmdir($,{recursive:!0,maxRetries:3})}function S($){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync($,{recursive:!0})}e.rimrafSync=S;async function w($,F){return u(await(F?b($):_.promises.readdir($)))}e.readdir=w;async function b($){try{return await _.promises.readdir($,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const F=[],U=await w($);for(const M of U){let N=!1,O=!1,V=!1;try{const q=await _.promises.lstat((0,A.join)($,M));N=q.isFile(),O=q.isDirectory(),V=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}F.push({name:M,isFile:()=>N,isDirectory:()=>O,isSymbolicLink:()=>V})}return F}function v($){return u(_.readdirSync($))}e.readdirSync=v;function u($){return $.map(F=>typeof F=="string"?D.isMacintosh?(0,n.normalizeNFC)(F):F:(F.name=D.isMacintosh?(0,n.normalizeNFC)(F.name):F.name,F))}async function l($){const F=await w($),U=[];for(const M of F)await i.existsDirectory((0,A.join)($,M))&&U.push(M);return U}e.readDirsInDir=l;function t($,F=1e3){return new Promise(U=>{let M=!1;const N=setInterval(()=>{M||(M=!0,_.access($,O=>{M=!1,O&&(clearInterval(N),U(void 0))}))},F)})}e.whenDeleted=t;var i;(function($){async function F(N){let O;try{if(O=await _.promises.lstat(N),!O.isSymbolicLink())return{stat:O}}catch(V){}try{return{stat:await _.promises.stat(N),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&V.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw V}}$.stat=F;async function U(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isFile()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsFile=U;async function M(N){try{const{stat:O,symbolicLink:V}=await $.stat(N);return O.isDirectory()&&(V==null?void 0:V.dangling)!==!0}catch(O){}return!1}$.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new I.ResourceQueue;function r($,F,U){return a.queueFor(C.URI.file($),R.extUriBiasedIgnorePathCase).queue(()=>{const M=E(U);return new Promise((N,O)=>o($,F,M,V=>V?O(V):N()))})}e.writeFile=r;let c=!0;function o($,F,U,M){if(!c)return _.writeFile($,F,{mode:U.mode,flag:U.flag},M);_.open($,U.flag,U.mode,(N,O)=>{if(N)return M(N);_.writeFile(O,F,V=>{if(V)return _.close(O,()=>M(V));_.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),c=!1),_.close(O,X=>M(X))))})})}function p($,F,U){const M=E(U);if(!c)return _.writeFileSync($,F,{mode:M.mode,flag:M.flag});const N=_.openSync($,M.flag,M.mode);try{_.writeFileSync(N,F);try{_.fdatasyncSync(N)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),c=!1}}finally{_.closeSync(N)}}e.writeFileSync=p;function E($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function f($,F){if($!==F){async function U(M){try{const N=await _.promises.lstat(M);if(N.isDirectory()||N.isSymbolicLink())return;const O=await _.promises.open(M,"a");try{await O.utimes(N.atime,new Date)}finally{await O.close()}}catch(N){}}try{await _.promises.rename($,F),await U(F)}catch(M){if($.toLowerCase()!==F.toLowerCase()&&M.code==="EXDEV"||$.endsWith("."))await h($,F,{preserveSymlinks:!1}),await m($,g.MOVE),await U(F);else throw M}}}e.move=f;async function h($,F,U){return L($,F,{root:{source:$,target:F},options:U,handledSourcePaths:new Set})}e.copy=h;const T=511;async function L($,F,U){if(!U.handledSourcePaths.has($)){U.handledSourcePaths.add($);const{stat:M,symbolicLink:N}=await i.stat($);if(N){if(U.options.preserveSymlinks)try{return await j($,F,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(N.dangling)return}return M.isDirectory()?W($,F,M.mode&T,U):ee($,F,M.mode&T)}}async function W($,F,U,M){await _.promises.mkdir(F,{recursive:!0,mode:U});const N=await w($);for(const O of N)await L((0,A.join)($,O),(0,A.join)(F,O),M)}async function ee($,F,U){await _.promises.copyFile($,F),await _.promises.chmod(F,U)}async function j($,F,U){let M=await _.promises.readlink($);(0,k.isEqualOrParent)(M,U.root.source,!D.isLinux)&&(M=(0,A.join)(U.root.target,M.substr(U.root.source.length+1))),await _.promises.symlink(M,F)}async function x($){try{return await _.promises.access($),!0}catch(F){return!1}}e.exists=x}),define(me[100],ge([0,1,37,284,10,8,26]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(C){const g=(0,I.dirname)(C);if(C===g)return C;const m=((0,I.basename)(C)||C).toLowerCase();try{const d=(0,D.readdirSync)(g).filter(S=>S.toLowerCase()===m);if(d.length===1){const S=k(g);if(S)return(0,I.join)(S,d[0])}else if(d.length>1){const S=d.indexOf(m);if(S>=0){const w=k(g);if(w)return(0,I.join)(w,d[S])}}}catch(s){}return null}e.realcaseSync=k;async function y(C){try{return await(0,P.promisify)(_.realpath)(C)}catch(g){const m=R(C);return await _.promises.access(m,_.constants.R_OK),m}}e.realpath=y;function n(C){try{return _.realpathSync(C)}catch(g){const m=R(C);return _.accessSync(m,_.constants.R_OK),m}}e.realpathSync=n;function R(C){return(0,A.rtrim)((0,I.normalize)(C),I.sep)}});var wt=this&&this.__await||function(G){return this instanceof wt?(this.v=G,this):new wt(G)},Tn=this&&this.__asyncGenerator||function(G,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var P=_.apply(G,e||[]),A,I=[];return A={},D("next"),D("throw"),D("return"),A[Symbol.asyncIterator]=function(){return this},A;function D(g){P[g]&&(A[g]=function(m){return new Promise(function(s,d){I.push([g,m,s,d])>1||k(g,m)})})}function k(g,m){try{y(P[g](m))}catch(s){C(I[0][3],s)}}function y(g){g.value instanceof wt?Promise.resolve(g.value.v).then(n,R):C(I[0][2],g)}function n(g){k("next",g)}function R(g){k("throw",g)}function C(g,m){g(m),I.shift(),I.length&&k(I[0][0],I[0][1])}},sn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},P("next"),P("throw"),P("return"),_[Symbol.asyncIterator]=function(){return this},_);function P(I){_[I]=G[I]&&function(D){return new Promise(function(k,y){D=G[I](D),A(k,y,D.done,D.value)})}}function A(I,D,k,y){Promise.resolve(y).then(function(n){I({value:n,done:k})},D)}};define(me[101],ge([0,1,26,48,8]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var y;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(y||(y={}));let n;switch(process.arch){case"ia32":case"x32":n=1;break;case"arm":case"arm64":n=2;break;default:n=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class C{constructor(l,t,i){this.exePath=l,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:u=!1}={}){return u?n===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:l=!1}={}){const t=g({useAlternateBitness:u});if(!t)return null;const i=A.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(i))return null;let a=-1,r=null;for(const p of await _.readdir(i)){let E=-1;if(l){const h=p.indexOf("-");if(h<0)continue;const T=p.substring(0,h);if(!I.test(T)||p.substring(h+1)!=="preview")continue;E=parseInt(T,10)}else{if(!I.test(p))continue;E=parseInt(p,10)}if(!(E<=a)){const f=A.join(i,p,"pwsh.exe");!await _.SymlinkSupport.existsFile(f)||(r=f,a=E)}}if(!r)return null;const c=t.includes("x86")?" (x86)":"",o=l?" Preview":"";return new C(r,`PowerShell${o}${c}`,!0)}async function s({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const l=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=u?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const a of await _.readdir(l))if(t.test(a)){const r=A.join(l,a,"pwsh.exe");return new C(r,i)}return null}function d(){const u=A.join(P.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function S(){const u=A.join(process.env.windir,n===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}function w(){return Tn(this,arguments,function*(){let l=yield wt(m());l&&(yield yield wt(l)),l=yield wt(m({useAlternateBitness:!0})),l&&(yield yield wt(l)),l=yield wt(s()),l&&(yield yield wt(l)),l=d(),l&&(yield yield wt(l)),l=yield wt(m({findPreview:!0})),l&&(yield yield wt(l)),l=yield wt(s({findPreview:!0})),l&&(yield yield wt(l)),l=yield wt(m({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield wt(l)),l=S(),l&&(yield yield wt(l))})}function b(){return Tn(this,arguments,function*(){var l,t;try{for(var i=sn(w()),a;a=yield wt(i.next()),!a.done;){const r=a.value;(yield wt(r.exists()))&&(yield yield wt(r))}}catch(r){l={error:r}}finally{try{a&&!a.done&&(t=i.return)&&(yield wt(t.call(i)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=b;async function v(){var u,l;try{for(var t=sn(b()),i;i=await t.next(),!i.done;)return i.value}catch(a){u={error:a}}finally{try{i&&!i.done&&(l=t.return)&&await l.call(t)}finally{if(u)throw u.error}}return null}e.getFirstAvailablePowerShellInstallation=v}),define(me[102],ge([0,1,3,6,19,21,18,22,14,15,57,10]),function(G,e,_,P,A,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function m(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(s=e.ResponseType||(e.ResponseType={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(S||(S={}));class w{constructor(N){this.buffer=N,this.pos=0}read(N){const O=this.buffer.slice(this.pos,this.pos+N);return this.pos+=O.byteLength,O}}class b{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var v;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(v||(v={}));function u(M){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function l(M){return M.read(4).readUInt32BE(0)}function t(M){const N=k.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const i={Undefined:t(v.Undefined),String:t(v.String),Buffer:t(v.Buffer),VSBuffer:t(v.VSBuffer),Array:t(v.Array),Object:t(v.Object)},a=typeof Buffer!="undefined";function r(M,N){if(typeof N=="undefined")M.write(i.Undefined);else if(typeof N=="string"){const O=k.VSBuffer.fromString(N);M.write(i.String),M.write(u(O.byteLength)),M.write(O)}else if(a&&Buffer.isBuffer(N)){const O=k.VSBuffer.wrap(N);M.write(i.Buffer),M.write(u(O.byteLength)),M.write(O)}else if(N instanceof k.VSBuffer)M.write(i.VSBuffer),M.write(u(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(i.Array),M.write(u(N.length));for(const O of N)r(M,O)}else{const O=k.VSBuffer.fromString(JSON.stringify(N));M.write(i.Object),M.write(u(O.byteLength)),M.write(O)}}function c(M){switch(M.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return M.read(l(M)).toString();case v.Buffer:return M.read(l(M)).buffer;case v.VSBuffer:return M.read(l(M));case v.Array:{const O=l(M),V=[];for(let q=0;q<O;q++)V.push(c(M));return V}case v.Object:return JSON.parse(M.read(l(M)).toString())}}class o{constructor(N,O,V=null,q=1e3){this.protocol=N,this.ctx=O,this.logger=V,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(N,O){this.channels.set(N,O),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const O=this.send([N.type]);this.logger&&this.logger.logOutgoing(O,0,1,d(N.type));return}case 201:case 202:case 204:case 203:{const O=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(O,N.id,1,d(N.type),N.data);return}}}send(N,O=void 0){const V=new b;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onRawMessage(N){const O=new w(N),V=c(O),q=c(O),X=V[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(X)}: ${V[2]}.${V[3]}`,q),this.onPromise({type:X,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(X)}: ${V[2]}.${V[3]}`,q),this.onEventListen({type:X,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(X)}`),this.disposeActiveRequest({type:X,id:V[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],1,`${m(X)}`),this.disposeActiveRequest({type:X,id:V[1]})}}onPromise(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=new I.CancellationTokenSource;let q;try{q=O.call(this.ctx,N.name,N.arg,V.token)}catch(ve){q=Promise.reject(ve)}const X=N.id;q.then(ve=>{this.sendResponse({id:X,data:ve,type:201}),this.activeRequests.delete(N.id)},ve=>{ve instanceof Error?this.sendResponse({id:X,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.sendResponse({id:X,data:ve,type:203}),this.activeRequests.delete(N.id)});const fe=(0,P.toDisposable)(()=>V.cancel());this.activeRequests.set(N.id,fe)}onEventListen(N){const O=this.channels.get(N.channelName);if(!O){this.collectPendingRequest(N);return}const V=N.id,X=O.listen(this.ctx,N.name,N.arg)(fe=>this.sendResponse({id:V,data:fe,type:204}));this.activeRequests.set(N.id,X)}disposeActiveRequest(N){const O=this.activeRequests.get(N.id);O&&(O.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let O=this.pendingRequests.get(N.channelName);O||(O=[],this.pendingRequests.set(N.channelName,O));const V=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:N,timeoutTimer:V})}flushPendingRequests(N){const O=this.pendingRequests.get(N);if(O){for(const V of O)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=o;var p;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,O=null){this.protocol=N,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=O}getChannel(N){const O=this;return{call(V,q,X){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(N,V,q,X)},listen(V,q){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(N,V,q)}}}requestPromise(N,O,V,q=I.CancellationToken.None){const X=this.lastRequestId++,ve={id:X,type:100,channelName:N,name:O,arg:V};if(q.isCancellationRequested)return Promise.reject(D.canceled());let Ae;return new Promise((Fe,z)=>{if(q.isCancellationRequested)return z(D.canceled());const J=()=>{const Ce=Me=>{switch(Me.type){case 201:this.handlers.delete(X),Fe(Me.data);break;case 202:this.handlers.delete(X);const we=new Error(Me.data.message);we.stack=Me.data.stack,we.name=Me.data.name,z(we);break;case 203:this.handlers.delete(X),z(Me.data);break}};this.handlers.set(X,Ce),this.sendRequest(ve)};let te=null;this.state===S.Idle?J():(te=(0,A.createCancelablePromise)(Ce=>this.whenInitialized()),te.then(()=>{te=null,J()}));const le=()=>{te?(te.cancel(),te=null):this.sendRequest({id:X,type:101}),z(D.canceled())},he=q.onCancellationRequested(le);Ae=(0,P.combinedDisposable)((0,P.toDisposable)(le),he),this.activeRequests.add(Ae)}).finally(()=>{this.activeRequests.delete(Ae)})}requestEvent(N,O,V){const q=this.lastRequestId++,fe={id:q,type:102,channelName:N,name:O,arg:V};let ve=null;const Ae=new _.Emitter({onFirstListenerAdd:()=>{ve=(0,A.createCancelablePromise)(Fe=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(Ae),this.sendRequest(fe)})},onLastListenerRemove:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(Ae),this.sendRequest({id:q,type:103}))}}),Pe=Fe=>Ae.fire(Fe.data);return this.handlers.set(q,Pe),Ae.event}sendRequest(N){switch(N.type){case 100:case 102:{const O=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(O,N.id,0,`${m(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const O=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(O,N.id,0,m(N.type));return}}}send(N,O=void 0){const V=new b;return r(V,N),r(V,O),this.sendBuffer(V.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(O){return 0}}onBuffer(N){const O=new w(N),V=c(O),q=c(O),X=V[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,d(X)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,V[1],0,d(X),q),this.onResponse({type:V[0],id:V[1],data:q})}}onResponse(N){if(N.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(N.id);O&&O(N)}whenInitialized(){return this.state===S.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelClient=E;class f{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:O,onDidClientDisconnect:V})=>{_.Event.once(O.onMessage)(X=>{const fe=new w(X),ve=c(fe),Ae=new o(O,ve),Pe=new E(O);this.channels.forEach((z,J)=>Ae.registerChannel(J,z));const Fe={channelServer:Ae,channelClient:Pe,ctx:ve};this._connections.add(Fe),this._onDidAddConnection.fire(Fe),V(()=>{Ae.dispose(),Pe.dispose(),this._connections.delete(Fe),this._onDidRemoveConnection.fire(Fe)})})})}get connections(){const N=[];return this._connections.forEach(O=>N.push(O)),N}getChannel(N,O){const V=this;return{call(q,X,fe){let ve;if((0,n.isFunction)(O)){let Pe=(0,y.getRandomElement)(V.connections.filter(O));ve=Pe?Promise.resolve(Pe):_.Event.toPromise(_.Event.filter(V.onDidAddConnection,O))}else ve=O.routeCall(V,q,X);const Ae=ve.then(Pe=>Pe.channelClient.getChannel(N));return T(Ae).call(q,X,fe)},listen(q,X){if((0,n.isFunction)(O))return V.getMulticastEvent(N,O,q,X);const fe=O.routeEvent(V,q,X).then(ve=>ve.channelClient.getChannel(N));return T(fe).listen(q,X)}}}getMulticastEvent(N,O,V,q){const X=this;let fe=new P.DisposableStore;const ve=new _.Emitter({onFirstListenerAdd:()=>{fe=new P.DisposableStore;const Ae=new _.EventMultiplexer,Pe=new Map,Fe=J=>{const le=J.channelClient.getChannel(N).listen(V,q),he=Ae.add(le);Pe.set(J,he)},z=J=>{const te=Pe.get(J);!te||(te.dispose(),Pe.delete(J))};X.connections.filter(O).forEach(Fe),_.Event.filter(X.onDidAddConnection,O)(Fe,void 0,fe),X.onDidRemoveConnection(z,void 0,fe),Ae.event(ve.fire,ve,fe),fe.add(Ae)},onLastListenerRemove:()=>{fe.dispose()}});return ve.event}registerChannel(N,O){this.channels.set(N,O),this._connections.forEach(V=>{V.channelServer.registerChannel(N,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class h{constructor(N,O,V=null){const q=new b;r(q,O),N.send(q.buffer),this.channelClient=new E(N,V),this.channelServer=new o(N,O,V)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,O){this.channelServer.registerChannel(N,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=h;function T(M){return{call(N,O,V){return M.then(q=>q.call(N,O,V))},listen(N,O){const V=new _.Relay;return M.then(q=>V.input=q.listen(N,O)),V.event}}}e.getDelayedChannel=T;function L(M){let N=!1;return{call(O,V,q){return N?M.call(O,V,q):(0,A.timeout)(0).then(()=>N=!0).then(()=>M.call(O,V,q))},listen(O,V){if(N)return M.listen(O,V);const q=new _.Relay;return(0,A.timeout)(0).then(()=>N=!0).then(()=>q.input=M.listen(O,V)),q.event}}}e.getNextTickChannel=L;class W{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const O of N.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await _.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=W;var ee;(function(M){function N(q,X){const fe=q,ve=X&&X.disableMarshalling,Ae=new Map;for(const Pe in fe)V(Pe)&&Ae.set(Pe,_.Event.buffer(fe[Pe],!0));return new class{listen(Pe,Fe){const z=Ae.get(Fe);if(z)return z;throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,z){const J=fe[Fe];if(typeof J=="function"){if(!ve&&Array.isArray(z))for(let te=0;te<z.length;te++)z[te]=(0,R.revive)(z[te]);return J.apply(fe,z)}throw new Error(`Method not found: ${Fe}`)}}}M.fromService=N;function O(q,X){const fe=X&&X.disableMarshalling;return new Proxy({},{get(ve,Ae){var Pe;if(typeof Ae=="string")return((Pe=X==null?void 0:X.properties)===null||Pe===void 0?void 0:Pe.has(Ae))?X.properties.get(Ae):V(Ae)?q.listen(Ae):async function(...Fe){let z;X&&!(0,n.isUndefinedOrNull)(X.context)?z=[X.context,...Fe]:z=Fe;const J=await q.call(Ae,z);return fe?J:(0,R.revive)(J)};throw new Error(`Property not found: ${String(Ae)}`)}})}M.toService=O;function V(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function $(M){return Array.isArray(M)?M.map(x):x(M)}function F(M,N,O,V,q,X,fe){fe=$(fe);const ve=j[q],Ae=ve[V%ve.length];let Pe=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${Ae}`];/\($/.test(X)?(Pe=Pe.concat(fe),Pe.push(")")):Pe.push(fe),console.log.apply(console,Pe)}e.logWithColors=F;class U{constructor(N,O){this._outgoingPrefix=N,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,O,V,q,X){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,O,V,q,X)}logIncoming(N,O,V,q,X){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,O,V,q,X)}}e.IPCLogger=U}),define(me[103],ge([0,1,3,102,6,22,9,36]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function n(){return y||(y=I.VSBuffer.alloc(0)),y}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,r){if(a===0)return n();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const E=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=a),E}if(this._chunks[0].byteLength>a){const E=this._chunks[0].slice(0,a);return r&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),E}let c=I.VSBuffer.alloc(a),o=0,p=0;for(;a>0;){const E=this._chunks[p];if(E.byteLength>a){const f=E.slice(0,a);c.set(f,o),o+=a,r&&(this._chunks[p]=E.slice(a),this._totalLength-=a),a-=a}else c.set(E,o),o+=E.byteLength,r?(this._chunks.shift(),this._totalLength-=E.byteLength):p++,a-=E.byteLength}return c}}e.ChunkStream=R;var C;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(a,r,c,o){this.type=a,this.id=r,this.ack=c,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends A.Disposable{constructor(a){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const c=this._state.messageType,o=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(c,o,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(!this._isDisposed){a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.VSBuffer.alloc(13);r.writeUInt8(a.type,0),r.writeUInt32BE(a.id,1),r.writeUInt32BE(a.ack,5),r.writeUInt32BE(a.data.byteLength,9),this._writeSoon(r,a.data)}}_bufferAdd(a,r){const c=this._totalLength===0;return this._data.push(a,r),this._totalLength+=a.byteLength+r.byteLength,c}_bufferTake(){const a=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,r){this._bufferAdd(a,r)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends A.Disposable{constructor(a){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new s(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new m(1,0,0,a))}}e.Protocol=S;class w extends P.IPCClient{constructor(a,r,c=null){super(a,r,c);this.protocol=a}static fromSocket(a,r){return new w(new S(a),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=w;class b{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=b;class v{constructor(a){this.data=a,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],r=0,c=this._first;for(;c;)a[r++]=c.data,c=c.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const r=new v(a);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class l{constructor(){this.lastRuns=[];const a=Date.now();for(let r=0;r<l._HISTORY_LENGTH;r++)this.lastRuns[r]=a-1e3*r;setInterval(()=>{for(let r=l._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const a=Date.now(),r=(1+l._HISTORY_LENGTH)*1e3;let c=0;for(let o=0;o<l._HISTORY_LENGTH;o++)a-this.lastRuns[o]<=r&&c++;return 1-c/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class t{constructor(a,r=null){this._loadEstimator=l.getInstance(),this._onControlMessage=new b,this.onControlMessage=this._onControlMessage.event,this._onMessage=new b,this.onMessage=this._onMessage.event,this._onDidDispose=new b,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new b,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new b,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,A.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new m(5,0,0,n());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const r=new m(4,0,0,n());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,r){this._isReconnecting=!0,this._socketDisposables=(0,A.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new s(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let r=0,c=a.length;r<c;r++)this._socketWriter.write(a[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new m(6,0,0,n())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const r=this._outgoingUnackMsg.toArray();for(let c=0,o=r.length;c<o;c++)this._socketWriter.write(r[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new m(1,r,this._incomingAckId,a);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(a){const r=new m(2,0,0,a);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const a=this._outgoingUnackMsg.peek(),r=Date.now()-a.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const a=new m(3,0,this._incomingAckId,n());this._socketWriter.write(a)}}}e.PersistentProtocol=t}),define(me[104],ge([0,1,93]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class P{constructor(k){let y=(0,_.toUint8)(k);this._defaultValue=y,this._asciiMap=P._createAsciiMap(y),this._map=new Map}static _createAsciiMap(k){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=k;return y}set(k,y){let n=(0,_.toUint8)(y);k>=0&&k<256?this._asciiMap[k]=n:this._map.set(k,n)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=P;var A;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(A||(A={}));class I{constructor(){this._actual=new P(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=I}),define(me[137],ge([0,1,104]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var P;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(P=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends _.CharacterClassifier{constructor(k){super(0);for(let y=0,n=k.length;y<n;y++)this.set(k.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function I(D){let k={};return y=>(k.hasOwnProperty(y)||(k[y]=D(y)),k[y])}e.getMapForWordSeparators=I(D=>new A(D))}),define(me[49],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(A,I){this.lineNumber=A,this.column=I}with(A=this.lineNumber,I=this.column){return A===this.lineNumber&&I===this.column?this:new _(A,I)}delta(A=0,I=0){return this.with(this.lineNumber+A,this.column+I)}equals(A){return _.equals(this,A)}static equals(A,I){return!A&&!I?!0:!!A&&!!I&&A.lineNumber===I.lineNumber&&A.column===I.column}isBefore(A){return _.isBefore(this,A)}static isBefore(A,I){return A.lineNumber<I.lineNumber?!0:I.lineNumber<A.lineNumber?!1:A.column<I.column}isBeforeOrEqual(A){return _.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,I){return A.lineNumber<I.lineNumber?!0:I.lineNumber<A.lineNumber?!1:A.column<=I.column}static compare(A,I){let D=A.lineNumber|0,k=I.lineNumber|0;if(D===k){let y=A.column|0,n=I.column|0;return y-n}return D-k}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new _(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=_}),define(me[44],ge([0,1,49]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(I,D,k,y){I>k||I===k&&D>y?(this.startLineNumber=k,this.startColumn=y,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=k,this.endColumn=y)}isEmpty(){return P.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return P.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}containsRange(I){return P.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return P.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return P.plusRange(this,I)}static plusRange(I,D){let k,y,n,R;return D.startLineNumber<I.startLineNumber?(k=D.startLineNumber,y=D.startColumn):D.startLineNumber===I.startLineNumber?(k=D.startLineNumber,y=Math.min(D.startColumn,I.startColumn)):(k=I.startLineNumber,y=I.startColumn),D.endLineNumber>I.endLineNumber?(n=D.endLineNumber,R=D.endColumn):D.endLineNumber===I.endLineNumber?(n=D.endLineNumber,R=Math.max(D.endColumn,I.endColumn)):(n=I.endLineNumber,R=I.endColumn),new P(k,y,n,R)}intersectRanges(I){return P.intersectRanges(this,I)}static intersectRanges(I,D){let k=I.startLineNumber,y=I.startColumn,n=I.endLineNumber,R=I.endColumn,C=D.startLineNumber,g=D.startColumn,m=D.endLineNumber,s=D.endColumn;return k<C?(k=C,y=g):k===C&&(y=Math.max(y,g)),n>m?(n=m,R=s):n===m&&(R=Math.min(R,s)),k>n||k===n&&y>R?null:new P(k,y,n,R)}equalsRange(I){return P.equalsRange(this,I)}static equalsRange(I,D){return!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(I){return new _.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(I){return new _.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new P(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new P(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(I){return new P(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}static fromPositions(I,D=I){return new P(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const n=I.startLineNumber|0,R=D.startLineNumber|0;if(n===R){const C=I.startColumn|0,g=D.startColumn|0;if(C===g){const m=I.endLineNumber|0,s=D.endLineNumber|0;if(m===s){const d=I.endColumn|0,S=D.endColumn|0;return d-S}return m-s}return C-g}return n-R}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}}e.Range=P}),define(me[138],ge([0,1,49,44]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class I extends P.Range{constructor(k,y,n,R){super(k,y,n,R);this.selectionStartLineNumber=k,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return I.selectionsEqual(this,k)}static selectionsEqual(k,y){return k.selectionStartLineNumber===y.selectionStartLineNumber&&k.selectionStartColumn===y.selectionStartColumn&&k.positionLineNumber===y.positionLineNumber&&k.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,y){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,k,y):new I(k,y,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,y){return this.getDirection()===0?new I(k,y,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,k,y)}static fromPositions(k,y=k){return new I(k.lineNumber,k.column,y.lineNumber,y.column)}static liftSelection(k){return new I(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,y){if(k&&!y||!k&&y)return!1;if(!k&&!y)return!0;if(k.length!==y.length)return!1;for(let n=0,R=k.length;n<R;n++)if(!this.selectionsEqual(k[n],y[n]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,y,n,R,C){return C===0?new I(k,y,n,R):new I(n,R,k,y)}}e.Selection=I}),define(me[105],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var P;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(P=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(s){this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace)}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class y{constructor(s,d){this.range=s,this.matches=d}}e.FindMatch=y;var n;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var R;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(R=e.ModelConstants||(e.ModelConstants={}));class C{constructor(s,d,S,w,b,v){this.identifier=s,this.range=d,this.text=S,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=b,this._isTracked=v}}e.ValidAnnotatedEditOperation=C;class g{constructor(s,d,S){this.reverseEdits=s,this.changes=d,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=g}),define(me[139],ge([0,1,10,137,49,44,105]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class y{constructor(v,u,l,t){this.searchString=v,this.isRegex=u,this.matchCase=l,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=n(this.searchString):v=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let l=!this.isRegex&&!v;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new R(u,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}e.SearchParams=y;function n(b){if(!b||b.length===0)return!1;for(let v=0,u=b.length;v<u;v++)if(b.charCodeAt(v)===92){if(v++,v>=u)break;const t=b.charCodeAt(v);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class R{constructor(v,u,l){this.regex=v,this.wordSeparators=u,this.simpleSearch=l}}e.SearchData=R;function C(b,v,u){if(!u)return new D.FindMatch(b,null);let l=[];for(let t=0,i=v.length;t<i;t++)l[t]=v[t];return new D.FindMatch(b,l)}e.createFindMatch=C;class g{constructor(v){let u=[],l=0;for(let t=0,i=v.length;t<i;t++)v.charCodeAt(t)===10&&(u[l++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(v){const u=this._lineFeedsOffsets;let l=0,t=u.length-1;if(t===-1||v<=u[0])return 0;for(;l<t;){const i=l+((t-l)/2>>0);u[i]>=v?t=i-1:u[i+1]>=v?(l=i,t=i):l=i+1}return l+1}}class m{static findMatches(v,u,l,t,i){const a=u.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(v,l,new w(a.wordSeparators,a.regex),t,i):this._doFindMatchesLineByLine(v,l,a,t,i):[]}static _getMultilineMatchRange(v,u,l,t,i,a){let r,c=0;t?(c=t.findLineFeedCountBeforeOffset(i),r=u+i+c):r=u+i;let o;if(t){let h=t.findLineFeedCountBeforeOffset(i+a.length)-c;o=r+a.length+h}else o=r+a.length;const p=v.getPositionAt(r),E=v.getPositionAt(o);return new I.Range(p.lineNumber,p.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(v,u,l,t,i){const a=v.getOffsetAt(u.getStartPosition()),r=v.getValueInRange(u,1),c=v.getEOL()===`\r
`?new g(r):null,o=[];let p=0,E;for(l.reset(0);E=l.next(r);)if(o[p++]=C(this._getMultilineMatchRange(v,a,r,c,E.index,E[0]),E,t),p>=i)return o;return o}static _doFindMatchesLineByLine(v,u,l,t,i){const a=[];let r=0;if(u.startLineNumber===u.endLineNumber){const o=v.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(l,o,u.startLineNumber,u.startColumn-1,r,a,t,i),a}const c=v.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(l,c,u.startLineNumber,u.startColumn-1,r,a,t,i);for(let o=u.startLineNumber+1;o<u.endLineNumber&&r<i;o++)r=this._findMatchesInLine(l,v.getLineContent(o),o,0,r,a,t,i);if(r<i){const o=v.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(l,o,u.endLineNumber,0,r,a,t,i)}return a}static _findMatchesInLine(v,u,l,t,i,a,r,c){const o=v.wordSeparators;if(!r&&v.simpleSearch){const f=v.simpleSearch,h=f.length,T=u.length;let L=-h;for(;(L=u.indexOf(f,L+h))!==-1;)if((!o||S(o,u,T,L,h))&&(a[i++]=new D.FindMatch(new I.Range(l,L+1+t,l,L+1+h+t),null),i>=c))return i;return i}const p=new w(v.wordSeparators,v.regex);let E;p.reset(0);do if(E=p.next(u),E&&(a[i++]=C(new I.Range(l,E.index+1+t,l,E.index+1+E[0].length+t),E,r),i>=c))return i;while(E);return i}static findNextMatch(v,u,l,t){const i=u.parseSearchRequest();if(!i)return null;const a=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(v,l,a,t):this._doFindNextMatchLineByLine(v,l,a,t)}static _doFindNextMatchMultiline(v,u,l,t){const i=new A.Position(u.lineNumber,1),a=v.getOffsetAt(i),r=v.getLineCount(),c=v.getValueInRange(new I.Range(i.lineNumber,i.column,r,v.getLineMaxColumn(r)),1),o=v.getEOL()===`\r
`?new g(c):null;l.reset(u.column-1);let p=l.next(c);return p?C(this._getMultilineMatchRange(v,a,c,o,p.index,p[0]),p,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(v,new A.Position(1,1),l,t):null}static _doFindNextMatchLineByLine(v,u,l,t){const i=v.getLineCount(),a=u.lineNumber,r=v.getLineContent(a),c=this._findFirstMatchInLine(l,r,a,u.column,t);if(c)return c;for(let o=1;o<=i;o++){const p=(a+o-1)%i,E=v.getLineContent(p+1),f=this._findFirstMatchInLine(l,E,p+1,1,t);if(f)return f}return null}static _findFirstMatchInLine(v,u,l,t,i){v.reset(t-1);const a=v.next(u);return a?C(new I.Range(l,a.index+1,l,a.index+1+a[0].length),a,i):null}static findPreviousMatch(v,u,l,t){const i=u.parseSearchRequest();if(!i)return null;const a=new w(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(v,l,a,t):this._doFindPreviousMatchLineByLine(v,l,a,t)}static _doFindPreviousMatchMultiline(v,u,l,t){const i=this._doFindMatchesMultiline(v,new I.Range(1,1,u.lineNumber,u.column),l,t,10*k);if(i.length>0)return i[i.length-1];const a=v.getLineCount();return u.lineNumber!==a||u.column!==v.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(v,new A.Position(a,v.getLineMaxColumn(a)),l,t):null}static _doFindPreviousMatchLineByLine(v,u,l,t){const i=v.getLineCount(),a=u.lineNumber,r=v.getLineContent(a).substring(0,u.column-1),c=this._findLastMatchInLine(l,r,a,t);if(c)return c;for(let o=1;o<=i;o++){const p=(i+a-o-1)%i,E=v.getLineContent(p+1),f=this._findLastMatchInLine(l,E,p+1,t);if(f)return f}return null}static _findLastMatchInLine(v,u,l,t){let i=null,a;for(v.reset(0);a=v.next(u);)i=C(new I.Range(l,a.index+1,l,a.index+1+a[0].length),a,t);return i}}e.TextModelSearch=m;function s(b,v,u,l,t){if(l===0)return!0;const i=v.charCodeAt(l-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const a=v.charCodeAt(l);if(b.get(a)!==0)return!0}return!1}function d(b,v,u,l,t){if(l+t===u)return!0;const i=v.charCodeAt(l+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const a=v.charCodeAt(l+t-1);if(b.get(a)!==0)return!0}return!1}function S(b,v,u,l,t){return s(b,v,u,l,t)&&d(b,v,u,l,t)}e.isValidMatch=S;class w{constructor(v,u){this._wordSeparators=v,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const u=v.length;let l;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(l=this._searchRegex.exec(v),!l))return null;const t=l.index,i=l[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){_.getNextCodePoint(v,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||S(this._wordSeparators,v,u,t,i))return l}while(l);return null}}e.Searcher=w}),define(me[106],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(k=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)k.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=_();function P(k){let y=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)y=k;else{let n="g";k.ignoreCase&&(n+="i"),k.multiline&&(n+="m"),k.unicode&&(n+="u"),y=new RegExp(k.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=P;const A={maxLen:1e3,windowSize:15,timeBudget:150};function I(k,y,n,R,C=A){if(n.length>C.maxLen){let S=k-C.maxLen/2;return S<0?S=0:R+=S,n=n.substring(S,k+C.maxLen/2),I(k,y,n,R,C)}const g=Date.now(),m=k-1-R;let s=-1,d=null;for(let S=1;!(Date.now()-g>=C.timeBudget);S++){const w=m-C.windowSize*S;y.lastIndex=Math.max(0,w);const b=D(y,n,m,s);if(!b&&d||(d=b,w<=0))break;s=w}if(d){let S={word:d[0],startColumn:R+1+d.index,endColumn:R+1+d.index+d[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=I;function D(k,y,n,R){let C;for(;C=k.exec(y);){const g=C.index||0;if(g<=n&&k.lastIndex>=n)return C;if(R>0&&g>R)return null}return null}}),define(me[140],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class P{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let y=0,n=k.notIn.length;y<n;y++)switch(k.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=P;class A{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of k)I(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),I(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),I(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),I(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&I(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=A;function I(D,k,y){D.has(k)?D.get(k).push(y):D.set(k,[y])}}),define(me[77],ge([0,1,33,8]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(I,D,k,y){if(Array.isArray(I)){let n=0;for(const R of I){const C=A(R,D,k,y);if(C===10)return C;C>n&&(n=C)}return n}else{if(typeof I=="string")return y?I==="*"?5:I===k?10:0:0;if(I){const{language:n,pattern:R,scheme:C,hasAccessToAllModels:g}=I;if(!y&&!g)return 0;let m=0;if(C)if(C===D.scheme)m=10;else if(C==="*")m=5;else return 0;if(n)if(n===k)m=10;else if(n==="*")m=Math.max(m,5);else return 0;if(R){let s;if(typeof R=="string"?s=R:s=Object.assign(Object.assign({},R),{base:(0,P.normalize)(R.base)}),s===D.fsPath||(0,_.match)(s,D.fsPath))m=10;else return 0}return m}else return 0}}e.score=A}),define(me[141],ge([0,1,104]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var P;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(P=e.State||(e.State={}));class A{constructor(s,d,S){const w=new Uint8Array(s*d);for(let b=0,v=s*d;b<v;b++)w[b]=S;this._data=w,this.rows=s,this.cols=d}get(s,d){return this._data[s*this.cols+d]}set(s,d,S){this._data[s*this.cols+d]=S}}e.Uint8Matrix=A;class I{constructor(s){let d=0,S=0;for(let b=0,v=s.length;b<v;b++){let[u,l,t]=s[b];l>d&&(d=l),u>S&&(S=u),t>S&&(S=t)}d++,S++;let w=new A(S,d,0);for(let b=0,v=s.length;b<v;b++){let[u,l,t]=s[b];w.set(u,l,t)}this._states=w,this._maxCharCode=d}nextState(s,d){return d<0||d>=this._maxCharCode?0:this._states.get(s,d)}}e.StateMachine=I;let D=null;function k(){return D===null&&(D=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function R(){if(n===null){n=new _.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<m.length;d++)n.set(m.charCodeAt(d),1);const s=".,;";for(let d=0;d<s.length;d++)n.set(s.charCodeAt(d),2)}return n}class C{static _createLink(s,d,S,w,b){let v=b-1;do{const u=d.charCodeAt(v);if(s.get(u)!==2)break;v--}while(v>w);if(w>0){const u=d.charCodeAt(w-1),l=d.charCodeAt(v);(u===40&&l===41||u===91&&l===93||u===123&&l===125)&&v--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:v+2},url:d.substring(w,v+1)}}static computeLinks(s,d=k()){const S=R();let w=[];for(let b=1,v=s.getLineCount();b<=v;b++){const u=s.getLineContent(b),l=u.length;let t=0,i=0,a=0,r=1,c=!1,o=!1,p=!1,E=!1;for(;t<l;){let f=!1;const h=u.charCodeAt(t);if(r===13){let T;switch(h){case 40:c=!0,T=0;break;case 41:T=c?0:1;break;case 91:p=!0,o=!0,T=0;break;case 93:p=!1,T=o?0:1;break;case 123:E=!0,T=0;break;case 125:T=E?0:1;break;case 39:T=a===34||a===96?0:1;break;case 34:T=a===39||a===96?0:1;break;case 96:T=a===39||a===34?0:1;break;case 42:T=a===42?1:0;break;case 124:T=a===124?1:0;break;case 32:T=p?0:1;break;default:T=S.get(h)}T===1&&(w.push(C._createLink(S,u,b,i,t)),f=!0)}else if(r===12){let T;h===91?(o=!0,T=0):T=S.get(h),T===1?f=!0:r=13}else r=d.nextState(r,h),r===0&&(f=!0);f&&(r=1,c=!1,o=!1,E=!1,i=t+1,a=h),t++}r===13&&w.push(C._createLink(S,u,b,i,l))}return w}}e.LinkComputer=C;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=g}),define(me[142],ge([0,1,3,6]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,k){return this._map.set(D,k),this.fire([D]),(0,P.toDisposable)(()=>{this._map.get(D)===k&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,k){let y=null,n=!1;return this._promises.set(D,k.then(R=>{this._promises.delete(D),!(n||!R)&&(y=this.register(D,R))})),(0,P.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(D){const k=this.get(D);if(k)return Promise.resolve(k);const y=this._promises.get(D);return y?y.then(n=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(me[107],ge([0,1,22,9]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(A||(A={}));function I(C){for(let g=0,m=C.length;g<m;g+=4){const s=C[g+0],d=C[g+1],S=C[g+2],w=C[g+3];C[g+0]=w,C[g+1]=S,C[g+2]=d,C[g+3]=s}}function D(C){const g=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return P.isLittleEndian()||I(g),_.VSBuffer.wrap(g)}function k(C){const g=C.buffer;if(P.isLittleEndian()||I(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const m=new Uint8Array(g.byteLength);return m.set(g),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(C){const g=new Uint32Array(n(C));let m=0;if(g[m++]=C.id,C.type==="full")g[m++]=1,g[m++]=C.data.length,g.set(C.data,m),m+=C.data.length;else{g[m++]=2,g[m++]=C.deltas.length;for(const s of C.deltas)g[m++]=s.start,g[m++]=s.deleteCount,s.data?(g[m++]=s.data.length,g.set(s.data,m),m+=s.data.length):g[m++]=0}return D(g)}e.encodeSemanticTokensDto=y;function n(C){let g=0;if(g+=1+1,C.type==="full")g+=1+C.data.length;else{g+=1,g+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(g+=m.data.length)}return g}function R(C){const g=k(C);let m=0;const s=g[m++];if(g[m++]===1){const b=g[m++],v=g.subarray(m,m+b);return m+=b,{id:s,type:"full",data:v}}const S=g[m++];let w=[];for(let b=0;b<S;b++){const v=g[m++],u=g[m++],l=g[m++];let t;l>0&&(t=g.subarray(m,m+l),m+=l),w[b]={start:v,deleteCount:u,data:t}}return{id:s,type:"delta",deltas:w}}e.decodeSemanticTokensDto=R}),define(me[108],ge([0,1,93]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class P{constructor(D,k){this.index=D,this.remainder=k}}e.PrefixSumIndexOfResult=P;class A{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,k){D=(0,_.toUint32)(D);const y=this.values,n=this.prefixSum,R=k.length;return R===0?!1:(this.values=new Uint32Array(y.length+R),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+R),this.values.set(k,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,k){return D=(0,_.toUint32)(D),k=(0,_.toUint32)(k),this.values[D]===k?!1:(this.values[D]=k,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,k){D=(0,_.toUint32)(D),k=(0,_.toUint32)(k);const y=this.values,n=this.prefixSum;if(D>=y.length)return!1;let R=y.length-D;return k>=R&&(k=R),k===0?!1:(this.values=new Uint32Array(y.length-k),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+k),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,_.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),D>=this.values.length&&(D=this.values.length-1);for(let y=k;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let k=0,y=this.values.length-1,n=0,R=0,C=0;for(;k<=y;)if(n=k+(y-k)/2|0,R=this.prefixSum[n],C=R-this.values[n],D<C)y=n-1;else if(D>=R)k=n+1;else break;return new P(n,D-C)}}e.PrefixSumComputer=A}),define(me[143],ge([0,1,10,49,108]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class I{constructor(k,y,n,R){this._uri=k,this._lines=y,this._eol=n,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const y=k.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new P.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let R=0;R<y;R++)n[R]=this._lines[R].length+k;this._lineStarts=new A.PrefixSumComputer(n)}}_setLineText(k,y){this._lines[k]=y,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,y){if(y.length!==0){let n=(0,_.splitLines)(y);if(n.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}n[n.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+n[0]);let R=new Uint32Array(n.length-1);for(let C=1;C<n.length;C++)this._lines.splice(k.lineNumber+C-1,0,n[C]),R[C-1]=n[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,R)}}}e.MirrorTextModel=I}),define(me[144],ge([16,17]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[145],ge([0,1,144]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,A=P*60,I=A*24,D=I*7,k=I*30,y=I*365;function n(C,g){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,_.localize)(0,null,n(new Date().getTime()+m*1e3,!1));if(m<30)return(0,_.localize)(1,null);let s;return m<P?(s=m,g?s===1?(0,_.localize)(2,null,s):(0,_.localize)(3,null,s):s===1?(0,_.localize)(4,null,s):(0,_.localize)(5,null,s)):m<A?(s=Math.floor(m/P),g?s===1?(0,_.localize)(6,null,s):(0,_.localize)(7,null,s):s===1?(0,_.localize)(8,null,s):(0,_.localize)(9,null,s)):m<I?(s=Math.floor(m/A),g?s===1?(0,_.localize)(10,null,s):(0,_.localize)(11,null,s):s===1?(0,_.localize)(12,null,s):(0,_.localize)(13,null,s)):m<D?(s=Math.floor(m/I),g?s===1?(0,_.localize)(14,null,s):(0,_.localize)(15,null,s):s===1?(0,_.localize)(16,null,s):(0,_.localize)(17,null,s)):m<k?(s=Math.floor(m/D),g?s===1?(0,_.localize)(18,null,s):(0,_.localize)(19,null,s):s===1?(0,_.localize)(20,null,s):(0,_.localize)(21,null,s)):m<y?(s=Math.floor(m/k),g?s===1?(0,_.localize)(22,null,s):(0,_.localize)(23,null,s):s===1?(0,_.localize)(24,null,s):(0,_.localize)(25,null,s)):(s=Math.floor(m/y),g?s===1?(0,_.localize)(26,null,s):(0,_.localize)(27,null,s):s===1?(0,_.localize)(28,null,s):(0,_.localize)(29,null,s))}e.fromNow=n;function R(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(me[146],ge([16,17]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[58],ge([0,1,146,15,14]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(n,R){return R&&(n.stack||n.stacktrace)?_.localize(0,null,k(n),D(n.stack)||D(n.stacktrace)):k(n)}function D(n){return Array.isArray(n)?n.join(`
`):n}function k(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?_.localize(1,null,n.message):n.message||_.localize(2,null)}function y(n=null,R=!1){if(!n)return _.localize(3,null);if(Array.isArray(n)){const C=A.coalesce(n),g=y(C[0],R);return C.length>1?_.localize(4,null,g,C.length):g}if(P.isString(n))return n;if(n.detail){const C=n.detail;if(C.error)return I(C.error,R);if(C.exception)return I(C.exception,R)}return n.stack?I(n,R):n.message?n.message:_.localize(5,null)}e.toErrorMessage=y}),define(me[147],ge([16,17]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[78],ge([0,1,8,37,26,38,147,36,15,23,30,9,136,11]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function s(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(l,t){if(C.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const a=I.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],i);return new Promise(r=>{a.once("error",c=>{r({success:!1,error:c})}),a.once("exit",(c,o)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?s(i.status):1})}else if(C.isLinux||C.isMacintosh)try{const i=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(a=>{I.execFile(i,[l.pid.toString()],{encoding:"utf8",shell:!0},(r,c,o)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function S(l=k.env){return l.comspec||"cmd.exe"}e.getWindowsShell=S;class w{constructor(t,i,a,r){if(i!==void 0&&a!==void 0&&r!==void 0)this.cmd=t,this.args=i,this.shell=a,this.options=r;else{const c=t;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(k.env).forEach(o=>{c[o]=k.env[o]}),Object.keys(this.options.env).forEach(o=>{c[o]=this.options.env[o]}),this.options.env=c}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(_.sep);return i!==-1&&(t=t.substring(i+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(k.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(i=>{let a,r;const c=new Promise((o,p)=>{a=o,r=p});if(i){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=I.exec(o,this.options,(p,E,f)=>{this.childProcess=null;const h=p;h&&h.killed?r({killed:this.terminateRequested,stdout:E.toString(),stderr:f.toString()}):this.handleExec(a,t,p,E,f)})}else{let o=null;const p=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,a,t,r);const f={terminated:this.terminateRequested};y.isNumber(E)&&(f.cmdCode=E),a(f)};if(this.shell&&C.isWindows){const E=n.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let f=!1,h=!1;const T=[];let L=this.ensureQuotes(this.cmd);T.push(L.value),f=L.quoted,this.args&&this.args.forEach(ee=>{L=this.ensureQuotes(ee),T.push(L.value),h=h&&L.quoted});const W=["/s","/c"];f?h?W.push('"'+T.join(" ")+'"'):T.length>1?W.push('"'+T[0]+'" '+T.slice(1).join(" ")):W.push('"'+T[0]+'"'):W.push(T.join(" ")),o=I.spawn(S(),W,E)}else this.cmd&&(o=I.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(y.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",E=>{this.childProcess=null,r({terminated:this.terminateRequested,error:E})}),o.pid&&(this.childProcess.on("close",p),this.handleSpawn(o,a,t,r,!0)))}return c})}handleClose(t,i,a,r){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const i=I.spawn(S(),["/s","/c"]);i.on("error",a=>t(!0)),i.on("exit",a=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class b extends w{constructor(t,i,a,r){super(t,i,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,a,r,c){[r,c].forEach((o,p)=>{const E=new g.LineDecoder;E.write(o).forEach(T=>{i({line:T,source:p===0?0:1})});const h=E.end();h&&i({line:h,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:a})}handleSpawn(t,i,a,r,c){const o=new g.LineDecoder,p=new g.LineDecoder;t.stdout.on("data",E=>{o.write(E).forEach(h=>a({line:h,source:0}))}),t.stderr.on("data",E=>{p.write(E).forEach(h=>a({line:h,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=p}handleClose(t,i,a,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&a({line:c,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&a({line:o,source:1})}}e.LineProcess=b;function v(l){let t=[],i=!1;const a=function(r){if(i){t.push(r);return}(!l.send(r,o=>{if(o&&console.error(o),i=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(E=>a(E))}})||C.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=v;var u;(function(l){async function t(i,a,r){if(_.isAbsolute(i))return i;if(a===void 0&&(a=k.cwd()),_.dirname(i)!=="."||(r===void 0&&y.isString(k.env.PATH)&&(r=k.env.PATH.split(_.delimiter)),r===void 0||r.length===0))return _.join(a,i);async function o(p){return await A.exists(p)?!(await P.promises.stat(p)).isDirectory():!1}for(let p of r){let E;if(_.isAbsolute(p)?E=_.join(p,i):E=_.join(a,p,i),await o(E))return E;let f=E+".com";if(await o(f)||(f=E+".exe",await o(f)))return f}return _.join(a,i)}l.findExecutable=t})(u=e.win32||(e.win32={}))}),define(me[148],ge([0,1,48,9,101,78]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(m,s){return m===3?P.isWindows?C():I.getWindowsShell(s):n(m,s)}e.getSystemShell=D;function k(m,s){return m===3?P.isWindows?g(s):I.getWindowsShell(s):n(m,s)}e.getSystemShellSync=k;let y=null;function n(m,s){if(P.isLinux&&m===1||P.isMacintosh&&m===2)return"/bin/bash";if(!y){let d;if(P.isWindows)d="/bin/bash";else{if(d=s.SHELL,!d)try{d=_.userInfo().shell}catch(S){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}y=d}return y}let R=null;async function C(){return R||(R=(await(0,A.getFirstAvailablePowerShellInstallation)()).exePath),R}function g(m){if(R)return R;const s=P.isWindows&&parseFloat(_.release())>=10,d=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${m.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return s?S:I.getWindowsShell(m)}}),define(me[149],ge([16,17]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[150],ge([0,1,149,9,106]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=D;class k{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,be){this._values[re]=be}}e.ValidatedEditorOptions=k;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(re,be,Ue,ze){this.id=re,this.name=be,this.defaultValue=Ue,this.schema=ze}compute(re,be,Ue){return Ue}}class R{constructor(re,be=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=be}validate(re){return this.defaultValue}}class C{constructor(re,be,Ue,ze){this.id=re,this.name=be,this.defaultValue=Ue,this.schema=ze}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,be,Ue){return Ue}}function g(Q,re){return typeof Q=="undefined"?re:Q==="false"?!1:Boolean(Q)}e.boolean=g;class m extends C{constructor(re,be,Ue,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ue),super(re,be,Ue,ze)}validate(re){return g(re,this.defaultValue)}}class s extends C{constructor(re,be,Ue,ze,$e,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Ue,Ze.minimum=ze,Ze.maximum=$e),super(re,be,Ue,Ze),this.minimum=ze,this.maximum=$e}static clampedInt(re,be,Ue,ze){if(typeof re=="undefined")return be;let $e=parseInt(re,10);return isNaN($e)?be:($e=Math.max(Ue,$e),$e=Math.min(ze,$e),$e|0)}validate(re){return s.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class d extends C{constructor(re,be,Ue,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ue),super(re,be,Ue,$e),this.validationFn=ze}static clamp(re,be,Ue){return re<be?be:re>Ue?Ue:re}static float(re,be){if(typeof re=="number")return re;if(typeof re=="undefined")return be;const Ue=parseFloat(re);return isNaN(Ue)?be:Ue}validate(re){return this.validationFn(d.float(re,this.defaultValue))}}class S extends C{static string(re,be){return typeof re!="string"?be:re}constructor(re,be,Ue,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ue),super(re,be,Ue,ze)}validate(re){return S.string(re,this.defaultValue)}}function w(Q,re,be){return typeof Q!="string"||be.indexOf(Q)===-1?re:Q}e.stringSet=w;class b extends C{constructor(re,be,Ue,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=Ue),super(re,be,Ue,$e),this._allowedValues=ze}validate(re){return w(re,this.defaultValue,this._allowedValues)}}class v extends n{constructor(re,be,Ue,ze,$e,Ze,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(re,be,Ue,K),this._allowedValues=$e,this._convert=Ze}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function u(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,be,Ue){return Ue===0?re.accessibilitySupport:Ue}}class t extends n{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:_.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{insertSpace:g(be.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(be.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(Q){switch(Q){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function o(Q){switch(Q){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends R{constructor(){super(123,[62,31])}compute(re,be,Ue){const ze=["monaco-editor"];return be.get(31)&&ze.push(be.get(31)),re.extraEditorClassName&&ze.push(re.extraEditorClassName),be.get(62)==="default"?ze.push("mouse-default"):be.get(62)==="copy"&&ze.push("mouse-copy"),be.get(97)&&ze.push("showUnused"),be.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class E extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(re,be,Ue){return Ue&&re.emptySelectionClipboard}}class f extends n{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:_.localize(13,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:_.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{cursorMoveOnType:g(be.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:g(be.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":w(be.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(be.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(be.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(be.loop,this.defaultValue.loop)}}}class h extends n{constructor(){super(41,"fontLigatures",h.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?h.OFF:re==="true"?h.ON:re:Boolean(re)?h.ON:h.OFF}}e.EditorFontLigatures=h,h.OFF='"liga" off, "calt" off',h.ON='"liga" on, "calt" on';class T extends R{constructor(){super(40)}compute(re,be,Ue){return re.fontInfo}}class L extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(re){let be=d.float(re,this.defaultValue);return be===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(be,6,100)}compute(re,be,Ue){return re.fontInfo.fontSize}}class W extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(s.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ee extends n{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},be={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},be),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},be),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},be),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},be),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},be),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(re){var be,Ue,ze,$e,Ze;if(!re||typeof re!="object")return this.defaultValue;const K=re;return{multiple:w(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(be=K.multipleDefinitions)!==null&&be!==void 0?be:w(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ue=K.multipleTypeDefinitions)!==null&&Ue!==void 0?Ue:w(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:w(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:w(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=K.multipleReferences)!==null&&Ze!==void 0?Ze:w(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends n{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:_.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{enabled:g(be.enabled,this.defaultValue.enabled),delay:s.clampedInt(be.delay,this.defaultValue.delay,0,1e4),sticky:g(be.sticky,this.defaultValue.sticky)}}}var x;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends R{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(re,be,Ue){return $.computeLayout(be,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const be=re.height/re.lineHeight,Ue=re.scrollBeyondLastLine?be-1:0,ze=(re.viewLineCount+Ue)/(re.pixelRatio*re.height),$e=Math.floor(re.viewLineCount/ze);return{typicalViewportLineCount:be,extraLinesBeyondLastLine:Ue,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(re,be){const Ue=re.outerWidth,ze=re.outerHeight,$e=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ze=be.stableMinimapLayoutInput,K=Ze&&re.outerHeight===Ze.outerHeight&&re.lineHeight===Ze.lineHeight&&re.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&re.pixelRatio===Ze.pixelRatio&&re.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&re.minimap.enabled===Ze.minimap.enabled&&re.minimap.side===Ze.minimap.side&&re.minimap.size===Ze.minimap.size&&re.minimap.showSlider===Ze.minimap.showSlider&&re.minimap.renderCharacters===Ze.minimap.renderCharacters&&re.minimap.maxColumn===Ze.minimap.maxColumn&&re.minimap.scale===Ze.minimap.scale&&re.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&re.isViewportWrapping===Ze.isViewportWrapping,oe=re.lineHeight,de=re.typicalHalfwidthCharacterWidth,Y=re.scrollBeyondLastLine,ie=re.minimap.renderCharacters;let ce=$e>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const pe=re.minimap.maxColumn,ye=re.minimap.size,We=re.minimap.side,Ne=re.verticalScrollbarWidth,Ke=re.viewLineCount,Xe=re.remainingWidth,nt=re.isViewportWrapping,rt=ie?2:3;let ot=Math.floor($e*ze);const it=ot/$e;let pt=!1,qe=!1,_e=rt*ce,De=ce/$e,ae=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:st,extraLinesBeyondLastLine:Qe,desiredRatio:lt,minimapLineCount:bt}=$.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Y,height:ze,lineHeight:oe,pixelRatio:$e});if(Ke/bt>1)pt=!0,qe=!0,ce=1,_e=1,De=ce/$e;else{let vt=!1,Et=ce+1;if(ye==="fit"){const yt=Math.ceil((Ke+Qe)*_e);nt&&K&&Xe<=be.stableFitRemainingWidth?(vt=!0,Et=be.stableFitMaxMinimapScale):(vt=yt>ot,nt&&vt?(be.stableMinimapLayoutInput=re,be.stableFitRemainingWidth=Xe):(be.stableMinimapLayoutInput=null,be.stableFitRemainingWidth=0))}if(ye==="fill"||vt){pt=!0;const yt=ce;_e=Math.min(oe*$e,Math.max(1,Math.floor(1/lt))),ce=Math.min(Et,Math.max(1,Math.floor(_e/rt))),ce>yt&&(ae=Math.min(2,ce/yt)),De=ce/$e/ae,ot=Math.ceil(Math.max(st,Ke+Qe)*_e),nt&&vt&&(be.stableFitMaxMinimapScale=ce)}}}const Z=Math.floor(pe*De),Oe=Math.min(Z,Math.max(0,Math.floor((Xe-Ne-2)*De/(de+De)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Oe);const Je=Te/$e;Te=Math.floor(Te*ae);const Ye=ie?1:2,at=We==="left"?0:Ue-Oe-Ne;return{renderMinimap:Ye,minimapLeft:at,minimapWidth:Oe,minimapHeightIsEditorHeight:pt,minimapIsSampling:qe,minimapScale:ce,minimapLineHeight:_e,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:it}}static computeLayout(re,be){const Ue=be.outerWidth|0,ze=be.outerHeight|0,$e=be.lineHeight|0,Ze=be.lineNumbersDigitCount|0,K=be.typicalHalfwidthCharacterWidth,oe=be.maxDigitWidth,de=be.pixelRatio,Y=be.viewLineCount,ie=re.get(118),ce=ie==="inherit"?re.get(117):ie,pe=ce==="inherit"?re.get(113):ce,ye=re.get(116),We=re.get(2),Ne=be.isDominatedByLongLines,Ke=re.get(46),Xe=re.get(56).renderType!==0,nt=re.get(57),rt=re.get(91),ot=re.get(61),it=re.get(89),pt=it.verticalScrollbarSize,qe=it.verticalHasArrows,_e=it.arrowSize,De=it.horizontalScrollbarSize,ae=re.get(54),Z=re.get(35);let Oe;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Rt=parseFloat(ae.substr(0,ae.length-2));Oe=s.clampedInt(Rt*K,0,0,1e3)}else Oe=s.clampedInt(ae,0,0,1e3);Z&&(Oe+=16);let Te=0;if(Xe){const Rt=Math.max(Ze,nt);Te=Math.round(Rt*oe)}let Je=0;Ke&&(Je=$e);let Ye=0,at=Ye+Je,st=at+Te,Qe=st+Oe;const lt=Ue-Je-Te-Oe;let bt=!1,ut=!1,vt=-1;We!==2&&(ce==="inherit"&&Ne?(bt=!0,ut=!0):pe==="on"||pe==="bounded"?ut=!0:pe==="wordWrapColumn"&&(vt=ye));const Et=$._computeMinimapLayout({outerWidth:Ue,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:de,scrollBeyondLastLine:rt,minimap:ot,verticalScrollbarWidth:pt,viewLineCount:Y,remainingWidth:lt,isViewportWrapping:ut},be.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(Ye+=Et.minimapWidth,at+=Et.minimapWidth,st+=Et.minimapWidth,Qe+=Et.minimapWidth);const yt=lt-Et.minimapWidth,_t=Math.max(1,Math.floor((yt-pt-2)/K)),Ot=qe?_e:0;return ut&&(vt=Math.max(1,_t),pe==="bounded"&&(vt=Math.min(vt,ye))),{width:Ue,height:ze,glyphMarginLeft:Ye,glyphMarginWidth:Je,lineNumbersLeft:at,lineNumbersWidth:Te,decorationsLeft:st,decorationsWidth:Oe,contentLeft:Qe,contentWidth:yt,minimap:Et,viewportColumn:_t,isWordWrapMinified:bt,isViewportWrapping:ut,wrappingColumn:vt,verticalScrollbarWidth:pt,horizontalScrollbarHeight:De,overviewRuler:{top:Ot,width:pt,height:ze-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=$;class F extends n{constructor(){const re={enabled:!0};super(53,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:_.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:g(re.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",re,{"editor.inlineHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:re.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:re.fontFamily,description:_.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{enabled:g(be.enabled,this.defaultValue.enabled),fontSize:s.clampedInt(be.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(be.fontFamily,this.defaultValue.fontFamily)}}}class M extends s{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(re,be,Ue){return re.fontInfo.lineHeight}}class N extends n{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:re.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:_.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{enabled:g(be.enabled,this.defaultValue.enabled),size:w(be.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(be.side,this.defaultValue.side,["right","left"]),showSlider:w(be.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(be.renderCharacters,this.defaultValue.renderCharacters),scale:s.clampedInt(be.scale,1,1,3),maxColumn:s.clampedInt(be.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(Q){return Q==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class V extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{top:s.clampedInt(be.top,0,0,1e3),bottom:s.clampedInt(be.bottom,0,0,1e3)}}}class q extends n{constructor(){const re={enabled:!0,cycle:!1};super(72,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:_.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{enabled:g(be.enabled,this.defaultValue.enabled),cycle:g(be.cycle,this.defaultValue.cycle)}}}class X extends R{constructor(){super(124)}compute(re,be,Ue){return re.pixelRatio}}class fe extends n{constructor(){const re={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:_.localize(58,null)},comments:{type:"boolean",default:re.comments,description:_.localize(59,null)},other:{type:"boolean",default:re.other,description:_.localize(60,null)}}}],default:re,description:_.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const be=re,Ue={other:g(be.other,this.defaultValue.other),comments:g(be.comments,this.defaultValue.comments),strings:g(be.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var ve;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ae extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(re){let be=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(be=4,Ue=re):re==="interval"?be=3:re==="relative"?be=2:re==="on"?be=1:be=0),{renderType:be,renderFn:Ue}}}function Pe(Q){const re=Q.get(84);return re==="editable"?Q.get(77):re!=="on"}e.filterValidationDecorations=Pe;class Fe extends n{constructor(){const re=[],be={type:"number",description:_.localize(67,null)};super(88,"rulers",re,{type:"array",items:{anyOf:[be,{type:["object"],properties:{column:be,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:re,description:_.localize(69,null)})}validate(re){if(Array.isArray(re)){let be=[];for(let Ue of re)if(typeof Ue=="number")be.push({column:s.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const ze=Ue;be.push({column:s.clampedInt(ze.column,0,0,1e4),color:ze.color})}return be.sort((Ue,ze)=>Ue.column-ze.column),be}return this.defaultValue}}function z(Q,re){if(typeof Q!="string")return re;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re,Ue=s.clampedInt(be.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=s.clampedInt(be.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:s.clampedInt(be.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(be.vertical,this.defaultValue.vertical),horizontal:z(be.horizontal,this.defaultValue.horizontal),useShadows:g(be.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(be.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(be.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(be.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(be.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:s.clampedInt(be.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:s.clampedInt(be.verticalSliderSize,ze,0,1e3),scrollByPage:g(be.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends n{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:re.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const be=re;return{insertMode:w(be.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(be.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(be.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(be.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(be.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(be.showIcons,this.defaultValue.showIcons),showStatusBar:g(be.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:g(be.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(be.showMethods,this.defaultValue.showMethods),showFunctions:g(be.showFunctions,this.defaultValue.showFunctions),showConstructors:g(be.showConstructors,this.defaultValue.showConstructors),showFields:g(be.showFields,this.defaultValue.showFields),showVariables:g(be.showVariables,this.defaultValue.showVariables),showClasses:g(be.showClasses,this.defaultValue.showClasses),showStructs:g(be.showStructs,this.defaultValue.showStructs),showInterfaces:g(be.showInterfaces,this.defaultValue.showInterfaces),showModules:g(be.showModules,this.defaultValue.showModules),showProperties:g(be.showProperties,this.defaultValue.showProperties),showEvents:g(be.showEvents,this.defaultValue.showEvents),showOperators:g(be.showOperators,this.defaultValue.showOperators),showUnits:g(be.showUnits,this.defaultValue.showUnits),showValues:g(be.showValues,this.defaultValue.showValues),showConstants:g(be.showConstants,this.defaultValue.showConstants),showEnums:g(be.showEnums,this.defaultValue.showEnums),showEnumMembers:g(be.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(be.showKeywords,this.defaultValue.showKeywords),showWords:g(be.showWords,this.defaultValue.showWords),showColors:g(be.showColors,this.defaultValue.showColors),showFiles:g(be.showFiles,this.defaultValue.showFiles),showReferences:g(be.showReferences,this.defaultValue.showReferences),showFolders:g(be.showFolders,this.defaultValue.showFolders),showTypeParameters:g(be.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(be.showSnippets,this.defaultValue.showSnippets),showUsers:g(be.showUsers,this.defaultValue.showUsers),showIssues:g(be.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends R{constructor(){super(125,[77])}compute(re,be,Ue){return be.get(77)?!0:re.tabFocusMode}}var Ce;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ce=e.WrappingIndent||(e.WrappingIndent={}));function Me(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class we extends R{constructor(){super(127,[126])}compute(re,be,Ue){const ze=be.get(126);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?Re:P.isLinux?Be:ke,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Ge;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.letterSpacing=52]="letterSpacing",Q[Q.lightbulb=53]="lightbulb",Q[Q.lineDecorationsWidth=54]="lineDecorationsWidth",Q[Q.lineHeight=55]="lineHeight",Q[Q.lineNumbers=56]="lineNumbers",Q[Q.lineNumbersMinChars=57]="lineNumbersMinChars",Q[Q.linkedEditing=58]="linkedEditing",Q[Q.links=59]="links",Q[Q.matchBrackets=60]="matchBrackets",Q[Q.minimap=61]="minimap",Q[Q.mouseStyle=62]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=64]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=66]="multiCursorModifier",Q[Q.multiCursorPaste=67]="multiCursorPaste",Q[Q.occurrencesHighlight=68]="occurrencesHighlight",Q[Q.overviewRulerBorder=69]="overviewRulerBorder",Q[Q.overviewRulerLanes=70]="overviewRulerLanes",Q[Q.padding=71]="padding",Q[Q.parameterHints=72]="parameterHints",Q[Q.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=75]="quickSuggestions",Q[Q.quickSuggestionsDelay=76]="quickSuggestionsDelay",Q[Q.readOnly=77]="readOnly",Q[Q.renameOnType=78]="renameOnType",Q[Q.renderControlCharacters=79]="renderControlCharacters",Q[Q.renderIndentGuides=80]="renderIndentGuides",Q[Q.renderFinalNewline=81]="renderFinalNewline",Q[Q.renderLineHighlight=82]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=84]="renderValidationDecorations",Q[Q.renderWhitespace=85]="renderWhitespace",Q[Q.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",Q[Q.roundedSelection=87]="roundedSelection",Q[Q.rulers=88]="rulers",Q[Q.scrollbar=89]="scrollbar",Q[Q.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=91]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=92]="scrollPredominantAxis",Q[Q.selectionClipboard=93]="selectionClipboard",Q[Q.selectionHighlight=94]="selectionHighlight",Q[Q.selectOnLineNumbers=95]="selectOnLineNumbers",Q[Q.showFoldingControls=96]="showFoldingControls",Q[Q.showUnused=97]="showUnused",Q[Q.snippetSuggestions=98]="snippetSuggestions",Q[Q.smartSelect=99]="smartSelect",Q[Q.smoothScrolling=100]="smoothScrolling",Q[Q.stickyTabStops=101]="stickyTabStops",Q[Q.stopRenderingLineAfter=102]="stopRenderingLineAfter",Q[Q.suggest=103]="suggest",Q[Q.suggestFontSize=104]="suggestFontSize",Q[Q.suggestLineHeight=105]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",Q[Q.suggestSelection=107]="suggestSelection",Q[Q.tabCompletion=108]="tabCompletion",Q[Q.tabIndex=109]="tabIndex",Q[Q.unusualLineTerminators=110]="unusualLineTerminators",Q[Q.useTabStops=111]="useTabStops",Q[Q.wordSeparators=112]="wordSeparators",Q[Q.wordWrap=113]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=116]="wordWrapColumn",Q[Q.wordWrapOverride1=117]="wordWrapOverride1",Q[Q.wordWrapOverride2=118]="wordWrapOverride2",Q[Q.wrappingIndent=119]="wrappingIndent",Q[Q.wrappingStrategy=120]="wrappingStrategy",Q[Q.showDeprecated=121]="showDeprecated",Q[Q.inlineHints=122]="inlineHints",Q[Q.editorClassName=123]="editorClassName",Q[Q.pixelRatio=124]="pixelRatio",Q[Q.tabFocusMode=125]="tabFocusMode",Q[Q.layoutInfo=126]="layoutInfo",Q[Q.wrappingInfo=127]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Ee(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Ee(new l),accessibilityPageSize:Ee(new s(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Ee(new S(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Ee(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:Ee(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:Ee(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:Ee(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:Ee(new v(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:Ee(new m(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:Ee(new S(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:Ee(new s(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:Ee(new v(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:Ee(new v(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:_.localize(145,null)})),cursorSurroundingLines:Ee(new s(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:Ee(new s(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:Ee(new E),extraEditorClassName:Ee(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new d(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:_.localize(152,null)})),find:Ee(new f),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:Ee(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:Ee(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:Ee(new T),fontLigatures2:Ee(new h),fontSize:Ee(new L),fontWeight:Ee(new W),formatOnPaste:Ee(new m(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:Ee(new m(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:Ee(new m(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:Ee(new ee),hideCursorInOverviewRuler:Ee(new m(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:Ee(new m(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:Ee(new j),inDiffEditor:Ee(new m(51,"inDiffEditor",!1)),letterSpacing:Ee(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>d.clamp(Q,-5,20),{description:_.localize(165,null)})),lightbulb:Ee(new F),lineDecorationsWidth:Ee(new C(54,"lineDecorationsWidth",10)),lineHeight:Ee(new M),lineNumbers:Ee(new Ae),lineNumbersMinChars:Ee(new s(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:Ee(new m(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:Ee(new b(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:Ee(new N),mouseStyle:Ee(new b(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new d(63,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:Ee(new m(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:Ee(new m(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:Ee(new v(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:Ee(new b(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:Ee(new m(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:Ee(new m(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:Ee(new s(70,"overviewRulerLanes",3,0,3)),padding:Ee(new V),parameterHints:Ee(new q),peekWidgetDefaultFocus:Ee(new b(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:Ee(new m(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:Ee(new fe),quickSuggestionsDelay:Ee(new s(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:Ee(new m(77,"readOnly",!1)),renameOnType:Ee(new m(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:Ee(new m(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:Ee(new m(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:Ee(new m(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:Ee(new b(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:Ee(new b(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new b(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:Ee(new s(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:Ee(new Fe),scrollbar:Ee(new J),scrollBeyondLastColumn:Ee(new s(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:Ee(new m(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:Ee(new m(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:Ee(new m(93,"selectionClipboard",!0,{description:_.localize(201,null),included:P.isLinux})),selectionHighlight:Ee(new m(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:Ee(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new b(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:Ee(new m(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:Ee(new m(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:Ee(new U),snippetSuggestions:Ee(new b(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:Ee(new le),smoothScrolling:Ee(new m(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:Ee(new s(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new te),suggestFontSize:Ee(new s(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:Ee(new s(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:Ee(new m(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:Ee(new b(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:Ee(new b(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:Ee(new s(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new b(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:Ee(new m(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:Ee(new S(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:Ee(new b(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new s(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:Ee(new b(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new b(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new v(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:Ee(new b(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:Ee(new p),pixelRatio:Ee(new X),tabFocusMode:Ee(new he),layoutInfo:Ee(new $),wrappingInfo:Ee(new we)}}),define(me[151],ge([16,17]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[152],ge([16,17]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[153],ge([16,17]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[154],ge([16,17]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[155],ge([16,17]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[156],ge([16,17]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[157],ge([16,17]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[158],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[159],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[160],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(me[161],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[162],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[163],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[164],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[165],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[166],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[167],ge([16,17]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[168],ge([16,17]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[169],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[170],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[171],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(me[172],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[173],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[174],ge([16,17]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[175],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var P;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(P=e.EditorOverride||(e.EditorOverride={}));var A;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[176],ge([0,1,153]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(C){return C=C.trim(),C==="*"||P.test(C)}e.isValidVersionStr=A;function I(C){if(!A(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=C.match(P);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function D(C){if(!C)return null;let g=C.majorBase,m=C.majorMustEqual,s=C.minorBase,d=C.minorMustEqual,S=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(g===0||(d=!1),w=!1),{majorBase:g,majorMustEqual:m,minorBase:s,minorMustEqual:d,patchBase:S,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=D;function k(C,g){let m;typeof C=="string"?m=D(I(C)):m=C;let s;if(typeof g=="string"?s=D(I(g)):s=g,!m||!s)return!1;let d=m.majorBase,S=m.minorBase,w=m.patchBase,b=s.majorBase,v=s.minorBase,u=s.patchBase,l=s.majorMustEqual,t=s.minorMustEqual,i=s.patchMustEqual;return s.isMinimum?d>b?!0:d<b?!1:S>v?!0:S<v?!1:w>=u:(d===1&&b===0&&(!l||!t||!i)&&(b=1,v=0,u=0,l=!0,t=!1,i=!1),d<b?!1:d>b?!l:S<v?!1:S>v?!t:w<u?!1:w>u?!i:!0)}e.isValidVersion=k;function y(C,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:R(C,g.engines.vscode,m)}e.isValidExtensionVersion=y;function n(C,g){return C==="*"||R(g,C)}e.isEngineValid=n;function R(C,g,m=[]){let s=D(I(g));if(!s)return m.push(_.localize(0,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return m.push(_.localize(1,null,g)),!1}else if(!s.majorMustEqual)return m.push(_.localize(2,null,g)),!1;return k(C,s)?!0:(m.push(_.localize(3,null,C,g)),!1)}e.isVersionValid=R}),define(me[109],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(I,D=[],k=!1){this.ctor=I,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=_;const P=(A,...I)=>new _(A,I);e.createSyncDescriptor=P}),define(me[79],ge([0,1,109]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const P=[];function A(D,k,y){k instanceof _.SyncDescriptor||(k=new _.SyncDescriptor(k,[],y)),P.push([D,k])}e.registerSingleton=A;function I(){return P}e.getSingletonServiceDescriptors=I}),define(me[177],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=_;class P{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let D of this._nodes.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const k=this.lookupOrInsertNode(I),y=this.lookupOrInsertNode(D);k.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(I),k)}removeNode(I){const D=this._hashFn(I);this._nodes.delete(D);for(let k of this._nodes.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(I){const D=this._hashFn(I);let k=this._nodes.get(D);return k||(k=new _(I),this._nodes.set(D,k)),k}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[D,k]of this._nodes)I.push(`${D}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,D]of this._nodes){const k=new Set([I]),y=this._findCycle(D,k);if(y)return y}}_findCycle(I,D){for(let[k,y]of I.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const n=this._findCycle(y,D);if(n)return n;D.delete(k)}}}e.Graph=P}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=y})(_=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function P(k,y,n,R){y[_.DI_TARGET]===y?y[_.DI_DEPENDENCIES].push({id:k,index:n,optional:R}):(y[_.DI_DEPENDENCIES]=[{id:k,index:n,optional:R}],y[_.DI_TARGET]=y)}function A(k){if(_.serviceIds.has(k))return _.serviceIds.get(k);const y=function(n,R,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(y,n,C,!1)};return y.toString=()=>k,_.serviceIds.set(k,y),y}e.createDecorator=A;function I(k){return k}e.refineServiceDecorator=I;function D(k){return function(y,n,R){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(k,y,R,!0)}}e.optional=D}),define(me[178],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function P(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(me[179],ge([0,1,3,74,6,24,73,77,178]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(n):!!g.exclusive}class R{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(m,s){let d={selector:m,provider:s,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(d){let S=this._entries.indexOf(d);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const s=[];for(let d of this._entries)d._score>0&&s.push(d.provider);return s}ordered(m){const s=[];return this._orderedForEach(m,d=>s.push(d.provider)),s}orderedGroups(m){const s=[];let d,S;return this._orderedForEach(m,w=>{d&&S===w._score?d.push(w.provider):(S=w._score,d=[w.provider],s.push(d))}),s}_orderedForEach(m,s){if(!!m){this._updateScores(m);for(const d of this._entries)d._score>0&&s(d)}}_updateScores(m){let s={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===s.language&&this._lastCandidate.uri===s.uri)){this._lastCandidate=s;for(let d of this._entries)if(d._score=(0,k.score)(d.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),n(d.selector)&&d._score>0){for(let S of this._entries)S._score=0;d._score=1e3;break}this._entries.sort(R._compareByScoreAndTime)}}static _compareByScoreAndTime(m,s){return m._score<s._score?1:m._score>s._score?-1:m._time<s._time?1:m._time>s._time?-1:0}}e.LanguageFeatureRegistry=R;class C{constructor(m,s,d=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=s,this.max=d,this._cache=new I.LRUCache(50,.7)}_key(m){return m.id+(0,P.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const s=this._key(m),d=this._cache.get(s);return this._clamp(d==null?void 0:d.value)}update(m,s){const d=this._key(m);let S=this._cache.get(d);return S||(S=new D.MovingAverage,this._cache.set(d,S)),S.update(s),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(me[80],ge([0,1,2,44,179,142,43]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class y{constructor(h,T){this.language=h,this.id=T}}e.LanguageIdentifier=y;var n;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var R;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var C;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var g;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(g=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(h){return(h&255)>>>0}static getTokenType(h){return(h&1792)>>>8}static getFontStyle(h){return(h&14336)>>>11}static getForeground(h){return(h&8372224)>>>14}static getBackground(h){return(h&4286578688)>>>23}static getClassNameFromMetadata(h){let T=this.getForeground(h),L="mtk"+T,W=this.getFontStyle(h);return W&1&&(L+=" mtki"),W&2&&(L+=" mtkb"),W&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(h,T){const L=this.getForeground(h),W=this.getFontStyle(h);let ee=`color: ${T[L]};`;return W&1&&(ee+="font-style: italic;"),W&2&&(ee+="font-weight: bold;"),W&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var s;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(s=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(h){const T=f[h];let L=T&&D.iconRegistry.get(T);return L||(console.info("No codicon found for CompletionItemKind "+h),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(h,T){let L=f[h];return typeof L=="undefined"&&!T&&(L=9),L}}();var d;(function(f){f[f.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(f){return f&&_.URI.isUri(f.uri)&&P.Range.isIRange(f.range)&&(P.Range.isIRange(f.originSelectionRange)||P.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=l;var t;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(f){f[f.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var a;(function(f){const h=new Map;h.set("file",0),h.set("module",1),h.set("namespace",2),h.set("package",3),h.set("class",4),h.set("method",5),h.set("property",6),h.set("field",7),h.set("constructor",8),h.set("enum",9),h.set("interface",10),h.set("function",11),h.set("variable",12),h.set("constant",13),h.set("string",14),h.set("number",15),h.set("boolean",16),h.set("array",17),h.set("object",18),h.set("key",19),h.set("null",20),h.set("enum-member",21),h.set("struct",22),h.set("event",23),h.set("operator",24),h.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function L(j){return h.get(j)}f.fromString=L;function W(j){return T.get(j)}f.toString=W;function ee(j,x){const $=T.get(j);let F=$&&D.iconRegistry.get("symbol-"+$);return F||(console.info("No codicon found for SymbolKind "+j),F=D.Codicon.symbolProperty),`${x?"inline":"block"} ${F.classNames}`}f.toCssClassName=ee})(a=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(h){this.value=h}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var c;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var p;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(p=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var E;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[180],ge([0,1,6,15,4,3,55,72]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new I.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const s=[];for(let S of y.description.args)s.push(S.constraint);const d=y.handler;y.handler=function(S,...w){return(0,P.validateConstraints)(w,s),d(S,...w)}}const{id:R}=y;let C=this._commands.get(R);C||(C=new D.LinkedList,this._commands.set(R,C));let g=C.unshift(y),m=(0,_.toDisposable)(()=>{g();const s=this._commands.get(R);(s==null?void 0:s.isEmpty())&&this._commands.delete(R)});return this._onDidRegisterCommand.fire(R),m}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(R,...C)=>R.get(e.ICommandService).executeCommand(n,...C))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return k.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const R=this.getCommand(n);R&&y.set(n,R)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(me[81],ge([0,1,10,4,9]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=A.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",A.isMacintosh),D.set("isLinux",A.isLinux),D.set("isWindows",A.isWindows),D.set("isWeb",A.isWeb),D.set("isMacNative",A.isMacintosh&&!A.isWeb),D.set("isEdge",I.indexOf("Edg/")>=0),D.set("isFirefox",I.indexOf("Firefox")>=0),D.set("isChrome",I.indexOf("Chrome")>=0),D.set("isSafari",I.indexOf("Safari")>=0),D.set("isIPad",I.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var y;(function(f){f[f.False=0]="False",f[f.True=1]="True",f[f.Defined=2]="Defined",f[f.Not=3]="Not",f[f.Equals=4]="Equals",f[f.NotEquals=5]="NotEquals",f[f.And=6]="And",f[f.Regex=7]="Regex",f[f.NotRegex=8]="NotRegex",f[f.Or=9]="Or",f[f.In=10]="In",f[f.NotIn=11]="NotIn",f[f.Greater=12]="Greater",f[f.GreaterEquals=13]="GreaterEquals",f[f.Smaller=14]="Smaller",f[f.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(h){return m.create(h)}static equals(h,T){return s.create(h,T)}static notEquals(h,T){return w.create(h,T)}static regex(h,T){return i.create(h,T)}static in(h,T){return d.create(h,T)}static not(h){return b.create(h)}static and(...h){return r.create(h)}static or(...h){return c.create(h)}static greater(h,T){return v.create(h,T)}static less(h,T){return l.create(h,T)}static deserialize(h,T=!1){if(!!h)return this._deserializeOrExpression(h,T)}static _deserializeOrExpression(h,T){let L=h.split("||");return c.create(L.map(W=>this._deserializeAndExpression(W,T)))}static _deserializeAndExpression(h,T){let L=h.split("&&");return r.create(L.map(W=>this._deserializeOne(W,T)))}static _deserializeOne(h,T){if(h=h.trim(),h.indexOf("!=")>=0){let L=h.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],T))}if(h.indexOf("==")>=0){let L=h.split("==");return s.create(L[0].trim(),this._deserializeValue(L[1],T))}if(h.indexOf("=~")>=0){let L=h.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],T))}if(h.indexOf(" in ")>=0){let L=h.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const L=h.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const L=h.split(">");return v.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const L=h.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const L=h.split("<");return l.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(h)?b.create(h.substr(1).trim()):m.create(h)}static _deserializeValue(h,T){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let L=/^'([^']*)'$/.exec(h);return L?L[1].trim():h}static _deserializeRegexValue(h,T){if((0,_.isFalsyOrWhitespace)(h)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=h.indexOf("/"),W=h.lastIndexOf("/");if(L===W||L<0){if(T)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let ee=h.slice(L+1,W),j=h[W+1]==="i"?"i":"";try{return new RegExp(ee,j)}catch(x){if(T)throw new Error(`bad regexp-value '${h}', parse error: ${x}`);return console.warn(`bad regexp-value '${h}', parse error: ${x}`),null}}}e.ContextKeyExpr=n;function R(f,h){return f.cmp(h)}class C{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{constructor(h){this.key=h,this.type=2}static create(h){const T=D.get(h);return typeof T=="boolean"?T?g.INSTANCE:C.INSTANCE:new m(h)}cmp(h){return h.type!==this.type?this.type-h.type:p(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=m;class s{constructor(h,T){this.key=h,this.value=T,this.type=4}static create(h,T){if(typeof T=="boolean")return T?m.create(h):b.create(h);const L=D.get(h);return typeof L=="boolean"?T===(L?"true":"false")?g.INSTANCE:C.INSTANCE:new s(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=s;class d{constructor(h,T){this.key=h,this.valueKey=T,this.type=10}static create(h,T){return new d(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const T=h.getValue(this.valueKey),L=h.getValue(this.key);return Array.isArray(T)?T.indexOf(L)>=0:typeof L=="string"&&typeof T=="object"&&T!==null?k.call(T,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=d;class S{constructor(h){this._actual=h,this.type=11}static create(h){return new S(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new S(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(h,T){this.key=h,this.value=T,this.type=5}static create(h,T){if(typeof T=="boolean")return T?b.create(h):m.create(h);const L=D.get(h);return typeof L=="boolean"?T===(L?"true":"false")?C.INSTANCE:g.INSTANCE:new w(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class b{constructor(h){this.key=h,this.type=3}static create(h){const T=D.get(h);return typeof T=="boolean"?T?C.INSTANCE:g.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:p(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=b;class v{constructor(h,T){this.key=h,this.value=T,this.type=12}static create(h,T){return new v(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class u{constructor(h,T){this.key=h,this.value=T,this.type=13}static create(h,T){return new u(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class l{constructor(h,T){this.key=h,this.value=T,this.type=14}static create(h,T){return new l(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=l;class t{constructor(h,T){this.key=h,this.value=T,this.type=15}static create(h,T){return new t(h,T)}cmp(h){return h.type!==this.type?this.type-h.type:E(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(h,T){this.key=h,this.regexp=T,this.type=7}static create(h,T){return new i(h,T)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const T=this.regexp?this.regexp.source:"",L=h.regexp?h.regexp.source:"";return T<L?-1:T>L?1:0}equals(h){if(h.type===this.type){const T=this.regexp?this.regexp.source:"",L=h.regexp?h.regexp.source:"";return this.key===h.key&&T===L}return!1}evaluate(h){let T=h.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=i;class a{constructor(h){this._actual=h,this.type=8}static create(h){return new a(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new a(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class r{constructor(h){this.expr=h,this.type=6}static create(h){return r._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const W=R(this.expr[T],h.expr[T]);if(W!==0)return W}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(h.expr[T]))return!1;return!0}return!1}evaluate(h){for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].evaluate(h))return!1;return!0}static _normalizeArr(h){const T=[];let L=!1;for(const W of h)if(!!W){if(W.type===1){L=!0;continue}if(W.type===0)return C.INSTANCE;if(W.type===6){T.push(...W.expr);continue}T.push(W)}if(T.length===0&&L)return g.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(R);T.length>1;){const W=T[T.length-1];if(W.type!==9)break;T.pop();const ee=T.pop(),j=c.create(W.expr.map(x=>r.create([x,ee])));j&&(T.push(j),T.sort(R))}return T.length===1?T[0]:new r(T)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let T of this.expr)h.push(...T.keys());return h}map(h){return new r(this.expr.map(T=>T.map(h)))}negate(){let h=[];for(let T of this.expr)h.push(T.negate());return c.create(h)}}e.ContextKeyAndExpr=r;class c{constructor(h){this.expr=h,this.type=9}static create(h){const T=c._normalizeArr(h);if(T.length!==0)return T.length===1?T[0]:new c(T)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let T=0,L=this.expr.length;T<L;T++){const W=R(this.expr[T],h.expr[T]);if(W!==0)return W}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let T=0,L=this.expr.length;T<L;T++)if(!this.expr[T].equals(h.expr[T]))return!1;return!0}return!1}evaluate(h){for(let T=0,L=this.expr.length;T<L;T++)if(this.expr[T].evaluate(h))return!0;return!1}static _normalizeArr(h){let T=[],L=!1;if(h){for(let W=0,ee=h.length;W<ee;W++){const j=h[W];if(!!j){if(j.type===0){L=!0;continue}if(j.type===1)return[g.INSTANCE];if(j.type===9){T=T.concat(j.expr);continue}T.push(j)}}if(T.length===0&&L)return[C.INSTANCE];T.sort(R)}return T}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let T of this.expr)h.push(...T.keys());return h}map(h){return new c(this.expr.map(T=>T.map(h)))}negate(){let h=[];for(let L of this.expr)h.push(L.negate());const T=L=>L.type===9?L.expr:[L];for(;h.length>1;){const L=h.shift(),W=h.shift(),ee=[];for(const j of T(L))for(const x of T(W))ee.push(n.and(j,x));h.unshift(n.or(...ee))}return h[0]}}e.ContextKeyOrExpr=c;class o extends m{constructor(h,T,L){super(h);this._defaultValue=T,typeof L=="object"?o._info.push(Object.assign(Object.assign({},L),{key:h})):L!==!0&&o._info.push({key:h,description:L,type:T!=null?typeof T:void 0})}static all(){return o._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(h){return n.equals(this.key,h)}notEqualsTo(h){return n.notEquals(this.key,h)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(f,h){return f<h?-1:f>h?1:0}function E(f,h,T,L){return f<T?-1:f>T?1:h<L?-1:h>L?1:0}}),define(me[181],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(me[182],ge([0,1,152,4,11]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function I(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=I;var D;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var k;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var y;(function(C){C.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var n;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(n=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(g,m){super(g);this.code=m}}e.ExtensionManagementError=R,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(me[29],ge([0,1,10,4]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class D{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,C){if(typeof R=="undefined"||R===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof R=="string"||typeof C=="string"){let g=typeof R=="string"?R:R.value,m=typeof C=="string"?C:C.value;return _.equalsIgnoreCase(g,m)}return R._lower===C._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}e.ExtensionIdentifier=D;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[183],ge([0,1,10,29]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(m,s){return m.uuid&&s.uuid?m.uuid===s.uuid:m.id===s.id?!0:(0,_.compareIgnoreCase)(m.id,s.id)===0}e.areSameExtensions=A;class I{constructor(s,d){this.version=d,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof I?A(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=I;function D(m,s){return`${m}.${s}`}e.getExtensionId=D;function k(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function y(m,s){return k(D(m,s))}e.getGalleryExtensionId=y;function n(m,s){const d=[],S=w=>{for(const b of d)if(b.some(v=>A(s(v),s(w))))return b;return null};for(const w of m){const b=S(w);b?b.push(w):d.push([w])}return d}e.groupByExtension=n;function R(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function g(m){const s=new Set;for(const d of m)d.malicious&&s.add(d.id.id);return s}e.getMaliciousExtensionsSet=g}),define(me[45],ge([0,1,154,8,2,4,10,15,24]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function n(j){return j.create===!0}e.isFileOpenForWriteOptions=n;var R;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=g;function m(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=m;function s(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function d(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=d;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(x,$){super(x);this.code=$}}e.FileSystemProviderError=w;function b(j,x){const $=new w(j.toString(),x);return u($,x),$}e.createFileSystemProviderError=b;function v(j){return j||b((0,_.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=v;function u(j,x){return j.name=x?`${x} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=u;function l(j){if(!j)return S.Unknown;if(j instanceof w)return j.code;const x=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!x)return S.Unknown;switch(x[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=l;function t(j){if(j instanceof p)return j.fileOperationResult;switch(l(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(x,$,F){this.resource=x,this.operation=$,this.target=F}isOperation(x){return this.operation===x}}e.FileOperationEvent=a;var r;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class c{constructor(x,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const F of x)switch(F.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(F.resource,F);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(F.resource,F);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(F.resource,F);break}}contains(x,...$){return this.doContains(x,{includeChildren:!1},...$)}affects(x,...$){return this.doContains(x,{includeChildren:!0},...$)}doContains(x,$,...F){var U,M,N,O,V,q;if(!x)return!1;const X=F.length>0;return!!((!X||F.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(x))||$.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(x)))||(!X||F.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(x))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(x)))||(!X||F.includes(2))&&(((V=this.deleted)===null||V===void 0?void 0:V.findSubstr(x))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const $=[],F=x===1?this.added:x===0?this.updated:this.deleted;if(F)for(const[,U]of F)$.push(U);return $}filter(x){return new c(this.changes.filter($=>x($)),this.ignorePathCasing)}}e.FileChangesEvent=c;function o(j,x,$){return!j||!x||j===x||x.length>j.length?!1:(x.charAt(x.length-1)!==P.sep&&(x+=P.sep),$?(0,D.startsWithIgnoreCase)(j,x):j.indexOf(x)===0)}e.isParent=o;class p extends Error{constructor(x,$,F){super(x);this.fileOperationResult=$,this.options=F}static isFileOperationError(x){return x instanceof Error&&!(0,k.isUndefinedOrNull)(x.fileOperationResult)}}e.FileOperationError=p;var E;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var f;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(f=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function h(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=h;async function T(j,x){if(!x.canHandleResource(A.URI.from({scheme:j.scheme})))return new Promise($=>{const F=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===j.scheme&&U.added&&(F.dispose(),$())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(x){return(0,k.isNumber)(x)||(x=0),x<L.KB?(0,_.localize)(1,null,x.toFixed(0)):x<L.MB?(0,_.localize)(2,null,(x/L.KB).toFixed(2)):x<L.GB?(0,_.localize)(3,null,(x/L.MB).toFixed(2)):x<L.TB?(0,_.localize)(4,null,(x/L.GB).toFixed(2)):(0,_.localize)(5,null,(x/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var W;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function ee(j){return{maxFileSize:j===0?300*L.MB:16*L.GB,maxHeapSize:j===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ee}),define(me[82],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...A){this._entries=new Map;for(let[I,D]of A)this.set(I,D)}set(A,I){const D=this._entries.get(A);return this._entries.set(A,I),D}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=_}),define(me[184],ge([0,1,18,177,109,4,82,19]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(s){var d;super("cyclic dependency between services");this.message=(d=s.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class R{constructor(s=new D.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=s,this._strict=d,this._parent=S,this._services.set(I.IInstantiationService,this)}createChild(s){return new R(s,this._strict,this)}invokeFunction(s,...d){let S=g.traceInvocation(s),w=!1;try{return s({get:(v,u)=>{if(w)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(v,S);if(!l&&u!==I.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return l}},...d)}finally{w=!0,S.stop()}}createInstance(s,...d){let S,w;return s instanceof A.SyncDescriptor?(S=g.traceCreation(s.ctor),w=this._createInstance(s.ctor,s.staticArguments.concat(d),S)):(S=g.traceCreation(s),w=this._createInstance(s,d,S)),S.stop(),w}_createInstance(s,d=[],S){let w=I._util.getServiceDependencies(s).sort((u,l)=>u.index-l.index),b=[];for(const u of w){let l=this._getOrCreateServiceInstance(u.id,S);if(!l&&this._strict&&!u.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${u.id}.`);b.push(l)}let v=w.length>0?w[0].index:d.length;if(d.length!==v){console.warn(`[createInstance] First service dependency of ${s.name} at position ${v+1} conflicts with ${d.length} static arguments`);let u=v-d.length;u>0?d=d.concat(new Array(u)):d=d.slice(0,v)}return new s(...[...d,...b])}_setServiceInstance(s,d){if(this._services.get(s)instanceof A.SyncDescriptor)this._services.set(s,d);else if(this._parent)this._parent._setServiceInstance(s,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let d=this._services.get(s);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):d}_getOrCreateServiceInstance(s,d){let S=this._getServiceInstanceOrDescriptor(s);return S instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,S,d.branch(s,!0)):(d.branch(s,!1),S)}_safeCreateAndCacheServiceInstance(s,d,S){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,d,S)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,d,S){const w=new P.Graph(u=>u.id.toString());let b=0;const v=[{id:s,desc:d,_trace:S}];for(;v.length;){const u=v.pop();if(w.lookupOrInsertNode(u),b++>1e3)throw new n(w);for(let l of I._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${s} depends on ${l.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:l.id,desc:t,_trace:u._trace.branch(l.id,!0)};w.insertEdge(u,i),v.push(i)}}}for(;;){const u=w.roots();if(u.length===0){if(!w.isEmpty())throw new n(w);break}for(const{data:l}of u){if(this._getServiceInstanceOrDescriptor(l.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,i)}w.removeNode(l)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,d,S=[],w,b){if(this._services.get(s)instanceof A.SyncDescriptor)return this._createServiceInstance(d,S,w,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,d,S,w,b);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(s,d=[],S,w){if(S){const b=new k.IdleValue(()=>this._createInstance(s,d,w));return new Proxy(Object.create(null),{get(v,u){if(u in v)return v[u];let l=b.value,t=l[u];return typeof t!="function"||(t=t.bind(l),v[u]=t),t},set(v,u,l){return b.value[u]=l,!0}})}else return this._createInstance(s,d,w)}}e.InstantiationService=R;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class g{constructor(s,d){this.type=s,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new g(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(s){return y?new g(0,s.name):g._None}branch(s,d){let S=new g(2,s.toString());return this._dep.push([s,d,S]),S}stop(){let s=Date.now()-this._start;g._totals+=s;let d=!1;function S(b,v){let u=[],l=new Array(b+1).join("	");for(const[t,i,a]of v._dep)if(i&&a){d=!0,u.push(`${l}CREATES -> ${t}`);let r=S(b+1,a);r&&u.push(r)}else u.push(`${l}uses -> ${t}`);return u.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(s>2||d)&&console.log(w.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(me[12],ge([0,1,4,6,9,3,58]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function k(){return new Date().toISOString()}var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class R extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(y.Error,this.format(a))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let a=0;a<t.length;a++){let r=t[a];if(typeof r=="object")try{r=JSON.stringify(r)}catch(c){}i+=(a>0?" ":"")+r}return i}}e.AbstractMessageLogger=R;class C extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...i):console.log(`[main ${k()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...i):console.log(`[main ${k()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...i):console.log(`[main ${k()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...i):console.warn(`[main ${k()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...i):console.error(`[main ${k()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...i):console.error(`[main ${k()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends n{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class s extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const a of this.logServices)a.trace(t,...i)}debug(t,...i){for(const a of this.logServices)a.debug(t,...i)}info(t,...i){for(const a of this.logServices)a.info(t,...i)}warn(t,...i){for(const a of this.logServices)a.warn(t,...i)}error(t,...i){for(const a of this.logServices)a.error(t,...i)}critical(t,...i){for(const a of this.logServices)a.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=s;class d extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=d;class S extends P.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}createLogger(t,i){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),a),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=w;function b(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const t=v(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function v(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function u(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=u}),define(me[110],ge([0,1,12,45]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(y,n,R,C){try{const g=await new Promise((m,s)=>{G(["spdlog"],m,s)});return g.setAsyncMode(8192,500),g.createRotatingLoggerAsync(y,n,R,C)}catch(g){console.error(g)}return null}function I(y,n,R,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(y,n,R,C)}e.createRotatingLogger=I;function D(y,n,R){switch(n){case _.LogLevel.Trace:y.trace(R);break;case _.LogLevel.Debug:y.debug(R);break;case _.LogLevel.Info:y.info(R);break;case _.LogLevel.Warning:y.warn(R);break;case _.LogLevel.Error:y.error(R);break;case _.LogLevel.Critical:y.critical(R);break;default:throw new Error("Invalid log level")}}class k extends _.AbstractMessageLogger{constructor(n,R,C,g){super();this.name=n,this.filepath=R,this.rotating=C,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const n=this.rotating?6:1,R=30/n*P.ByteSize.MB;return A(this.name,this.filepath,R,n).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:g,message:m}of this.buffer)D(this._logger,g,m);this.buffer=[]}})}log(n,R){this._logger?D(this._logger,n,R):this.getLevel()<=n&&this.buffer.push({level:n,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(me[111],ge([0,1,4,155,56]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(s,d){return d-s}y.compare=n;const R=Object.create(null);R[y.Error]=(0,P.localize)(0,null),R[y.Warning]=(0,P.localize)(1,null),R[y.Info]=(0,P.localize)(2,null);function C(s){return R[s]||""}y.toString=C;function g(s){switch(s){case A.default.Error:return y.Error;case A.default.Warning:return y.Warning;case A.default.Info:return y.Info;case A.default.Ignore:return y.Hint}}y.fromSeverity=g;function m(s){switch(s){case y.Error:return A.default.Error;case y.Warning:return A.default.Warning;case y.Info:return A.default.Info;case y.Hint:return A.default.Ignore}}y.toSeverity=m}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(y){const n="";function R(g){return C(g,!0)}y.makeKey=R;function C(g,m){let s=[n];return g.source?s.push(g.source.replace("\xA6","\\\xA6")):s.push(n),g.code?typeof g.code=="string"?s.push(g.code.replace("\xA6","\\\xA6")):s.push(g.code.value.replace("\xA6","\\\xA6")):s.push(n),g.severity!==void 0&&g.severity!==null?s.push(D.toString(g.severity)):s.push(n),g.message&&m?s.push(g.message.replace("\xA6","\\\xA6")):s.push(n),g.startLineNumber!==void 0&&g.startLineNumber!==null?s.push(g.startLineNumber.toString()):s.push(n),g.startColumn!==void 0&&g.startColumn!==null?s.push(g.startColumn.toString()):s.push(n),g.endLineNumber!==void 0&&g.endLineNumber!==null?s.push(g.endLineNumber.toString()):s.push(n),g.endColumn!==void 0&&g.endColumn!==null?s.push(g.endColumn.toString()):s.push(n),s.push(n),s.join("\xA6")}y.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(me[185],ge([0,1,56,4,3]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,P.createDecorator)("notificationService");var I;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new y,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class y{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=y}),define(me[186],ge([0,1,11,9,36,25]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof P.globals.vscode!="undefined"){const k=P.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const k=(0,I.dirname)(_.FileAccess.asFileUri("",G));D=G.__$__nodeRequire((0,I.joinPath)(k,"product.json").fsPath);const y=G.__$__nodeRequire((0,I.joinPath)(k,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.56.0-dev",nameShort:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=D});var je=this&&this.__decorate||function(G,e,_,P){var A=arguments.length,I=A<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,_):P,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(G,e,_,P);else for(var k=G.length-1;k>=0;k--)(D=G[k])&&(I=(A<3?D(I):A>3?D(e,_,I):D(e,_))||I);return A>3&&I&&Object.defineProperty(e,_,I),I},xe=this&&this.__param||function(G,e){return function(_,P){e(_,P,G)}};define(me[112],ge([0,1,4,21,6,19]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let y=class extends A.Disposable{constructor(C,g){super();this.deferred=new I.DeferredPromise,g.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([xe(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends A.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(C){this.stop();const g=++this.currentOperationId,m=new P.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:m.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,15,52]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(D,k){P.ok(_.isString(D)),P.ok(_.isObject(k)),P.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,k)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new A}),define(me[113],ge([0,1,40,3]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class I{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[A(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new I;_.Registry.add(e.Extensions.JSONContribution,D)}),define(me[83],ge([0,1,151,3,40,15,113]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=A.Registry.as(D.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,b=!0){this.registerConfigurations([w],b)}registerConfigurations(w,b=!0){const v=[];w.forEach(u=>{v.push(...this.validateAndRegisterProperties(u,b,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(w){const b=[],v=u=>{if(u.properties)for(const l in u.properties)b.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,u.properties[l]);u.allOf&&u.allOf.forEach(l=>v(l))};for(const u of w){v(u);const l=this.configurationContributors.indexOf(u);l!==-1&&this.configurationContributors.splice(l,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(w){const b=[],v=[];for(const u of w)for(const l in u)if(b.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),u[l]);const t={type:"object",default:this.defaultValues[l],description:_.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};v.push(C(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=u[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(w){const b=[];for(const v of w)for(const u in v)if(b.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const l=this.configurationProperties[u];l&&(this.updatePropertyDefaultValue(u,l),this.updateSchema(u,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const b of w)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,b=!0,v,u=3){var l;u=I.isUndefinedOrNull(w.scope)?u:w.scope;let t=[],i=w.properties;if(i)for(let r in i){if(b&&s(r)){delete i[r];continue}const c=i[r];if(this.updatePropertyDefaultValue(r,c),e.OVERRIDE_PROPERTY_PATTERN.test(r)?c.scope=void 0:(c.scope=I.isUndefinedOrNull(c.scope)?u:c.scope,c.requireTrust=I.isUndefinedOrNull(c.requireTrust)?!!((l=v==null?void 0:v.requireTrustForConfigurations)===null||l===void 0?void 0:l.includes(r)):c.requireTrust),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),t.push(r)}let a=w.allOf;if(a)for(let r of a)t.push(...this.validateAndRegisterProperties(r,b,v,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const b=v=>{let u=v.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let l=v.allOf;l&&l.forEach(b)};b(w)}updateSchema(w,b){switch(e.allSettings.properties[w]=b,b.scope){case 1:e.applicationSettings.properties[w]=b;break;case 2:e.machineSettings.properties[w]=b;break;case 6:e.machineOverridableSettings.properties[w]=b;break;case 3:e.windowSettings.properties[w]=b;break;case 4:e.resourceSettings.properties[w]=b;break;case 5:e.resourceSettings.properties[w]=b,this.resourceLanguageSettingsSchema.properties[w]=b;break}}removeFromSchema(w,b){switch(delete e.allSettings.properties[w],b.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const b=`[${w}]`,v={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,v),e.allSettings.properties[b]=v,e.applicationSettings.properties[b]=v,e.machineSettings.properties[b]=v,e.machineOverridableSettings.properties[b]=v,e.windowSettings.properties[b]=v,e.resourceSettings.properties[b]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,b){let v=this.defaultValues[w];I.isUndefined(v)&&(v=b.default),I.isUndefined(v)&&(v=g(b.type)),b.default=v}}const R="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function C(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=C;function g(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new n;A.Registry.add(e.Extensions.Configuration,m);function s(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?_.localize(5,null,S):m.getConfigurationProperties()[S]!==void 0?_.localize(6,null,S):null:_.localize(4,null)}e.validateProperty=s;function d(){const S=[],w=m.getConfigurationProperties();for(const b of Object.keys(w))S.push([b,w[b].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=d}),define(me[84],ge([0,1,23,15,2,40,4,83]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=R;function C(i,a){const r=a?i?a.keys.filter(T=>i.keys.indexOf(T)===-1):[...a.keys]:[],c=i?a?i.keys.filter(T=>a.keys.indexOf(T)===-1):[...i.keys]:[],o=[];if(a&&i){for(const T of i.keys)if(a.keys.indexOf(T)!==-1){const L=w(i.contents,T),W=w(a.contents,T);_.equals(L,W)||o.push(T)}}const p=[],E=T=>{const L={};for(const W of T)for(const ee of W.identifiers)L[l(ee)]=W;return L},f=a?E(a.overrides):{},h=i?E(i.overrides):{};if(Object.keys(f).length)for(const T of r){const L=f[T];L&&p.push([(0,k.overrideIdentifierFromKey)(T),L.keys])}if(Object.keys(h).length)for(const T of c){const L=h[T];L&&p.push([(0,k.overrideIdentifierFromKey)(T),L.keys])}if(Object.keys(f).length&&Object.keys(h).length)for(const T of o){const L=h[T],W=f[T];if(L&&W){const ee=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});p.push([(0,k.overrideIdentifierFromKey)(T),[...ee.added,...ee.removed,...ee.updated]])}}return{added:r,removed:c,updated:o,overrides:p}}e.compare=C;function g(i,a){const r=[];for(const c of Object.keys(i))if(k.OVERRIDE_PROPERTY_PATTERN.test(c)){const o={};for(const p in i[c])o[p]=i[c][p];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(o),contents:m(o,a)})}return r}e.toOverrides=g;function m(i,a){const r=Object.create(null);for(let c in i)s(r,c,i[c],a);return r}e.toValuesTree=m;function s(i,a,r,c){const o=a.split("."),p=o.pop();let E=i;for(let f=0;f<o.length;f++){let h=o[f],T=E[h];switch(typeof T){case"undefined":T=E[h]=Object.create(null);break;case"object":break;default:c(`Ignoring ${a} as ${o.slice(0,f+1).join(".")} is ${JSON.stringify(T)}`);return}E=T}if(typeof E=="object"&&E!==null)try{E[p]=r}catch(f){c(`Ignoring ${a} as ${o.join(".")} is ${JSON.stringify(E)}`)}else c(`Ignoring ${a} as ${o.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=s;function d(i,a){const r=a.split(".");S(i,r)}e.removeFromValueTree=d;function S(i,a){const r=a.shift();if(a.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const c=i[r];typeof c=="object"&&!Array.isArray(c)&&(S(c,a),Object.keys(c).length===0&&delete i[r])}}function w(i,a,r){function c(E,f){let h=E;for(const T of f){if(typeof h!="object"||h===null)return;h=h[T]}return h}const o=a.split("."),p=c(i,o);return typeof p=="undefined"?r:p}e.getConfigurationValue=w;function b(i,a,r){Object.keys(a).forEach(c=>{c!=="__proto__"&&(c in i?P.isObject(i[c])&&P.isObject(a[c])?b(i[c],a[c],r):r&&(i[c]=a[c]):i[c]=a[c])})}e.merge=b;function v(){const i=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=v;function u(){const i=Object.create(null),a=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in a){let c=a[r].default;s(i,r,c,o=>console.error(`Conflict in default settings: ${o}`))}return i}e.getDefaultValues=u;function l(i){return`[${i}]`}e.keyFromOverrideIdentifier=l;function t(i,a,r){const c=i.inspect(a),o=i.inspect(r);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:c.defaultValue}e.getMigratedSettingValue=t}),define(me[187],ge([0,1,54,24,14,15,23,2,83,84,40,6,3]),function(G,e,_,P,A,I,D,k,y,n,R,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},i=[],a=[]){this._contents=t,this._keys=i,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const a=this.getContentsForOverrideIdentifer(i);return a?t?(0,n.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let a={};for(const r of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[r],o=i[r];o&&(typeof c=="object"&&typeof o=="object"?(c=D.deepClone(c),this.mergeContents(c,o)):c=o),a[r]=c}return new m(a,this.keys,this.overrides)}merge(...t){const i=D.deepClone(this.contents),a=D.deepClone(this.overrides),r=[...this.keys];for(const c of t){this.mergeContents(i,c.contents);for(const o of c.overrides){const[p]=a.filter(E=>A.equals(E.identifiers,o.identifiers));p?this.mergeContents(p.contents,o.contents):a.push(D.deepClone(o))}for(const o of c.keys)r.indexOf(o)===-1&&r.push(o)}return new m(i,r,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const a of Object.keys(i)){if(a in t&&I.isObject(t[a])&&I.isObject(i[a])){this.mergeContents(t[a],i[a]);continue}t[a]=D.deepClone(i[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let a=0;a<i;a++)t.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class s extends m{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),a=[];for(const r of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(r)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,i,a)}}e.DefaultConfigurationModel=s;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!I.isUndefinedOrNull(t)){const a=this.doParseContent(t);this.parseRaw(a,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:a,keys:r,overrides:c,untrusted:o}=this.doParseRaw(t,i);this._configurationModel=new m(a,r,c),this._untrustedConfigurations=o||[]}doParseContent(t){let i={},a=null,r=[],c=[],o=[];function p(f){Array.isArray(r)?r.push(f):a&&(r[a]=f)}let E={onObjectBegin:()=>{let f={};p(f),c.push(r),r=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{let f=[];p(f),c.push(r),r=f,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:p,onError:(f,h,T)=>{o.push({error:f,offset:h,length:T})}};if(t)try{_.visit(t,E),i=r[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return i}doParseRaw(t,i){const a=R.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,a,!0,i);t=r.raw;const c=(0,n.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),o=Object.keys(t),p=(0,n.toOverrides)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:c,keys:o,overrides:p,untrusted:r.untrusted}}filter(t,i,a,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const c={},o=[];for(let p in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(p)&&a){const E=this.filter(t[p],i,!1,r);c[p]=E.raw,o.push(...E.untrusted)}else{const E=i[p],f=E?typeof E.scope!="undefined"?E.scope:3:void 0;(f===void 0||r.scopes===void 0||r.scopes.includes(f))&&(r.isUntrusted&&(E==null?void 0:E.requireTrust)?o.push(p):c[p]=t[p])}return{raw:c,untrusted:o}}}e.ConfigurationModelParser=d;class S extends C.Disposable{constructor(t,i,a,r){super();this.userSettingsResource=t,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=S;class w{constructor(t,i,a=new m,r=new m,c=new P.ResourceMap,o=new m,p=new P.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=c,this._memoryConfiguration=o,this._memoryConfigurationByResource=p,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,i,a){return this.getConsolidateConfigurationModel(i,a).getValue(t)}updateValue(t,i,a={}){let r;a.resource?(r=this._memoryConfigurationByResource.get(a.resource),r||(r=new m,this._memoryConfigurationByResource.set(a.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(t):r.setValue(t,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,a){const r=this.getConsolidateConfigurationModel(i,a),c=this.getFolderConfigurationModelForResource(i.resource,a),o=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),f=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,W=i.overrideIdentifier?o.override(i.overrideIdentifier).getValue(t):o.getValue(t),ee=r.getValue(t),j=A.distinct(A.flatten(r.overrides.map(x=>x.identifiers))).filter(x=>r.getOverrideValue(t,x)!==void 0);return{defaultValue:p,userValue:E,userLocalValue:f,userRemoteValue:h,workspaceValue:T,workspaceFolderValue:L,memoryValue:W,value:ee,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:i.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:o.getValue(t),override:i.overrideIdentifier?o.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const a=i.filter(r=>y.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const c=(0,y.overrideIdentifierFromKey)(r),o=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=t.getKeysForOverrideIdentifier(c),E=[...p.filter(f=>o.indexOf(f)===-1),...o.filter(f=>p.indexOf(f)===-1),...o.filter(f=>!D.equals(this._defaultConfiguration.override(c).getValue(f),t.override(c).getValue(f)))];return[c,E]});return this.updateDefaultConfiguration(t),{keys:i,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:a,removed:r,overrides:c}=(0,n.compare)(this.localUserConfiguration,t),o=[...i,...a,...r];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:a,removed:r,overrides:c}=(0,n.compare)(this.remoteUserConfiguration,t);let o=[...i,...a,...r];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:a,removed:r,overrides:c}=(0,n.compare)(this.workspaceConfiguration,t);let o=[...i,...a,...r];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const a=this.folderConfigurations.get(t),{added:r,updated:c,removed:o,overrides:p}=(0,n.compare)(a,i);let E=[...r,...c,...o];return(E.length||!a)&&this.updateFolderConfiguration(t,i),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:r,removed:c,overrides:o}=(0,n.compare)(i,void 0);return{keys:[...a,...r,...c],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let a=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const r=i.getFolder(t);r&&(a=this.getFolderConsolidatedConfiguration(r.uri)||a);const c=this._memoryConfigurationByResource.get(t);c&&(a=a.merge(c))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(i=a.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=a}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const a=i.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:a,overrides:r,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:a,overrides:r,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((o,p)=>(o.set(k.URI.revive(p[0]),this.parseConfigurationModel(p[1])),o),new P.ResourceMap);return new w(i,a,new m,r,c,new m,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,i=new Map;for(const r of l)r.keys.forEach(c=>t.add(c)),r.overrides.forEach(([c,o])=>{const p=(0,P.getOrSet)(i,c,new Set);o.forEach(E=>p.add(E))});const a=[];return i.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=b;class v{constructor(t,i,a,r){this.change=t,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=r,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(p=>c.add(p)),t.overrides.forEach(([,p])=>p.forEach(E=>c.add(E))),this.affectedKeys=[...c.values()];const o=new m;this.affectedKeys.forEach(p=>o.setValue(p,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,c=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!D.equals(r,c)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let a=(0,n.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(t=t[r],!t)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=v;class u extends v{constructor(t,i,a,r){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=a,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(me[114],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(D,k=P.Unknown,y){super(D);this._message=D,this._code=k,this._detail=y,this.isHandled=k===P.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(D){return D instanceof A&&D._code===P.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof A&&D._code===P.NoResolverFound}static isHandled(D){return D instanceof A&&D.isHandled}}e.RemoteAuthorityResolverError=A}),define(me[115],ge([0,1,11]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function P(y){return y.scheme===_.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=P;function A(y){if(!!y){const n=y.indexOf("+");return n<0?y:y.substr(0,n)}}e.getRemoteName=A;function I(y){return y.scheme!==_.Schemas.file&&y.scheme!==_.Schemas.vscodeRemote}function D(y){if(y.folders.length)return y.folders.every(n=>I(n.uri))?y.folders[0].uri:void 0;if(y.configuration&&I(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=D;function k(y){var n;return(n=D(y))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=k}),define(me[188],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((A,I)=>G(["vsda"],A,I))}async sign(A){try{const I=await this.vsda(),D=new I.signer;if(D)return D.sign(A)}catch(I){}return A}}e.SignService=_}),define(me[189],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,I,D=5){let k;return k=I(y=>{const n=typeof y=="string"?y:y.data;let R=this._terminalBufferMap.get(A);if(R){R.data.push(n);return}const C=setTimeout(()=>this.flushBuffer(A),D);R={data:[n],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(A),k.dispose()}},this._terminalBufferMap.set(A,R)}),k}stopBuffering(A){const I=this._terminalBufferMap.get(A);I&&I.dispose()}flushBuffer(A){const I=this._terminalBufferMap.get(A);I&&(this._terminalBufferMap.delete(A),this._callback(A,I.data.join("")))}}e.TerminalDataBufferer=_}),define(me[190],ge([0,1,48,8,36,26,15,23,9]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function n(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=n;async function R(C,g,m,s=A.env,d=I.exists){if(P.isAbsolute(C))return await d(C)?C:void 0;if(g===void 0&&(g=A.cwd()),P.dirname(C)!=="."){const v=P.join(g,C);return await d(v)?v:void 0}const w=(0,k.getCaseInsensitive)(s,"PATH");if(m===void 0&&(0,D.isString)(w)&&(m=w.split(P.delimiter)),m===void 0||m.length===0){const v=P.join(g,C);return await d(v)?v:void 0}for(let v of m){let u;if(P.isAbsolute(v)?u=P.join(v,C):u=P.join(g,v,C),await d(u))return u;if(y.isWindows){let l=u+".com";if(await d(l)||(l=u+".exe",await d(l)))return l}}const b=P.join(g,C);return await d(b)?b:void 0}e.findExecutable=R}),define(me[191],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(me[192],ge([0,1,4,6,40,3,191,43]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var y;(function(S){function w(b){return b&&typeof b=="object"&&typeof b.id=="string"}S.isThemeColor=w})(y=e.ThemeColor||(e.ThemeColor={}));function n(S){return{id:S}}e.themeColorFromId=n;var R;(function(S){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=w;const b=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function v(t){const i=b.exec(t);if(!!i){let[,a]=i;return{id:a}}}S.fromString=v;function u(t,i){let a=t.id;const r=a.lastIndexOf("~");return r!==-1&&(a=a.substring(0,r)),i&&(a=`${a}~${i}`),{id:a}}S.modify=u;function l(t,i){var a,r;return t.id===i.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((r=i.color)===null||r===void 0?void 0:r.id)}S.isEqual=l,S.asClassNameArray=k.CSSIcon.asClassNameArray,S.asClassName=k.CSSIcon.asClassName,S.asCSSSelector=k.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,P.toDisposable)(()=>{const b=this.themingParticipants.indexOf(w);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new g;A.Registry.add(e.Extensions.ThemingContribution,m);function s(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=s;class d extends P.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,b){let v=this.theme.getColor(w);return v&&b&&(v=b(v,this.theme)),v?v.toString():null}}e.Themable=d}),define(me[193],ge([0,1,40,192,3,156,113,19,43]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,b,v,u){const l=this.iconsById[w];if(l){if(v&&!l.description){l.description=v,this.iconSchema.properties[w].markdownDescription=`${v} $(${w})`;const a=this.iconReferenceSchema.enum.indexOf(w);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=v),this._onDidChange.fire()}return l}let t={id:w,description:v,defaults:b,deprecationMessage:u};this.iconsById[w]=t;let i={$ref:"#/definitions/icons"};return u&&(i.deprecationMessage=u),v&&(i.markdownDescription=`${v}: $(${w})`),this.iconSchema.properties[w]=i,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const b=this.iconReferenceSchema.enum.indexOf(w);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,b){const v=this.iconFontsById[w];if(v)return v;let u={id:w,definition:b};return this.iconFontsById[w]=u,this._onDidChange.fire(),u}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(l,t)=>l.id.localeCompare(t.id),b=l=>{for(;P.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`};let v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of u.filter(t=>!!t.description).sort(w))v.push(`|<i class="${b(l)}"></i>|${l.id}|${P.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const l of u.filter(t=>!P.ThemeIcon.isThemeIcon(t.defaults)).sort(w))v.push(`|<i class="${b(l)}"></i>|${l.id}|`);return v.join(`
`)}}const R=new n;_.Registry.add(e.Extensions.IconContribution,R);function C(S,w,b,v){return R.registerIcon(S,w,b,v)}e.registerIcon=C;function g(){return R}e.getIconRegistry=g;function m(){for(const S of y.iconRegistry.all)R.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>R.registerIcon(S.id,S.definition,S.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let s=_.Registry.as(D.Extensions.JSONContribution);s.registerSchema(e.iconsSchemaId,R.getIconSchema());const d=new k.RunOnceScheduler(()=>s.notifySchemaChanged(e.iconsSchemaId),200);R.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=P.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(me[59],ge([0,1,2,25,4,24]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var D;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function k(g){const m=g;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=k;function y(g){const m=g;return!!(m&&typeof m=="object"&&_.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(m,s,d,S){this._id=m,this._configuration=d,this._ignorePathCasing=S,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class R{constructor(m,s){this.raw=s,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,P.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function C(g){return new R({uri:g,index:0,name:(0,P.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=C}),define(me[116],ge([0,1,4,157,59,2,9,8,25,132,54,11,76,30,115]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?(0,k.extname)($):(0,y.extname)($))===d}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function b($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=b;function v($){return $.hasOwnProperty("fileUri")}e.isRecentFile=v;function u($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.uri)}e.isSingleFolderWorkspaceIdentifier=u;function l($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=l;function t($){const F=$;return typeof(F==null?void 0:F.id)=="string"&&I.URI.isUri(F.configPath)}e.isWorkspaceIdentifier=t;function i($){const F=$;if(F==null?void 0:F.uri)return{id:F.id,uri:I.URI.revive(F.uri)};const U=$;if(U==null?void 0:U.configPath)return{id:U.id,configPath:I.URI.revive(U.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=i;function a($,F){return y.extUriBiasedIgnorePathCase.isEqualOrParent($,F.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function r($){return c($)||o($)}e.isStoredWorkspaceFolder=r;function c($){const F=$;return typeof(F==null?void 0:F.path)=="string"&&(!F.name||typeof F.name=="string")}e.isRawFileWorkspaceFolder=c;function o($){const F=$;return typeof(F==null?void 0:F.uri)=="string"&&(!F.name||typeof F.name=="string")}e.isRawUriWorkspaceFolder=o;function p($,F,U,M,N=!D.isWindows,O){if($.scheme!==M.scheme)return{name:U,uri:$.toString(!0)};let V=F?void 0:O.relativePath(M,$);if(V!==void 0)V.length===0?V=".":D.isWindows&&$.scheme===C.Schemas.file&&!N&&(V=V.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)V=$.fsPath,D.isWindows&&(V=(0,g.normalizeDriveLetter)(V),N&&(V=(0,m.toSlashes)(V)));else{if(!O.isEqualAuthority($.authority,M.authority))return{name:U,uri:$.toString(!0)};V=$.path}return{name:U,path:V}}e.getStoredWorkspaceFolder=p;function E($,F,U){let M=[],N=new Set;const O=U.dirname(F);for(let V of $){let q=null;if(c(V))V.path&&(q=U.resolvePath(O,V.path));else if(o(V))try{q=I.URI.parse(V.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(X){console.warn(X)}if(q){let X=U.getComparisonKey(q);if(!N.has(X)){N.add(X);const fe=V.name||U.basenameOrAuthority(q);M.push(new A.WorkspaceFolder({uri:q,name:fe,index:M.length},V))}}}return M}e.toWorkspaceFolders=E;function f($,F,U,M,N){let O=h(F,$);const V=N.dirname(F),q=N.dirname(M),X=[],fe=T(O.folders);for(const Fe of O.folders){const z=c(Fe)?N.resolvePath(V,Fe.path):I.URI.parse(Fe.uri);let J;U?J=!1:J=!c(Fe)||(0,k.isAbsolute)(Fe.path),X.push(p(z,J,Fe.name,q,fe,N))}const ve={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Ae=n.setProperty($,["folders"],X,ve);let Pe=n.applyEdits($,Ae);return O.remoteAuthority===(0,s.getRemoteAuthority)(M)&&(Pe=n.applyEdits(Pe,n.removeProperty(Pe,["remoteAuthority"],ve))),Pe}e.rewriteWorkspaceFileForNewLocation=f;function h($,F){let U=R.parse(F);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(M=>r(M));else throw new Error(`${$} looks like an invalid workspace file.`);return U}function T($){return D.isWindows?$.some(F=>c(F)&&F.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function W($){return typeof $.folderUri=="string"}function ee($){return typeof $.fileUri=="string"}function j($,F){const U={workspaces:[],files:[]};if($){const M=function(O,V){for(let q=0;q<O.length;q++)try{V(O[q],q)}catch(X){F.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${X.toString()}. Skip entry.`)}},N=$;if(Array.isArray(N.entries))M(N.entries,O=>{const V=O.label,q=O.remoteAuthority;L(O)?U.workspaces.push({label:V,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:I.URI.parse(O.workspace.configPath)}}):W(O)?U.workspaces.push({label:V,remoteAuthority:q,folderUri:I.URI.parse(O.folderUri)}):ee(O)&&U.files.push({label:V,remoteAuthority:q,fileUri:I.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&M(O.workspaces3,(V,q)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof V=="object"&&typeof V.id=="string"&&typeof V.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:V.id,configPath:I.URI.parse(V.configURIPath)}}):typeof V=="string"&&U.workspaces.push({label:X,folderUri:I.URI.parse(V)})}),Array.isArray(O.files2)&&M(O.files2,(V,q)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof V=="string"&&U.files.push({label:X,fileUri:I.URI.parse(V)})})}}return U}e.restoreRecentlyOpened=j;function x($){const F={entries:[]};for(const U of $.workspaces)b(U)?F.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):F.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of $.files)F.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return F}e.toStoreData=x}),define(me[85],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const I=this._idPool++;return this._data.set(I,A),this.logDebugInfo(),I}get(A,I){return this._data.has(A)?this._data.get(A)[I]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(me[194],ge([0,1,2,3]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(k=>({name:k.name,group:k.group,resource:_.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(me[60],ge([0,1,11,4]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,k){k===null?this._providerInfo.delete(D):this._providerInfo.set(D,k)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(me[195],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(I,D,k){this._id=I,this._shared=D,this._storage=k,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(I,D){let k=this._value[I];return typeof k=="undefined"&&(k=D),k}update(I,D){return this._value[I]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class P extends _{constructor(I,D){super(I.identifier.value,!0,D);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=P}),define(me[13],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class P{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=P});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[196],ge([0,1,29,3]),function(G,e,_,P){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(k,y){A.set(this,void 0),this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(k.identifier),tt(this,A,y,"f"),He(this,A,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(k){return He(this,A,"f").get(this._id,k)}store(k,y){return He(this,A,"f").store(this._id,k,y)}delete(k){return He(this,A,"f").delete(this._id,k)}}e.ExtensionSecrets=I,A=new WeakMap}),define(me[117],ge([0,1,4,3]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new P.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(me[50],ge([0,1,4,3,13]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(k){function y(R){return{remoteAddress:R.remoteAddress,localAddress:R.localAddress,public:!!R.public}}k.fromApiTunnel=y;function n(R){return{remoteAddress:{host:R.tunnelRemoteHost,port:R.tunnelRemotePort},localAddress:R.localAddress,public:R.public}}k.fromServiceTunnel=n})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new P.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,R,C,g){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([xe(0,A.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)},zt=this&&this.__rest||function(G,e){var _={};for(var P in G)Object.prototype.hasOwnProperty.call(G,P)&&e.indexOf(P)<0&&(_[P]=G[P]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,P=Object.getOwnPropertySymbols(G);A<P.length;A++)e.indexOf(P[A])<0&&Object.prototype.propertyIsEnumerable.call(G,P[A])&&(_[P[A]]=G[P[A]]);return _};define(me[7],ge([0,1,14,18,95,24,15,2,28,45,114]),function(G,e,_,P,A,I,D,k,y,n,R){"use strict";var C,g,m,s,d,S,w,b,v,u,l,t,i,a,r,c,o,p;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function E(H){function B(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf(B,H),Object.setPrototypeOf(B.prototype,H.prototype),B}let f=d=class{constructor(B){C.set(this,void 0),tt(this,C,B,"f")}static from(...B){let se=B;return new d(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}dispose(){typeof He(this,C,"f")=="function"&&(He(this,C,"f").call(this),tt(this,C,void 0,"f"))}};C=new WeakMap,f=d=je([E],f),e.Disposable=f;let h=S=class{constructor(B,se){if(B<0)throw(0,P.illegalArgument)("line must be non-negative");if(se<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=B,this._character=se}static Min(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let Se=1;Se<B.length;Se++){const Ve=B[Se];Ve.isBefore(se)&&(se=Ve)}return se}static Max(...B){if(B.length===0)throw new TypeError;let se=B[0];for(let Se=1;Se<B.length;Se++){const Ve=B[Se];Ve.isAfter(se)&&(se=Ve)}return se}static isPosition(B){if(!B)return!1;if(B instanceof S)return!0;let{line:se,character:Se}=B;return typeof se=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,se=0){if(B===null||se===null)throw(0,P.illegalArgument)();let Se;return typeof B=="undefined"?Se=0:typeof B=="number"?Se=B:(Se=typeof B.lineDelta=="number"?B.lineDelta:0,se=typeof B.characterDelta=="number"?B.characterDelta:0),Se===0&&se===0?this:new S(this.line+Se,this.character+se)}with(B,se=this.character){if(B===null||se===null)throw(0,P.illegalArgument)();let Se;return typeof B=="undefined"?Se=this.line:typeof B=="number"?Se=B:(Se=typeof B.line=="number"?B.line:this.line,se=typeof B.character=="number"?B.character:this.character),Se===this.line&&se===this.character?this:new S(Se,se)}toJSON(){return{line:this.line,character:this.character}}};h=S=je([E],h),e.Position=h;let T=w=class{constructor(B,se,Se,Ve){let et,ht;if(typeof B=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ve=="number"?(et=new h(B,se),ht=new h(Se,Ve)):B instanceof h&&se instanceof h&&(et=B,ht=se),!et||!ht)throw new Error("Invalid arguments");et.isBefore(ht)?(this._start=et,this._end=ht):(this._start=ht,this._end=et)}static isRange(B){return B instanceof w?!0:B?h.isPosition(B.start)&&h.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof w?this.contains(B._start)&&this.contains(B._end):B instanceof h?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const se=h.Max(B.start,this._start),Se=h.Min(B.end,this._end);if(!se.isAfter(Se))return new w(se,Se)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const se=h.Min(B.start,this._start),Se=h.Max(B.end,this.end);return new w(se,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,se=this.end){if(B===null||se===null)throw(0,P.illegalArgument)();let Se;return B?h.isPosition(B)?Se=B:(Se=B.start||this.start,se=B.end||this.end):Se=this.start,Se.isEqual(this._start)&&se.isEqual(this.end)?this:new w(Se,se)}toJSON(){return[this.start,this.end]}};T=w=je([E],T),e.Range=T;let L=b=class extends T{constructor(B,se,Se,Ve){let et,ht;if(typeof B=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ve=="number"?(et=new h(B,se),ht=new h(Se,Ve)):B instanceof h&&se instanceof h&&(et=B,ht=se),!et||!ht)throw new Error("Invalid arguments");super(et,ht);this._anchor=et,this._active=ht}static isSelection(B){return B instanceof b?!0:B?T.isRange(B)&&h.isPosition(B.anchor)&&h.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=b=je([E],L),e.Selection=L;class W{constructor(B,se,Se){if(typeof B!="string"||B.length===0)throw(0,P.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,P.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,P.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(se),this.connectionToken=Se}}e.ResolvedAuthority=W;class ee extends Error{constructor(B,se=R.RemoteAuthorityResolverErrorCode.Unknown,Se){super(B);this._message=B,this._code=se,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable(B,se){return new ee(B,R.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(B){return new ee(B,R.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var j;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var x;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=v=class{constructor(B,se){this._range=B,this._newText=se}static isTextEdit(B){return B instanceof v?!0:B?T.isRange(B)&&typeof B.newText=="string":!1}static replace(B,se){return new v(B,se)}static insert(B,se){return v.replace(new T(B,B),se)}static delete(B){return v.replace(B,"")}static setEndOfLine(B){const se=new v(new T(new h(0,0),new h(0,0)),"");return se.newEol=B,se}get range(){return this._range}set range(B){if(B&&!T.isRange(B))throw(0,P.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,P.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,P.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=v=je([E],$),e.TextEdit=$;var F;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellOutput=4]="CellOutput",H[H.CellReplace=5]="CellReplace",H[H.CellOutputItem=6]="CellOutputItem"})(F=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,se,Se,Ve){this._edits.push({_type:1,from:B,to:se,options:Se,metadata:Ve})}createFile(B,se,Se){this._edits.push({_type:1,from:void 0,to:B,options:se,metadata:Se})}deleteFile(B,se,Se){this._edits.push({_type:1,from:B,to:void 0,options:se,metadata:Se})}replaceNotebookMetadata(B,se,Se){this._edits.push({_type:3,metadata:Se,uri:B,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(B,se,Se,Ve,et){(se!==Se||Ve.length>0)&&this._edits.push({_type:5,uri:B,index:se,count:Se-se,cells:Ve,metadata:et})}replaceNotebookCellOutput(B,se,Se,Ve){this._editNotebookCellOutput(B,se,!1,Se,Ve)}appendNotebookCellOutput(B,se,Se,Ve){this._editNotebookCellOutput(B,se,!0,Se,Ve)}replaceNotebookCellOutputItems(B,se,Se,Ve,et){this._editNotebookCellOutputItems(B,se,Se,!1,Ve,et)}appendNotebookCellOutputItems(B,se,Se,Ve,et){this._editNotebookCellOutputItems(B,se,Se,!0,Ve,et)}_editNotebookCellOutputItems(B,se,Se,Ve,et,ht){this._edits.push({_type:6,metadata:ht,uri:B,index:se,outputId:Se,append:Ve,newOutputItems:et})}_editNotebookCellOutput(B,se,Se,Ve,et){this._edits.push({_type:4,metadata:et,uri:B,index:se,append:Se,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(B,se,Se,Ve){this._edits.push({_type:3,metadata:Ve,uri:B,edit:{editType:11,index:se,metadata:Se}})}replace(B,se,Se,Ve){this._edits.push({_type:2,uri:B,edit:new $(se,Se),metadata:Ve})}insert(B,se,Se,Ve){this.replace(B,new T(se,se),Se,Ve)}delete(B,se,Se){this.replace(B,se,"",Se)}has(B){return this._edits.some(se=>se._type===2&&se.uri.toString()===B.toString())}set(B,se){if(se)for(const Se of se)Se&&this._edits.push({_type:2,uri:B,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ve=this._edits[Se];Ve._type===2&&Ve.uri.toString()===B.toString()&&(this._edits[Se]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(B){const se=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===B.toString()&&se.push(Se.edit);return se}entries(){const B=new I.ResourceMap;for(let se of this._edits)if(se._type===2){let Se=B.get(se.uri);Se||(Se=[se.uri,[]],B.set(se.uri,Se)),Se[1].push(se.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([E],U),e.WorkspaceEdit=U;let M=u=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof u?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=u._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,se=this._tabstop++){if(typeof B=="function"){const Se=new u;Se._tabstop=this._tabstop,B(Se),this._tabstop=Se._tabstop,B=Se.value}else B=u._escape(B);return this.value+="${",this.value+=se,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,se=this._tabstop++){const Se=B.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(B,se){if(typeof se=="function"){const Se=new u;Se._tabstop=this._tabstop,se(Se),this._tabstop=Se._tabstop,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=u=je([E],M),e.SnippetString=M;var N;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let V=l=class{constructor(B,se){if(this.uri=B,se)if(se instanceof T)this.range=se;else if(se instanceof h)this.range=new T(se,se);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof l?!0:B?T.isRange(B.range)&&k.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};V=l=je([E],V),e.Location=V;let q=class{constructor(B,se){this.location=B,this.message=se}static is(B){return B?typeof B.message=="string"&&B.location&&T.isRange(B.location.range)&&k.URI.isUri(B.location.uri):!1}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.location.range.isEqual(se.location.range)&&B.location.uri.toString()===se.location.uri.toString()}};q=je([E],q),e.DiagnosticRelatedInformation=q;let X=class{constructor(B,se,Se=O.Error){if(!T.isRange(B))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=B,this.message=se,this.severity=Se}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,se){return B===se?!0:!B||!se?!1:B.message===se.message&&B.severity===se.severity&&B.code===se.code&&B.severity===se.severity&&B.source===se.source&&B.range.isEqual(se.range)&&(0,_.equals)(B.tags,se.tags)&&(0,_.equals)(B.relatedInformation,se.relatedInformation,q.isEqual)}};X=je([E],X),e.Diagnostic=X;let fe=class{constructor(B,se){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:(0,A.isMarkdownString)(B)?this.contents=[B]:this.contents=[B],this.range=se}};fe=je([E],fe),e.Hover=fe;var ve;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ae=class{constructor(B,se=ve.Text){this.range=B,this.kind=se}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Ae=je([E],Ae),e.DocumentHighlight=Ae;var Pe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(Pe=e.SymbolKind||(e.SymbolKind={}));var Fe;(function(H){H[H.Deprecated=1]="Deprecated"})(Fe=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(B,se,Se,Ve,et){this.name=B,this.kind=se,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),Ve instanceof V?this.location=Ve:Se instanceof T&&(this.location=new V(Ve,Se)),t.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Pe[this.kind],location:this.location,containerName:this.containerName}}};z=t=je([E],z),e.SymbolInformation=z;let J=i=class{constructor(B,se,Se,Ve,et){this.name=B,this.detail=se,this.kind=Se,this.range=Ve,this.selectionRange=et,this.children=[],i.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(i.validate)}};J=i=je([E],J),e.DocumentSymbol=J;var te;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(B,se){this.title=B,this.kind=se}};le=je([E],le),e.CodeAction=le;let he=a=class{constructor(B){this.value=B}append(B){return new a(this.value?this.value+a.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+a.sep)}};he.sep=".",he=a=je([E],he),e.CodeActionKind=he,he.Empty=new he(""),he.QuickFix=he.Empty.append("quickfix"),he.Refactor=he.Empty.append("refactor"),he.RefactorExtract=he.Refactor.append("extract"),he.RefactorInline=he.Refactor.append("inline"),he.RefactorRewrite=he.Refactor.append("rewrite"),he.Source=he.Empty.append("source"),he.SourceOrganizeImports=he.Source.append("organizeImports"),he.SourceFixAll=he.Source.append("fixAll");let Ce=class{constructor(B,se){if(this.range=B,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ce=je([E],Ce),e.SelectionRange=Ce;class Me{constructor(B,se,Se,Ve,et,ht){this.kind=B,this.name=se,this.detail=Se,this.uri=Ve,this.range=et,this.selectionRange=ht}}e.CallHierarchyItem=Me;class we{constructor(B,se){this.fromRanges=se,this.from=B}}e.CallHierarchyIncomingCall=we;class ke{constructor(B,se){this.fromRanges=se,this.to=B}}e.CallHierarchyOutgoingCall=ke;let Re=class{constructor(B,se){this.range=B,this.command=se}get isResolved(){return!!this.command}};Re=je([E],Re),e.CodeLens=Re;let Be=r=class{constructor(B,se=!1){g.set(this,void 0),tt(this,g,new A.MarkdownString(B,{supportThemeIcons:se}),"f")}static isMarkdownString(B){return B instanceof r?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return He(this,g,"f").value}set value(B){He(this,g,"f").value=B}get isTrusted(){return He(this,g,"f").isTrusted}set isTrusted(B){He(this,g,"f").isTrusted=B}get supportThemeIcons(){return He(this,g,"f").supportThemeIcons}appendText(B){return He(this,g,"f").appendText(B),this}appendMarkdown(B){return He(this,g,"f").appendMarkdown(B),this}appendCodeblock(B,se){return He(this,g,"f").appendCodeblock(se!=null?se:"",B),this}};g=new WeakMap,Be=r=je([E],Be),e.MarkdownString=Be;let Ee=class{constructor(B,se){this.label=B,this.documentation=se}};Ee=je([E],Ee),e.ParameterInformation=Ee;let Ge=class{constructor(B,se){this.label=B,this.documentation=se,this.parameters=[]}};Ge=je([E],Ge),e.SignatureInformation=Ge;let Q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Q=je([E],Q),e.SignatureHelp=Q;var re;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var be;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(be=e.InlineHintKind||(e.InlineHintKind={}));let Ue=class{constructor(B,se,Se){this.text=B,this.range=se,this.kind=Se}};Ue=je([E],Ue),e.InlineHint=Ue;var ze;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(H){H[H.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let K=class{constructor(B,se){this.label=B,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};K=je([E],K),e.CompletionItem=K;let oe=class{constructor(B=[],se=!1){this.items=B,this.isIncomplete=se}};oe=je([E],oe),e.CompletionList=oe;var de;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(de=e.ViewColumn||(e.ViewColumn={}));var Y;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Y=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ie;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var pe;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var We;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(We=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function B(se){switch(se){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=B}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ne=class{constructor(B,se){if(se&&!k.URI.isUri(se))throw(0,P.illegalArgument)("target");if(!T.isRange(B)||B.isEmpty)throw(0,P.illegalArgument)("range");this.range=B,this.target=se}};Ne=je([E],Ne),e.DocumentLink=Ne;let Ke=class{constructor(B,se,Se,Ve){this.red=B,this.green=se,this.blue=Se,this.alpha=Ve}};Ke=je([E],Ke),e.Color=Ke;let Xe=class{constructor(B,se){if(se&&!(se instanceof Ke))throw(0,P.illegalArgument)("color");if(!T.isRange(B)||B.isEmpty)throw(0,P.illegalArgument)("range");this.range=B,this.color=se}};Xe=je([E],Xe),e.ColorInformation=Xe;let nt=class{constructor(B){if(!B||typeof B!="string")throw(0,P.illegalArgument)("label");this.label=B}};nt=je([E],nt),e.ColorPresentation=nt;var rt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var ot;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var pt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(pt=e.TaskPanelKind||(e.TaskPanelKind={}));let qe=c=class{constructor(B,se){if(typeof B!="string"||typeof se!="string")throw(0,P.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};qe.Clean=new c("clean","Clean"),qe.Build=new c("build","Build"),qe.Rebuild=new c("rebuild","Rebuild"),qe.Test=new c("test","Test"),qe=c=je([E],qe),e.TaskGroup=qe;function _e(H){let B="";for(let se=0;se<H.length;se++)B+=H[se].replace(/,/g,",,")+",";return B}let De=class{constructor(B,se,Se){if(typeof B!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=B,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Se):this._options=se)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,P.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let se of this._args)B.push(se);return _e(B)}};De=je([E],De),e.ProcessExecution=De;let ae=class{constructor(B,se,Se){if(this._args=[],Array.isArray(se)){if(!B)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,P.illegalArgument)("command");this._command=B,this._args=se,this._options=Se}else{if(typeof B!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=B,this._options=se}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,P.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)B.push(typeof se=="string"?se:se.value);return _e(B)}};ae=je([E],ae),e.ShellExecution=ae;var Z;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Z=e.ShellQuoting||(e.ShellQuoting={}));var Oe;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Oe=e.TaskScope||(e.TaskScope={}));class Te{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=Te;let Je=o=class{constructor(B,se,Se,Ve,et,ht){this.__deprecated=!1,this._definition=this.definition=B;let gt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Se,this.execution=Ve,gt=et,this.__deprecated=!0):se===Oe.Global||se===Oe.Workspace?(this.target=se,this._name=this.name=Se,this._source=this.source=Ve,this.execution=et,gt=ht):(this.target=se,this._name=this.name=Se,this._source=this.source=Ve,this.execution=et,gt=ht),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof De?this._definition={type:o.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:o.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:o.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:o.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const se=this._definition.type;(o.EmptyType===se||o.ProcessType===se||o.ShellType===se||o.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};Je.ExtensionCallbackType="customExecution",Je.ProcessType="process",Je.ShellType="shell",Je.EmptyType="$empty",Je=o=je([E],Je),e.Task=Je;var Ye;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Ye=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(B,se=st.None){this.collapsibleState=se,k.URI.isUri(B)?this.resourceUri=B:this.label=B}};at=je([E],at),e.TreeItem=at;var st;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(st=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Qe=class{constructor(B,se){this.id=B,this.color=se}};Qe=je([E],Qe),e.ThemeIcon=Qe,Qe.File=new Qe("file"),Qe.Folder=new Qe("folder");let lt=class{constructor(B){this.id=B}};lt=je([E],lt),e.ThemeColor=lt;var bt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(bt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{constructor(B,se){if(typeof B!="string"&&(!B||!k.URI.isUri(B)&&!k.URI.isUri(B.uri)))throw(0,P.illegalArgument)("base");if(typeof se!="string")throw(0,P.illegalArgument)("pattern");typeof B=="string"?(this.baseFolder=k.URI.file(B),this.base=B):k.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=se}};ut=je([E],ut),e.RelativePattern=ut;let vt=class{constructor(B,se,Se,Ve){this.enabled=typeof B=="boolean"?B:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([E],vt),e.Breakpoint=vt;let Et=class extends vt{constructor(B,se,Se,Ve,et){super(se,Se,Ve,et);if(B===null)throw(0,P.illegalArgument)("location");this.location=B}};Et=je([E],Et),e.SourceBreakpoint=Et;let yt=class extends vt{constructor(B,se,Se,Ve,et){super(se,Se,Ve,et);this.functionName=B}};yt=je([E],yt),e.FunctionBreakpoint=yt;let _t=class extends vt{constructor(B,se,Se,Ve,et,ht,gt){super(Ve,et,ht,gt);if(!se)throw(0,P.illegalArgument)("dataId");this.label=B,this.dataId=se,this.canPersist=Se}};_t=je([E],_t),e.DataBreakpoint=_t;let Ot=class{constructor(B,se,Se){this.command=B,this.args=se||[],this.options=Se}};Ot=je([E],Ot),e.DebugAdapterExecutable=Ot;let Rt=class{constructor(B,se){this.port=B,this.host=se}};Rt=je([E],Rt),e.DebugAdapterServer=Rt;let ft=class{constructor(B){this.path=B}};ft=je([E],ft),e.DebugAdapterNamedPipeServer=ft;let Kt=class{constructor(B){this.implementation=B}};Kt=je([E],Kt),e.DebugAdapterInlineImplementation=Kt;let St=class{constructor(B,se){this.range=B,this.expression=se}};St=je([E],St),e.EvaluatableExpression=St;let Vt=class{constructor(B,se){this.range=B,this.text=se}};Vt=je([E],Vt),e.InlineValueText=Vt;let Gt=class{constructor(B,se,Se=!0){this.range=B,this.variableName=se,this.caseSensitiveLookup=Se}};Gt=je([E],Gt),e.InlineValueVariableLookup=Gt;let Nt=class{constructor(B,se){this.range=B,this.expression=se}};Nt=je([E],Nt),e.InlineValueEvaluatableExpression=Nt;let dt=class{constructor(B,se){this.frameId=B,this.stoppedLocation=se}};dt=je([E],dt),e.InlineValueContext=dt;var gn;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(gn=e.FileChangeType||(e.FileChangeType={}));let Pt=p=class extends Error{constructor(B,se=n.FileSystemProviderErrorCode.Unknown,Se){var Ve;super(k.URI.isUri(B)?B.toString(!0):B);this.code=(Ve=Se==null?void 0:Se.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(B){return new p(B,n.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(B){return new p(B,n.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(B){return new p(B,n.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(B){return new p(B,n.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(B){return new p(B,n.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(B){return new p(B,n.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};Pt=p=je([E],Pt),e.FileSystemError=Pt;let Lt=class{constructor(B,se,Se){this.start=B,this.end=se,this.kind=Se}};Lt=je([E],Lt),e.FoldingRange=Lt;var on;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(on=e.FoldingRangeKind||(e.FoldingRangeKind={}));var pn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(pn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var an;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(an=e.CommentMode||(e.CommentMode={}));class vn{constructor(B,se=[]){this.tokenTypes=B,this.tokenModifiers=se}}e.SemanticTokensLegend=vn;function ln(H){return typeof H=="undefined"||(0,D.isStringArray)(H)}class At{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let se=0,Se=B.tokenTypes.length;se<Se;se++)this._tokenTypeStrToInt.set(B.tokenTypes[se],se);for(let se=0,Se=B.tokenModifiers.length;se<Se;se++)this._tokenModifierStrToInt.set(B.tokenModifiers[se],se)}}push(B,se,Se,Ve,et){if(typeof B=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ve=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(B,se,Se,Ve,et);if(T.isRange(B)&&typeof se=="string"&&ln(Se))return this._push(B,se,Se);throw(0,P.illegalArgument)()}_push(B,se,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ve=B.start.line,et=B.start.character,ht=B.end.character-B.start.character,gt=this._tokenTypeStrToInt.get(se);let Dt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);Dt|=1<<It>>>0}this._pushEncoded(Ve,et,ht,gt,Dt)}_pushEncoded(B,se,Se,Ve,et){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let kt=0,It=0;for(let Tt=0;Tt<Dt;Tt++){let Ft=this._data[5*Tt],nn=this._data[5*Tt+1];Ft===0?(Ft=kt,nn+=It):Ft+=kt,this._data[5*Tt]=Ft,this._data[5*Tt+1]=nn,kt=Ft,It=nn}}let ht=B,gt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=et,this._prevLine=B,this._prevChar=se}static _sortAndDeltaEncode(B){let se=[];const Se=B.length/5|0;for(let gt=0;gt<Se;gt++)se[gt]=gt;se.sort((gt,Dt)=>{const kt=B[5*gt],It=B[5*Dt];if(kt===It){const Tt=B[5*gt+1],Ft=B[5*Dt+1];return Tt-Ft}return kt-It});const Ve=new Uint32Array(B.length);let et=0,ht=0;for(let gt=0;gt<Se;gt++){const Dt=5*se[gt],kt=B[Dt+0],It=B[Dt+1],Tt=B[Dt+2],Ft=B[Dt+3],nn=B[Dt+4],Rn=kt-et,Nn=Rn===0?It-ht:It,rn=5*gt;Ve[rn+0]=Rn,Ve[rn+1]=Nn,Ve[rn+2]=Tt,Ve[rn+3]=Ft,Ve[rn+4]=nn,et=kt,ht=It}return Ve}build(B){return this._dataIsSortedAndDeltaEncoded?new Qt(new Uint32Array(this._data),B):new Qt(At._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=At;class Qt{constructor(B,se){this.resultId=se,this.data=B}}e.SemanticTokens=Qt;class Xt{constructor(B,se,Se){this.start=B,this.deleteCount=se,this.data=Se}}e.SemanticTokensEdit=Xt;class Jt{constructor(B,se){this.resultId=se,this.edits=B}}e.SemanticTokensEdits=Jt;var wn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var bn;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(bn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Ct=class{constructor(){}};Ct.Back={iconPath:new Qe("arrow-left")},Ct=je([E],Ct),e.QuickInputButtons=Ct;var _n;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class En{constructor(B,se,Se){this.badge=B,this.tooltip=se,this.color=Se}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=En;let Yt=class{constructor(B){this.kind=B}};Yt=je([E],Yt),e.ColorTheme=Yt;var Sn;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(Sn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ut{constructor(B,se){if(B<0)throw(0,P.illegalArgument)("start must be positive");if(se<B)throw(0,P.illegalArgument)("end cannot be smaller than start");this._start=B,this._end=se}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let se=this._start,Se=this._end;return B.start!==void 0&&(se=B.start),B.end!==void 0&&(Se=B.end),se===this._start&&Se===this._end?this:new Ut(se,Se)}}e.NotebookRange=Ut;class jt{constructor(B,se){typeof B=="object"?Object.assign(this,B):(this.inputCollapsed=B,this.outputCollapsed=se)}with(B){let{inputCollapsed:se,outputCollapsed:Se,custom:Ve}=B,et=zt(B,["inputCollapsed","outputCollapsed","custom"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),Ve===void 0?Ve=this.custom:Ve===null&&(Ve=void 0),se===this.inputCollapsed&&Se===this.outputCollapsed&&Ve===this.custom&&Object.keys(et).length===0?this:new jt(Object.assign({inputCollapsed:se,outputCollapsed:Se,custom:Ve},et))}}e.NotebookCellMetadata=jt;class xt{constructor(B=!0,se={}){var Se,Ve;typeof B=="object"?(Object.assign(this,B),this.trusted=(Se=B.trusted)!==null&&Se!==void 0?Se:!0,this.custom=(Ve=B.custom)!==null&&Ve!==void 0?Ve:{}):(this.trusted=B,this.custom=se)}with(B){let{custom:se,trusted:Se}=B,Ve=zt(B,["custom","trusted"]);return se===void 0?se=this.custom:se===null&&(se=void 0),Se===void 0?Se=this.trusted:Se===null&&(Se=void 0),se===this.custom&&Se===this.trusted&&Object.keys(Ve).length===0?this:new xt(Object.assign({trusted:Se,custom:se},Ve))}}e.NotebookDocumentMetadata=xt;class Zt{constructor(B,se,Se,Ve,et,ht){this.kind=B,this.source=se,this.language=Se,this.outputs=Ve!=null?Ve:[],this.metadata=et,this.latestExecutionSummary=ht}}e.NotebookCellData=Zt;class Le{constructor(B,se){this.cells=B,this.metadata=se!=null?se:new xt}}e.NotebookData=Le;class Bt{constructor(B,se,Se){this.mime=B,this.value=se,this.metadata=Se}static isNotebookCellOutputItem(B){return B instanceof Bt}}e.NotebookCellOutputItem=Bt;class en{constructor(B,se,Se){this.outputs=B,typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,y.generateUuid)(),this.metadata=se!=null?se:Se)}}e.NotebookCellOutput=en;var mt;(function(H){H[H.Markdown=1]="Markdown",H[H.Code=2]="Code"})(mt=e.NotebookCellKind||(e.NotebookCellKind={}));var yn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(yn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Dn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Dn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var cn;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class un{constructor(B,se,Se,Ve,et,ht){this.text=B,this.alignment=se,this.command=Se,this.tooltip=Ve,this.priority=et,this.accessibilityInformation=ht}}e.NotebookCellStatusBarItem=un;let tn=class{constructor(B,se){this.label=B,this.timestamp=se}};tn=je([E],tn),e.TimelineItem=tn;var Cn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class dn{constructor(B,se){this.ranges=B,this.wordPattern=se}}e.LinkedEditingRanges=dn;var In;(function(H){H[H.Unset=0]="Unset",H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(In=e.TestResultState||(e.TestResultState={}));var hn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(hn=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const qt=(H,B,se)=>{let Se=se;return{enumerable:!0,configurable:!1,get(){return Se},set(Ve){var et;(et=H[e.TestItemHookProperty])===null||et===void 0||et.setProp(B,Ve),Se=Ve}}};class fn{constructor(B){m.set(this,new Map),s.set(this,void 0),tt(this,s,B,"f")}get size(){return He(this,m,"f").size}add(B){const se=He(this,m,"f"),Se=He(this,s,"f").call(this),Ve=se.get(B.id);Ve!==B&&(Ve&&(Se==null||Se.delete(B.id)),se.set(B.id,B),Se==null||Se.created(B))}get(B){return He(this,m,"f").get(B)}clear(){for(const B of He(this,m,"f").keys())this.delete(B)}delete(B){var se;const Se=typeof B=="string"?B:B.id;He(this,m,"f").has(Se)&&(He(this,m,"f").delete(Se),(se=He(this,s,"f").call(this))===null||se===void 0||se.delete(Se))}toJSON(){return[...He(this,m,"f").values()]}[(m=new WeakMap,s=new WeakMap,Symbol.iterator)](){return He(this,m,"f").values()}}e.TestChildrenCollection=fn;class An{constructor(B,se,Se,Ve){this.label=se,this.expandable=Ve,Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},children:{value:new fn(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:qt(this,"range",void 0),description:qt(this,"description",void 0),runnable:qt(this,"runnable",!0),debuggable:qt(this,"debuggable",!0)})}invalidate(){var B;(B=this[e.TestItemHookProperty])===null||B===void 0||B.invalidate(this.id)}discoverChildren(B,se){B.report({busy:!1})}}e.TestItem=An;class ne{constructor(B){this.message=B,this.severity=hn.Error}static diff(B,se,Se){const Ve=new ne(B);return Ve.expectedOutput=se,Ve.actualOutput=Se,Ve}}e.TestMessage=ne;var ue;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(ue=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ie;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ie=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ct;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore"})(ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[118],ge([0,1,52,11,10,143,106,7,14]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function R(s,d){d?n.set(s,d):n.delete(s)}e.setWordDefinitionFor=R;function C(s){return n.get(s)}e.getWordDefinitionFor=C;class g extends I.MirrorTextModel{constructor(d,S,w,b,v,u,l,t){super(S,w,b,v);this._proxy=d,this._languageId=u,this._isDirty=l,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===P.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(S){return S?d._getTextInRange(S):d.getText()},get eol(){return d._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(S){return d._lineAt(S)},offsetAt(S){return d._offsetAt(S)},positionAt(S){return d._positionAt(S)},validateRange(S){return d._validateRange(S)},validatePosition(S){return d._validatePosition(S)},getWordRangeAtPosition(S,w){return d._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,_.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,_.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const S=this._validateRange(d);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,b=S.start.line,v=S.end.line,u=[];u.push(this._lines[b].substring(S.start.character));for(let l=b+1;l<v;l++)u.push(this._lines[l]);return u.push(this._lines[v].substring(0,S.end.character)),u.join(w)}_lineAt(d){let S;if(d instanceof k.Position?S=d.line:typeof d=="number"&&(S=d),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new m(S,this._lines[S],S===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(d),w=this._lines[S.index].length;return new k.Position(S.index,Math.min(S.remainder,w))}_validateRange(d){if(!(d instanceof k.Range))throw new Error("Invalid argument");const S=this._validatePosition(d.start),w=this._validatePosition(d.end);return S===d.start&&w===d.end?d:new k.Range(S.line,S.character,w.line,w.character)}_validatePosition(d){if(!(d instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:S,character:w}=d,b=!1;if(S<0)S=0,w=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,b=!0;else{const v=this._lines[S].length;w<0?(w=0,b=!0):w>v&&(w=v,b=!0)}return b?new k.Position(S,w):d}_getWordRangeAtPosition(d,S){const w=this._validatePosition(d);if(!S)S=C(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=(0,D.getWordAtText)(w.character+1,(0,D.ensureValidWordDefinition)(S),this._lines[w.line],0);if(b)return new k.Range(w.line,b.startColumn-1,w.line,b.endColumn-1)}}e.ExtHostDocumentData=g;class m{constructor(d,S,w){this._line=d,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[197],ge([0,1,7,3,108,6,77,24,2,28]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(g,m,s,d){this._notebook=s,this._selector=d,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(w=>{const b=this._cellUris.get(w.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const g=[],m=[];for(const s of this._notebook.getCells())s.kind===_.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),g.push(s.document.getText().length+1),m.push(s.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(g){var m,s;if(!g){let v="";for(const u of this._cells)v+=u.document.getText()+`
`;return v=v.slice(0,-1),v}if(g.isEmpty)return"";const d=this.locationAt(g.start),S=this.locationAt(g.end),w=this._cells[(m=this._cellUris.get(d.uri))!==null&&m!==void 0?m:-1],b=this._cells[(s=this._cellUris.get(S.uri))!==null&&s!==void 0?s:-1];if(!w||!b)return"";if(w===b)return w.document.getText(new _.Range(d.range.start,S.range.end));{const v=w.document.getText(new _.Range(d.range.start,new _.Position(w.document.lineCount,0))),u=b.document.getText(new _.Range(new _.Position(0,0),S.range.end));return v+`
`+u}}offsetAt(g){const m=this._cellLines.getIndexOf(g.line),s=this._cellLengths.getAccumulatedValue(m.index-1),d=this._cells[m.index].document.offsetAt(g.with(m.remainder));return s+d}positionAt(g){if(typeof g=="number"){const s=this._cellLengths.getIndexOf(g),d=this._cellLines.getAccumulatedValue(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(d)}const m=this._cellUris.get(g.uri);if(m!==void 0){const s=this._cellLines.getAccumulatedValue(m-1);return new _.Position(s+g.range.start.line,g.range.start.character)}return new _.Position(0,0)}locationAt(g){_.Range.isRange(g)||(g=new _.Range(g,g));const m=this._cellLines.getIndexOf(g.start.line);let s=m;g.isEmpty||(s=this._cellLines.getIndexOf(g.end.line));const d=new _.Position(m.remainder,g.start.character),S=new _.Position(s.remainder,g.end.character),w=new _.Range(d,S),b=this._cells[m.index];return new _.Location(b.document.uri,b.document.validateRange(w))}contains(g){return this._cellUris.has(g)}validateRange(g){const m=this.validatePosition(g.start),s=this.validatePosition(g.end);return g.with(m,s)}validatePosition(g){const m=this._cellLines.getIndexOf(g.line),s=new _.Position(m.remainder,g.character),d=this._cells[m.index].document.validatePosition(s),S=this._cellLines.getAccumulatedValue(m.index-1);return new _.Position(S+d.line,d.character)}}e.ExtHostNotebookConcatDocument=R}),define(me[198],ge([0,1,7,13,3]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(k){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let y=k==="light"?_.ColorThemeKind.Light:k==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=je([xe(0,P.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(me[61],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class P{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=P}),define(me[199],ge([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function A(k,y){if(y){const n=new P,R=(m,s)=>{if(s instanceof ArrayBuffer){const d=n.add(s);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(s)){const d=I(s);if(d){const S=n.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:d,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},C=JSON.stringify(k,R),g=n.buffers.map(m=>{const s=new Uint8Array(m);return _.VSBuffer.wrap(s)});return{message:C,buffers:g}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=A;function I(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(k,y){const n=y.map(g=>{const m=new ArrayBuffer(g.byteLength);return new Uint8Array(m).set(g.buffer),m}),R=y.length?(g,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const s=m,{index:d}=s,S=n[d];if(s.view)switch(s.view.type){case 1:return new Int8Array(S,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return m}:void 0;return{message:JSON.parse(k,R),arrayBuffers:n}}e.deserializeWebviewMessage=D}),define(me[62],ge([0,1,2]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function P(I,D,k){const y=I.webviewResourceRoot.replace("{{resource}}",k.scheme+A(k)).replace("{{uuid}}",D);return _.URI.parse(y)}e.asWebviewUri=P;function A(I){return I.toString().replace(/^\S+?:/,"")}}),define(me[200],ge([0,1,3,6,62,28]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,n,R){this._proxy=y,this._editors=n,this._initData=R,this._handlePool=0,this._disposables=new P.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const C=n.getVisibleTextEditors();for(const g of this._insets.values())C.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,R,C,g){let m;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){m=u;break}if(!m)throw new Error("not a visible editor");const s=this,d=this._handlePool++,S=new _.Emitter,w=new _.Emitter,b=new class{constructor(){this._uuid=(0,I.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,A.asWebviewUri)(s._initData,this._uuid,u)}get cspSource(){return s._initData.webviewCspSource}set options(u){this._options=u,s._proxy.$setOptions(d,u)}get options(){return this._options}set html(u){this._html=u,s._proxy.$setHtml(d,u)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(u){return s._proxy.$postMessage(d,u)}},v=new class{constructor(){this.editor=y,this.line=n,this.height=R,this.webview=b,this.onDidDispose=w.event}dispose(){s._insets.has(d)&&(s._insets.delete(d),s._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),S.dispose())}};return this._proxy.$createEditorInset(d,m.id,m.value.document.uri,n+1,R,C||{},g.identifier,g.extensionLocation),this._insets.set(d,{editor:y,inset:v,onDidReceiveMessage:S}),v}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const R=this._insets.get(y);R&&R.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=D}),define(me[201],ge([0,1,3,81,168,4,6,24,40,14,53,23,43,193]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",g.Codicon.window,(0,A.localize)(0,null));var s;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(s=e.Extensions||(e.Extensions={}));var d;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function w(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=w;class b extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(o,p,E){var f;const h=this.get(o.id);if(h)return h;const T=o;return T.openCommandActionDescriptor=(E==null?void 0:E.donotRegisterOpenCommand)?void 0:(f=T.openCommandActionDescriptor)!==null&&f!==void 0?f:{id:T.id},(0,k.getOrSet)(this.viewContainers,p,[]).push(T),(E==null?void 0:E.isDefault)&&this.defaultViewContainers.push(T),this._onDidRegister.fire({viewContainer:T,viewContainerLocation:p}),T}deregisterViewContainer(o){for(const p of this.viewContainers.keys()){const E=this.viewContainers.get(p),f=E==null?void 0:E.indexOf(o);if(f!==-1){E==null||E.splice(f,1),E.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:p});return}}}get(o){return this.all.filter(p=>p.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(E=>(E==null?void 0:E.id)===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===o)}}y.Registry.add(s.ViewContainersRegistry,new b);var v;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(v=e.ViewContentGroups||(e.ViewContentGroups={}));function u(c,o){var p,E,f,h;const T=(p=c.group)!==null&&p!==void 0?p:v.More,L=(E=o.group)!==null&&E!==void 0?E:v.More;return T!==L?T.localeCompare(L):((f=c.order)!==null&&f!==void 0?f:5)-((h=o.order)!==null&&h!==void 0?h:5)}class l extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(o,p){this.registerViews2([{views:o,viewContainer:p}])}registerViews2(o){o.forEach(({views:p,viewContainer:E})=>this.addViews(p,E)),this._onViewsRegistered.fire(o)}deregisterViews(o,p){const E=this.removeViews(o,p);E.length&&this._onViewsDeregistered.fire({views:E,viewContainer:p})}moveViews(o,p){for(const E of this._views.keys())if(E!==p){const f=this.removeViews(o,E);f.length&&(this.addViews(f,p),this._onDidChangeContainer.fire({views:f,from:E,to:p}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const p of this._viewContainers){const E=(this._views.get(p)||[]).filter(f=>f.id===o)[0];if(E)return E}return null}getViewContainer(o){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(f=>f.id===o)[0])return p;return null}registerViewWelcomeContent(o,p){return this._viewWelcomeContents.add(o,p),this._onDidChangeViewWelcomeContent.fire(o),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(o,p),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,p){const E=new Map;for(const[f,h]of p)this._viewWelcomeContents.add(o,h),E.set(f,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(o,h),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),E}getViewWelcomeContent(o){const p=[];return this._viewWelcomeContents.forEach(o,E=>p.push(E)),p.sort(u)}addViews(o,p){let E=this._views.get(p);E||(E=[],this._views.set(p,E),this._viewContainers.push(p));for(const f of o){if(this.getView(f.id)!==null)throw new Error((0,A.localize)(1,null,f.id));E.push(f)}}removeViews(o,p){const E=this._views.get(p);if(!E)return[];const f=[],h=[];for(const T of E)o.includes(T)?f.push(T):h.push(T);return f.length&&(h.length?this._views.set(p,h):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),f}}y.Registry.add(s.ViewsRegistry,new l),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new P.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var i;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(o,p){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,o),this._hasResolve=!!p,this.resolve=async E=>{var f,h;if(p&&!this.resolved){const T=await p(E);T&&(this.tooltip=(f=this.tooltip)!==null&&f!==void 0?f:T.tooltip,this.command=(h=this.command)!==null&&h!==void 0?h:T.command)}E.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[202],ge([0,1,2,180,116,12,181,201]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(d){return(S,...w)=>d(S.get(P.ICommandService),...w)}class n{static execute(S,w){const b={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return S.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",P.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),P.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,S){return d.get(A.IWorkspacesService).removeRecentlyOpened([S])});class R{static execute(S,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?_.URI.parse(w):_.URI.file(w):w=_.URI.revive(w),S.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=R,R.ID="vscode.removeFromRecentlyOpened",P.CommandsRegistry.registerCommand(R.ID,y(R.execute));class C{static execute(S,w){const b=typeof w=="string"?{extensionId:w}:w;return S.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",P.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,S){const w=d.get(A.IWorkspacesService);let b;const v=S.uri,u=S.label,l=S.remoteAuthority;return S.type==="workspace"?b={workspace:await w.getWorkspaceIdentifier(v),label:u,remoteAuthority:l}:S.type==="folder"?b={folderUri:v,label:u,remoteAuthority:l}:b={fileUri:v,label:u,remoteAuthority:l},w.addRecentlyOpened([b])}),P.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(A.IWorkspacesService).getRecentlyOpened()}),P.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,S){const w=d.get(I.ILogService),b=d.get(D.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&w.setLevel(S)}),P.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(I.ILogService).getLevel()}),P.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,S){const w=d.get(k.IViewDescriptorService),b=w.getViewContainerById(S.destinationId);if(!!b){for(const v of S.viewIds){const u=w.getViewDescriptorById(v);(u==null?void 0:u.canMoveView)&&w.moveViewsToContainer([u],b,k.ViewVisibilityState.Default)}await d.get(k.IViewsService).openViewContainer(b.id,!0)}});class g{static execute(S,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=g,g.ID="vscode.moveViews",P.CommandsRegistry.registerCommand({id:g.ID,handler:y(g.execute),description:{description:"Move Views",args:[]}});class m{static execute(S,w){return S.executeCommand("_workbench.open",w)}}m.ID="vscode.open",P.CommandsRegistry.registerCommand(m.ID,y(m.execute));class s{static execute(S,w,b,v,u){return S.executeCommand("_workbench.diff",[w,b,v])}}s.ID="vscode.diff",P.CommandsRegistry.registerCommand(s.ID,y(s.execute))}),define(me[119],ge([0,1,3,19,169]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,y,n,R){const C={command:k};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof R=="number"){const g=setTimeout(()=>{clearTimeout(g);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const s={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,A.localize)(0,null,R,k)};m(s)}},R)}return n&&this.pendingRequests.set(C.seq,n),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,y){return k.type!=="event"||y.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,P.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const y=k,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(k,y){y.type=k,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((y,n)=>k.set(n,y)),await(0,P.timeout)(500),k.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(me[203],ge([0,1,10,2,8,23,11]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function y(i,a,r){return i.replace(k,function(c,o){return a&&o.length>0&&o[0]!=="_"?c:r&&r.hasOwnProperty(o)?r[o]:c})}e.formatPII=y;function n(i){const a={};for(const r of Object.keys(i))r.startsWith("!")||(a[r]=i[r]);return a}e.filterExceptionsFromTelemetry=n;function R(i){return i.configuration.request==="attach"&&!C(i)}e.isSessionAttach=R;function C(i){let a=i.configuration.type;if(!!a)return a==="vslsShare"&&(a=i.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(a,"extensionhost")||(0,_.equalsIgnoreCase)(a,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function g(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=g;function m(i,a,r){let c,o=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=p.exec(i);){let f=E.index+1,h=f+E[0].length;if(f<=a&&h>=r){c=E[0],o=f;break}}if(c){let f=/\w+/g,h=null;for(;(h=f.exec(c))&&!(h.index+1+o+h[0].length>=r););h&&(c=c.substring(0,f.lastIndex))}return c?{start:o,end:o+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(i){return!!(i&&i.match(s))}e.isUri=d;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(d(i.path))return P.URI.parse(i.path);if((0,A.isAbsolute)(i.path))return P.URI.file(i.path)}return i.path}function w(i){if(typeof i.path=="object"){const a=P.URI.revive(i.path);if(a)return a.scheme===D.Schemas.file?a.fsPath:a.toString()}return i.path}function b(i,a){const r=a?S:w,c=(0,I.deepClone)(i);return u(c,(o,p)=>{o&&p&&(p.path=r(p))}),c}e.convertToDAPaths=b;function v(i,a){const r=a?S:w,c=(0,I.deepClone)(i);return u(c,(o,p)=>{!o&&p&&(p.path=r(p))}),c}e.convertToVSCPaths=v;function u(i,a){switch(i.type){case"event":const r=i;switch(r.event){case"output":a(!1,r.body.source);break;case"loadedSource":a(!1,r.body.source);break;case"breakpoint":a(!1,r.body.breakpoint.source);break;default:break}break;case"request":const c=i;switch(c.command){case"setBreakpoints":a(!0,c.arguments.source);break;case"breakpointLocations":a(!0,c.arguments.source);break;case"source":a(!0,c.arguments.source);break;case"gotoTargets":a(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(p=>a(!1,p));break;default:break}break;case"response":const o=i;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(p=>a(!1,p.source));break;case"loadedSources":o.body.sources.forEach(p=>a(!1,p));break;case"scopes":o.body.scopes.forEach(p=>a(!1,p.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(p=>a(!1,p.source));break;case"setBreakpoints":o.body.breakpoints.forEach(p=>a(!1,p.source));break;default:break}break}}function l(i){return i.filter(a=>{var r;return!((r=a.presentation)===null||r===void 0?void 0:r.hidden)}).sort((a,r)=>a.presentation?r.presentation?a.presentation.group?r.presentation.group?a.presentation.group!==r.presentation.group?a.presentation.group.localeCompare(r.presentation.group):t(a.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(a.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=l;function t(i,a){return typeof i!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:i-a}}),define(me[204],ge([0,1,26,38,170,120,8,10,23,9,182,119]),function(G,e,_,P,A,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class g extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",u=>this.handleData(u))}sendMessage(b){if(this.outputStream){const v=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${g.TWO_CRLF}${v}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(u){this._onError.fire(new Error((u.message||u)+`
`+v))}continue}}else{const v=this.rawData.indexOf(g.TWO_CRLF);if(v!==-1){const l=this.rawData.toString("utf8",0,v).split(g.HEADER_LINESEPARATOR);for(const t of l){const i=t.split(g.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(v+g.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=g,g.TWO_CRLF=`\r
\r
`,g.HEADER_LINESEPARATOR=/\r?\n/,g.HEADER_FIELDSEPARATOR=/: */;class m extends g{startSession(){return new Promise((b,v)=>{let u=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),u=!0}),this.socket.on("close",()=>{u?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",l=>{u?this._onError.fire(l):v(l)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class s extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=s;class d extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return I.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=d;class S extends g{constructor(b,v,u){super();this.adapterExecutable=b,this.debugType=v,this.outputService=u}async startSession(){const b=this.adapterExecutable.command,v=this.adapterExecutable.args,u=this.adapterExecutable.options||{};try{if(b)if(D.isAbsolute(b)){if(!await(0,_.exists)(b))throw new Error(A.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(A.localize(1,null,this.debugType));let l=process.env;if(u.env&&Object.keys(u.env).length>0&&(l=y.mixin(y.deepClone(process.env),u.env)),b==="node")if(Array.isArray(v)&&v.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:l,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};u.cwd&&(a.cwd=u.cwd);const r=P.fork(v[0],v.slice(1),a);if(!r.pid)throw new Error(A.localize(2,null,v[0]));this.serverProcess=r}else throw new Error(A.localize(3,null));else{const i={env:l};u.cwd&&(i.cwd=u.cwd),this.serverProcess=P.spawn(b,v,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,a)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=a=>a.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",a=>{const r=t.getChannel(R.ExtensionsChannelId);r&&r.append(i(a))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(l){this._onError.fire(l)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),n.isWindows?new Promise((b,v)=>{const u=P.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(l,t,i){if(l)return v(l)});u.on("exit",b),u.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,v){if(!!b){const u=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?u.runtime=D.join(v,b.runtime):u.runtime=b.runtime),b.runtimeArgs&&(u.runtimeArgs=b.runtimeArgs),b.program&&(D.isAbsolute(b.program)?u.program=b.program:u.program=D.join(v,b.program)),b.args&&(u.args=b.args);const l=b;return l.win&&(u.win=S.extract(l.win,v)),l.winx86&&(u.winx86=S.extract(l.winx86,v)),l.windows&&(u.windows=S.extract(l.windows,v)),l.osx&&(u.osx=S.extract(l.osx,v)),l.linux&&(u.linux=S.extract(l.linux,v)),u}}static platformAdapterExecutable(b,v){let u=Object.create(null);v=v.toLowerCase();for(const c of b)if(c.contributes){const o=c.contributes.debuggers;o&&o.length>0&&o.filter(p=>typeof p.type=="string"&&k.equalsIgnoreCase(p.type,v)).forEach(p=>{const E=S.extract(p,c.extensionLocation.fsPath);u=y.mixin(u,E,c.isBuiltin)})}let l;n.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?l=u.winx86||u.win||u.windows:n.isWindows?l=u.win||u.windows:n.isMacintosh?l=u.osx:n.isLinux&&(l=u.linux),l=l||u;let t=l.program||u.program;const i=l.args||u.args;let a=l.runtime||u.runtime;const r=l.runtimeArgs||u.runtimeArgs;if(a)return{type:"executable",command:a,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=S}),define(me[205],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(me[206],ge([0,1,38,8,78,171,26,9,84,4,205,11]),function(G,e,_,P,A,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=I.localize(0,null);let m=class Wt{constructor(v){this._configurationService=v}openTerminal(v){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,A.getWindowsShell(),v)}}runInTerminal(v,u,l,t,i){const a=i.windowsExec||Wt.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${u} - ${g}"`,p=`""${l.join('" "')}" & pause"`,E=["/c","start",o,"/wait",a,"/c",p],f=Object.assign({},process.env,t);Object.keys(f).filter(L=>f[L]===null).forEach(L=>delete f[L]);const h={cwd:u,env:f,windowsVerbatimArguments:!0};_.spawn(Wt.CMD,E,h).on("error",L=>{c(S(L))}),r(void 0)})}spawnTerminal(v,u,l,t){const a=u.terminal.external.windowsExec||Wt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const r=P.basename(a).toLowerCase();if(r==="cmder"||r==="cmder.exe")return v.spawn(a,t?[t]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return a.indexOf(" ")>=0&&c.push('""'),c.push(a),(r==="wt"||r==="wt.exe")&&c.push("-d ."),new Promise((o,p)=>{const E=t?{cwd:t}:void 0,f=v.spawn(l,c,E);f.on("error",p),f.on("exit",()=>o())})}static getDefaultTerminalWindows(){if(!Wt._DEFAULT_TERMINAL_WINDOWS){const v=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Wt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${v?"Sysnative":"System32"}\\cmd.exe`}return Wt._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=je([xe(0,(0,n.optional)(y.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let s=class Ln{constructor(v){this._configurationService=v}openTerminal(v){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,v)}}runInTerminal(v,u,l,t,i){const a=i.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(a===R.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,G).fsPath,"-t",v||g,"-w",u];for(let T of l)E.push("-a"),E.push(T);if(t)for(let T in t){const L=t[T];L===null?(E.push("-u"),E.push(T)):(E.push("-e"),E.push(`${T}=${L}`))}let f="";const h=_.spawn(Ln.OSASCRIPT,E);h.on("error",T=>{c(S(T))}),h.stderr.on("data",T=>{f+=T.toString()}),h.on("exit",T=>{if(T===0)r(void 0);else if(f){const L=f.split(`
`,1);c(new Error(L[0]))}else c(new Error(I.localize(1,null,o,T)))})}else c(new Error(I.localize(2,null,a)))})}spawnTerminal(v,u,l){const i=u.terminal.external.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((a,r)=>{const c=["-a",i];l&&c.push(l);const o=v.spawn("/usr/bin/open",c);o.on("error",r),o.on("exit",()=>a())})}};s.OSASCRIPT="/usr/bin/osascript",s=je([xe(0,(0,n.optional)(y.IConfigurationService))],s),e.MacExternalTerminalService=s;let d=class $t{constructor(v){this._configurationService=v}openTerminal(v){if(this._configurationService){const u=this._configurationService.getValue();this.spawnTerminal(_,u,v)}}runInTerminal(v,u,l,t,i){const a=i.linuxExec?Promise.resolve(i.linuxExec):$t.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{let o=[];a.then(p=>{p.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const E=`${w(l)}; echo; read -p "${$t.WAIT_MESSAGE}" -n1;`;o.push(`''${E}''`);const f=Object.assign({},process.env,t);Object.keys(f).filter(W=>f[W]===null).forEach(W=>delete f[W]);const h={cwd:u,env:f};let T="";const L=_.spawn(p,o,h);L.on("error",W=>{c(S(W))}),L.stderr.on("data",W=>{T+=W.toString()}),L.on("exit",W=>{if(W===0)r(void 0);else if(T){const ee=T.split(`
`,1);c(new Error(ee[0]))}else c(new Error(I.localize(4,null,p,W)))})})})}spawnTerminal(v,u,l){const t=u.terminal.external,i=t.linuxExec?Promise.resolve(t.linuxExec):$t.getDefaultTerminalLinuxReady();return new Promise((a,r)=>{i.then(c=>{const o=l?{cwd:l}:void 0,p=v.spawn(c,[],o);p.on("error",r),p.on("exit",()=>a())})})}static async getDefaultTerminalLinuxReady(){return $t._DEFAULT_TERMINAL_LINUX_READY||($t._DEFAULT_TERMINAL_LINUX_READY=new Promise(async v=>{k.isLinux?await D.exists("/etc/debian_version")?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm"):v("xterm")})),$t._DEFAULT_TERMINAL_LINUX_READY}};d.WAIT_MESSAGE=I.localize(3,null),d=je([xe(0,(0,n.optional)(y.IConfigurationService))],d),e.LinuxExternalTerminalService=d;function S(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function w(b){let v="";for(let u of b)u.indexOf(" ")>=0?v+='"'+u+'"':v+=u,v+=" ";return v}}),define(me[207],ge([0,1,38,9,206,30]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function k(g,m){if(!D)if(P.isWindows)D=new A.WindowsExternalTerminalService(void 0);else if(P.isMacintosh)D=new A.MacExternalTerminalService(void 0);else if(P.isLinux)D=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const s=m.getConfiguration("terminal");return D.runInTerminal(g.title,g.cwd,g.args,g.env||{},s.external||{})}e.runInExternalTerminal=k;function y(g,m){return new Promise((s,d)=>{let S="";const w=_.spawn(g,m);w.pid&&w.stdout.on("data",b=>{S+=b.toString()}),w.on("error",b=>{d(b)}),w.on("close",b=>{s(S)})})}function n(g){return g?P.isWindows?y("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(d=>parseInt(d)===g),m=>!0):y("/usr/bin/pgrep",["-lP",String(g)]).then(m=>{const s=m.trim();return!(s.length===0||s.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=n;var R;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(R||(R={}));function C(g,m,s,d){g=g.trim().toLowerCase();let S;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?S=1:g.indexOf("cmd.exe")>=0?S=0:g.indexOf("bash")>=0?S=2:P.isWindows?S=0:S=2;let w,b=" ";switch(S){case 1:if(w=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),s){const u=(0,I.getDriveLetter)(s);u&&(b+=`${u}:; `),b+=`cd ${w(s)}; `}if(d)for(let u in d){const l=d[u];l===null?b+=`Remove-Item env:${u}; `:b+=`\${env:${u}}='${l}'; `}if(m.length>0){const u=w(m.shift());b+=u[0]==="'"?`& ${u} `:`${u} `;for(let l of m)b+=`${w(l)} `}break;case 0:if(w=u=>(u=u.replace(/\"/g,'""'),u.indexOf(" ")>=0||u.indexOf('"')>=0||u.length===0?`"${u}"`:u),s){const u=(0,I.getDriveLetter)(s);u&&(b+=`${u}: && `),b+=`cd ${w(s)} && `}if(d){b+='cmd /C "';for(let u in d){let l=d[u];l===null?b+=`set "${u}=" && `:(l=l.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${u}=${l}" && `)}}for(let u of m)b+=`${w(u)} `;d&&(b+='"');break;case 2:w=u=>(u=u.replace(/(["'\\\$])/g,"\\$1"),u.indexOf(" ")>=0||u.indexOf(";")>=0||u.length===0?`"${u}"`:u);const v=u=>/[^\w@%\/+=,.:^-]/.test(u)?`'${u.replace(/'/g,"'\\''")}'`:u;if(s&&(b+=`cd ${w(s)} ; `),d){b+="/usr/bin/env";for(let u in d){const l=d[u];l===null?b+=` -u ${v(u)}`:b+=` ${v(`${u}=${l}`)}`}b+=" "}for(let u of m)b+=`${w(u)} `;break}return b}e.prepareCommand=C}),define(me[86],ge([0,1,33,11,8,9,81]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var n;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var R;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(R=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function s(L){const W=d.parse(L);return W?W.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=s;var d;(function(L){L.scheme=P.Schemas.vscodeNotebookCell;const W=/^ch(\d{7,})/;function ee(F,U){return F.with({scheme:L.scheme,fragment:`ch${U.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}L.generate=ee;function j(F){if(F.scheme===L.scheme){const U=W.exec(F.fragment);if(!!U)return{handle:Number(U[1]),notebook:F.with({scheme:F.fragment.substr(U[0].length)||P.Schemas.file,fragment:null})}}}L.parse=j;function x(F,U){return F.with({scheme:P.Schemas.vscodeNotebookCellMetadata,fragment:`ch${U.toString().padStart(7,"0")}${F.scheme!==P.Schemas.file?F.scheme:""}`})}L.generateCellMetadataUri=x;function $(F){if(F.scheme===P.Schemas.vscodeNotebookCellMetadata){const U=W.exec(F.fragment);if(!!U)return{handle:Number(U[1]),notebook:F.with({scheme:F.fragment.substr(U[0].length)||P.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=$})(d=e.CellUri||(e.CellUri={}));const S=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(L){var W,ee;return(ee=(W=S.get(L))===null||W===void 0?void 0:W.alwaysSecure)!==null&&ee!==void 0?ee:!1}e.mimeTypeIsAlwaysSecure=w;function b(L){var W,ee;return(ee=(W=S.get(L))===null||W===void 0?void 0:W.supportedByCore)!==null&&ee!==void 0?ee:!1}e.mimeTypeSupportedByCore=b;function v(L){var W,ee;return(ee=(W=S.get(L))===null||W===void 0?void 0:W.mergeable)!==null&&ee!==void 0?ee:!1}e.mimeTypeIsMergeable=v;function u(L,W){return I.isWindows&&(L=L.replace(/\//g,"\\"),W=W.replace(/\//g,"\\")),_.match(L,W)}function l(L,W,ee){let j=0;for(let x=0;x<W.length;x++){if(u(W[x],L))return j;j++}for(let x=0;x<ee.length;x++){if(u(ee[x],L))return j;j++}return j}function t(L,W,ee){return L.sort((j,x)=>l(j,W,ee)-l(x,W,ee))}e.sortMimeTypes=t;function i(L,W,ee,j=(x,$)=>x===$){const x=[];function $(M,N,O){if(!(N===0&&O.length===0)){const V=x[x.length-1];V&&V.start+V.deleteCount===M?(V.deleteCount+=N,V.toInsert.push(...O)):x.push({start:M,deleteCount:N,toInsert:O})}}let F=0,U=0;for(;;){if(F===L.length){$(F,0,W.slice(U));break}if(U===W.length){$(F,L.length-F,[]);break}const M=L[F],N=W[U];if(j(M,N)){F+=1,U+=1;continue}ee(N)?($(F,1,[]),F+=1):($(F,0,[N]),U+=1)}return x}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(L){L.default="default",L.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(L){const W=L;return!!((typeof W.include=="string"||_.isRelativePattern(W.include))&&(typeof W.exclude=="string"||_.isRelativePattern(W.exclude)))}e.isDocumentExcludePattern=r;function c(L,W,ee){if(Array.isArray(L.viewType)&&L.viewType.indexOf(W)>=0||L.viewType===W)return!0;if(L.filenamePattern){let j=r(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,x=r(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(_.match(j,(0,A.basename)(ee.fsPath).toLowerCase()))return!(x&&_.match(x,(0,A.basename)(ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class o{constructor(W){this.textModel=W}getElements(){const W=new Int32Array(this.textModel.cells.length);for(let ee=0;ee<this.textModel.cells.length;ee++)W[ee]=this.textModel.cells[ee].getHashValue();return W}}e.CellSequence=o,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var p;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function E(L){L.sort((ee,j)=>ee-j);const W=L.shift();return W===void 0?[]:L.reduce(function(ee,j){return j<=ee[0][1]?ee[0][1]=j+1:ee.unshift([j,j+1]),ee},[[W,W+1]]).reverse().map(ee=>({start:ee[0],end:ee[1]}))}e.cellIndexesToRanges=E;function f(L){return L.reduce((ee,j)=>{for(let x=j.start;x<j.end;x++)ee.push(x);return ee},[])}e.cellRangesToIndexes=f;function h(L){const W=L.sort((j,x)=>j.start-x.start),ee=W[0];return ee?W.reduce((j,x)=>{const $=j[j.length-1];return $.end>=x.start?$.end=Math.max($.end,x.end):j.push(x),j},[ee]):[]}e.reduceRanges=h;function T(L,W){return W.start>=L.start&&W.end<=L.end}e.cellRangeContains=T}),define(me[208],ge([0,1,173,4,81]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,P.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[209],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=_;function P(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=P}),define(me[210],ge([0,1,8,9,134]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(l,t){if(!!t)if(P.isWindows)for(const i in t){let a=i;for(const c in l)if(i.toLowerCase()===c.toLowerCase()){a=c;break}const r=t[i];r!==void 0&&D(l,a,r)}else Object.keys(t).forEach(i=>{const a=t[i];a!==void 0&&D(l,i,a)})}e.mergeEnvironments=I;function D(l,t,i){typeof i=="string"?l[t]=i:delete l[t]}function k(l,t,i,a){l.TERM_PROGRAM="vscode",t&&(l.TERM_PROGRAM_VERSION=t),R(l,a)&&(l.LANG=C(i)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function y(l,t){if(!!t)for(const i of Object.keys(t)){const a=t[i];a&&(l[i]=a)}}function n(l,t){return Object.keys(t).forEach(i=>{const a=t[i];if(typeof a=="string")try{t[i]=l(a)}catch(r){t[i]=a}}),t}function R(l,t){if(t==="on")return!0;if(t==="auto"){const i=l.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=R;function C(l){const t=l?l.split("-"):[],i=t.length;if(i===0)return"en_US.UTF-8";if(i===1){const a={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in a&&t.push(a[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function g(l,t,i,a,r,c){if(l.cwd){const p=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,E=m(p,i);return s(E||p)}let o;return!l.ignoreConfigurationCwd&&r&&(i&&(r=m(r,i,c)),r&&(_.isAbsolute(r)?o=r:a&&(o=_.join(a.fsPath,r)))),o||(o=a?a.fsPath:t||""),s(o)}e.getCwd=g;function m(l,t,i){if(t)try{return t(l)}catch(a){i==null||i.error("Could not resolve terminal cwd",a);return}return l}function s(l){return P.platform===3&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function d(l){let t=l;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const i=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(i,""),`'${t}'`}e.escapeNonWindowsPath=d;function S(l,t){if(!!t)return i=>t.resolve(l,i)}e.createVariableResolver=S;function w(l,t,i,a,r,c,o,p,E=P.platform){let f=null;p&&(f=v(l,t,"automationShell",E)),f||(f=v(l,t,"shell",E));let h=f||i;if(E===3&&!a&&r){const T=_.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(T)===0&&(h=_.join(r,"System32",h.substr(T.length+1)))}if(h&&E===3&&(h=h.replace(/\//g,"\\")),c)try{h=c(h)}catch(T){o.error("Could not resolve shell",T)}return h}e.getDefaultShell=w;function b(l,t,i,a,r,c=P.platform){if(i&&v(l,t,"automationShell",c))return[];const o=c===3?"windows":c===1?"osx":"linux",p=l(`terminal.integrated.shellArgs.${o}`);let E=(t?p.value:p.userValue)||p.defaultValue;if(!E)return[];if(typeof E=="string"&&c===3)return a?a(E):E;if(a){const f=[];for(const h of E)try{f.push(a(h))}catch(T){r.error(`Could not resolve terminal.integrated.shellArgs.${o}`,T),f.push(h)}E=f}return E}e.getDefaultShellArgs=b;function v(l,t,i,a=P.platform){const c=l(`terminal.integrated.${i}.${a===3?"windows":a===1?"osx":"linux"}`);return(t?c.value:c.userValue)||c.defaultValue}function u(l,t,i,a,r,c,o){let p={};if(l.strictEnv)y(p,l.env);else{y(p,o);const E=Object.assign({},a?t.value:t.userValue);i&&(E&&n(i,E),l.env&&n(i,l.env)),(0,A.sanitizeProcessEnvironment)(p,"VSCODE_IPC_HOOK_CLI"),I(p,E),I(p,l.env),k(p,r,P.locale,c)}return p}e.createTerminalEnvironment=u});var sn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],_;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),_={},P("next"),P("throw"),P("return"),_[Symbol.asyncIterator]=function(){return this},_);function P(I){_[I]=G[I]&&function(D){return new Promise(function(k,y){D=G[I](D),A(k,y,D.done,D.value)})}}function A(I,D,k,y){Promise.resolve(y).then(function(n){I({value:n,done:k})},D)}};define(me[211],ge([0,1,37,9,8,101,190,38,26,43]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R;function C(u,l,t,i,a,r,c){return l=l||{existsFile:y.SymlinkSupport.existsFile,readFile:_.promises.readFile},P.isWindows?g(u,l,t,i==null?void 0:i.useWslProfiles,i==null?void 0:i.profiles.windows,a,r):w(l,t,u,P.isMacintosh?i==null?void 0:i.profiles.osx:i==null?void 0:i.profiles.linux,c,a,r)}e.detectAvailableProfiles=C;async function g(u,l,t,i,a,r,c){const o=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${process.env.windir}\\${o?"Sysnative":"System32"}`;let E=!1;(0,D.getWindowsBuildNumber)()>=16299&&(E=!0),await s();const f=new Map;u||(f.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell.id,isAutoDetected:!0}),f.set("Windows PowerShell",{path:`${p}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell.id,isAutoDetected:!0}),f.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),f.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),f.set("Command Prompt",{path:`${p}\\cmd.exe`,icon:n.Codicon.terminalCmd.id,isAutoDetected:!0})),b(a,f);const h=await m(f.entries(),l,t,r,c);if(!u||u&&i)try{const T=await S(`${p}\\${E?"wsl.exe":"bash.exe"}`,i);T&&h.push(...T)}catch(T){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return h}async function m(u,l,t,i,a){const r=[];for(const[c,o]of u)if(o!==null){let p,E,f;if("source"in o){const L=R==null?void 0:R.get(o.source);if(!L)continue;p=L.paths,E=o.args||L.args,f=o.icon||L.icon}else p=Array.isArray(o.path)?o.path:[o.path],E=P.isWindows||Array.isArray(o.args)?o.args:void 0,f=o.icon;const h=p.slice();for(let L=0;L<h.length;L++)h[L]=await(i==null?void 0:i.resolveAsync(a,h[L]))||h[L];const T=await v(c,h,l,E,o.env,o.overrideName,o.isAutoDetected,t);T?(T.isAutoDetected=o.isAutoDetected,T.icon=f,r.push(T)):t==null||t.trace("profile not validated",c,p)}return r}async function s(){R||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:await d(),icon:"terminal-powershell"}))}async function d(){var u,l;const t=[];try{for(var i=sn((0,I.enumeratePowerShellInstallations)()),a;a=await i.next(),!a.done;){const r=a.value;t.push(r.exePath)}}catch(r){u={error:r}}finally{try{a&&!a.done&&(l=i.return)&&await l.call(i)}finally{if(u)throw u.error}}return t}async function S(u,l){const t=[];if(l){const i=await new Promise((a,r)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(c,o)=>{if(c)return r("Problem occurred when getting wsl distros");a(o)})});if(i){const a=new RegExp(/[\r?\n]/),r=i.split(a).filter(c=>c.trim().length>0&&c!=="");for(let c of r)if(c!==""&&!c.startsWith("docker-desktop")){const o={profileName:`${c} (WSL)`,path:u,args:["-d",`${c}`]};c.includes("Debian")?o.icon="terminal-debian":o.icon="terminal-linux",t.push(o)}return t}}return[]}async function w(u,l,t,i,a,r,c){const o=new Map;if(!t){const p=await u.readFile("/etc/shells","utf8"),E=a||p.split(`
`).filter(h=>h.trim().indexOf("#")!==0&&h.trim().length>0),f=new Map;for(const h of E){let T=(0,A.basename)(h),L=f.get(T)||0;L++,L>1&&(T=`${T} (${L})`),f.set(T,L),o.set(T,{path:h,isAutoDetected:!0})}}return b(i,o),await m(o.entries(),u,l,r,c)}function b(u,l){if(!!u)for(const[t,i]of Object.entries(u))i===null||!("path"in i)&&!("source"in i)?l.delete(t):l.set(t,i)}async function v(u,l,t,i,a,r,c,o){if(l.length===0)return Promise.resolve(void 0);const p=l.shift();if(p==="")return v(u,l,t,i,a,r,c);const E={profileName:u,path:p,args:i,env:a,overrideName:r,isAutoDetected:c};if((0,A.basename)(p)===p){const h=process.env.PATH?process.env.PATH.split(A.delimiter):void 0;return await(0,D.findExecutable)(p,void 0,h,void 0,t.existsFile)?E:v(u,l,t,i)}return await t.existsFile((0,A.normalize)(p))?E:v(u,l,t,i,a,r,c)}}),define(me[121],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=P;var A;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const I=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=I;class D{add(n){}update(n){}remove(n,R){}complete(){}}e.IncrementalChangeCollector=D;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const R=this.createChangeCollector();for(const C of n)switch(C[0]){case 0:{const g=C[1];if(g.parent){if(this.items.has(g.parent)){const m=this.items.get(g.parent);m.children.add(g.item.extId);const s=this.createItem(g,m);this.items.set(g.item.extId,s),R.add(s)}}else{this.roots.add(g.item.extId);const m=this.createItem(g);this.items.set(g.item.extId,m),R.add(m)}g.expand===2&&this.updateBusyProviders(1);break}case 1:{const g=C[1],m=this.items.get(g.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,g),R.update(m),g.expand!==void 0&&m.expand===2&&g.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const g=this.items.get(C[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g.item.extId);const m=[[C[1]]];for(;m.length;)for(const s of m.pop()){const d=this.items.get(s);d&&(m.push(d.children),this.items.delete(s),R.remove(d,d!==g),d.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}R.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=k}),define(me[212],ge([0,1,8,36,15,23,9,76,174]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(C,g,m,s){if(this._contributedVariables=new Map,this._context=C,this._labelService=g,m)if(D.isWindows){const d=Object.create(null);this._envVariables=d,Object.keys(m).forEach(S=>{d[S.toLowerCase()]=m[S]})}else this._envVariables=m}resolveWithEnvironment(C,g,m){return this.recursiveResolve(C,g?g.uri:void 0,m)}async resolveAsync(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolve(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolveAnyBase(C,g,m,s){const d=I.deepClone(g);return D.isWindows&&d.windows?Object.keys(d.windows).forEach(S=>d[S]=d.windows[S]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(S=>d[S]=d.osx[S]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(S=>d[S]=d.linux[S]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,d,m,s)}resolveAny(C,g,m){return this.resolveAnyBase(C,g,m)}async resolveAnyAsync(C,g,m){return this.resolveAnyBase(C,g,m)}resolveAnyMap(C,g,m){const s=new Map;return{newConfig:this.resolveAnyBase(C,g,m,s),resolvedVariables:s}}resolveWithInteractionReplace(C,g,m,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,g,m,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,g){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,g)}recursiveResolve(C,g,m,s,d){if(A.isString(m))return this.resolveString(C,g,m,s,d);if(A.isArray(m))return m.map(S=>this.recursiveResolve(C,g,S,s,d));if(A.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(w=>{const b=this.resolveString(C,g,w,s,d);S[b]=this.recursiveResolve(C,g,m[w],s,d)}),S}return m}resolveString(C,g,m,s,d){return m.replace(n.VARIABLE_REGEXP,(w,b)=>{if(b.includes(n.VARIABLE_LHS))return w;let v=this.evaluateSingleVariable(C,w,b,g,s);return d&&d.set(b,v),v})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,g,m,s,d){let S;const w=m.split(":");w.length>1&&(m=w[0],S=w[1]);const b=()=>{const l=this._context.getFilePath();if(l)return l;throw new Error((0,y.localize)(0,null,g))},v=()=>{const l=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,g,_.basename(l)))},u=()=>{if(S){const l=this._context.getFolderUri(S);if(l)return l;throw new Error((0,y.localize)(2,null,g,S))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,g)):new Error((0,y.localize)(4,null,g))};switch(m){case"env":if(S){if(C){const l=C[D.isWindows?S.toLowerCase():S];if(A.isString(l))return l}return""}throw new Error((0,y.localize)(5,null,g));case"config":if(S){const l=this._context.getConfigurationValue(s,S);if(A.isUndefinedOrNull(l))throw new Error((0,y.localize)(6,null,g,S));if(A.isObject(l))throw new Error((0,y.localize)(7,null,g,S));return l}throw new Error((0,y.localize)(8,null,g));case"command":return this.resolveFromMap(g,S,d,"command");case"input":return this.resolveFromMap(g,S,d,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return s||S?(0,k.normalizeDriveLetter)(this.fsPath(u())):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(u()));case"lineNumber":const l=this._context.getLineNumber();if(l)return l;throw new Error((0,y.localize)(9,null,g));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,g));case"file":return b();case"fileWorkspaceFolder":return v();case"relativeFile":return s||S?_.relative(this.fsPath(u()),b()):b();case"relativeFileDirname":const i=_.dirname(b());if(s||S){const o=_.relative(this.fsPath(u()),i);return o.length===0?".":o}return i;case"fileDirname":return _.dirname(b());case"fileExtname":return _.extname(b());case"fileBasename":return _.basename(b());case"fileBasenameNoExtension":const a=_.basename(b());return a.slice(0,a.length-_.extname(a).length);case"fileDirnameBasename":return _.basename(_.dirname(b()));case"execPath":const r=this._context.getExecPath();return r||g;case"execInstallFolder":const c=this._context.getAppRoot();return c||g;case"pathSeparator":return _.sep;default:try{const o=S?`${m}:${S}`:m;return this.resolveFromMap(g,o,d,void 0)}catch(o){return g}}}}resolveFromMap(C,g,m,s){if(g&&m){const d=s===void 0?m[g]:m[s+":"+g];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[213],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var P;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var A;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var D;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_PIN=7]="EDITOR_PIN",g[g.EDITOR_STICKY=8]="EDITOR_STICKY",g[g.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var R;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function C(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(me[214],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,14,95,285,57,23,15,2,44,80,175,111,86,214,7]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(_e){function De(Z){const{selectionStartLineNumber:Oe,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:Ye}=Z,at=new d.Position(Oe-1,Te-1),st=new d.Position(Je-1,Ye-1);return new d.Selection(at,st)}_e.to=De;function ae(Z){const{anchor:Oe,active:Te}=Z;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}_e.from=ae})(S=e.Selection||(e.Selection={}));var w;(function(_e){function De(Z){if(!!Z){const{start:Oe,end:Te}=Z;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}_e.from=De;function ae(Z){if(!!Z){const{startLineNumber:Oe,startColumn:Te,endLineNumber:Je,endColumn:Ye}=Z;return new d.Range(Oe-1,Te-1,Je-1,Ye-1)}}_e.to=ae})(w=e.Range||(e.Range={}));var b;(function(_e){function De(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}_e.to=De})(b=e.TokenType||(e.TokenType={}));var v;(function(_e){function De(Z){return new d.Position(Z.lineNumber-1,Z.column-1)}_e.to=De;function ae(Z){return{lineNumber:Z.line+1,column:Z.character+1}}_e.from=ae})(v=e.Position||(e.Position={}));var u;(function(_e){function De(Z){switch(Z){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}_e.from=De;function ae(Z){switch(Z){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}_e.to=ae})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(_e){function De(Z){let Oe;return Z.code&&((0,k.isString)(Z.code)||(0,k.isNumber)(Z.code)?Oe=String(Z.code):Oe={value:String(Z.code.value),target:Z.code.target}),Object.assign(Object.assign({},w.from(Z.range)),{message:Z.message,source:Z.source,code:Oe,severity:i.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(t.from),tags:Array.isArray(Z.tags)?(0,_.coalesce)(Z.tags.map(u.from)):void 0})}_e.from=De;function ae(Z){var Oe;const Te=new d.Diagnostic(w.to(Z),Z.message,i.to(Z.severity));return Te.source=Z.source,Te.code=(0,k.isString)(Z.code)?Z.code:(Oe=Z.code)===null||Oe===void 0?void 0:Oe.value,Te.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(t.to),Te.tags=Z.tags&&(0,_.coalesce)(Z.tags.map(u.to)),Te}_e.to=ae})(l=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function De(Z){return Object.assign(Object.assign({},w.from(Z.location.range)),{message:Z.message,resource:Z.location.uri})}_e.from=De;function ae(Z){return new d.DiagnosticRelatedInformation(new d.Location(Z.resource,w.to(Z)),Z.message)}_e.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function De(Z){switch(Z){case d.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}_e.from=De;function ae(Z){switch(Z){case g.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}_e.to=ae})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(_e){function De(Z){return typeof Z=="number"&&Z>=d.ViewColumn.One?Z-1:Z===d.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}_e.from=De;function ae(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=ae})(a=e.ViewColumn||(e.ViewColumn={}));function r(_e){return typeof _e.range!="undefined"}function c(_e){return _e.length===0?!0:!!r(_e[0])}e.isDecorationOptionsArr=c;var o;(function(_e){function De(Ye){return Ye.map(_e.from)}_e.fromMany=De;function ae(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function Z(Ye){let at;if(ae(Ye)){const{language:bt,value:ut}=Ye;at={value:"```"+bt+`
`+ut+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ye)?at={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons}:typeof Ye=="string"?at={value:Ye}:at={value:""};const st=Object.create(null);at.uris=st;const Qe=bt=>{try{let ut=y.URI.parse(bt,!0);ut=ut.with({query:Oe(ut.query,st)}),st[bt]=ut}catch(ut){}return""},lt=new A.Renderer;return lt.link=Qe,lt.image=bt=>Qe(P.parseHrefAndDimensions(bt).href),A(at.value,{renderer:lt}),at}_e.from=Z;function Oe(Ye,at){if(!Ye)return Ye;let st;try{st=(0,I.parse)(Ye)}catch(lt){}if(!st)return Ye;let Qe=!1;return st=(0,D.cloneAndChange)(st,lt=>{if(y.URI.isUri(lt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[bt]=lt,Qe=!0,bt}else return}),Qe?JSON.stringify(st):Ye}function Te(Ye){const at=new d.MarkdownString(Ye.value,Ye.supportThemeIcons);return at.isTrusted=Ye.isTrusted,at}_e.to=Te;function Je(Ye){if(!!Ye)return typeof Ye=="string"?Ye:_e.from(Ye)}_e.fromStrict=Je})(o=e.MarkdownString||(e.MarkdownString={}));function p(_e){return c(_e)?_e.map(De=>({range:w.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?o.fromMany(De.hoverMessage):De.hoverMessage?o.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):_e.map(De=>({range:w.from(De)}))}e.fromRangeOrRangeWithMessage=p;function E(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?y.URI.file(_e):_e}e.pathOrURIToURI=E;var f;(function(_e){function De(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?E(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}_e.from=De})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var h;(function(_e){function De(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?E(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?f.from(ae.before):void 0,after:ae.after?f.from(ae.after):void 0}}_e.from=De})(h=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(_e){function De(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=De})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(_e){function De(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?T.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?h.from(ae.light):void 0,dark:ae.dark?h.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?E(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?f.from(ae.before):void 0,after:ae.after?f.from(ae.after):void 0}}_e.from=De})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(_e){function De(Z){return{text:Z.newText,eol:Z.newEol&&re.from(Z.newEol),range:w.from(Z.range)}}_e.from=De;function ae(Z){const Oe=new d.TextEdit(w.to(Z.range),Z.text);return Oe.newEol=typeof Z.eol=="undefined"?void 0:re.to(Z.eol),Oe}_e.to=ae})(W=e.TextEdit||(e.TextEdit={}));var ee;(function(_e){function De(Z,Oe,Te){var Je,Ye,at;const st={edits:[]};if(Z instanceof d.WorkspaceEdit)for(let Qe of Z._allEntries())if(Qe._type===1)st.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const lt=Oe==null?void 0:Oe.getDocument(Qe.uri);st.edits.push({_type:2,resource:Qe.uri,edit:W.from(Qe.edit),modelVersionId:lt==null?void 0:lt.version,metadata:Qe.metadata})}else Qe._type===3?st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(We.from)}}),Qe.newMetadata&&st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ye=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ye===void 0?void 0:Ye.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(pe.from)}}):Qe._type===6&&st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((at=Qe.newOutputItems)===null||at===void 0?void 0:at.map(ye.from))||[],append:Qe.append}});return st}_e.from=De;function ae(Z){const Oe=new d.WorkspaceEdit;for(const Te of Z.edits)Te.edit?Oe.replace(y.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Oe.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Oe}_e.to=ae})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(_e){const De=Object.create(null);De[d.SymbolKind.File]=0,De[d.SymbolKind.Module]=1,De[d.SymbolKind.Namespace]=2,De[d.SymbolKind.Package]=3,De[d.SymbolKind.Class]=4,De[d.SymbolKind.Method]=5,De[d.SymbolKind.Property]=6,De[d.SymbolKind.Field]=7,De[d.SymbolKind.Constructor]=8,De[d.SymbolKind.Enum]=9,De[d.SymbolKind.Interface]=10,De[d.SymbolKind.Function]=11,De[d.SymbolKind.Variable]=12,De[d.SymbolKind.Constant]=13,De[d.SymbolKind.String]=14,De[d.SymbolKind.Number]=15,De[d.SymbolKind.Boolean]=16,De[d.SymbolKind.Array]=17,De[d.SymbolKind.Object]=18,De[d.SymbolKind.Key]=19,De[d.SymbolKind.Null]=20,De[d.SymbolKind.EnumMember]=21,De[d.SymbolKind.Struct]=22,De[d.SymbolKind.Event]=23,De[d.SymbolKind.Operator]=24,De[d.SymbolKind.TypeParameter]=25;function ae(Oe){return typeof De[Oe]=="number"?De[Oe]:6}_e.from=ae;function Z(Oe){for(const Te in De)if(De[Te]===Oe)return Number(Te);return d.SymbolKind.Property}_e.to=Z})(j=e.SymbolKind||(e.SymbolKind={}));var x;(function(_e){function De(Z){switch(Z){case d.SymbolTag.Deprecated:return 1}}_e.from=De;function ae(Z){switch(Z){case 1:return d.SymbolTag.Deprecated}}_e.to=ae})(x=e.SymbolTag||(e.SymbolTag={}));var $;(function(_e){function De(Z){return{name:Z.name,kind:j.from(Z.kind),tags:Z.tags&&Z.tags.map(x.from),containerName:Z.containerName,location:O.from(Z.location)}}_e.from=De;function ae(Z){const Oe=new d.SymbolInformation(Z.name,j.to(Z.kind),Z.containerName,O.to(Z.location));return Oe.tags=Z.tags&&Z.tags.map(x.to),Oe}_e.to=ae})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var F;(function(_e){function De(Z){var Oe,Te;const Je={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),kind:j.from(Z.kind),tags:(Te=(Oe=Z.tags)===null||Oe===void 0?void 0:Oe.map(x.from))!==null&&Te!==void 0?Te:[]};return Z.children&&(Je.children=Z.children.map(De)),Je}_e.from=De;function ae(Z){const Oe=new d.DocumentSymbol(Z.name,Z.detail,j.to(Z.kind),w.to(Z.range),w.to(Z.selectionRange));return(0,_.isNonEmptyArray)(Z.tags)&&(Oe.tags=Z.tags.map(x.to)),Z.children&&(Oe.children=Z.children.map(ae)),Oe}_e.to=ae})(F=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(_e){function De(ae){const Z=new d.CallHierarchyItem(j.to(ae.kind),ae.name,ae.detail||"",y.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return Z._sessionId=ae._sessionId,Z._itemId=ae._itemId,Z}_e.to=De})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(_e){function De(ae){return new d.CallHierarchyIncomingCall(U.to(ae.from),ae.fromRanges.map(Z=>w.to(Z)))}_e.to=De})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(_e){function De(ae){return new d.CallHierarchyOutgoingCall(U.to(ae.to),ae.fromRanges.map(Z=>w.to(Z)))}_e.to=De})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(_e){function De(Z){return{range:Z.range&&w.from(Z.range),uri:Z.uri}}_e.from=De;function ae(Z){return new d.Location(y.URI.revive(Z.uri),w.to(Z.range))}_e.to=ae})(O=e.location||(e.location={}));var V;(function(_e){function De(Z){const Oe=Z,Te=Z;return{originSelectionRange:Oe.originSelectionRange?w.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Te.uri,range:w.from(Oe.targetRange?Oe.targetRange:Te.range),targetSelectionRange:Oe.targetSelectionRange?w.from(Oe.targetSelectionRange):void 0}}_e.from=De;function ae(Z){return{targetUri:y.URI.revive(Z.uri),targetRange:w.to(Z.range),targetSelectionRange:Z.targetSelectionRange?w.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?w.to(Z.originSelectionRange):void 0}}_e.to=ae})(V=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(_e){function De(Z){return{range:w.from(Z.range),contents:o.fromMany(Z.contents)}}_e.from=De;function ae(Z){return new d.Hover(Z.contents.map(o.to),w.to(Z.range))}_e.to=ae})(q=e.Hover||(e.Hover={}));var X;(function(_e){function De(Z){return{range:w.from(Z.range),expression:Z.expression}}_e.from=De;function ae(Z){return new d.EvaluatableExpression(w.to(Z.range),Z.expression)}_e.to=ae})(X=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(_e){function De(Z){if(Z instanceof d.InlineValueText)return{type:"text",range:w.from(Z.range),text:Z.text};if(Z instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=De;function ae(Z){switch(Z.type){case"text":return{range:w.to(Z.range),text:Z.text};case"variable":return{range:w.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:w.to(Z.range),expression:Z.expression}}}_e.to=ae})(fe=e.InlineValue||(e.InlineValue={}));var ve;(function(_e){function De(Z){return{frameId:Z.frameId,stoppedLocation:w.from(Z.stoppedLocation)}}_e.from=De;function ae(Z){return new d.InlineValueContext(Z.frameId,w.to(Z.stoppedLocation))}_e.to=ae})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Ae;(function(_e){function De(Z){return{range:w.from(Z.range),kind:Z.kind}}_e.from=De;function ae(Z){return new d.DocumentHighlight(w.to(Z.range),Z.kind)}_e.to=ae})(Ae=e.DocumentHighlight||(e.DocumentHighlight={}));var Pe;(function(_e){function De(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}_e.to=De})(Pe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(_e){function De(ae){return{triggerKind:Pe.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}_e.to=De})(Fe=e.CompletionContext||(e.CompletionContext={}));var z;(function(_e){function De(Z){switch(Z){case d.CompletionItemTag.Deprecated:return 1}}_e.from=De;function ae(Z){switch(Z){case 1:return d.CompletionItemTag.Deprecated}}_e.to=ae})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(_e){const De=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Te){var Je;return(Je=De.get(Te))!==null&&Je!==void 0?Je:9}_e.from=ae;const Z=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Oe(Te){var Je;return(Je=Z.get(Te))!==null&&Je!==void 0?Je:d.CompletionItemKind.Property}_e.to=Oe})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(_e){function De(ae,Z){var Oe;const Te=new d.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Te.label2=ae.label),Te.insertText=ae.insertText,Te.kind=J.to(ae.kind),Te.tags=(Oe=ae.tags)===null||Oe===void 0?void 0:Oe.map(z.to),Te.detail=ae.detail,Te.documentation=P.isMarkdownString(ae.documentation)?o.to(ae.documentation):ae.documentation,Te.sortText=ae.sortText,Te.filterText=ae.filterText,Te.preselect=ae.preselect,Te.commitCharacters=ae.commitCharacters,n.Range.isIRange(ae.range)?Te.range=w.to(ae.range):typeof ae.range=="object"&&(Te.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Te.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Te.insertText=new d.SnippetString(ae.insertText):(Te.insertText=ae.insertText,Te.textEdit=Te.range instanceof d.Range?new d.TextEdit(Te.range,Te.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Je=>W.to(Je))),Te.command=Z&&ae.command?Z.fromInternal(ae.command):void 0,Te}_e.to=De})(te=e.CompletionItem||(e.CompletionItem={}));var le;(function(_e){function De(Z){return{label:Z.label,documentation:Z.documentation?o.fromStrict(Z.documentation):void 0}}_e.from=De;function ae(Z){return{label:Z.label,documentation:P.isMarkdownString(Z.documentation)?o.to(Z.documentation):Z.documentation}}_e.to=ae})(le=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(_e){function De(Z){return{label:Z.label,documentation:Z.documentation?o.fromStrict(Z.documentation):void 0,parameters:Array.isArray(Z.parameters)?Z.parameters.map(le.from):[],activeParameter:Z.activeParameter}}_e.from=De;function ae(Z){return{label:Z.label,documentation:P.isMarkdownString(Z.documentation)?o.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(le.to):[],activeParameter:Z.activeParameter}}_e.to=ae})(he=e.SignatureInformation||(e.SignatureInformation={}));var Ce;(function(_e){function De(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(he.from):[]}}_e.from=De;function ae(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(he.to):[]}}_e.to=ae})(Ce=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(_e){function De(Z){var Oe;return{text:Z.text,range:w.from(Z.range),kind:we.from((Oe=Z.kind)!==null&&Oe!==void 0?Oe:d.InlineHintKind.Other),description:Z.description&&o.fromStrict(Z.description),whitespaceBefore:Z.whitespaceBefore,whitespaceAfter:Z.whitespaceAfter}}_e.from=De;function ae(Z){const Oe=new d.InlineHint(Z.text,w.to(Z.range),we.to(Z.kind));return Oe.whitespaceAfter=Z.whitespaceAfter,Oe.whitespaceBefore=Z.whitespaceBefore,Oe.description=P.isMarkdownString(Z.description)?o.to(Z.description):Z.description,Oe}_e.to=ae})(Me=e.InlineHint||(e.InlineHint={}));var we;(function(_e){function De(Z){return Z}_e.from=De;function ae(Z){return Z}_e.to=ae})(we=e.InlineHintKind||(e.InlineHintKind={}));var ke;(function(_e){function De(Z){return{range:w.from(Z.range),url:Z.target,tooltip:Z.tooltip}}_e.from=De;function ae(Z){let Oe;if(Z.url)try{Oe=typeof Z.url=="string"?y.URI.parse(Z.url,!0):y.URI.revive(Z.url)}catch(Te){}return new d.DocumentLink(w.to(Z.range),Oe)}_e.to=ae})(ke=e.DocumentLink||(e.DocumentLink={}));var Re;(function(_e){function De(Z){const Oe=new d.ColorPresentation(Z.label);return Z.textEdit&&(Oe.textEdit=W.to(Z.textEdit)),Z.additionalTextEdits&&(Oe.additionalTextEdits=Z.additionalTextEdits.map(Te=>W.to(Te))),Oe}_e.to=De;function ae(Z){return{label:Z.label,textEdit:Z.textEdit?W.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Oe=>W.from(Oe)):void 0}}_e.from=ae})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(_e){function De(Z){return new d.Color(Z[0],Z[1],Z[2],Z[3])}_e.to=De;function ae(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}_e.from=ae})(Be=e.Color||(e.Color={}));var Ee;(function(_e){function De(Z){return{range:w.from(Z.range)}}_e.from=De;function ae(Z){return new d.SelectionRange(w.to(Z.range))}_e.to=ae})(Ee=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(_e){function De(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}_e.to=De})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(_e){function De(Z){switch(Z){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=De;function ae(Z){switch(Z){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}_e.to=ae})(Q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(_e){function De(Z){if(Z===d.EndOfLine.CRLF)return 1;if(Z===d.EndOfLine.LF)return 0}_e.from=De;function ae(Z){if(Z===1)return d.EndOfLine.CRLF;if(Z===0)return d.EndOfLine.LF}_e.to=ae})(re=e.EndOfLine||(e.EndOfLine={}));var be;(function(_e){function De(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=De})(be=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(_e){function De(ae){const Z={start:ae.start+1,end:ae.end+1};return ae.kind&&(Z.kind=ze.from(ae.kind)),Z}_e.from=De})(Ue=e.FoldingRange||(e.FoldingRange={}));var ze;(function(_e){function De(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return R.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return R.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return R.FoldingRangeKind.Region}}_e.from=De})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(_e){function De(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?C.EditorOverride.DISABLED:void 0}}_e.from=De})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(_e){function De(Z){return Z instanceof d.RelativePattern||typeof Z=="string"?Z:ae(Z)?new d.RelativePattern(Z.base,Z.pattern):Z}_e.from=De;function ae(Z){const Oe=Z;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var K;(function(_e){function De(ae){if(ae){if(Array.isArray(ae))return ae.map(De);if(typeof ae=="string")return ae;{const Z=ae;return{language:Z.language,scheme:Z.scheme,pattern:typeof Z.pattern=="undefined"?void 0:Ze.from(Z.pattern),exclusive:Z.exclusive}}}else return}_e.from=De})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(_e){function De(Z){return{start:Z.start,end:Z.end}}_e.from=De;function ae(Z){return new d.NotebookRange(Z.start,Z.end)}_e.to=ae})(oe=e.NotebookRange||(e.NotebookRange={}));var de;(function(_e){function De(ae){return new d.NotebookCellMetadata(ae.inputCollapsed,ae.outputCollapsed).with({custom:ae.custom})}_e.to=De})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Y;(function(_e){function De(Z){return Z}_e.from=De;function ae(Z){return new d.NotebookDocumentMetadata(Z.trusted,Z.custom)}_e.to=ae})(Y=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ie;(function(_e){function De(Z){return{startTime:Z.runStartTime,endTime:Z.runEndTime,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}_e.to=De;function ae(Z){return{lastRunSuccess:Z.success,runStartTime:Z.startTime,runEndTime:Z.endTime,executionOrder:Z.executionOrder}}_e.from=ae})(ie=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(_e){function De(Z){switch(Z){case d.NotebookCellKind.Markdown:return m.CellKind.Markdown;case d.NotebookCellKind.Code:default:return m.CellKind.Code}}_e.from=De;function ae(Z){switch(Z){case m.CellKind.Markdown:return d.NotebookCellKind.Markdown;case m.CellKind.Code:default:return d.NotebookCellKind.Code}}_e.to=ae})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(_e){function De(Z){var Oe;return{cellKind:ce.from(Z.kind),language:Z.language,source:Z.source,metadata:Object.assign(Object.assign({},Z.metadata),ie.from((Oe=Z.latestExecutionSummary)!==null&&Oe!==void 0?Oe:{})),outputs:Z.outputs?Z.outputs.map(We.from):[]}}_e.from=De;function ae(Z){return new d.NotebookCellData(ce.to(Z.cellKind),Z.source,Z.language,Z.outputs?Z.outputs.map(We.to):void 0,Z.metadata?de.to(Z.metadata):void 0)}_e.to=ae})(pe=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(_e){function De(Z){return{mime:Z.mime,value:Z.value,metadata:Z.metadata}}_e.from=De;function ae(Z){return new d.NotebookCellOutputItem(Z.mime,Z.value,Z.metadata)}_e.to=ae})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(_e){function De(Z){return{outputId:Z.id,outputs:Z.outputs.map(ye.from),metadata:Z.metadata}}_e.from=De;function ae(Z){const Oe=Z.outputs.map(ye.to);return new d.NotebookCellOutput(Oe,Z.outputId,Z.metadata)}_e.to=ae})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(_e){function De(Te){if(Te!=null){if(Te instanceof d.RelativePattern||typeof Te=="string")return Te;if(Oe(Te))return new d.RelativePattern(Te.base,Te.pattern);if(Z(Te))return{include:Ze.from(Te.include)||void 0,exclude:Ze.from(Te.exclude)||void 0}}}_e.from=De;function ae(Te){return typeof Te=="string"?Te:Oe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}_e.to=ae;function Z(Te){const Je=Te,Ye=Ze.from(Je.include);if(!(Ye&&Ye instanceof d.RelativePattern||typeof Ye=="string"))return!1;const at=Ze.from(Je.exclude);return!!(at&&at instanceof d.RelativePattern||typeof at=="string")}function Oe(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ke;(function(_e){function De(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?f.from(ae.top):void 0}}_e.from=De})(Ke=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(_e){function De(ae,Z,Oe){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Te,Oe),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}_e.from=De})(Xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(_e){function De(ae){var Z;return{transientOutputs:(Z=ae==null?void 0:ae.transientOutputs)!==null&&Z!==void 0?Z:!1,transientMetadata:Object.assign(Object.assign({},ae==null?void 0:ae.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0})}}_e.from=De})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(_e){function De(Z){var Oe;return{uri:Z.uri,provides:typeof Z.provides=="string"?[Z.provides]:(Oe=Z.provides)!==null&&Oe!==void 0?Oe:[]}}_e.from=De;function ae(Z){return{uri:y.URI.revive(Z.uri),provides:Z.provides}}_e.to=ae})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var ot;(function(_e){function De(Z){return{message:o.fromStrict(Z.message)||"",severity:Z.severity,expectedOutput:Z.expectedOutput,actualOutput:Z.actualOutput,location:Z.location?O.from(Z.location):void 0}}_e.from=De;function ae(Z){const Oe=new d.TestMessage(typeof Z.message=="string"?Z.message:o.to(Z.message));return Oe.severity=Z.severity,Oe.actualOutput=Z.actualOutput,Oe.expectedOutput=Z.expectedOutput,Oe}_e.to=ae})(ot=e.TestMessage||(e.TestMessage={}));var it;(function(_e){function De(Te){var Je,Ye;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description,runnable:(Ye=Te.runnable)!==null&&Ye!==void 0?Ye:!0,expandable:Te.expandable}}_e.from=De;function ae(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:!1,description:Te.description,runnable:!0,expandable:!0}}_e.fromResultSnapshot=ae;function Z(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:w.to(Te.range),expandable:Te.expandable,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}_e.toPlain=Z;function Oe(Te){const Je=new d.TestItem(Te.extId,Te.label,y.URI.revive(Te.uri),Te.expandable);return Je.range=w.to(Te.range),Je.debuggable=Te.debuggable,Je.description=Te.description,Je.runnable=Te.runnable,Je}_e.to=Oe})(it=e.TestItem||(e.TestItem={}));var pt;(function(_e){function De(Oe,Te){var Je,Ye,at;const st={completedAt:Te.completedAt,id:Oe,output:Te.output,items:[]},Qe=[[null,Te.results]];for(;Qe.length;){const[lt,bt]=Qe.pop();for(const ut of bt){const vt={children:(Ye=(Je=ut.children)===null||Je===void 0?void 0:Je.map(Et=>Et.id))!==null&&Ye!==void 0?Ye:[],computedState:ut.state,item:it.fromResultSnapshot(ut),state:{state:ut.state,duration:ut.duration,messages:ut.messages.map(ot.from)},retired:void 0,expand:3,parent:(at=lt==null?void 0:lt.item.extId)!==null&&at!==void 0?at:null,src:{provider:"",tree:-1},direct:!lt};st.items.push(vt),ut.children&&Qe.push([vt,ut.children])}}return st}_e.from=De;const ae=(Oe,Te)=>Object.assign(Object.assign({},it.toPlain(Oe.item)),{state:Oe.state.state,duration:Oe.state.duration,messages:Oe.state.messages.map(ot.to),children:Oe.children.map(Je=>Te.get(Je)).filter(k.isDefined).map(Je=>ae(Je,Te))});function Z(Oe){const Te=[],Je=new Map;for(const Ye of Oe.items)Je.set(Ye.item.extId,Ye),Ye.direct&&Te.push(Ye);return{completedAt:Oe.completedAt,results:Te.map(Ye=>ae(Ye,Je))}}_e.to=Z})(pt=e.TestResults||(e.TestResults={}));var qe;(function(_e){function De(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}_e.to=De})(qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[215],ge([0,1,2,18,7,20,55]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(n,R,C,g={timeout:1500,errors:3}){this._logService=n,this._documents=R,this._mainThreadBulkEdits=C,this._thresholds=g,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(R,C,g)=>{const s={dispose:this._callbacks.push([R,C,n])};return Array.isArray(g)&&g.push(s),s}}async $participateInSave(n,R){const C=_.URI.revive(n);let g=!1;const m=setTimeout(()=>g=!0,this._thresholds.timeout),s=[];try{for(let d of[...this._callbacks]){if(g)break;const S=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(d,{document:S,reason:I.TextDocumentSaveReason.to(R)});s.push(w)}}finally{clearTimeout(m)}return s}_deliverEventAsyncAndBlameBadListeners([n,R,C],g){const m=this._badListeners.get(n);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,n,R,g).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const d=this._badListeners.get(n);this._badListeners.set(n,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,R,C,g){const m=[],s=Date.now(),{document:d,reason:S}=g,{version:w}=d,b=Object.freeze({document:d,reason:S,waitUntil(v){if(Object.isFrozen(m))throw(0,P.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(v))}});try{R.apply(C,[b])}catch(v){return Promise.reject(v)}return Object.freeze(m),new Promise((v,u)=>{const l=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(l),v(t)}).catch(t=>{clearTimeout(l),u(t)})}).then(v=>{const u={edits:[]};for(const l of v)if(Array.isArray(l)&&l.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:i,range:a}of l)u.edits.push({_type:2,resource:d.uri,edit:{range:a&&I.Range.from(a),text:t,eol:i&&I.EndOfLine.from(i)}});if(u.edits.length!==0)return w===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(me[216],ge([0,1,3,19,33,2,20,7]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,g,m,s,d){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,m&&(this._config+=1),s&&(this._config+=2),d&&(this._config+=4);const S=(0,A.parse)(g),w=C(b=>{if(!m)for(let v of b.created){const u=I.URI.revive(v);S(u.fsPath)&&this._onDidCreate.fire(u)}if(!s)for(let v of b.changed){const u=I.URI.revive(v);S(u.fsPath)&&this._onDidChange.fire(u)}if(!d)for(let v of b.deleted){const u=I.URI.revive(v);S(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(C,g,m){this._logService=g,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new P.AsyncEmitter,this._onWillCreateFile=new P.AsyncEmitter,this._onWillDeleteFile=new P.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,g,m,s){return new y(this._onFileSystemEvent.event,C,g,m,s)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,g){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(m=>({oldUri:I.URI.revive(m.source),newUri:I.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(m=>I.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(m=>I.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,g){return(m,s,d)=>{const S=function(b){m.call(s,b)};return S.extension=C,g.event(S,void 0,d)}}async $onWillRunFileOperation(C,g,m,s){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},m,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(d=>I.URI.revive(d.target))},m,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(d=>I.URI.revive(d.target))},m,s)}}async _fireWillEvent(C,g,m,s){const d=new Set,S=[];if(await C.fireAsync(g,s,async(b,v)=>{var u;const l=Date.now(),t=await Promise.resolve(b);t instanceof k.WorkspaceEdit&&(S.push(t),d.add((u=v.extension.displayName)!==null&&u!==void 0?u:v.extension.identifier.value)),Date.now()-l>m&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),!s.isCancellationRequested&&S.length!==0){const w={edits:[]};for(let b of S){let{edits:v}=D.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(v)}return{edit:w,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=n}),define(me[217],ge([0,1,11,23,2,20,7,86]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(g,m,s,d){this.start=g,this.deletedCount=m,this.deletedItems=s,this.items=d}static asApiEvents(g){return g.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(s=>s.cell)}))}}class n{constructor(g,m,s){var d;this._notebook=g,this._extHostDocument=m,this._cellData=s,this.handle=s.handle,this.uri=A.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=(d=s.metadata)!==null&&d!==void 0?d:{},this._metadata=I.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=I.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(g,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:g}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const g=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return g._notebook.getCellIndex(g)},notebook:g._notebook.notebookDocument,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return g._outputs.slice(0)},get metadata(){return g._metadata},get latestExecutionSummary(){return g._previousResult}})}return this._cell}setOutputs(g){this._outputs=g.map(I.NotebookCellOutput.to)}setOutputItems(g,m,s){const d=s.map(I.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===g);S&&(m||(S.outputs.length=0),S.outputs.push(...d))}setMetadata(g){this._internalMetadata=g,this._metadata=I.NotebookCellMetadata.to(g),this._previousResult=I.NotebookCellPreviousExecutionResult.to(g)}}e.ExtHostCell=n;class R{constructor(g,m,s,d,S,w,b){this._proxy=g,this._textDocumentsAndEditors=m,this._textDocuments=s,this._emitter=d,this._viewType=S,this._metadata=w,this.uri=b,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const g=this;this._notebook={get uri(){return g.uri},get version(){return g._versionId},get viewType(){return g._viewType},get isDirty(){return g._isDirty},get isUntitled(){return g.uri.scheme===_.Schemas.untitled},get isClosed(){return g._disposed},get metadata(){return g._metadata},get cellCount(){return g._cells.length},cellAt(m){return m=g._validateIndex(m),g._cells[m].cell},getCells(m){return(m?g._getCells(m):g._cells).map(d=>d.cell)},save(){return g._save()}}}return this._notebook}updateBackup(g){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=g}disposeBackup(){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(g){g.metadata&&(this._metadata=this._metadata.with(g.metadata))}acceptModelChanged(g,m){this._versionId=g.versionId,this._isDirty=m;for(const s of g.rawEvents)s.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(s.changes,!0),s.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1):s.kind===k.NotebookCellsChangeType.Move?this._moveCell(s.index,s.newIdx):s.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(s.index,s.outputs):s.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems):s.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(s.index,s.language):s.kind===k.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(s.index,s.metadata)}_validateIndex(g){return g<0?0:g>=this._cells.length?this._cells.length-1:g}_validateRange(g){return g.start<0&&(g=g.with({start:0})),g.end>this._cells.length&&(g=g.with({end:this._cells.length})),g}_getCells(g){g=this._validateRange(g);const m=[];for(let s=g.start;s<g.end;s++)m.push(this._cells[s]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(g,m){if(!this._disposed){const s=[],d=[],S=[];g.reverse().forEach(w=>{const v=w[2].map(t=>{const i=new n(this,this._textDocumentsAndEditors,t);return m||d.push(n.asModelAddData(this.notebookDocument,t)),i}),u=new y(w[0],w[1],[],v),l=this._cells.splice(w[0],w[1],...v);for(let t of l)S.push(t.uri),u.deletedItems.push(t.cell);s.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:S}),m||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(s)}))}}_moveCell(g,m){const s=this._cells.splice(g,1);this._cells.splice(m,0,...s);const d=[new y(g,1,s.map(S=>S.cell),[]),new y(m,0,[],s)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(d)}))}_setCellOutputs(g,m){const s=this._cells[g];s.setOutputs(m),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[s.cell]}))}_setCellOutputItems(g,m,s,d){const S=this._cells[g];S.setOutputItems(m,s,d),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_changeCellLanguage(g,m){const s=this._cells[g];s.cell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(s.uri,m)}_changeCellMetadata(g,m){var s;const d=this._cells[g],S=d.internalMetadata,w=d.cell.metadata;d.setMetadata(m);const b=d.cell.metadata;if((0,P.equals)(w,b)||this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:d.cell})),S.runState!==m.runState){const v=(s=m.runState)!==null&&s!==void 0?s:D.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,P.deepFreeze)({document:this.notebookDocument,cell:d.cell,executionState:v}))}}getCellFromIndex(g){return this._cells[g]}getCell(g){return this._cells.find(m=>m.handle===g)}getCellIndex(g){return this._cells.indexOf(g)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(me[218],ge([0,1,7,20]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:y})}replaceCellOutput(k,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:k,outputs:y.map(n=>P.NotebookCellOutput.from(n))})}replaceCells(k,y,n){this._throwIfFinalized(),!(k===y&&n.length===0)&&this._collectedEdits.push({editType:1,index:k,count:y-k,cells:n.map(P.NotebookCellData.from)})}}class I{constructor(k,y,n,R,C,g){this.id=k,this._proxy=y,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=R,this._viewColumn=g}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.notebookDocument},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(y,n){k._proxy.$tryRevealRange(k.id,P.NotebookRange.from(y),n!=null?n:_.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(y){const n=new A(this.document.version);return y(n),k._applyEdit(n.finalize())},get kernel(){return k._kernel},setDecorations(y,n){return k.setDecorations(y,n)}}}return this._editor}_acceptKernel(k){this._kernel=k}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const y=[];let n=-1;for(let R=0;R<k.cellEdits.length;R++){if(n<0){y.push(k.cellEdits[R]),n++;continue}const g=y[n],m=k.cellEdits[R];if(g.editType===1&&m.editType===1&&g.index===m.index){g.cells.push(...k.cellEdits[R].cells),g.count+=k.cellEdits[R].count;continue}y.push(k.cellEdits[R]),n++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,y)}setDecorations(k,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return y.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,P.NotebookRange.from(y),k.key)}}e.ExtHostNotebookEditor=I}),define(me[219],ge([0,1,20,112,162,21,69]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,g,m){const s=this._handles++,{title:d,location:S,cancellable:w}=g,b={label:(0,A.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(s,{location:_.ProgressLocation.from(S),title:d,source:b,cancellable:w},C),this._withProgress(s,m,!!w)}_withProgress(C,g,m){let s;m&&(s=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,s));const d=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),s&&s.dispose()};let S;try{S=g(new n(this._proxy,C),m&&s?s.token:I.CancellationToken.None)}catch(w){throw d(C),w}return S.then(w=>d(C),w=>d(C)),S}$acceptProgressCanceled(C){const g=this._mapHandleToCancellationSource.get(C);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function y(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class n extends P.Progress{constructor(C,g){super(m=>this.throttledReport(m));this._proxy=C,this._handle=g}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,D.throttle)(100,(R,C)=>y(R,C),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(me[122],ge([0,1,52,18,71,20,7]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(g,m){const s=k._Keys.nextId();g.$registerTextEditorDecorationType(s,I.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){g.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=k,k._Keys=new A.IdGenerator("TextEditorDecorationType");class y{constructor(g,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,m){this._throwIfFinalized();let s=null;if(g instanceof D.Position)s=new D.Range(g,g);else if(g instanceof D.Range)s=g;else throw new Error("Unrecognized location");this._pushEdit(s,m,!1)}insert(g,m){this._throwIfFinalized(),this._pushEdit(new D.Range(g,g),m,!0)}delete(g){this._throwIfFinalized();let m=null;if(g instanceof D.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(g,m,s){const d=this._document.validateRange(g);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:s})}setEndOfLine(g){if(this._throwIfFinalized(),g!==D.EndOfLine.LF&&g!==D.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=y;class n{constructor(g,m,s,d){this._proxy=g,this._id=m,this._accept(s),this._logService=d;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const m=Math.floor(g);return m>0?m:null}if(typeof g=="string"){const m=parseInt(g,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(g){const m=this._validateTabSize(g);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const m=this._validateInsertSpaces(g);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(g)})))}assign(g){const m={};let s=!1;if(typeof g.tabSize!="undefined"){const d=this._validateTabSize(g.tabSize);d==="auto"?(s=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,s=!0,m.tabSize=d)}if(typeof g.insertSpaces!="undefined"){const d=this._validateInsertSpaces(g.insertSpaces);d==="auto"?(s=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,s=!0,m.insertSpaces=d)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,s=!0,m.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,s=!0,m.lineNumbers=I.TextEditorLineNumbersStyle.from(g.lineNumbers)),s&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(g){g.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=n;class R{constructor(g,m,s,d,S,w,b,v){this.id=g,this._proxy=m,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new n(this._proxy,this.id,w,s),this._visibleRanges=b,this._viewColumn=v;const u=this;this.value=Object.freeze({get document(){return d.getValue()},set document(l){throw(0,P.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(l){if(!(l instanceof D.Selection))throw(0,P.illegalArgument)("selection");u._selections=[l],u._trySetSelection()},get selections(){return u._selections},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof D.Selection)))throw(0,P.illegalArgument)("selections");u._selections=l,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(l){throw(0,P.readonly)("visibleRanges")},get options(){return u._options.value},set options(l){u._disposed||u._options.assign(l)},get viewColumn(){return u._viewColumn},set viewColumn(l){throw(0,P.readonly)("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(d.getValue(),t);return l(i),u._applyEdit(i)},insertSnippet(l,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=u._selections.map(r=>I.Range.from(r));else if(t instanceof D.Position){const{lineNumber:r,column:c}=I.Position.from(t);a=[{startLineNumber:r,startColumn:c,endLineNumber:r,endColumn:c}]}else if(t instanceof D.Range)a=[I.Range.from(t)];else{a=[];for(const r of t)if(r instanceof D.Range)a.push(I.Range.from(r));else{const{lineNumber:c,column:o}=I.Position.from(r);a.push({startLineNumber:c,startColumn:o,endLineNumber:c,endColumn:o})}}return m.$tryInsertSnippet(g,l.value,a,i)},setDecorations(l,t){const i=t.length===0;i&&!u._hasDecorationsForKey.has(l.key)||(i?u._hasDecorationsForKey.delete(l.key):u._hasDecorationsForKey.add(l.key),u._runOnProxy(()=>{if(I.isDecorationOptionsArr(t))return m.$trySetDecorations(g,l.key,I.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let r=0,c=t.length;r<c;r++){const o=t[r];a[4*r]=o.start.line+1,a[4*r+1]=o.start.character+1,a[4*r+2]=o.end.line+1,a[4*r+3]=o.end.character+1}return m.$trySetDecorationsFast(g,l.key,a)}}))},revealRange(l,t){u._runOnProxy(()=>m.$tryRevealRange(g,I.Range.from(l),t||D.TextEditorRevealType.Default))},show(l){m.$tryShowEditor(g,I.ViewColumn.from(l))},hide(){m.$tryHideEditor(g)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,_.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,_.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,_.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,_.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const m=g.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const s=m.edits.map(S=>S.range);s.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=s.length-1;S<w;S++){const b=s[S].end;if(s[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(S=>({range:I.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?I.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=R}),define(me[220],ge([0,1,165,25,2,3,6,19,7,15,14,20,21]),function(G,e,_,P,A,I,D,k,y,n,R,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(S,w){if((0,n.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let b;return Array.isArray(S.highlights)&&(b=S.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),b=b.length?b:void 0),{label:S.label,highlights:b}}}class s{constructor(w,b,v){this._proxy=w,this.commands=b,this.logService=v,this.treeViews=new Map;function u(l){return l&&l.$treeViewId&&l.$treeItemHandle}b.registerArgumentProcessor({processArgument:l=>u(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(t=>u(t)?this.convertArgument(t):t):l})}registerTreeDataProvider(w,b,v){const u=this.createTreeView(w,{treeDataProvider:b},v);return{dispose:()=>u.dispose()}}createTreeView(w,b,v){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),l=this.createExtHostTreeView(w,b,v);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get message(){return l.message},set message(t){l.message=t},get title(){return l.title},set title(t){l.title=t},get description(){return l.description},set description(t){l.description=t},reveal:(t,i)=>l.reveal(t,i),dispose:async()=>{await u,this.treeViews.delete(w),l.dispose()}}}$getChildren(w,b){const v=this.treeViews.get(w);return v?v.getChildren(b):Promise.reject(new Error((0,_.localize)(0,null,w)))}async $hasResolve(w){const b=this.treeViews.get(w);if(!b)throw new Error((0,_.localize)(1,null,w));return b.hasResolve}$resolve(w,b,v){const u=this.treeViews.get(w);if(!u)throw new Error((0,_.localize)(2,null,w));return u.resolveTreeItem(b,v)}$setExpanded(w,b,v){const u=this.treeViews.get(w);if(!u)throw new Error((0,_.localize)(3,null,w));u.setExpanded(b,v)}$setSelection(w,b){const v=this.treeViews.get(w);if(!v)throw new Error((0,_.localize)(4,null,w));v.setSelection(b)}$setVisible(w,b){const v=this.treeViews.get(w);if(!v)throw new Error((0,_.localize)(5,null,w));v.setVisible(b)}createExtHostTreeView(w,b,v){const u=new d(w,b,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(w,u),u}convertArgument(w){const b=this.treeViews.get(w.$treeViewId);return b?b.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=s;class d extends D.Disposable{constructor(w,b,v,u,l,t){super();if(this.viewId=w,this.proxy=v,this.commands=u,this.logService=l,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const c of t.contributes.views[r])c.id===w&&(this._title=c.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let i,a;this._register(I.Event.debounce(this._onDidChangeData.event,(r,c)=>(r||(r={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(o=>a=o),this.refreshPromise=this.refreshPromise.then(()=>i)),r.elements.push(c.element)),c.message&&(r.message=!0),r),200,!0)(({message:r,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=a;return i=null,this.refresh(c).then(()=>o())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,n.isUndefinedOrNull)(w))}getChildren(w){const b=w?this.getExtensionElement(w):void 0;if(w&&!b)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(w);return(v?Promise.resolve(v):this.fetchChildrenNodes(b)).then(u=>u.map(l=>l.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,b){b=b||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(b.select)?!0:b.select,u=(0,n.isUndefinedOrNull)(b.focus)?!1:b.focus,l=(0,n.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(a=>a.item)},{select:v,focus:u,expand:l})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:u,expand:l})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,b){const v=this.getExtensionElement(w);v&&(b?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(w){(0,R.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,b){var v;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(w);if(u){const l=this.nodes.get(u);if(l){const t=(v=await this.dataProvider.resolveTreeItem(l.extensionItem,u,b))!==null&&v!==void 0?v:l.extensionItem;return l.item.tooltip=this.getTooltip(t.tooltip),l.item.command=this.getCommand(l.disposableStore,t.command),l.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(b=>b?this.resolveUnknownParentChain(b).then(v=>this.resolveTreeNode(b,v[v.length-1]).then(u=>(v.push(u),v))):Promise.resolve([]))}resolveParent(w){const b=this.nodes.get(w);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,b){const v=this.nodes.get(w);return v?Promise.resolve(v):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(u=>this.createHandle(w,u,b,!0)).then(u=>this.getChildren(b?b.item.handle:void 0).then(()=>{const l=this.getExtensionElement(u);if(l){const t=this.nodes.get(l);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(w){if(w){let b;if(typeof w=="string"){const v=this.getExtensionElement(w);b=v?this.nodes.get(v):void 0}else b=w;return b&&b.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const b=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=w?this.nodes.get(w):void 0,u=await this.dataProvider.getChildren(w);if(b.token.isCancellationRequested)return[];const l=await Promise.all((0,R.coalesce)(u||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,v):null}));return b.token.isCancellationRequested?[]:(0,R.coalesce)(l)}finally{b.dispose()}}refresh(w){if(w.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(w);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const b=new Set,v=w.map(l=>this.nodes.get(l));for(const l of v)if(l&&!b.has(l.item.handle)){let t=l;for(;t&&t.parent&&v.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(l.item.handle)}const u=[];return b.forEach(l=>{const t=this.elements.get(l);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&u.push(l)}}),u}refreshHandles(w){const b={};return Promise.all(w.map(v=>this.refreshNode(v).then(u=>{u&&(b[v]=u.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(w){const b=this.getExtensionElement(w);if(b){const v=this.nodes.get(b);if(v)return this.clearChildren(b),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(u=>{if(u){const l=this.createTreeNode(b,u,v.parent);return this.updateNodeCache(b,l,v,v.parent),v.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,b,v){const u=this.createTreeNode(w,b,v);if(b.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,b.id));return this.addNodeToCache(w,u),this.addNodeToParentCache(u,v),u}getTooltip(w){return y.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,b){return b?this.commands.toInternal(b,w):void 0}createTreeNode(w,b,v){const u=new D.DisposableStore,l=this.createHandle(w,b,v),t=this.getLightIconPath(b);return{item:{handle:l,parentHandle:v?v.item.handle:void 0,label:m(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(u,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,n.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:v,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(w){return w.iconPath instanceof y.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:b,label:v,resourceUri:u},l,t){if(b)return`${d.ID_HANDLE_PREFIX}/${b}`;const i=m(v,this.extension),a=l?l.item.handle:d.LABEL_HANDLE_PREFIX;let r=i?i.label:u?(0,P.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const c=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,o=this.getChildrenNodes(l)||[];let p,E=0;do{if(p=`${a}/${E}:${r}`,t||!this.elements.has(p)||c===p)break;E++}while(E<=o.length);return p}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof y.ThemeIcon))return typeof w.iconPath=="string"||A.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof y.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return A.URI.isUri(w)?w:A.URI.file(w)}addNodeToCache(w,b){this.elements.set(b.item.handle,w),this.nodes.set(w,b)}updateNodeCache(w,b,v,u){this.elements.delete(b.item.handle),this.nodes.delete(w),b.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(w,b);const l=this.getChildrenNodes(u)||[],t=l.filter(i=>i.item.handle===v.item.handle)[0];t&&l.splice(l.indexOf(t),1,b)}addNodeToParentCache(w,b){b?(b.children||(b.children=[]),b.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const b=this.nodes.get(w);if(b){if(b.children)for(const v of b.children){const u=this.elements.get(v.item.handle);u&&this.clear(u)}b.children=void 0}}else this.clearAll()}clear(w){const b=this.nodes.get(w);if(b){if(b.children)for(const v of b.children){const u=this.elements.get(v.item.handle);u&&this.clear(u)}this.nodes.delete(w),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,14,19,21,20,7,121]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(s,d){if(d!==void 0){const S=this.testIdsToInternal.get(d),w=S==null?void 0:S.get(s);if(w)return[S,w]}return(0,_.mapFind)(this.testIdsToInternal.values(),S=>{const w=S.get(s);return w&&[S,w]})}createForHierarchy(s=()=>{}){return new g(this.createIdMap(R++),s)}createIdMap(s){const d=new C(s);return this.testIdsToInternal.set(d.id,d),{object:d,dispose:()=>this.testIdsToInternal.delete(d.id)}}}e.OwnedTestCollection=y;var n;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let R=0;class C{constructor(s){this.id=s,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(s){if(this.map.has(s.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${s.item.extId}`);this.map.set(s.item.extId,s),s.parent||this._roots.add(s)}has(s){return this.map.has(s)}delete(s){const d=this.map.get(s);return d?(this.map.delete(s),this._roots.delete(d),!0):!1}get(s){return this.map.get(s)}comparePositions(s,d){const S=typeof s=="string"?this.map.get(s):s,w=typeof d=="string"?this.map.get(d):d;if(!S||!w)return 0;if(S===w)return 3;for(let b=this.map.get(w.parent);b;b=this.map.get(b.parent))if(b===S)return 1;for(let b=this.map.get(S.parent);b;b=this.map.get(b.parent))if(b===w)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=C;class g{constructor(s,d){this.testIdToInternal=s,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new P.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(s,d){this.addItem(s,d,null)}getTestByReference(s){return this.testItemToInternal.get(s)}collectDiff(){const s=this.diff;return this.diff=[],s}pushDiff(s){const d=this.diff[this.diff.length-1];if(d&&s[0]===1){if(d[0]===1&&d[1].extId===s[1].extId){(0,k.applyTestItemUpdate)(d[1],s[1]);return}if(d[0]===0&&d[1].item.extId===s[1].extId){(0,k.applyTestItemUpdate)(d[1],s[1]);return}}this.diff.push(s),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(s,d){var S;const w=this.testIdToInternal.object.get(s);if(!!w){if((w.expandLevels===void 0||d>w.expandLevels)&&(w.expandLevels=d),w.expand===1){const b=this.refreshChildren(w);return b.isSettled?this.expandChildren(w,d-1):b.p.then(()=>this.expandChildren(w,d-1))}else if(w.expand===3)return((S=w.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?w.initialExpand.p.then(()=>this.expandChildren(w,d-1)):this.expandChildren(w,d-1)}}dispose(){var s;for(const d of this.testItemToInternal.values())(s=d.discoverCts)===null||s===void 0||s.dispose(!0),d.actual[D.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(s,d,S){if(!(s instanceof D.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${s.id} did not`);if(this.testItemToInternal.has(s))throw new Error(`Attempted to add a single TestItem ${s.id} multiple times to the tree`);if(this.testIdToInternal.object.has(s.id))throw new Error(`Attempted to insert a duplicate test item ID ${s.id}`);const w=S?S.item.extId:null,b=s.expandable?1:0,v=S==null?void 0:S.expandLevels,u={provider:d,tree:this.testIdToInternal.object.id},l={actual:s,parent:w,item:I.TestItem.from(s),expandLevels:v&&b===1?v-1:void 0,expand:b,src:u};this.testIdToInternal.object.add(l),this.testItemToInternal.set(s,l),this.pushDiff([0,{parent:w,src:u,expand:b,item:l.item}]),s[D.TestItemHookProperty]={created:t=>this.addItem(t,d,l),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:s.id,item:{[t]:t==="range"?I.Range.from(i):i}}])};for(const t of s.children)this.addItem(t,d,l)}expandChildren(s,d){if(!(d<0)){const S=[...s.actual.children].map(w=>this.expand(w.id,d-1)).filter(P.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(s){s.discoverCts&&s.discoverCts.dispose(!0),s.expand=2,s.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(s);const d=new P.DeferredPromise;return s.initialExpand=d,s.actual.discoverChildren({report:S=>{S.busy?(s.expand=2,this.pushExpandStateUpdate(s)):(s.expand=3,d.isSettled||d.complete(),this.pushExpandStateUpdate(s))}},s.discoverCts.token),d}pushExpandStateUpdate(s){this.pushDiff([1,{extId:s.actual.id,expand:s.expand}])}removeItembyId(s){var d;this.pushDiff([2,s]);const S=[this.testIdToInternal.object.get(s)];for(;S.length;){const w=S.pop();if(!!w){(d=w.discoverCts)===null||d===void 0||d.dispose(!0),this.testIdToInternal.object.delete(w.item.extId),this.testItemToInternal.delete(w.actual);for(const b of w.actual.children)S.push(this.testIdToInternal.object.get(b.id))}}}flushDiff(){const s=this.collectDiff();s.length&&this.publishDiff(s)}}e.SingleUseTestCollection=g}),define(me[222],ge([0,1,29,3,8]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=I;class D{constructor(R){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let C of R.activationEvents)C==="onUri"&&(C=`onUri:${_.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(R)}}keepOnly(R){const C=new Set;R.forEach(g=>C.add(_.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>C.has(_.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,C){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const g=D._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(g.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(s=>m.add(_.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!m.has(_.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(g)}static _findLoopingExtensions(R){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const b=C.getArcs(S);for(let v=0;v<b.length;v++)if(!w.has(b[v]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let S of R){const w=_.ExtensionIdentifier.toKey(S.identifier);if(g.set(w,S),S.extensionDependencies)for(let b of S.extensionDependencies){const v=_.ExtensionIdentifier.toKey(b);C.addArc(w,v)}}let m=new Set;C.getNodes().filter(S=>C.getArcs(S).length===0).forEach(S=>m.add(S));let s=C.getNodes().filter(S=>!m.has(S)),d;do{d=!1;for(let S=0;S<s.length;S++){const w=s[S];C.hasOnlyGoodArcs(w,m)&&(s.splice(S,1),S--,m.add(w),d=!0)}}while(d);return s.map(S=>g.get(S))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const C=this._activationMap.get(R);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const C=this._extensionsMap.get(_.ExtensionIdentifier.toKey(R));return C||void 0}}e.ExtensionDescriptionRegistry=D;var k;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(k||(k={}));function y(n,R){const C=n.isBuiltin?0:n.isUnderDevelopment?2:1,g=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(C!==g)return C-g;const m=A.posix.basename(n.extensionLocation.path),s=A.posix.basename(R.extensionLocation.path);return m<s?-1:m>s?1:0}}),define(me[223],ge([0,1,22]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var P;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(P=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function I(k){const y=_.VSBuffer.alloc(1);switch(k){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=I;function D(k,y){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(me[41],ge([0,1,3,2,4,29,183]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class k{constructor(b){this.dependency=b}}e.MissingDependencyError=k;var y;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(b,v,u,l){this.codeLoadingTime=b,this.activateCallTime=v,this.activateResolvedTime=u,this.activationReason=l}}e.ActivationTimes=n;class R{constructor(b,v){this.description=b,this.value=v}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function g(w){w.enableProposedApi||m(w)}e.checkProposedApiEnabled=g;function m(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=m;function s(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=s;function d(w){return Object.assign(Object.assign({identifier:new I.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=d;class S{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(b,v){}_activateById(b,v){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,v,u,l,t){}_onExtensionRuntimeError(b,v){}_onExtensionHostExit(b){}}e.NullExtensionService=S}),define(me[224],ge([0,1,160,29,41,12]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class k{constructor(d,S,w,b){this.startup=d,this.codeLoadingTime=S,this.activateCallTime=w,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,S){return d===-1||S===-1?-1:S-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(d,S,w,b,v,u){this.activationFailed=d,this.activationFailedError=S,this.activationTimes=w,this.module=b,this.exports=v,this.subscriptions=u}}e.ActivatedExtension=n;class R extends n{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class C extends n{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class g extends n{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let m=class{constructor(d,S,w,b,v){this._logService=v,this._registry=d,this._resolvedExtensionsSet=new Set,S.forEach(u=>this._resolvedExtensionsSet.add(P.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,w.forEach(u=>this._hostExtensionsMap.set(P.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const S=P.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(S)}getActivatedExtension(d){const S=P.ExtensionIdentifier.toKey(d),w=this._activatedExtensions.get(S);if(!w)throw new Error("Extension `"+d.value+"` is not known or not activated");return w}activateByEvent(d,S){if(this._alreadyActivatedEvents[d])return D;const w=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(w.map(b=>({id:b.identifier,reason:{startup:S,extensionId:b.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,S){const w=this._registry.getExtensionDescription(d);if(!w)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:w.identifier,reason:S}])}_handleActivateRequest(d,S,w){if(this._hostExtensionsMap.has(P.ExtensionIdentifier.toKey(d.id))){S[P.ExtensionIdentifier.toKey(d.id)]=d;return}const b=this._registry.getExtensionDescription(d.id);if(!b){this._host.onExtensionActivationError(d.id,new A.MissingDependencyError(d.id.value));const l=new Error(`Unknown dependency '${d.id.value}'`);this._activatedExtensions.set(P.ExtensionIdentifier.toKey(d.id),new g(l));return}const v=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let l=0,t=v.length;l<t;l++){const i=v[l];if(!this._resolvedExtensionsSet.has(P.ExtensionIdentifier.toKey(i))){const a=this._activatedExtensions.get(P.ExtensionIdentifier.toKey(i));if(!(a&&!a.activationFailed)){if(a&&a.activationFailed){this._host.onExtensionActivationError(b.identifier,_.localize(0,null,b.displayName||b.identifier.value,i));const o=new Error(`Dependency ${i} failed to activate`);o.detail=a.activationFailedError,this._activatedExtensions.set(P.ExtensionIdentifier.toKey(b.identifier),new g(o));return}if(this._hostExtensionsMap.has(P.ExtensionIdentifier.toKey(i))){u=!1,S[P.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(P.ExtensionIdentifier.toKey(i)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){u=!1,S[P.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:d.reason};continue}this._host.onExtensionActivationError(b.identifier,new A.MissingDependencyError(i));const c=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(P.ExtensionIdentifier.toKey(b.identifier),new g(c));return}}}u?S[P.ExtensionIdentifier.toKey(b.identifier)]=d:w.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(v=>!this._activatedExtensions.has(P.ExtensionIdentifier.toKey(v.id))),d.length===0))return Promise.resolve(void 0);const S=Object.create(null),w=[];for(let v=0,u=d.length;v<u;v++)this._handleActivateRequest(d[v],S,w);for(let v=0,u=w.length;v<u;v++){const l=P.ExtensionIdentifier.toKey(w[v].id);S[l]&&delete S[l]}const b=Object.keys(S).map(v=>S[v]);return w.length===0?Promise.all(b.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(b).then(v=>this._activateExtensions(w))}_activateExtension(d,S){const w=P.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const b=this._activatingExtensions.get(w);if(b)return b;const v=this._host.actualActivateExtension(d,S).then(void 0,u=>(this._host.onExtensionActivationError(d,_.localize(1,null,d.value,u.message)),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(u),new g(u))).then(u=>{this._activatedExtensions.set(w,u),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,v),v}};m=je([xe(4,I.ILogService)],m),e.ExtensionsActivator=m}),define(me[225],ge([0,1,12,41,27,11,110]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends _.LogService{constructor(n){if(n.logFile.scheme!==I.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(P.ExtensionHostLogFileName,n.logFile.fsPath,!0,n.logLevel))}$setLevel(n){this.setLevel(n)}};k=je([xe(0,A.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(me[226],ge([0,1,18]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class P{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,D)=>{this._actualOk=I,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,_.onUnexpectedError)(I))}then(I,D){return this._ensureActual().then(I,D)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=P}),define(me[123],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const P=[];function A(k){const y=new _(!0,k);return P[y.nid]=y,y}e.createMainContextProxyIdentifier=A;function I(k){const y=new _(!1,k);return P[y.nid]=y,y}e.createExtHostContextProxyIdentifier=I;function D(k){return P[k].sid}e.getStringIdentifierForProxy=D}),define(me[5],ge([0,1,2,123,57]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var D;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var R;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(u){u.name="$ident";function l(i,a){return Object.defineProperty(i,u.name,{value:a,enumerable:!0}),i}u.mixin=l;function t(i){return i[u.name]}u.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class s{static mixin(l){return l._id=s._n++,l}}e.IdObject=s,s._n=0;var d;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(u){if(u&&u.edits)for(const l of u.edits)typeof l.resource=="object"?l.resource=_.URI.revive(l.resource):(l.newUri=_.URI.revive(l.newUri),l.oldUri=_.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,A.revive)(l.metadata));return u}e.reviveWorkspaceEditDto=b;var v;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,P.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,P.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,P.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,P.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,P.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,P.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,P.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,P.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,P.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,P.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,P.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,P.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,P.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,P.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,P.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,P.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,P.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,P.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,P.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,P.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,P.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,P.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,P.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,P.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,P.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,P.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,P.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,P.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,P.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,P.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,P.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,P.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,P.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,P.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,P.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,P.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,P.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,P.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,P.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,P.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,P.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,P.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,P.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,P.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,P.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,P.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,P.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,P.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,P.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,P.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,P.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,P.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,P.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,P.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,P.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,P.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,P.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,P.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,P.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,P.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,P.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,P.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[87],ge([0,1,5,3,4]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(k){this._onDidChangePassword=new P.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,y){return this._proxy.$getPassword(k,y)}store(k,y,n){return this._proxy.$setPassword(k,y,n)}delete(k,y){return this._proxy.$deletePassword(k,y)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(me[63],ge([0,1,4,12,5,13]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(A.MainContext.MainThreadTelemetry)}report(y,n,R){const C=this.getUsageKey(y,n);this._reportedUsages.has(C)||(this._reportedUsages.add(C),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};D=je([xe(0,I.IExtHostRpcService),xe(1,P.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(k,y,n){}})}),define(me[227],ge([0,1,3,5,7,29]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,R,C={}){const g=I.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(g)||[],s=R.sort().join(" ");let d=m.find(S=>S.scopes===s);if(d)return d.result;{const S=this._getSession(y,g,n,R,C);d={scopes:s,result:S},m.push(d),this._inFlightRequests.set(g,m);try{await S}finally{const w=m.findIndex(b=>b.scopes===s);w>-1&&(m.splice(w),this._inFlightRequests.set(g,m))}return S}}async _getSession(y,n,R,C,g={}){await this._proxy.$ensureProvider(R);const m=y.displayName||y.name;return this._proxy.$getSession(R,C,n,m,g)}async removeSession(y,n){const R=this._authenticationProviders.get(y);return R?R.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,R,C){var g;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:R,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(s=>s.id===y)||this._providers.push({id:y,label:n});const m=R.onDidChangeSessions(s=>{var d,S,w;this._proxy.$sendDidChangeSessions(y,{added:(d=s.added)!==null&&d!==void 0?d:[],changed:(S=s.changed)!==null&&S!==void 0?S:[],removed:(w=s.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(g=C==null?void 0:C.supportsMultipleAccounts)!==null&&g!==void 0?g:!1),new A.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const s=this._providers.findIndex(d=>d.id===y);s>-1&&this._providers.splice(s),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const R=this._authenticationProviders.get(y);if(R)return Promise.resolve(R.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(R=>{this._providers.some(C=>C.id===R.id)||this._providers.push(R)}),n.forEach(R=>{const C=this._providers.findIndex(g=>g.id===R.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(me[228],ge([0,1,5,13,20]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(k,y){this._extHostDocumentsAndEditors=y,this._proxy=k.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const y=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};I=je([xe(0,P.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(me[229],ge([0,1,5]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(I){const D=I.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(k){return D.$writeText(k)}})}}e.ExtHostClipboard=P}),define(me[51],ge([0,1,15,7,20,23,5,14,12,57,44,49,2,6,4,13]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,a=>{const r=this._apiCommands.get(a);return(r==null?void 0:r.result)===v.Void?r:void 0},i),this._argumentProcessors=[{processArgument(a){return(0,n.revive)(a)}},{processArgument(a){return(0,I.cloneAndChange)(a,function(r){if(R.Range.isIRange(r))return A.Range.to(r);if(C.Position.isIPosition(r))return A.Position.to(r);if(R.Range.isIRange(r.range)&&g.URI.isUri(r.uri))return A.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...a)=>{const r=t.args.map((o,p)=>{if(!o.validate(a[p]))throw new Error(`Invalid argument '${o.name}' when running '${t.id}', received: ${a[p]}`);return o.convert(a[p])}),c=await this.executeCommand(t.internalId,...r);return t.result.convert(c,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new P.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,a,r,c){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:a,thisArg:r,description:c}),t&&this._proxy.$registerCommand(i),new P.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,a){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const r=(0,I.cloneAndChange)(i,function(c){if(c instanceof P.Position)return A.Position.from(c);if(c instanceof P.Range)return A.Range.from(c);if(c instanceof P.Location)return A.location.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,r,a);return(0,n.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw c}}}async _executeContributedCommand(t,i){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:r,thisArg:c,description:o}=a;if(o)for(let p=0;p<o.args.length;p++)try{(0,_.validateConstraint)(i[p],o.args[p].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${o.args[p].name}' - ${o.args[p].description}`)}try{return await r.apply(c,i)}catch(p){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...i);E&&(t=E.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(a=>this._argumentProcessors.reduce((r,c)=>c.processArgument(r),a)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(a=>a[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,a]of this._commands){let{description:r}=a;r&&(t[i]=r)}return Promise.resolve(t)}};S=je([xe(0,d.IExtHostRpcService),xe(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class w{constructor(t,i,a){this._commands=t,this._lookupApiCommand=i,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const r=this._lookupApiCommand(t.command);if(r)a.id=r.internalId,a.arguments=r.args.map((c,o)=>c.convert(t.arguments&&t.arguments[o]));else if((0,k.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),i.add((0,m.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),a.$ident=c,a.id=this.delegatingCommandId,a.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return a}}fromInternal(t){const i=D.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class b{constructor(t,i,a,r){this.name=t,this.description=i,this.validate=a,this.convert=r}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",l=>g.URI.isUri(l),l=>l),b.Position=new b("position","A position in a text document",l=>P.Position.isPosition(l),A.Position.from),b.Range=new b("range","A range in a text document",l=>P.Range.isRange(l),A.Range.from),b.Selection=new b("selection","A selection in a text document",l=>P.Selection.isSelection(l),A.Selection.from),b.Number=new b("number","",l=>typeof l=="number",l=>l),b.String=new b("string","",l=>typeof l=="string",l=>l),b.CallHierarchyItem=new b("item","A call hierarchy item",l=>l instanceof P.CallHierarchyItem,A.CallHierarchyItem.to);class v{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=v,v.Void=new v("no result",l=>l);class u{constructor(t,i,a,r,c){this.id=t,this.internalId=i,this.description=a,this.args=r,this.result=c}}e.ApiCommand=u}),define(me[230],ge([0,1,6,20,7,80,51,202,14,107]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const R=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",g(P.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(s,d)=>{if(!(0,y.isFalsyOrEmpty)(s)){class S extends A.SymbolInformation{static to(b){const v=new S(b.name,P.SymbolKind.to(b.kind),b.containerName||"",new A.Location(d[0],P.Range.to(b.range)));return v.detail=b.detail,v.range=v.location.range,v.selectionRange=P.Range.to(b.selectionRange),v.children=b.children?b.children.map(S.to):[],v}}return s.map(S.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(P.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(P.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new D.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(P.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(P.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(P.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(d=>A.Position.isPosition(d)),s=>s.map(P.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(d=>{let S;for(const w of d.reverse())S=new A.SelectionRange(P.Range.to(w),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>{const d=[];if(Array.isArray(s))for(let S of s)d.push(...S[1].map(P.WorkspaceSymbol.to));return d})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",s=>s.map(P.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return P.WorkspaceEdit.to(s)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(P.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new A.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,n.decodeSemanticTokensDto)(s);if(d.type==="full")return new A.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new A.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!!s){const d=(0,n.decodeSemanticTokensDto)(s);if(d.type==="full")return new A.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,d,S)=>{if(!s)return new A.CompletionList([]);const w=s.suggestions.map(b=>P.CompletionItem.to(b,S));return new A.CompletionList(w,s.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return P.SignatureHelp.to(s)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,d,S)=>g(w=>new A.CodeLens(P.Range.to(w.range),w.command&&S.fromInternal(w.command)))(s))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>A.Range.isRange(s),s=>A.Selection.isSelection(s)?P.Selection.from(s):P.Range.from(s)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,d,S)=>g(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(w.command)}else{const b=new A.CodeAction(w.title,w.kind?new A.CodeActionKind(w.kind):void 0);return w.edit&&(b.edit=P.WorkspaceEdit.to(w.edit)),w.command&&(b.command=S.fromInternal(w.command)),b.isPreferred=w.isPreferred,b}})(s))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(d=>new A.ColorInformation(P.Range.to(d.range),P.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",s=>s instanceof A.Color,P.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:P.Range.from(s.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(P.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",s=>s.map(P.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientMetadata:s.options.transientMetadata},filenamePattern:s.filenamePattern.map(d=>P.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(P.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[s,void 0]:[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[P.ViewColumn.from(s.viewColumn),P.TextEditorOpenOptions.from(s)]).optional()],D.ApiCommandResult.Void)];class C{constructor(d){this._disposables=new _.DisposableStore,this._commands=d}static register(d){return R.forEach(d.registerApiCommand,d),new C(d).registerCommands()}registerCommands(){const d=S=>(...w)=>S(this._commands,...w);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,d(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(k.OpenIssueReporter.ID,d(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(d,S,w){const b=this._commands.registerCommand(!1,d,S,this,w);this._disposables.add(b)}}e.ExtHostApiCommands=C;function g(s){return d=>{if(Array.isArray(d))return d.map(s)}}function m(s){if(!!Array.isArray(s)){const d=[];for(const S of s)I.isLocationLink(S)?d.push(P.DefinitionLink.to(S)):d.push(P.location.to(S));return d}}}),define(me[231],ge([0,1,19,69,3,6,2,80,29,20,7,5]),function(G,e,_,P,A,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class g{constructor(u,l,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(C.MainContext.MainThreadComments),l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const a=this._commentControllers.get(i.handle);return a||i}else if(i&&i.$mid===7){const a=this._commentControllers.get(i.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.commentThreadHandle);return r||i}else if(i&&i.$mid===8){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.thread.commentThreadHandle);return r?{thread:r,text:i.text}:i}else if(i&&i.$mid===9){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let c=i.commentUniqueId,o=r.getCommentByUniqueId(c);return o||i}else if(i&&i.$mid===10){const a=this._commentControllers.get(i.thread.commentControlHandle);if(!a)return i;const r=a.getCommentThread(i.thread.commentThreadHandle);if(!r)return i;let c=i.text,o=i.commentUniqueId,p=r.getCommentByUniqueId(o);return p?(p.body=c,p):i}return i}})}createCommentController(u,l,t){const i=g.handlePool++,a=new s(u,i,this._proxy,l,t);this._commentControllers.set(a.handle,a);const r=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(a),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),r),a}$createCommentThreadTemplate(u,l,t){const i=this._commentControllers.get(u);!i||i.$createCommentThreadTemplate(l,t)}async $updateCommentThreadTemplate(u,l,t){const i=this._commentControllers.get(u);!i||i.$updateCommentThreadTemplate(l,t)}$deleteCommentThread(u,l){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(l)}$provideCommentingRanges(u,l,t){const i=this._commentControllers.get(u);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const a=this._documents.getDocument(D.URI.revive(l));return(0,_.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(a,t)).then(r=>r?r.map(c=>n.Range.from(c)):void 0)}$toggleReaction(u,l,t,i,a){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const c=r.getCommentThread(l);if(c){const o=c.getCommentByUniqueId(i.uniqueIdInThread);if(r!==void 0&&o&&r.reactionHandler)return r.reactionHandler(o,w(a))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=g,g.handlePool=0;class m{constructor(u,l,t,i,a,r,c){this._proxy=u,this._commentController=l,this._id=t,this._uri=i,this._range=a,this._comments=r,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${l.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),c),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),l={};u("range")&&(l.range=n.Range.from(this._range)),u("label")&&(l.label=this.label),u("contextValue")&&(l.contextValue=this.contextValue),u("comments")&&(l.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(l.collapseState=b(this._collapseState)),u("canReply")&&(l.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,l)}}getCommentByUniqueId(u){for(let l of this._commentsMap){let t=l[0],i=l[1];if(u===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,P.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class s{constructor(u,l,t,i,a){this._extension=u,this._handle=l,this._proxy=t,this._id=i,this._label=a,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,a)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,l,t,i){if(typeof u=="string"){const a=new m(this._proxy,this,u,l,t,i,this._extension.identifier);return this._threads.set(a.handle,a),a}else{const a=new m(this._proxy,this,void 0,u,l,t,this._extension.identifier);return this._threads.set(a.handle,a),a}}$createCommentThreadTemplate(u,l){const t=new m(this._proxy,this,void 0,D.URI.revive(u),n.Range.to(l),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,l){let t=this._threads.get(u);t&&(t.range=n.Range.to(l))}$deleteCommentThread(u){let l=this._threads.get(u);l&&l.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(v,u,l,t){let i=t.get(l);i||(i=++v.commentHandle,t.set(l,i));const a=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(l.body),userName:l.author.name,userIconPath:a,label:l.label,commentReactions:l.reactions?l.reactions.map(r=>S(r)):void 0}}function S(v){return{label:v.label,iconPath:v.iconPath?n.pathOrURIToURI(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function w(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?D.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function b(v){if(v!==void 0)switch(v){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(me[124],ge([0,1,2,5,7,4,13,12,14,10,8]),function(G,e,_,P,A,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class mn{constructor(m,s){this._logService=s,this._provider=new Map,this._proxy=m.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,s){const d=mn._handlePool++;this._provider.set(d,{provider:m,extensionId:s}),this._proxy.$registerDecorationProvider(d,s.value);const S=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(d,null);return}let b=(0,y.asArray)(w);if(b.length<=mn._maxEventSize){this._proxy.$onDidChange(d,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,b.length);const v=b.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),u=(0,y.groupBy)(v,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let l=[];e:for(let t of u){let i;for(let a of t){let r=(0,R.dirname)(a.uri.path);if(i!==r&&(i=r,l.push(a.uri)>=mn._maxEventSize))break e}}this._proxy.$onDidChange(d,l)});return new A.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,s,d){if(!this._provider.has(m))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:b}=this._provider.get(m);return await Promise.all(s.map(async v=>{try{const{uri:u,id:l}=v,t=await Promise.resolve(w.provideFileDecoration(_.URI.revive(u),d));if(!t)return;try{A.FileDecoration.validate(t),S[l]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(u){this._logService.error(u)}})),S}};C._handlePool=0,C._maxEventSize=250,C=je([xe(0,D.IExtHostRpcService),xe(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")}),define(me[232],ge([0,1,159,111,2,5,7,20,3,12,24]),function(G,e,_,P,A,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(s,d,S,w,b){this._name=s,this._owner=d,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new R.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,d){if(!s){this.clear();return}this._checkDisposed();let S=[];if(A.URI.isUri(s)){if(!d){this.delete(s);return}this._data.set(s,d.slice()),S=[s]}else if(Array.isArray(s)){S=[];let b;s=[...s].sort(C._compareIndexedTuplesByUri);for(const v of s){const[u,l]=v;if((!b||u.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=u,S.push(u),this._data.set(u,[])),l){const t=this._data.get(u);t&&t.push(...l)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const w=[];for(let b of S){let v=[];const u=this._data.get(b);if(u)if(u.length>this._maxDiagnosticsPerFile){v=[];const l=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of u)if(i.severity===l[t]&&v.push(k.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;v.push({severity:P.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:v[v.length-1].startLineNumber,startColumn:v[v.length-1].startColumn,endLineNumber:v[v.length-1].endLineNumber,endColumn:v[v.length-1].endColumn})}else v=u.map(l=>k.Diagnostic.from(l));w.push([b,v])}this._proxy.$changeMany(this._owner,w)}}delete(s){this._checkDisposed(),this._onDidChangeDiagnostics.fire([s]),this._data.delete(s),this._proxy&&this._proxy.$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(s,d){this._checkDisposed();for(let S of this._data.keys())s.apply(d,[S,this.get(S),this])}get(s){this._checkDisposed();const d=this._data.get(s);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(this._data.get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,d){return s[0].toString()<d[0].toString()?-1:s[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=C;let g=class Ht{constructor(s,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Ht._debouncer,50),Ht._mapper),this._proxy=s.getProxy(I.MainContext.MainThreadDiagnostics)}static _debouncer(s,d){return s?s.concat(d):d}static _mapper(s){const d=[],S=new Set;for(const w of s)typeof w=="string"?S.has(w)||(S.add(w),d.push(A.URI.parse(w))):S.has(w.toString())||(S.add(w.toString()),d.push(w));return Object.freeze(d),{uris:d}}createDiagnosticCollection(s,d){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:b,_logService:v}=this,u=new class{$changeMany(i,a){w.$changeMany(i,a),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,i,a.length===0?"CLEARING":a)}$clear(i){w.$clear(i),v.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,i)}dispose(){w.dispose()}};let l;if(!d)d="_generated_diagnostic_collection_name_#"+Ht._idPool++,l=d;else if(!S.has(d))l=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do l=d+Ht._idPool++;while(S.has(l))}return new class extends C{constructor(){super(d,l,Ht._maxDiagnosticsPerFile,u,b);S.set(l,this)}dispose(){super.dispose(),S.delete(l)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const d=new Map,S=[];for(const w of this._collections.values())w.forEach((b,v)=>{let u=d.get(b.toString());typeof u=="undefined"&&(u=S.length,d.set(b.toString(),u),S.push([b,[]])),S[u][1]=S[u][1].concat(...v)});return S}}_getDiagnostics(s){let d=[];for(let S of this._collections.values())S.has(s)&&(d=d.concat(S.get(s)));return d}$acceptMarkersChange(s){if(!this._mirrorCollection){const d="_generated_mirror",S=new C(d,d,Ht._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,S),this._mirrorCollection=S}for(const[d,S]of s)this._mirrorCollection.set(A.URI.revive(d),S.map(k.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=je([xe(1,n.ILogService)],g),e.ExtHostDiagnostics=g}),define(me[233],ge([0,1,2,5]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(D){this._proxy=D.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(k=>k?k.map(y=>_.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(k=>k?_.URI.revive(k):void 0)}}e.ExtHostDialogs=A}),define(me[234],ge([0,1,18,2,7,5,11,21,10]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(C,g,m){this._documentsAndEditors=g,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,g){if(Object.keys(D.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=n._handlePool++;this._documentContentProviders.set(m,g),this._proxy.$registerTextContentProvider(m,C);let s;return typeof g.onDidChange=="function"&&(s=g.onDidChange(d=>{if(d.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(S=>{if(!(!S&&typeof S!="string")){const w=this._documentsAndEditors.getDocument(d);if(!!w){const b=(0,y.splitLines)(S);if(!w.equalLines(b))return this._proxy.$onVirtualDocumentChange(d,S)}}},_.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(C,g){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(P.URI.revive(g),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(me[235],ge([0,1,3,6,2,5,118,20,15,23]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class R{constructor(g,m){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new P.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const d of s)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const d of s)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!!g){const m=this._documentsAndEditors.getDocument(g);if(m)return m}}getDocument(g){const m=this.getDocumentData(g);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${g}'`);return m.document}ensureDocumentData(g){const m=this._documentsAndEditors.getDocument(g);if(m)return Promise.resolve(m);let s=this._documentLoader.get(g.toString());return s||(s=this._proxy.$tryOpenDocument(g).then(d=>{this._documentLoader.delete(g.toString());const S=A.URI.revive(d);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},d=>(this._documentLoader.delete(g.toString()),Promise.reject(d))),this._documentLoader.set(g.toString(),s)),s}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(m=>A.URI.revive(m))}$acceptModelModeChanged(g,m){const s=A.URI.revive(g),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(m),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(g){const m=A.URI.revive(g),s=this._documentsAndEditors.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(g,m){const s=A.URI.revive(g),d=this._documentsAndEditors.getDocument(s);if(!d)throw new Error("unknown document");d._acceptIsDirty(m),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(g,m,s){const d=A.URI.revive(g),S=this._documentsAndEditors.getDocument(d);if(!S)throw new Error("unknown document");S._acceptIsDirty(s),S.onEvents(m),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:S.document,contentChanges:m.changes.map(w=>({range:k.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(g,m){(0,D.setWordDefinitionFor)(g,m)}}e.ExtHostDocuments=R}),define(me[39],ge([0,1,52,3,6,2,4,5,118,13,122,20,12,24,11,72,133]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(u,l){this._extHostRpc=u,this._logService=l,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new P.Emitter,this._onDidRemoveDocuments=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const l=[],t=[],i=[];if(u.removedDocuments)for(const a of u.removedDocuments){const r=I.URI.revive(a),c=this._documents.get(r);(c==null?void 0:c.unref())&&(this._documents.delete(r),l.push(c.value))}if(u.addedDocuments)for(const a of u.addedDocuments){const r=I.URI.revive(a.uri);let c=this._documents.get(r);if(c&&r.scheme!==s.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);c||(c=new w(new y.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(r,c),t.push(c.value)),c.ref()}if(u.removedEditors)for(const a of u.removedEditors){const r=this._editors.get(a);this._editors.delete(a),r&&i.push(r)}if(u.addedEditors)for(const a of u.addedEditors){const r=I.URI.revive(a.documentUri);_.ok(this._documents.has(r),`document '${r}' does not exist`),_.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const c=this._documents.get(r).value,o=new R.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>c.document),a.selections.map(C.Selection.to),a.options,a.visibleRanges.map(p=>C.Range.to(p)),typeof a.editorPosition=="number"?C.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,o)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,A.dispose)(l),(0,A.dispose)(i),u.removedDocuments&&this._onDidRemoveDocuments.fire(l),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var l;return(l=this._documents.get(u))===null||l===void 0?void 0:l.value}allDocuments(){return d.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const l=this._editors.get(this._activeEditorId);return u?l:l==null?void 0:l.value}}allEditors(){return[...this._editors.values()]}};b=je([xe(0,n.IExtHostRpcService),xe(1,g.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[236],ge([0,1,2,5,6,7,20,141,10,22]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class R{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const s=this._schemes.indexOf(m);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),s=[];let d,S,w=14,b=14;for(const v of m){let u=d?(0,y.commonPrefixLength)(d,v):0;for(u===0?S=1:S=b;u<v.length;u++)u+1===v.length?(w=b,b=9):b+=1,s.push([S,v.toUpperCase().charCodeAt(u),b]),s.push([S,v.toLowerCase().charCodeAt(u),b]),S=b;d=v,b=w}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new k.StateMachine(s)}}provideDocumentLinks(m){this._initStateMachine();const s=[],d=k.LinkComputer.computeLinks({getLineContent(S){return m.lineAt(S-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const S of d){const w=D.DocumentLink.to(S);w.target&&s.push(w)}return s}}class C{constructor(m,s){this._extHostLanguageFeatures=s,this._linkProvider=new R,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,s,d,S={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(w,d);let b=2;S.isCaseSensitive&&(b+=1024),S.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(w,s,b).catch(u=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${s}`),console.error(u)});const v=d.onDidChangeFile(u=>{const l=[];for(const t of u){let{uri:i,type:a}=t;if(i.scheme===s){let r;switch(a){case I.FileChangeType.Changed:r=0;break;case I.FileChangeType.Created:r=1;break;case I.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:i,type:r})}}this._proxy.$onFileSystemChange(w,l)});return(0,A.toDisposable)(()=>{v.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(m){const{type:s,ctime:d,mtime:S,size:w}=m;return{type:s,ctime:d,mtime:S,size:w}}$stat(m,s){return Promise.resolve(this._getFsProvider(m).stat(_.URI.revive(s))).then(C._asIStat)}$readdir(m,s){return Promise.resolve(this._getFsProvider(m).readDirectory(_.URI.revive(s)))}$readFile(m,s){return Promise.resolve(this._getFsProvider(m).readFile(_.URI.revive(s))).then(d=>n.VSBuffer.wrap(d))}$writeFile(m,s,d,S){return Promise.resolve(this._getFsProvider(m).writeFile(_.URI.revive(s),d.buffer,S))}$delete(m,s,d){return Promise.resolve(this._getFsProvider(m).delete(_.URI.revive(s),d))}$rename(m,s,d,S){return Promise.resolve(this._getFsProvider(m).rename(_.URI.revive(s),_.URI.revive(d),S))}$copy(m,s,d,S){const w=this._getFsProvider(m);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(_.URI.revive(s),_.URI.revive(d),S))}$mkdir(m,s){return Promise.resolve(this._getFsProvider(m).createDirectory(_.URI.revive(s)))}$watch(m,s,d,S){const w=this._getFsProvider(m).watch(_.URI.revive(d),S);this._watches.set(s,w)}$unwatch(m,s){const d=this._watches.get(s);d&&(d.dispose(),this._watches.delete(s))}$open(m,s,d){const S=this._getFsProvider(m);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(_.URI.revive(s),d))}$close(m,s){const d=this._getFsProvider(m);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(s))}$read(m,s,d,S){const w=this._getFsProvider(m);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const b=n.VSBuffer.alloc(S);return Promise.resolve(w.read(s,d,b.buffer,0,S)).then(v=>b.slice(0,v))}$write(m,s,d,S){const w=this._getFsProvider(m);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(s,d,S.buffer,0,S.byteLength))}_getFsProvider(m){const s=this._fsProvider.get(m);if(!s){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return s}}e.ExtHostFileSystem=C}),define(me[88],ge([0,1,5,45,7,22,4,13,60]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Mt{constructor(C,g){const m=C.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(s){return m.$stat(s).catch(Mt._handleError)},readDirectory(s){return m.$readdir(s).catch(Mt._handleError)},createDirectory(s){return m.$mkdir(s).catch(Mt._handleError)},async readFile(s){return m.$readFile(s).then(d=>d.buffer).catch(Mt._handleError)},writeFile(s,d){return m.$writeFile(s,I.VSBuffer.wrap(d)).catch(Mt._handleError)},delete(s,d){return m.$delete(s,Object.assign({recursive:!1,useTrash:!1},d)).catch(Mt._handleError)},rename(s,d,S){return m.$rename(s,d,Object.assign({overwrite:!1},S)).catch(Mt._handleError)},copy(s,d,S){return m.$copy(s,d,Object.assign({overwrite:!1},S)).catch(Mt._handleError)},isWritableFileSystem(s){const d=g.getCapabilities(s);if(typeof d=="number")return!(d&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new A.FileSystemError(String(C));if(C.name==="ENOPRO")throw A.FileSystemError.Unavailable(C.message);switch(C.name){case P.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(C.message);case P.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(C.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(C.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(C.message);case P.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(C.message);case P.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(C.message);default:throw new A.FileSystemError(C.message,C.name)}}};n=je([xe(0,k.IExtHostRpcService),xe(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(me[237],ge([0,1,6,5]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(D){this._handlePool=0,this._proxy=D.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,D),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=A}),define(me[238],ge([0,1,2,23,20,7,19,5,10,44,14,15,138,6,107,71,85,47,18]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class v{constructor(z,J){this._documents=z,this._provider=J}provideDocumentSymbols(z,J){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(te,J)).then(le=>{if(!(0,R.isFalsyOrEmpty)(le))return le[0]instanceof I.DocumentSymbol?le.map(A.DocumentSymbol.from):v._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(z){var J;z=z.slice(0).sort((he,Ce)=>{let Me=he.location.range.start.compareTo(Ce.location.range.start);return Me===0&&(Me=Ce.location.range.end.compareTo(he.location.range.end)),Me});const te=[],le=[];for(const he of z){const Ce={name:he.name||"!!MISSING: name!!",kind:A.SymbolKind.from(he.kind),tags:((J=he.tags)===null||J===void 0?void 0:J.map(A.SymbolTag.from))||[],detail:"",containerName:he.containerName,range:A.Range.from(he.location.range),selectionRange:A.Range.from(he.location.range),children:[]};for(;;){if(le.length===0){le.push(Ce),te.push(Ce);break}const Me=le[le.length-1];if(n.Range.containsRange(Me.range,Ce.range)&&!n.Range.equalsRange(Me.range,Ce.range)){Me.children&&Me.children.push(Ce),le.push(Ce);break}le.pop()}}return te}}class u{constructor(z,J,te){this._documents=z,this._commands=J,this._provider=te,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,J){const te=this._documents.getDocument(z),le=await this._provider.provideCodeLenses(te,J);if(!(!le||J.isCancellationRequested)){const he=this._cache.add(le),Ce=new m.DisposableStore;this._disposables.set(he,Ce);const Me={cacheId:he,lenses:[]};for(let we=0;we<le.length;we++)Me.lenses.push({cacheId:[he,we],range:A.Range.from(le[we].range),command:this._commands.toInternal(le[we].command,Ce)});return Me}}async resolveCodeLens(z,J){var te;const le=z.cacheId&&this._cache.get(...z.cacheId);if(!!le){let he;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?he=le:he=await this._provider.resolveCodeLens(le,J),he||(he=le),!J.isCancellationRequested){const Ce=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Ce)return z.command=this._commands.toInternal((te=he.command)!==null&&te!==void 0?te:u._badCmd,Ce),z}}}releaseCodeLenses(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function l(Fe){return Array.isArray(Fe)?Fe.map(A.DefinitionLink.from):Fe?[A.DefinitionLink.from(Fe)]:[]}class t{constructor(z,J){this._documents=z,this._provider=J}provideDefinition(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDefinition(le,he,te)).then(l)}}class i{constructor(z,J){this._documents=z,this._provider=J}provideDeclaration(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDeclaration(le,he,te)).then(l)}}class a{constructor(z,J){this._documents=z,this._provider=J}provideImplementation(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideImplementation(le,he,te)).then(l)}}class r{constructor(z,J){this._documents=z,this._provider=J}provideTypeDefinition(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(le,he,te)).then(l)}}class c{constructor(z,J){this._documents=z,this._provider=J}provideHover(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideHover(le,he,te)).then(Ce=>{if(!(!Ce||(0,R.isFalsyOrEmpty)(Ce.contents)))return Ce.range||(Ce.range=le.getWordRangeAtPosition(he)),Ce.range||(Ce.range=new I.Range(he,he)),A.Hover.from(Ce)})}}class o{constructor(z,J){this._documents=z,this._provider=J}provideEvaluatableExpression(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(le,he,te)).then(Ce=>{if(Ce)return A.EvaluatableExpression.from(Ce)})}}class p{constructor(z,J){this._documents=z,this._provider=J}provideInlineValues(z,J,te,le){const he=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineValues(he,A.Range.to(J),A.InlineValueContext.to(te),le)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(Me=>A.InlineValue.from(Me))})}}class E{constructor(z,J){this._documents=z,this._provider=J}provideDocumentHighlights(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(le,he,te)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(A.DocumentHighlight.from)})}}class f{constructor(z,J){this._documents=z,this._provider=J}provideLinkedEditingRanges(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,he,te)).then(Ce=>{if(Ce&&Array.isArray(Ce.ranges))return{ranges:(0,R.coalesce)(Ce.ranges.map(A.Range.from)),wordPattern:Ce.wordPattern}})}}class h{constructor(z,J){this._documents=z,this._provider=J}provideReferences(z,J,te,le){const he=this._documents.getDocument(z),Ce=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideReferences(he,Ce,te,le)).then(Me=>{if(Array.isArray(Me))return Me.map(A.location.from)})}}class T{constructor(z,J,te,le,he,Ce,Me){this._documents=z,this._commands=J,this._diagnostics=te,this._provider=le,this._logService=he,this._extension=Ce,this._apiDeprecation=Me,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,J,te,le){const he=this._documents.getDocument(z),Ce=g.Selection.isISelection(J)?A.Selection.to(J):A.Range.to(J),Me=[];for(const ke of this._diagnostics.getDiagnostics(z))if(Ce.intersection(ke.range)&&Me.push(ke)>T._maxCodeActionsPerFile)break;const we={diagnostics:Me,only:te.only?new I.CodeActionKind(te.only):void 0,triggerKind:A.CodeActionTriggerKind.to(te.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(he,Ce,we,le)).then(ke=>{var Re;if(!(!(0,R.isNonEmptyArray)(ke)||le.isCancellationRequested)){const Be=this._cache.add(ke),Ee=new m.DisposableStore;this._disposables.set(Be,Ee);const Ge=[];for(let Q=0;Q<ke.length;Q++){const re=ke[Q];!re||(T._isCommand(re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:re.title,command:this._commands.toInternal(re,Ee)})):(we.only&&(re.kind?we.only.contains(re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[Be,Q],title:re.title,command:re.command&&this._commands.toInternal(re.command,Ee),diagnostics:re.diagnostics&&re.diagnostics.map(A.Diagnostic.from),edit:re.edit&&A.WorkspaceEdit.from(re.edit),kind:re.kind&&re.kind.value,isPreferred:re.isPreferred,disabled:(Re=re.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:Ge}}})}async resolveCodeAction(z,J){var te;const[le,he]=z,Ce=this._cache.get(le,he);if(!(!Ce||T._isCommand(Ce))&&!!this._provider.resolveCodeAction){const Me=(te=await this._provider.resolveCodeAction(Ce,J))!==null&&te!==void 0?te:Ce;return(Me==null?void 0:Me.edit)?A.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}T._maxCodeActionsPerFile=1e3;class L{constructor(z,J){this._documents=z,this._provider=J}provideDocumentFormattingEdits(z,J,te){const le=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,J,te)).then(he=>{if(Array.isArray(he))return he.map(A.TextEdit.from)})}}class W{constructor(z,J){this._documents=z,this._provider=J}provideDocumentRangeFormattingEdits(z,J,te,le){const he=this._documents.getDocument(z),Ce=A.Range.to(J);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(he,Ce,te,le)).then(Me=>{if(Array.isArray(Me))return Me.map(A.TextEdit.from)})}}class ee{constructor(z,J){this._documents=z,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,J,te,le,he){const Ce=this._documents.getDocument(z),Me=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ce,Me,te,le,he)).then(we=>{if(Array.isArray(we))return we.map(A.TextEdit.from)})}}class j{constructor(z,J){this._provider=z,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,J){const te=k.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,J)).then(le=>{if((0,R.isNonEmptyArray)(le)){for(const he of le)if(!!he){if(!he.name){this._logService.warn("INVALID SymbolInformation, lacks name",he);continue}const Ce=k.IdObject.mixin(A.WorkspaceSymbol.from(he));this._symbolCache.set(Ce._id,he),te.symbols.push(Ce)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(z,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const te=this._symbolCache.get(z._id);if(te){const le=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,J));return le&&(0,P.mixin)(z,A.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(z){const J=this._resultCache.get(z);if(J){for(let[te,le]=J;te<=le;te++)this._symbolCache.delete(te);this._resultCache.delete(z)}}}class x{constructor(z,J,te){this._documents=z,this._provider=J,this._logService=te}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,J,te,le){const he=this._documents.getDocument(z),Ce=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(he,Ce,te,le)).then(Me=>{if(!!Me)return A.WorkspaceEdit.from(Me)},Me=>{const we=x._asMessage(Me);return we?{rejectReason:we,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(z,J,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(z),he=A.Position.to(J);return(0,D.asPromise)(()=>this._provider.prepareRename(le,he,te)).then(Ce=>{let Me,we;if(I.Range.isRange(Ce)?(Me=Ce,we=le.getText(Ce)):(0,C.isObject)(Ce)&&(Me=Ce.range,we=Ce.placeholder),!!Me){if(Me.start.line>he.line||Me.end.line<he.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Me),text:we}}},Ce=>{const Me=x._asMessage(Ce);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(Ce)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,J){this.resultId=z,this.tokens=J}}class F{constructor(z,J){this._documents=z,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,J,te){const le=this._documents.getDocument(z),he=J!==0?this._previousResults.get(J):null;return(0,D.asPromise)(()=>he&&typeof he.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,he.resultId,te):this._provider.provideDocumentSemanticTokens(le,te)).then(Ce=>(he&&this._previousResults.delete(J),Ce?(Ce=F._fixProvidedSemanticTokens(Ce),this._send(F._convertToEdits(he,Ce),Ce)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return F._isSemanticTokens(z)?F._isCorrectSemanticTokens(z)?z:new I.SemanticTokens(new Uint32Array(z.data),z.resultId):F._isSemanticTokensEdits(z)?F._isCorrectSemanticTokensEdits(z)?z:new I.SemanticTokensEdits(z.edits.map(J=>new I.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const J of z.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,J){if(!F._isSemanticTokens(J)||!z||!z.tokens)return J;const te=z.tokens,le=te.length,he=J.data,Ce=he.length;let Me=0;const we=Math.min(le,Ce);for(;Me<we&&te[Me]===he[Me];)Me++;if(Me===le&&Me===Ce)return new I.SemanticTokensEdits([],J.resultId);let ke=0;const Re=we-Me;for(;ke<Re&&te[le-ke-1]===he[Ce-ke-1];)ke++;return new I.SemanticTokensEdits([{start:Me,deleteCount:le-Me-ke,data:he.subarray(Me,Ce-ke)}],J.resultId)}_send(z,J){if(F._isSemanticTokens(z)){const te=this._nextResultId++;return this._previousResults.set(te,new $(z.resultId,z.data)),(0,s.encodeSemanticTokensDto)({id:te,type:"full",data:z.data})}if(F._isSemanticTokensEdits(z)){const te=this._nextResultId++;return F._isSemanticTokens(J)?this._previousResults.set(te,new $(J.resultId,J.data)):this._previousResults.set(te,new $(z.resultId)),(0,s.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(z.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=F;class U{constructor(z,J){this._documents=z,this._provider=J}provideDocumentRangeSemanticTokens(z,J,te){const le=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,A.Range.to(J),te)).then(he=>he?this._send(he):null)}_send(z){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(z,J,te,le,he){this._documents=z,this._commands=J,this._provider=te,this._apiDeprecation=le,this._extension=he,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,J,te,le){const he=this._documents.getDocument(z),Ce=A.Position.to(J),Me=he.getWordRangeAtPosition(Ce)||new I.Range(Ce,Ce),we=Me.with({end:Ce}),ke=new w.StopWatch(!0),Re=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(he,Ce,le,A.CompletionContext.to(te)));if(!!Re&&!le.isCancellationRequested){const Be=Array.isArray(Re)?new I.CompletionList(Re):Re,Ee=M.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ge=new m.DisposableStore;this._disposables.set(Ee,Ge);const Q=[],re={x:Ee,b:Q,a:{replace:A.Range.from(Me),insert:A.Range.from(we)},c:Be.isIncomplete||void 0,d:ke.elapsed()};for(let be=0;be<Be.items.length;be++){const Ue=Be.items[be],ze=this._convertCompletionItem(Ue,[Ee,be],we,Me);Q.push(ze)}return re}}async resolveCompletionItem(z,J){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...z);if(!!te){const le=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(te,J));if(!!le)return this._convertCompletionItem(le,z)}}}releaseCompletionItems(z){var J;(J=this._disposables.get(z))===null||J===void 0||J.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,J,te,le){var he;const Ce=this._disposables.get(J[0]);if(!Ce)throw Error("DisposableStore is missing...");const Me={x:J,a:(he=z.label)!==null&&he!==void 0?he:"",o:z.label2,b:z.kind!==void 0?A.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(A.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(z.command,Ce)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=z.textEdit.newText):typeof z.insertText=="string"?Me.h=z.insertText:z.insertText instanceof I.SnippetString&&(Me.h=z.insertText.value,Me.i|=4);let we;return z.textEdit?we=z.textEdit.range:z.range&&(we=z.range),I.Range.isRange(we)?Me.j=A.Range.from(we):we&&(!(te==null?void 0:te.isEqual(we.inserting))||!(le==null?void 0:le.isEqual(we.replacing)))&&(Me.j={insert:A.Range.from(we.inserting),replace:A.Range.from(we.replacing)}),Me}}class N{constructor(z,J){this._documents=z,this._provider=J,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(z,J,te,le){const he=this._documents.getDocument(z),Ce=A.Position.to(J),Me=this.reviveContext(te);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(he,Ce,le,Me)).then(we=>{if(we){const ke=this._cache.add([we]);return Object.assign(Object.assign({},A.SignatureHelp.from(we)),{id:ke})}})}reviveContext(z){let J;if(z.activeSignatureHelp){const te=A.SignatureHelp.to(z.activeSignatureHelp),le=this._cache.get(z.activeSignatureHelp.id,0);le?(J=le,J.activeSignature=te.activeSignature,J.activeParameter=te.activeParameter):J=te}return Object.assign(Object.assign({},z),{activeSignatureHelp:J})}releaseSignatureHelp(z){this._cache.delete(z)}}class O{constructor(z,J){this._documents=z,this._provider=J}provideInlineHints(z,J,te){const le=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideInlineHints(le,A.Range.to(J),te)).then(he=>he?{hints:he.map(A.InlineHint.from)}:void 0)}}class V{constructor(z,J){this._documents=z,this._provider=J,this._cache=new S.Cache("DocumentLink")}provideLinks(z,J){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(te,J)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(A.DocumentLink.from)};{const he=this._cache.add(le),Ce={links:[],id:he};for(let Me=0;Me<le.length;Me++){const we=A.DocumentLink.from(le[Me]);we.cacheId=[he,Me],Ce.links.push(we)}return Ce}}})}resolveLink(z,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...z);return te?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(te,J)).then(le=>le&&A.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,J){this._documents=z,this._provider=J}provideColors(z,J){const te=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(te,J)).then(le=>Array.isArray(le)?le.map(Ce=>({color:A.Color.from(Ce.color),range:A.Range.from(Ce.range)})):[])}provideColorPresentations(z,J,te){const le=this._documents.getDocument(z),he=A.Range.to(J.range),Ce=A.Color.to(J.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(Ce,{document:le,range:he},te)).then(Me=>{if(!!Array.isArray(Me))return Me.map(A.ColorPresentation.from)})}}class X{constructor(z,J){this._documents=z,this._provider=J}provideFoldingRanges(z,J,te){const le=this._documents.getDocument(z);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(le,J,te)).then(he=>{if(!!Array.isArray(he))return he.map(A.FoldingRange.from)})}}class fe{constructor(z,J,te){this._documents=z,this._provider=J,this._logService=te}provideSelectionRanges(z,J,te){const le=this._documents.getDocument(z),he=J.map(A.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(le,he,te)).then(Ce=>{if(!(0,R.isNonEmptyArray)(Ce))return[];if(Ce.length!==he.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let we=0;we<he.length;we++){const ke=[];Me.push(ke);let Re=he[we],Be=Ce[we];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(A.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Me})}}class ve{constructor(z,J){this._documents=z,this._provider=J,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(z,J,te){const le=this._documents.getDocument(z),he=A.Position.to(J),Ce=await this._provider.prepareCallHierarchy(le,he,te);if(!!Ce){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(Ce)?Ce.map(we=>this._cacheAndConvertItem(Me,we)):[this._cacheAndConvertItem(Me,Ce)]}}async provideCallsTo(z,J,te){const le=this._itemFromCache(z,J);if(!le)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyIncomingCalls(le,te);if(!!he)return he.map(Ce=>({from:this._cacheAndConvertItem(z,Ce.from),fromRanges:Ce.fromRanges.map(Me=>A.Range.from(Me))}))}async provideCallsFrom(z,J,te){const le=this._itemFromCache(z,J);if(!le)throw new Error("missing call hierarchy item");const he=await this._provider.provideCallHierarchyOutgoingCalls(le,te);if(!!he)return he.map(Ce=>({to:this._cacheAndConvertItem(z,Ce.to),fromRanges:Ce.fromRanges.map(Me=>A.Range.from(Me))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,J){var te;const le=this._cache.get(z),he={_sessionId:z,_itemId:le.size.toString(36),name:J.name,detail:J.detail,kind:A.SymbolKind.from(J.kind),uri:J.uri,range:A.Range.from(J.range),selectionRange:A.Range.from(J.selectionRange),tags:(te=J.tags)===null||te===void 0?void 0:te.map(A.SymbolTag.from)};return le.set(he._itemId,J),he}_itemFromCache(z,J){const te=this._cache.get(z);return te==null?void 0:te.get(J)}}class Ae{constructor(z,J){this.adapter=z,this.extension=J}}class Pe{constructor(z,J,te,le,he,Ce,Me){this._adapter=new Map,this._uriTransformer=J,this._proxy=z.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=le,this._diagnostics=he,this._logService=Ce,this._apiDeprecation=Me}_transformDocumentSelector(z){return(0,R.coalesce)((0,R.asArray)(z).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:A.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new I.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Pe._handlePool++}_withAdapter(z,J,te,le,he=!1){const Ce=this._adapter.get(z);if(!Ce)return Promise.resolve(le);if(Ce.adapter instanceof J){let Me;Ce.extension&&(Me=Date.now(),this._logService.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const we=te(Ce.adapter,Ce.extension),ke=Ce.extension;return ke&&Promise.resolve(we).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Re=>{he&&Re instanceof b.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Re))}),we}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,J){const te=this._nextHandle();return this._adapter.set(te,new Ae(z,J)),te}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,J,te,le){const he=this._addNewAdapter(new v(this._documents,te),z),Ce=le&&le.label||Pe._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(he,this._transformDocumentSelector(J),Ce),this._createDisposable(he)}$provideDocumentSymbols(z,J,te){return this._withAdapter(z,v,le=>le.provideDocumentSymbols(_.URI.revive(J),te),void 0)}registerCodeLensProvider(z,J,te){const le=this._nextHandle(),he=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ae(new u(this._documents,this._commands.converter,te),z)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(J),he);let Ce=this._createDisposable(le);if(he!==void 0){const Me=te.onDidChangeCodeLenses(we=>this._proxy.$emitCodeLensEvent(he));Ce=I.Disposable.from(Ce,Me)}return Ce}$provideCodeLenses(z,J,te){return this._withAdapter(z,u,le=>le.provideCodeLenses(_.URI.revive(J),te),void 0)}$resolveCodeLens(z,J,te){return this._withAdapter(z,u,le=>le.resolveCodeLens(J,te),void 0)}$releaseCodeLenses(z,J){this._withAdapter(z,u,te=>Promise.resolve(te.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(z,J,te){const le=this._addNewAdapter(new t(this._documents,te),z);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideDefinition(z,J,te,le){return this._withAdapter(z,t,he=>he.provideDefinition(_.URI.revive(J),te,le),[])}registerDeclarationProvider(z,J,te){const le=this._addNewAdapter(new i(this._documents,te),z);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideDeclaration(z,J,te,le){return this._withAdapter(z,i,he=>he.provideDeclaration(_.URI.revive(J),te,le),[])}registerImplementationProvider(z,J,te){const le=this._addNewAdapter(new a(this._documents,te),z);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideImplementation(z,J,te,le){return this._withAdapter(z,a,he=>he.provideImplementation(_.URI.revive(J),te,le),[])}registerTypeDefinitionProvider(z,J,te){const le=this._addNewAdapter(new r(this._documents,te),z);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideTypeDefinition(z,J,te,le){return this._withAdapter(z,r,he=>he.provideTypeDefinition(_.URI.revive(J),te,le),[])}registerHoverProvider(z,J,te,le){const he=this._addNewAdapter(new c(this._documents,te),z);return this._proxy.$registerHoverProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideHover(z,J,te,le){return this._withAdapter(z,c,he=>he.provideHover(_.URI.revive(J),te,le),void 0)}registerEvaluatableExpressionProvider(z,J,te,le){const he=this._addNewAdapter(new o(this._documents,te),z);return this._proxy.$registerEvaluatableExpressionProvider(he,this._transformDocumentSelector(J)),this._createDisposable(he)}$provideEvaluatableExpression(z,J,te,le){return this._withAdapter(z,o,he=>he.provideEvaluatableExpression(_.URI.revive(J),te,le),void 0)}registerInlineValuesProvider(z,J,te,le){const he=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ce=this._addNewAdapter(new p(this._documents,te),z);this._proxy.$registerInlineValuesProvider(Ce,this._transformDocumentSelector(J),he);let Me=this._createDisposable(Ce);if(he!==void 0){const we=te.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(he));Me=I.Disposable.from(Me,we)}return Me}$provideInlineValues(z,J,te,le,he){return this._withAdapter(z,p,Ce=>Ce.provideInlineValues(_.URI.revive(J),te,le,he),void 0)}registerDocumentHighlightProvider(z,J,te){const le=this._addNewAdapter(new E(this._documents,te),z);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideDocumentHighlights(z,J,te,le){return this._withAdapter(z,E,he=>he.provideDocumentHighlights(_.URI.revive(J),te,le),void 0)}registerLinkedEditingRangeProvider(z,J,te){const le=this._addNewAdapter(new f(this._documents,te),z);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideLinkedEditingRanges(z,J,te,le){return this._withAdapter(z,f,async he=>{const Ce=await he.provideLinkedEditingRanges(_.URI.revive(J),te,le);if(Ce)return{ranges:Ce.ranges,wordPattern:Ce.wordPattern?Pe._serializeRegExp(Ce.wordPattern):void 0}},void 0)}registerReferenceProvider(z,J,te){const le=this._addNewAdapter(new h(this._documents,te),z);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideReferences(z,J,te,le,he){return this._withAdapter(z,h,Ce=>Ce.provideReferences(_.URI.revive(J),te,le,he),void 0)}registerCodeActionProvider(z,J,te,le){var he,Ce;const Me=new m.DisposableStore,we=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,te,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(J),{providedKinds:(he=le==null?void 0:le.providedCodeActionKinds)===null||he===void 0?void 0:he.map(ke=>ke.value),documentation:(Ce=le==null?void 0:le.documentation)===null||Ce===void 0?void 0:Ce.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,Me)}))},Pe._extLabel(z),Boolean(te.resolveCodeAction)),Me.add(this._createDisposable(we)),Me}$provideCodeActions(z,J,te,le,he){return this._withAdapter(z,T,Ce=>Ce.provideCodeActions(_.URI.revive(J),te,le,he),void 0)}$resolveCodeAction(z,J,te){return this._withAdapter(z,T,le=>le.resolveCodeAction(J,te),void 0)}$releaseCodeActions(z,J){this._withAdapter(z,T,te=>Promise.resolve(te.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(z,J,te){const le=this._addNewAdapter(new L(this._documents,te),z);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentFormattingEdits(z,J,te,le){return this._withAdapter(z,L,he=>he.provideDocumentFormattingEdits(_.URI.revive(J),te,le),void 0)}registerDocumentRangeFormattingEditProvider(z,J,te){const le=this._addNewAdapter(new W(this._documents,te),z);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(J),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(z,J,te,le,he){return this._withAdapter(z,W,Ce=>Ce.provideDocumentRangeFormattingEdits(_.URI.revive(J),te,le,he),void 0)}registerOnTypeFormattingEditProvider(z,J,te,le){const he=this._addNewAdapter(new ee(this._documents,te),z);return this._proxy.$registerOnTypeFormattingSupport(he,this._transformDocumentSelector(J),le,z.identifier),this._createDisposable(he)}$provideOnTypeFormattingEdits(z,J,te,le,he,Ce){return this._withAdapter(z,ee,Me=>Me.provideOnTypeFormattingEdits(_.URI.revive(J),te,le,he,Ce),void 0)}registerWorkspaceSymbolProvider(z,J){const te=this._addNewAdapter(new j(J,this._logService),z);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(z,J,te){return this._withAdapter(z,j,le=>le.provideWorkspaceSymbols(J,te),{symbols:[]})}$resolveWorkspaceSymbol(z,J,te){return this._withAdapter(z,j,le=>le.resolveWorkspaceSymbol(J,te),void 0)}$releaseWorkspaceSymbols(z,J){this._withAdapter(z,j,te=>te.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(z,J,te){const le=this._addNewAdapter(new x(this._documents,te,this._logService),z);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(J),x.supportsResolving(te)),this._createDisposable(le)}$provideRenameEdits(z,J,te,le,he){return this._withAdapter(z,x,Ce=>Ce.provideRenameEdits(_.URI.revive(J),te,le,he),void 0)}$resolveRenameLocation(z,J,te,le){return this._withAdapter(z,x,he=>he.resolveRenameLocation(_.URI.revive(J),te,le),void 0)}registerDocumentSemanticTokensProvider(z,J,te,le){const he=this._nextHandle(),Ce=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(he,new Ae(new F(this._documents,te),z)),this._proxy.$registerDocumentSemanticTokensProvider(he,this._transformDocumentSelector(J),le,Ce);let Me=this._createDisposable(he);if(Ce){const we=te.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(Ce));Me=I.Disposable.from(Me,we)}return Me}$provideDocumentSemanticTokens(z,J,te,le){return this._withAdapter(z,F,he=>he.provideDocumentSemanticTokens(_.URI.revive(J),te,le),null,!0)}$releaseDocumentSemanticTokens(z,J){this._withAdapter(z,F,te=>te.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(z,J,te,le){const he=this._addNewAdapter(new U(this._documents,te),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(he,this._transformDocumentSelector(J),le),this._createDisposable(he)}$provideDocumentRangeSemanticTokens(z,J,te,le){return this._withAdapter(z,U,he=>he.provideDocumentRangeSemanticTokens(_.URI.revive(J),te,le),null,!0)}registerCompletionItemProvider(z,J,te,le){const he=this._addNewAdapter(new M(this._documents,this._commands.converter,te,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(he,this._transformDocumentSelector(J),le,M.supportsResolving(te),`${z.identifier.value}(${le.join("")})`),this._createDisposable(he)}$provideCompletionItems(z,J,te,le,he){return this._withAdapter(z,M,Ce=>Ce.provideCompletionItems(_.URI.revive(J),te,le,he),void 0)}$resolveCompletionItem(z,J,te){return this._withAdapter(z,M,le=>le.resolveCompletionItem(J,te),void 0)}$releaseCompletionItems(z,J){this._withAdapter(z,M,te=>te.releaseCompletionItems(J),void 0)}registerSignatureHelpProvider(z,J,te,le){const he=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Ce=this._addNewAdapter(new N(this._documents,te),z);return this._proxy.$registerSignatureHelpProvider(Ce,this._transformDocumentSelector(J),he),this._createDisposable(Ce)}$provideSignatureHelp(z,J,te,le,he){return this._withAdapter(z,N,Ce=>Ce.provideSignatureHelp(_.URI.revive(J),te,le,he),void 0)}$releaseSignatureHelp(z,J){this._withAdapter(z,N,te=>te.releaseSignatureHelp(J),void 0)}registerInlineHintsProvider(z,J,te){const le=typeof te.onDidChangeInlineHints=="function"?this._nextHandle():void 0,he=this._addNewAdapter(new O(this._documents,te),z);this._proxy.$registerInlineHintsProvider(he,this._transformDocumentSelector(J),le);let Ce=this._createDisposable(he);if(le!==void 0){const Me=te.onDidChangeInlineHints(we=>this._proxy.$emitInlineHintsEvent(le));Ce=I.Disposable.from(Ce,Me)}return Ce}$provideInlineHints(z,J,te,le){return this._withAdapter(z,O,he=>he.provideInlineHints(_.URI.revive(J),te,le),void 0)}registerDocumentLinkProvider(z,J,te){const le=this._addNewAdapter(new V(this._documents,te),z);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(J),typeof te.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(z,J,te){return this._withAdapter(z,V,le=>le.provideLinks(_.URI.revive(J),te),void 0)}$resolveDocumentLink(z,J,te){return this._withAdapter(z,V,le=>le.resolveLink(J,te),void 0)}$releaseDocumentLinks(z,J){this._withAdapter(z,V,te=>te.releaseLinks(J),void 0)}registerColorProvider(z,J,te){const le=this._addNewAdapter(new q(this._documents,te),z);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideDocumentColors(z,J,te){return this._withAdapter(z,q,le=>le.provideColors(_.URI.revive(J),te),[])}$provideColorPresentations(z,J,te,le){return this._withAdapter(z,q,he=>he.provideColorPresentations(_.URI.revive(J),te,le),void 0)}registerFoldingRangeProvider(z,J,te){const le=this._nextHandle(),he=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ae(new X(this._documents,te),z)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(J),he);let Ce=this._createDisposable(le);if(he!==void 0){const Me=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(he));Ce=I.Disposable.from(Ce,Me)}return Ce}$provideFoldingRanges(z,J,te,le){return this._withAdapter(z,X,he=>he.provideFoldingRanges(_.URI.revive(J),te,le),void 0)}registerSelectionRangeProvider(z,J,te){const le=this._addNewAdapter(new fe(this._documents,te,this._logService),z);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$provideSelectionRanges(z,J,te,le){return this._withAdapter(z,fe,he=>he.provideSelectionRanges(_.URI.revive(J),te,le),[])}registerCallHierarchyProvider(z,J,te){const le=this._addNewAdapter(new ve(this._documents,te),z);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(J)),this._createDisposable(le)}$prepareCallHierarchy(z,J,te,le){return this._withAdapter(z,ve,he=>Promise.resolve(he.prepareSession(_.URI.revive(J),te,le)),void 0)}$provideCallHierarchyIncomingCalls(z,J,te,le){return this._withAdapter(z,ve,he=>he.provideCallsTo(J,te,le),void 0)}$provideCallHierarchyOutgoingCalls(z,J,te,le){return this._withAdapter(z,ve,he=>he.provideCallsFrom(J,te,le),void 0)}$releaseCallHierarchy(z,J){this._withAdapter(z,ve,te=>Promise.resolve(te.releaseSession(J)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,y.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Pe._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Pe._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Pe._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Pe._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Pe._serializeRegExp(z.beforeText),afterText:z.afterText?Pe._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Pe._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Pe._serializeOnEnterRule)}setLanguageConfiguration(z,J,te){let{wordPattern:le}=te;if(le&&(0,y.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(J,le):this._documents.setWordDefinitionFor(J,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const he=this._nextHandle(),Ce={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Pe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Pe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Pe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(he,J,Ce),this._createDisposable(he)}$setWordDefinitions(z){for(const J of z)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=Pe,Pe._handlePool=0}),define(me[239],ge([0,1,5,20,7]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(k,y){this._proxy=k.getProxy(_.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,y){await this._proxy.$changeLanguage(k,y);const n=this._documents.getDocumentData(k);if(!n)throw new Error(`document '${k.toString}' NOT found`);return n.document}async tokenAtPosition(k,y){var n;const R=k.version,C=P.Position.from(y),g=await this._proxy.$tokensAtPosition(k.uri,C),m={type:A.StandardTokenType.Other,range:(n=k.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new A.Range(y.line,y.character,y.line,y.character)};if(!g)return m;const s={range:P.Range.to(g.range),type:P.TokenType.to(g.type)};return!s.range.contains(y)||R!==k.version?m:s}}e.ExtHostLanguages=I}),define(me[240],ge([0,1,5,12,41]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(k){return k&&k.title}let D=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(_.MainContext.MainThreadMessageService)}showMessage(y,n,R,C,g){const m={extension:y};let s;typeof C=="string"||I(C)?s=[C,...g]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,s=g),m.useCustom&&(0,A.checkProposedApiEnabled)(y);const d=[];for(let S=0;S<s.length;S++){const w=s[S];if(typeof w=="string")d.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:b,isCloseAffordance:v}=w;d.push({title:b,isCloseAffordance:!!v,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(n,R,m,d).then(S=>{if(typeof S=="number")return s[S]})}};D=je([xe(1,P.ILogService)],D),e.ExtHostMessageService=D}),define(me[241],ge([0,1,21,3,6,2,28,5,20,7,62,86,24,217,218,71,15,22,74,85]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class u extends A.Disposable{constructor(o,p,E,f,h){super();this._editorId=o,this.uri=p,this._proxy=E,this._webviewInitData=f,this.document=h,this._onDidReceiveDocumentMessage=new P.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:T=>this._proxy.$postMessage(this._editorId,void 0,T),asWebviewUri:T=>this._asWebviewUri(T)}}onDidReceiveMessage(o,p){var E;this._onDidReceiveDocumentMessage.fire(p),o!==void 0&&((E=this._rendererIdToEmitters.get(o))===null||E===void 0||E.fire(p))}getRendererComm(o){const p=new P.Emitter;return this._rendererIdToEmitters.set(o,p),{editorId:this._editorId,onDidReceiveMessage:p.event,postMessage:E=>this._proxy.$postMessage(this._editorId,o,E),asWebviewUri:E=>this._asWebviewUri(E)}}_asWebviewUri(o){return(0,R.asWebviewUri)(this._webviewInitData,this._editorId,o)}}class l extends A.Disposable{constructor(o,p,E,f){super();this._proxy=o,this._handle=p,this._extension=E,this._provider=f,this._kernelToFriendlyId=new g.ResourceMap,this._friendlyIdToKernel=new g.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(h=>{const T=h==null?void 0:h.uri;this._proxy.$onNotebookKernelChange(this._handle,T)}))}async provideKernels(o,p){const E=await this._provider.provideKernels(o.notebookDocument,p)||[],f=new Map;let h=0;const T=new Set,L=this._kernelToFriendlyId.get(o.uri),W=E.map(j=>{var x;let $=L==null?void 0:L.get(j);return $===void 0&&(j.id&&T.has(j.id)?$=`${this._extension.identifier.value}_${j.id}_${h++}`:$=`${this._extension.identifier.value}_${j.id||D.generateUuid()}`),f.set(j,$),{id:j.id,friendlyId:$,label:j.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:j.description,detail:j.detail,isPreferred:j.isPreferred,preloads:(x=j.preloads)===null||x===void 0?void 0:x.map(F=>(I.URI.isUri(F)&&(F={uri:F,provides:[]}),{uri:F.uri,provides:typeof F.provides=="string"?[F.provides]:F.provides===void 0?[]:F.provides})),supportedLanguages:j.supportedLanguages,implementsInterrupt:!!j.interrupt}});this._kernelToFriendlyId.set(o.uri,f);const ee=new Map;return f.forEach((j,x)=>{ee.set(j,x)}),this._friendlyIdToKernel.set(o.uri,ee),W}getKernelByFriendlyId(o,p){var E;return(E=this._friendlyIdToKernel.get(o))===null||E===void 0?void 0:E.get(p)}async resolveNotebook(o,p,E,f){var h;const T=(h=this._friendlyIdToKernel.get(p.uri))===null||h===void 0?void 0:h.get(o);if(T&&this._provider.resolveKernel)return this._provider.resolveKernel(T,p.notebookDocument,E,f)}async executeNotebook(o,p,E){var f;const h=(f=this._friendlyIdToKernel.get(p.uri))===null||f===void 0?void 0:f.get(o);if(!!h){const T=E.map(L=>y.NotebookRange.to(L));return h.executeCellsRequest(p.notebookDocument,T)}}async interruptNotebookExecution(o,p){var E;const f=(E=this._friendlyIdToKernel.get(p.uri))===null||E===void 0?void 0:E.get(o);if(!(!f||!f.interrupt))return f.interrupt(p.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=l;class t{constructor(o,p){const E=t._Keys.nextId();o.$registerNotebookEditorDecorationType(E,y.NotebookDecorationRenderOptions.from(p)),this.value={key:E,dispose(){o.$removeNotebookEditorDecorationType(E)}}}}e.NotebookEditorDecorationType=t,t._Keys=new d.IdGenerator("NotebookEditorDecorationType");class i{constructor(o,p,E,f,h,T,L){this._textDocumentsAndEditors=E,this._textDocuments=f,this._webviewInitData=h,this.logService=T,this._extensionStoragePaths=L,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new g.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new P.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new P.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new P.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new P.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new P.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new P.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new P.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new P.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new P.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new P.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new P.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new P.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new g.ResourceMap,this._statusBarCache=new v.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:W=>{var ee;if(W&&W.$mid===12){const j=(ee=W.notebookEditor)===null||ee===void 0?void 0:ee.notebookUri,x=W.cell.handle,$=this._documents.get(j),F=$==null?void 0:$.getCell(x);if(F)return F.cell}return W}})}get activeNotebookEditor(){var o;return(o=this._activeNotebookEditor)===null||o===void 0?void 0:o.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){return this._editors.get(o)}getIdByEditor(o){for(const[p,E]of this._editors)if(E.apiEditor===o)return p}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(o){return this._documents.get(o)}_getNotebookDocument(o){const p=this._documents.get(o);if(!p)throw new Error(`NO notebook document for '${o}'`);return p}_getProviderData(o){const p=this._notebookContentProviders.get(o);if(!p)throw new Error(`NO provider for '${o}'`);return p}registerNotebookContentProvider(o,p,E,f){var h,T,L;if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:o,provider:E});let W;E.onDidChangeNotebookContentOptions&&(W=E.onDidChangeNotebookContentOptions(()=>{const x=y.NotebookDocumentContentOptions.from(E.options);this._notebookProxy.$updateNotebookProviderOptions(p,x)}));const ee=(h=f==null?void 0:f.viewOptions)===null||h===void 0?void 0:h.filenamePattern.map(x=>y.NotebookExclusiveDocumentPattern.from(x)).filter(x=>x!==void 0);((T=f==null?void 0:f.viewOptions)===null||T===void 0?void 0:T.filenamePattern)&&!ee&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=f==null?void 0:f.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`);const j=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation,description:o.description},p,{transientOutputs:j.transientOutputs,transientMetadata:j.transientMetadata,viewOptions:(f==null?void 0:f.viewOptions)&&ee?{displayName:f.viewOptions.displayName,filenamePattern:ee,exclusive:f.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{W==null||W.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}registerNotebookKernelProvider(o,p,E){const f=i._notebookKernelProviderHandlePool++,h=new l(this._notebookProxy,f,o,E);return this._notebookKernelProviders.set(f,h),this._notebookProxy.$registerNotebookKernelProvider({id:o.identifier,location:o.extensionLocation,description:o.description},f,{viewType:p.viewType,filenamePattern:p.filenamePattern?y.NotebookExclusiveDocumentPattern.from(p.filenamePattern):void 0}),new n.Disposable(()=>{h.dispose(),this._notebookKernelProviders.delete(f),this._notebookProxy.$unregisterNotebookKernelProvider(f)})}registerNotebookCellStatusBarItemProvider(o,p,E){const f=i._notebookStatusBarItemProviderHandlePool++,h=typeof E.onDidChangeCellStatusBarItems=="function"?i._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(f,E),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(f,h,{viewType:p.viewType,filenamePattern:p.filenamePattern?y.NotebookExclusiveDocumentPattern.from(p.filenamePattern):void 0});let T;return h!==void 0&&(T=E.onDidChangeCellStatusBarItems(L=>this._notebookProxy.$emitCellStatusBarEvent(h))),new n.Disposable(()=>{this._notebookStatusBarItemProviders.delete(f),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(f,h),T&&T.dispose()})}createNotebookEditorDecorationType(o){return new t(this._notebookEditorsProxy,o).value}async openNotebookDocument(o){const p=this._documents.get(o);if(p)return p.notebookDocument;const E=await this._notebookDocumentsProxy.$tryOpenDocument(o),f=this._documents.get(I.URI.revive(E));return(0,S.assertIsDefined)(f==null?void 0:f.notebookDocument)}_withAdapter(o,p,E){const f=this._documents.get(I.URI.revive(p));if(!f)return[];const h=this._notebookKernelProviders.get(o);return h?E(h,f):[]}async showNotebookDocument(o,p){var E;I.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let f;typeof p=="object"?f={position:y.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(y.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:f={preserveFocus:!1};const h=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.viewType,f),T=h&&((E=this._editors.get(h))===null||E===void 0?void 0:E.apiEditor);if(T)return T;throw h?new Error(`Could NOT open editor for "${o.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.toString()}".`)}async $provideNotebookKernels(o,p,E){return this._withAdapter(o,p,(f,h)=>f.provideKernels(h,E))}async $resolveNotebookKernel(o,p,E,f,h){await this._withAdapter(o,E,async(T,L)=>{const W=this._webviewComm.get(p);W&&await T.resolveNotebook(f,L,W.contentProviderComm,h)})}async $provideNotebookCellStatusBarItems(o,p,E,f){var h;const T=this._notebookStatusBarItemProviders.get(o),L=I.URI.revive(p),W=this._documents.get(L);if(!(!W||!T)){const ee=W.getCellFromIndex(E);if(!!ee){const j=await T.provideCellStatusBarItems(ee.cell,f);if(!!j){const x=new A.DisposableStore,$=this._statusBarCache.add([x]),F=(h=j&&j.map(U=>y.NotebookStatusBarItem.from(U,this._commandsConverter,x)))!==null&&h!==void 0?h:void 0;return{cacheId:$,items:F}}}}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}async $resolveNotebookEditor(o,p,E){const f=this._notebookContentProviders.get(o),h=I.URI.revive(p),T=this._documents.get(h);if(!(!T||!f)){let L=this._webviewComm.get(E);L||(L=new u(E,h,this._notebookProxy,this._webviewInitData,T),this._webviewComm.set(E,L))}}async $executeNotebookKernelFromProvider(o,p,E,f){await this._withAdapter(o,p,async(h,T)=>h.executeNotebook(E,T,f))}registerNotebookSerializer(o,p,E,f){const h=this._handlePool++;this._notebookSerializer.set(h,E);const T=y.NotebookDocumentContentOptions.from(f);return this._notebookProxy.$registerNotebookSerializer(h,{id:o.identifier,location:o.extensionLocation,description:o.description},p,T),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(h)})}async $dataToNotebook(o,p,E){const f=this._notebookSerializer.get(o);if(!f)throw new Error("NO serializer found");const h=await f.deserializeNotebook(p.buffer,E);return{metadata:y.NotebookDocumentMetadata.from(h.metadata),cells:h.cells.map(y.NotebookCellData.from)}}async $notebookToData(o,p,E){const f=this._notebookSerializer.get(o);if(!f)throw new Error("NO serializer found");const h=await f.serializeNotebook({metadata:y.NotebookDocumentMetadata.to(p.metadata),cells:p.cells.map(y.NotebookCellData.to)},E);return w.VSBuffer.wrap(h)}async $cancelNotebookCellExecution(o,p,E,f){await this._withAdapter(o,p,async(T,L)=>T.interruptNotebookExecution(E,L));const h=this._documents.get(I.URI.revive(p));if(!!h)for(let T of f)for(let L=T.start;L<T.end;L++){const W=h.getCellFromIndex(L);W&&this.cancelOneNotebookCellExecution(W)}}cancelOneNotebookCellExecution(o){const p=this._activeExecutions.get(o.uri);p==null||p.cancel()}async $openNotebook(o,p,E,f,h){const{provider:T}=this._getProviderData(o),L=await T.openNotebook(I.URI.revive(p),{backupId:E,untitledDocumentData:f==null?void 0:f.buffer},h);return{metadata:y.NotebookDocumentMetadata.from(L.metadata),cells:L.cells.map(y.NotebookCellData.from)}}async $saveNotebook(o,p,E){const f=this._getNotebookDocument(I.URI.revive(p)),{provider:h}=this._getProviderData(o);return await h.saveNotebook(f.notebookDocument,E),!0}async $saveNotebookAs(o,p,E,f){const h=this._getNotebookDocument(I.URI.revive(p)),{provider:T}=this._getProviderData(o);return await T.saveNotebookAs(I.URI.revive(E),h.notebookDocument,f),!0}async $backupNotebook(o,p,E){var f;const h=this._getNotebookDocument(I.URI.revive(p)),T=this._getProviderData(o),L=(f=this._extensionStoragePaths.workspaceValue(T.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(T.extension),W=String((0,b.hash)([h.uri.toString(),this._backupIdPool++])),ee=I.URI.joinPath(L,W),j=await T.provider.backupNotebook(h.notebookDocument,{destination:ee},E);return h.updateBackup(j),j.id}$acceptNotebookActiveKernelChange(o){o.providerHandle!==void 0&&this._withAdapter(o.providerHandle,o.uri,async(p,E)=>{const f=o.kernelFriendlyId?p.getKernelByFriendlyId(I.URI.revive(o.uri),o.kernelFriendlyId):void 0;this._editors.forEach(h=>{h.notebookData===E&&h._acceptKernel(f)}),this._onDidChangeActiveNotebookKernel.fire({document:E.notebookDocument,kernel:f})})}$onDidReceiveMessage(o,p,E){var f;(f=this._webviewComm.get(o))===null||f===void 0||f.onDidReceiveMessage(p,E)}$acceptModelChanged(o,p,E){this._getNotebookDocument(I.URI.revive(o)).acceptModelChanged(p,E)}$acceptDirtyStateChanged(o,p){const E=this._getNotebookDocument(I.URI.revive(o));E.acceptModelChanged({rawEvents:[],versionId:E.notebookDocument.version},p)}$acceptModelSaved(o){const p=this._getNotebookDocument(I.URI.revive(o));this._onDidSaveNotebookDocument.fire(p.notebookDocument)}$acceptEditorPropertiesChanged(o,p){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",o,p);const E=this._editors.get(o);if(!E)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(y.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(y.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(o){for(const p in o){const E=this._editors.get(p);if(!E)throw new Error(`unknown text editor: ${p}. known editors: ${[...this._editors.keys()]} `);E._acceptViewColumn(y.ViewColumn.to(o[p]))}}$acceptDocumentPropertiesChanged(o,p){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",o.path,p);const E=this._getNotebookDocument(I.URI.revive(o));E.acceptDocumentPropertiesChanged(p),p.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:E.notebookDocument})}_createExtHostEditor(o,p,E){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const f=o.uri;let h=this._webviewComm.get(p);h||(h=new u(p,f,this._notebookProxy,this._webviewInitData,o),this._webviewComm.set(p,h));const T=new s.ExtHostNotebookEditor(p,this._notebookEditorsProxy,o,E.visibleRanges.map(y.NotebookRange.to),E.selections.map(y.NotebookRange.to),typeof E.viewColumn=="number"?y.ViewColumn.to(E.viewColumn):void 0);this._editors.set(p,T)}$acceptDocumentAndEditorsDelta(o){var p,E,f;if(o.removedDocuments)for(const T of o.removedDocuments){const L=I.URI.revive(T),W=this._documents.get(L);W&&(W.dispose(),this._documents.delete(L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:W.notebookDocument.getCells().map(ee=>ee.document.uri)}),this._onDidCloseNotebookDocument.fire(W.notebookDocument));for(const ee of this._editors.values())ee.notebookData.uri.toString()===L.toString()&&this._editors.delete(ee.id)}if(o.addedDocuments){const T=[];for(const L of o.addedDocuments){const W=I.URI.revive(L.uri),ee=L.viewType;if(this._documents.has(W))throw new Error(`adding EXISTING notebook ${W} `);const j=this,x=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange($){j._onDidChangeNotebookCells.fire($)},emitCellOutputsChange($){j._onDidChangeCellOutputs.fire($)},emitCellMetadataChange($){j._onDidChangeCellMetadata.fire($)},emitCellExecutionStateChange($){j._onDidChangeCellExecutionState.fire($)}},ee,L.metadata?y.NotebookDocumentMetadata.to(L.metadata):new n.NotebookDocumentMetadata,W);x.acceptModelChanged({versionId:L.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,L.cells]]}]},!1),T.push(...L.cells.map($=>m.ExtHostCell.asModelAddData(x.notebookDocument,$))),(p=this._documents.get(W))===null||p===void 0||p.dispose(),this._documents.set(W,x),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this._onDidOpenNotebookDocument.fire(x.notebookDocument)}}if(o.addedEditors)for(const T of o.addedEditors){if(this._editors.has(T.id))return;const L=I.URI.revive(T.documentUri),W=this._documents.get(L);W&&this._createExtHostEditor(W,T.id,T)}const h=[];if(o.removedEditors)for(const T of o.removedEditors){const L=this._editors.get(T);L&&(this._editors.delete(T),((E=this._activeNotebookEditor)===null||E===void 0?void 0:E.id)===L.id&&(this._activeNotebookEditor=void 0),h.push(L))}if(o.visibleEditors){this._visibleNotebookEditors=o.visibleEditors.map(L=>this._editors.get(L)).filter(L=>!!L);const T=new Set;this._visibleNotebookEditors.forEach(L=>T.add(L.id));for(const L of this._editors.values()){const W=T.has(L.id);L._acceptVisibility(W)}this._visibleNotebookEditors=[...this._editors.values()].map(L=>L).filter(L=>L.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.newActiveEditor===null?this._activeNotebookEditor=void 0:o.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.newActiveEditor)),o.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor)}createNotebookCellExecution(o,p,E){const f=this.lookupNotebookDocument(o);if(!f)throw new Error(`Invalid cell uri / index: ${o}, ${p} `);const h=f.getCellFromIndex(p);if(!h)throw new Error(`Invalid cell uri / index: ${o}, ${p} `);if(!this._activeExecutions.has(h.uri)){const T=new r(o,f,h,this._notebookDocumentsProxy);this._activeExecutions.set(h.uri,T);const L=T.onDidChangeState(()=>{T.state===a.Resolved&&(T.dispose(),L.dispose(),this._activeExecutions.delete(h.uri))});return T.asApiObject()}}}e.ExtHostNotebookController=i,i._notebookKernelProviderHandlePool=0,i._notebookStatusBarItemProviderHandlePool=0;var a;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(a||(a={}));class r extends A.Disposable{constructor(o,p,E,f){super();this._uri=o,this._document=p,this._cell=E,this._proxy=f,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._executionOrder=E.internalMetadata.executionOrder,this.mixinMetadata({runState:n.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(o){return this._proxy.$applyEdits(this._uri,o,!1)}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(o){const p=[{editType:11,handle:this._cell.handle,metadata:o}];this.applyEdits(p)}cellIndexToHandle(o){const p=typeof o=="number"?this._document.getCellFromIndex(o):this._cell;if(!!p)return p.handle}asApiObject(){const o=this;return Object.freeze({get document(){return o._document.notebookDocument},get cell(){return o._cell.cell},get executionOrder(){return o._executionOrder},set executionOrder(p){o._executionOrder=p,o.mixinMetadata({executionOrder:p})},start(p){if(o._state===a.Resolved||o._state===a.Started)throw new Error("Cannot call start again");o._state=a.Started,o._onDidChangeState.fire(),o.mixinMetadata({runState:n.NotebookCellExecutionState.Executing,runStartTime:p==null?void 0:p.startTime})},end(p){var E,f;if(o._state===a.Resolved)throw new Error("Cannot call resolve twice");o._state=a.Resolved,o._onDidChangeState.fire(),o.mixinMetadata({runState:n.NotebookCellExecutionState.Idle,lastRunSuccess:(E=p==null?void 0:p.success)!==null&&E!==void 0?E:null,runEndTime:(f=p==null?void 0:p.endTime)!==null&&f!==void 0?f:null})},clearOutput(p){return o.verifyStateForOutput(),this.replaceOutput([],p)},async appendOutput(p,E){o.verifyStateForOutput();const f=o.cellIndexToHandle(E);if(typeof f=="number")return p=Array.isArray(p)?p:[p],o.applyEdits([{editType:2,handle:f,append:!0,outputs:p.map(y.NotebookCellOutput.from)}])},async replaceOutput(p,E){o.verifyStateForOutput();const f=o.cellIndexToHandle(E);if(typeof f=="number")return p=Array.isArray(p)?p:[p],o.applyEdits([{editType:2,handle:f,outputs:p.map(y.NotebookCellOutput.from)}])},async appendOutputItems(p,E){return o.verifyStateForOutput(),p=Array.isArray(p)?p:[p],o.applyEdits([{editType:10,append:!0,items:p.map(y.NotebookCellOutputItem.from),outputId:E}])},async replaceOutputItems(p,E){return o.verifyStateForOutput(),p=Array.isArray(p)?p:[p],o.applyEdits([{editType:10,items:p.map(y.NotebookCellOutputItem.from),outputId:E}])},token:o._tokenSource.token})}}}),define(me[242],ge([0,1,3,6,5,2,20,14,62]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class n{constructor(C,g,m){this._initData=g,this._extHostNotebook=m,this._kernelData=new Map,this._handlePool=0,this._proxy=C.getProxy(A.MainContext.MainThreadNotebookKernels)}createKernel(C,g){var m,s;const d=this._handlePool++,S=this;let w=!1;const b=new P.DisposableStore,v=new _.Emitter,u=new _.Emitter,l={id:g.id,selector:g.selector,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:g.label,supportedLanguages:[]};let t=g.executeHandler,i=g.interruptHandler;this._proxy.$addKernel(d,l);let a=0;const r=()=>{if(!w){const o=++a;Promise.resolve().then(()=>{o===a&&this._proxy.$updateKernel(d,l)})}},c={get id(){return l.id},get selector(){return l.selector},onDidChangeNotebookAssociation:v.event,get label(){return l.label},set label(o){l.label=o,r()},get description(){var o;return(o=l.description)!==null&&o!==void 0?o:""},set description(o){l.description=o,r()},get isPreferred(){var o;return(o=l.isPreferred)!==null&&o!==void 0?o:!1},set isPreferred(o){l.isPreferred=o,r()},get supportedLanguages(){return l.supportedLanguages},set supportedLanguages(o){l.supportedLanguages=(0,k.isNonEmptyArray)(o)?o:["plaintext"],r()},get hasExecutionOrder(){var o;return(o=l.hasExecutionOrder)!==null&&o!==void 0?o:!1},set hasExecutionOrder(o){l.hasExecutionOrder=o,r()},get preloads(){return l.preloads&&l.preloads.map(D.NotebookKernelPreload.to)},set preloads(o){l.preloads=o&&o.map(D.NotebookKernelPreload.from),r()},get executeHandler(){return t},get interruptHandler(){return i},set interruptHandler(o){i=o,l.supportsInterrupt=Boolean(o),r()},createNotebookCellExecutionTask(o){if(w)throw new Error("notebook controller is DISPOSED");return S._extHostNotebook.createNotebookCellExecution(o.notebook.uri,o.index,l.id)},dispose:()=>{w||(w=!0,this._kernelData.delete(d),b.dispose(),v.dispose(),u.dispose(),this._proxy.$removeKernel(d))},onDidReceiveMessage:u.event,postMessage(o,p){return S._proxy.$postMessage(d,p&&S._extHostNotebook.getIdByEditor(p),o)},asWebviewUri(o,p){return(0,y.asWebviewUri)(S._initData.environment,S._extHostNotebook.getIdByEditor(p),o)}};return this._kernelData.set(d,{controller:c,onDidChangeSelection:v,onDidReceiveMessage:u}),c.supportedLanguages=(m=g.supportedLanguages)!==null&&m!==void 0?m:[],c.interruptHandler=g.interruptHandler,c.hasExecutionOrder=(s=g.hasExecutionOrder)!==null&&s!==void 0?s:!1,c}$acceptSelection(C,g,m){const s=this._kernelData.get(C);s&&s.onDidChangeSelection.fire({selected:m,notebook:this._extHostNotebook.lookupNotebookDocument(I.URI.revive(g)).notebookDocument})}$executeCells(C,g,m){const s=this._kernelData.get(C);if(!!s){const d=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(g));if(!d)throw new Error("MISSING notebook");const S=[];for(let w of m)S.push(...d.notebookDocument.getCells(D.NotebookRange.to(w)));try{s.controller.executeHandler(S,s.controller)}catch(w){console.error(w)}}}$cancelCells(C,g,m){const s=this._kernelData.get(C);if(!!s){const d=this._extHostNotebook.lookupNotebookDocument(I.URI.revive(g));if(!d)throw new Error("MISSING notebook");s.controller.interruptHandler&&s.controller.interruptHandler(d.notebookDocument)}}$acceptRendererMessage(C,g,m){const s=this._kernelData.get(C);if(!!s){const d=this._extHostNotebook.getEditorById(g);if(!d)throw new Error(`send message for UNKNOWN editor: ${g}`);s.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:m}))}}}e.ExtHostNotebookKernels=n}),define(me[64],ge([0,1,5,3,6,22,4,13]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends A.Disposable{constructor(s,d,S,w){super();this._onDidAppend=this._register(new P.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=s,this._proxy=w,this._id=w.$register(this.name,d,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(s){this.validate(),this._offset+=s?I.VSBuffer.fromString(s).byteLength:0}update(){this._id.then(s=>this._proxy.$update(s))}appendLine(s){this.validate(),this.append(s+`
`)}clear(){this.validate();const s=this._offset;this._id.then(d=>this._proxy.$clear(d,s))}show(s,d){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof s=="boolean"?s:d)))}hide(){this.validate(),this._id.then(s=>this._proxy.$close(s))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(s=>this._proxy.$dispose(s)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(s,d){super(s,!1,void 0,d)}append(s){super.append(s),this._id.then(d=>this._proxy.$append(d,s)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class R extends y{constructor(s,d,S){super(s,!0,d,S)}append(s){throw new Error("Not supported")}}class C{constructor(s,d){this.name=s,this._channel=d}append(s){this._channel.then(d=>d.append(s))}appendLine(s){this._channel.then(d=>d.appendLine(s))}clear(){this._channel.then(s=>s.clear())}show(s,d){this._channel.then(S=>S.show(s,d))}hide(){this._channel.then(s=>s.hide())}dispose(){this._channel.then(s=>s.dispose())}}e.LazyOutputChannel=C;let g=class{constructor(s){this._proxy=s.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(s){}createOutputChannel(s){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");return new n(s,this._proxy)}createOutputChannelFromLogFile(s,d){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new R(s,d,this._proxy)}};g=je([xe(0,k.IExtHostRpcService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(me[243],ge([0,1,19,21,3,6,5,2,7,18,14,56]),function(G,e,_,P,A,I,D,k,y,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(m,s,d){const S=m.getProxy(D.MainContext.MainThreadQuickOpen);class w{constructor(r,c){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=c}showQuickPick(r,c,o,p=P.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(r),f=++this._instances,h=S.$show(f,{title:o==null?void 0:o.title,placeHolder:o==null?void 0:o.placeHolder,matchOnDescription:o==null?void 0:o.matchOnDescription,matchOnDetail:o==null?void 0:o.matchOnDetail,ignoreFocusLost:o==null?void 0:o.ignoreFocusOut,canPickMany:o==null?void 0:o.canPickMany},p),T={},L=h.then(()=>T);return Promise.race([L,E]).then(W=>{if(W!==T)return E.then(ee=>{const j=[];for(let x=0;x<ee.length;x++){const $=ee[x];let F,U,M,N,O;typeof $=="string"?F=$:(F=$.label,U=$.description,M=$.detail,N=$.picked,O=$.alwaysShow),j.push({label:F,description:U,handle:x,detail:M,picked:N,alwaysShow:O})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{o.onDidSelectItem(ee[x])}),S.$setItems(f,j),h.then(x=>{if(typeof x=="number")return ee[x];if(Array.isArray(x))return x.map($=>ee[$])})})}).then(void 0,W=>{if(!(0,n.isPromiseCanceledError)(W))return S.$setError(f,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,c=P.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",c).then(void 0,o=>{if(!(0,n.isPromiseCanceledError)(o))return Promise.reject(o)})}$validateInput(r){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,c=P.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!o){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(E=>E.uri.toString()===o.uri.toString())}}createQuickPick(r,c){const o=new t(r,c,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(r){const c=new i(r,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(r,c){const o=this._sessions.get(r);o&&o._fireDidChangeValue(c)}$onDidAccept(r){const c=this._sessions.get(r);c&&c._fireDidAccept()}$onDidChangeActive(r,c){const o=this._sessions.get(r);o instanceof t&&o._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const o=this._sessions.get(r);o instanceof t&&o._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){const o=this._sessions.get(r);o&&o._fireDidTriggerButton(c)}$onDidHide(r){const c=this._sessions.get(r);c&&c._fireDidHide()}}class b{constructor(r,c){this._extensionId=r,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((c,o)=>{const p=c===y.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(p,c)}),this.update({buttons:r.map((c,o)=>({iconPath:v(c.iconPath),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const c=this._handlesToButtons.get(r);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const c of Object.keys(r)){const o=r[c];this._pendingUpdate[c]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function v(a){if(a instanceof y.ThemeIcon)return{id:a.id};const r=l(a),c=u(a);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof c=="string"?k.URI.file(c):c}}function u(a){return typeof a=="object"&&"light"in a?a.light:a}function l(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends b{constructor(r,c,o){super(r,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,o)=>{this._handlesToItems.set(o,c),this._itemsToHandles.set(c,o)}),this.update({items:r.map((c,o)=>({label:c.label,description:c.description,handle:o,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(r){const c=(0,R.coalesce)(r.map(o=>this._handlesToItems.get(o)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(r){const c=(0,R.coalesce)(r.map(o=>this._handlesToItems.get(o)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class i extends b{constructor(r,c){super(r,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?C.default.Error:C.default.Ignore})}}return new w(s,d)}e.createExtHostQuickOpen=g}),define(me[244],ge([0,1,2,3,69,6,19,5,14,96,12,29,41]),function(G,e,_,P,A,I,D,k,y,n,R,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(r){if(r)return typeof r.iconPath=="string"?_.URI.file(r.iconPath):r.iconPath}function s(r,c){if(!r.iconPath&&!c.iconPath)return 0;if(r.iconPath){if(!c.iconPath)return 1}else return-1;const o=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof c.iconPath=="string"?c.iconPath:c.iconPath.fsPath;return(0,n.comparePaths)(o,p)}function d(r,c){let o=0;if(r.strikeThrough!==c.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==c.faded)return r.faded?1:-1;if(r.tooltip!==c.tooltip)return(r.tooltip||"").localeCompare(c.tooltip||"");if(o=s(r,c),o!==0)return o;if(r.light&&c.light)o=s(r.light,c.light);else{if(r.light)return 1;if(c.light)return-1}if(o!==0)return o;if(r.dark&&c.dark)o=s(r.dark,c.dark);else{if(r.dark)return 1;if(c.dark)return-1}return o}function S(r,c){if(r.command!==c.command)return r.command<c.command?-1:1;if(r.title!==c.title)return r.title<c.title?-1:1;if(r.tooltip!==c.tooltip){if(r.tooltip!==void 0&&c.tooltip!==void 0)return r.tooltip<c.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(r.arguments===c.arguments)return 0;if(r.arguments)if(c.arguments){if(r.arguments.length!==c.arguments.length)return r.arguments.length-c.arguments.length}else return 1;else return-1;for(let o=0;o<r.arguments.length;o++){const p=r.arguments[o],E=c.arguments[o];if(p!==E)return p<E?-1:1}return 0}function w(r,c){let o=(0,n.comparePaths)(r.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(o!==0)return o;if(r.command&&c.command)o=S(r.command,c.command);else{if(r.command)return 1;if(c.command)return-1}if(o!==0)return o;if(r.decorations&&c.decorations)o=d(r.decorations,c.decorations);else{if(r.decorations)return 1;if(c.decorations)return-1}return o}function b(r,c){for(let o=0;o<r.length;o++)if(r[o]!==c[o])return!1;return!0}function v(r,c){return r.command===c.command&&r.title===c.title&&r.tooltip===c.tooltip&&(r.arguments&&c.arguments?b(r.arguments,c.arguments):r.arguments===c.arguments)}function u(r,c){return(0,y.equals)(r,c,v)}class l{constructor(c,o,p){this._extension=c,this._proxy=o,this._sourceControlHandle=p,this._value="",this._onDidChange=new P.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,g.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,g.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,o){(0,g.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,o)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=l;class t{constructor(c,o,p,E,f){this._proxy=c,this._commands=o,this._sourceControlHandle=p,this._id=E,this._label=f,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new P.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new P.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,o){const p=this._resourceStatesCommandsMap.get(c);return p?(0,D.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],o)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var c;const o=[...this._resourceStates].sort(w),E=(0,y.sortedDiff)(this._resourceSnapshot,o,w).map(T=>{const L=T.toInsert.map(W=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,W);const j=W.resourceUri,x=m(W.decorations),$=W.decorations&&m(W.decorations.light)||x,F=W.decorations&&m(W.decorations.dark)||x,U=[];let M;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const fe=new I.DisposableStore;M=this._commands.converter.toInternal(W.command,fe),this._resourceStatesDisposablesMap.set(ee,fe)}else this._resourceStatesCommandsMap.set(ee,W.command);$&&U.push($),F&&F.toString()!==($==null?void 0:$.toString())&&U.push(F);const N=W.decorations&&W.decorations.tooltip||"",O=W.decorations&&!!W.decorations.strikeThrough,V=W.decorations&&!!W.decorations.faded,q=W.contextValue||"";return{rawResource:[ee,j,U,N,O,V,q,M],handle:ee}});return{start:T.start,deleteCount:T.deleteCount,toInsert:L}}),f=E.map(({start:T,deleteCount:L,toInsert:W})=>[T,L,W.map(ee=>ee.rawResource)]),h=E.reverse();for(const{start:T,deleteCount:L,toInsert:W}of h){const ee=W.map(x=>x.handle),j=this._handlesSnapshot.splice(T,L,...ee);for(const x of j)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(c=this._resourceStatesDisposablesMap.get(x))===null||c===void 0||c.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=o,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(c,o,p,E,f,h){this._proxy=o,this._commands=p,this._id=E,this._label=f,this._rootUri=h,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new P.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new l(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,f,h)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=c;const o=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:o})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(!(this._statusBarCommands&&c&&u(this._statusBarCommands,c))){this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=c;const o=(c||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:o})}}get selected(){return this._selected}createResourceGroup(c,o){const p=new t(this._proxy,this._commands,this.handle,c,o),E=P.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,E),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const c=[],o=[];for(const[p,E]of this.createdResourceGroups){E.dispose();const f=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});P.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),f.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),c.push([p.handle,p.id,p.label,p.features]);const h=p._takeResourceStateSnapshot();h.length>0&&o.push([p.handle,h]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,c,o),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(o=>{const p=o._takeResourceStateSnapshot();p.length!==0&&c.push([o.handle,p])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,A.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,A.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let a=class Fn{constructor(c,o,p){this._commands=o,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new P.Emitter,this._proxy=c.getProxy(k.MainContext.MainThreadSCM),this._telemetry=c.getProxy(k.MainContext.MainThreadTelemetry),o.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const f=this._sourceControls.get(E.sourceControlHandle);if(!f)return E;const h=f.getResourceGroup(E.groupHandle);return h?h.getResourceState(E.handle):E}else if(E&&E.$mid===4){const f=this._sourceControls.get(E.sourceControlHandle);return f?f.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const f=this._sourceControls.get(E.handle);return f||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,o,p,E){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,o,p,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const f=Fn._handlePool++,h=new i(c,this._proxy,this._commands,o,p,E);this._sourceControls.set(f,h);const T=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(c.identifier))||[];return T.push(h),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(c.identifier),T),h}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const o=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(c.identifier)),p=o&&o[o.length-1];return p&&p.inputBox}$provideOriginalResource(c,o,p){const E=_.URI.revive(o);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,E.toString());const f=this._sourceControls.get(c);return!f||!f.quickDiffProvider||!f.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>f.quickDiffProvider.provideOriginalResource(E,p)).then(h=>h||null)}$onInputBoxValueChange(c,o){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const p=this._sourceControls.get(c);return p&&p.inputBox.$onInputBoxValueChange(o),Promise.resolve(void 0)}$executeResourceCommand(c,o,p,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,o,p);const f=this._sourceControls.get(c);if(!f)return Promise.resolve(void 0);const h=f.getResourceGroup(o);return h?h.$executeResourceCommand(p,E):Promise.resolve(void 0)}$validateInput(c,o,p){this.logService.trace("ExtHostSCM#$validateInput",c);const E=this._sourceControls.get(c);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>E.inputBox.validateInput(o,p)).then(f=>f?Promise.resolve([f.message,f.type]):Promise.resolve(void 0))}$setSelectedSourceControl(c){var o,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&((o=this._sourceControls.get(c))===null||o===void 0||o.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};a._handlePool=0,a=je([xe(2,R.ILogService)],a),e.ExtHostSCM=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[245],ge([0,1,7,5,163,6]),function(G,e,_,P,A,I){"use strict";var D,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(g,m,s,d,S=_.StatusBarAlignment.Left,w,b){D.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,tt(this,D,g,"f"),tt(this,k,m,"f"),this._id=y.ID_GEN++,this._statusId=s,this._statusName=d,this._alignment=S,this._priority=w,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!y.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:He(this,k,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:He(this,k,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,D,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var g;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),He(this,D,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(g=this._command)===null||g===void 0?void 0:g.internal,m,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,k=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(g){this._messages=[],this._item=g.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const m={message:g};return this._messages.unshift(m),this._update(),new _.Disposable(()=>{const s=this._messages.indexOf(m);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class R{constructor(g,m){this._proxy=g.getProxy(P.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new n(this)}createStatusBarEntry(g,m,s,d,S){return new y(this._proxy,this._commands,g,m,s,d,S)}setStatusBarMessage(g,m){const s=this._statusMessage.setMessage(g);let d;return typeof m=="number"?d=setTimeout(()=>s.dispose(),m):typeof m!="undefined"&&m.then(()=>s.dispose(),()=>s.dispose()),new _.Disposable(()=>{s.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=R}),define(me[89],ge([0,1,5,3,4]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(k){this._onDidChangeStorage=new P.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,y){this._proxy.$registerExtensionStorageKeysToSync(k,y)}getValue(k,y,n){return this._proxy.$getValue(k,y).then(R=>R||n)}setValue(k,y,n){return this._proxy.$setValue(k,y,n)}$acceptValue(k,y,n){this._onDidChangeStorage.fire({shared:k,key:y,value:n})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(me[90],ge([0,1,4,27,12,88,2]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let k=class{constructor(n,R,C){var g;this._logService=R,this._extHostFileSystem=C,this._workspace=(g=n.workspace)!==null&&g!==void 0?g:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,C=D.URI.joinPath(this._environment.workspaceStorageHome,R);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(g){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=D.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),C}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(n){if(this._value)return D.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return D.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};k=je([xe(0,P.IExtHostInitDataService),xe(1,A.ILogService),xe(2,I.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(me[34],ge([0,1,3,5,4,2,13,6,7,164,18,209,21,28,189]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class d{constructor(t,i,a,r){this._proxy=t,this._id=i,this._creationOptions=a,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(o=>this._pidPromiseComplete=o);const c=this;this.value={get name(){return c._name||""},get processId(){return c._pidPromise},get creationOptions(){return c._creationOptions},get exitStatus(){return c._exitStatus},sendText(o,p=!0){c._checkDisposed(),c._proxy.$sendText(c._id,o,p)},show(o){c._checkDisposed(),c._proxy.$show(c._id,o)},hide(){c._checkDisposed(),c._proxy.$hide(c._id)},dispose(){c._disposed||(c._disposed=!0,c._proxy.$dispose(c._id))},get dimensions(){if(!(c._cols===void 0||c._rows===void 0))return{columns:c._cols,rows:c._rows}}}}async create(t,i,a,r,c,o,p,E,f,h,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:a,env:r,icon:c,initialText:o,waitOnExit:p,strictEnv:E,hideFromUser:f,isFeatureTerminal:h,isExtensionOwnedTerminal:T})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let w=1,b=class extends k.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=i.getProxy(P.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[a,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new d(this._proxy,(0,m.generateUuid)(),t,t.name),a=new S(t.pty);return i.createExtensionTerminal().then(r=>{const c=this._setupExtHostProcessListeners(r,a);this._terminalProcessDisposables[r]=c}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(i),c=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=c}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(t);a&&(this._activeTerminal=a,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const a=this._getTerminalById(t);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:i})}async $acceptTerminalDimensions(t,i,a){const r=this._getTerminalById(t);r&&r.setDimensions(i,a)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,a){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,a)}async $acceptTerminalTitleChange(t,i){const a=this._getTerminalById(t);a&&(a.name=i)}async $acceptTerminalClosed(t,i){const a=this._getTerminalObjectIndexById(this._terminals,t);if(a!==null){const r=this._terminals.splice(a,1)[0];r.setExitCode(i),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,i,a,r){if(i){const p=this._getTerminalObjectIndexById(this._terminals,i);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const c={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:I.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},o=new d(this._proxy,t,c,a);this._terminals.push(o),this._onDidOpenTerminal.fire(o.value),o.isOpen=!0}async $acceptTerminalProcessId(t,i){const a=this._getTerminalById(t);a&&a._setProcessId(i)}async $startExtensionTerminal(t,i){const a=this._getTerminalById(t);if(!a)return{message:(0,n.localize)(0,null,t)};a.isOpen||await new Promise(c=>{const o=this.onDidOpenTerminal(async p=>{p===a.value&&(o.dispose(),c())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const a=new k.DisposableStore;a.add(i.onProcessReady(c=>this._proxy.$sendProcessReady(t,c.pid,c.cwd))),a.add(i.onProcessTitleChanged(c=>this._proxy.$sendProcessTitle(t,c))),this._bufferer.startBuffering(t,i.onProcessData),a.add(i.onProcessExit(c=>this._onProcessExit(t,c))),i.onProcessOverrideDimensions&&a.add(i.onProcessOverrideDimensions(c=>this._proxy.$sendOverrideDimensions(t,c))),this._terminalProcesses.set(t,i);const r=this._extensionTerminalAwaitingStart[t];return r&&i instanceof S&&(i.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),a}$acceptProcessAckDataEvent(t,i){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.input(i)}$acceptProcessResize(t,i,a){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(i,a)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(t,i){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(t,a))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(a=>this._proxy.$sendProcessCwd(t,a))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const a=this._getTerminalById(t);if(!a)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const c=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,c);const o=[],p={terminal:a.value,line:i},E=[];for(const T of this._linkProviders)E.push(new Promise(async L=>{c.token.onCancellationRequested(()=>L({provider:T,links:[]}));const W=await T.provideTerminalLinks(p,c.token)||[];c.token.isCancellationRequested||L({provider:T,links:W})}));const f=await Promise.all(E);if(c.token.isCancellationRequested)return[];const h=new Map;for(const T of f)T&&T.links.length>0&&o.push(...T.links.map(L=>{const W={id:w++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return h.set(W.id,{provider:T.provider,link:L}),W}));return this._terminalLinkCache.set(t,h),o}$activateLink(t,i){var a;const r=(a=this._terminalLinkCache.get(t))===null||a===void 0?void 0:a.get(i);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const a=this._terminalProcessDisposables[t];a&&(a.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const a=this._getTerminalObjectIndexById(t,i);return a!==null?t[a]:null}_getTerminalObjectIndexById(t,i){let a=null;return t.some((r,c)=>r._id===i?(a=c,!0):!1),a}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new v,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const a=(0,C.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const a=i[0],r=new v(i[1]);this._setEnvironmentVariableCollection(a,r)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};b=je([xe(1,D.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class v{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const a=this.map.get(t);(!a||a.value!==i.value||a.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((a,r)=>t.call(i,r,a,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let u=class extends b{constructor(t){super(!1,t)}createTerminal(t,i,a){throw new R.NotSupportedError}createTerminalFromOptions(t){throw new R.NotSupportedError}getDefaultShell(t,i){throw new R.NotSupportedError}getDefaultShellArgs(t,i){throw new R.NotSupportedError}$getAvailableProfiles(t){throw new R.NotSupportedError}async $getDefaultShellAndArgs(t){throw new R.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new R.NotSupportedError}};u=je([xe(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(me[246],ge([0,1,3,14,5,122,20,7]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(R,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const C=this._extHostDocumentsAndEditors.allEditors();return R?C:C.map(g=>g.value)}async showTextDocument(R,C,g){let m;typeof C=="number"?m={position:D.ViewColumn.from(C),preserveFocus:g}:typeof C=="object"?m={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(R.uri,m),d=s&&this._extHostDocumentsAndEditors.getEditor(s);if(d)return d.value;throw s?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R){return new I.TextEditorDecorationType(this._proxy,R).value}$acceptEditorPropertiesChanged(R,C){const g=this._extHostDocumentsAndEditors.getEditor(R);if(!g)throw new Error("unknown text editor");if(C.options&&g._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(D.Selection.to);g._acceptSelections(m)}if(C.visibleRanges){const m=P.coalesce(C.visibleRanges.map(D.Range.to));g._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),s=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:s,kind:m})}if(C.visibleRanges){const m=P.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:m})}}$acceptEditorPositionData(R){for(const C in R){const g=this._extHostDocumentsAndEditors.getEditor(C);if(!g)throw new Error("Unknown text editor");const m=D.ViewColumn.to(R[C]);g.value.viewColumn!==m&&(g._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:m}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=y});var zt=this&&this.__rest||function(G,e){var _={};for(var P in G)Object.prototype.hasOwnProperty.call(G,P)&&e.indexOf(P)<0&&(_[P]=G[P]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,P=Object.getOwnPropertySymbols(G);A<P.length;A++)e.indexOf(P[A])<0&&Object.prototype.propertyIsEnumerable.call(G,P[A])&&(_[P[A]]=G[P[A]]);return _};define(me[247],ge([0,1,2,4,5,6,7]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class k{constructor(R,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(A.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:g=>{var m,s;if(g&&g.$mid===11){const d=g.uri===void 0?void 0:_.URI.revive(g.uri);return(s=(m=this._itemsBySourceAndUriMap.get(g.source))===null||m===void 0?void 0:m.get(y(d)))===null||s===void 0?void 0:s.get(g.handle)}return g}})}async $getTimeline(R,C,g,m,s){const d=this._providers.get(R);return d==null?void 0:d.provideTimeline(_.URI.revive(C),g,m,s)}registerTimelineProvider(R,C,g,m){const s=new I.DisposableStore,d=this.convertTimelineItem(C.id,m,s).bind(this);let S;C.onDidChange&&(S=C.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:R,onDidChange:void 0,async provideTimeline(b,v,u,l){var t;(l==null?void 0:l.resetCache)&&(s.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const i=await C.provideTimeline(b,v,u);if(i!=null){const a=d(b,l);return Object.assign(Object.assign({},i),{source:C.id,items:i.items.map(a)})}},dispose(){var b;for(const v of w.values())(b=v.get(C.id))===null||b===void 0||b.clear();S==null||S.dispose(),s.dispose()}}))}convertTimelineItem(R,C,g){return(m,s)=>{let d;if(s==null?void 0:s.cacheResults){let S=this._itemsBySourceAndUriMap.get(R);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(R,S));const w=y(m);d=S.get(w),d===void 0&&(d=new Map,S.set(w,d))}return S=>{var w,b;const{iconPath:v}=S,u=zt(S,["iconPath"]),l=`${R}|${(w=S.id)!==null&&w!==void 0?w:S.timestamp}`;d==null||d.set(l,S);let t,i,a;return S.iconPath&&(v instanceof D.ThemeIcon?a={id:v.id}:_.URI.isUri(v)?(t=v,i=v):{light:t,dark:i}=v),Object.assign(Object.assign({},u),{id:(b=u.id)!==null&&b!==void 0?b:void 0,handle:l,source:R,command:S.command?C.toInternal(S.command,g):void 0,icon:t,iconDark:i,themeIcon:a,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,I.toDisposable)(()=>{var g;for(const m of this._itemsBySourceAndUriMap.values())(g=m.get(R.id))===null||g===void 0||g.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=k;function y(n){return n==null?void 0:n.toString()}}),define(me[248],ge([0,1,6,11,2,5]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,R,C){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const g=C.schemes.find(m=>!D.supportedSchemes.has(m));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,R),this._proxy.$registerUriOpener(n,C.schemes,y,C.label),(0,_.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const g=A.URI.revive(n);return C.canOpenExternalUri(g,R)}async $openUri(y,n,R){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(A.URI.revive(n.resolvedUri),{sourceUri:A.URI.revive(n.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([P.Schemas.http,P.Schemas.https])}),define(me[249],ge([0,1,5,2,6,18,29]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(n,R){if(this.handles.has(D.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const C=k.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(n)),this.handlers.set(C,R),this._proxy.$registerUriHandler(C,n),(0,A.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(n)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(n,R){const C=this.handlers.get(n);if(!C)return Promise.resolve(void 0);try{C.handleUri(P.URI.revive(R))}catch(g){(0,I.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(n){return P.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[65],ge([0,1,22,3,2,176,199,62,5]),function(G,e,_,P,A,I,D,k,y){"use strict";var n,R,C,g,m,s,d,S,w,b,v,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(f,h,T,L,W,ee,j){n.set(this,void 0),R.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),s.set(this,void 0),d.set(this,""),S.set(this,void 0),w.set(this,!1),b.set(this,!1),v.set(this,!1),this._onMessageEmitter=new P.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new P.Emitter),this._onDidDispose=He(this,u,"f").event,tt(this,n,f,"f"),tt(this,R,h,"f"),tt(this,S,T,"f"),tt(this,g,L,"f"),tt(this,m,W,"f"),tt(this,s,ee,"f"),tt(this,v,t(ee),"f"),tt(this,C,j,"f")}dispose(){tt(this,w,!0,"f"),He(this,u,"f").fire(),He(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return tt(this,b,!0,"f"),(0,k.asWebviewUri)(He(this,g,"f"),He(this,n,"f"),f)}get cspSource(){return He(this,g,"f").webviewCspSource.replace("{{uuid}}",He(this,n,"f"))}get html(){return this.assertNotDisposed(),He(this,d,"f")}set html(f){this.assertNotDisposed(),He(this,d,"f")!==f&&(tt(this,d,f,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(tt(this,b,!0,"f"),He(this,C,"f").report("Webview vscode-resource: uris",He(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,R,"f").$setHtml(He(this,n,"f"),f))}get options(){return this.assertNotDisposed(),He(this,S,"f")}set options(f){this.assertNotDisposed(),He(this,R,"f").$setOptions(He(this,n,"f"),c(He(this,s,"f"),He(this,m,"f"),f)),tt(this,S,f,"f")}async postMessage(f){if(He(this,w,"f"))return!1;const h=i(f,{serializeBuffersForPostMessage:He(this,v,"f")});return He(this,R,"f").$postMessage(He(this,n,"f"),h.message,...h.buffers)}assertNotDisposed(){if(He(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,n=new WeakMap,R=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,u=new WeakMap;function t(E){if(!E.enableProposedApi)return!1;try{const f=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=56}catch(f){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(E,f){if(f.serializeBuffersForPostMessage){const h=[],T=(W,ee)=>{if(ee&&ee instanceof ArrayBuffer){let j=h.findIndex(x=>x.original===ee);if(j===-1){const x=new Uint8Array(ee),$=_.VSBuffer.wrap(x);j=h.length,h.push({original:ee,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return ee};return{message:JSON.stringify(E,T),buffers:h.map(W=>W.vsBuffer)}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeMessage=i;class a{constructor(f,h,T,L,W){this.initData=h,this.workspace=T,this._logService=L,this._deprecationService=W,this._webviews=new Map,this._webviewProxy=f.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(f,h,...T){const L=this.getWebview(f);if(L){const{message:W}=(0,D.deserializeWebviewMessage)(h,T);L._onMessageEmitter.fire(W)}}$onMissingCsp(f,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,h,T){const L=new l(f,this._webviewProxy,o(h),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(f,L),L._onDidDispose(()=>{this._webviews.delete(f)}),L}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=a;function r(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=r;function c(E,f,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||p(E,f)}}e.serializeWebviewOptions=c;function o(E){var f;return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:(f=E.localResourceRoots)===null||f===void 0?void 0:f.map(h=>A.URI.from(h))}}e.reviveOptions=o;function p(E,f){return[...((f==null?void 0:f.getWorkspaceFolders())||[]).map(h=>h.uri),E.extensionLocation]}}),define(me[250],ge([0,1,21,74,6,11,25,2,20,65,85,5,7]),function(G,e,_,P,A,I,D,k,y,n,R,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class s{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,a){const r=this.key(t,i.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const c=new m(i,a);return this._documents.set(r,c),c}delete(t,i){const a=this.key(t,i.uri);this._documents.delete(a)}key(t,i){return`${t}@@@${i}`}}var d;(function(l){l[l.Text=0]="Text",l[l.Custom=1]="Custom"})(d||(d={}));class S{constructor(){this._providers=new Map}addTextProvider(t,i,a){return this.add(0,t,i,a)}addCustomProvider(t,i,a){return this.add(1,t,i,a)}get(t){return this._providers.get(t)}add(t,i,a,r){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:a,provider:r}),new g.Disposable(()=>this._providers.delete(i))}}class w{constructor(t,i,a,r,c){this._extHostDocuments=i,this._extensionStoragePaths=a,this._extHostWebview=r,this._extHostWebviewPanels=c,this._editorProviders=new S,this._documents=new s,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,a,r){const c=new A.DisposableStore;return b(a)?(c.add(this._editorProviders.addTextProvider(i,t,a)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(i,t,a)),this.supportEditing(a)&&c.add(a.onDidChangeCustomDocument(o=>{const p=this.getCustomDocumentEntry(i,o.document.uri);if(v(o)){const E=p.addEdit(o);this._proxy.$onDidEdit(o.document.uri,i,E,o.label)}else this._proxy.$onContentChange(o.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(c,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,a,r,c){var o;const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${i}'`);const E=k.URI.revive(t),f=await p.provider.openCustomDocument(E,{backupId:a,untitledDocumentData:r==null?void 0:r.buffer},c);let h;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(h=(o=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&o!==void 0?o:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(i,f,h),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,i){const a=this._editorProviders.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${i}'`);const r=k.URI.revive(t),{document:c}=this.getCustomDocumentEntry(i,r);this._documents.delete(i,c),c.dispose()}async $resolveWebviewEditor(t,i,a,r,c,o){const p=this._editorProviders.get(a);if(!p)throw new Error(`No provider found for '${a}'`);const E=y.ViewColumn.to(c),f=this._extHostWebview.createNewWebview(i,r.webviewOptions,p.extension),h=this._extHostWebviewPanels.createNewWebviewPanel(i,a,r.title,E,r.panelOptions,f),T=k.URI.revive(t);switch(p.type){case 1:{const{document:L}=this.getCustomDocumentEntry(a,T);return p.provider.resolveCustomEditor(L,h,o)}case 0:{const L=this._extHostDocuments.getDocument(T);return p.provider.resolveCustomTextEditor(L,h,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,a){this.getCustomDocumentEntry(i,t).disposeEdits(a)}async $onMoveCustomEditor(t,i,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const o=k.URI.revive(i),p=this._extHostDocuments.getDocument(o);await r.provider.moveCustomTextEditor(p,c,_.CancellationToken.None)}async $undo(t,i,a,r){return this.getCustomDocumentEntry(i,t).undo(a,r)}async $redo(t,i,a,r){return this.getCustomDocumentEntry(i,t).redo(a,r)}async $revert(t,i,a){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(r.document,a),r.disposeBackup()}async $onSave(t,i,a){const r=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(r.document,a),r.disposeBackup()}async $onSaveAs(t,i,a,r){const c=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(c.document,k.URI.revive(a),r)}async $backup(t,i,a){const r=this.getCustomDocumentEntry(i,t),o=await this.getCustomEditorProvider(i).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},a);return r.updateBackup(o),o.id}getCustomDocumentEntry(t,i){const a=this._documents.get(t,k.URI.revive(i));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const i=this._editorProviders.get(t),a=i==null?void 0:i.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function b(l){return typeof l.resolveCustomTextEditor=="function"}function v(l){return typeof l.undo=="function"&&typeof l.redo=="function"}function u(l){const t=l.scheme===I.Schemas.file||l.scheme===I.Schemas.untitled?l.fsPath:l.toString();return(0,P.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[251],ge([0,1,3,6,2,28,20,65,5,7]),function(G,e,_,P,A,I,D,k,y,n){"use strict";var R,C,g,m,s,d,S,w,b,v,u,l,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends P.Disposable{constructor(o,p,E,f,h,T,L){super();R.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),s.set(this,void 0),d.set(this,void 0),S.set(this,void 0),w.set(this,void 0),b.set(this,!0),v.set(this,!0),u.set(this,!1),l.set(this,this._register(new _.Emitter)),this.onDidDispose=He(this,l,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,tt(this,R,o,"f"),tt(this,C,p,"f"),tt(this,g,E,"f"),tt(this,s,T,"f"),tt(this,w,h,"f"),tt(this,d,f,"f"),tt(this,m,L,"f")}dispose(){He(this,u,"f")||(tt(this,u,!0,"f"),He(this,l,"f").fire(),He(this,C,"f").$disposeWebview(He(this,R,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,g,"f")}get title(){return this.assertNotDisposed(),He(this,d,"f")}set title(o){this.assertNotDisposed(),He(this,d,"f")!==o&&(tt(this,d,o,"f"),He(this,C,"f").$setTitle(He(this,R,"f"),o))}get iconPath(){return this.assertNotDisposed(),He(this,S,"f")}set iconPath(o){this.assertNotDisposed(),He(this,S,"f")!==o&&(tt(this,S,o,"f"),He(this,C,"f").$setIconPath(He(this,R,"f"),A.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return He(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,w,"f")=="number"&&He(this,w,"f")<0))return He(this,w,"f")}get active(){return this.assertNotDisposed(),He(this,v,"f")}get visible(){return this.assertNotDisposed(),He(this,b,"f")}_updateViewState(o){He(this,u,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(tt(this,v,o.active,"f"),tt(this,b,o.visible,"f"),tt(this,w,o.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(o,p){this.assertNotDisposed(),He(this,C,"f").$reveal(He(this,R,"f"),{viewColumn:o?D.ViewColumn.from(o):void 0,preserveFocus:!!p})}assertNotDisposed(){if(He(this,u,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap,w=new WeakMap,b=new WeakMap,v=new WeakMap,u=new WeakMap,l=new WeakMap,t=new WeakMap;class a{constructor(o,p,E){this.webviews=p,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(o,p,E,f,h={}){const T=typeof f=="object"?f.viewColumn:f,L={viewColumn:D.ViewColumn.from(T),preserveFocus:typeof f=="object"&&!!f.preserveFocus},W=(0,k.shouldSerializeBuffersForPostMessage)(o),ee=a.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(o),ee,p,{title:E,panelOptions:r(h),webviewOptions:(0,k.serializeWebviewOptions)(o,this.workspace,h),serializeBuffersForPostMessage:W},L);const j=this.webviews.createNewWebview(ee,h,o);return this.createNewWebviewPanel(ee,p,E,T,h,j)}$onDidChangeWebviewPanelViewStates(o){const p=Object.keys(o);p.sort((E,f)=>{const h=o[E],T=o[f];return h.active?1:T.active?-1:+h.visible-+T.visible});for(const E of p){const f=this.getWebviewPanel(E);if(!!f){const h=o[E];f._updateViewState({active:h.active,visible:h.visible,viewColumn:D.ViewColumn.to(h.position)})}}}async $onDidDisposeWebviewPanel(o){const p=this.getWebviewPanel(o);p==null||p.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,p,E){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:E,extension:o}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(o)}),new n.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(o,p,E,f){const h=this._serializers.get(p);if(!h)throw new Error(`No serializer found for '${p}'`);const{serializer:T,extension:L}=h,W=this.webviews.createNewWebview(o,E.webviewOptions,L),ee=this.createNewWebviewPanel(o,p,E.title,f,E.panelOptions,W);await T.deserializeWebviewPanel(ee,E.state)}createNewWebviewPanel(o,p,E,f,h,T){const L=new i(o,this._proxy,p,E,f,h,T);return this._webviewPanels.set(o,L),L}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=a;function r(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[252],ge([0,1,3,6,65,5,7]),function(G,e,_,P,A,I,D){"use strict";var k,y,n,R,C,g,m,s,d,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends P.Disposable{constructor(u,l,t,i,a,r){super();k.set(this,void 0),y.set(this,void 0),n.set(this,void 0),R.set(this,void 0),C.set(this,!1),g.set(this,void 0),m.set(this,void 0),s.set(this,void 0),d.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=He(this,d,"f").event,S.set(this,this._register(new _.Emitter)),this.onDidDispose=He(this,S,"f").event,tt(this,n,t,"f"),tt(this,m,i,"f"),tt(this,k,u,"f"),tt(this,y,l,"f"),tt(this,R,a,"f"),tt(this,g,r,"f")}dispose(){He(this,C,"f")||(tt(this,C,!0,"f"),He(this,S,"f").fire(),He(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(u){this.assertNotDisposed(),He(this,m,"f")!==u&&(tt(this,m,u,"f"),He(this,y,"f").$setWebviewViewTitle(He(this,k,"f"),u))}get description(){return this.assertNotDisposed(),He(this,s,"f")}set description(u){this.assertNotDisposed(),He(this,s,"f")!==u&&(tt(this,s,u,"f"),He(this,y,"f").$setWebviewViewDescription(He(this,k,"f"),u))}get visible(){return He(this,g,"f")}get webview(){return He(this,R,"f")}get viewType(){return He(this,n,"f")}_setVisible(u){u===He(this,g,"f")||He(this,C,"f")||(tt(this,g,u,"f"),He(this,d,"f").fire())}show(u){this.assertNotDisposed(),He(this,y,"f").$show(He(this,k,"f"),!!u)}assertNotDisposed(){if(He(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,y=new WeakMap,n=new WeakMap,R=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,s=new WeakMap,d=new WeakMap,S=new WeakMap;class b{constructor(u,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,l,t,i){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(u),l,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(u,l,t,i,a){const r=this._viewProviders.get(l);if(!r)throw new Error(`No view provider found for '${l}'`);const{provider:c,extension:o}=r,p=this._extHostWebview.createNewWebview(u,{},o),E=new w(u,this._proxy,l,t,p,!0);this._webviewViews.set(u,E),await c.resolveWebviewView(E,{state:i},a)}async $onDidChangeWebviewViewVisibility(u,l){this.getWebviewView(u)._setVisible(l)}async $disposeWebviewView(u){const l=this.getWebviewView(u);this._webviewViews.delete(u),l.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const l=this._webviewViews.get(u);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=b}),define(me[125],ge([0,1,3,5,2,11,10,4,13]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Mn{constructor(C){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Mn.InitialState,this._proxy=C.getProxy(P.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,g){let m;if(typeof C=="string"){m=C;try{C=A.URI.parse(C)}catch(s){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,D.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,g)}async asExternalUri(C,g){if((0,D.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([I.Schemas.http,I.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,g);return A.URI.from(m)}};n.InitialState={focused:!0},n=je([xe(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(me[253],ge([0,1,8,48,28,51,6,5,2,13]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(g,m){super();const s=g.getProxy(k.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async d=>{const S=y.URI.file((0,_.join)((0,P.tmpdir)(),(0,A.generateUuid)()));return await s.$download(d,S),S})}};R=je([xe(0,n.IExtHostRpcService),xe(1,I.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(me[254],ge([0,1,2,8,145,26,37,64,27,13,6,12,110,45]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class s{constructor(b,v){this.file=v,this.appender=(0,g.createRotatingLogger)(b,v,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class d extends k.AbstractExtHostOutputChannel{constructor(b,v,u){super(b,!1,_.URI.file(v.file),u);this._appender=v}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,v){this._appender.flush(),super.show(b,v)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=d;let S=class extends k.ExtHostOutputService{constructor(b,v,u){super(b);this.logService=v,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new R.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(b){if(b){const v=this._channels.get(b);v&&(this._visibleChannelDisposable.value=v.onDidAppend(()=>v.update()))}}createOutputChannel(b){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const v=this._doCreateOutChannel(b);return v.then(u=>u._id.then(l=>this._channels.set(l,u))),new k.LazyOutputChannel(b,v)}async _doCreateOutChannel(b){try{const v=(0,P.join)(this._logsLocation.fsPath,`output_logging_${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await I.SymlinkSupport.existsDirectory(v)||await D.promises.mkdir(v,{recursive:!0});const l=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,P.join)(v,`${l}.log`)),i=new s(l,t.fsPath);return new d(b,i,this._proxy)}catch(v){return this.logService.error(v),new k.ExtHostPushOutputChannel(b,this._proxy)}}};S=je([xe(0,n.IExtHostRpcService),xe(1,C.ILogService),xe(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(me[255],ge([0,1,5,13,6,27,2,38,25,37,26,7,9,50,3,73,12]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(p,E,f){this.remoteAddress=p,this.localAddress=E,this._dispose=f,this._onDispose=new s.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function b(o){const p=o.trim().split(`
`),E=[];return p.forEach(h=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(h);T&&T.length>=3&&E.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),E.reduce((h,T)=>(h[T.socket]=T,h),{})}e.getSockets=b;function v(...o){const p=[].concat(...o.map(l));return[...new Map(p.filter(E=>E.st==="0A").map(E=>{const f=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:u(f[0]),port:parseInt(f[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=v;function u(o){let p="";if(o.length===8)for(let E=o.length-2;E>=0;E-=2)p+=parseInt(o.substr(E,2),16),E!==0&&(p+=".");else for(let E=o.length-4;E>=0;E-=4)p+=parseInt(o.substr(E,4),16).toString(16),E!==0&&(p+=":");return p}e.parseIpAddress=u;function l(o){const p=o.trim().split(`
`),E=p.shift().trim().split(/\s+/).filter(h=>h!=="rx_queue"&&h!=="tm->when");return p.map(h=>h.trim().split(/\s+/).reduce((T,L,W)=>(T[E[W]||W]=L,T),{}))}e.loadConnectionTable=l;function t(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function i(o){const p=o.trim().split(`
`),E=[];return p.forEach(f=>{const h=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);h&&h.length>=4&&E.push({pid:parseInt(h[1],10),ppid:parseInt(h[2]),cmd:h[3]})}),E}e.getRootProcesses=i;async function a(o,p,E){const f=E.reduce((T,L)=>(T[L.pid]=L,T),{}),h=[];return o.forEach(({socket:T,ip:L,port:W})=>{var ee;const j=p[T]?p[T].pid:void 0,x=j?(ee=f[j])===null||ee===void 0?void 0:ee.cmd:void 0;j&&x&&!t(x)&&h.push({host:L,port:W,detail:x,pid:j})}),h}e.findPorts=a;function r(o,p,E){const f=new Map,h=i(p);for(const T of o){const L=E.get(T.port);if(L){f.set(T.port,L);continue}const W=h.find(ee=>ee.cmd.includes(`${T.port}`));if(W){let ee=W,j;do j=h.find(x=>x.ppid===ee.pid),j&&(ee=j);while(j);f.set(T.port,{host:T.ip,port:T.port,pid:ee.pid,detail:ee.cmd,ppid:ee.ppid})}else f.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=r;let c=class extends A.Disposable{constructor(p,E,f){super();this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new s.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadTunnelService),g.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${E.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(E,p.displayName);if(f){const h=new w(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(h),h}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,E){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:p,provider:E}),this._proxy.$registerPortsAttributesProvider(p,f),new C.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(p,E,f,h,T){const L=[];for(const ee of p){const j=this._portAttributesProviders.get(ee);if(!j)return[];L.push(...await Promise.all(E.map(async x=>j.provider.providePortAttributes(x,f,h,T))))}const W=L.filter(ee=>!!ee);return W.length>0?W.map(ee=>({autoForwardAction:ee.autoForwardAction,port:ee.port})):[]}async $registerCandidateFinder(p){if(!(p&&this._candidateFindingEnabled)){this._candidateFindingEnabled=p;let E=new d.MovingAverage,f;for(;this._candidateFindingEnabled;){const h=new Date().getTime(),T=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(W=>W.port).join(", ")}`);const L=new Date().getTime()-h;E.update(L),(!f||JSON.stringify(f)!==JSON.stringify(T))&&(f=T,await this._proxy.$onFoundNewCandidates(f)),await new Promise(W=>setTimeout(()=>W(),this.calculateDelay(E.value)))}}}async setTunnelExtensionFunctions(p){var E;return p?(p.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,await this._proxy.$setCandidateFilter()),p.tunnelFactory&&(this._forwardPortProvider=p.tunnelFactory,await this._proxy.$setTunnelProvider((E=p.tunnelFeatures)!==null&&E!==void 0?E:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,E){if(this._extensionTunnels.has(p.host)){const f=this._extensionTunnels.get(p.host);f.has(p.port)&&(E&&f.get(p.port).disposeListener.dispose(),await f.get(p.port).tunnel.dispose(),f.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(p,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const h=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const T=this._register(h.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(h.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:h,disposeListener:T}),m.TunnelDto.fromApiTunnel(h)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const E=await Promise.all(p.map(h=>{var T;return this._showCandidatePort(h.host,h.port,(T=h.detail)!==null&&T!==void 0?T:"")})),f=p.filter((h,T)=>E[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(h=>h.port).join(", ")} to ${f.map(h=>h.port).join(", ")}`),f}async findCandidatePorts(){let p="",E="";try{p=await n.promises.readFile("/proc/net/tcp","utf8"),E=await n.promises.readFile("/proc/net/tcp6","utf8")}catch(F){}const f=v(p,E),h=await new Promise(F=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,M,N)=>{F(M)})}),T=b(h),L=await R.readdir("/proc"),W=[];for(let F of L)try{const U=Number(F),M=y.joinPath(D.URI.file("/proc"),F);if((await n.promises.stat(M.fsPath)).isDirectory()&&!isNaN(U)){const O=await n.promises.readlink(y.joinPath(M,"cwd").fsPath),V=await n.promises.readFile(y.joinPath(M,"cmdline").fsPath,"utf8");W.push({pid:U,cwd:O,cmd:V})}}catch(U){}const ee=[],j=f.filter(F=>{const U=T[F.socket];return U||ee.push(F),U}),x=a(j,T,W);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ee.length}`),ee.length>0){const F=await new Promise(U=>{(0,k.exec)("ps -F -A -l | grep root",(M,N,O)=>{U(N)})});this._foundRootPorts=r(ee,F,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return x.then(F=>$?F.concat($):F)}};c=je([xe(0,P.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,S.ILogService)],c),e.ExtHostTunnelService=c}),define(me[256],ge([0,1,19,21,18,3,6,98,226,123,22]),function(G,e,_,P,A,I,D,k,y,n,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function g(r,c){try{return JSON.stringify(r,c)}catch(o){return"null"}}function m(r,c){return JSON.stringify(r,c)}function s(r){return r?(c,o)=>o&&o.$mid===1?r.transformOutgoing(o):o:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},b=Symbol.for("rpcProtocol"),v=Symbol.for("rpcProxy");class u extends D.Disposable{constructor(c,o=null,p=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=o,this._uriTransformer=p,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,f=n.ProxyIdentifier.count;E<f;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,k.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:o,sid:p}=c;return this._proxies[o]||(this._proxies[o]=this._createProxy(o,p)),this._proxies[o]}_createProxy(c,o){let p={get:(E,f)=>(typeof f=="string"&&!E[f]&&f.charCodeAt(0)===36&&(E[f]=(...h)=>this._remoteCall(c,f,h)),f===v?o:E[f])};return new Proxy(Object.create(null),p)}set(c,o){return this._locals[c.nid]=o,o}assertRegistered(c){for(let o=0,p=c.length;o<p;o++){const E=c[o];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(c){if(!this._isDisposed){const o=c.byteLength,p=l.read(c,0),E=p.readUInt8(),f=p.readUInt32();switch(E){case 1:case 2:{let{rpcId:h,method:T,args:L}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(L=(0,k.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(o,f,h,T,L,E===2);break}case 3:case 4:{let{rpcId:h,method:T,args:L}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(L=(0,k.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(o,f,h,T,L,E===4);break}case 5:{this._logger&&this._logger.logIncoming(o,f,0,"ack"),this._onDidReceiveAcknowledge(f);break}case 6:{this._receiveCancel(o,f);break}case 7:{this._receiveReply(o,f,void 0);break}case 9:{let h=t.deserializeReplyOKJSON(p);this._uriTransformer&&(h=(0,k.transformIncomingURIs)(h,this._uriTransformer)),this._receiveReply(o,f,h);break}case 8:{let h=t.deserializeReplyOKVSBuffer(p);this._receiveReply(o,f,h);break}case 10:{let h=t.deserializeReplyErrError(p);this._uriTransformer&&(h=(0,k.transformIncomingURIs)(h,this._uriTransformer)),this._receiveReplyErr(o,f,h);break}case 11:{this._receiveReplyErr(o,f,void 0);break}default:console.error("received unexpected message"),console.error(c)}}}_receiveRequest(c,o,p,E,f,h){this._logger&&this._logger.logIncoming(c,o,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(p)}.${E}(`,f);const T=String(o);let L,W;if(h){const j=new P.CancellationTokenSource;f.push(j.token),L=this._invokeHandler(p,E,f),W=()=>j.cancel()}else L=this._invokeHandler(p,E,f),W=w;this._cancelInvokedHandlers[T]=W;const ee=t.serializeAcknowledged(o);this._logger&&this._logger.logOutgoing(ee.byteLength,o,1,"ack"),this._protocol.send(ee),L.then(j=>{delete this._cancelInvokedHandlers[T];const x=t.serializeReplyOK(o,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,o,1,"reply:",j),this._protocol.send(x)},j=>{delete this._cancelInvokedHandlers[T];const x=t.serializeReplyErr(o,j);this._logger&&this._logger.logOutgoing(x.byteLength,o,1,"replyErr:",j),this._protocol.send(x)})}_receiveCancel(c,o){this._logger&&this._logger.logIncoming(c,o,1,"receiveCancel");const p=String(o);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(c,o,p){this._logger&&this._logger.logIncoming(c,o,0,"receiveReply:",p);const E=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const f=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],f.resolveOk(p)}}_receiveReplyErr(c,o,p){this._logger&&this._logger.logIncoming(c,o,0,"receiveReplyErr:",p);const E=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const f=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let h;p&&(p.$isError?(h=new Error,h.name=p.name,h.message=p.message,h.stack=p.stack):h=p),f.resolveErr(h)}}_invokeHandler(c,o,p){try{return Promise.resolve(this._doInvokeHandler(c,o,p))}catch(E){return Promise.reject(E)}}_doInvokeHandler(c,o,p){const E=this._locals[c];if(!E)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(c));let f=E[o];if(typeof f!="function")throw new Error("Unknown method "+o+" on actor "+(0,n.getStringIdentifierForProxy)(c));return f.apply(E,p)}_remoteCall(c,o,p){if(this._isDisposed)return Promise.reject(A.canceled());let E=null;if(p.length>0&&P.CancellationToken.isCancellationToken(p[p.length-1])&&(E=p.pop()),E&&E.isCancellationRequested)return Promise.reject(A.canceled());const f=t.serializeRequestArguments(p,this._uriReplacer),h=++this._lastMessageId,T=String(h),L=new y.LazyPromise;E&&E.onCancellationRequested(()=>{const ee=t.serializeCancel(h);this._logger&&this._logger.logOutgoing(ee.byteLength,h,0,"cancel"),this._protocol.send(t.serializeCancel(h))}),this._pendingRPCReplies[T]=L,this._onWillSendRequest(h);const W=t.serializeRequest(h,c,o,f,!!E);return this._logger&&this._logger.logOutgoing(W.byteLength,h,0,`request: ${(0,n.getStringIdentifierForProxy)(c)}.${o}(`,p),this._protocol.send(W),L}}e.RPCProtocol=u,C=b,u.UNRESPONSIVE_TIME=3*1e3;class l{constructor(c,o){this._buff=c,this._offset=o}static alloc(c,o,p){let E=new l(R.VSBuffer.alloc(p+1+4),0);return E.writeUInt8(c),E.writeUInt32(o),E}static read(c,o){return new l(c,o)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const o=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,o}static sizeMixedArray(c,o){let p=0;p+=1;for(let E=0,f=c.length;E<f;E++){const h=c[E],T=o[E];switch(p+=1,T){case 1:p+=this.sizeLongString(h);break;case 2:p+=this.sizeVSBuffer(h);break;case 3:break}}return p}writeMixedArray(c,o){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let p=0,E=c.length;p<E;p++){const f=c[p];switch(o[p]){case 1:this.writeUInt8(1),this.writeLongString(f);break;case 2:this.writeUInt8(2),this.writeVSBuffer(f);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let o=new Array(c);for(let p=0;p<c;p++)switch(this.readUInt8()){case 1:o[p]=this.readLongString();break;case 2:o[p]=this.readVSBuffer();break;case 3:o[p]=void 0;break}return o}}class t{static _arrayContainsBufferOrUndefined(c){for(let o=0,p=c.length;o<p;o++)if(c[o]instanceof R.VSBuffer||typeof c[o]=="undefined")return!0;return!1}static serializeRequestArguments(c,o){if(this._arrayContainsBufferOrUndefined(c)){let p=[],E=[];for(let f=0,h=c.length;f<h;f++){const T=c[f];T instanceof R.VSBuffer?(p[f]=T,E[f]=2):typeof T=="undefined"?(p[f]=R.VSBuffer.alloc(0),E[f]=3):(p[f]=R.VSBuffer.fromString(m(T,o)),E[f]=1)}return{type:"mixed",args:p,argsType:E}}return{type:"simple",args:m(c,o)}}static serializeRequest(c,o,p,E,f){return E.type==="mixed"?this._requestMixedArgs(c,o,p,E.args,E.argsType,f):this._requestJSONArgs(c,o,p,E.args,f)}static _requestJSONArgs(c,o,p,E,f){const h=R.VSBuffer.fromString(p),T=R.VSBuffer.fromString(E);let L=0;L+=l.sizeUInt8(),L+=l.sizeShortString(h),L+=l.sizeLongString(T);let W=l.alloc(f?2:1,c,L);return W.writeUInt8(o),W.writeShortString(h),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(c){const o=c.readUInt8(),p=c.readShortString(),E=c.readLongString();return{rpcId:o,method:p,args:JSON.parse(E)}}static _requestMixedArgs(c,o,p,E,f,h){const T=R.VSBuffer.fromString(p);let L=0;L+=l.sizeUInt8(),L+=l.sizeShortString(T),L+=l.sizeMixedArray(E,f);let W=l.alloc(h?4:3,c,L);return W.writeUInt8(o),W.writeShortString(T),W.writeMixedArray(E,f),W.buffer}static deserializeRequestMixedArgs(c){const o=c.readUInt8(),p=c.readShortString(),E=c.readMixedArray(),f=new Array(E.length);for(let h=0,T=E.length;h<T;h++){const L=E[h];typeof L=="string"?f[h]=JSON.parse(L):f[h]=L}return{rpcId:o,method:p,args:f}}static serializeAcknowledged(c){return l.alloc(5,c,0).buffer}static serializeCancel(c){return l.alloc(6,c,0).buffer}static serializeReplyOK(c,o,p){return typeof o=="undefined"?this._serializeReplyOKEmpty(c):o instanceof R.VSBuffer?this._serializeReplyOKVSBuffer(c,o):this._serializeReplyOKJSON(c,g(o,p))}static _serializeReplyOKEmpty(c){return l.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,o){let p=0;p+=l.sizeVSBuffer(o);let E=l.alloc(8,c,p);return E.writeVSBuffer(o),E.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,o){const p=R.VSBuffer.fromString(o);let E=0;E+=l.sizeLongString(p);let f=l.alloc(9,c,E);return f.writeLongString(p),f.buffer}static deserializeReplyOKJSON(c){const o=c.readLongString();return JSON.parse(o)}static serializeReplyErr(c,o){return o?this._serializeReplyErrEror(c,o):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,o){const p=R.VSBuffer.fromString(g(A.transformErrorForSerialization(o),null));let E=0;E+=l.sizeLongString(p);let f=l.alloc(10,c,E);return f.writeLongString(p),f.buffer}static deserializeReplyErrError(c){const o=c.readLongString();return JSON.parse(o)}static _serializeReplyErrEmpty(c){return l.alloc(11,c,0).buffer}}var i;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var a;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(a||(a={}))}),define(me[257],ge([0,1,4]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(me[258],ge([0,1,11,8,9,2,4,257]),function(G,e,_,P,A,I,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(R,C){this.localUserHome=R,this.remoteAgentService=C,this.resolveOS=(async()=>{const g=await this.remoteAgentService.getEnvironment();return(g==null?void 0:g.os)||A.OS})(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(g==null?void 0:g.userHome)||R})()}async userHome(R){return(R==null?void 0:R.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(R=>R===1?P.win32:P.posix)}async fileURI(R){let C="";if(await this.resolveOS===1&&(R=R.replace(/\\/g,"/")),R[0]==="/"&&R[1]==="/"){const m=R.indexOf("/",2);m===-1?(C=R.substring(2),R="/"):(C=R.substring(2,m),R=R.substring(m)||"/")}return I.URI.from({scheme:_.Schemas.file,authority:C,path:R,query:"",fragment:""})}};y=je([xe(1,k.IRemoteAgentService)],y),e.AbstractPathService=y}),define(me[31],ge([0,1,14,33,23,30,10,4,8,18]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const R="\u27EA ",C=" characters skipped \u27EB",g=(R.length+C.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var m;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function d(F){return!!F.preview}e.resultIsMatch=d;function S(F){return!!F.resource}e.isFileMatch=S;function w(F){return!!F.message}e.isProgressMessage=w;var b;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=v;class u{constructor(U,M,N){this.ranges=M;const O=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&l(O)){U=(0,D.getNLines)(U,N.matchLines);let V="",q=0,X=0;const fe=Math.floor(N.charsPerLine/5),ve=[];for(const Ae of O){const Pe=Math.max(Ae.startColumn-fe,0),Fe=Ae.startColumn+N.charsPerLine;if(Pe>X+fe+g){const z=R+(Pe-X)+C;V+=z+U.slice(Pe,Fe),q+=Pe-(X+z.length)}else V+=U.slice(X,Fe);ve.push(new i(0,Ae.startColumn-q,Ae.endColumn-q)),X=Fe}this.preview={text:V,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const V=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,_.mapArrayOrNot)(M,q=>new t(q.startLineNumber-V,q.startColumn,q.endLineNumber-V,q.endColumn))}}}}e.TextSearchMatch=u;function l(F){const U=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class t{constructor(U,M,N,O){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=N,this.endColumn=O}}e.SearchRange=t;class i extends t{constructor(U,M,N){super(U,M,U,N)}}e.OneLineRange=i;var a;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function r(F,U=!0){const M=F&&F.files&&F.files.exclude,N=U&&F&&F.search&&F.search.exclude;if(!(!M&&!N)){if(!M||!N)return M||N;let O=Object.create(null);return O=A.mixin(O,A.deepClone(M)),O=A.mixin(O,A.deepClone(N),!0),O}}e.getExcludes=r;function c(F,U){return F.excludePattern&&P.match(F.excludePattern,U)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&P.match(F.includePattern,U)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(I.isEqualOrParent(U,N)){const O=y.relative(N,U);return!M.includePattern||!!P.match(M.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var o;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(o=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=p;function E(F){const U=F.message;if((0,n.isPromiseCanceledError)(F))return new p(U,o.canceled);try{const M=JSON.parse(U);return new p(M.message,M.code)}catch(M){return new p(U,o.other)}}e.deserializeSearchError=E;function f(F){const U={message:F.message,code:F.code};return new Error(JSON.stringify(U))}e.serializeSearchError=f;function h(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=h;function T(F){return F.type==="success"}e.isSerializedSearchSuccess=T;function L(F){return!!F.path}e.isSerializedFileMatch=L;function W(F,U){const M=F.searchPath?F.searchPath:F.relativePath;return(0,D.fuzzyContains)(M,U)}e.isFilePatternMatch=W;class ee{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function j(F,U){const M=Object.assign(Object.assign({},F||{}),U||{});return Object.keys(M).filter(N=>{const O=M[N];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=j;class x{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=P.parse(this._excludeExpression);let N=U.includePattern;M.includePattern&&(N?N=Object.assign(Object.assign({},N),M.includePattern):N=M.includePattern),N&&(this._parsedIncludeExpression=P.parse(N))}includedInQuerySync(U,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,N))}includedInQuery(U,M,N){return Promise.resolve(this._parsedExcludeExpression(U,M,N)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,N)).then(q=>!!q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=x;function $(F){for(const U in F)if(typeof F[U]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,14,19,21,3,24,11,73,25,10,15,2,166,4,12,185,59,60,27,13,7,31,5]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v,u,l,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(T,L,W){return new n.ExtUri(ee=>p(ee,W)).isEqual(T,L)}function r(T,L,W){return a(T.uri,L.uri,W)?0:(0,R.compare)(T.uri.toString(),L.uri.toString())}function c(T,L,W){return T.index!==L.index?T.index<L.index?-1:1:a(T.uri,L.uri,W)?(0,R.compare)(T.name,L.name):(0,R.compare)(T.uri.toString(),L.uri.toString())}function o(T,L,W,ee){const j=T.slice(0).sort(($,F)=>W($,F,ee)),x=L.slice(0).sort(($,F)=>W($,F,ee));return(0,_.delta)(j,x,($,F)=>W($,F,ee))}function p(T,L){const W=L.getCapabilities(T.scheme);return!(W&&W&1024)}class E extends w.Workspace{constructor(L,W,ee,j,x,$){super(L,ee.map(F=>new w.WorkspaceFolder(F)),j,$);this._name=W,this._isUntitled=x,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris($),ee.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(L,W,ee,j){if(!L)return{workspace:null,added:[],removed:[]};const{id:x,name:$,folders:F,configuration:U,isUntitled:M}=L,N=[],O=W;W?F.forEach((fe,ve)=>{const Ae=g.URI.revive(fe.uri),Pe=E._findFolder(ee||W,Ae,j);Pe?(Pe.name=fe.name,Pe.index=fe.index,N.push(Pe)):N.push({uri:Ae,name:fe.name,index:ve})}):N.push(...F.map(({uri:fe,name:ve,index:Ae})=>({uri:g.URI.revive(fe),name:ve,index:Ae}))),N.sort((fe,ve)=>fe.index<ve.index?-1:1);const V=new E(x,$,N,U?g.URI.revive(U):null,!!M,fe=>p(fe,j)),{added:q,removed:X}=o(O?O.workspaceFolders:[],V.workspaceFolders,r,j);return{workspace:V,added:q,removed:X}}static _findFolder(L,W,ee){for(let j=0;j<L.folders.length;j++){const x=L.workspaceFolders[j];if(a(x.uri,W,ee))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,W){return W&&this._structure.get(L)&&(L=(0,n.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let f=class{constructor(L,W,ee,j){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new I.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=ee,this._requestIdProvider=new y.Counter,this._barrier=new P.Barrier,this._proxy=L.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(i.MainContext.MainThreadMessageService);const x=W.workspace;this._confirmedWorkspace=x?new E(x.id,x.name,[],x.configuration?g.URI.revive(x.configuration):null,!!x.isUntitled,$=>p($,ee)):void 0}$initializeWorkspace(L,W){this._trusted=W,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:k.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,W,ee,...j){const x=[];if(Array.isArray(j)&&j.forEach(N=>{g.URI.isUri(N.uri)&&!x.some(O=>a(O.uri,N.uri,this._extHostFileSystemInfo))&&x.push({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[W,ee].some(N=>typeof N!="number"||N<0)||ee===0&&x.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+ee>$.length)return!1;const F=$.slice(0);F.splice(W,ee,...x.map(N=>({uri:N.uri,name:N.name||(0,n.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<F.length;N++){const O=F[N];if(F.some((V,q)=>q!==N&&a(O.uri,V.uri,this._extHostFileSystemInfo)))return!1}F.forEach((N,O)=>N.index=O);const{added:U,removed:M}=o($,F,c,this._extHostFileSystemInfo);if(U.length===0&&M.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,W,ee,x).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,m.localize)(0,null,N,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(F),!0}getWorkspaceFolder(L,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,W)}async getWorkspaceFolder2(L,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,W)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,W){let ee,j="";if(typeof L=="string"?(ee=g.URI.file(L),j=L):typeof L!="undefined"&&(ee=L,j=L.fsPath),!ee)return j;const x=this.getWorkspaceFolder(ee,!0);if(!x)return j;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let $=(0,n.relativePath)(x.uri,ee);return W&&x.name&&($=`${x.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:W,added:ee,removed:j}=E.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:j}))}findFiles(L,W,ee,j,x=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let $;if(W===null?$=!1:W&&(typeof W=="string"?$=W:$=W.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:F,folder:U}=h(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(F),(0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(ee),x).then(M=>Array.isArray(M)?M.map(N=>g.URI.revive(N)):[])}async findTextInFiles(L,W,ee,j,x=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),F=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:U,folder:M}=h(W.include),N=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,O={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:F,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:U,excludePattern:N},V=!1;if(this._activeSearchCallbacks[$]=q=>{if(!V){const X=g.URI.revive(q.resource);q.results.forEach(fe=>{(0,t.resultIsMatch)(fe)?ee({uri:X,preview:{text:fe.preview.text,matches:(0,_.mapArrayOrNot)(fe.preview.matches,ve=>new l.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,_.mapArrayOrNot)(fe.ranges,ve=>new l.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ee({uri:X,text:fe.text,lineNumber:fe.lineNumber})})}},x.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(M),O,$,x);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};f=je([xe(0,u.IExtHostRpcService),xe(1,v.IExtHostInitDataService),xe(2,b.IExtHostFileSystemInfo),xe(3,d.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function h(T){let L,W;return T&&(typeof T=="string"?L=T:(L=T.pattern,W=T.baseFolder||g.URI.file(T.base))),{includePattern:L,folder:W}}}),define(me[35],ge([0,1,23,3,32,5,7,187,83,15,19,4,13,12,2]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,a){if(a){const r=a.split(".");let c=i;for(let o=0;c&&o<r.length;o++)c=c[r[o]];return c}}function S(i){return i instanceof s.URI}function w(i){return i&&i.uri instanceof s.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function v(i){return i&&i.uri instanceof s.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function u(i){if(S(i))return{resource:i};if(w(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(v(i))return{resource:i.uri};if(i===null)return{resource:null}}let l=class{constructor(a,r,c){this._proxy=a.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=c,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,r){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,r))}};l=je([xe(0,g.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,m.ILogService)],l),e.ExtHostConfiguration=l;class t{constructor(a,r,c,o){this._onDidChangeConfiguration=new P.Emitter,this._proxy=a,this._logService=o,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,r){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,c))}getConfiguration(a,r,c){const o=u(r)||{},p=this._toReadonlyValue(a?d(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,o,c==null?void 0:c.identifier);function E(h){if(h==null)return null;if(typeof h=="boolean")return h?1:4;switch(h){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(h){return typeof d(p,h)!="undefined"},get:(h,T)=>{this._validateConfigurationAccess(a?`${a}.${h}`:h,o,c==null?void 0:c.identifier);let L=d(p,h);if(typeof L=="undefined")L=T;else{let W;const ee=(j,x)=>{let $;const F=()=>{W=W||(0,_.deepClone)(p),$=$||d(W,x)};return(0,n.isObject)(j)?new Proxy(j,{get:(U,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return F(),()=>$;if(W)return $=$||d(W,x),$[M];const N=U[M];return typeof M=="string"?ee(N,`${x}.${M}`):N},set:(U,M,N)=>(F(),$&&($[M]=N),!0),deleteProperty:(U,M)=>(F(),$&&delete $[M],!0),defineProperty:(U,M,N)=>(F(),$&&Object.defineProperty($,M,N),!0)}):j};L=ee(L,h)}return L},update:(h,T,L,W)=>{h=a?`${a}.${h}`:h;const ee=E(L);return T!==void 0?this._proxy.$updateConfigurationOption(ee,h,T,o,W):this._proxy.$removeConfigurationOption(ee,h,o,W)},inspect:h=>{var T,L,W,ee,j,x,$,F;h=a?`${a}.${h}`:h;const U=(0,_.deepClone)(this._configuration.inspect(h,o,this._extHostWorkspace.workspace));if(U)return{key:h,defaultValue:(T=U.default)===null||T===void 0?void 0:T.value,globalValue:(L=U.user)===null||L===void 0?void 0:L.value,workspaceValue:(W=U.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(ee=U.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(j=U.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(x=U.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:($=U.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(F=U.workspaceFolder)===null||F===void 0?void 0:F.override,languageIds:U.overrideIdentifiers}}};return typeof p=="object"&&(0,_.mixin)(f,p,!1),Object.freeze(f)}_toReadonlyValue(a){const r=c=>(0,n.isObject)(c)?new Proxy(c,{get:(o,p)=>r(o[p]),set:(o,p,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(o,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(o,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return r(a)}_validateConfigurationAccess(a,r,c){const o=y.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),p=c?`[${c.value}] `:"";if(o===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,r){const c=new k.ConfigurationChangeEvent(a,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,p)=>c.affectsConfiguration(o,u(p))})}_toMap(a){return a.reduce((r,c)=>(r.set(c[0],c[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[66],ge([0,1,2,19,3,5,7,32,39,35,21,34,13,27,4,11,9,12,63,208,18]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v,u){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(j){function x(U){if(U){const M=U;return M&&!!M.process}else return!1}j.is=x;function $(U){if(U!=null){const M={process:U.process,args:U.args};return U.options&&(M.options=a.from(U.options)),M}}j.from=$;function F(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}j.to=F})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(j){function x(F){if(F!=null)return F}j.from=x;function $(F){if(F!=null)return F}j.to=$})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(j){function x(U){if(U){const M=U;return M&&(!!M.commandLine||!!M.command)}else return!1}j.is=x;function $(U){if(U!=null){const M={};return U.commandLine!==void 0?M.commandLine=U.commandLine:(M.command=U.command,M.args=U.args),U.options&&(M.options=c.from(U.options)),M}}j.from=$;function F(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}j.to=F})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(j){function x(U){if(U){let M=U;return M&&M.customExecution==="customExecution"}else return!1}j.is=x;function $(U){return{customExecution:"customExecution"}}j.from=$;function F(U,M){return M.get(U)}j.to=F})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(j){function x($,F){let U;return $.scope!==void 0&&typeof $.scope!="number"?U=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===D.TaskScope.Workspace&&F&&F.workspaceFile?U=F.workspaceFile:U=v.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:U}}j.from=x})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(j){function x(U,M){if(U==null)return[];const N=[];for(let O of U){const V=$(O,M);V&&N.push(V)}return N}j.fromMany=x;function $(U,M){if(U!=null){let N;U.execution instanceof D.ProcessExecution?N=r.from(U.execution):U.execution instanceof D.ShellExecution?N=o.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(N=p.from(U.execution));const O=t.from(U.definition);let V;if(U.scope?typeof U.scope=="number"?V=U.scope:V=U.scope.uri:V=D.TaskScope.Workspace,!(!O||!V)){const q=U.group?U.group.id:void 0;return{_id:U._id,definition:O,name:U.name,source:{extensionId:M.identifier.value,label:U.source,scope:V},execution:N,isBackground:U.isBackground,group:q,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}j.from=$;async function F(U,M,N){if(U!=null){let O;r.is(U.execution)?O=r.to(U.execution):o.is(U.execution)?O=o.to(U.execution):p.is(U.execution)&&(O=p.to(U._id,N));const V=t.to(U.definition);let q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?q=U.source.scope:q=await M.resolveWorkspaceFolder(_.URI.revive(U.source.scope)):q=D.TaskScope.Workspace),!(!V||!q)){const X=new D.Task(V,q,U.name,U.source.label,O,U.problemMatchers);return U.isBackground!==void 0&&(X.isBackground=U.isBackground),U.group!==void 0&&(X.group=D.TaskGroup.from(U.group)),U.presentationOptions&&(X.presentationOptions=i.to(U.presentationOptions)),U._id&&(X._id=U._id),U.detail&&(X.detail=U.detail),X}}}j.to=F})(f=e.TaskDTO||(e.TaskDTO={}));var h;(function(j){function x(F){return F}j.from=x;function $(F){if(!!F)return Object.assign(Object.create(null),F)}j.to=$})(h=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(x,$,F){this._id=$,this._task=F,l.set(this,void 0),tt(this,l,x,"f")}get task(){return this._task}terminate(){He(this,l,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}l=new WeakMap;var L;(function(j){function x($){return{id:$._id,task:void 0}}j.from=x})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(x,$,F,U,M,N,O,V){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=x.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=F,this._editorService=U,this._configurationService=M,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=V,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,$,F){if(!F)return new D.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:$,provider:F,extension:x}),this._proxy.$registerTaskProvider(U,$),new D.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(x,$){this._proxy.$registerTaskSystem(x,$)}fetchTasks(x){return this._proxy.$fetchTasks(h.from(x)).then(async $=>{const F=[];for(let U of $){const M=await f.to(U,this._workspaceProvider,this._providedCustomExecutions2);M&&F.push(M)}return F})}get taskExecutions(){const x=[];return this._taskExecutions.forEach($=>x.push($)),x}terminateTask(x){if(!(x instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,$,F){const U=this._providedCustomExecutions2.get(x.id);if(U){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,U),this._terminalService.attachPtyToTerminal($,await U.callback(F))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const $=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:$,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const $=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:x.exitCode})}$provideTasks(x,$){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));const U=[],M=(0,P.asPromise)(()=>F.provider.provideTasks(R.CancellationToken.None)).then(N=>this.provideTasksInternal($,U,F,N));return new Promise(N=>{M.then(O=>{Promise.all(U).then(()=>{N(O)})})})}async $resolveTask(x,$){const F=this._handlers.get(x);if(!F)return Promise.reject(new Error("no handler found"));if($.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${F.type}].`);const U=await f.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const M=await F.provider.resolveTask(U,R.CancellationToken.None);if(!!M){this.checkDeprecation(M,F);const N=f.from(M,F.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(N.execution)&&await this.addCustomExecution(N,M,!0),await this.resolveTaskInternal(N)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,$,F){const U=await this._proxy.$createTaskId(x);!F&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,$.execution)}async getTaskExecution(x,$){if(typeof x=="string"){const M=this._taskExecutionPromises.get(x);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let F=this._taskExecutionPromises.get(x.id);if(F)return F;const U=new Promise(async(M,N)=>{const O=$||await f.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new T(this,x.id,O)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,U),U.then(M=>(this._taskExecutions.set(x.id,M),M),M=>Promise.reject(M))}checkDeprecation(x,$){x._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let F=this._notProvidedCustomExecutions.values(),U=F.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=F.next()}};W=je([xe(0,g.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,n.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,b.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let ee=class extends W{constructor(x,$,F,U,M,N,O,V){super(x,$,F,U,M,N,O,V);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(x,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const F=f.from($,x);if(F===void 0)throw new Error("Task is not valid");if(p.is(F.execution))await this.addCustomExecution(F,$,!1);else throw new u.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(F),$);return this._proxy.$executeTask(F).catch(M=>{throw new Error(M)}),U}provideTasksInternal(x,$,F,U){const M=[];if(U)for(let N of U){this.checkDeprecation(N,F),(!N.definition||!x[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const O=f.from(N,F.extension);O&&p.is(O.execution)?(M.push(O),$.push(this.addCustomExecution(O,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:F.extension}}async resolveTaskInternal(x){if(p.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,$,F){}};ee=je([xe(0,g.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,n.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,b.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")});var zt=this&&this.__rest||function(G,e){var _={};for(var P in G)Object.prototype.hasOwnProperty.call(G,P)&&e.indexOf(P)<0&&(_[P]=G[P]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,P=Object.getOwnPropertySymbols(G);A<P.length;A++)e.indexOf(P[A])<0&&Object.prototype.propertyIsEnumerable.call(G,P[A])&&(_[P[A]]=G[P[A]]);return _};define(me[259],ge([0,1,14,19,22,21,3,70,6,23,15,2,28,5,39,13,20,7,32,221,121]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const l=(f,h)=>`${f}:${h.toString()}`;let t=class{constructor(h,T,L){this.documents=T,this.workspace=L,this.resultsChangedEmitter=new D.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=h.getProxy(m.MainContext.MainThreadTesting),this.workspaceObservers=new p(this.proxy),this.textDocumentObservers=new E(this.proxy,T)}registerTestProvider(h){const T=(0,g.generateUuid)();this.providers.set(T,h),this.proxy.$registerTestProvider(T);const L=[...this.testSubscriptions.keys()];return setTimeout(()=>{var W;for(const ee of L)(W=this.testSubscriptions.get(ee))===null||W===void 0||W.subscribeFn(T,h)},0),new w.Disposable(()=>{this.providers.delete(T),this.proxy.$unregisterTestProvider(T)})}createTextDocumentTestObserver(h){return this.textDocumentObservers.checkout(h.uri)}createWorkspaceTestObserver(h){return this.workspaceObservers.checkout(h.uri)}async runTests(h,T=I.CancellationToken.None){const L=W=>W.map(this.getInternalTestForReference,this).filter(R.isDefined).map(ee=>({src:ee.src,testId:ee.item.extId}));await this.proxy.$runTests({exclude:h.exclude?L(h.exclude).map(W=>W.testId):void 0,tests:L(h.tests),debug:h.debug},T)}publishExtensionProvidedResults(h,T){this.proxy.$publishExtensionProvidedResults(S.TestResults.from((0,g.generateUuid)(),h),T)}$publishTestResults(h){this.results=Object.freeze(h.map(T=>(0,n.deepFreeze)(S.TestResults.to(T))).concat(this.results).sort((T,L)=>L.completedAt-T.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(h,T){const L=C.URI.revive(T),W=l(h,L);if(!this.testSubscriptions.has(W)){const ee=new I.CancellationTokenSource;let j;if(h===1){let U=this.documents.getDocument(L);if(!U){const M=new y.DisposableStore;U=await new Promise(N=>{M.add((0,P.disposableTimeout)(()=>N(void 0),5e3)),M.add(this.documents.onDidAddDocuments(O=>{const V=O.find(q=>q.document.uri.toString()===L.toString());V&&N(V)}))}).finally(()=>M.dispose())}if(U){const M=await this.workspace.getWorkspaceFolder2(L,!1);j=N=>N.provideDocumentTestRoot?N.provideDocumentTestRoot(U.document,ee.token):(0,e.createDefaultDocumentTestRoot)(N,U.document,M,ee.token)}}else{const U=await this.workspace.getWorkspaceFolder2(L,!1);U&&(j=M=>M.provideWorkspaceTestRoot(U,ee.token))}if(!!j){const x=async(U,M)=>{try{const N=await j(M);N&&F.addRoot(N,U)}catch(N){console.error(N)}},$=new y.DisposableStore,F=$.add(this.ownedTests.createForHierarchy(U=>this.proxy.$publishDiff(h,T,U)));$.add((0,y.toDisposable)(()=>ee.dispose(!0)));for(const[U,M]of this.providers)x(U,M);F.pushDiff([3,-1]),this.testSubscriptions.set(W,{store:$,collection:F,subscribeFn:x})}}}async $expandTest(h,T){const L=(0,_.mapFind)(this.testSubscriptions.values(),W=>W.collection.treeId===h.src.tree?W:void 0);await(L==null?void 0:L.collection.expand(h.testId,T<0?Infinity:T)),this.flushCollectionDiffs()}$unsubscribeFromTests(h,T){var L;const W=C.URI.revive(T),ee=l(h,W);(L=this.testSubscriptions.get(ee))===null||L===void 0||L.store.dispose(),this.testSubscriptions.delete(ee)}$acceptDiff(h,T,L){h===1?this.textDocumentObservers.acceptDiff(C.URI.revive(T),L):this.workspaceObservers.acceptDiff(C.URI.revive(T),L)}async $runTestsForProvider(h,T){const L=this.providers.get(h.tests[0].src.provider);if(!!L){const W=h.tests.map(({testId:x,src:$})=>this.ownedTests.getTestById(x,$.tree)).filter(R.isDefined).map(([x,$])=>$),ee=h.excludeExtIds.map(x=>this.ownedTests.getTestById(x)).filter(R.isDefined).filter(([x,$])=>W.some(F=>x.comparePositions(F,$)===1));if(!!W.length){const j=x=>{for(const[$,F]of ee){const U=$.comparePositions(F,x.id);if(U===1||U===3)return!0}return!1};try{await L.runTests({appendOutput:x=>{this.proxy.$appendOutputToRun(h.runId,A.VSBuffer.fromString(x))},appendMessage:(x,$)=>{j(x)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(h.runId,x.id,S.TestMessage.from($)))},setState:(x,$,F)=>{j(x)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(h.runId,x.id,$,F))},tests:W.map(x=>a.unwrap(x.actual)),exclude:ee.map(([,x])=>a.unwrap(x.actual)),debug:h.debug},T);for(const{collection:x}of this.testSubscriptions.values())x.flushDiff();return}catch(x){throw console.error(x),x}}}}$lookupTest(h){const T=this.ownedTests.getTestById(h.testId);if(!T)return Promise.resolve(void 0);const L=T[1],{actual:W,discoverCts:ee,expandLevels:j}=L,x=zt(L,["actual","discoverCts","expandLevels"]);return Promise.resolve(x)}flushCollectionDiffs(){for(const{collection:h}of this.testSubscriptions.values())h.flushDiff()}getInternalTestForReference(h){var T,L;return(L=(T=this.workspaceObservers.getMirroredTestDataByReference(h))!==null&&T!==void 0?T:(0,_.mapFind)(this.testSubscriptions.values(),W=>W.collection.getTestByReference(h)))!==null&&L!==void 0?L:this.textDocumentObservers.getMirroredTestDataByReference(h)}};t=je([xe(0,d.IExtHostRpcService),xe(1,s.IExtHostDocumentsAndEditors),xe(2,b.IExtHostWorkspace)],t),e.ExtHostTesting=t;const i=async(f,h,T,L)=>{if(!!T){const W=await f.provideWorkspaceTestRoot(T,L);if(!!W)return L.onCancellationRequested(()=>{a.removeFilter(h)}),a.getWrapperForTestItem(W,h)}};e.createDefaultDocumentTestRoot=i;class a extends w.TestItem{constructor(h,T,L){super(h.id,h.label,h.uri,h.expandable);if(this.actual=h,this.filterDocument=T,this.parent=L,!(h instanceof w.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);h[w.TestItemHookProperty]={setProp:(W,ee)=>this[W]=ee,created:W=>a.getWrapperForTestItem(W,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:W=>this.children.delete(W)}}static removeFilter(h){this.wrapperMap.delete(h)}static getWrapperForTestItem(h,T,L){let W=this.wrapperMap.get(T);if(W==null?void 0:W.has(h))return W.get(h);W||(W=new WeakMap,this.wrapperMap.set(T,W));const ee=new a(h,T,L);return W.set(h,ee),ee}static unwrap(h){return h instanceof a?h.actual:h}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var h;const T=this._cachedMatchesFilter;for(const W of this.actual.children){const ee=a.getWrapperForTestItem(W,this.filterDocument,this);ee.hasNodeMatchingFilter?this.children.add(ee):this.children.delete(ee)}const L=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=L,L!==T&&((h=this.parent)===null||h===void 0||h.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=a,a.wrapperMap=new WeakMap;class r extends u.IncrementalChangeCollector{constructor(h){super();this.emitter=h,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(h){this.added.add(h)}update(h){Object.assign(h.revived,S.TestItem.toPlain(h.item)),this.added.has(h)||this.updated.add(h)}remove(h){if(this.added.has(h)){this.added.delete(h);return}if(this.updated.delete(h),h.parent&&this.alreadyRemoved.has(h.parent)){this.alreadyRemoved.add(h.item.extId);return}this.removed.add(h)}getChangeEvent(){const{added:h,updated:T,removed:L}=this;return{get added(){return[...h].map(W=>W.revived)},get updated(){return[...T].map(W=>W.revived)},get removed(){return[...L].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends u.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(h){let T=[];for(const L of h){const W=this.items.get(L);W&&T.push(W.revived)}return T}getMirroredTestDataById(h){return this.items.get(h)}getMirroredTestDataByReference(h){return this.items.get(h.id)}createItem(h,T){return Object.assign(Object.assign({},h),{revived:S.TestItem.toPlain(h.item),depth:T?T.depth+1:0,children:new Set})}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=c;class o{constructor(){this.resources=new Map}checkout(h){var T,L;const W=h.toString(),ee=(T=this.resources.get(W))!==null&&T!==void 0?T:this.createObserverData(h);return(L=ee.pendingDeletion)===null||L===void 0||L.dispose(),ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,onDidDiscoverInitialTests:new D.Emitter().event,get tests(){return ee.tests.rootTestItems},dispose:(0,k.once)(()=>{--ee.observers||(ee.pendingDeletion=this.eventuallyDispose(h))})}}getMirroredTestDataByReference(h){for(const{tests:T}of this.resources.values()){const L=T.getMirroredTestDataByReference(h);if(L)return L}}eventuallyDispose(h){return(0,P.disposableTimeout)(()=>this.unlisten(h),10*1e3)}createObserverData(h){const T=new c,L=this.listen(h,ee=>T.apply(ee)),W={observers:0,tests:T,listener:L};return this.resources.set(h.toString(),W),W}unlisten(h){var T;const L=h.toString(),W=this.resources.get(L);W&&(W.observers=-1,(T=W.pendingDeletion)===null||T===void 0||T.dispose(),W.listener.dispose(),this.resources.delete(L))}}class p extends o{constructor(h){super();this.proxy=h,this.diffListeners=new Map}acceptDiff(h,T){var L;(L=this.diffListeners.get(h.toString()))===null||L===void 0||L(T)}listen(h,T){this.proxy.$subscribeToDiffs(0,h);const L=h.toString();return this.diffListeners.set(L,T),new w.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,h),this.diffListeners.delete(L)})}}class E extends o{constructor(h,T){super();this.proxy=h,this.documents=T,this.diffListeners=new Map}acceptDiff(h,T){var L;(L=this.diffListeners.get(h.toString()))===null||L===void 0||L(T)}listen(h,T){if(!this.documents.getDocument(h))return new w.Disposable(()=>{});const W=h.toString();return this.diffListeners.set(W,T),this.proxy.$subscribeToDiffs(1,h),new w.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,h),this.diffListeners.delete(W)})}}}),define(me[260],ge([0,1,14,53,33,76,24,11,8,25,10,15,2,139,172,84,59,213,258,31]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(E,f,h,T){this.configurationService=E,this.workspaceContextService=f,this.editorGroupsService=h,this.pathService=T}text(E,f,h={}){E=this.getContentPattern(E,h);const T=this.configurationService.getValue(),L=f&&f.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),W=this.commonQuery(f==null?void 0:f.map(S.toWorkspaceFolder),h);return Object.assign(Object.assign({},W),{type:2,contentPattern:E,previewOptions:h.previewOptions,maxFileSize:h.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:h.beforeContext,afterContext:h.afterContext,userDisabledExcludesAndIgnoreFiles:h.disregardExcludeSettings&&h.disregardIgnoreFiles})}getContentPattern(E,f){const h=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const T=Object.assign(Object.assign({},E),{wordSeparators:h.editor.wordSeparators});return this.isCaseSensitive(E,f)&&(T.isCaseSensitive=!0),this.isMultiline(E)&&(T.isMultiline=!0),T}file(E,f={}){const h=this.commonQuery(E,f);return Object.assign(Object.assign({},h),{type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey})}handleIncludeExclude(E,f){return E?(E=Array.isArray(E)?E.map(r):r(E),f?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],f={}){const h=this.handleIncludeExclude(f.includePattern,f.expandPatterns),T=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),L=E.length>1,W=(h.searchPaths&&h.searchPaths.length?h.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,f,T)):E.map(x=>this.getFolderQueryForRoot(x,f,T,L))).filter(x=>!!x),ee={_reason:f._reason,folderQueries:W,usingSearchPaths:!!(h.searchPaths&&h.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:T.pattern,includePattern:h.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const $=_.coalesce(_.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(M=>M.resource)))).filter(U=>(0,v.pathIncludedInQuery)(ee,U.fsPath)),F=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ee),F)}const j=f.extraFileResources&&f.extraFileResources.filter(x=>(0,v.pathIncludedInQuery)(ee,x.fsPath));return ee.extraFileResources=j&&j.length?j:void 0,ee}commonQueryFromFileList(E){const f=[],h=new D.ResourceMap,T={};let L=!1;return E.forEach(W=>{var ee,j;if(W.scheme!==k.Schemas.walkThrough)if((0,n.isAbsolutePath)(W)){const $=(j=(ee=this.workspaceContextService.getWorkspaceFolder(W))===null||ee===void 0?void 0:ee.uri)!==null&&j!==void 0?j:W.with({path:y.dirname(W.fsPath)});let F=h.get($);F||(L=!0,F={folder:$,includePattern:{}},f.push(F),h.set($,F));const U=y.relative($.fsPath,W.fsPath);(0,C.assertIsDefined)(F.includePattern)[U.replace(/\\/g,"/")]=!0}else W.fsPath&&(L=!0,T[W.fsPath]=!0)}),{folderQueries:f,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(E,f){if(f.isSmartCase){if(E.isRegExp){if(R.containsUppercaseCharacter(E.pattern,!0))return!0}else if(R.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,m.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const f=F=>y.isAbsolute(F)||/^\.\.?([\/\\]|$)/.test(F),T=(Array.isArray(E)?E:i(E)).map(F=>{const U=this.pathService.resolvedUserHome;return U?(0,I.untildify)(F,U.scheme===k.Schemas.file?U.fsPath:U.path):F}),L=P.groupBy(T,F=>f(F)?"searchPaths":"exprSegments"),W=(L.exprSegments||[]).map(F=>R.rtrim(F,"/")).map(F=>R.rtrim(F,"\\")).map(F=>(F[0]==="."&&(F="*"+F),a(F))),ee={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(ee.searchPaths=j);const x=_.flatten(W),$=t(...x);return $&&(ee.pattern=$),ee}getExcludesForFolder(E,f){return f.disregardExcludeSettings?void 0:(0,v.getExcludes)(E,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const f=_.flatten(E.map(T=>{let{pathPortion:L,globPortion:W}=l(T);W&&(W=c(W));const ee=this.expandOneSearchPath(L);return _.flatten(ee.map(j=>this.resolveOneSearchPathPattern(j,W)))})),h=new Map;return f.forEach(T=>{const L=T.searchPath.toString(),W=h.get(L);W?T.pattern&&(W.pattern=W.pattern||{},W.pattern[T.pattern]=!0):h.set(L,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(h.values())}expandOneSearchPath(E){if(y.isAbsolute(E)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==k.Schemas.file?[{searchPath:f[0].uri.with({path:E})}]:[{searchPath:g.URI.file(y.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=r(E),E.startsWith("../")||E===".."){const T=y.posix.resolve(f.path,E);return[{searchPath:f.with({path:T})}]}const h=c(E);return[{searchPath:f,pattern:h}]}else{if(E==="./"||E===".\\")return[];{const f=E.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(f){const h=f[1],T=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===h);if(T.length)return T.map(L=>{const W=f[2];return{searchPath:L.uri,pattern:W&&c(W)}});{const L=s.localize(0,null,h);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(E,f){const h=E.pattern&&f?`${E.pattern}/${f}`:E.pattern||f,T=[{searchPath:E.searchPath,pattern:h}];return h&&!h.endsWith("**")&&T.push({searchPath:E.searchPath,pattern:h+"/**"}),T}getFolderQueryForSearchPath(E,f,h){const T=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(E.searchPath),f,h,!1);return T?Object.assign(Object.assign({},T),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,f,h,T){let L;const W=g.URI.isUri(E)?E:E.uri;if(h.searchPaths){const F=h.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,W))[0];if(F&&!F.pattern)return null;F&&(L=F.pattern)}const ee=this.configurationService.getValue({resource:W}),j=this.getExcludesForFolder(ee,f),x=Object.assign(Object.assign({},j||{}),L||{}),$=g.URI.isUri(E)?(0,n.basename)(E):E.name;return{folder:W,folderName:T?$:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!ee.search.followSymlinks}}};u=je([xe(0,d.IConfigurationService),xe(1,S.IWorkspaceContextService),xe(2,w.IEditorGroupsService),xe(3,b.IPathService)],u),e.QueryBuilder=u;function l(p){const E=p.match(/[\*\{\}\(\)\[\]\?]/);if(E){const f=E.index,h=p.substr(0,f).match(/[/|\\][^/\\]*$/);if(h){let T=p.substr(0,h.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:p.substr((h.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((E,f)=>(E[f]=!0,E),Object.create(null)):void 0}function i(p){return A.splitGlobAware(p,",").map(E=>E.trim()).filter(E=>!!E.length)}function a(p){return[`**/${p}/**`,`**/${p}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function c(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(p,E){p=_.distinct(p,T=>T.toString());const f=[],h=E.getWorkspace();return p&&p.forEach(T=>{let L;if(E.getWorkbenchState()===2)L=(0,n.relativePath)(h.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const W=E.getWorkspaceFolder(T);if(W){const ee=W.name;if(h.folders.filter(x=>x.name===ee).length===1){const x=(0,n.relativePath)(W.uri,T);x===""?L=`./${W.name}`:L=`./${W.name}/${x}`}else L=T.fsPath}}L&&f.push(L)}),f}e.resolveResourcesForSearchIncludes=o}),define(me[261],ge([0,1,25,2,21,18,4,260,31,59]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function C(d,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const b=[],v=[];for(const r of w)if(/^workspaceContains:/.test(r)){const c=r.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||d.forceUsingSearch?v.push(c):b.push(c)}if(b.length===0&&v.length===0)return Promise.resolve(void 0);let u;const l=new Promise((r,c)=>{u=r}),t=r=>u({activationEvent:r}),i=Promise.all(b.map(r=>g(d,r,t))).then(()=>{}),a=m(d,S.identifier,v,t);return Promise.all([i,a]).then(()=>{u(void 0)}),l}e.checkActivateWorkspaceContainsExtension=C;async function g(d,S,w){for(const b of d.folders)if(await d.exists(_.joinPath(P.URI.revive(b),S))){w(`workspaceContains:${S}`);return}}async function m(d,S,w,b){if(w.length===0)return Promise.resolve(void 0);const v=new A.CancellationTokenSource,u=d.checkExists(d.folders,w,v.token),l=setTimeout(async()=>{v.cancel(),b(`workspaceContainsTimeout:${w.join(",")}`)},R);let t=!1;try{t=await u}catch(i){I.isPromiseCanceledError(i)||I.onUnexpectedError(i)}v.dispose(),clearTimeout(l),t&&b(`workspaceContains:${w.join(",")}`)}function s(d,S,w,b){const v=d.get(D.IInstantiationService),u=d.get(y.ISearchService),t=v.createInstance(k.QueryBuilder).file(S.map(i=>(0,n.toWorkspaceFolder)(P.URI.revive(i))),{_reason:"checkExists",includePattern:w,exists:!0});return u.fileSearch(t,b).then(i=>!!i.limitHit,i=>I.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=s});var tt=this&&this.__classPrivateFieldSet||function(G,e,_,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(G,_):A?A.value=_:e.set(G,_),_},He=this&&this.__classPrivateFieldGet||function(G,e,_,P){if(_==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?P:_==="a"?P.call(G):P?P.value:e.get(G)};define(me[42],ge([0,1,161,8,67,25,19,6,24,2,12,5,35,224,89,32,41,222,18,29,11,22,195,7,114,4,27,90,13,82,50,34,3,261,87,196]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v,u,l,t,i,a,r,c,o,p,E,f,h,T,L,W,ee){"use strict";var j,x,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let F=class On extends k.Disposable{constructor(O,V,q,X,fe,ve,Ae,Pe,Fe,z){super();this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=q,this._initData=Ae,this._extHostWorkspace=X,this._extHostConfiguration=fe,this._logService=ve,this._extHostTunnelService=Fe,this._extHostTerminalService=z,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=O.createChild(new E.ServiceCollection([s.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState]));const J=new Set;this._initData.hostExtensions.forEach(te=>J.add(v.ExtensionIdentifier.toKey(te))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(te,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,le)},actualActivateExtension:async(te,le)=>{if(J.has(v.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,le),new m.HostExtension;const he=this._registry.getExtensionDescription(te);return this._activateExtension(he,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch(V){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,V){return this._activator.activateByEvent(O,V)}_activateById(O,V){return this._activator.activateById(O,V)}activateByIdWithErrors(O,V){return this._activateById(O,V).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),V=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(X=>O.set(n.URI.file(X).fsPath,q))});this._extensionPathIndex=Promise.all(V).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return V;const q=this._activator.getActivatedExtension(O);if(!q)return V;try{typeof q.module.deactivate=="function"&&(V=Promise.resolve(q.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,k.dispose)(q.subscriptions)}catch(X){}return V}async _activateExtension(O,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,V).then(q=>{const X=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,V),this._logExtensionActivationTimes(O,V,"success",X),q},q=>{throw this._logExtensionActivationTimes(O,V,"failure"),q})}_logExtensionActivationTimes(O,V,q,X){const fe=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},fe),X||{}),{outcome:q}))}_doActivateExtension(O,V){const q=U(O,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(V)}`),this._logService.flush();const fe=new m.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,I.joinPath)(O.extensionLocation,X),fe),this._loadExtensionContext(O)]).then(ve=>(A.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),On._callActivate(this._logService,O.identifier,ve[0],ve[1],fe))).then(ve=>(A.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),ve))}_loadExtensionContext(O){const V=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),X=new ee.ExtensionSecrets(O,this._secretState),fe=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([V.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Ae=this;let Pe;return Object.freeze({globalState:V,workspaceState:q,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Fe){return P.join(O.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Ae._storagePath.workspaceValue(O))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Ae._storagePath.globalValue(O).fsPath},get logPath(){return P.join(Ae._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return n.URI.joinPath(Ae._initData.logsLocation,O.identifier.value)},get storageUri(){return Ae._storagePath.workspaceValue(O)},get globalStorageUri(){return Ae._storagePath.globalValue(O)},get extensionMode(){return fe},get extension(){return Pe===void 0&&(Pe=new M(Ae,O.identifier,O,ve)),Pe},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Ae.extensionRuntime},get environmentVariableCollection(){return Ae._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,V,q,X,fe){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,V,q,X,fe).then(ve=>new m.ActivatedExtension(!1,null,fe.build(),q,ve,X.subscriptions))}static _callActivateOptional(O,V,q,X,fe){if(typeof q.activate=="function")try{fe.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${V.value}`);const ve=typeof global=="object"?global:self,Ae=q.activate.apply(ve,[X]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(Ae).then(Pe=>(fe.activateResolveStop(),Pe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}_activateOneStartupFinished(O,V){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:V}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const V of O.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(O,V)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(V),X=Promise.all([O,q]).then(()=>{});return Promise.race([X,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(O,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,V){if(!this.isActivated(V.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(ve=>ve.uri),forceUsingSearch:q,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Ae,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Ae,Pe)},fe=await(0,L.checkActivateWorkspaceContainsExtension)(X,V);if(!!fe)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:fe.activationEvent}).then(void 0,ve=>this._logService.error(ve))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:V}=this._initData.environment;if(!O||!V||V.scheme!==u.Schemas.file)throw new Error(_.localize(0,null));const q=(0,I.originalFSPath)(V),X=await this._loadCommonJSModule(null,V,new m.ExtensionActivationTimesBuilder(!1));if(!X||typeof X.run!="function")throw new Error(_.localize(1,null,q));return new Promise((fe,ve)=>{const Ae=(Fe,z)=>{Fe?ve(Fe):fe(typeof z=="number"&&z>0?1:0)},Pe=X.run(q,Ae);Pe&&Pe.then&&Pe.then(()=>{fe(0)}).catch(Fe=>{ve(Fe.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,V){return this._resolvers[O]=V,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,V){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const X=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const fe=this._resolvers[X];if(!fe)return{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${X}`);const ve=await fe.resolve(O,{resolveAttempt:V});A.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(fe));const Ae={authority:O,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Pe={extensionHostEnv:ve.extensionHostEnv};return{type:"ok",value:{authority:Ae,options:Pe,tunnelInformation:{environmentTunnels:ve.environmentTunnels}}}}catch(ve){if(A.mark(`code/extHost/didResolveAuthorityError/${X}`),ve instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,V){return V===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,V),!0):!1}async $deltaExtensions(O,V){O.forEach(X=>X.extensionLocation=n.URI.revive(X.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(V.map(async X=>{const fe=this._registry.getExtensionDescription(X);if(!!fe){const ve=await this._hostUtils.realpath(fe.extensionLocation.fsPath);q.delete(n.URI.file(ve).fsPath)}})),await Promise.all(O.map(async X=>{const fe=await this._hostUtils.realpath(X.extensionLocation.fsPath);q.set(n.URI.file(fe).fsPath,X)})),this._registry.deltaExtensions(O,V),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let V=l.VSBuffer.alloc(O),q=Math.random()%256;for(let X=0;X<O;X++)V.writeUInt8(q,X);return V}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};F=je([xe(0,r.IInstantiationService),xe(1,e.IHostUtils),xe(2,p.IExtHostRpcService),xe(3,d.IExtHostWorkspace),xe(4,g.IExtHostConfiguration),xe(5,R.ILogService),xe(6,c.IExtHostInitDataService),xe(7,o.IExtensionStoragePaths),xe(8,f.IExtHostTunnelService),xe(9,h.IExtHostTerminalService)],F),e.AbstractExtHostExtensionService=F;function U(N,O){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,V,q,X){j.set(this,void 0),x.set(this,void 0),$.set(this,void 0),tt(this,j,O,"f"),tt(this,x,V,"f"),tt(this,$,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=P.normalize((0,I.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=X}get isActive(){return He(this,j,"f").isActivated(He(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,j,"f").getExtensionExports(He(this,$,"f"))}activate(){return He(this,j,"f").activateByIdWithErrors(He(this,$,"f"),{startup:!1,extensionId:He(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,j=new WeakMap,x=new WeakMap,$=new WeakMap}),define(me[46],ge([0,1,8,2,3,19,5,7,119,32,42,39,212,35,203,13,4,15,36]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let v=class{constructor(o,p,E,f,h){this._workspaceService=p,this._extensionService=E,this._editorsService=f,this._configurationService=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=o.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(T=>{T.onDidChange(L=>{this.registerAllDebugTypes(T)}),this.registerAllDebugTypes(T)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,p){const E=o;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let f=`debug:${encodeURIComponent(E.path||"")}`,h="?";return p&&(f+=`${h}session=${encodeURIComponent(p.id)}`,h="&"),f+=`${h}ref=${E.sourceReference}`,P.URI.parse(f)}else{if(E.path)return P.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const p=[];for(const E of o.getAllExtensionDescriptions())if(E.contributes){const f=E.contributes.debuggers;if(f&&f.length>0)for(const h of f)(0,s.isDebuggerMainContribution)(h)&&p.push(h.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(p=>o.push(p)),o}addBreakpoints(o){this.startBreakpoints();const p=o.filter(h=>{const T=h.id;return this._breakpoints.has(T)?!1:(this._breakpoints.set(T,h),!0)});this.fireBreakpointChanges(p,[],[]);const E=[],f=new Map;for(const h of p)if(h instanceof k.SourceBreakpoint){let T=f.get(h.location.uri.toString());T||(T={type:"sourceMulti",uri:h.location.uri,lines:[]},f.set(h.location.uri.toString(),T),E.push(T)),T.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof k.FunctionBreakpoint&&E.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(o){this.startBreakpoints();const p=o.filter(T=>this._breakpoints.delete(T.id));this.fireBreakpointChanges([],p,[]);const E=p.filter(T=>T instanceof k.SourceBreakpoint).map(T=>T.id),f=p.filter(T=>T instanceof k.FunctionBreakpoint).map(T=>T.id),h=p.filter(T=>T instanceof k.DataBreakpoint).map(T=>T.id);return this._debugServiceProxy.$unregisterBreakpoints(E,f,h)}startDebugging(o,p,E){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,p,{parentSessionID:E.parentSession?E.parentSession.id:void 0,repl:E.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,p,E){if(!p)return new k.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:f,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,E,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,f),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(h=>h.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(o,p,E){if(!E)return new k.Disposable(()=>{});if(!this.definesDebugType(o,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:f,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,f),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(h=>h.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(o,p){if(!p)return new k.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:E,factory:p}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==p)})}async $runInTerminal(o,p){return Promise.resolve(void 0)}async $substituteVariables(o,p){if(!this._variableResolver){const[h,T]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(h||[],this._editorsService,T)}let E;const f=await this.getFolder(o);return f&&(E={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,p)}createDebugAdapter(o,p){if(o.type==="implementation")return new a(o.implementation)}createSignService(){}async $startDASession(o,p){const E=this,f=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const T=this.convertToDto(h),L=this.createDebugAdapter(T,f);if(!L)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const W=L;return this._debugAdapters.set(o,W),this.getDebugAdapterTrackers(f).then(ee=>(ee&&this._debugAdaptersTrackers.set(o,ee),W.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const x=j,$={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(x.arguments.value);$.body={signature:F},W.sendResponse($)}else throw new Error("no signer")}catch(F){$.success=!1,$.message=F.message,W.sendResponse($)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(j),j=(0,s.convertToVSCPaths)(j,!0),E._debugServiceProxy.$acceptDAMessage(o,j)}),W.onError(j=>{ee&&ee.onError&&ee.onError(j),this._debugServiceProxy.$acceptDAError(o,j.name,j.message,j.stack)}),W.onExit(j=>{ee&&ee.onExit&&ee.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,w.withNullAsUndefined)(j),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),W.startSession()))})}$sendDAMessage(o,p){p=(0,s.convertToDAPaths)(p,!1);const E=this._debugAdaptersTrackers.get(o);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(p);const f=this._debugAdapters.get(o);f&&f.sendMessage(p)}$stopDASession(o){const p=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),p&&p.onWillStopSession&&p.onWillStopSession();const E=this._debugAdapters.get(o);return this._debugAdapters.delete(o),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const p=[],E=[],f=[];if(o.added)for(const h of o.added){const T=h.id;if(T&&!this._breakpoints.has(T)){let L;if(h.type==="function")L=new k.FunctionBreakpoint(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")L=new k.DataBreakpoint(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const W=P.URI.revive(h.uri);L=new k.SourceBreakpoint(new k.Location(W,new k.Position(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}L._id=T,this._breakpoints.set(T,L),p.push(L)}}if(o.removed)for(const h of o.removed){const T=this._breakpoints.get(h);T&&(this._breakpoints.delete(h),E.push(T))}if(o.changed){for(const h of o.changed)if(h.id){const T=this._breakpoints.get(h.id);if(T){if(T instanceof k.FunctionBreakpoint&&h.type==="function"){const L=T;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.functionName=h.functionName}else if(T instanceof k.SourceBreakpoint&&h.type==="source"){const L=T;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.location=new k.Location(P.URI.revive(h.uri),new k.Position(h.line,h.character))}f.push(T)}}}this.fireBreakpointChanges(p,E,f)}$provideDebugConfigurations(o,p,E){return(0,I.asPromise)(async()=>{const f=this.getConfigProviderByHandle(o);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.getFolder(p);return f.provideDebugConfigurations(h,E)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(o,p,E,f){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(o);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const T=await this.getFolder(p);return h.resolveDebugConfiguration(T,E,f)})}$resolveDebugConfigurationWithSubstitutedVariables(o,p,E,f){return(0,I.asPromise)(async()=>{const h=this.getConfigProviderByHandle(o);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const T=await this.getFolder(p);return h.resolveDebugConfigurationWithSubstitutedVariables(T,E,f)})}async $provideDebugAdapter(o,p){const E=this.getAdapterDescriptorFactoryByHandle(o);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(p);return this.getAdapterDescriptor(E,f).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(h)})}async $acceptDebugSessionStarted(o){const p=await this.getSession(o);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(o){const p=await this.getSession(o);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,p){const E=await this.getSession(o);E&&E._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(o,p){const f={session:await this.getSession(o),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const p=this._adapterFactories.filter(E=>E.type===o);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(o){const p=this._adapterFactories.filter(E=>E.handle===o);if(p.length>0)return p[0].factory}getConfigProviderByHandle(o){const p=this._configProviders.filter(E=>E.handle===o);if(p.length>0)return p[0].provider}definesDebugType(o,p){if(o.contributes){const E=o.contributes.debuggers;if(E&&E.length>0){for(const f of E)if(f.label&&f.type&&f.type===p)return!0}}return!1}getDebugAdapterTrackers(o){const E=o.configuration.type,f=this._trackerFactories.filter(h=>h.type===E||h.type==="*").map(h=>(0,I.asPromise)(()=>h.factory.createDebugAdapterTracker(o)).then(T=>T,T=>null));return Promise.race([Promise.all(f).then(h=>{const T=h.filter(L=>!!L);if(T.length>0)return new i(T)}),new Promise((h,T)=>{const L=setTimeout(()=>{clearTimeout(L),T(new Error("timeout"))},1e3)})]).catch(h=>{})}async getAdapterDescriptor(o,p){const E=p.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new k.DebugAdapterServer(E));if(o){const h=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>o.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,h))).then(T=>{if(T)return T})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,f))}daExecutableFromPackage(o,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,p,E){(o.length>0||p.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:p,changed:E}))}async getSession(o){if(o)if(typeof o=="string"){const p=this._debugSessions.get(o);if(p)return p}else{let p=this._debugSessions.get(o.id);if(!p){const E=await this.getFolder(o.folderUri);p=new u(this._debugServiceProxy,o.id,o.type,o.name,E,o.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(o){if(o){const p=P.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};v=je([xe(0,d.IExtHostRpcService),xe(1,n.IExtHostWorkspace),xe(2,R.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration)],v),e.ExtHostDebugServiceBase=v;class u{constructor(o,p,E,f,h,T){this._debugServiceProxy=o,this._id=p,this._type=E,this._name=f,this._workspaceFolder=h,this._configuration=T}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,p)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=u;class l{constructor(o){this.value=Object.freeze({append(p){o.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=l;class t extends g.AbstractVariableResolverService{constructor(o,p,E,f){super({getFolderUri:h=>{const T=o.filter(L=>L.name===h);if(T&&T.length>0)return T[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(h,T)=>E.getConfiguration(void 0,h).get(T),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const h=p.activeEditor();if(h)return _.normalize(h.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&f){const h=p.activeEditor();if(h){const T=f.getWorkspaceFolder(h.document.uri);if(T)return _.normalize(T.uri.fsPath)}}},getSelectedText:()=>{if(p){const h=p.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(p){const h=p.activeEditor();if(h)return String(h.selection.end.line+1)}}},void 0,b.env)}}e.ExtHostVariableResolverService=t;class i{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(p=>p.onError?p.onError(o):void 0)}onExit(o,p){this.trackers.forEach(E=>E.onExit?E.onExit(o,p):void 0)}}class a extends y.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends v{constructor(o,p,E,f,h){super(o,p,E,f,h)}createVariableResolver(o,p,E){return new t(o,p,E)}};r=je([xe(0,d.IExtHostRpcService),xe(1,n.IExtHostWorkspace),xe(2,R.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(me[262],ge([0,1,67,2,5,35,41,29,13,27,4,42,36,12]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(v,u,l,t,i,a,r){this._apiFactory=v,this._extensionRegistry=u,this._instaService=l,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=a,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,u,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,u,this._initData.environment.appUriScheme))}register(v){if(Array.isArray(v.nodeModuleName))for(let u of v.nodeModuleName)this._factories.set(u,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(u=>v.alternativeModuleName(u))}};s=je([xe(2,R.IInstantiationService),xe(3,I.IExtHostConfiguration),xe(4,C.IExtHostExtensionService),xe(5,n.IExtHostInitDataService),xe(6,m.ILogService)],s),e.RequireInterceptor=s;class d{constructor(v,u,l,t,i){this._apiFactory=v,this._extensionPaths=u,this._extensionRegistry=l,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,u){const l=this._extensionPaths.findSubstr(u.fsPath);if(l){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(l.identifier));return t||(t=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(l.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,a)=>t+=`	${a} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(v,u){this.nodeModuleName="keytar";const{environment:l}=u,t=v.getProxy(A.MainContext.MainThreadKeytar);if(l.appRoot){let i=l.appRoot.fsPath;g.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,a)=>t.$getPassword(i,a),setPassword:(i,a,r)=>t.$setPassword(i,a,r),deletePassword:(i,a)=>t.$deletePassword(i,a),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(v,u){return this._impl}alternativeModuleName(v){const u=v.length;if(!(u<=7||!this.alternativeNames)){const l=u-7;if((v.charAt(l)==="/"||v.charAt(l)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}}};S=je([xe(0,y.IExtHostRpcService),xe(1,n.IExtHostInitDataService)],S);let w=class{constructor(v,u,l){this._extensionPaths=v,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(A.MainContext.MainThreadTelemetry);const t=l.getProxy(A.MainContext.MainThreadWindow);this._impl=(i,a)=>{const r=P.URI.parse(i);return a?this.callOriginal(i,a):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,i,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,i,{}):this.callOriginal(i,a)}}load(v,u,l){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=l(v),this._impl}callOriginal(v,u){return this.sendNoForwardTelemetry(),this._original(v,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=je([xe(2,y.IExtHostRpcService)],w)}),define(me[263],ge([0,1,167,9,7,204,32,42,39,35,34,13,46,188,207,19]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends g.ExtHostDebugServiceBase{constructor(v,u,l,t,i,a){super(v,u,l,t,i);this._terminalService=a,this._integratedTerminalInstances=new w}createDebugAdapter(v,u){switch(v.type){case"server":return new I.SocketDebugAdapter(v);case"pipeServer":return new I.NamedPipeDebugAdapter(v);case"executable":return new I.ExecutableDebugAdapter(v,u.type)}return super.createDebugAdapter(v,u)}daExecutableFromPackage(v,u){const l=I.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),v.type);if(l)return new A.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new m.SignService}async $runInTerminal(v,u){if(v.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(h=>{this._integratedTerminalInstances.onTerminalClosed(h)}));const l=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,l),i=this._terminalService.getDefaultShellArgs(!0,l),a=JSON.stringify({shell:t,shellArgs:i});let r=await this._integratedTerminalInstances.checkout(a),c,o=!1;if(r)c=v.cwd;else{const h={shellPath:t,shellArgs:i,cwd:v.cwd,name:v.title||_.localize(0,null)};o=!0,r=this._terminalService.createTerminalFromOptions(h,!0),this._integratedTerminalInstances.insert(r,a)}r.show(!0);const p=await r.processId;o?await new Promise(h=>setTimeout(h,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?r.sendText("cls"):t.indexOf("bash")>=0?r.sendText("clear"):P.isWindows?r.sendText("cls"):r.sendText("clear"));const E=(0,s.prepareCommand)(t,v.args,c,v.env);r.sendText(E);const f=this.onDidTerminateDebugSession(h=>{h.id===u&&(this._integratedTerminalInstances.free(r),f.dispose())});return p}else if(v.kind==="external")return(0,s.runInExternalTerminal)(v,await this._configurationService.getConfigProvider());return super.$runInTerminal(v,u)}createVariableResolver(v,u,l){return new g.ExtHostVariableResolverService(v,u,l,this._workspaceService)}};S=je([xe(0,C.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,k.IExtHostExtensionService),xe(3,y.IExtHostDocumentsAndEditors),xe(4,n.IExtHostConfiguration),xe(5,R.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class w{constructor(){this._terminalInstances=new Map}async checkout(v){const l=[...this._terminalInstances.entries()].map(([t,i])=>(0,d.createCancelablePromise)(async a=>{if(i.lastUsedAt!==-1&&await(0,s.hasChildProcesses)(await t.processId))return null;const r=Date.now();return i.lastUsedAt+w.minUseDelay>r||a.isCancellationRequested||i.config!==v?null:(i.lastUsedAt=r,t)}));return await(0,d.firstParallel)(l,t=>!!t)}insert(v,u){this._terminalInstances.set(v,{lastUsedAt:Date.now(),config:u})}free(v){const u=this._terminalInstances.get(v);u&&(u.lastUsedAt=-1)}onTerminalClosed(v){this._terminalInstances.delete(v)}}w.minUseDelay=1e3}),define(me[264],ge([0,1,8,2,78,32,46,39,35,34,13,27,66,11,12,63]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends g.ExtHostTaskBase{constructor(b,v,u,l,t,i,a,r){super(b,v,u,l,t,i,a,r);this.workspaceService=u,v.remote.isRemote&&v.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:v.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,v){const u=v;if(!v.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const l=g.TaskHandleDTO.from(u,this.workspaceService),t=await this._proxy.$getTaskExecution(l);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(t,v);return this._proxy.$executeTask(l).catch(()=>{}),i}else{const l=g.TaskDTO.from(v,b);if(l===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(l.execution)&&await this.addCustomExecution(l,v,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(l),v);return this._proxy.$executeTask(l).catch(()=>{}),t}}provideTasksInternal(b,v,u,l){const t=[];if(l)for(let i of l){this.checkDeprecation(i,u),(!i.definition||!b[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const a=g.TaskDTO.from(i,u.extension);a&&(t.push(a),g.CustomExecutionDTO.is(a.execution)&&v.push(this.addCustomExecution(a,i,!0)))}return{tasks:t,extension:u.extension}}async resolveTaskInternal(b){return b}async getVariableResolver(b){if(this._variableResolver===void 0){const v=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(b,this._editorService,v,this.workspaceService)}return this._variableResolver}async $resolveVariables(b,v){const u=P.URI.revive(b),l={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(u),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const a=await this.getVariableResolver(i),r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let c of v.variables)l.variables[c]=await a.resolveAsync(r,c);if(v.process!==void 0){let c;if(v.process.path!==void 0){c=v.process.path.split(_.delimiter);for(let o=0;o<c.length;o++)c[o]=await a.resolveAsync(r,c[o])}l.process=await A.win32.findExecutable(await a.resolveAsync(r,v.process.name),v.process.cwd!==void 0?await a.resolveAsync(r,v.process.cwd):void 0,c)}return l}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(b,v,u){return A.win32.findExecutable(b,v,u)}};S=je([xe(0,R.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,I.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,y.IExtHostConfiguration),xe(5,n.IExtHostTerminalService),xe(6,s.ILogService),xe(7,d.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(me[265],ge([0,1,9,15,28,148,12,35,46,39,13,34,32,210,211]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let d=class extends C.BaseExtHostTerminalService{constructor(w,b,v,u,l){super(!0,w);this._extHostConfiguration=b,this._extHostWorkspace=v,this._extHostDocumentsAndEditors=u,this._logService=l,this._isWorkspaceShellAllowed=!1,(0,I.getSystemShell)(_.platform,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,b,v){const u=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),{name:w,shellPath:b,shellArgs:v},w);return this._terminals.push(u),u.create(b,v),u.value}createTerminalFromOptions(w,b){const v=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),w,w.name);return this._terminals.push(v),v.create((0,P.withNullAsUndefined)(w.shellPath),(0,P.withNullAsUndefined)(w.shellArgs),(0,P.withNullAsUndefined)(w.cwd),(0,P.withNullAsUndefined)(w.env),(0,P.withNullAsUndefined)(w.icon),(0,P.withNullAsUndefined)(w.message),void 0,(0,P.withNullAsUndefined)(w.strictEnv),(0,P.withNullAsUndefined)(w.hideFromUser),(0,P.withNullAsUndefined)(b),!0),v.value}getDefaultShell(w,b){var v;const u=l=>{const t=b.getConfiguration(l.substr(0,l.lastIndexOf("."))).inspect(l.substr(l.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(t)};return m.getDefaultShell(u,this._isWorkspaceShellAllowed,(v=this._defaultShell)!==null&&v!==void 0?v:(0,I.getSystemShellSync)(_.platform,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,b){const v=u=>{const l=b.getConfiguration(u.substr(0,u.lastIndexOf("."))).inspect(u.substr(u.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(l)};return m.getDefaultShellArgs(v,this._isWorkspaceShellAllowed,w,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_apiInspectConfigToPlain(w){return{userValue:w?w.globalValue:void 0,value:w?w.workspaceValue:void 0,defaultValue:w?w.defaultValue:void 0}}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),b=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(b||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const b=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,s.detectAvailableProfiles)(w,void 0,this._logService,b,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(w){const b=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,b),args:this.getDefaultShellArgs(w,b)}}$acceptWorkspacePermissionsChanged(w){this._isWorkspaceShellAllowed=w}};d=je([xe(0,R.IExtHostRpcService),xe(1,k.IExtHostConfiguration),xe(2,g.IExtHostWorkspace),xe(3,n.IExtHostDocumentsAndEditors),xe(4,D.ILogService)],d),e.ExtHostTerminalService=d}),define(me[266],ge([0,1,19,18,67,6,2,5,256,12,79,82,27,184,13,61,42,34]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(u,l,t,i){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const a=new y.RPCProtocol(u,null,i);l=b._transform(l,a);const r=new C.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());r.set(g.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},l)),r.set(s.IExtHostRpcService,new s.ExtHostRpcService(a)),r.set(d.IURITransformerService,new d.URITransformerService(i)),r.set(S.IHostUtils,t);const c=new m.InstantiationService(r,!0),o=c.invokeFunction(h=>h.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=c.invokeFunction(h=>h.get(n.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",l),this._extensionService=c.invokeFunction(h=>h.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(T,L)=>{let W="",ee,j;for(const x of L)W+=`
	at ${x.toString()}`,j=x.getFileName(),!ee&&j&&(ee=h.findSubstr(j));return p.set(T,ee),`${T.name||"Error"}: ${T.message||""}${W}`}});const E=a.getProxy(k.MainContext.MainThreadExtensionService),f=a.getProxy(k.MainContext.MainThreadErrors);P.setUnexpectedErrorHandler(h=>{const T=P.transformErrorForSerialization(h),L=p.get(h);L?E.$onExtensionRuntimeError(L.identifier,T):f.$onUnexpectedError(T)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),P.setUnexpectedErrorHandler(t=>{});const l=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),l]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,l){u.extensions.forEach(i=>i.extensionLocation=D.URI.revive(l.transformIncomingURIs(i.extensionLocation))),u.environment.appRoot=D.URI.revive(l.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(i=>D.URI.revive(l.transformIncomingURIs(i)))),u.environment.extensionTestsLocationURI=D.URI.revive(l.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=D.URI.revive(l.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=D.URI.revive(l.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=D.URI.revive(l.transformIncomingURIs(u.logsLocation)),u.logFile=D.URI.revive(l.transformIncomingURIs(u.logFile)),u.workspace=l.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=b}),define(me[267],ge([0,1,8,21,58,33,25,47,31]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(g,m,s){this.config=g,this.provider=m,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&I.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&I.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const m=this.config.folderQueries||[];return new Promise((s,d)=>{const S=w=>{this.resultCount++,g(w)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const b=w.toString(),v=_.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,v)||this.matchFile(S,{base:w,basename:v})}),Promise.all(m.map(w=>this.searchInFolder(w,S))).then(w=>{s({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{d(new Error((0,A.toErrorMessage)(w)))})})}async searchInFolder(g,m){const s=new P.CancellationTokenSource,d=this.getSearchOptionsForFolder(g),S=this.initDirectoryTree(),w=new y.QueryGlobTester(this.config,g),b=!w.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(s),v=k.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,s.token),l=v.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(i=>{const a=_.posix.relative(g.folder.path,i.path);if(b){const r=_.basename(i.path);this.matchFile(m,{base:g.folder,relativePath:a,basename:r});return}this.addDirectoryEntries(S,g.folder,a,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,m),{providerTime:l,postProcessTime:t.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(g){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:s,includes:m,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},m,s,d){if(s===this.filePattern){const w=_.basename(this.filePattern);this.matchFile(d,{base:m,relativePath:this.filePattern,basename:w})}function S(w){const b=_.basename(w),v=_.dirname(w);let u=g[v];u||(u=g[v]=[],S(v)),u.push({base:m,relativePath:w,basename:b})}S(s)}matchDirectoryTree({rootEntries:g,pathToEntries:m},s,d){const S=this,w=this.filePattern;function b(v){const u=I.hasSiblingFn(()=>v.map(l=>l.basename));for(let l=0,t=v.length;l<t;l++){const i=v[l],{relativePath:a,basename:r}=i;if(!!s.includedInQuerySync(a,r,w!==r?u:void 0)){const c=m[a];if(c)b(c);else{if(a===w)continue;S.matchFile(d,i)}if(S.isLimitHit)break}}}b(g)}matchFile(g,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(m))}}class R{constructor(){this.sessions=new Map}fileSearch(g,m,s,d){const S=this.getSessionTokenSource(g.cacheKey),w=new n(g,m,S&&S.token);let b=0;const v=u=>{b+=u.length,s(u.map(l=>this.rawMatchToSearchItem(l)))};return this.doSearch(w,R.BATCH_SIZE,v,d).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:u.stats}}))}clearCache(g){const m=this.getSessionTokenSource(g);m&&m.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new P.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:D.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,m,s,d){d.onCancellationRequested(()=>{g.cancel()});const S=b=>{b&&(w.push(b),m>0&&w.length>=m&&(s(w),w=[]))};let w=[];return g.search(S).then(b=>(w.length&&s(w),b),b=>(w.length&&s(w),Promise.reject(b)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(me[126],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class _{constructor(I,D){this.line=I,this.character=D}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,D){return new _(0,0)}with(I){return new _(0,0)}}e.Position=_;class P{constructor(I,D,k,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(I,D),this.end=new _(k,y)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new P(0,0,0,0)}with(I){return new P(0,0,0,0)}}e.Range=P}),define(me[127],ge([0,1,8,14,21,58,25,33,2,31,11]),function(G,e,_,P,A,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(b,v,u){this.query=b,this.provider=v,this.fileUtils=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,v){const u=this.query.folderQueries||[],l=new A.CancellationTokenSource;return v.onCancellationRequested(()=>l.cancel()),new Promise((t,i)=>{this.collector=new m(b);let a=!1;const r=(c,o)=>{if(!a&&!this.isLimitHit){const p=this.resultSize(c);d(c)&&typeof this.query.maxResults=="number"&&this.resultCount+p>this.query.maxResults&&(this.isLimitHit=!0,a=!0,l.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const E=this.resultSize(c);this.resultCount+=E,(E>0||!d(c))&&this.collector.add(c,o)}};Promise.all(u.map((c,o)=>this.searchInFolder(c,p=>r(p,o),l.token))).then(c=>{l.dispose(),this.collector.flush();const o=c.some(p=>!!p&&!!p.limitHit);t({limitHit:this.isLimitHit||o,stats:{type:"textSearchProvider"}})},c=>{l.dispose();const o=(0,I.toErrorMessage)(c);i(new Error(o))})})}resultSize(b){return d(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,v){const u=Array.isArray(b.ranges)?b.ranges:[b.ranges],l=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:u.slice(0,v),preview:{matches:l.slice(0,v),text:b.preview.text},uri:b.uri}}async searchInFolder(b,v,u){const l=new n.QueryGlobTester(this.query,b),t=[],i={report:c=>{if(!!this.validateProviderResult(c)){const o=b.folder.scheme===R.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(c.uri))):void 0,p=D.relativePath(b.folder,c.uri);p&&t.push(l.includedInQuery(p,_.basename(p),o).then(E=>{E&&v(c)}))}}},a=this.getSearchOptionsForFolder(b),r=await this.provider.provideTextSearchResults(g(this.query.contentPattern),a,i,u);return await Promise.all(t),r}validateProviderResult(b){if(d(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const v=(0,n.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),u=(0,n.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),l={folder:y.URI.from(b.folder),excludes:u,includes:v,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=C;function g(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class m{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,v=>this.sendItems(v))}add(b,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!D.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(s(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=m;function s(w){return d(w)?{preview:{matches:(0,P.mapArrayOrNot)(w.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:w.preview.text},ranges:(0,P.mapArrayOrNot)(w.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function d(w){return!!w.preview}e.extensionResultIsMatch=d;class S{constructor(b,v){this.maxBatchSize=b,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,v){!b||this.addItemToBatch(b,v)}addItems(b,v){!b||this.addItemsToBatch(b,v)}addItemToBatch(b,v){this.batch.push(b),this.batchSize+=v,this.onUpdate()}addItemsToBatch(b,v){this.batch=this.batch.concat(b),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(me[68],ge([0,1,6,5,4,267,13,61,12,2,127]),function(G,e,_,P,A,I,D,k,y,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let C=class{constructor(d,S,w){this.extHostRpc=d,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(P.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,S){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(d,S){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(d)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(d,S,w,b){const v=g(w),u=this._fileSearchProvider.get(d);if(u)return this._fileSearchManager.fileSearch(v,u,l=>{this._proxy.$handleFileMatch(d,S,l.map(t=>t.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,S,w,b){const v=this._textSearchProvider.get(d);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const u=g(w);return this.createTextSearchManager(u,v).search(t=>this._proxy.$handleTextMatch(d,S,t),b)}createTextSearchManager(d,S){return new R.TextSearchManager(d,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=je([xe(0,D.IExtHostRpcService),xe(1,k.IURITransformerService),xe(2,y.ILogService)],C),e.ExtHostSearch=C;function g(s){return Object.assign(Object.assign({},s),{folderQueries:s.folderQueries&&s.folderQueries.map(m),extraFileResources:s.extraFileResources&&s.extraFileResources.map(d=>n.URI.revive(d))})}e.reviveQuery=g;function m(s){return Object.assign(Object.assign({},s),{folder:n.URI.revive(s.folder)})}}),define(me[268],ge([0,1,158,21,18,3,56,2,150,105,140,77,45,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,64,219,243,244,245,89,34,246,220,20,7,249,65,125,32,41,53,200,237,115,124,66,46,68,12,61,13,27,241,198,50,63,227,247,197,90,88,252,250,251,228,60,259,248,87,194,117,242]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v,u,l,t,i,a,r,c,o,p,E,f,h,T,L,W,ee,j,x,$,F,U,M,N,O,V,q,X,fe,ve,Ae,Pe,Fe,z,J,te,le,he,Ce,Me,we,ke,Re,Be,Ee,Ge,Q,re,be,Ue,ze,$e,Ze,K,oe,de,Y,ie,ce,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ye(We){const Ne=We.get(Me.IExtHostInitDataService),Ke=We.get(K.IExtHostFileSystemInfo),Xe=We.get(be.IExtHostConsumerFileSystem),nt=We.get(r.IExtHostExtensionService),rt=We.get(q.IExtHostWorkspace),ot=We.get(ce.IExtHostTelemetry),it=We.get(b.IExtHostConfiguration),pt=We.get(he.IURITransformerService),qe=We.get(Ce.IExtHostRpcService),_e=We.get(j.IExtHostStorage),De=We.get(re.IExtensionStoragePaths),ae=We.get(le.ILogService),Z=We.get(Re.IExtHostTunnelService),Oe=We.get(Be.IExtHostApiDeprecationService),Te=We.get(V.IExtHostWindow),Je=We.get(Y.IExtHostSecretState);qe.set(m.ExtHostContext.ExtHostFileSystemInfo,Ke),qe.set(m.ExtHostContext.ExtHostLogService,ae),qe.set(m.ExtHostContext.ExtHostWorkspace,rt),qe.set(m.ExtHostContext.ExtHostConfiguration,it),qe.set(m.ExtHostContext.ExtHostExtensionService,nt),qe.set(m.ExtHostContext.ExtHostStorage,_e),qe.set(m.ExtHostContext.ExtHostTunnelService,Z),qe.set(m.ExtHostContext.ExtHostWindow,Te),qe.set(m.ExtHostContext.ExtHostSecretState,Je),qe.set(m.ExtHostContext.ExtHostTelemetry,ot);const Ye=qe.set(m.ExtHostContext.ExtHostDecorations,We.get(Fe.IExtHostDecorations)),at=qe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,We.get(a.IExtHostDocumentsAndEditors)),st=qe.set(m.ExtHostContext.ExtHostCommands,We.get(S.IExtHostCommands)),Qe=qe.set(m.ExtHostContext.ExtHostTerminalService,We.get(x.IExtHostTerminalService)),lt=qe.set(m.ExtHostContext.ExtHostDebugService,We.get(J.IExtHostDebugService)),bt=qe.set(m.ExtHostContext.ExtHostSearch,We.get(te.IExtHostSearch)),ut=qe.set(m.ExtHostContext.ExtHostTask,We.get(z.IExtHostTask)),vt=qe.set(m.ExtHostContext.ExtHostOutputService,We.get(h.IExtHostOutputService)),Et=qe.set(m.ExtHostContext.ExtHostEditorTabs,new ie.ExtHostEditorTabs),yt=qe.set(m.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(qe)),_t=qe.set(m.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(qe,at)),Ot=qe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new l.ExtHostDocumentContentProvider(qe,at,ae)),Rt=qe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ae,_t,qe.getProxy(m.MainContext.MainThreadBulkEdits))),ft=qe.set(m.ExtHostContext.ExtHostNotebook,new we.ExtHostNotebookController(qe,st,at,_t,Ne.environment,ae,De)),Kt=qe.set(m.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(qe,Ne,ft)),St=qe.set(m.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(qe,at)),Vt=qe.set(m.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(qe.getProxy(m.MainContext.MainThreadTreeViews),st,ae)),Gt=qe.set(m.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(qe.getProxy(m.MainContext.MainThreadEditorInsets),St,Ne.environment)),Nt=qe.set(m.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(qe,ae)),dt=qe.set(m.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(qe,pt,_t,st,Nt,ae,Oe)),gn=qe.set(m.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(qe,dt)),Pt=qe.set(m.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(qe,ae,at)),Lt=qe.set(m.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(qe,rt,st)),on=qe.set(m.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(qe,st,ae)),pn=qe.set(m.ExtHostContext.ExtHostComments,new w.ExtHostComments(qe,st,_t)),an=qe.set(m.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(qe.getProxy(m.MainContext.MainThreadProgress))),vn=qe.set(m.ExtHostContext.ExtHosLabelService,new Ae.ExtHostLabelService(qe)),ln=qe.set(m.ExtHostContext.ExtHostTheming,new ke.ExtHostTheming(qe)),At=qe.set(m.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(qe)),Qt=qe.set(m.ExtHostContext.ExtHostTimeline,new Ge.ExtHostTimeline(qe,st)),Xt=qe.set(m.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(qe,Ne.environment,rt,ae,Oe)),Jt=qe.set(m.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(qe,Xt,rt)),wn=qe.set(m.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(qe,_t,De,Xt,Jt)),bn=qe.set(m.ExtHostContext.ExtHostWebviewViews,new Ue.ExtHostWebviewViews(qe,Xt)),Ct=qe.set(m.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(qe,at,rt)),_n=qe.set(m.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(qe)),En=(0,fe.values)(m.ExtHostContext);qe.assertRegistered(En);const Yt=new Ze.ExtHostBulkEdits(qe,at),Sn=new d.ExtHostClipboard(qe),Ut=new f.ExtHostMessageService(qe,ae),jt=new u.ExtHostDialogs(qe),xt=new ee.ExtHostStatusBar(qe,st.converter),Zt=new E.ExtHostLanguages(qe,_t);return s.ExtHostApiCommands.register(st),function(Le,Bt,en){const mt=function(){let ne=!Le.isUnderDevelopment;function ue(Ie){ne||(ae.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ie(ct){if(Array.isArray(ct))ct.forEach(Ie);else if(typeof ct=="string")ue(ct);else{const H=ct;typeof H.scheme=="undefined"&&ue(ct),!Le.enableProposedApi&&typeof H.exclusive=="boolean"&&(0,X.throwProposedApiError)(Le)}return ct}}(),yn={getSession(ne,ue,Ie){return At.getSession(Le,ne,ue,Ie)},get onDidChangeSessions(){return At.onDidChangeSessions},registerAuthenticationProvider(ne,ue,Ie,ct){return At.registerAuthenticationProvider(ne,ue,Ie,ct)},get onDidChangeAuthenticationProviders(){return(0,X.checkProposedApiEnabled)(Le),At.onDidChangeAuthenticationProviders},get providers(){return(0,X.checkProposedApiEnabled)(Le),At.providers},logout(ne,ue){return(0,X.checkProposedApiEnabled)(Le),At.removeSession(ne,ue)}},Dn={registerCommand(ne,ue,Ie){return st.registerCommand(!0,ne,ue,Ie)},registerTextEditorCommand(ne,ue,Ie){return st.registerCommand(!0,ne,(...ct)=>{const H=St.getActiveTextEditor();if(!H){ae.warn("Cannot execute "+ne+" because there is no active text editor.");return}return H.edit(B=>{ue.apply(Ie,[H,B,...ct])}).then(B=>{B||ae.warn("Edits from command "+ne+" were not applied.")},B=>{ae.warn("An error occurred while running command "+ne,B)})})},registerDiffInformationCommand:(ne,ue,Ie)=>((0,X.checkProposedApiEnabled)(Le),st.registerCommand(!0,ne,async(...ct)=>{const H=at.activeEditor(!0);if(!H){ae.warn("Cannot execute "+ne+" because there is no active text editor.");return}const B=await St.getDiffInformation(H.id);ue.apply(Ie,[B,...ct])})),executeCommand(ne,...ue){return st.executeCommand(ne,...ue)},getCommands(ne=!1){return st.getCommands(ne)}},cn={get machineId(){return Ne.telemetryInfo.machineId},get sessionId(){return Ne.telemetryInfo.sessionId},get language(){return Ne.environment.appLanguage},get appName(){return Ne.environment.appName},get appRoot(){var ne,ue;return(ue=(ne=Ne.environment.appRoot)===null||ne===void 0?void 0:ne.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ne.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return Qe.getDefaultShell(!1,en)},get isTelemetryEnabled(){return ot.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ot.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Ne.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,ue){return Te.openUri(ne,{allowTunneling:!!Ne.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(ne){return ne.scheme===Ne.environment.appUriScheme?yt.createAppUri(ne):Te.asExternalUri(ne,{allowTunneling:!!Ne.remote.authority})},get remoteName(){return(0,Pe.getRemoteName)(Ne.remote.authority)},get uiKind(){return Ne.uiKind}};Ne.environment.extensionTestsLocationURI||Object.freeze(cn);const un=Ne.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,tn={registerTestProvider(ne){return(0,X.checkProposedApiEnabled)(Le),Ct.registerTestProvider(ne)},createDocumentTestObserver(ne){return(0,X.checkProposedApiEnabled)(Le),Ct.createTextDocumentTestObserver(ne)},createWorkspaceTestObserver(ne){return(0,X.checkProposedApiEnabled)(Le),Ct.createWorkspaceTestObserver(ne)},runTests(ne){return(0,X.checkProposedApiEnabled)(Le),Ct.runTests(ne)},publishTestResult(ne,ue=!0){return(0,X.checkProposedApiEnabled)(Le),Ct.publishExtensionProvidedResults(ne,ue)},get onDidChangeTestResults(){return(0,X.checkProposedApiEnabled)(Le),Ct.onResultsChanged},get testResults(){return(0,X.checkProposedApiEnabled)(Le),Ct.results}},Cn={getExtension(ne){const ue=Bt.getExtensionDescription(ne);if(ue)return new r.Extension(nt,Le.identifier,ue,un)},get all(){return Bt.getAllExtensionDescriptions().map(ne=>new r.Extension(nt,Le.identifier,ne,un))},get onDidChange(){return Bt.onDidChange}},kn={createDiagnosticCollection(ne){return Nt.createDiagnosticCollection(Le.identifier,ne)},get onDidChangeDiagnostics(){return Nt.onDidChangeDiagnostics},getDiagnostics:ne=>Nt.getDiagnostics(ne),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(ne,ue){return Zt.changeLanguage(ne.uri,ue)},match(ne,ue){return(0,C.score)(U.LanguageSelector.from(ne),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(ne,ue,Ie){return dt.registerCodeActionProvider(Le,mt(ne),ue,Ie)},registerCodeLensProvider(ne,ue){return dt.registerCodeLensProvider(Le,mt(ne),ue)},registerDefinitionProvider(ne,ue){return dt.registerDefinitionProvider(Le,mt(ne),ue)},registerDeclarationProvider(ne,ue){return dt.registerDeclarationProvider(Le,mt(ne),ue)},registerImplementationProvider(ne,ue){return dt.registerImplementationProvider(Le,mt(ne),ue)},registerTypeDefinitionProvider(ne,ue){return dt.registerTypeDefinitionProvider(Le,mt(ne),ue)},registerHoverProvider(ne,ue){return dt.registerHoverProvider(Le,mt(ne),ue,Le.identifier)},registerEvaluatableExpressionProvider(ne,ue){return dt.registerEvaluatableExpressionProvider(Le,mt(ne),ue,Le.identifier)},registerInlineValuesProvider(ne,ue){return dt.registerInlineValuesProvider(Le,mt(ne),ue,Le.identifier)},registerDocumentHighlightProvider(ne,ue){return dt.registerDocumentHighlightProvider(Le,mt(ne),ue)},registerLinkedEditingRangeProvider(ne,ue){return dt.registerLinkedEditingRangeProvider(Le,mt(ne),ue)},registerReferenceProvider(ne,ue){return dt.registerReferenceProvider(Le,mt(ne),ue)},registerRenameProvider(ne,ue){return dt.registerRenameProvider(Le,mt(ne),ue)},registerDocumentSymbolProvider(ne,ue,Ie){return dt.registerDocumentSymbolProvider(Le,mt(ne),ue,Ie)},registerWorkspaceSymbolProvider(ne){return dt.registerWorkspaceSymbolProvider(Le,ne)},registerDocumentFormattingEditProvider(ne,ue){return dt.registerDocumentFormattingEditProvider(Le,mt(ne),ue)},registerDocumentRangeFormattingEditProvider(ne,ue){return dt.registerDocumentRangeFormattingEditProvider(Le,mt(ne),ue)},registerOnTypeFormattingEditProvider(ne,ue,Ie,...ct){return dt.registerOnTypeFormattingEditProvider(Le,mt(ne),ue,[Ie].concat(ct))},registerDocumentSemanticTokensProvider(ne,ue,Ie){return dt.registerDocumentSemanticTokensProvider(Le,mt(ne),ue,Ie)},registerDocumentRangeSemanticTokensProvider(ne,ue,Ie){return dt.registerDocumentRangeSemanticTokensProvider(Le,mt(ne),ue,Ie)},registerSignatureHelpProvider(ne,ue,Ie,...ct){return typeof Ie=="object"?dt.registerSignatureHelpProvider(Le,mt(ne),ue,Ie):dt.registerSignatureHelpProvider(Le,mt(ne),ue,typeof Ie=="undefined"?[]:[Ie,...ct])},registerCompletionItemProvider(ne,ue,...Ie){return dt.registerCompletionItemProvider(Le,mt(ne),ue,Ie)},registerDocumentLinkProvider(ne,ue){return dt.registerDocumentLinkProvider(Le,mt(ne),ue)},registerColorProvider(ne,ue){return dt.registerColorProvider(Le,mt(ne),ue)},registerFoldingRangeProvider(ne,ue){return dt.registerFoldingRangeProvider(Le,mt(ne),ue)},registerSelectionRangeProvider(ne,ue){return dt.registerSelectionRangeProvider(Le,ne,ue)},registerCallHierarchyProvider(ne,ue){return dt.registerCallHierarchyProvider(Le,ne,ue)},setLanguageConfiguration:(ne,ue)=>dt.setLanguageConfiguration(Le,ne,ue),getTokenInformationAtPosition(ne,ue){return(0,X.checkProposedApiEnabled)(Le),Zt.tokenAtPosition(ne,ue)},registerInlineHintsProvider(ne,ue){return(0,X.checkProposedApiEnabled)(Le),dt.registerInlineHintsProvider(Le,ne,ue)}},Pn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return Qe.activeTerminal},get terminals(){return Qe.terminals},async showTextDocument(ne,ue,Ie){const ct=await(k.URI.isUri(ne)?Promise.resolve(dn.openTextDocument(ne)):Promise.resolve(ne));return St.showTextDocument(ct,ue,Ie)},createTextEditorDecorationType(ne){return St.createTextEditorDecorationType(ne)},onDidChangeActiveTextEditor(ne,ue,Ie){return St.onDidChangeActiveTextEditor(ne,ue,Ie)},onDidChangeVisibleTextEditors(ne,ue,Ie){return St.onDidChangeVisibleTextEditors(ne,ue,Ie)},onDidChangeTextEditorSelection(ne,ue,Ie){return St.onDidChangeTextEditorSelection(ne,ue,Ie)},onDidChangeTextEditorOptions(ne,ue,Ie){return St.onDidChangeTextEditorOptions(ne,ue,Ie)},onDidChangeTextEditorVisibleRanges(ne,ue,Ie){return St.onDidChangeTextEditorVisibleRanges(ne,ue,Ie)},onDidChangeTextEditorViewColumn(ne,ue,Ie){return St.onDidChangeTextEditorViewColumn(ne,ue,Ie)},onDidCloseTerminal(ne,ue,Ie){return Qe.onDidCloseTerminal(ne,ue,Ie)},onDidOpenTerminal(ne,ue,Ie){return Qe.onDidOpenTerminal(ne,ue,Ie)},onDidChangeActiveTerminal(ne,ue,Ie){return Qe.onDidChangeActiveTerminal(ne,ue,Ie)},onDidChangeTerminalDimensions(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),Qe.onDidChangeTerminalDimensions(ne,ue,Ie)},onDidWriteTerminalData(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),Qe.onDidWriteTerminalData(ne,ue,Ie)},get state(){return Te.state},onDidChangeWindowState(ne,ue,Ie){return Te.onDidChangeWindowState(ne,ue,Ie)},showInformationMessage(ne,...ue){return Ut.showMessage(Le,D.default.Info,ne,ue[0],ue.slice(1))},showWarningMessage(ne,...ue){return Ut.showMessage(Le,D.default.Warning,ne,ue[0],ue.slice(1))},showErrorMessage(ne,...ue){return Ut.showMessage(Le,D.default.Error,ne,ue[0],ue.slice(1))},showQuickPick(ne,ue,Ie){return Lt.showQuickPick(ne,!!Le.enableProposedApi,ue,Ie)},showWorkspaceFolderPick(ne){return Lt.showWorkspaceFolderPick(ne)},showInputBox(ne,ue){return Lt.showInput(ne,ue)},showOpenDialog(ne){return jt.showOpenDialog(ne)},showSaveDialog(ne){return jt.showSaveDialog(ne)},createStatusBarItem(ne,ue){let Ie,ct,H,B;return ne&&typeof ne!="number"?(Ie=ne.id,ct=ne.name,H=ne.alignment,ue=ne.priority,B=ne.accessibilityInformation):(Ie=Le.identifier.value,ct=_.localize(0,null,Le.displayName||Le.name),H=ne),xt.createStatusBarEntry(Ie,ct,H,ue,B)},setStatusBarMessage(ne,ue){return xt.setStatusBarMessage(ne,ue)},withScmProgress(ne){return Oe.report("window.withScmProgress",Le,"Use 'withProgress' instead."),an.withProgress(Le,{location:M.ProgressLocation.SourceControl},(ue,Ie)=>ne({report(ct){}}))},withProgress(ne,ue){return an.withProgress(Le,ne,ue)},createOutputChannel(ne){return vt.createOutputChannel(ne)},createWebviewPanel(ne,ue,Ie,ct){return Jt.createWebviewPanel(Le,ne,ue,Ie,ct)},createWebviewTextEditorInset(ne,ue,Ie,ct){return(0,X.checkProposedApiEnabled)(Le),Gt.createWebviewEditorInset(ne,ue,Ie,ct,Le)},createTerminal(ne,ue,Ie){return typeof ne=="object"?"pty"in ne?Qe.createExtensionTerminal(ne):(ne.message&&(0,X.checkProposedApiEnabled)(Le),ne.icon&&(0,X.checkProposedApiEnabled)(Le),Qe.createTerminalFromOptions(ne)):Qe.createTerminal(ne,ue,Ie)},registerTerminalLinkProvider(ne){return Qe.registerLinkProvider(ne)},registerTreeDataProvider(ne,ue){return Vt.registerTreeDataProvider(ne,ue,Le)},createTreeView(ne,ue){return Vt.createTreeView(ne,ue,Le)},registerWebviewPanelSerializer:(ne,ue)=>Jt.registerWebviewPanelSerializer(Le,ne,ue),registerCustomEditorProvider:(ne,ue,Ie={})=>wn.registerCustomEditorProvider(Le,ne,ue,Ie),registerFileDecorationProvider(ne){return Ye.registerFileDecorationProvider(ne,Le.identifier)},registerUriHandler(ne){return yt.registerUriHandler(Le.identifier,ne)},createQuickPick(){return Lt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Lt.createInputBox(Le.identifier)},get activeColorTheme(){return ln.activeColorTheme},onDidChangeActiveColorTheme(ne,ue,Ie){return ln.onDidChangeActiveColorTheme(ne,ue,Ie)},registerWebviewViewProvider(ne,ue,Ie){return bn.registerWebviewViewProvider(Le,ne,ue,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,X.checkProposedApiEnabled)(Le),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeActiveNotebookEditor(ne,ue,Ie)},get visibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Le),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookEditorSelection(ne,ue,Ie)},onDidChangeNotebookEditorVisibleRanges(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookEditorVisibleRanges(ne,ue,Ie)},showNotebookDocument(ne,ue){return(0,X.checkProposedApiEnabled)(Le),ft.showNotebookDocument(ne,ue)},registerExternalUriOpener(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),_n.registerExternalUriOpener(Le.identifier,ne,ue,Ie)},get openEditors(){return(0,X.checkProposedApiEnabled)(Le),Et.tabs},get onDidChangeOpenEditors(){return(0,X.checkProposedApiEnabled)(Le),Et.onDidChangeTabs}},dn={get rootPath(){return Oe.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),rt.getPath()},set rootPath(ne){throw A.readonly()},getWorkspaceFolder(ne){return rt.getWorkspaceFolder(ne)},get workspaceFolders(){return rt.getWorkspaceFolders()},get name(){return rt.name},set name(ne){throw A.readonly()},get workspaceFile(){return rt.workspaceFile},set workspaceFile(ne){throw A.readonly()},updateWorkspaceFolders:(ne,ue,...Ie)=>rt.updateWorkspaceFolders(Le,ne,ue||0,...Ie),onDidChangeWorkspaceFolders:function(ne,ue,Ie){return rt.onDidChangeWorkspace(ne,ue,Ie)},asRelativePath:(ne,ue)=>rt.getRelativePath(ne,ue),findFiles:(ne,ue,Ie,ct)=>rt.findFiles(U.GlobPattern.from(ne),U.GlobPattern.from(ue),Ie,Le.identifier,ct),findTextInFiles:(ne,ue,Ie,ct)=>{let H,B;return typeof ue=="object"?(H=ue,B=Ie):(H={},B=ue,ct=Ie),rt.findTextInFiles(ne,H||{},B,Le.identifier,ct)},saveAll:ne=>rt.saveAll(ne),applyEdit(ne){return Yt.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,ue,Ie,ct)=>Pt.createFileSystemWatcher(U.GlobPattern.from(ne),ue,Ie,ct),get textDocuments(){return _t.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw A.readonly()},openTextDocument(ne){let ue;const Ie=ne;if(typeof ne=="string")ue=Promise.resolve(k.URI.file(ne));else if(k.URI.isUri(ne))ue=Promise.resolve(ne);else if(!Ie||typeof Ie=="object")ue=_t.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(ct=>_t.ensureDocumentData(ct).then(H=>H.document))},onDidOpenTextDocument:(ne,ue,Ie)=>_t.onDidAddDocument(ne,ue,Ie),onDidCloseTextDocument:(ne,ue,Ie)=>_t.onDidRemoveDocument(ne,ue,Ie),onDidChangeTextDocument:(ne,ue,Ie)=>_t.onDidChangeDocument(ne,ue,Ie),onDidSaveTextDocument:(ne,ue,Ie)=>_t.onDidSaveDocument(ne,ue,Ie),onWillSaveTextDocument:(ne,ue,Ie)=>Rt.getOnWillSaveTextDocumentEvent(Le)(ne,ue,Ie),onDidChangeConfiguration:(ne,ue,Ie)=>en.onDidChangeConfiguration(ne,ue,Ie),getConfiguration(ne,ue){return ue=arguments.length===1?void 0:ue,en.getConfiguration(ne,ue,Le)},registerTextDocumentContentProvider(ne,ue){return Ot.registerTextDocumentContentProvider(ne,ue)},registerTaskProvider:(ne,ue)=>(Oe.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),ut.registerTaskProvider(Le,ne,ue)),registerFileSystemProvider(ne,ue,Ie){return gn.registerFileSystemProvider(Le.identifier,ne,ue,Ie)},get fs(){return Xe.value},registerFileSearchProvider:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),bt.registerFileSearchProvider(ne,ue)),registerTextSearchProvider:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),bt.registerTextSearchProvider(ne,ue)),registerRemoteAuthorityResolver:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),nt.registerRemoteAuthorityResolver(ne,ue)),registerResourceLabelFormatter:ne=>((0,X.checkProposedApiEnabled)(Le),vn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,ue,Ie)=>Pt.onDidCreateFile(ne,ue,Ie),onDidDeleteFiles:(ne,ue,Ie)=>Pt.onDidDeleteFile(ne,ue,Ie),onDidRenameFiles:(ne,ue,Ie)=>Pt.onDidRenameFile(ne,ue,Ie),onWillCreateFiles:(ne,ue,Ie)=>Pt.getOnWillCreateFileEvent(Le)(ne,ue,Ie),onWillDeleteFiles:(ne,ue,Ie)=>Pt.getOnWillDeleteFileEvent(Le)(ne,ue,Ie),onWillRenameFiles:(ne,ue,Ie)=>Pt.getOnWillRenameFileEvent(Le)(ne,ue,Ie),openTunnel:ne=>((0,X.checkProposedApiEnabled)(Le),Z.openTunnel(Le,ne).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,X.checkProposedApiEnabled)(Le),Z.getTunnels()},onDidChangeTunnels:(ne,ue,Ie)=>((0,X.checkProposedApiEnabled)(Le),Z.onDidChangeTunnels(ne,ue,Ie)),registerPortAttributesProvider:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),Z.registerPortsAttributesProvider(ne,ue)),registerTimelineProvider:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),Qt.registerTimelineProvider(ne,ue,Le.identifier,st.converter)),get isTrusted(){return(0,X.checkProposedApiEnabled)(Le),rt.trusted},requestWorkspaceTrust:ne=>((0,X.checkProposedApiEnabled)(Le),rt.requestWorkspaceTrust(ne)),onDidReceiveWorkspaceTrust:(ne,ue,Ie)=>rt.onDidReceiveWorkspaceTrust(ne,ue,Ie)},In={get inputBox(){return Oe.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),on.getLastInputBox(Le)},createSourceControl(ne,ue,Ie){return on.createSourceControl(Le,ne,ue,Ie)}},hn={createCommentController(ne,ue){return pn.createCommentController(Le,ne,ue)}},qt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ne,ue,Ie){return lt.onDidStartDebugSession(ne,ue,Ie)},onDidTerminateDebugSession(ne,ue,Ie){return lt.onDidTerminateDebugSession(ne,ue,Ie)},onDidChangeActiveDebugSession(ne,ue,Ie){return lt.onDidChangeActiveDebugSession(ne,ue,Ie)},onDidReceiveDebugSessionCustomEvent(ne,ue,Ie){return lt.onDidReceiveDebugSessionCustomEvent(ne,ue,Ie)},onDidChangeBreakpoints(ne,ue,Ie){return lt.onDidChangeBreakpoints(ne,ue,Ie)},registerDebugConfigurationProvider(ne,ue,Ie){return lt.registerDebugConfigurationProvider(ne,ue,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,ue){return lt.registerDebugAdapterDescriptorFactory(Le,ne,ue)},registerDebugAdapterTrackerFactory(ne,ue){return lt.registerDebugAdapterTrackerFactory(ne,ue)},startDebugging(ne,ue,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?lt.startDebugging(ne,ue,{parentSession:Ie}):lt.startDebugging(ne,ue,Ie||{})},stopDebugging(ne){return lt.stopDebugging(ne)},addBreakpoints(ne){return lt.addBreakpoints(ne)},removeBreakpoints(ne){return lt.removeBreakpoints(ne)},asDebugSourceUri(ne,ue){return lt.asDebugSourceUri(ne,ue)}},fn={registerTaskProvider:(ne,ue)=>ut.registerTaskProvider(Le,ne,ue),fetchTasks:ne=>ut.fetchTasks(ne),executeTask:ne=>ut.executeTask(Le,ne),get taskExecutions(){return ut.taskExecutions},onDidStartTask:(ne,ue,Ie)=>ut.onDidStartTask(ne,ue,Ie),onDidEndTask:(ne,ue,Ie)=>ut.onDidEndTask(ne,ue,Ie),onDidStartTaskProcess:(ne,ue,Ie)=>ut.onDidStartTaskProcess(ne,ue,Ie),onDidEndTaskProcess:(ne,ue,Ie)=>ut.onDidEndTaskProcess(ne,ue,Ie)},An={openNotebookDocument:ne=>((0,X.checkProposedApiEnabled)(Le),ft.openNotebookDocument(ne)),get onDidOpenNotebookDocument(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,X.checkProposedApiEnabled)(Le),ft.notebookDocuments.map(ne=>ne.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.registerNotebookSerializer(Le,ne,ue,Ie)},registerNotebookContentProvider:(ne,ue,Ie)=>((0,X.checkProposedApiEnabled)(Le),ft.registerNotebookContentProvider(Le,ne,ue,Ie)),registerNotebookKernelProvider:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),ft.registerNotebookKernelProvider(Le,ne,ue)),registerNotebookCellStatusBarItemProvider:(ne,ue)=>((0,X.checkProposedApiEnabled)(Le),ft.registerNotebookCellStatusBarItemProvider(Le,ne,ue)),createNotebookEditorDecorationType(ne){return(0,X.checkProposedApiEnabled)(Le),ft.createNotebookEditorDecorationType(ne)},onDidChangeNotebookDocumentMetadata(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookDocumentMetadata(ne,ue,Ie)},onDidChangeNotebookCells(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookCells(ne,ue,Ie)},onDidChangeCellExecutionState(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeNotebookCellExecutionState(ne,ue,Ie)},onDidChangeCellOutputs(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeCellOutputs(ne,ue,Ie)},onDidChangeCellMetadata(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.onDidChangeCellMetadata(ne,ue,Ie)},createConcatTextDocument(ne,ue){return(0,X.checkProposedApiEnabled)(Le),new Q.ExtHostNotebookConcatDocument(ft,_t,ne,ue)},createNotebookCellExecutionTask(ne,ue,Ie){return(0,X.checkProposedApiEnabled)(Le),ft.createNotebookCellExecution(ne,ue,Ie)},createNotebookController(ne){return(0,X.checkProposedApiEnabled)(Le),Kt.createKernel(Le,ne)}};return{version:Ne.version,authentication:yn,commands:Dn,comments:hn,debug:qt,env:cn,extensions:Cn,languages:kn,notebook:An,scm:In,tasks:fn,test:tn,window:Pn,workspace:dn,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:P.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:g.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:R.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItem:M.TestItem,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=ye}),define(me[269],ge([0,1,79,64,32,124,35,51,39,34,66,46,68,90,89,50,63,125,88,60,87,117]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b,v,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,_.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,_.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,_.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,_.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,_.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,_.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,_.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,_.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService),(0,_.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,_.registerSingleton)(s.IExtHostStorage,s.ExtHostStorage),(0,_.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,_.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,_.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,_.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,_.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry)}),define(me[91],ge([0,1,14,12,31,126]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=D;function k(C,g,m,s){const d=(0,_.mapArrayOrNot)(m,y),S=new A.TextSearchMatch(g,d,s),w=S.preview.matches;return{ranges:(0,_.mapArrayOrNot)(d,n),uri:C,preview:{text:S.preview.text,matches:(0,_.mapArrayOrNot)(w,n)}}}e.createTextSearchResult=k;function y(C){return new A.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function n(C){return new I.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(g,m){this.prefix=g,this.logService=m}appendLine(g){this.logService.debug(`${this.prefix}#search`,g)}};R=je([xe(1,P.ILogService)],R),e.OutputChannel=R}),define(me[270],ge([0,1,92,22]),function(G,e,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const I=512,D=512,k=512*8,y=512*128;class n{constructor(i){this.iconvLiteDecoder=i}static async create(i){let a;if(i!==e.UTF8)a=(await new Promise((c,o)=>{G(["iconv-lite-umd"],c,o)})).getDecoder(m(i));else{const r=new TextDecoder;a={write(c){return r.decode(c,{stream:!0})},end(){return r.decode()}}}return new n(a)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function R(t,i){var a;const r=((a=i.minBytesRequiredForDetection)!==null&&a!==void 0?a:i.guessEncoding)?k:D;return new Promise((c,o)=>{const p=(0,_.newWriteableStream)(L=>L.join("")),E=[];let f=0,h;const T=async()=>{try{const L=await l({buffer:P.VSBuffer.concat(E),bytesRead:f},i.guessEncoding);L.encoding=await i.overwriteEncoding(L.encoding),h=await n.create(L.encoding);const W=h.write(P.VSBuffer.concat(E).buffer);p.write(W),E.length=0,f=0,c({stream:p,detected:L})}catch(L){o(L)}};(0,_.listenStream)(t,{onData:async L=>{h?p.write(h.write(L.buffer)):(E.push(L),f+=L.byteLength,f>=r&&(t.pause(),await T(),setTimeout(()=>t.resume())))},onError:L=>p.error(L),onEnd:async()=>{h||await T(),p.end(h==null?void 0:h.end())}})})}e.toDecodeStream=R;async function C(t,i,a){const c=(await new Promise((E,f)=>{G(["iconv-lite-umd"],E,f)})).getEncoder(m(i),a);let o=!1,p=!1;return{read(){if(p)return null;const E=t.read();if(typeof E!="string"){if(p=!0,!o&&(a==null?void 0:a.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return P.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return P.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const f=c.end();return f&&f.length>0?(o=!0,P.VSBuffer.wrap(f)):null}return o=!0,P.VSBuffer.wrap(c.write(E))}}}e.toEncodeReadable=C;async function g(t){return(await new Promise((a,r)=>{G(["iconv-lite-umd"],a,r)})).encodingExists(m(t))}e.encodingExists=g;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function s(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const a=t.readUInt8(0),r=t.readUInt8(1);if(a===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(a===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const c=t.readUInt8(2);return a===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=s;const d=["ascii","utf-16","utf-32"];async function S(t){const i=await new Promise((p,E)=>{G(["jschardet"],p,E)}),a=t.slice(0,y),r=v(a.buffer),c=i.detect(r);if(!c||!c.encoding)return null;const o=c.encoding.toLowerCase();return 0<=d.indexOf(o)?null:b(c.encoding)}const w={ibm866:"cp866",big5:"cp950"};function b(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[i]||i}function v(t){let i="";for(let a=0;a<t.length;a++)i+=String.fromCharCode(t[a]);return i}function u(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=u;function l({buffer:t,bytesRead:i},a){let r=s(t,i),c=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let o=!0,p=!0,E=!1;for(let f=0;f<i&&f<I;f++){const h=f%2==1,T=t.readUInt8(f)===0;if(T&&(E=!0),o&&(h&&!T||!h&&T)&&(o=!1),p&&(h&&T||!h&&!T)&&(p=!1),T&&!o&&!p)break}E&&(o?r=e.UTF16le:p?r=e.UTF16be:c=!0)}return a&&!c&&!r&&t?S(t.slice(0,i)).then(o=>({seemsBinary:!1,encoding:o})):{seemsBinary:c,encoding:r}}e.detectEncodingFromBuffer=l,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[128],ge([0,1,270,26,127]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class I extends A.TextSearchManager{constructor(k,y,n=P){super(k,y,{readdir:R=>n.readdir(R.fsPath),toCanonicalName:R=>(0,_.toCanonicalName)(R)})}}e.NativeTextSearchManager=I}),define(me[271],ge([0,1,272,286,287,2,288]),function(G,e,_,P,A,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,g,m,s,d,S){const w=S.environment.useHostProxy,b=typeof w=="boolean"?w:!S.remote.isRemote,v=(0,D.createProxyResolver)({resolveProxy:l=>C.resolveProxy(l),getHttpProxySetting:()=>g.getConfiguration("http").get("proxy"),log:(l,t,...i)=>{switch(l){case D.LogLevel.Trace:s.trace(t,...i);break;case D.LogLevel.Debug:s.debug(t,...i);break;case D.LogLevel.Info:s.info(t,...i);break;case D.LogLevel.Warning:s.warn(t,...i);break;case D.LogLevel.Error:s.error(t,...i);break;case D.LogLevel.Critical:s.critical(t,...i);break;case D.LogLevel.Off:break;default:a(l,t,i);break}function a(r,c,...o){s.error("Unknown log level",r),s.error(c,...o)}},getLogLevel:()=>s.getLevel(),proxyResolveTelemetry:l=>{d.$publicLog2("resolveProxy",l)},useHostProxy:b,env:process.env}),u=y(g,v);return R(m,u)}e.connectProxyResolver=k;function y(C,g){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(d=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const s={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(d=>{s.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,D.createHttpPatch)(_,g,{config:"off"},s,!0)),on:Object.assign({},_,(0,D.createHttpPatch)(_,g,{config:"on"},s,!0)),override:Object.assign({},_,(0,D.createHttpPatch)(_,g,{config:"override"},s,!0)),onRequest:Object.assign({},_,(0,D.createHttpPatch)(_,g,m,s,!0)),default:Object.assign(_,(0,D.createHttpPatch)(_,g,m,s,!1))},https:{off:Object.assign({},P,(0,D.createHttpPatch)(P,g,{config:"off"},s,!0)),on:Object.assign({},P,(0,D.createHttpPatch)(P,g,{config:"on"},s,!0)),override:Object.assign({},P,(0,D.createHttpPatch)(P,g,{config:"override"},s,!0)),onRequest:Object.assign({},P,(0,D.createHttpPatch)(P,g,m,s,!0)),default:Object.assign(P,(0,D.createHttpPatch)(P,g,m,s,!1))},tls:Object.assign(A,(0,D.createTlsPatch)(A))}}const n=new Map;function R(C,g){return C.getExtensionPathIndex().then(m=>{const s=G.__$__nodeRequire("module"),d=s._load;s._load=function(w,b,v){if(w==="tls")return g.tls;if(w!=="http"&&w!=="https")return d.apply(this,arguments);const u=g[w],l=m.findSubstr(I.URI.file(b.filename).fsPath);let t=n.get(l);if(t||n.set(l,t={}),!t[w]){let i=u.default;l&&l.enableProposedApi&&(i=u[l.proxySupport]||u.onRequest),t[w]=Object.assign({},i)}return t[w]}})}}),define(me[273],ge([0,1,38,8,75,30,9,10,91,274]),function(G,e,_,P,A,I,D,k,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=n.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(v,u,l,t){const i=g(v,u,l,t),a=u.folder.fsPath;return{cmd:_.spawn(R,i.args,{cwd:a}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:a}}e.spawnRipgrepCmd=C;function g(v,u,l,t){const i=["--files","--hidden","--case-sensitive"];s([u],l,!1).forEach(r=>{const c=(0,y.anchorGlob)(r);if(i.push("-g",c),D.isMacintosh){const o=(0,A.normalizeNFD)(c);o!==c&&i.push("-g",o)}});const a=m([u],t,void 0,!1);return a.globArgs.forEach(r=>{const c=`!${(0,y.anchorGlob)(r)}`;if(i.push("-g",c),D.isMacintosh){const o=(0,A.normalizeNFD)(c);o!==c&&i.push("-g",o)}}),u.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),u.ignoreSymlinks||i.push("--follow"),v.exists&&i.push("--quiet"),i.push("--no-config"),u.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:a.siblingClauses}}function m(v,u,l,t=!0){const i=[];let a={};return v.forEach(r=>{const c=Object.assign({},r.excludePattern||{},u||{}),o=d(c,t?r.folder.fsPath:void 0,l);i.push(...o.globArgs),o.siblingClauses&&(a=Object.assign(a,o.siblingClauses))}),{globArgs:i,siblingClauses:a}}e.foldersToRgExcludeGlobs=m;function s(v,u,l=!0){const t=[];return v.forEach(i=>{const a=Object.assign({},u||{},i.includePattern||{}),r=d(a,l?i.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=s;function d(v,u,l){const t=[],i={};return Object.keys(v).forEach(a=>{if(!(l&&l.has(a))&&!!a){const r=v[a];a=w(u?S(u,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof r=="boolean"&&r?(a.startsWith("\\\\")&&(a+="**"),t.push(b(a))):r&&r.when&&(i[a]=r)}}),{globArgs:t,siblingClauses:i}}function S(v,u){return P.isAbsolute(u)?u:P.join(v,u)}e.getAbsoluteGlob=S;function w(v){return v=k.rtrim(v,"\\"),k.rtrim(v,"/")}function b(v){return I.getRoot(v).toLowerCase()==="c:/"?v.replace(/^c:[/\\]/i,"/"):v}e.fixDriveC=b}),define(me[275],ge([0,1,38,37,8,99,14,58,33,75,30,9,47,10,15,26,31,273,97]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const v=new Set;process.on("exit",()=>{v.forEach(a=>a())});class u{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&y.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&y.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(c=>{const o=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),p=c.folder.fsPath;r.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==p).forEach(E=>{(0,R.isEqualOrParent)(E,p)&&(o[A.relative(p,E)]=!0)}),this.folderExcludePatterns.set(p,new t(o,p))})}cancel(){this.isCanceled=!0}walk(r,c,o,p,E){if(this.fileWalkSW=g.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);c.forEach(f=>{const h=A.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,h)||this.matchFile(o,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=g.StopWatch.create(!1),this.parallel(r,(f,h)=>{this.call(this.cmdTraversal,this,f,o,p,T=>{if(T){const L=(0,k.toErrorMessage)(T);console.error(L),this.errors.push(L),h(T,void 0)}else h(null,void 0)})},(f,h)=>{this.fileWalkSW.stop();const T=f?D.coalesce(f)[0]:null;E(T,this.isLimitHit)})}parallel(r,c,o){const p=new Array(r.length),E=new Array(r.length);let f=!1,h=0;if(r.length===0)return o(null,[]);r.forEach((T,L)=>{c(T,(W,ee)=>{if(W?(f=!0,p[L]=null,E[L]=W):(p[L]=ee,E[L]=null),++h===r.length)return o(f?E:null,p)})})}call(r,c,...o){try{r.apply(c,o)}catch(p){o[o.length-1](p)}}cmdTraversal(r,c,o,p){const E=r.folder.fsPath,f=C.isMacintosh;let h;const T=()=>h&&h.kill();v.add(T);let L=U=>{v.delete(T),L=()=>{},p(U)},W="";const ee=this.initDirectoryTree();let j;const x=(0,w.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);h=x.cmd,j=!Object.keys(x.siblingClauses).length;const $=x.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let F=`${x.rgDiskPath} ${$}
 - cwd: ${x.cwd}`;x.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(x.rgArgs.siblingClauses)}`),o({message:F}),this.cmdResultCount=0,this.collectStdout(h,"utf8",o,(U,M,N)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const V=(W+(f?n.normalizeNFC(M||""):M)).split(`
`);if(N){const q=V.length;V[q-1]=V[q-1].trim(),V[q-1]||V.pop()}else W=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,j){for(const q of V)if(this.matchFile(c,{base:E,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){T();break}(N||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,ee,E,V,c),N&&(this.matchDirectoryTree(ee,E,c),L())})}spawnFindCmd(r){const c=this.folderExcludePatterns.get(r.folder.fsPath),o=c.getBasenameTerms(),p=c.getPathTerms(),E=["-L","."];if(o.length||p.length){E.push("-not","(","(");for(const f of o)E.push("-name",f),E.push("-o");for(const f of p)E.push("-path",f),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),_.spawn("find",E,{cwd:r.folder.fsPath})}readStdout(r,c,o){let p="";this.collectStdout(r,c,()=>{},(E,f,h)=>{if(E){o(E);return}p+=f,h&&o(null,p)})}collectStdout(r,c,o,p){let E=(T,L,W)=>{(T||W)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),p(T,L,W)},f=!1;r.stdout?(this.forwardData(r.stdout,c,E),r.stdout.once("data",()=>f=!0)):o({message:"stdout is null"});let h;r.stderr?h=this.collectData(r.stderr):o({message:"stderr is null"}),r.on("error",T=>{E(T)}),r.on("close",T=>{let L;!f&&(L=this.decodeData(h,c))&&i(L)?E(new Error(`command failed with error code ${T}: ${this.decodeData(h,c)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(r,c,o){const p=new I.StringDecoder(c);return r.on("data",E=>{o(null,p.write(E))}),p}collectData(r){const c=[];return r.on("data",o=>{c.push(o)}),c}decodeData(r,c){const o=new I.StringDecoder(c);return r.map(p=>o.write(p)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:c},o,p,E){p.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:o,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const f=h=>{const T=A.basename(h),L=A.dirname(h);let W=c[L];W||(W=c[L]=[],f(L)),W.push({base:o,relativePath:h,basename:T,searchPath:this.getSearchPath(r,h)})};p.forEach(f)}matchDirectoryTree({rootEntries:r,pathToEntries:c},o,p){const E=this,f=this.folderExcludePatterns.get(o),h=this.filePattern;function T(L){E.directoriesWalked++;const W=y.hasSiblingFn(()=>L.map(ee=>ee.basename));for(let ee=0,j=L.length;ee<j;ee++){const x=L[ee],{relativePath:$,basename:F}=x;if(!f.test($,F,h!==F?W:void 0)){const U=c[$];if(U)T(U);else{if(E.filesWalked++,$===h)continue;E.matchFile(p,x)}if(E.isLimitHit)break}}}T(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,c,o,p,E){const f=r.folder,h=y.hasSiblingFn(()=>o);this.parallel(o,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const W=c?[c,T].join(A.sep):T;if(this.folderExcludePatterns.get(r.folder.fsPath).test(W,T,this.config.filePattern!==T?h:void 0))return L(null);const ee=[f.fsPath,W].join(A.sep);P.lstat(ee,(j,x)=>{if(j||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ee,x,($,F)=>$||this.isCanceled||this.isLimitHit?L(null):F.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,x,(U,M)=>U||this.isCanceled||this.isLimitHit||(M=M||"",this.walkedPaths[M])?L(null):(this.walkedPaths[M]=!0,(0,d.readdir)(ee).then(N=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(r,W,N,p,O=>L(O||null))},N=>{L(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&s.isNumber(F.size)&&F.size>this.maxFilesize||this.matchFile(p,{base:f.fsPath,relativePath:W,searchPath:this.getSearchPath(r,W)}),L(null,void 0)))})},T=>{const L=T&&D.coalesce(T);return E(L&&L.length>0?L[0]:void 0)})}matchFile(r,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,A.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(c))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,c,o){return c.isSymbolicLink()?P.stat(r,o):o(null,c)}realPathIfNeeded(r,c,o){return c.isSymbolicLink()?P.realpath(r,(p,E)=>p?o(p):o(null,E)):o(null,r)}getSearchPath(r,c){return r.folderName?A.join(r.folderName,c):c}}e.FileWalker=u;class l{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new u(r)}search(r,c,o){this.walker.walk(this.folderQueries,this.extraFiles,r,c,(p,E)=>{o(p,{limitHit:E,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=l;class t{constructor(r,c){this.expression=r,this.root=c,this.init(r)}init(r){let c,o;Object.keys(r).filter(p=>r[p]).forEach(p=>{A.isAbsolute(p)?(c=c||y.getEmptyExpression(),c[p]=r[p]):(o=o||y.getEmptyExpression(),o[p]=r[p])}),this.absoluteParsedExpr=c&&y.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=o&&y.parse(o,{trimForExclusions:!0})}test(r,c,o){return this.relativeParsedExpr&&this.relativeParsedExpr(r,c,o)||this.absoluteParsedExpr&&this.absoluteParsedExpr(A.join(this.root,r),c,o)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...y.getPathTerms(this.relativeParsedExpr)),r}}function i(a){const r=a.trim().split(`
`),c=r[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return m.uppercaseFirstLetter(r[r.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}e.rgErrorMsgForDisplay=i}),define(me[129],ge([0,1,38,289,99,14,53,33,8,10,2,31,126,290,274,91]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=s.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(f){this.outputChannel=f}provideTextSearchResults(f,h,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify(Object.assign(Object.assign({},h),{folder:h.folder.toString()}))}`),new Promise((W,ee)=>{L.onCancellationRequested(()=>O());const j=i(f,h),x=h.folder.fsPath,$=j.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${S} ${$}
 - cwd: ${x}`);let F=_.spawn(S,j,{cwd:x});F.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ee((0,C.serializeSearchError)(new C.SearchError(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let U=!1;const M=new u(h.maxResults,x,h.previewOptions);M.on("result",ve=>{U=!0,q="",T.report(ve)});let N=!1;const O=()=>{N=!0,F&&F.kill(),M&&M.cancel()};let V=!1;M.on("hitLimit",()=>{V=!0,O()});let q="";F.stdout.on("data",ve=>{M.handleData(ve),U||(q+=ve)});let X=!1;F.stdout.once("data",()=>X=!0);let fe="";F.stderr.on("data",ve=>{const Ae=ve.toString();this.outputChannel.appendLine(Ae),fe+=Ae}),F.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),N)W({limitHit:V});else{M.flush(),F=null;let ve;fe&&!X&&(ve=b(fe))?ee((0,C.serializeSearchError)(new C.SearchError(ve.message,ve.code))):W({limitHit:V})}})})}}e.RipgrepTextSearchEngine=w;function b(E){const f=E.split(`
`),h=f[0].trim();if(f.some(L=>L.startsWith("regex parse error")))return new C.SearchError(v(f),C.SearchErrorCode.regexParseError);const T=h.match(/grep config error: unknown encoding: (.*)/);if(T)return new C.SearchError(`Unknown encoding: ${T[1]}`,C.SearchErrorCode.unknownEncoding);if(h.startsWith("error parsing glob"))return new C.SearchError(h.charAt(0).toUpperCase()+h.substr(1),C.SearchErrorCode.globParseError);if(h.startsWith("the literal"))return new C.SearchError(h.charAt(0).toUpperCase()+h.substr(1),C.SearchErrorCode.invalidLiteral);if(h.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(h,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function v(E){const f=["Regex parse error"],h=E.filter(T=>T.startsWith("PCRE2:"));if(h.length>=1){const T=h[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];f.push(":"+L)}}return f.join("")}e.buildRegexParseError=v;class u extends P.EventEmitter{constructor(f,h,T){super();this.maxResults=f,this.rootFolder=h,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new A.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,h){return super.on(f,h),this}handleData(f){if(!this.isDone){const h=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(h)}}handleDecodedData(f){let h=f.indexOf(`
`);const T=this.remainder+f;if(h>=0)h+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;h>=0;)this.handleLine(T.substring(L,h).trim()),L=h+1,h=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(f){if(!(this.isDone||!f)){let h;try{h=JSON.parse(f)}catch(T){throw new Error(`malformed line from rg: ${f}`)}if(h.type==="match"){const T=l(h.data.path),L=R.URI.file(y.join(this.rootFolder,T)),W=this.createTextSearchMatch(h.data,L);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(h.type==="context"){const T=l(h.data.path),L=R.URI.file(y.join(this.rootFolder,T));this.createTextSearchContext(h.data,L).forEach(ee=>this.onResult(ee))}}}createTextSearchMatch(f,h){const T=f.line_number-1;let L=!1,W=l(f.lines);T===0&&(0,n.startsWithUTF8BOM)(W)&&(L=!0,W=(0,n.stripUTF8BOM)(W));const ee=Buffer.from(W);let j=0,x=0,$=T;f.submatches.length===0&&f.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const F=(0,I.coalesce)(f.submatches.map((U,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let N=l(U.match);T===0&&M===0&&L&&(N=(0,n.stripUTF8BOM)(N),U.start=U.start<=3?0:U.start-3,U.end=U.end<=3?0:U.end-3);const O=ee.slice(j,U.start).toString().length,V=x+O,q=t(N),X=$,fe=q.numLines+X,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return j=U.end,x=ve,$=fe,new g.Range(X,V,fe,ve)}));return(0,d.createTextSearchResult)(h,W,F,this.previewOptions)}createTextSearchContext(f,h){const T=l(f.lines),L=f.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((W,ee)=>({text:W,uri:h,lineNumber:L+ee}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=u;function l(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const f=/\n/g;let h=0,T=-1,L;for(;L=f.exec(E);)h++,T=L.index;const W=T>=0?E.length-T-1:E.length;return{numLines:h,lastLineLength:W}}function i(E,f){const h=["--hidden"];h.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=(0,D.groupBy)(f.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ee=new Set;L.forEach(j=>{ee.add(j)}),h.push("-g","!*"),ee.forEach(j=>{a(j).map(d.anchorGlob).forEach(x=>{h.push("-g",x)})})}T&&T.length&&T.forEach(ee=>{h.push("-g",ee)}),f.excludes.map(d.anchorGlob).forEach(ee=>h.push("-g",`!${ee}`)),f.maxFileSize&&h.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?h.push("--no-ignore-parent"):h.push("--no-ignore"),f.followSymlinks&&h.push("--follow"),f.encoding&&f.encoding!=="utf8"&&h.push("--encoding",f.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,n.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),f.usePCRE2&&h.push("--pcre2"),h.push("--crlf"),E.isRegExp&&(E.pattern=r(E.pattern),h.push("--auto-hybrid-regex"));let W;if(E.isWordMatch){const j=(0,n.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");h.push("--regexp",j)}else if(E.isRegExp){let ee=o(E.pattern);ee=p(ee),h.push("--regexp",ee)}else W=E.pattern,h.push("--fixed-strings");return h.push("--no-config"),f.useGlobalIgnoreFiles||h.push("--no-ignore-global"),h.push("--json"),E.isMultiline&&h.push("--multiline"),f.beforeContext&&h.push("--before-context",f.beforeContext+""),f.afterContext&&h.push("--after-context",f.afterContext+""),h.push("--"),W&&h.push(W),h.push("."),h}function a(E){const f=(0,k.splitGlobAware)(E,"/");return f.map((h,T)=>f.slice(0,T+1).join("/"))}e.spreadGlobComponents=a;function r(E){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(f);)E=E.replace(f,"$1\\x{$2}");const h=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(h);)E=E.replace(h,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=r;const c=E=>E.type==="Assertion"&&E.kind==="lookbehind";function o(E){let f;try{f=new m.RegExpParser().parsePattern(E)}catch(j){return E}let h="",T=0;const L=(j,x,$)=>{h+=E.slice(T,j)+$,T=x},W=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const x=W[0];if(!x)L(j.start,j.end,"\\r?\\n");else if(!W.some(c))if(x.type==="CharacterClass"){const $=E.slice(x.start+1,j.start)+E.slice(j.end,x.end-1);L(x.start,x.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else x.type==="Quantifier"&&L(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){W.unshift(j)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(j){W.unshift(j)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(j){W.unshift(j)},onCharacterClassLeave(){W.shift()},onAssertionEnter(j){c(j)&&W.push(j)},onAssertionLeave(j){W[0]===j&&W.shift()}}).visit(f),h+=E.slice(T),h}e.fixRegexNewline=o;function p(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(me[276],ge([0,1,21,129,112,11]),function(G,e,_,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(n){this.outputChannel=n,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(n,R,C,g){const m=new P.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===I.Schemas.userData){const s=Object.assign(Object.assign({},R),{folder:R.folder.with({scheme:I.Schemas.file})}),d=new A.Progress(S=>C.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:R.folder.scheme})})));return this.withToken(g,S=>m.provideTextSearchResults(n,s,d,S))}else return this.withToken(g,s=>m.provideTextSearchResults(n,R,C,s))}async withToken(n,R){const C=k(n);this.inProgress.add(C);const g=await R(C.token);return this.inProgress.delete(C),g}dispose(){this.inProgress.forEach(n=>n.cancel())}}e.RipgrepSearchProvider=D;function k(y){const n=new _.CancellationTokenSource;return y.onCancellationRequested(()=>n.cancel()),n}}),define(me[277],ge([0,1,26,129,128]),function(G,e,_,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class I{constructor(y){this.query=y}search(y,n,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){R({message:m})}},g=new A.NativeTextSearchManager(this.query,new P.RipgrepTextSearchEngine(C),_);return new Promise((m,s)=>g.search(d=>{n(d.map(D))},y).then(d=>m({limitHit:d.limitHit,type:"success"}),s))}}e.TextSearchEngineAdapter=I;function D(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((y,n)=>{if(n.ranges){const R=n;return y+(Array.isArray(R.ranges)?R.ranges.length:1)}else return y+1},0)}}}),define(me[278],ge([0,1,37,291,14,19,18,3,97,8,47,2,45,31,275,277]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,P.gracefulify(_);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const a=v(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{i=(0,I.createCancelablePromise)(c=>this.doFileSearchWithEngine(s.Engine,a,o=>r.fire(o),c)),i.then(c=>r.fire(c),c=>r.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}textSearch(t){let i;const a=v(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{i=(0,I.createCancelablePromise)(c=>this.ripgrepTextSearch(a,o=>r.fire(o),c)),i.then(c=>r.fire(c),c=>r.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return r.event}ripgrepTextSearch(t,i,a){return t.maxFileSize=(0,g.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(a,i,i)}doFileSearch(t,i,a){return this.doFileSearchWithEngine(s.Engine,t,i,a)}doFileSearchWithEngine(t,i,a,r,c=S.BATCH_SIZE){let o=0;const p=f=>{Array.isArray(f)?(o+=f.length,a(f.map(h=>this.rawMatchToSearchItem(h)))):f.relativePath?(o++,a(this.rawMatchToSearchItem(f))):a(f)};if(i.sortByScore){let f=this.trySortedSearchFromCache(i,p,r);if(!f){const h=i.maxResults?Object.assign({},i,{maxResults:null}):i,T=new t(h);f=this.doSortedSearch(T,i,a,p,r)}return new Promise((h,T)=>{f.then(([L,W])=>{const ee=W.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(ee,a,c),h(L)},T)})}const E=new t(i);return this.doSearch(E,p,c,r).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:"searchProcess",fromCache:!1,resultCount:o,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,n.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,a,r,c){const o=new k.Emitter;let p=(0,I.createCancelablePromise)(f=>{let h=[];const T=L=>{Array.isArray(L)?h=L:(r(L),o.fire(L))};return this.doSearch(t,T,-1,f).then(L=>[L,h])}),E;if(i.cacheKey){E=this.getOrCreateCache(i.cacheKey);const f={promise:p,event:o.event,resolved:!1};E.resultsToSearchCache[i.filePattern||""]=f,p.then(()=>{f.resolved=!0},h=>{delete E.resultsToSearchCache[i.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([f,h])=>{const T=E?E.scorerCache:Object.create(null),L=(typeof i.maxResults!="number"||i.maxResults>0)&&R.StopWatch.create(!1);return this.sortResults(i,h,T,c).then(W=>{const ee=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:W.length},limitHit:f.limitHit||typeof i.maxResults=="number"&&h.length>i.maxResults},W]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new w)}trySortedSearchFromCache(t,i,a){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const c=this.getResultsFromCache(r,t.filePattern||"",i,a);if(c)return c.then(([o,p,E])=>{const f=R.StopWatch.create(!1);return this.sortResults(t,p,r.scorerCache,a).then(h=>{const T=f.elapsed(),L={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:p.length,sortingTime:T};return[{type:"success",limitHit:o.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:L},h]})})}}sortResults(t,i,a,r){const c=(0,y.prepareQuery)(t.filePattern||""),o=(E,f)=>(0,y.compareItemsByFuzzyScore)(E,f,c,!0,b,a),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return A.topAsync(i,o,p,1e4,r)}sendProgress(t,i,a){if(a&&a>0)for(let r=0;r<t.length;r+=a)i(t.slice(r,r+a));else i(t)}getResultsFromCache(t,i,a,r){const c=R.StopWatch.create(!1),o=i.indexOf(n.sep)>=0;let p;for(const T in t.resultsToSearchCache)if(i.startsWith(T)){if(o&&T.indexOf(n.sep)<0&&T!=="")continue;const L=t.resultsToSearchCache[T];p={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!p)return null;const E=c.elapsed(),f=R.StopWatch.create(!1),h=p.event(a);return r&&r.onCancellationRequested(()=>{h.dispose()}),p.promise.then(([T,L])=>{if(r&&r.isCancellationRequested)throw(0,D.canceled)();const W=[],ee=(0,y.prepareQuery)(i).normalizedLowercase;for(const j of L)!(0,m.isFilePatternMatch)(j,ee)||W.push(j);return[T,W,{cacheWasResolved:p.resolved,cacheLookupTime:E,cacheFilterTime:f.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,i,a,r){return new Promise((c,o)=>{let p=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(a?(p.push(E),a>0&&p.length>=a&&(i(p),p=[])):i(E))},E=>{i(E)},(E,f)=>{p.length&&i(p),E?o(E):c(f)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,a){return t.then(i,a)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(l){return(0,n.basename)(l.relativePath)}getItemDescription(l){return(0,n.dirname)(l.relativePath)}getItemPath(l){return l.relativePath}};function v(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(u),extraFileResources:l.extraFileResources&&l.extraFileResources.map(t=>C.URI.revive(t))})}function u(l){return Object.assign(Object.assign({},l),{folder:C.URI.revive(l.folder)})}}),define(me[279],ge([0,1,6,2,26,12,31,278,276,91,13,61,27,68,11,128]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends m.ExtHostSearch{constructor(b,v,u,l){super(b,u,l);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new n.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(s.Schemas.userData,new y.RipgrepSearchProvider(t)),v.remote.isRemote&&v.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const b=new n.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(s.Schemas.file,new y.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(s.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(b,v){const u=this._handlePool++;return this._internalFileSearchProvider=v,this._internalFileSearchHandle=u,this._proxy.$registerFileSearchProvider(u,this._transformScheme(b)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(b,v,u,l){const t=(0,m.reviveQuery)(u);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,v,t,l):super.$provideFileSearchResults(b,v,u,l)}doInternalFileSearch(b,v,u,l){const t=i=>{if((0,D.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(b,v,i.map(a=>P.URI.file(a.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(u,t,l)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,v){return new d.NativeTextSearchManager(b,v)}};S=je([xe(0,R.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,C.IURITransformerService),xe(3,I.ILogService)],S),e.NativeExtHostSearch=S}),define(me[130],ge([0,1,292,120,293,3,102,8,48,28,6,22,103,18,9]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(p){this.socket=p,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const E=f=>p(C.VSBuffer.wrap(f));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}}end(){this.socket.end()}drain(){return new Promise((p,E)=>{if(this.socket.bufferSize===0){p();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),p()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=d;var S;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(w||(w={}));class b extends R.Disposable{constructor(p,E,f,h){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=h,E?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,m.onUnexpectedError)(T),this._onClose.fire()}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),f&&(this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,m.onUnexpectedError)(T),this._onClose.fire()}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new g.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(C.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,E){let f=2;p.byteLength<126?f+=0:p.byteLength<2**16?f+=2:f+=8;const h=C.VSBuffer.alloc(f);if(E?h.writeUInt8(194,0):h.writeUInt8(130,0),p.byteLength<126)h.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){h.writeUInt8(126,1);let T=1;h.writeUInt8(p.byteLength>>>8&255,++T),h.writeUInt8(p.byteLength>>>0&255,++T)}else{h.writeUInt8(127,1);let T=1;h.writeUInt8(0,++T),h.writeUInt8(0,++T),h.writeUInt8(0,++T),h.writeUInt8(0,++T),h.writeUInt8(p.byteLength>>>24&255,++T),h.writeUInt8(p.byteLength>>>16&255,++T),h.writeUInt8(p.byteLength>>>8&255,++T),h.writeUInt8(p.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=h.byteLength+p.byteLength,this.socket.write(C.VSBuffer.concat([h,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),h=(E.readUInt8(0)&128)>>>7,T=E.readUInt8(1),L=(T&128)>>>7,W=T&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=h,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),f=E.readUInt8(1),h=(f&128)>>>7;let T=f&127,L=1;T===126?T=E.readUInt8(++L)*2**8+E.readUInt8(++L):T===127&&(T=E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*2**24+E.readUInt8(++L)*2**16+E.readUInt8(++L)*2**8+E.readUInt8(++L));let W=0;h&&(W=E.readUInt8(++L)*2**24+E.readUInt8(++L)*2**16+E.readUInt8(++L)*2**8+E.readUInt8(++L)),this._state.state=3,this._state.readLen=T,this._state.mask=W}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);v(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const f=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=f.length,this._onData.fire(C.VSBuffer.wrap(f))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function v(o,p){if(p!==0){let E=o.byteLength>>>2;for(let ee=0;ee<E;ee++){const j=o.readUInt32BE(ee*4);o.writeUInt32BE(j^p,ee*4)}let f=E*4,h=o.byteLength-f;const T=p>>>24&255,L=p>>>16&255,W=p>>>8&255;h>=1&&o.writeUInt8(o.readUInt8(f)^T,f),h>=2&&o.writeUInt8(o.readUInt8(f+1)^L,f+1),h>=3&&o.writeUInt8(o.readUInt8(f+2)^W,f+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function l(){const o=(0,n.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):p=(0,k.join)((0,y.tmpdir)(),`vscode-ipc-${o}.sock`),i(p),p}e.createRandomIPCHandle=l;function t(o,p,E){const f=(0,_.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${E}-${p}-sock`;let h;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?h=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${E}-${p}.sock`):h=(0,k.join)(o,`${E}-${p}.sock`),i(h),h}e.createStaticIPCHandle=t;function i(o){const p=u[s.platform];typeof p=="number"&&o.length>=p&&console.warn(`WARNING: IPC handle "${o}" is longer than ${p} chars, try a shorter --user-data-dir`)}class a extends D.IPCServer{constructor(p){super(a.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const E=I.Event.fromNodeEventEmitter(p,"connection");return I.Event.map(E,f=>({protocol:new g.Protocol(new d(f)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=a;function r(o){return new Promise((p,E)=>{const f=(0,P.createServer)();f.on("error",E),f.listen(o,()=>{f.removeListener("error",E),p(new a(f))})})}e.serve=r;function c(o,p){return new Promise((E,f)=>{const h=(0,P.createConnection)(o,()=>{h.removeListener("error",f),E(g.Client.fromSocket(new d(h),p))});h.once("error",f)})}e.connect=c}),define(me[280],ge([0,1,130,272,37,51,2,116,12]),function(G,e,_,P,A,I,D,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class n{constructor(g,m,s){this._commands=g,this.logService=m,this._ipcHandlePath=s,this._server=P.createServer((d,S)=>this.onRequest(d,S)),this.setup().catch(d=>(m.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch(g){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,m){const s=[];g.setEncoding("utf8"),g.on("data",d=>s.push(d)),g.on("end",()=>{const d=JSON.parse(s.join(""));switch(d.type){case"open":this.open(d,m);break;case"openExternal":this.openExternal(d,m);break;case"status":this.getStatus(d,m);break;case"extensionManagement":this.manageExtensions(d,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${d.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(g,m){let{fileURIs:s,folderURIs:d,forceNewWindow:S,diffMode:w,addMode:b,forceReuseWindow:v,gotoLineMode:u,waitMarkerFilePath:l}=g;const t=[];if(Array.isArray(d))for(const i of d)try{t.push({folderUri:D.URI.parse(i)})}catch(a){}if(Array.isArray(s))for(const i of s)try{(0,k.hasWorkspaceFileExtension)(i)?t.push({workspaceUri:D.URI.parse(i)}):t.push({fileUri:D.URI.parse(i)})}catch(a){}if(t.length){const i=l?D.URI.file(l):void 0,r={forceNewWindow:S,diffMode:w,addMode:b,gotoLineMode:u,forceReuseWindow:v,preferNewWindow:!v&&!i&&!b,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}m.writeHead(200),m.end()}async openExternal(g,m){for(const s of g.uris){const d=D.URI.parse(s),S=d.scheme==="file"?d:s;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(g,m){try{const s=w=>w==null?void 0:w.map(b=>/\.vsix$/i.test(b)?D.URI.parse(b):b),d={list:g.list,install:s(g.install),uninstall:s(g.uninstall),force:g.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);m.writeHead(200),m.write(S)}catch(s){m.writeHead(500),m.write(String(s),d=>{d&&this.logService.error(d)})}m.end()}async getStatus(g,m){try{const s=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(s),m.end()}catch(s){m.writeHead(500),m.write(String(s),d=>{d&&this.logService.error(d)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&A.existsSync(this._ipcHandlePath)&&A.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=n;let R=class extends n{constructor(g,m){super(g,m,(0,_.createRandomIPCHandle)())}};R=je([xe(0,I.IExtHostCommands),xe(1,y.ILogService)],R),e.CLIServer=R}),define(me[281],ge([0,1,67,268,262,5,271,42,253,2,11,7,280,100]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class s extends A.RequireInterceptor{_installInterceptor(){const w=this,b=G.__$__nodeRequire("module"),v=b._load;b._load=function(l,t,i){for(let a of w._alternatives){let r=a(l);if(r){l=r;break}}return w._factories.has(l)?w._factories.get(l).load(l,n.URI.file((0,m.realpathSync)(t.filename)),a=>v.apply(this,[a,t,i])):v.apply(this,arguments)}}}class d extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(P.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(g.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(s,w,this._registry).install(),_.mark("code/extHost/didInitAPI");const v=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,v,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const u=process.send,l=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?u.apply(process,t):(l.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,b,v){if(b.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let u=null;v.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{w&&_.mark(`code/extHost/willLoadExtensionCode/${w.value}`),u=G.__$__nodeRequire(b.fsPath)}catch(l){return Promise.reject(l)}finally{w&&_.mark(`code/extHost/didLoadExtensionCode/${w.value}`),v.codeLoadingStop()}return Promise.resolve(u)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const b in w){const v=w[b];v===null?delete process.env[b]:process.env[b]=v}}}e.ExtHostExtensionService=d}),define(me[282],ge([0,1,79,254,265,264,263,279,281,225,255,46,42,64,68,66,34,50,12]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d,S,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(g.IExtHostExtensionService,y.ExtHostExtensionService),(0,_.registerSingleton)(b.ILogService,n.ExtHostLogService),(0,_.registerSingleton)(C.IExtHostDebugService,D.ExtHostDebugService),(0,_.registerSingleton)(m.IExtHostOutputService,P.ExtHostOutputService2),(0,_.registerSingleton)(s.IExtHostSearch,k.NativeExtHostSearch),(0,_.registerSingleton)(d.IExtHostTask,I.ExtHostTask),(0,_.registerSingleton)(S.IExtHostTerminalService,A.ExtHostTerminalService),(0,_.registerSingleton)(w.IExtHostTunnelService,R.ExtHostTunnelService)}),define(me[283],ge([0,1,120,294,67,18,103,130,186,223,266,22,98,26,100,19,269,282]),function(G,e,_,P,A,I,D,k,y,n,R,C,g,m,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=P(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const a=G.__$__nodeRequire("module"),r=a._load;a._load=function(c){if(c==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function b(a){process.exit=function(r){if(a)w(r);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let v=function(a){w()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((a,r)=>{let c=null,o=setTimeout(()=>{r(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const p=108e5,E=3e5,f=new d.RunOnceScheduler(()=>v("renderer disconnected for too long (1)"),p),h=new d.RunOnceScheduler(()=>v("renderer disconnected for too long (2)"),E);process.on("message",(L,W)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let j;if(L.skipWebSocketFrames)j=new k.NodeSocket(W);else{const x=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));j=new k.WebSocketNodeSocket(new k.NodeSocket(W),L.permessageDeflate,x,!1)}c?(f.cancel(),h.cancel(),c.beginAcceptReconnection(j,ee),c.endAcceptReconnection()):(clearTimeout(o),c=new D.PersistentProtocol(j,ee),c.onDidDispose(()=>v("renderer disconnected")),a(c),c.onSocketClose(()=>{f.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(h.isScheduled())return;f.isScheduled()&&h.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const a=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,c)=>{const o=_.createConnection(a,()=>{o.removeListener("error",c),r(new D.PersistentProtocol(new k.NodeSocket(o)))});o.once("error",c)})}}async function l(){const a=await u();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,a.onMessage(r=>{(0,n.isMessageOfType)(r,2)?(this._terminating=!0,v("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||a.send(r)}drain(){return a.drain()}}}function t(a){return new Promise(r=>{const c=a.onMessage(o=>{c.dispose();const p=JSON.parse(o.toString()),E=p.commit,f=y.default.commit;E&&f&&E!==f&&w(55);const h=[];process.on("unhandledRejection",(W,ee)=>{h.push(ee),setTimeout(()=>{const j=h.indexOf(ee);j>=0&&ee.catch(x=>{h.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),(0,I.onUnexpectedError)(W)})},1e3)}),process.on("rejectionHandled",W=>{const ee=h.indexOf(W);ee>=0&&h.splice(ee,1)}),process.on("uncaughtException",function(W){(0,I.onUnexpectedError)(W)});let T=0;setInterval(function(){try{process.kill(p.parentPid,0),T=0}catch(W){W&&W.code==="EPERM"?(T++,T>=3&&v(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):v(`parent process ${p.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let L;try{L=G.__$__nodeRequire("native-watchdog"),L.start(p.parentPid)}catch(W){(0,I.onUnexpectedError)(W)}a.send((0,n.createMessageOfType)(0)),r({protocol:a,initData:p})});a.send((0,n.createMessageOfType)(1))})}async function i(){A.mark("code/extHost/willConnectToRenderer");const a=await l();A.mark("code/extHost/didConnectToRenderer");const r=await t(a);A.mark("code/extHost/didWaitForInitData");const{initData:c}=r;b(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const o=new class{exit(h){w(h)}exists(h){return(0,m.exists)(h)}realpath(h){return(0,s.realpath)(h)}};let p=null;if(c.remote.authority&&S.uriTransformerPath)try{const h=G.__$__nodeRequire(S.uriTransformerPath)(c.remote.authority);p=new g.URITransformer(h)}catch(f){console.error(f)}const E=new R.ExtensionHostMain(r.protocol,c,o,p);v=f=>E.terminate(f)}e.startExtensionHostProcess=i}),define(me[295],ge([0,1,283]),function(G,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(P=>console.log(P))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ce791d27dc9889a392f4d29abefe9c53eb0b5129/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
