/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/shared/webview","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],E=0,C=ee.length;E<C;E++)e[E]=ve[ee[E]];return e};define(ve[42],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(C,P){if(!C)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=E}),define(ve[51],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function C(T){const k=[];for(let h in T)E.call(T,h)&&k.push(T[h]);return k}e.values=C;function P(T,k){for(let h in T)if(E.call(T,h)&&k({key:h,value:T[h]},function(){delete T[h]})===!1)return}e.forEach=P;function A(T,k){const h=Object.create(null);for(const f of T){const r=k(f);let s=h[r];s||(s=h[r]=[]),s.push(f)}return h}e.groupBy=A;function S(T){const k=Object.create(null);return T&&T.forEach((h,f)=>{k[f]=h}),k}e.fromMap=S;function D(T,k){const h=[],f=[];for(let r of T)k.has(r)||h.push(r);for(let r of k)T.has(r)||f.push(r);return{removed:h,added:f}}e.diffSets=D;function y(T,k){const h=[],f=[];for(let[r,s]of T)k.has(r)||h.push(s);for(let[r,s]of k)T.has(r)||f.push(s);return{removed:h,added:f}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(k,h){let f=this.map.get(k);f||(f=new Set,this.map.set(k,f)),f.add(h)}delete(k,h){const f=this.map.get(k);!f||(f.delete(h),f.size===0&&this.map.delete(k))}forEach(k,h){const f=this.map.get(k);!f||f.forEach(h)}}e.SetMap=n}),define(ve[52],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,T,k)=>{let h=null,f=null;if(typeof k.value=="function"?(h="value",f=k.value):typeof k.get=="function"&&(h="get",f=k.get),!f)throw new Error("not supported");k[h]=y(f,T)}}e.createDecorator=E;let C=0;function P(){const y=`$memoize${C++}`;let n;const T=function(h,f,r){let s=null,_=null;if(typeof r.value=="function"?(s="value",_=r.value,_.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(s="get",_=r.get),!_)throw new Error("not supported");const m=`${y}:${f}`;r[s]=function(...b){return n=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:_.apply(this,b)}),this[m]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(y)===0&&delete n[k]})},T}e.createMemoizer=P;function A(y,n,T){return P()(y,n,T)}e.memoize=A;function S(y,n,T){return E((k,h)=>{const f=`$debounce$${h}`,r=`$debounce$result$${h}`;return function(...s){this[r]||(this[r]=T?T():void 0),clearTimeout(this[f]),n&&(this[r]=n(this[r],...s),s=[this[r]]),this[f]=setTimeout(()=>{k.apply(this,s),this[r]=T?T():void 0},y)}})}e.debounce=S;function D(y,n,T){return E((k,h)=>{const f=`$throttle$timer$${h}`,r=`$throttle$result$${h}`,s=`$throttle$lastRun$${h}`,_=`$throttle$pending$${h}`;return function(...m){if(this[r]||(this[r]=T?T():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),n&&(this[r]=n(this[r],...m)),!this[_]){const b=this[s]+y;b<=Date.now()?(this[s]=Date.now(),k.apply(this,[this[r]]),this[r]=T?T():void 0):(this[_]=!0,this[f]=setTimeout(()=>{this[_]=!1,this[s]=Date.now(),k.apply(this,[this[r]]),this[r]=T?T():void 0},b-Date.now()))}}})}e.throttle=D}),define(ve[10],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function C(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=C;function P(u){y(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=P;function A(u){y(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=A;function S(u){if(u instanceof Error){let{name:t,message:i}=u;const c=u.stacktrace||u.stack;return{$isError:!0,name:t,message:i,stack:c}}return u}e.transformErrorForSerialization=S;const D="Canceled";function y(u){return u instanceof Error&&u.name===D&&u.message===D}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=n;function T(){const u=new Error(D);return u.name=u.message,u}e.canceled=T;function k(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=k;function h(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=h;function f(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function r(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function s(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=s;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function v(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function d(u,t=Object.create(null)){const i=new Error(u);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=d}),define(ve[11],_e([0,1,10]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function C(M,N=0){return M[M.length-(1+N)]}e.tail=C;function P(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=P;function A(M,N,W=(Q,x)=>Q===x){if(M===N)return!0;if(!M||!N||M.length!==N.length)return!1;for(let Q=0,x=M.length;Q<x;Q++)if(!W(M[Q],N[Q]))return!1;return!0}e.equals=A;function S(M,N,W){let Q=0,x=M.length-1;for(;Q<=x;){const Z=(Q+x)/2|0,re=W(M[Z],N);if(re<0)Q=Z+1;else if(re>0)x=Z-1;else return Z}return-(Q+1)}e.binarySearch=S;function D(M,N){let W=0,Q=M.length;if(Q===0)return 0;for(;W<Q;){const x=Math.floor((W+Q)/2);N(M[x])?Q=x:W=x+1}return W}e.findFirstInSorted=D;function y(M,N,W){if(M=M|0,M>=N.length)throw new TypeError("invalid index");let Q=N[Math.floor(N.length*Math.random())],x=[],Z=[],re=[];for(let oe of N){const ye=W(oe,Q);ye<0?x.push(oe):ye>0?Z.push(oe):re.push(oe)}return M<x.length?y(M,x,W):M<x.length+re.length?re[0]:y(M-(x.length+re.length),Z,W)}e.quickSelect=y;function n(M,N){const W=[];let Q;for(const x of M.slice(0).sort(N))!Q||N(Q[0],x)!==0?(Q=[x],W.push(Q)):Q.push(x);return W}e.groupBy=n;function T(M,N,W){const Q=[];function x(oe,ye,Pe){if(!(ye===0&&Pe.length===0)){const Be=Q[Q.length-1];Be&&Be.start+Be.deleteCount===oe?(Be.deleteCount+=ye,Be.toInsert.push(...Pe)):Q.push({start:oe,deleteCount:ye,toInsert:Pe})}}let Z=0,re=0;for(;;){if(Z===M.length){x(Z,0,N.slice(re));break}if(re===N.length){x(Z,M.length-Z,[]);break}const oe=M[Z],ye=N[re],Pe=W(oe,ye);Pe===0?(Z+=1,re+=1):Pe<0?(x(Z,1,[]),Z+=1):Pe>0&&(x(Z,0,[ye]),re+=1)}return Q}e.sortedDiff=T;function k(M,N,W){const Q=T(M,N,W),x=[],Z=[];for(const re of Q)x.push(...M.slice(re.start,re.start+re.deleteCount)),Z.push(...re.toInsert);return{removed:x,added:Z}}e.delta=k;function h(M,N,W){if(W===0)return[];const Q=M.slice(0,W).sort(N);return r(M,N,Q,W,M.length),Q}e.top=h;function f(M,N,W,Q,x){return W===0?Promise.resolve([]):new Promise((Z,re)=>{(async()=>{const oe=M.length,ye=M.slice(0,W).sort(N);for(let Pe=W,Be=Math.min(W+Q,oe);Pe<oe;Pe=Be,Be=Math.min(Be+Q,oe)){if(Pe>W&&await new Promise(Re=>setTimeout(Re)),x&&x.isCancellationRequested)throw(0,E.canceled)();r(M,N,ye,Pe,Be)}return ye})().then(Z,re)})}e.topAsync=f;function r(M,N,W,Q,x){for(const Z=W.length;Q<x;Q++){const re=M[Q];if(N(re,W[Z-1])<0){W.pop();const oe=D(W,ye=>N(re,ye)<0);W.splice(oe,0,re)}}}function s(M){return M.filter(N=>!!N)}e.coalesce=s;function _(M){let N=0;for(let W=0;W<M.length;W++)M[W]&&(M[N]=M[W],N+=1);M.length=N}e.coalesceInPlace=_;function m(M,N,W){M.splice(W,0,M.splice(N,1)[0])}e.move=m;function b(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=b;function v(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=v;function d(M,N){if(!N)return M.filter((Q,x)=>M.indexOf(Q)===x);const W=Object.create(null);return M.filter(Q=>{const x=N(Q);return W[x]?!1:(W[x]=!0,!0)})}e.distinct=d;function u(M){const N=new Set;return M.filter(W=>N.has(W)?!1:(N.add(W),!0))}e.distinctES6=u;function t(M){const N=Object.create(null);return W=>{const Q=M(W);return N[Q]?!1:(N[Q]=!0,!0)}}e.uniqueFilter=t;function i(M,N){for(let W=M.length-1;W>=0;W--){const Q=M[W];if(N(Q))return W}return-1}e.lastIndex=i;function c(M,N){return M.length>0?M[0]:N}e.firstOrDefault=c;function a(M,N,W=(Q,x)=>Q===x){let Q=0;for(let x=0,Z=Math.min(M.length,N.length);x<Z&&W(M[x],N[x]);x++)Q++;return Q}e.commonPrefixLength=a;function l(M){return[].concat(...M)}e.flatten=l;function o(M,N){let W=typeof N=="number"?M:0;typeof N=="number"?W=M:(W=0,N=M);const Q=[];if(W<=N)for(let x=W;x<N;x++)Q.push(x);else for(let x=W;x>N;x--)Q.push(x);return Q}e.range=o;function w(M,N,W){return M.reduce((Q,x)=>(Q[N(x)]=W?W(x):x,Q),Object.create(null))}e.index=w;function I(M,N){return M.push(N),()=>p(M,N)}e.insert=I;function p(M,N){const W=M.indexOf(N);if(W>-1)return M.splice(W,1),N}e.remove=p;function g(M,N,W){const Q=M.slice(0,N),x=M.slice(N);return Q.concat(W,x)}e.arrayInsert=g;function R(M,N){let W;if(typeof N=="number"){let Q=N;W=()=>{const x=Math.sin(Q++)*179426549;return x-Math.floor(x)}}else W=Math.random;for(let Q=M.length-1;Q>0;Q-=1){const x=Math.floor(W()*(Q+1)),Z=M[Q];M[Q]=M[x],M[x]=Z}}e.shuffle=R;function F(M,N){const W=M.indexOf(N);W>-1&&(M.splice(W,1),M.unshift(N))}e.pushToStart=F;function $(M,N){const W=M.indexOf(N);W>-1&&(M.splice(W,1),M.push(N))}e.pushToEnd=$;function ue(M,N){return Array.isArray(M)?M.map(N):N(M)}e.mapArrayOrNot=ue;function z(M){return Array.isArray(M)?M:[M]}e.asArray=z;function B(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=B;function G(M,N){for(const W of M){const Q=N(W);if(Q!==void 0)return Q}}e.mapFind=G}),define(ve[53],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(C){const P=this;let A=!1,S;return function(){return A||(A=!0,S=C.apply(P,arguments)),S}}e.once=E}),define(ve[54],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(ve[55],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(C){function P(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}C.is=P;const A=Object.freeze([]);function S(){return A}C.empty=S;function*D(u){yield u}C.single=D;function y(u){return u||A}C.from=y;function n(u){return!u||u[Symbol.iterator]().next().done===!0}C.isEmpty=n;function T(u){return u[Symbol.iterator]().next().value}C.first=T;function k(u,t){for(const i of u)if(t(i))return!0;return!1}C.some=k;function h(u,t){for(const i of u)if(t(i))return i}C.find=h;function*f(u,t){for(const i of u)t(i)&&(yield i)}C.filter=f;function*r(u,t){for(const i of u)yield t(i)}C.map=r;function*s(...u){for(const t of u)for(const i of t)yield i}C.concat=s;function*_(u){for(const t of u)for(const i of t)yield i}C.concatNested=_;function m(u,t,i){let c=i;for(const a of u)c=t(c,a);return c}C.reduce=m;function*b(u,t,i=u.length){for(t<0&&(t+=u.length),i<0?i+=u.length:i>u.length&&(i=u.length);t<i;t++)yield u[t]}C.slice=b;function v(u,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,u];const c=u[Symbol.iterator]();for(let a=0;a<t;a++){const l=c.next();if(l.done)return[i,C.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return c}}]}C.consume=v;function d(u,t,i=(c,a)=>c===a){const c=u[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const l=c.next(),o=a.next();if(l.done!==o.done)return!1;if(l.done)return!0;if(!i(l.value,o.value))return!1}}C.equals=d})(E=e.Iterable||(e.Iterable={}))}),define(ve[43],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function S(t,i=!1){let c=0,a=t.length,l="",o=0,w=16,I=0;function p(B){let G=0,M=0;for(;G<B;){const N=t.charCodeAt(c);if(N>=48&&N<=57)M=M*16+N-48;else if(N>=65&&N<=70)M=M*16+N-65+10;else if(N>=97&&N<=102)M=M*16+N-97+10;else break;c++,G++}return G<B&&(M=-1),M}function g(B){c=B,l="",o=0,w=16,I=0}function R(){const B=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&n(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&n(t.charCodeAt(c)))for(c++;c<t.length&&n(t.charCodeAt(c));)c++;else return I=3,t.substring(B,c);let G=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&n(t.charCodeAt(c))){for(c++;c<t.length&&n(t.charCodeAt(c));)c++;G=c}else I=3;return t.substring(B,G)}function F(){let B="",G=c;for(;;){if(c>=a){B+=t.substring(G,c),I=2;break}const M=t.charCodeAt(c);if(M===34){B+=t.substring(G,c),c++;break}if(M===92){if(B+=t.substring(G,c),c++,c>=a){I=2;break}switch(t.charCodeAt(c++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const W=p(4);W>=0?B+=String.fromCharCode(W):I=4;break;default:I=5}G=c;continue}if(M>=0&&M<=31)if(y(M)){B+=t.substring(G,c),I=2;break}else I=6;c++}return B}function $(){if(l="",I=0,o=c,c>=a)return o=a,w=17;let B=t.charCodeAt(c);if(D(B)){do c++,l+=String.fromCharCode(B),B=t.charCodeAt(c);while(D(B));return w=15}if(y(B))return c++,l+=String.fromCharCode(B),B===13&&t.charCodeAt(c)===10&&(c++,l+=`
`),w=14;switch(B){case 123:return c++,w=1;case 125:return c++,w=2;case 91:return c++,w=3;case 93:return c++,w=4;case 58:return c++,w=6;case 44:return c++,w=5;case 34:return c++,l=F(),w=10;case 47:const G=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<a&&!y(t.charCodeAt(c));)c++;return l=t.substring(G,c),w=12}if(t.charCodeAt(c+1)===42){c+=2;const M=a-1;let N=!1;for(;c<M;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,N=!0;break}c++}return N||(c++,I=1),l=t.substring(G,c),w=13}return l+=String.fromCharCode(B),c++,w=16;case 45:if(l+=String.fromCharCode(B),c++,c===a||!n(t.charCodeAt(c)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=R(),w=11;default:for(;c<a&&ue(B);)c++,B=t.charCodeAt(c);if(o!==c){switch(l=t.substring(o,c),l){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return l+=String.fromCharCode(B),c++,w=16}}function ue(B){if(D(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let B;do B=$();while(B>=12&&B<=15);return B}return{setPosition:g,getPosition:()=>c,scan:i?z:$,getToken:()=>w,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>c-o,getTokenError:()=>I}}e.createScanner=S;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,i){const c=[],a=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function I(p,g,R,F){o.value=p,o.offset=g,o.length=R,o.type=F,o.colonOffset=void 0,l=o}try{v(t,{onObjectBegin:(p,g)=>{if(i<=p)throw a;l=void 0,w=i>p,c.push("")},onObjectProperty:(p,g,R)=>{if(i<g||(I(p,g,R,"property"),c[c.length-1]=p,i<=g+R))throw a},onObjectEnd:(p,g)=>{if(i<=p)throw a;l=void 0,c.pop()},onArrayBegin:(p,g)=>{if(i<=p)throw a;l=void 0,c.push(0)},onArrayEnd:(p,g)=>{if(i<=p)throw a;l=void 0,c.pop()},onLiteralValue:(p,g,R)=>{if(i<g||(I(p,g,R,u(p)),i<=g+R))throw a},onSeparator:(p,g,R)=>{if(i<=g)throw a;if(p===":"&&l&&l.type==="property")l.colonOffset=g,w=!1,l=void 0;else if(p===","){const F=c[c.length-1];typeof F=="number"?c[c.length-1]=F+1:(w=!0,c[c.length-1]=""),l=void 0}}})}catch(p){if(p!==a)throw p}return{path:c,previousNode:l,isAtPropertyKey:w,matches:p=>{let g=0;for(let R=0;g<p.length&&R<c.length;R++)if(p[g]===c[R]||p[g]==="*")g++;else if(p[g]!=="**")return!1;return g===p.length}}}e.getLocation=k;function h(t,i=[],c=A.DEFAULT){let a=null,l=[];const o=[];function w(p){Array.isArray(l)?l.push(p):a!==null&&(l[a]=p)}return v(t,{onObjectBegin:()=>{const p={};w(p),o.push(l),l=p,a=null},onObjectProperty:p=>{a=p},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const p=[];w(p),o.push(l),l=p,a=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:w,onError:(p,g,R)=>{i.push({error:p,offset:g,length:R})}},c),l[0]}e.parse=h;function f(t,i=[],c=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(p){a.type==="property"&&(a.length=p-a.offset,a=a.parent)}function o(p){return a.children.push(p),p}v(t,{onObjectBegin:p=>{a=o({type:"object",offset:p,length:-1,parent:a,children:[]})},onObjectProperty:(p,g,R)=>{a=o({type:"property",offset:g,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:p,offset:g,length:R,parent:a})},onObjectEnd:(p,g)=>{a.length=p+g-a.offset,a=a.parent,l(p+g)},onArrayBegin:(p,g)=>{a=o({type:"array",offset:p,length:-1,parent:a,children:[]})},onArrayEnd:(p,g)=>{a.length=p+g-a.offset,a=a.parent,l(p+g)},onLiteralValue:(p,g,R)=>{o({type:u(p),offset:g,length:R,parent:a,value:p}),l(g+R)},onSeparator:(p,g,R)=>{a.type==="property"&&(p===":"?a.colonOffset=g:p===","&&l(g))},onError:(p,g,R)=>{i.push({error:p,offset:g,length:R})}},c);const I=a.children[0];return I&&delete I.parent,I}e.parseTree=f;function r(t,i){if(!!t){let c=t;for(let a of i)if(typeof a=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let l=!1;for(const o of c.children)if(Array.isArray(o.children)&&o.children[0].value===a){c=o.children[1],l=!0;break}if(!l)return}else{const l=a;if(c.type!=="array"||l<0||!Array.isArray(c.children)||l>=c.children.length)return;c=c.children[l]}return c}}e.findNodeAtLocation=r;function s(t){if(!t.parent||!t.parent.children)return[];const i=s(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;i.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&i.push(c)}return i}e.getNodePath=s;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const i=Object.create(null);for(let c of t.children){const a=c.children[1];a&&(i[c.children[0].value]=_(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function m(t,i,c=!1){return i>=t.offset&&i<t.offset+t.length||c&&i===t.offset+t.length}e.contains=m;function b(t,i,c=!1){if(m(t,i,c)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=i;l++){const o=b(a[l],i,c);if(o)return o}return t}}e.findNodeAtOffset=b;function v(t,i,c=A.DEFAULT){const a=S(t,!1);function l(ye){return ye?()=>ye(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o(ye){return ye?Pe=>ye(Pe,a.getTokenOffset(),a.getTokenLength()):()=>!0}const w=l(i.onObjectBegin),I=o(i.onObjectProperty),p=l(i.onObjectEnd),g=l(i.onArrayBegin),R=l(i.onArrayEnd),F=o(i.onLiteralValue),$=o(i.onSeparator),ue=l(i.onComment),z=o(i.onError),B=c&&c.disallowComments,G=c&&c.allowTrailingComma;function M(){for(;;){const ye=a.scan();switch(a.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:B||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(ye){case 12:case 13:B?N(10):ue();break;case 16:N(1);break;case 15:case 14:break;default:return ye}}}function N(ye,Pe=[],Be=[]){if(z(ye),Pe.length+Be.length>0){let Re=a.getToken();for(;Re!==17;){if(Pe.indexOf(Re)!==-1){M();break}else if(Be.indexOf(Re)!==-1)break;Re=M()}}}function W(ye){const Pe=a.getTokenValue();return ye?F(Pe):I(Pe),M(),!0}function Q(){switch(a.getToken()){case 11:let ye=0;try{ye=JSON.parse(a.getTokenValue()),typeof ye!="number"&&(N(2),ye=0)}catch(Pe){N(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return M(),!0}function x(){return a.getToken()!==10?(N(3,[],[2,5]),!1):(W(!1),a.getToken()===6?($(":"),M(),oe()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function Z(){w(),M();let ye=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ye||N(4,[],[]),$(","),M(),a.getToken()===2&&G)break}else ye&&N(6,[],[]);x()||N(4,[],[2,5]),ye=!0}return p(),a.getToken()!==2?N(7,[2],[]):M(),!0}function re(){g(),M();let ye=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ye||N(4,[],[]),$(","),M(),a.getToken()===4&&G)break}else ye&&N(6,[],[]);oe()||N(4,[],[4,5]),ye=!0}return R(),a.getToken()!==4?N(8,[4],[]):M(),!0}function oe(){switch(a.getToken()){case 3:return re();case 1:return Z();case 10:return W(!0);default:return Q()}}return M(),a.getToken()===17?c.allowEmptyContent?!0:(N(4,[],[]),!1):oe()?(a.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=v;function d(t,i){let c=S(t),a=[],l,o=0,w;do switch(w=c.getPosition(),l=c.scan(),l){case 12:case 13:case 17:o!==w&&a.push(t.substring(o,w)),i!==void 0&&a.push(c.getTokenValue().replace(/[^\r\n]/g,i)),o=c.getPosition();break}while(l!==17);return a.join("")}e.stripComments=d;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ve[104],_e([0,1,43]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function C(y,n,T){let k,h,f,r,s;if(n){for(r=n.offset,s=r+n.length,f=r;f>0&&!D(y,f-1);)f--;let o=s;for(;o<y.length&&!D(y,o);)o++;h=y.substring(f,o),k=A(h,T)}else h=y,k=0,f=0,r=0,s=y.length;const _=S(T,y);let m=!1,b=0,v;T.insertSpaces?v=P(" ",T.tabSize||4):v="	";const d=(0,E.createScanner)(h,!1);let u=!1;function t(){return _+P(v,k+b)}function i(){let o=d.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=d.scan();return u=o===16||d.getTokenError()!==0,o}const c=[];function a(o,w,I){!u&&w<s&&I>r&&y.substring(w,I)!==o&&c.push({offset:w,length:I-w,content:o})}let l=i();if(l!==17){const o=d.getTokenOffset()+f,w=P(v,k);a(w,f,o)}for(;l!==17;){let o=d.getTokenOffset()+d.getTokenLength()+f,w=i(),I="";for(;!m&&(w===12||w===13);){const g=d.getTokenOffset()+f;a(" ",o,g),o=d.getTokenOffset()+d.getTokenLength()+f,I=w===12?t():"",w=i()}if(w===2)l!==1&&(b--,I=t());else if(w===4)l!==3&&(b--,I=t());else{switch(l){case 3:case 1:b++,I=t();break;case 5:case 12:I=t();break;case 13:m?I=t():I=" ";break;case 6:I=" ";break;case 10:if(w===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?I=" ":w!==5&&w!==17&&(u=!0);break;case 16:u=!0;break}m&&(w===12||w===13)&&(I=t())}const p=d.getTokenOffset()+f;a(I,o,p),l=w}return c}e.format=C;function P(y,n){let T="";for(let k=0;k<n;k++)T+=y;return T}function A(y,n){let T=0,k=0;const h=n.tabSize||4;for(;T<y.length;){const f=y.charAt(T);if(f===" ")k++;else if(f==="	")k+=h;else break;T++}return Math.floor(k/h)}function S(y,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function D(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=D}),define(ve[105],_e([0,1,43,104]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(n,T,k){return A(n,T,void 0,k)}e.removeProperty=P;function A(n,T,k,h,f){const r=T.slice(),s=[],_=(0,E.parseTree)(n,s);let m,b;for(;r.length>0&&(b=r.pop(),m=(0,E.findNodeAtLocation)(_,r),m===void 0&&k!==void 0);)typeof b=="string"?k={[b]:k}:k=[k];if(m)if(m.type==="object"&&typeof b=="string"&&Array.isArray(m.children)){const v=(0,E.findNodeAtLocation)(m,[b]);if(v!==void 0)if(k===void 0){if(!v.parent)throw new Error("Malformed AST");const d=m.children.indexOf(v.parent);let u,t=v.parent.offset+v.parent.length;if(d>0){const i=m.children[d-1];u=i.offset+i.length}else u=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return S(n,{offset:u,length:t-u,content:""},h)}else return S(n,{offset:v.offset,length:v.length,content:JSON.stringify(k)},h);else{if(k===void 0)return[];const d=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,u=f?f(m.children.map(i=>i.children[0].value)):m.children.length;let t;if(u>0){const i=m.children[u-1];t={offset:i.offset+i.length,length:0,content:","+d}}else m.children.length===0?t={offset:m.offset+1,length:0,content:d}:t={offset:m.offset+1,length:0,content:d+","};return S(n,t,h)}}else if(m.type==="array"&&typeof b=="number"&&Array.isArray(m.children))if(k!==void 0){const v=`${JSON.stringify(k)}`;let d;if(m.children.length===0||b===0)d={offset:m.offset+1,length:0,content:m.children.length===0?v:v+","};else{const u=b===-1||b>m.children.length?m.children.length:b,t=m.children[u-1];d={offset:t.offset+t.length,length:0,content:","+v}}return S(n,d,h)}else{const v=b,d=m.children[v];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===v){const t=m.children[v-1],i=t.offset+t.length,c=m.offset+m.length;u={offset:i,length:c-2-i,content:""}}else u={offset:d.offset,length:m.children[v+1].offset-d.offset,content:""};return S(n,u,h)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${m.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(k)},h)}}e.setProperty=A;function S(n,T,k){let h=D(n,T),f=T.offset,r=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;f>0&&!(0,C.isEOL)(h,f-1);)f--;for(;r<h.length&&!(0,C.isEOL)(h,r);)r++}const s=(0,C.format)(h,{offset:f,length:r-f},k);for(let m=s.length-1;m>=0;m--){const b=s[m];h=D(h,b),f=Math.min(f,b.offset),r=Math.max(r,b.offset+b.length),r+=b.content.length-b.length}const _=n.length-(h.length-r)-f;return[{offset:f,length:_,content:h.substring(f,r)}]}e.withFormatting=S;function D(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=D;function y(n,T){let k=T.slice(0).sort((f,r)=>{const s=f.offset-r.offset;return s===0?f.length-r.length:s}),h=n.length;for(let f=k.length-1;f>=0;f--){let r=k[f];if(r.offset+r.length<=h)n=D(n,r);else throw new Error("Overlapping edit");h=r.offset}return n}e.applyEdits=y}),define(ve[106],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new E(()=>P(this.getValue()))}}e.Lazy=E}),define(ve[6],_e([0,1,53,55]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const P=!1;let A=null;function S(v){A=v}if(e.setDisposableTracker=S,P){const v="__is_disposable_tracked__";A=new class{trackDisposable(d){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[v]||console.log(u)},3e3)}markTracked(d){if(d&&d!==s.None)try{d[v]=!0}catch(u){}}}}function D(v){!A||A.markTracked(v)}function y(v){return A&&A.trackDisposable(v),v}e.trackDisposable=y;class n extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=n;function T(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=T;function k(v){if(C.Iterable.is(v)){let d=[];for(const u of v)if(u){D(u);try{u.dispose()}catch(t){d.push(t)}}if(d.length===1)throw d[0];if(d.length>1)throw new n(d);return Array.isArray(v)?[]:v}else if(v)return D(v),v.dispose(),v}e.dispose=k;function h(...v){return v.forEach(D),f(()=>k(v))}e.combinedDisposable=h;function f(v){const d=y({dispose:()=>{D(d),v()}});return d}e.toDisposable=f;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return D(d),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this._store=new r,y(this)}dispose(){D(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=s,s.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){var u;this._isDisposed||d===this._value||((u=this._value)===null||u===void 0||u.dispose(),d&&D(d),this._value=d)}clear(){this.value=void 0}dispose(){var d;this._isDisposed=!0,D(this),(d=this._value)===null||d===void 0||d.dispose(),this._value=void 0}}e.MutableDisposable=_;class m{constructor(){this.references=new Map}acquire(d,...u){let t=this.references.get(d);t||(t={counter:0,object:this.createReferencedObject(d,...u)},this.references.set(d,t));const{object:i}=t,c=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(d,t.object),this.references.delete(d))});return t.counter++,{object:i,dispose:c}}}e.ReferenceCollection=m;class b{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=b}),define(ve[44],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class C{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,S){const D=new E(A);if(this._first===E.Undefined)this._first=D,this._last=D;else if(S){const n=this._last;this._last=D,D.prev=n,n.next=D}else{const n=this._first;this._first=D,D.next=n,n.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==E.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==E.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const S=A.prev;S.next=A.next,A.next.prev=S}else A.prev===E.Undefined&&A.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):A.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):A.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=C}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(H,ie){for(var de=0;de<ie.length;de++){var j=ie[de];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(H,j.key,j)}}function e(H,ie,de){return ie&&ee(H.prototype,ie),de&&ee(H,de),H}function E(H,ie){if(!!H){if(typeof H=="string")return C(H,ie);var de=Object.prototype.toString.call(H).slice(8,-1);if(de==="Object"&&H.constructor&&(de=H.constructor.name),de==="Map"||de==="Set")return Array.from(H);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return C(H,ie)}}function C(H,ie){(ie==null||ie>H.length)&&(ie=H.length);for(var de=0,j=new Array(ie);de<ie;de++)j[de]=H[de];return j}function P(H,ie){var de;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(de=E(H))||ie&&H&&typeof H.length=="number"){de&&(H=de);var j=0;return function(){return j>=H.length?{done:!0}:{done:!1,value:H[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=H[Symbol.iterator](),de.next.bind(de)}function A(H){var ie={exports:{}};return H(ie,ie.exports),ie.exports}var S=A(function(H){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(j){H.exports.defaults=j}H.exports={defaults:ie(),getDefaults:ie,changeDefaults:de}}),D=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ie){return k[ie]};function f(H,ie){if(ie){if(D.test(H))return H.replace(y,h)}else if(n.test(H))return H.replace(T,h);return H}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(H){return H.replace(r,function(ie,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var _=/(^|[^\[])\^/g;function m(H,ie){H=H.source||H,ie=ie||"";var de={replace:function(Y,ae){return ae=ae.source||ae,ae=ae.replace(_,"$1"),H=H.replace(Y,ae),de},getRegex:function(){return new RegExp(H,ie)}};return de}var b=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(H,ie,de){if(H){var j;try{j=decodeURIComponent(s(de)).replace(b,"").toLowerCase()}catch(Y){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ie&&!v.test(de)&&(de=a(ie,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(Y){return null}return de}var u={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(H,ie){u[" "+H]||(t.test(H)?u[" "+H]=H+"/":u[" "+H]=I(H,"/",!0)),H=u[" "+H];var de=H.indexOf(":")===-1;return ie.substring(0,2)==="//"?de?ie:H.replace(i,"$1")+ie:ie.charAt(0)==="/"?de?ie:H.replace(c,"$1")+ie:H+ie}var l={exec:function(){}};function o(H){for(var ie=1,de,j;ie<arguments.length;ie++){de=arguments[ie];for(j in de)Object.prototype.hasOwnProperty.call(de,j)&&(H[j]=de[j])}return H}function w(H,ie){var de=H.replace(/\|/g,function(ae,he,Ee){for(var Ne=!1,Le=he;--Le>=0&&Ee[Le]==="\\";)Ne=!Ne;return Ne?"|":" |"}),j=de.split(/ \|/),Y=0;if(j.length>ie)j.splice(ie);else for(;j.length<ie;)j.push("");for(;Y<j.length;Y++)j[Y]=j[Y].trim().replace(/\\\|/g,"|");return j}function I(H,ie,de){var j=H.length;if(j===0)return"";for(var Y=0;Y<j;){var ae=H.charAt(j-Y-1);if(ae===ie&&!de)Y++;else if(ae!==ie&&de)Y++;else break}return H.substr(0,j-Y)}function p(H,ie){if(H.indexOf(ie[1])===-1)return-1;for(var de=H.length,j=0,Y=0;Y<de;Y++)if(H[Y]==="\\")Y++;else if(H[Y]===ie[0])j++;else if(H[Y]===ie[1]&&(j--,j<0))return Y;return-1}function g(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(H,ie){if(ie<1)return"";for(var de="";ie>1;)ie&1&&(de+=H),ie>>=1,H+=H;return de+H}var F={escape:f,unescape:s,edit:m,cleanUrl:d,resolveUrl:a,noopTest:l,merge:o,splitCells:w,rtrim:I,findClosingBracket:p,checkSanitizeDeprecation:g,repeatString:R},$=S.defaults,ue=F.rtrim,z=F.splitCells,B=F.escape,G=F.findClosingBracket;function M(H,ie,de){var j=ie.href,Y=ie.title?B(ie.title):null,ae=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:de,href:j,title:Y,text:ae}:{type:"image",raw:de,href:j,title:Y,text:B(ae)}}function N(H,ie){var de=H.match(/^(\s+)(?:```)/);if(de===null)return ie;var j=de[1];return ie.split(`
`).map(function(Y){var ae=Y.match(/^\s+/);if(ae===null)return Y;var he=ae[0];return he.length>=j.length?Y.slice(j.length):Y}).join(`
`)}var W=function(){function H(de){this.options=de||$}var ie=H.prototype;return ie.space=function(j){var Y=this.rules.block.newline.exec(j);if(Y)return Y[0].length>1?{type:"space",raw:Y[0]}:{raw:`
`}},ie.code=function(j){var Y=this.rules.block.code.exec(j);if(Y){var ae=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:ue(ae,`
`)}}},ie.fences=function(j){var Y=this.rules.block.fences.exec(j);if(Y){var ae=Y[0],he=N(ae,Y[3]||"");return{type:"code",raw:ae,lang:Y[2]?Y[2].trim():Y[2],text:he}}},ie.heading=function(j){var Y=this.rules.block.heading.exec(j);if(Y){var ae=Y[2].trim();if(/#$/.test(ae)){var he=ue(ae,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ae=he.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ae}}},ie.nptable=function(j){var Y=this.rules.block.nptable.exec(j);if(Y){var ae={type:"table",header:z(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[],raw:Y[0]};if(ae.header.length===ae.align.length){var he=ae.align.length,Ee;for(Ee=0;Ee<he;Ee++)/^ *-+: *$/.test(ae.align[Ee])?ae.align[Ee]="right":/^ *:-+: *$/.test(ae.align[Ee])?ae.align[Ee]="center":/^ *:-+ *$/.test(ae.align[Ee])?ae.align[Ee]="left":ae.align[Ee]=null;for(he=ae.cells.length,Ee=0;Ee<he;Ee++)ae.cells[Ee]=z(ae.cells[Ee],ae.header.length);return ae}}},ie.hr=function(j){var Y=this.rules.block.hr.exec(j);if(Y)return{type:"hr",raw:Y[0]}},ie.blockquote=function(j){var Y=this.rules.block.blockquote.exec(j);if(Y){var ae=Y[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Y[0],text:ae}}},ie.list=function(j){var Y=this.rules.block.list.exec(j);if(Y){var ae=Y[0],he=Y[2],Ee=he.length>1,Ne={type:"list",raw:ae,ordered:Ee,start:Ee?+he.slice(0,-1):"",loose:!1,items:[]},Le=Y[0].match(this.rules.block.item),je=!1,Je,nt,rt,ot,it,pt,Ve,pe,Se=Le.length;rt=this.rules.block.listItemStart.exec(Le[0]);for(var se=0;se<Se;se++){if(Je=Le[se],ae=Je,se!==Se-1){if(ot=this.rules.block.listItemStart.exec(Le[se+1]),this.options.pedantic?ot[1].length>rt[1].length:ot[1].length>rt[0].length||ot[1].length>3){Le.splice(se,2,Le[se]+`
`+Le[se+1]),se--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==he[he.length-1]:Ee===(ot[2].length===1))&&(it=Le.slice(se+1).join(`
`),Ne.raw=Ne.raw.substring(0,Ne.raw.length-it.length),se=Se-1);rt=ot}nt=Je.length,Je=Je.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Je.indexOf(`
 `)&&(nt-=Je.length,Je=this.options.pedantic?Je.replace(/^ {1,4}/gm,""):Je.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),pt=je||/\n\n(?!\s*$)/.test(Je),se!==Se-1&&(je=Je.charAt(Je.length-1)===`
`,pt||(pt=je)),pt&&(Ne.loose=!0),this.options.gfm&&(Ve=/^\[[ xX]\] /.test(Je),pe=void 0,Ve&&(pe=Je[1]!==" ",Je=Je.replace(/^\[[ xX]\] +/,""))),Ne.items.push({type:"list_item",raw:ae,task:Ve,checked:pe,loose:pt,text:Je})}return Ne}},ie.html=function(j){var Y=this.rules.block.html.exec(j);if(Y)return{type:this.options.sanitize?"paragraph":"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):B(Y[0]):Y[0]}},ie.def=function(j){var Y=this.rules.block.def.exec(j);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ae=Y[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:Y[0],href:Y[2],title:Y[3]}}},ie.table=function(j){var Y=this.rules.block.table.exec(j);if(Y){var ae={type:"table",header:z(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=Y[0];var he=ae.align.length,Ee;for(Ee=0;Ee<he;Ee++)/^ *-+: *$/.test(ae.align[Ee])?ae.align[Ee]="right":/^ *:-+: *$/.test(ae.align[Ee])?ae.align[Ee]="center":/^ *:-+ *$/.test(ae.align[Ee])?ae.align[Ee]="left":ae.align[Ee]=null;for(he=ae.cells.length,Ee=0;Ee<he;Ee++)ae.cells[Ee]=z(ae.cells[Ee].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},ie.lheading=function(j){var Y=this.rules.block.lheading.exec(j);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1]}},ie.paragraph=function(j){var Y=this.rules.block.paragraph.exec(j);if(Y)return{type:"paragraph",raw:Y[0],text:Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1]}},ie.text=function(j){var Y=this.rules.block.text.exec(j);if(Y)return{type:"text",raw:Y[0],text:Y[0]}},ie.escape=function(j){var Y=this.rules.inline.escape.exec(j);if(Y)return{type:"escape",raw:Y[0],text:B(Y[1])}},ie.tag=function(j,Y,ae){var he=this.rules.inline.tag.exec(j);if(he)return!Y&&/^<a /i.test(he[0])?Y=!0:Y&&/^<\/a>/i.test(he[0])&&(Y=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:Y,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):B(he[0]):he[0]}},ie.link=function(j){var Y=this.rules.inline.link.exec(j);if(Y){var ae=Y[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var he=ue(ae.slice(0,-1),"\\");if((ae.length-he.length)%2==0)return}else{var Ee=G(Y[2],"()");if(Ee>-1){var Ne=Y[0].indexOf("!")===0?5:4,Le=Ne+Y[1].length+Ee;Y[2]=Y[2].substring(0,Ee),Y[0]=Y[0].substring(0,Le).trim(),Y[3]=""}}var je=Y[2],Je="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);nt&&(je=nt[1],Je=nt[3])}else Je=Y[3]?Y[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ae)?je=je.slice(1):je=je.slice(1,-1)),M(Y,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Je&&Je.replace(this.rules.inline._escapes,"$1")},Y[0])}},ie.reflink=function(j,Y){var ae;if((ae=this.rules.inline.reflink.exec(j))||(ae=this.rules.inline.nolink.exec(j))){var he=(ae[2]||ae[1]).replace(/\s+/g," ");if(he=Y[he.toLowerCase()],!he||!he.href){var Ee=ae[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return M(ae,he,ae[0])}},ie.emStrong=function(j,Y,ae){ae===void 0&&(ae="");var he=this.rules.inline.emStrong.lDelim.exec(j);if(!!he&&!(he[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=he[1]||he[2]||"";if(!Ee||Ee&&(ae===""||this.rules.inline.punctuation.exec(ae))){var Ne=he[0].length-1,Le,je,Je=Ne,nt=0,rt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,Y=Y.slice(-1*j.length+Ne);(he=rt.exec(Y))!=null;)if(Le=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Le){if(je=Le.length,he[3]||he[4]){Je+=je;continue}else if((he[5]||he[6])&&Ne%3&&!((Ne+je)%3)){nt+=je;continue}if(Je-=je,!(Je>0)){if(Je+nt-je<=0&&!Y.slice(rt.lastIndex).match(rt)&&(je=Math.min(je,je+Je+nt)),Math.min(Ne,je)%2)return{type:"em",raw:j.slice(0,Ne+he.index+je+1),text:j.slice(1,Ne+he.index+je)};if(Math.min(Ne,je)%2==0)return{type:"strong",raw:j.slice(0,Ne+he.index+je+1),text:j.slice(2,Ne+he.index+je-1)}}}}}},ie.codespan=function(j){var Y=this.rules.inline.code.exec(j);if(Y){var ae=Y[2].replace(/\n/g," "),he=/[^ ]/.test(ae),Ee=/^ /.test(ae)&&/ $/.test(ae);return he&&Ee&&(ae=ae.substring(1,ae.length-1)),ae=B(ae,!0),{type:"codespan",raw:Y[0],text:ae}}},ie.br=function(j){var Y=this.rules.inline.br.exec(j);if(Y)return{type:"br",raw:Y[0]}},ie.del=function(j){var Y=this.rules.inline.del.exec(j);if(Y)return{type:"del",raw:Y[0],text:Y[2]}},ie.autolink=function(j,Y){var ae=this.rules.inline.autolink.exec(j);if(ae){var he,Ee;return ae[2]==="@"?(he=B(this.options.mangle?Y(ae[1]):ae[1]),Ee="mailto:"+he):(he=B(ae[1]),Ee=he),{type:"link",raw:ae[0],text:he,href:Ee,tokens:[{type:"text",raw:he,text:he}]}}},ie.url=function(j,Y){var ae;if(ae=this.rules.inline.url.exec(j)){var he,Ee;if(ae[2]==="@")he=B(this.options.mangle?Y(ae[0]):ae[0]),Ee="mailto:"+he;else{var Ne;do Ne=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(Ne!==ae[0]);he=B(ae[0]),ae[1]==="www."?Ee="http://"+he:Ee=he}return{type:"link",raw:ae[0],text:he,href:Ee,tokens:[{type:"text",raw:he,text:he}]}}},ie.inlineText=function(j,Y,ae){var he=this.rules.inline.text.exec(j);if(he){var Ee;return Y?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):B(he[0]):he[0]:Ee=B(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:Ee}}},H}(),Q=F.noopTest,x=F.edit,Z=F.merge,re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=x(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,re.item=x(re.item,"gm").replace(/bull/g,re.bullet).getRegex(),re.listItemStart=x(/^( *)(bull)/).replace("bull",re.bullet).getRegex(),re.list=x(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=x(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=x(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.blockquote=x(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=Z({},re),re.gfm=Z({},re.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.nptable=x(re.gfm.nptable).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.gfm.table=x(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",re._tag).getRegex(),re.pedantic=Z({},re.normal,{html:x(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:x(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=x(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=x(re._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=x(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=x(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=x(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=x(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=x(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=x(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=x(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=x(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=Z({},oe),oe.pedantic=Z({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:x(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:x(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=Z({},oe.normal,{escape:x(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),oe.gfm.url=x(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=Z({},oe.gfm,{br:x(oe.br).replace("{2,}","*").getRegex(),text:x(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:re,inline:oe},Pe=S.defaults,Be=ye.block,Re=ye.inline,ze=F.repeatString;function U(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(H){var ie="",de,j,Y=H.length;for(de=0;de<Y;de++)j=H.charCodeAt(de),Math.random()>.5&&(j="x"+j.toString(16)),ie+="&#"+j+";";return ie}var ne=function(){function H(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Pe,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:Be.normal,inline:Re.normal};this.options.pedantic?(j.block=Be.pedantic,j.inline=Re.pedantic):this.options.gfm&&(j.block=Be.gfm,this.options.breaks?j.inline=Re.breaks:j.inline=Re.gfm),this.tokenizer.rules=j}H.lex=function(j,Y){var ae=new H(Y);return ae.lex(j)},H.lexInline=function(j,Y){var ae=new H(Y);return ae.inlineTokens(j)};var ie=H.prototype;return ie.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(j,Y,ae){Y===void 0&&(Y=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var he,Ee,Ne,Le;j;){if(he=this.tokenizer.space(j)){j=j.substring(he.raw.length),he.type&&Y.push(he);continue}if(he=this.tokenizer.code(j)){j=j.substring(he.raw.length),Le=Y[Y.length-1],Le&&Le.type==="paragraph"?(Le.raw+=`
`+he.raw,Le.text+=`
`+he.text):Y.push(he);continue}if(he=this.tokenizer.fences(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.heading(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.nptable(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.hr(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.blockquote(j)){j=j.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],ae),Y.push(he);continue}if(he=this.tokenizer.list(j)){for(j=j.substring(he.raw.length),Ne=he.items.length,Ee=0;Ee<Ne;Ee++)he.items[Ee].tokens=this.blockTokens(he.items[Ee].text,[],!1);Y.push(he);continue}if(he=this.tokenizer.html(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(ae&&(he=this.tokenizer.def(j))){j=j.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.lheading(j)){j=j.substring(he.raw.length),Y.push(he);continue}if(ae&&(he=this.tokenizer.paragraph(j))){j=j.substring(he.raw.length),Y.push(he);continue}if(he=this.tokenizer.text(j)){j=j.substring(he.raw.length),Le=Y[Y.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+he.raw,Le.text+=`
`+he.text):Y.push(he);continue}if(j){var je="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return Y},ie.inline=function(j){var Y,ae,he,Ee,Ne,Le,je=j.length;for(Y=0;Y<je;Y++)switch(Le=j[Y],Le.type){case"paragraph":case"text":case"heading":{Le.tokens=[],this.inlineTokens(Le.text,Le.tokens);break}case"table":{for(Le.tokens={header:[],cells:[]},Ee=Le.header.length,ae=0;ae<Ee;ae++)Le.tokens.header[ae]=[],this.inlineTokens(Le.header[ae],Le.tokens.header[ae]);for(Ee=Le.cells.length,ae=0;ae<Ee;ae++)for(Ne=Le.cells[ae],Le.tokens.cells[ae]=[],he=0;he<Ne.length;he++)Le.tokens.cells[ae][he]=[],this.inlineTokens(Ne[he],Le.tokens.cells[ae][he]);break}case"blockquote":{this.inline(Le.tokens);break}case"list":{for(Ee=Le.items.length,ae=0;ae<Ee;ae++)this.inline(Le.items[ae].tokens);break}}return j},ie.inlineTokens=function(j,Y,ae,he){Y===void 0&&(Y=[]),ae===void 0&&(ae=!1),he===void 0&&(he=!1);var Ee,Ne,Le=j,je,Je,nt;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)rt.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,je.index)+"["+ze("a",je[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,je.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Je||(nt=""),Je=!1,Ee=this.tokenizer.escape(j)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.tag(j,ae,he)){j=j.substring(Ee.raw.length),ae=Ee.inLink,he=Ee.inRawBlock;var ot=Y[Y.length-1];ot&&Ee.type==="text"&&ot.type==="text"?(ot.raw+=Ee.raw,ot.text+=Ee.text):Y.push(Ee);continue}if(Ee=this.tokenizer.link(j)){j=j.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,he)),Y.push(Ee);continue}if(Ee=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(Ee.raw.length);var it=Y[Y.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,he),Y.push(Ee)):it&&Ee.type==="text"&&it.type==="text"?(it.raw+=Ee.raw,it.text+=Ee.text):Y.push(Ee);continue}if(Ee=this.tokenizer.emStrong(j,Le,nt)){j=j.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],ae,he),Y.push(Ee);continue}if(Ee=this.tokenizer.codespan(j)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.br(j)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.del(j)){j=j.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],ae,he),Y.push(Ee);continue}if(Ee=this.tokenizer.autolink(j,K)){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(!ae&&(Ee=this.tokenizer.url(j,K))){j=j.substring(Ee.raw.length),Y.push(Ee);continue}if(Ee=this.tokenizer.inlineText(j,he,U)){j=j.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(nt=Ee.raw.slice(-1)),Je=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=Ee.raw,Ne.text+=Ee.text):Y.push(Ee);continue}if(j){var pt="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(pt);break}else throw new Error(pt)}}return Y},e(H,null,[{key:"rules",get:function(){return{block:Be,inline:Re}}}]),H}(),le=S.defaults,fe=F.cleanUrl,De=F.escape,Oe=function(){function H(de){this.options=de||le}var ie=H.prototype;return ie.code=function(j,Y,ae){var he=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(j,he);Ee!=null&&Ee!==j&&(ae=!0,j=Ee)}return j=j.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+De(he,!0)+'">'+(ae?j:De(j,!0))+`</code></pre>
`:"<pre><code>"+(ae?j:De(j,!0))+`</code></pre>
`},ie.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ie.html=function(j){return j},ie.heading=function(j,Y,ae,he){return this.options.headerIds?"<h"+Y+' id="'+this.options.headerPrefix+he.slug(ae)+'">'+j+"</h"+Y+`>
`:"<h"+Y+">"+j+"</h"+Y+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(j,Y,ae){var he=Y?"ol":"ul",Ee=Y&&ae!==1?' start="'+ae+'"':"";return"<"+he+Ee+`>
`+j+"</"+he+`>
`},ie.listitem=function(j){return"<li>"+j+`</li>
`},ie.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(j){return"<p>"+j+`</p>
`},ie.table=function(j,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+Y+`</table>
`},ie.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ie.tablecell=function(j,Y){var ae=Y.header?"th":"td",he=Y.align?"<"+ae+' align="'+Y.align+'">':"<"+ae+">";return he+j+"</"+ae+`>
`},ie.strong=function(j){return"<strong>"+j+"</strong>"},ie.em=function(j){return"<em>"+j+"</em>"},ie.codespan=function(j){return"<code>"+j+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(j){return"<del>"+j+"</del>"},ie.link=function(j,Y,ae){if(j=fe(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<a href="'+De(j)+'"';return Y&&(he+=' title="'+Y+'"'),he+=">"+ae+"</a>",he},ie.image=function(j,Y,ae){if(j=fe(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<img src="'+j+'" alt="'+ae+'"';return Y&&(he+=' title="'+Y+'"'),he+=this.options.xhtml?"/>":">",he},ie.text=function(j){return j},H}(),me=function(){function H(){}var ie=H.prototype;return ie.strong=function(j){return j},ie.em=function(j){return j},ie.codespan=function(j){return j},ie.del=function(j){return j},ie.html=function(j){return j},ie.text=function(j){return j},ie.link=function(j,Y,ae){return""+ae},ie.image=function(j,Y,ae){return""+ae},ie.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var ie=H.prototype;return ie.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(j,Y){var ae=j,he=0;if(this.seen.hasOwnProperty(ae)){he=this.seen[j];do he++,ae=j+"-"+he;while(this.seen.hasOwnProperty(ae))}return Y||(this.seen[j]=he,this.seen[ae]=0),ae},ie.slug=function(j,Y){Y===void 0&&(Y={});var ae=this.serialize(j);return this.getNextSafeSlug(ae,Y.dryrun)},H}(),Ae=S.defaults,$e=F.unescape,be=function(){function H(de){this.options=de||Ae,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new Ce}H.parse=function(j,Y){var ae=new H(Y);return ae.parse(j)},H.parseInline=function(j,Y){var ae=new H(Y);return ae.parseInline(j)};var ie=H.prototype;return ie.parse=function(j,Y){Y===void 0&&(Y=!0);var ae="",he,Ee,Ne,Le,je,Je,nt,rt,ot,it,pt,Ve,pe,Se,se,q,Fe,Ie,Ye=j.length;for(he=0;he<Ye;he++)switch(it=j[he],it.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(it.tokens),it.depth,$e(this.parseInline(it.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(it.text,it.lang,it.escaped);continue}case"table":{for(rt="",nt="",Le=it.header.length,Ee=0;Ee<Le;Ee++)nt+=this.renderer.tablecell(this.parseInline(it.tokens.header[Ee]),{header:!0,align:it.align[Ee]});for(rt+=this.renderer.tablerow(nt),ot="",Le=it.cells.length,Ee=0;Ee<Le;Ee++){for(Je=it.tokens.cells[Ee],nt="",je=Je.length,Ne=0;Ne<je;Ne++)nt+=this.renderer.tablecell(this.parseInline(Je[Ne]),{header:!1,align:it.align[Ne]});ot+=this.renderer.tablerow(nt)}ae+=this.renderer.table(rt,ot);continue}case"blockquote":{ot=this.parse(it.tokens),ae+=this.renderer.blockquote(ot);continue}case"list":{for(pt=it.ordered,Ve=it.start,pe=it.loose,Le=it.items.length,ot="",Ee=0;Ee<Le;Ee++)se=it.items[Ee],q=se.checked,Fe=se.task,Se="",se.task&&(Ie=this.renderer.checkbox(q),pe?se.tokens.length>0&&se.tokens[0].type==="text"?(se.tokens[0].text=Ie+" "+se.tokens[0].text,se.tokens[0].tokens&&se.tokens[0].tokens.length>0&&se.tokens[0].tokens[0].type==="text"&&(se.tokens[0].tokens[0].text=Ie+" "+se.tokens[0].tokens[0].text)):se.tokens.unshift({type:"text",text:Ie}):Se+=Ie),Se+=this.parse(se.tokens,pe),ot+=this.renderer.listitem(Se,Fe,q);ae+=this.renderer.list(ot,pt,Ve);continue}case"html":{ae+=this.renderer.html(it.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(it.tokens));continue}case"text":{for(ot=it.tokens?this.parseInline(it.tokens):it.text;he+1<Ye&&j[he+1].type==="text";)it=j[++he],ot+=`
`+(it.tokens?this.parseInline(it.tokens):it.text);ae+=Y?this.renderer.paragraph(ot):ot;continue}default:{var Xe='Token with "'+it.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}return ae},ie.parseInline=function(j,Y){Y=Y||this.renderer;var ae="",he,Ee,Ne=j.length;for(he=0;he<Ne;he++)switch(Ee=j[he],Ee.type){case"escape":{ae+=Y.text(Ee.text);break}case"html":{ae+=Y.html(Ee.text);break}case"link":{ae+=Y.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,Y));break}case"image":{ae+=Y.image(Ee.href,Ee.title,Ee.text);break}case"strong":{ae+=Y.strong(this.parseInline(Ee.tokens,Y));break}case"em":{ae+=Y.em(this.parseInline(Ee.tokens,Y));break}case"codespan":{ae+=Y.codespan(Ee.text);break}case"br":{ae+=Y.br();break}case"del":{ae+=Y.del(this.parseInline(Ee.tokens,Y));break}case"text":{ae+=Y.text(Ee.text);break}default:{var Le='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}return ae},H}(),Ke=F.merge,V=F.checkSanitizeDeprecation,X=F.escape,ge=S.getDefaults,Me=S.changeDefaults,We=S.defaults;function Ue(H,ie,de){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof ie=="function"&&(de=ie,ie=null),ie=Ke({},Ue.defaults,ie||{}),V(ie),de){var j=ie.highlight,Y;try{Y=ne.lex(H,ie)}catch(Ne){return de(Ne)}var ae=function(Le){var je;if(!Le)try{je=be.parse(Y,ie)}catch(Je){Le=Je}return ie.highlight=j,Le?de(Le):de(null,je)};if(!j||j.length<3||(delete ie.highlight,!Y.length))return ae();var he=0;Ue.walkTokens(Y,function(Ne){Ne.type==="code"&&(he++,setTimeout(function(){j(Ne.text,Ne.lang,function(Le,je){if(Le)return ae(Le);je!=null&&je!==Ne.text&&(Ne.text=je,Ne.escaped=!0),he--,he===0&&ae()})},0))}),he===0&&ae();return}try{var Ee=ne.lex(H,ie);return ie.walkTokens&&Ue.walkTokens(Ee,ie.walkTokens),be.parse(Ee,ie)}catch(Ne){if(Ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+X(Ne.message+"",!0)+"</pre>";throw Ne}}Ue.options=Ue.setOptions=function(H){return Ke(Ue.defaults,H),Me(Ue.defaults),Ue},Ue.getDefaults=ge,Ue.defaults=We,Ue.use=function(H){var ie=Ke({},H);if(H.renderer&&function(){var j=Ue.defaults.renderer||new Oe,Y=function(Ee){var Ne=j[Ee];j[Ee]=function(){for(var Le=arguments.length,je=new Array(Le),Je=0;Je<Le;Je++)je[Je]=arguments[Je];var nt=H.renderer[Ee].apply(j,je);return nt===!1&&(nt=Ne.apply(j,je)),nt}};for(var ae in H.renderer)Y(ae);ie.renderer=j}(),H.tokenizer&&function(){var j=Ue.defaults.tokenizer||new W,Y=function(Ee){var Ne=j[Ee];j[Ee]=function(){for(var Le=arguments.length,je=new Array(Le),Je=0;Je<Le;Je++)je[Je]=arguments[Je];var nt=H.tokenizer[Ee].apply(j,je);return nt===!1&&(nt=Ne.apply(j,je)),nt}};for(var ae in H.tokenizer)Y(ae);ie.tokenizer=j}(),H.walkTokens){var de=Ue.defaults.walkTokens;ie.walkTokens=function(j){H.walkTokens(j),de&&de(j)}}Ue.setOptions(ie)},Ue.walkTokens=function(H,ie){for(var de=P(H),j;!(j=de()).done;){var Y=j.value;switch(ie(Y),Y.type){case"table":{for(var ae=P(Y.tokens.header),he;!(he=ae()).done;){var Ee=he.value;Ue.walkTokens(Ee,ie)}for(var Ne=P(Y.tokens.cells),Le;!(Le=Ne()).done;)for(var je=Le.value,Je=P(je),nt;!(nt=Je()).done;){var rt=nt.value;Ue.walkTokens(rt,ie)}break}case"list":{Ue.walkTokens(Y.items,ie);break}default:Y.tokens&&Ue.walkTokens(Y.tokens,ie)}}},Ue.parseInline=function(H,ie){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");ie=Ke({},Ue.defaults,ie||{}),V(ie);try{var de=ne.lexInline(H,ie);return ie.walkTokens&&Ue.walkTokens(de,ie.walkTokens),be.parseInline(de,ie)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+X(j.message+"",!0)+"</pre>";throw j}},Ue.Parser=be,Ue.parser=be.parse,Ue.Renderer=Oe,Ue.TextRenderer=me,Ue.Lexer=ne,Ue.lexer=ne.lex,Ue.Tokenizer=W,Ue.Slugger=Ce,Ue.parse=Ue;var Ze=Ue;return Ze}),define(ve[79],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(S,D,y){return Math.min(Math.max(S,D),y)}e.clamp=E;function C(S,D){return(D+S%D)%D}e.rot=C;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class A{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function ee(P){const A=[];typeof P=="number"&&A.push("code/timeOrigin",P);function S(y){A.push(y,Date.now())}function D(){const y=[];for(let n=0;n<A.length;n+=2)y.push({name:A[n],startTime:A[n+1]});return y}return{mark:S,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const S of performance.getEntriesByType("mark"))A.push({name:S.name,startTime:Math.round(P+S.startTime)});return A}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=E(C))})(),define(ve[21],_e([0,1]),function(ee,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const C="en";let P=!1,A=!1,S=!1,D=!1,y=!1,n=!1,T=!1,k,h=C,f,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.globals.vscode!="undefined"?s=e.globals.vscode.process:typeof process!="undefined"&&(s=process);const _=typeof((E=s==null?void 0:s.versions)===null||E===void 0?void 0:E.electron)=="string"&&s.type==="renderer";if(e.isElectronSandboxed=_&&(s==null?void 0:s.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=s==null?void 0:s.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)r=navigator.userAgent,P=r.indexOf("Windows")>=0,A=r.indexOf("Macintosh")>=0,T=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,n=!0,k=navigator.language,h=k;else if(typeof s=="object"){P=s.platform==="win32",A=s.platform==="darwin",S=s.platform==="linux",D=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,k=C,h=C;const a=s.env.VSCODE_NLS_CONFIG;if(a)try{const l=JSON.parse(a),o=l.availableLanguages["*"];k=l.locale,h=o||C,f=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var m;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function b(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let v=0;A?v=1:P?v=3:S&&(v=2),e.isWindows=P,e.isMacintosh=A,e.isLinux=S,e.isLinuxSnap=D,e.isNative=y,e.isWeb=n,e.isIOS=T,e.platform=v,e.userAgent=r,e.language=h;var d;(function(a){function l(){return e.language}a.value=l;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=o;function w(){return e.language==="en"}a.isDefault=w})(d=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let p=0,g=o.length;p<g;p++){const R=o[p];if(R.id===I.data.vscodeSetImmediateId){o.splice(p,1),R.callback();return}}});let w=0;return I=>{const p=++w;o.push({id:p,callback:I}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof(s==null?void 0:s.nextTick)=="function")return s.nextTick.bind(s);const l=Promise.resolve();return o=>l.then(o)}();var u;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||T?2:P?1:3;let t=!0,i=!1;function c(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=c}),define(ve[45],_e([0,1,21]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let C;if(typeof E.globals.vscode!="undefined"){const P=E.globals.vscode.process;C={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(A){return(0,E.setImmediate)(A)}}}else typeof process!="undefined"?C={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:C={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(P){return(0,E.setImmediate)(P)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.platform=C.platform,e.nextTick=C.nextTick}),define(ve[12],_e([0,1,45]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const C=65,P=97,A=90,S=122,D=46,y=47,n=92,T=58,k=63;class h extends Error{constructor(d,u,t){let i;typeof u=="string"&&u.indexOf("not ")===0?(i="must not be",u=u.replace(/^not /,"")):i="must be";const c=d.indexOf(".")!==-1?"property":"argument";let a=`The "${d}" ${c} ${i} of type ${u}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(v,d){if(typeof v!="string")throw new h(d,"string",v)}function r(v){return v===y||v===n}function s(v){return v===y}function _(v){return v>=C&&v<=A||v>=P&&v<=S}function m(v,d,u,t){let i="",c=0,a=-1,l=0,o=0;for(let w=0;w<=v.length;++w){if(w<v.length)o=v.charCodeAt(w);else{if(t(o))break;o=y}if(t(o)){if(!(a===w-1||l===1))if(l===2){if(i.length<2||c!==2||i.charCodeAt(i.length-1)!==D||i.charCodeAt(i.length-2)!==D){if(i.length>2){const I=i.lastIndexOf(u);I===-1?(i="",c=0):(i=i.slice(0,I),c=i.length-1-i.lastIndexOf(u)),a=w,l=0;continue}else if(i.length!==0){i="",c=0,a=w,l=0;continue}}d&&(i+=i.length>0?`${u}..`:"..",c=2)}else i.length>0?i+=`${u}${v.slice(a+1,w)}`:i=v.slice(a+1,w),c=w-a-1;a=w,l=0}else o===D&&l!==-1?++l:l=-1}return i}function b(v,d){if(d===null||typeof d!="object")throw new h("pathObject","Object",d);const u=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return u?u===d.root?`${u}${t}`:`${u}${v}${t}`:t}e.win32={resolve(...v){let d="",u="",t=!1;for(let i=v.length-1;i>=-1;i--){let c;if(i>=0){if(c=v[i],f(c,"path"),c.length===0)continue}else d.length===0?c=E.cwd():(c=E.env[`=${d}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==d.toLowerCase()&&c.charCodeAt(2)===n)&&(c=`${d}\\`));const a=c.length;let l=0,o="",w=!1;const I=c.charCodeAt(0);if(a===1)r(I)&&(l=1,w=!0);else if(r(I))if(w=!0,r(c.charCodeAt(1))){let p=2,g=p;for(;p<a&&!r(c.charCodeAt(p));)p++;if(p<a&&p!==g){const R=c.slice(g,p);for(g=p;p<a&&r(c.charCodeAt(p));)p++;if(p<a&&p!==g){for(g=p;p<a&&!r(c.charCodeAt(p));)p++;(p===a||p!==g)&&(o=`\\\\${R}\\${c.slice(g,p)}`,l=p)}}}else l=1;else _(I)&&c.charCodeAt(1)===T&&(o=c.slice(0,2),l=2,a>2&&r(c.charCodeAt(2))&&(w=!0,l=3));if(o.length>0)if(d.length>0){if(o.toLowerCase()!==d.toLowerCase())continue}else d=o;if(t){if(d.length>0)break}else if(u=`${c.slice(l)}\\${u}`,t=w,w&&d.length>0)break}return u=m(u,!t,"\\",r),t?`${d}\\${u}`:`${d}${u}`||"."},normalize(v){f(v,"path");const d=v.length;if(d===0)return".";let u=0,t,i=!1;const c=v.charCodeAt(0);if(d===1)return s(c)?"\\":v;if(r(c))if(i=!0,r(v.charCodeAt(1))){let l=2,o=l;for(;l<d&&!r(v.charCodeAt(l));)l++;if(l<d&&l!==o){const w=v.slice(o,l);for(o=l;l<d&&r(v.charCodeAt(l));)l++;if(l<d&&l!==o){for(o=l;l<d&&!r(v.charCodeAt(l));)l++;if(l===d)return`\\\\${w}\\${v.slice(o)}\\`;l!==o&&(t=`\\\\${w}\\${v.slice(o,l)}`,u=l)}}}else u=1;else _(c)&&v.charCodeAt(1)===T&&(t=v.slice(0,2),u=2,d>2&&r(v.charCodeAt(2))&&(i=!0,u=3));let a=u<d?m(v.slice(u),!i,"\\",r):"";return a.length===0&&!i&&(a="."),a.length>0&&r(v.charCodeAt(d-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(v){f(v,"path");const d=v.length;if(d===0)return!1;const u=v.charCodeAt(0);return r(u)||d>2&&_(u)&&v.charCodeAt(1)===T&&r(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let d,u;for(let c=0;c<v.length;++c){const a=v[c];f(a,"path"),a.length>0&&(d===void 0?d=u=a:d+=`\\${a}`)}if(d===void 0)return".";let t=!0,i=0;if(typeof u=="string"&&r(u.charCodeAt(0))){++i;const c=u.length;c>1&&r(u.charCodeAt(1))&&(++i,c>2&&(r(u.charCodeAt(2))?++i:t=!1))}if(t){for(;i<d.length&&r(d.charCodeAt(i));)i++;i>=2&&(d=`\\${d.slice(i)}`)}return e.win32.normalize(d)},relative(v,d){if(f(v,"from"),f(d,"to"),v===d)return"";const u=e.win32.resolve(v),t=e.win32.resolve(d);if(u===t||(v=u.toLowerCase(),d=t.toLowerCase(),v===d))return"";let i=0;for(;i<v.length&&v.charCodeAt(i)===n;)i++;let c=v.length;for(;c-1>i&&v.charCodeAt(c-1)===n;)c--;const a=c-i;let l=0;for(;l<d.length&&d.charCodeAt(l)===n;)l++;let o=d.length;for(;o-1>l&&d.charCodeAt(o-1)===n;)o--;const w=o-l,I=a<w?a:w;let p=-1,g=0;for(;g<I;g++){const F=v.charCodeAt(i+g);if(F!==d.charCodeAt(l+g))break;F===n&&(p=g)}if(g!==I){if(p===-1)return t}else{if(w>I){if(d.charCodeAt(l+g)===n)return t.slice(l+g+1);if(g===2)return t.slice(l+g)}a>I&&(v.charCodeAt(i+g)===n?p=g:g===2&&(p=3)),p===-1&&(p=0)}let R="";for(g=i+p+1;g<=c;++g)(g===c||v.charCodeAt(g)===n)&&(R+=R.length===0?"..":"\\..");return l+=p,R.length>0?`${R}${t.slice(l,o)}`:(t.charCodeAt(l)===n&&++l,t.slice(l,o))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const d=e.win32.resolve(v);if(d.length<=2)return v;if(d.charCodeAt(0)===n){if(d.charCodeAt(1)===n){const u=d.charCodeAt(2);if(u!==k&&u!==D)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(_(d.charCodeAt(0))&&d.charCodeAt(1)===T&&d.charCodeAt(2)===n)return`\\\\?\\${d}`;return v},dirname(v){f(v,"path");const d=v.length;if(d===0)return".";let u=-1,t=0;const i=v.charCodeAt(0);if(d===1)return r(i)?v:".";if(r(i)){if(u=t=1,r(v.charCodeAt(1))){let l=2,o=l;for(;l<d&&!r(v.charCodeAt(l));)l++;if(l<d&&l!==o){for(o=l;l<d&&r(v.charCodeAt(l));)l++;if(l<d&&l!==o){for(o=l;l<d&&!r(v.charCodeAt(l));)l++;if(l===d)return v;l!==o&&(u=t=l+1)}}}}else _(i)&&v.charCodeAt(1)===T&&(u=d>2&&r(v.charCodeAt(2))?3:2,t=u);let c=-1,a=!0;for(let l=d-1;l>=t;--l)if(r(v.charCodeAt(l))){if(!a){c=l;break}}else a=!1;if(c===-1){if(u===-1)return".";c=u}return v.slice(0,c)},basename(v,d){d!==void 0&&f(d,"ext"),f(v,"path");let u=0,t=-1,i=!0,c;if(v.length>=2&&_(v.charCodeAt(0))&&v.charCodeAt(1)===T&&(u=2),d!==void 0&&d.length>0&&d.length<=v.length){if(d===v)return"";let a=d.length-1,l=-1;for(c=v.length-1;c>=u;--c){const o=v.charCodeAt(c);if(r(o)){if(!i){u=c+1;break}}else l===-1&&(i=!1,l=c+1),a>=0&&(o===d.charCodeAt(a)?--a==-1&&(t=c):(a=-1,t=l))}return u===t?t=l:t===-1&&(t=v.length),v.slice(u,t)}for(c=v.length-1;c>=u;--c)if(r(v.charCodeAt(c))){if(!i){u=c+1;break}}else t===-1&&(i=!1,t=c+1);return t===-1?"":v.slice(u,t)},extname(v){f(v,"path");let d=0,u=-1,t=0,i=-1,c=!0,a=0;v.length>=2&&v.charCodeAt(1)===T&&_(v.charCodeAt(0))&&(d=t=2);for(let l=v.length-1;l>=d;--l){const o=v.charCodeAt(l);if(r(o)){if(!c){t=l+1;break}continue}i===-1&&(c=!1,i=l+1),o===D?u===-1?u=l:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||i===-1||a===0||a===1&&u===i-1&&u===t+1?"":v.slice(u,i)},format:b.bind(null,"\\"),parse(v){f(v,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return d;const u=v.length;let t=0,i=v.charCodeAt(0);if(u===1)return r(i)?(d.root=d.dir=v,d):(d.base=d.name=v,d);if(r(i)){if(t=1,r(v.charCodeAt(1))){let p=2,g=p;for(;p<u&&!r(v.charCodeAt(p));)p++;if(p<u&&p!==g){for(g=p;p<u&&r(v.charCodeAt(p));)p++;if(p<u&&p!==g){for(g=p;p<u&&!r(v.charCodeAt(p));)p++;p===u?t=p:p!==g&&(t=p+1)}}}}else if(_(i)&&v.charCodeAt(1)===T){if(u<=2)return d.root=d.dir=v,d;if(t=2,r(v.charCodeAt(2))){if(u===3)return d.root=d.dir=v,d;t=3}}t>0&&(d.root=v.slice(0,t));let c=-1,a=t,l=-1,o=!0,w=v.length-1,I=0;for(;w>=t;--w){if(i=v.charCodeAt(w),r(i)){if(!o){a=w+1;break}continue}l===-1&&(o=!1,l=w+1),i===D?c===-1?c=w:I!==1&&(I=1):c!==-1&&(I=-1)}return l!==-1&&(c===-1||I===0||I===1&&c===l-1&&c===a+1?d.base=d.name=v.slice(a,l):(d.name=v.slice(a,c),d.base=v.slice(a,l),d.ext=v.slice(c,l))),a>0&&a!==t?d.dir=v.slice(0,a-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let d="",u=!1;for(let t=v.length-1;t>=-1&&!u;t--){const i=t>=0?v[t]:E.cwd();f(i,"path"),i.length!==0&&(d=`${i}/${d}`,u=i.charCodeAt(0)===y)}return d=m(d,!u,"/",s),u?`/${d}`:d.length>0?d:"."},normalize(v){if(f(v,"path"),v.length===0)return".";const d=v.charCodeAt(0)===y,u=v.charCodeAt(v.length-1)===y;return v=m(v,!d,"/",s),v.length===0?d?"/":u?"./":".":(u&&(v+="/"),d?`/${v}`:v)},isAbsolute(v){return f(v,"path"),v.length>0&&v.charCodeAt(0)===y},join(...v){if(v.length===0)return".";let d;for(let u=0;u<v.length;++u){const t=v[u];f(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(v,d){if(f(v,"from"),f(d,"to"),v===d||(v=e.posix.resolve(v),d=e.posix.resolve(d),v===d))return"";const u=1,t=v.length,i=t-u,c=1,a=d.length-c,l=i<a?i:a;let o=-1,w=0;for(;w<l;w++){const p=v.charCodeAt(u+w);if(p!==d.charCodeAt(c+w))break;p===y&&(o=w)}if(w===l)if(a>l){if(d.charCodeAt(c+w)===y)return d.slice(c+w+1);if(w===0)return d.slice(c+w)}else i>l&&(v.charCodeAt(u+w)===y?o=w:w===0&&(o=0));let I="";for(w=u+o+1;w<=t;++w)(w===t||v.charCodeAt(w)===y)&&(I+=I.length===0?"..":"/..");return`${I}${d.slice(c+o)}`},toNamespacedPath(v){return v},dirname(v){if(f(v,"path"),v.length===0)return".";const d=v.charCodeAt(0)===y;let u=-1,t=!0;for(let i=v.length-1;i>=1;--i)if(v.charCodeAt(i)===y){if(!t){u=i;break}}else t=!1;return u===-1?d?"/":".":d&&u===1?"//":v.slice(0,u)},basename(v,d){d!==void 0&&f(d,"ext"),f(v,"path");let u=0,t=-1,i=!0,c;if(d!==void 0&&d.length>0&&d.length<=v.length){if(d===v)return"";let a=d.length-1,l=-1;for(c=v.length-1;c>=0;--c){const o=v.charCodeAt(c);if(o===y){if(!i){u=c+1;break}}else l===-1&&(i=!1,l=c+1),a>=0&&(o===d.charCodeAt(a)?--a==-1&&(t=c):(a=-1,t=l))}return u===t?t=l:t===-1&&(t=v.length),v.slice(u,t)}for(c=v.length-1;c>=0;--c)if(v.charCodeAt(c)===y){if(!i){u=c+1;break}}else t===-1&&(i=!1,t=c+1);return t===-1?"":v.slice(u,t)},extname(v){f(v,"path");let d=-1,u=0,t=-1,i=!0,c=0;for(let a=v.length-1;a>=0;--a){const l=v.charCodeAt(a);if(l===y){if(!i){u=a+1;break}continue}t===-1&&(i=!1,t=a+1),l===D?d===-1?d=a:c!==1&&(c=1):d!==-1&&(c=-1)}return d===-1||t===-1||c===0||c===1&&d===t-1&&d===u+1?"":v.slice(d,t)},format:b.bind(null,"/"),parse(v){f(v,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return d;const u=v.charCodeAt(0)===y;let t;u?(d.root="/",t=1):t=0;let i=-1,c=0,a=-1,l=!0,o=v.length-1,w=0;for(;o>=t;--o){const I=v.charCodeAt(o);if(I===y){if(!l){c=o+1;break}continue}a===-1&&(l=!1,a=o+1),I===D?i===-1?i=o:w!==1&&(w=1):i!==-1&&(w=-1)}if(a!==-1){const I=c===0&&u?1:c;i===-1||w===0||w===1&&i===a-1&&i===c+1?d.base=d.name=v.slice(I,a):(d.name=v.slice(I,i),d.base=v.slice(I,a),d.ext=v.slice(i,a))}return c>0?d.dir=v.slice(0,c-1):u&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[56],_e([0,1,21]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const C=E.globals.performance&&typeof E.globals.performance.now=="function";class P{constructor(S){this._highResolution=C&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new P(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=P}),define(ve[3],_e([0,1,10,53,6,44,56]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(m){m.None=()=>P.Disposable.None;function b(z){return(B,G=null,M)=>{let N=!1,W;return W=z(Q=>{if(!N)return W?W.dispose():N=!0,B.call(G,Q)},null,M),N&&W.dispose(),W}}m.once=b;function v(z,B){return a((G,M=null,N)=>z(W=>G.call(M,B(W)),null,N))}m.map=v;function d(z,B){return a((G,M=null,N)=>z(W=>{B(W),G.call(M,W)},null,N))}m.forEach=d;function u(z,B){return a((G,M=null,N)=>z(W=>B(W)&&G.call(M,W),null,N))}m.filter=u;function t(z){return z}m.signal=t;function i(...z){return(B,G=null,M)=>(0,P.combinedDisposable)(...z.map(N=>N(W=>B.call(G,W),null,M)))}m.any=i;function c(z,B,G){let M=G;return v(z,N=>(M=B(M,N),M))}m.reduce=c;function a(z){let B;const G=new h({onFirstListenerAdd(){B=z(G.fire,G)},onLastListenerRemove(){B.dispose()}});return G.event}m.snapshot=a;function l(z,B,G=100,M=!1,N){let W,Q,x,Z=0;const re=new h({leakWarningThreshold:N,onFirstListenerAdd(){W=z(oe=>{Z++,Q=B(Q,oe),M&&!x&&(re.fire(Q),Q=void 0),clearTimeout(x),x=setTimeout(()=>{const ye=Q;Q=void 0,x=void 0,(!M||Z>1)&&re.fire(ye),Z=0},G)})},onLastListenerRemove(){W.dispose()}});return re.event}m.debounce=l;function o(z){const B=new Date().getTime();return v(b(z),G=>new Date().getTime()-B)}m.stopwatch=o;function w(z){let B=!0,G;return u(z,M=>{const N=B||M!==G;return B=!1,G=M,N})}m.latch=w;function I(z,B=!1,G=[]){let M=G.slice(),N=z(x=>{M?M.push(x):Q.fire(x)});const W=()=>{M&&M.forEach(x=>Q.fire(x)),M=null},Q=new h({onFirstListenerAdd(){N||(N=z(x=>Q.fire(x)))},onFirstListenerDidAdd(){M&&(B?setTimeout(W):W())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Q.event}m.buffer=I;class p{constructor(B){this.event=B}map(B){return new p(v(this.event,B))}forEach(B){return new p(d(this.event,B))}filter(B){return new p(u(this.event,B))}reduce(B,G){return new p(c(this.event,B,G))}latch(){return new p(w(this.event))}debounce(B,G=100,M=!1,N){return new p(l(this.event,B,G,M,N))}on(B,G,M){return this.event(B,G,M)}once(B,G,M){return b(this.event)(B,G,M)}}function g(z){return new p(z)}m.chain=g;function R(z,B,G=M=>M){const M=(...x)=>Q.fire(G(...x)),N=()=>z.on(B,M),W=()=>z.removeListener(B,M),Q=new h({onFirstListenerAdd:N,onLastListenerRemove:W});return Q.event}m.fromNodeEventEmitter=R;function F(z,B,G=M=>M){const M=(...x)=>Q.fire(G(...x)),N=()=>z.addEventListener(B,M),W=()=>z.removeEventListener(B,M),Q=new h({onFirstListenerAdd:N,onLastListenerRemove:W});return Q.event}m.fromDOMEventEmitter=F;function $(z){const B=new h;let G=!1;return z.then(void 0,()=>null).then(()=>{G?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),G=!0,B.event}m.fromPromise=$;function ue(z){return new Promise(B=>b(z)(B))}m.toPromise=ue})(D=e.Event||(e.Event={}));class y{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${y._idPool++}`}start(b){this._stopWatch=new S.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function T(m){const b=n;return n=m,{dispose(){n=b}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(b,v=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b){let v=n;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),!(v<=0||b<v)){this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(d)||0;if(this._stacks.set(d,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let t,i=0;for(const[c,a]of this._stacks)(!t||i<a)&&(t=c,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}}class h{constructor(b){var v;this._disposed=!1,this._options=b,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((v=this._options)===null||v===void 0?void 0:v._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(b,v,d)=>{var u;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(v?[b,v]:b);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,v);const c=(u=this._leakageMon)===null||u===void 0?void 0:u.check(this._listeners.size);let a;return a={dispose:()=>{c&&c(),a.dispose=h._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof P.DisposableStore?d.add(a):Array.isArray(d)&&d.push(a),a}),this._event}fire(b){var v,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,b]);for((v=this._perfMon)===null||v===void 0||v.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(i){(0,E.onUnexpectedError)(i)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var b,v,d;(b=this._listeners)===null||b===void 0||b.clear(),(v=this._deliveryQueue)===null||v===void 0||v.clear(),(d=this._leakageMon)===null||d===void 0||d.dispose(),this._disposed=!0}}e.Emitter=h,h._noop=function(){};class f extends h{constructor(b){super(b);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=b==null?void 0:b.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}e.PauseableEmitter=f;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const v={event:b,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const d=()=>{this.hasListeners&&this.unhook(v);const u=this.events.indexOf(v);this.events.splice(u,1)};return(0,P.toDisposable)((0,C.once)(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(v=>this.emitter.fire(v))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(b){return(v,d,u)=>b(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(d,t)):v.call(d,t)},void 0,u)}bufferEvents(b){const v=[];this.buffers.push(v);const d=b();return this.buffers.pop(),v.forEach(u=>u()),d}}e.EventBufferer=s;class _{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=P.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(ve[20],_e([0,1,3]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const C=Object.freeze(function(D,y){const n=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(n)}}});var P;(function(D){function y(n){return n===D.None||n===D.Cancelled||n instanceof A?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(P=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?C:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=P.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=S}),define(ve[36],_e([0,1,3]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class C{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new C;e.iconRegistry=P;function A(n,T){return new S(n,T)}e.registerCodicon=A;class S{constructor(T,k,h){this.id=T,this.definition=k,this.description=h,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function D(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=D;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(r){if(r instanceof S)return["codicon","codicon-"+r.id];const s=T.exec(r.id);if(!s)return k(S.error);let[,_,m]=s;const b=["codicon","codicon-"+_];return m&&b.push("codicon-modifier-"+m.substr(1)),b}n.asClassNameArray=k;function h(r){return k(r).join(" ")}n.asClassName=h;function f(r){return"."+k(r).join(".")}n.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(ve[107],_e([0,1,10,6]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(m){const b=m;return b&&[b.on,b.pause,b.resume,b.destroy].every(v=>typeof v=="function")}e.isReadableStream=P;function A(m){const b=m;return b&&P(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean"}e.isReadableBufferedStream=A;function S(m,b){return new D(m,b)}e.newWriteableStream=S;class D{constructor(b,v){this.reducer=b,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(v=>v(b))}emitError(b){this.listeners.error.length===0?(0,E.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(v=>v(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,v){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(b,v){if(!this.state.destroyed){let d;switch(b){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const u=d.indexOf(v);u>=0&&d.splice(u,1)}}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(m,b){const v=[];let d;for(;(d=m.read())!==null;)v.push(d);return b(v)}e.consumeReadable=y;function n(m,b,v){const d=[];let u;for(;(u=m.read())!==null&&d.length<v;)d.push(u);return u===null&&d.length>0?b(d):{read:()=>{if(d.length>0)return d.shift();if(typeof u!="undefined"){const t=u;return u=void 0,t}return m.read()}}}e.peekReadable=n;function T(m,b){return new Promise((v,d)=>{const u=[];k(m,{onData:t=>{b&&u.push(t)},onError:t=>{b?d(t):v(void 0)},onEnd:()=>{v(b?b(u):void 0)}})})}e.consumeStream=T;function k(m,b){m.on("error",v=>b.onError(v)),m.on("end",()=>b.onEnd()),m.on("data",v=>b.onData(v))}e.listenStream=k;function h(m,b){return new Promise((v,d)=>{const u=new C.DisposableStore,t=[],i=l=>{if(t.push(l),t.length>b)return u.dispose(),m.pause(),v({stream:m,buffer:t,ended:!1})},c=l=>d(l),a=()=>v({stream:m,buffer:t,ended:!0});u.add((0,C.toDisposable)(()=>m.removeListener("error",c))),m.on("error",c),u.add((0,C.toDisposable)(()=>m.removeListener("end",a))),m.on("end",a),u.add((0,C.toDisposable)(()=>m.removeListener("data",i))),m.on("data",i)})}e.peekStream=h;function f(m,b){const v=S(b);return v.end(m),v}e.toStream=f;function r(){const m=S(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=r;function s(m){let b=!1;return{read:()=>b?null:(b=!0,m)}}e.toReadable=s;function _(m,b,v){const d=S(v);return k(m,{onData:u=>d.write(b.data(u)),onError:u=>d.error(b.error?b.error(u):u),onEnd:()=>d.end()}),d}e.transform=_}),define(ve[8],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=E;const C=/{(\d+)}/g;function P(H,...ie){return ie.length===0?H:H.replace(C,function(de,j){const Y=parseInt(j,10);return isNaN(Y)||Y<0||Y>=ie.length?de:ie[Y]})}e.format=P;function A(H){return H.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=A;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function D(H,ie){let de=0;const j=ie.charCodeAt(0);for(let Y=H.length-1;Y>=0;Y--)H.charCodeAt(Y)===j&&de++;return de}e.count=D;function y(H,ie,de="\u2026"){return H.length<=ie?H:`${H.substr(0,ie)}${de}`}e.truncate=y;function n(H,ie=" "){const de=T(H,ie);return k(de,ie)}e.trim=n;function T(H,ie){if(!H||!ie)return H;const de=ie.length;if(de===0||H.length===0)return H;let j=0;for(;H.indexOf(ie,j)===j;)j=j+de;return H.substring(j)}e.ltrim=T;function k(H,ie){if(!H||!ie)return H;const de=ie.length,j=H.length;if(de===0||j===0)return H;let Y=j,ae=-1;for(;ae=H.lastIndexOf(ie,Y-1),!(ae===-1||ae+de!==Y);){if(ae===0)return"";Y=ae}return H.substring(0,Y)}e.rtrim=k;function h(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function f(H){return H.replace(/\*/g,"")}e.stripWildcards=f;function r(H,ie,de={}){if(!H)throw new Error("Cannot create regex from empty string");ie||(H=S(H)),de.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let j="";return de.global&&(j+="g"),de.matchCase||(j+="i"),de.multiline&&(j+="m"),de.unicode&&(j+="u"),new RegExp(H,j)}e.createRegExp=r;function s(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function _(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function m(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=m;function b(H){return H.split(/\r\n|\r|\n/)}e.splitLines=b;function v(H){for(let ie=0,de=H.length;ie<de;ie++){const j=H.charCodeAt(ie);if(j!==32&&j!==9)return ie}return-1}e.firstNonWhitespaceIndex=v;function d(H,ie=0,de=H.length){for(let j=ie;j<de;j++){const Y=H.charCodeAt(j);if(Y!==32&&Y!==9)return H.substring(ie,j)}return H.substring(ie,de)}e.getLeadingWhitespace=d;function u(H,ie=H.length-1){for(let de=ie;de>=0;de--){const j=H.charCodeAt(de);if(j!==32&&j!==9)return de}return-1}e.lastNonWhitespaceIndex=u;function t(H,ie){return H<ie?-1:H>ie?1:0}e.compare=t;function i(H,ie,de=0,j=H.length,Y=0,ae=ie.length){for(;de<j&&Y<ae;de++,Y++){let Ne=H.charCodeAt(de),Le=ie.charCodeAt(Y);if(Ne<Le)return-1;if(Ne>Le)return 1}const he=j-de,Ee=ae-Y;return he<Ee?-1:he>Ee?1:0}e.compareSubstring=i;function c(H,ie){return a(H,ie,0,H.length,0,ie.length)}e.compareIgnoreCase=c;function a(H,ie,de=0,j=H.length,Y=0,ae=ie.length){for(;de<j&&Y<ae;de++,Y++){let Ne=H.charCodeAt(de),Le=ie.charCodeAt(Y);if(Ne!==Le){const je=Ne-Le;if(!(je===32&&o(Le))&&!(je===-32&&o(Ne)))return l(Ne)&&l(Le)?je:i(H.toLowerCase(),ie.toLowerCase(),de,j,Y,ae)}}const he=j-de,Ee=ae-Y;return he<Ee?-1:he>Ee?1:0}e.compareSubstringIgnoreCase=a;function l(H){return H>=97&&H<=122}e.isLowerAsciiLetter=l;function o(H){return H>=65&&H<=90}e.isUpperAsciiLetter=o;function w(H){return l(H)||o(H)}function I(H,ie){return H.length===ie.length&&p(H,ie)}e.equalsIgnoreCase=I;function p(H,ie,de=H.length){for(let j=0;j<de;j++){const Y=H.charCodeAt(j),ae=ie.charCodeAt(j);if(Y!==ae){if(w(Y)&&w(ae)){const he=Math.abs(Y-ae);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(Y).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function g(H,ie){const de=ie.length;return ie.length>H.length?!1:p(H,ie,de)}e.startsWithIgnoreCase=g;function R(H,ie){let de,j=Math.min(H.length,ie.length);for(de=0;de<j;de++)if(H.charCodeAt(de)!==ie.charCodeAt(de))return de;return j}e.commonPrefixLength=R;function F(H,ie){let de,j=Math.min(H.length,ie.length);const Y=H.length-1,ae=ie.length-1;for(de=0;de<j;de++)if(H.charCodeAt(Y-de)!==ie.charCodeAt(ae-de))return de;return j}e.commonSuffixLength=F;function $(H){return 55296<=H&&H<=56319}e.isHighSurrogate=$;function ue(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ue;function z(H,ie){return(H-55296<<10)+(ie-56320)+65536}e.computeCodePoint=z;function B(H,ie,de){const j=H.charCodeAt(de);if($(j)&&de+1<ie){const Y=H.charCodeAt(de+1);if(ue(Y))return z(j,Y)}return j}e.getNextCodePoint=B;function G(H,ie){const de=H.charCodeAt(ie-1);if(ue(de)&&ie>1){const j=H.charCodeAt(ie-2);if($(j))return z(j,de)}return de}function M(H,ie){const de=Ue.getInstance(),j=ie,Y=H.length,ae=B(H,Y,ie);ie+=ae>=65536?2:1;let he=de.getGraphemeBreakType(ae);for(;ie<Y;){const Ee=B(H,Y,ie),Ne=de.getGraphemeBreakType(Ee);if(Me(he,Ne))break;ie+=Ee>=65536?2:1,he=Ne}return ie-j}e.nextCharLength=M;function N(H,ie){const de=Ue.getInstance(),j=ie,Y=G(H,ie);ie-=Y>=65536?2:1;let ae=de.getGraphemeBreakType(Y);for(;ie>0;){const he=G(H,ie),Ee=de.getGraphemeBreakType(he);if(Me(Ee,ae))break;ie-=he>=65536?2:1,ae=Ee}return j-ie}e.prevCharLength=N;function W(H,ie){const de=Ue.getInstance(),j=H.length,Y=ie,ae=B(H,j,ie),he=de.getGraphemeBreakType(ae);ie+=ae>=65536?2:1;let Ee=he;for(;ie<j;){const Le=B(H,j,ie),je=de.getGraphemeBreakType(Le);if(Me(Ee,je))break;ie+=Le>=65536?2:1,Ee=je}const Ne=ie;for(ie=Y,Ee=he;ie>0;){const Le=G(H,ie),je=de.getGraphemeBreakType(Le);if(Me(je,Ee))break;ie-=Le>=65536?2:1,Ee=je}return[ie,Ne]}function Q(H,ie){return ie>0&&ue(H.charCodeAt(ie))?W(H,ie-1):W(H,ie)}e.getCharContainingOffset=Q;function x(H){const ie=H.length;let de=0,j=0;for(;j<ie;){const he=B(H,ie,j);j+=he>=65536?2:1,he<128?de+=1:he<2048?de+=2:he<65536?de+=3:de+=4}const Y=new Uint8Array(de);j=0;let ae=0;for(;j<ie;){const he=B(H,ie,j);j+=he>=65536?2:1,he<128?Y[ae++]=he:he<2048?(Y[ae++]=192|(he&1984)>>>6,Y[ae++]=128|(he&63)>>>0):he<65536?(Y[ae++]=224|(he&61440)>>>12,Y[ae++]=128|(he&4032)>>>6,Y[ae++]=128|(he&63)>>>0):(Y[ae++]=240|(he&1835008)>>>18,Y[ae++]=128|(he&258048)>>>12,Y[ae++]=128|(he&4032)>>>6,Y[ae++]=128|(he&63)>>>0)}return Y}e.encodeUTF8=x;function Z(H){const ie=H.byteLength,de=[];let j=0;for(;j<ie;){const Y=H[j];let ae;if(Y>=240&&j+3<ie?ae=(H[j++]&7)<<18>>>0|(H[j++]&63)<<12>>>0|(H[j++]&63)<<6>>>0|(H[j++]&63)<<0>>>0:Y>=224&&j+2<ie?ae=(H[j++]&15)<<12>>>0|(H[j++]&63)<<6>>>0|(H[j++]&63)<<0>>>0:Y>=192&&j+1<ie?ae=(H[j++]&31)<<6>>>0|(H[j++]&63)<<0>>>0:ae=H[j++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)de.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const he=ae-65536,Ee=55296+((he&1047552)>>>10),Ne=56320+((he&1023)>>>0);de.push(String.fromCharCode(Ee)),de.push(String.fromCharCode(Ne))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=Z;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function oe(H){return re.test(H)}e.containsRTL=oe;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(H){return ye.test(H)}e.containsEmoji=Pe;const Be=/^[\t\n\r\x20-\x7E]*$/;function Re(H){return Be.test(H)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ze;function U(H){for(let ie=0,de=H.length;ie<de;ie++)if(K(H.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=U;function K(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=K;function ne(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ne;function le(H,ie){if(H.length<ie)return H;const de=/\b/g;let j=0;for(;de.test(H)&&!(H.length-de.lastIndex<ie);)j=de.lastIndex,de.lastIndex+=1;return H.substring(j).replace(/^\s/,"")}e.lcut=le;const fe=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function me(H){return H&&(H=H.replace(fe,""),H=H.replace(De,""),H=H.replace(Oe,"")),H}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Ae;function $e(H,ie){if(!H||!ie||H.length<ie.length)return!1;const de=ie.length,j=H.toLowerCase();let Y=0,ae=-1;for(;Y<de;){const he=j.indexOf(ie[Y],ae+1);if(he<0)return!1;ae=he,Y++}return!0}e.fuzzyContains=$e;function be(H,ie=!1){return H?(ie&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=be;function Ke(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ke;function V(H,ie=1){if(ie===0)return"";let de=-1;do de=H.indexOf(`
`,de+1),ie--;while(ie>0&&de>=0);return de===-1?H:(H[de-1]==="\r"&&de--,H.substr(0,de))}e.getNLines=V;function X(H){const ie=90-65+1;return H=H%(2*ie),H<ie?String.fromCharCode(97+H):String.fromCharCode(65+H-ie)}e.singleLetterHash=X;function ge(H){return Ue.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=ge;function Me(H,ie){return H===0?ie!==5&&ie!==7:H===2&&ie===3?!1:H===4||H===2||H===3||ie===4||ie===2||ie===3?!0:!(H===8&&(ie===8||ie===9||ie===11||ie===12)||(H===11||H===9)&&(ie===9||ie===10)||(H===12||H===10)&&ie===10||ie===5||ie===13||ie===7||H===1||H===13&&ie===14||H===6&&ie===6)}e.breakBetweenGraphemeBreakType=Me;var We;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Ze()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const de=this._data,j=de.length/3;let Y=1;for(;Y<=j;)if(ie<de[3*Y])Y=2*Y;else if(ie>de[3*Y+1])Y=2*Y+1;else return de[3*Y+2];return 0}}Ue._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ve[23],_e([0,1,8,107]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let D,y;class n{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return P?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return P&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,o){return!((o==null?void 0:o.dontUseNodeBuffer)||!1)&&P?new n(Buffer.from(l)):A?(D||(D=new TextEncoder),new n(D.encode(l))):new n(E.encodeUTF8(l))}static concat(l,o){if(typeof o=="undefined"){o=0;for(let p=0,g=l.length;p<g;p++)o+=l[p].byteLength}const w=n.alloc(o);let I=0;for(let p=0,g=l.length;p<g;p++){const R=l[p];w.set(R,I),I+=R.byteLength}return w}toString(){return P?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(l,o){return new n(this.buffer.subarray(l,o))}set(l,o){l instanceof n?this.buffer.set(l.buffer,o):this.buffer.set(l,o)}readUInt32BE(l){return h(this.buffer,l)}writeUInt32BE(l,o){f(this.buffer,l,o)}readUInt32LE(l){return r(this.buffer,l)}writeUInt32LE(l,o){s(this.buffer,l,o)}readUInt8(l){return _(this.buffer,l)}writeUInt8(l,o){m(this.buffer,l,o)}}e.VSBuffer=n;function T(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=T;function k(a,l,o){a[o+0]=l&255,l=l>>>8,a[o+1]=l&255}e.writeUInt16LE=k;function h(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=h;function f(a,l,o){a[o+3]=l,l=l>>>8,a[o+2]=l,l=l>>>8,a[o+1]=l,l=l>>>8,a[o]=l}e.writeUInt32BE=f;function r(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=r;function s(a,l,o){a[o+0]=l&255,l=l>>>8,a[o+1]=l&255,l=l>>>8,a[o+2]=l&255,l=l>>>8,a[o+3]=l&255}e.writeUInt32LE=s;function _(a,l){return a[l]}e.readUInt8=_;function m(a,l,o){a[o]=l}e.writeUInt8=m;function b(a){return C.consumeReadable(a,l=>n.concat(l))}e.readableToBuffer=b;function v(a){return C.toReadable(a)}e.bufferToReadable=v;function d(a){return C.consumeStream(a,l=>n.concat(l))}e.streamToBuffer=d;async function u(a){return a.ended?n.concat(a.buffer):n.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=u;function t(a){return C.toStream(a,l=>n.concat(l))}e.bufferToStream=t;function i(a){return C.transform(a,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=i;function c(a){return C.newWriteableStream(l=>n.concat(l),a)}e.newWriteableBufferStream=c}),define(ve[57],_e([0,1,8]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function C(m){return P(m,0)}e.hash=C;function P(m,b){switch(typeof m){case"object":return m===null?A(349,b):Array.isArray(m)?y(m,b):n(m,b);case"string":return D(m,b);case"boolean":return S(m,b);case"number":return A(m,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=P;function A(m,b){return(b<<5)-b+m|0}function S(m,b){return A(m?433:863,b)}function D(m,b){b=A(149417,b);for(let v=0,d=m.length;v<d;v++)b=A(m.charCodeAt(v),b);return b}e.stringHash=D;function y(m,b){return b=A(104579,b),m.reduce((v,d)=>P(d,v),b)}function n(m,b){return b=A(181387,b),Object.keys(m).sort().reduce((v,d)=>(v=D(d,v),P(m[d],v)),b)}class T{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=P(b,this._value),this._value}}e.Hasher=T;var k;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function h(m,b,v=32){const d=v-b,u=~((1<<d)-1);return(m<<b|(u&m)>>>d)>>>0}function f(m,b=0,v=m.byteLength,d=0){for(let u=0;u<v;u++)m[b+u]=d}function r(m,b,v="0"){for(;m.length<b;)m=v+m;return m}function s(m,b=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(v=>v.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),b/4)}e.toHexString=s;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const v=b.length;if(v!==0){const d=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,i,c;for(t!==0?(i=t,c=-1,t=0):(i=b.charCodeAt(0),c=0);;){let a=i;if(E.isHighSurrogate(i))if(c+1<v){const l=b.charCodeAt(c+1);E.isLowSurrogate(l)?(c++,a=E.computeCodePoint(i,l)):a=65533}else{t=i;break}else E.isLowSurrogate(i)&&(a=65533);if(u=this._push(d,u,a),c++,c<v)i=b.charCodeAt(c);else break}this._buffLen=u,this._leftoverHighSurrogate=t}}_push(b,v,d){return d<128?b[v++]=d:d<2048?(b[v++]=192|(d&1984)>>>6,b[v++]=128|(d&63)>>>0):d<65536?(b[v++]=224|(d&61440)>>>12,b[v++]=128|(d&4032)>>>6,b[v++]=128|(d&63)>>>0):(b[v++]=240|(d&1835008)>>>18,b[v++]=128|(d&258048)>>>12,b[v++]=128|(d&4032)>>>6,b[v++]=128|(d&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),s(this._h0)+s(this._h1)+s(this._h2)+s(this._h3)+s(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=_._bigBlock32,v=this._buffDV;for(let w=0;w<64;w+=4)b.setUint32(w,v.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)b.setUint32(w,h(b.getUint32(w-12,!1)^b.getUint32(w-32,!1)^b.getUint32(w-56,!1)^b.getUint32(w-64,!1),1),!1);let d=this._h0,u=this._h1,t=this._h2,i=this._h3,c=this._h4,a,l,o;for(let w=0;w<80;w++)w<20?(a=u&t|~u&i,l=1518500249):w<40?(a=u^t^i,l=1859775393):w<60?(a=u&t|u&i|t&i,l=2400959708):(a=u^t^i,l=3395469782),o=h(d,5)+a+c+l+b.getUint32(w*4,!1)&4294967295,c=i,i=t,t=h(u,30),u=d,d=o;this._h0=this._h0+d&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+c&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[46],_e([0,1,8]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const A="error",S="warning",D="warn",y="info";function n(T){return T?E.equalsIgnoreCase(A,T)?P.Error:E.equalsIgnoreCase(S,T)||E.equalsIgnoreCase(D,T)?P.Warning:E.equalsIgnoreCase(y,T)?P.Info:P.Ignore:P.Ignore}P.fromValue=n}(C||(C={})),e.default=C}),define(ve[13],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(o){return Array.isArray(o)}e.isArray=E;function C(o){return typeof o=="string"}e.isString=C;function P(o){return Array.isArray(o)&&o.every(w=>C(w))}e.isStringArray=P;function A(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=A;function S(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=S;function D(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=D;function y(o){return o===!0||o===!1}e.isBoolean=y;function n(o){return typeof o=="undefined"}e.isUndefined=n;function T(o){return!k(o)}e.isDefined=T;function k(o){return n(o)||o===null}e.isUndefinedOrNull=k;function h(o,w){if(!o)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=h;function f(o){if(k(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=f;function r(...o){const w=[];for(let I=0;I<o.length;I++){const p=o[I];if(k(p))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);w.push(p)}return w}e.assertAllDefined=r;const s=Object.prototype.hasOwnProperty;function _(o){if(!A(o))return!1;for(let w in o)if(s.call(o,w))return!1;return!0}e.isEmptyObject=_;function m(o){return typeof o=="function"}e.isFunction=m;function b(...o){return o.length>0&&o.every(m)}e.areFunctions=b;function v(o,w){const I=Math.min(o.length,w.length);for(let p=0;p<I;p++)d(o[p],w[p])}e.validateConstraints=v;function d(o,w){if(C(w)){if(typeof o!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(m(w)){try{if(o instanceof w)return}catch(I){}if(!k(o)&&o.constructor===w||w.length===1&&w.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function u(o){let w=[],I=Object.getPrototypeOf(o);for(;Object.prototype!==I;)w=w.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return w}e.getAllPropertyNames=u;function t(o){const w=[];for(const I of u(o))typeof o[I]=="function"&&w.push(I);return w}e.getAllMethodNames=t;function i(o,w){const I=g=>function(){const R=Array.prototype.slice.call(arguments,0);return w(g,R)};let p={};for(const g of o)p[g]=I(g);return p}e.createProxyObject=i;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function a(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=a;function l(o){return class{constructor(){return new Proxy({},{get(w,I){if(w[I])return w[I];throw new Error(`Not Implemented: ${o}->${String(I)}`)}})}}}e.NotImplementedProxy=l}),define(ve[37],_e([0,1,21,8,12,13]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function D(i){return i.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=D;function y(i,c=P.posix.sep){if(!i)return"";const a=i.length,l=i.charCodeAt(0);if(S(l)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let w=3;const I=w;for(;w<a&&!S(i.charCodeAt(w));w++);if(I!==w&&!S(i.charCodeAt(w+1))){for(w+=1;w<a;w++)if(S(i.charCodeAt(w)))return i.slice(0,w+1).replace(/[\\/]/g,c)}}return c}else if(_(l)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+c:i.slice(0,2);let o=i.indexOf("://");if(o!==-1){for(o+=3;o<a;o++)if(S(i.charCodeAt(o)))return i.slice(0,o+1)}return""}e.getRoot=y;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let c=i.charCodeAt(0);if(c!==92||(c=i.charCodeAt(1),c!==92))return!1;let a=2;const l=a;for(;a<i.length&&(c=i.charCodeAt(a),c!==92);a++);return!(l===a||(c=i.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,c=E.isWindows){const a=c?T:k;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||c&&h.test(i)||i==="."||i===".."||c&&i[i.length-1]==="."||c&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function r(i,c,a){const l=i===c;return!a||l?l:!i||!c?!1:(0,C.equalsIgnoreCase)(i,c)}e.isEqual=r;function s(i,c,a,l=P.sep){if(i===c)return!0;if(!i||!c||c.length>i.length)return!1;if(a){if(!(0,C.startsWithIgnoreCase)(i,c))return!1;if(c.length===i.length)return!0;let w=c.length;return c.charAt(c.length-1)===l&&w--,i.charAt(w)===l}return c.charAt(c.length-1)!==l&&(c+=l),i.indexOf(c)===0}e.isEqualOrParent=s;function _(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=_;function m(i,c){return E.isWindows&&i.endsWith(":")&&(i+=P.sep),(0,P.isAbsolute)(i)||(i=(0,P.join)(c,i)),i=(0,P.normalize)(i),E.isWindows?(i=(0,C.rtrim)(i,P.sep),i.endsWith(":")&&(i+=P.sep)):(i=(0,C.rtrim)(i,P.sep),i||(i=P.sep)),i}e.sanitizeFilePath=m;function b(i){const c=(0,P.normalize)(i);return E.isWindows?i.length>3?!1:v(c)&&(i.length===2||c.charCodeAt(2)===92):c===P.posix.sep}e.isRootOrDriveLetter=b;function v(i){return E.isWindows?_(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function d(i){return v(i)?i[0]:void 0}e.getDriveLetter=d;function u(i,c,a){return c.length>i.length?-1:i===c?0:(a&&(i=i.toLowerCase(),c=c.toLowerCase()),i.indexOf(c))}e.indexOfPath=u;function t(i){const c=i.split(":");let a,l,o;if(c.forEach(w=>{const I=Number(w);(0,A.isNumber)(I)?l===void 0?l=I:o===void 0&&(o=I):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:o!==void 0?o:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[24],_e([0,1,13]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function C(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const s=Array.isArray(r)?[]:{};return Object.keys(r).forEach(_=>{r[_]&&typeof r[_]=="object"?s[_]=C(r[_]):s[_]=r[_]}),s}e.deepClone=C;function P(r){if(!r||typeof r!="object")return r;const s=[r];for(;s.length>0;){const _=s.shift();Object.freeze(_);for(const m in _)if(A.call(_,m)){const b=_[m];typeof b=="object"&&!Object.isFrozen(b)&&s.push(b)}}return r}e.deepFreeze=P;const A=Object.prototype.hasOwnProperty;function S(r,s){return D(r,s,new Set)}e.cloneAndChange=S;function D(r,s,_){if((0,E.isUndefinedOrNull)(r))return r;const m=s(r);if(typeof m!="undefined")return m;if((0,E.isArray)(r)){const b=[];for(const v of r)b.push(D(v,s,_));return b}if((0,E.isObject)(r)){if(_.has(r))throw new Error("Cannot clone recursive data-structure");_.add(r);const b={};for(let v in r)A.call(r,v)&&(b[v]=D(r[v],s,_));return _.delete(r),b}return r}function y(r,s,_=!0){return(0,E.isObject)(r)?((0,E.isObject)(s)&&Object.keys(s).forEach(m=>{m in r?_&&((0,E.isObject)(r[m])&&(0,E.isObject)(s[m])?y(r[m],s[m],_):r[m]=s[m]):r[m]=s[m]}),r):s}e.mixin=y;function n(r,s){if(r===s)return!0;if(r==null||s===null||s===void 0||typeof r!=typeof s||typeof r!="object"||Array.isArray(r)!==Array.isArray(s))return!1;let _,m;if(Array.isArray(r)){if(r.length!==s.length)return!1;for(_=0;_<r.length;_++)if(!n(r[_],s[_]))return!1}else{const b=[];for(m in r)b.push(m);b.sort();const v=[];for(m in s)v.push(m);if(v.sort(),!n(b,v))return!1;for(_=0;_<b.length;_++)if(!n(r[b[_]],s[b[_]]))return!1}return!0}e.equals=n;function T(r){const s=new Set;return JSON.stringify(r,(_,m)=>{if((0,E.isObject)(m)||Array.isArray(m)){if(s.has(m))return"[Circular]";s.add(m)}return m})}e.safeStringify=T;function k(r,s,_){const m=s(r);return typeof m=="undefined"?_:m}e.getOrDefault=k;function h(r,s){const _=Object.create(null);return!r||!s||Object.keys(s).forEach(b=>{const v=r[b],d=s[b];n(v,d)||(_[b]=d)}),_}e.distinct=h;function f(r,s){const _=s.toLowerCase(),m=Object.keys(r).find(b=>b.toLowerCase()===_);return m?r[m]:r[s]}e.getCaseInsensitive=f}),define(ve[80],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function C(A){return A<0?0:A>255?255:A|0}e.toUint8=C;function P(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=P}),define(ve[2],_e([0,1,21,12]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,A=/^\//,S=/^\/\//;function D(c,a){if(!c.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!P.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!A.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(c,a){return!c&&!a?"file":c}function n(c,a){switch(c){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const T="",k="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(a,l,o,w,I,p=!1){typeof a=="object"?(this.scheme=a.scheme||T,this.authority=a.authority||T,this.path=a.path||T,this.query=a.query||T,this.fragment=a.fragment||T):(this.scheme=y(a,p),this.authority=l||T,this.path=n(this.scheme,o||T),this.query=w||T,this.fragment=I||T,D(this,p))}static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return v(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:o,path:w,query:I,fragment:p}=a;return l===void 0?l=this.scheme:l===null&&(l=T),o===void 0?o=this.authority:o===null&&(o=T),w===void 0?w=this.path:w===null&&(w=T),I===void 0?I=this.query:I===null&&(I=T),p===void 0?p=this.fragment:p===null&&(p=T),l===this.scheme&&o===this.authority&&w===this.path&&I===this.query&&p===this.fragment?this:new s(l,o,w,I,p)}static parse(a,l=!1){const o=h.exec(a);return o?new s(o[2]||T,i(o[4]||T),i(o[5]||T),i(o[7]||T),i(o[9]||T),l):new s(T,T,T,T,T)}static file(a){let l=T;if(E.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const o=a.indexOf(k,2);o===-1?(l=a.substring(2),a=k):(l=a.substring(2,o),a=a.substring(o)||k)}return new s("file",l,a,T,T)}static from(a){return new s(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return E.isWindows&&a.scheme==="file"?o=f.file(C.win32.join(v(a,!0),...l)).path:o=C.posix.join(a.path,...l),a.with({path:o})}toString(a=!1){return d(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const l=new s(a);return l._formatted=a.external,l._fsPath=a._sep===r?a.fsPath:null,l}}else return a}}e.URI=f;const r=E.isWindows?1:void 0;class s extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(a=!1){return a?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=r),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(c,a){let l,o=-1;for(let w=0;w<c.length;w++){const I=c.charCodeAt(w);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||a&&I===47)o!==-1&&(l+=encodeURIComponent(c.substring(o,w)),o=-1),l!==void 0&&(l+=c.charAt(w));else{l===void 0&&(l=c.substr(0,w));const p=_[I];p!==void 0?(o!==-1&&(l+=encodeURIComponent(c.substring(o,w)),o=-1),l+=p):o===-1&&(o=w)}}return o!==-1&&(l+=encodeURIComponent(c.substring(o))),l!==void 0?l:c}function b(c){let a;for(let l=0;l<c.length;l++){const o=c.charCodeAt(l);o===35||o===63?(a===void 0&&(a=c.substr(0,l)),a+=_[o]):a!==void 0&&(a+=c[l])}return a!==void 0?a:c}function v(c,a){let l;return c.authority&&c.path.length>1&&c.scheme==="file"?l=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?a?l=c.path.substr(1):l=c.path[1].toLowerCase()+c.path.substr(2):l=c.path,E.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=v;function d(c,a){const l=a?b:m;let o="",{scheme:w,authority:I,path:p,query:g,fragment:R}=c;if(w&&(o+=w,o+=":"),(I||w==="file")&&(o+=k,o+=k),I){let F=I.indexOf("@");if(F!==-1){const $=I.substr(0,F);I=I.substr(F+1),F=$.indexOf(":"),F===-1?o+=l($,!1):(o+=l($.substr(0,F),!1),o+=":",o+=l($.substr(F+1),!1)),o+="@"}I=I.toLowerCase(),F=I.indexOf(":"),F===-1?o+=l(I,!1):(o+=l(I.substr(0,F),!1),o+=I.substr(F))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const F=p.charCodeAt(1);F>=65&&F<=90&&(p=`/${String.fromCharCode(F+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const F=p.charCodeAt(0);F>=65&&F<=90&&(p=`${String.fromCharCode(F+32)}:${p.substr(2)}`)}o+=l(p,!0)}return g&&(o+="?",o+=l(g,!1)),R&&(o+="#",o+=a?R:m(R,!1)),o}function u(c){try{return decodeURIComponent(c)}catch(a){return c.length>3?c.substr(0,3)+u(c.substr(3)):c}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(c){return c.match(t)?c.replace(t,a=>u(a)):c}}),define(ve[22],_e([0,1,2,8]),function(ee,e,E,C){"use strict";var P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(d,u,t){let i=d.get(u);return i===void 0&&(i=t,d.set(u,i)),i}e.getOrSet=S;function D(d){const u=[];return d.forEach((t,i)=>{u.push(`${i} => ${t}`)}),`Map(${d.size}) {${u.join(", ")}}`}e.mapToString=D;function y(d){const u=[];return d.forEach(t=>{u.push(t)}),`Set(${d.size}) {${u.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const t=u.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,C.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(u=!0,t=!0){this._splitOnBackslash=u,this._caseSensitive=t}reset(u){return this._value=u.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,C.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var h;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(h||(h={}));class f{constructor(u){this._ignorePathCasing=u,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,C.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class r{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class s{constructor(u){this._iter=u}static forUris(u=()=>!1){return new s(new f(u))}static forPaths(){return new s(new k)}static forStrings(){return new s(new n)}static forConfigKeys(){return new s(new T)}clear(){this._root=void 0}set(u,t){const i=this._iter.reset(u);let c;for(this._root||(this._root=new r,this._root.segment=i.value()),c=this._root;;){const l=i.cmp(c.segment);if(l>0)c.left||(c.left=new r,c.left.segment=i.value()),c=c.left;else if(l<0)c.right||(c.right=new r,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new r,c.mid.segment=i.value()),c=c.mid;else break}const a=c.value;return c.value=t,c.key=u,a}get(u){var t;return(t=this._getNode(u))===null||t===void 0?void 0:t.value}_getNode(u){const t=this._iter.reset(u);let i=this._root;for(;i;){const c=t.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(u){const t=this._getNode(u);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,t){const i=this._iter.reset(u),c=[];let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)c.push([1,a]),a=a.left;else if(l<0)c.push([-1,a]),a=a.right;else if(i.hasNext())i.next(),c.push([0,a]),a=a.mid;else{for(t?(a.left=void 0,a.mid=void 0,a.right=void 0):a.value=void 0;c.length>0&&a.isEmpty();){let[o,w]=c.pop();switch(o){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}a=w}break}}}findSubstr(u){const t=this._iter.reset(u);let i=this._root,c;for(;i;){const a=t.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(t.hasNext())t.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(u){const t=this._iter.reset(u);let i=this._root;for(;i;){const c=t.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(u){for(const[t,i]of this)u(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(u){u&&(yield*this._entries(u.left),u.value&&(yield[u.key,u.value]),yield*this._entries(u.mid),yield*this._entries(u.right))}}e.TernarySearchTree=s;class _{constructor(u,t){this[P]="ResourceMap",u instanceof _?(this.map=new Map(u.map),this.toKey=t!=null?t:_.defaultToKey):(this.map=new Map,this.toKey=u!=null?u:_.defaultToKey)}set(u,t){return this.map.set(this.toKey(u),t),this}get(u){return this.map.get(this.toKey(u))}has(u){return this.map.has(this.toKey(u))}get size(){return this.map.size}clear(){this.map.clear()}delete(u){return this.map.delete(this.toKey(u))}forEach(u,t){typeof t!="undefined"&&(u=u.bind(t));for(let[i,c]of this.map)u(c,E.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let u of this.map.keys())yield E.URI.parse(u)}*entries(){for(let u of this.map.entries())yield[E.URI.parse(u[0]),u[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let u of this.map)yield[E.URI.parse(u[0]),u[1]]}}e.ResourceMap=_,_.defaultToKey=d=>d.toString();var m;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class b{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var u;return(u=this._head)===null||u===void 0?void 0:u.value}get last(){var u;return(u=this._tail)===null||u===void 0?void 0:u.value}has(u){return this._map.has(u)}get(u,t=0){const i=this._map.get(u);if(!!i)return t!==0&&this.touch(i,t),i.value}set(u,t,i=0){let c=this._map.get(u);if(c)c.value=t,i!==0&&this.touch(c,i);else{switch(c={key:u,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(u,c),this._size++}return this}delete(u){return!!this.remove(u)}remove(u){const t=this._map.get(u);if(!!t)return this._map.delete(u),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const u=this._head;return this._map.delete(u.key),this.removeItem(u),this._size--,u.value}}forEach(u,t){const i=this._state;let c=this._head;for(;c;){if(t?u.bind(t)(c.value,c.key,this):u(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const u=this,t=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:i.key,done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return c}values(){const u=this,t=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:i.value,done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return c}entries(){const u=this,t=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(u._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const a={value:[i.key,i.value],done:!1};return i=i.next,a}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(u){if(!(u>=this.size)){if(u===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>u;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(u){if(!this._head&&!this._tail)this._tail=u;else if(this._head)u.next=this._head,this._head.previous=u;else throw new Error("Invalid list");this._head=u,this._state++}addItemLast(u){if(!this._head&&!this._tail)this._head=u;else if(this._tail)u.previous=this._tail,this._tail.next=u;else throw new Error("Invalid list");this._tail=u,this._state++}removeItem(u){if(u===this._head&&u===this._tail)this._head=void 0,this._tail=void 0;else if(u===this._head){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this._head=u.next}else if(u===this._tail){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this._tail=u.previous}else{const t=u.next,i=u.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}u.next=void 0,u.previous=void 0,this._state++}touch(u,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(u===this._head)return;const i=u.next,c=u.previous;u===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),u.previous=void 0,u.next=this._head,this._head.previous=u,this._head=u,this._state++}else if(t===2){if(u===this._tail)return;const i=u.next,c=u.previous;u===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),u.next=void 0,u.previous=this._tail,this._tail.next=u,this._tail=u,this._state++}}}toJSON(){const u=[];return this.forEach((t,i)=>{u.push([i,t])}),u}fromJSON(u){this.clear();for(const[t,i]of u)this.set(t,i)}}e.LinkedMap=b;class v extends b{constructor(u,t=1){super();this._limit=u,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(u){this._limit=u,this.checkTrim()}get ratio(){return this._ratio}set ratio(u){this._ratio=Math.min(Math.max(0,u),1),this.checkTrim()}get(u,t=2){return super.get(u,t)}peek(u){return super.get(u,0)}set(u,t){return super.set(u,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v}),define(ve[108],_e([0,1,22,8]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...me){return function(Ce,Ae){for(let $e=0,be=me.length;$e<be;$e++){const Ke=me[$e](Ce,Ae);if(Ke)return Ke}return null}}e.or=P,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(me,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let $e;return me?$e=C.startsWithIgnoreCase(Ae,Ce):$e=Ae.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(me,Ce){const Ae=Ce.toLowerCase().indexOf(me.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+me.length}]}e.matchesContiguousSubString=S;function D(me,Ce){return y(me.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function y(me,Ce,Ae,$e){if(Ae===me.length)return[];if($e===Ce.length)return null;if(me[Ae]===Ce[$e]){let be=null;return(be=y(me,Ce,Ae+1,$e+1))?m({start:$e,end:$e+1},be):null}return y(me,Ce,Ae,$e+1)}function n(me){return 97<=me&&me<=122}function T(me){return 65<=me&&me<=90}e.isUpper=T;function k(me){return 48<=me&&me<=57}function h(me){return me===32||me===9||me===10||me===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(me=>f.add(me.charCodeAt(0)));function r(me){return h(me)||f.has(me)}function s(me,Ce){return me===Ce||r(me)&&r(Ce)}function _(me){return n(me)||T(me)||k(me)}function m(me,Ce){return Ce.length===0?Ce=[me]:me.end===Ce[0].start?Ce[0].start=me.start:Ce.unshift(me),Ce}function b(me,Ce){for(let Ae=Ce;Ae<me.length;Ae++){const $e=me.charCodeAt(Ae);if(T($e)||k($e)||Ae>0&&!_(me.charCodeAt(Ae-1)))return Ae}return me.length}function v(me,Ce,Ae,$e){if(Ae===me.length)return[];if($e===Ce.length)return null;if(me[Ae]!==Ce[$e].toLowerCase())return null;{let be=null,Ke=$e+1;for(be=v(me,Ce,Ae+1,$e+1);!be&&(Ke=b(Ce,Ke))<Ce.length;)be=v(me,Ce,Ae+1,Ke),Ke++;return be===null?null:m({start:$e,end:$e+1},be)}}function d(me){let Ce=0,Ae=0,$e=0,be=0,Ke=0;for(let We=0;We<me.length;We++)Ke=me.charCodeAt(We),T(Ke)&&Ce++,n(Ke)&&Ae++,_(Ke)&&$e++,k(Ke)&&be++;const V=Ce/me.length,X=Ae/me.length,ge=$e/me.length,Me=be/me.length;return{upperPercent:V,lowerPercent:X,alphaPercent:ge,numericPercent:Me}}function u(me){const{upperPercent:Ce,lowerPercent:Ae}=me;return Ae===0&&Ce>.6}function t(me){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:$e,numericPercent:be}=me;return Ae>.2&&Ce<.8&&$e>.6&&be<.2}function i(me){let Ce=0,Ae=0,$e=0,be=0;for(let Ke=0;Ke<me.length;Ke++)$e=me.charCodeAt(Ke),T($e)&&Ce++,n($e)&&Ae++,h($e)&&be++;return(Ce===0||Ae===0)&&be===0?me.length<=30:Ce<=5}function c(me,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(me)||Ce.length>60)return null;const Ae=d(Ce);if(!t(Ae)){if(!u(Ae))return null;Ce=Ce.toLowerCase()}let $e=null,be=0;for(me=me.toLowerCase();be<Ce.length&&($e=v(me,Ce,0,be))===null;)be=b(Ce,be+1);return $e}e.matchesCamelCase=c;function a(me,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let $e=null,be=0;for(me=me.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&($e=l(me,Ce,0,be,Ae))===null;)be=o(Ce,be+1);return $e}e.matchesWords=a;function l(me,Ce,Ae,$e,be){if(Ae===me.length)return[];if($e===Ce.length)return null;if(s(me.charCodeAt(Ae),Ce.charCodeAt($e))){let Ke=null,V=$e+1;if(Ke=l(me,Ce,Ae+1,$e+1,be),!be)for(;!Ke&&(V=o(Ce,V))<Ce.length;)Ke=l(me,Ce,Ae+1,V,be),V++;return Ke===null?null:m({start:$e,end:$e+1},Ke)}else return null}function o(me,Ce){for(let Ae=Ce;Ae<me.length;Ae++)if(r(me.charCodeAt(Ae))||Ae>0&&r(me.charCodeAt(Ae-1)))return Ae;return me.length}const w=P(e.matchesPrefix,c,S),I=P(e.matchesPrefix,c,D),p=new E.LRUCache(1e4);function g(me,Ce,Ae=!1){if(typeof me!="string"||typeof Ce!="string")return null;let $e=p.get(me);$e||($e=new RegExp(C.convertSimple2RegExpPattern(me),"i"),p.set(me,$e));const be=$e.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:Ae?I(me,Ce):w(me,Ce)}e.matchesFuzzy=g;function R(me,Ce){const Ae=U(me,me.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?$(Ae):null}e.matchesFuzzy2=R;function F(me,Ce,Ae,$e,be,Ke){const V=Math.min(13,me.length);for(;Ae<V;Ae++){const X=U(me,Ce,Ae,$e,be,Ke,!1);if(X)return X}return[0,Ke]}e.anyScore=F;function $(me){if(typeof me=="undefined")return[];const Ce=[],Ae=me[1];for(let $e=me.length-1;$e>1;$e--){const be=me[$e]+Ae,Ke=Ce[Ce.length-1];Ke&&Ke.end===be?Ke.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=$;const ue=128;function z(){const me=[],Ce=[];for(let Ae=0;Ae<=ue;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=ue;Ae++)me.push(Ce.slice(0));return me}function B(me){const Ce=[];for(let Ae=0;Ae<=me;Ae++)Ce[Ae]=0;return Ce}const G=B(2*ue),M=B(2*ue),N=z(),W=z(),Q=z(),x=!1;function Z(me,Ce,Ae,$e,be){function Ke(X,ge,Me=" "){for(;X.length<ge;)X=Me+X;return X}let V=` |   |${$e.split("").map(X=>Ke(X,3)).join("|")}
`;for(let X=0;X<=Ae;X++)X===0?V+=" |":V+=`${Ce[X-1]}|`,V+=me[X].slice(0,be+1).map(ge=>Ke(ge.toString(),3)).join("|")+`
`;return V}function re(me,Ce,Ae,$e){me=me.substr(Ce),Ae=Ae.substr($e),console.log(Z(W,me,me.length,Ae,Ae.length)),console.log(Z(Q,me,me.length,Ae,Ae.length)),console.log(Z(N,me,me.length,Ae,Ae.length))}function oe(me,Ce){if(Ce<0||Ce>=me.length)return!1;const Ae=me.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(Ae)}}function ye(me,Ce){if(Ce<0||Ce>=me.length)return!1;switch(me.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Pe(me,Ce,Ae){return Ce[me]!==Ae[me]}function Be(me,Ce,Ae,$e,be,Ke,V=!1){for(;Ce<Ae&&be<Ke;)me[Ce]===$e[be]&&(V&&(G[Ce]=be),Ce+=1),be+=1;return Ce===Ae}e.isPatternInWord=Be;var Re;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var ze;(function(me){me.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}me.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function U(me,Ce,Ae,$e,be,Ke,V){const X=me.length>ue?ue:me.length,ge=$e.length>ue?ue:$e.length;if(!(Ae>=X||Ke>=ge||X-Ae>ge-Ke)&&!!Be(Ce,Ae,X,be,Ke,ge,!0)){K(X,ge,Ae,Ke,Ce,be);let Me=1,We=1,Ue=Ae,Ze=Ke;const H=[!1];for(Me=1,Ue=Ae;Ue<X;Me++,Ue++){const ae=G[Ue],he=M[Ue],Ee=Ue+1<X?M[Ue+1]:ge;for(We=ae-Ke+1,Ze=ae;Ze<Ee;We++,Ze++){let Ne=Number.MIN_SAFE_INTEGER,Le=!1;Ze<=he&&(Ne=ne(me,Ce,Ue,Ae,$e,be,Ze,ge,Ke,N[Me-1][We-1]===0,H));let je=0;Ne!==Number.MAX_SAFE_INTEGER&&(Le=!0,je=Ne+W[Me-1][We-1]);const Je=Ze>ae,nt=Je?W[Me][We-1]+(N[Me][We-1]>0?-5:0):0,rt=Ze>ae+1&&N[Me][We-1]>0,ot=rt?W[Me][We-2]+(N[Me][We-2]>0?-5:0):0;if(rt&&(!Je||ot>=nt)&&(!Le||ot>=je))W[Me][We]=ot,Q[Me][We]=3,N[Me][We]=0;else if(Je&&(!Le||nt>=je))W[Me][We]=nt,Q[Me][We]=2,N[Me][We]=0;else if(Le)W[Me][We]=je,Q[Me][We]=1,N[Me][We]=N[Me-1][We-1]+1;else throw new Error("not possible")}}if(x&&re(me,Ae,$e,Ke),!(!H[0]&&!V)){Me--,We--;const ie=[W[Me][We],Ke];let de=0,j=0;for(;Me>=1;){let ae=We;do{const he=Q[Me][ae];if(he===3)ae=ae-2;else if(he===2)ae=ae-1;else break}while(ae>=1);de>1&&Ce[Ae+Me-1]===be[Ke+We-1]&&!Pe(ae+Ke-1,$e,be)&&de+1>N[Me][ae]&&(ae=We),ae===We?de++:de=1,j||(j=ae),Me--,We=ae-1,ie.push(We)}ge===X&&(ie[0]+=2);const Y=j-X;return ie[0]-=Y,ie}}}e.fuzzyScore=U;function K(me,Ce,Ae,$e,be,Ke){let V=me-1,X=Ce-1;for(;V>=Ae&&X>=$e;)be[V]===Ke[X]&&(M[V]=X,V--),X--}function ne(me,Ce,Ae,$e,be,Ke,V,X,ge,Me,We){if(Ce[Ae]!==Ke[V])return Number.MIN_SAFE_INTEGER;let Ue=1,Ze=!1;return V===Ae-$e?Ue=me[Ae]===be[V]?7:5:Pe(V,be,Ke)&&(V===0||!Pe(V-1,be,Ke))?(Ue=me[Ae]===be[V]?7:5,Ze=!0):oe(Ke,V)&&(V===0||!oe(Ke,V-1))?Ue=5:(oe(Ke,V-1)||ye(Ke,V-1))&&(Ue=5,Ze=!0),Ue>1&&Ae===$e&&(We[0]=!0),Ze||(Ze=Pe(V,be,Ke)||oe(Ke,V-1)||ye(Ke,V-1)),Ae===$e?V>ge&&(Ue-=Ze?3:5):Me?Ue+=Ze?2:0:Ue+=Ze?0:1,V+1===X&&(Ue-=Ze?3:5),Ue}function le(me,Ce,Ae,$e,be,Ke,V){return De(me,Ce,Ae,$e,be,Ke,!0,V)}e.fuzzyScoreGracefulAggressive=le;function fe(me,Ce,Ae,$e,be,Ke,V){return De(me,Ce,Ae,$e,be,Ke,!1,V)}e.fuzzyScoreGraceful=fe;function De(me,Ce,Ae,$e,be,Ke,V,X){let ge=U(me,Ce,Ae,$e,be,Ke,X);if(ge&&!V)return ge;if(me.length>=3){const Me=Math.min(7,me.length-1);for(let We=Ae+1;We<Me;We++){const Ue=Oe(me,We);if(Ue){const Ze=U(Ue,Ue.toLowerCase(),Ae,$e,be,Ke,X);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function Oe(me,Ce){if(!(Ce+1>=me.length)){const Ae=me[Ce],$e=me[Ce+1];if(Ae!==$e)return me.slice(0,Ce)+$e+Ae+me.slice(Ce+2)}}}),define(ve[109],_e([0,1,36,108,8]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${A.source}`,"g");function D(s){return s.replace(S,(_,m)=>m?_:`\\${_}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${A.source}`,"g");function n(s){return s.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function k(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(T,(_,m,b,v)=>b?_:m||v||"")}e.stripIcons=k;function h(s){const _=s.indexOf(e.iconStartMarker);return _===-1?{text:s}:f(s,_)}e.parseLabelWithIcons=h;function f(s,_){const m=[];let b="";function v(o){if(o){b+=o;for(const w of o)m.push(t)}}let d=-1,u="",t=0,i,c,a=_;const l=s.length;for(v(s.substr(0,_));a<l;)i=s[a],c=s[a+1],i===e.iconStartMarker[0]&&c===e.iconStartMarker[1]?(d=a,v(u),u=e.iconStartMarker,a++):i===")"&&d!==-1?(t+=a-d+1,d=-1,u=""):d!==-1?/^[a-z0-9\-]$/i.test(i)?u+=i:(v(u),d=-1,u=""):v(i),a++;return v(u),{text:b,iconOffsets:m}}function r(s,_,m=!1){const{text:b,iconOffsets:v}=_;if(!v||v.length===0)return(0,C.matchesFuzzy)(s,b,m);const d=(0,P.ltrim)(b," "),u=b.length-d.length,t=(0,C.matchesFuzzy)(s,d,m);if(t)for(const i of t){const c=v[i.start+u]+u;i.start+=c,i.end+=c}return t}e.matchesFuzzyIconAware=r}),define(ve[81],_e([0,1,11,109,10]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(s="",_=!1){var m,b;if(this.value=s,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1):(this.isTrusted=(m=_.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(b=_.supportThemeIcons)!==null&&b!==void 0?b:!1)}appendText(s,_=0){return this.value+=k(this.supportThemeIcons?(0,C.escapeIcons)(s):s).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,_){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}}e.MarkdownString=S;function D(r){return y(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function y(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(r,s){return!r&&!s?!0:!r||!s?!1:Array.isArray(r)&&Array.isArray(s)?(0,E.equals)(r,s,T):y(r)&&y(s)?T(r,s):!1}e.markedStringsEquals=n;function T(r,s){return r===s?!0:!r||!s?!1:r.value===s.value&&r.isTrusted===s.isTrusted&&r.supportThemeIcons===s.supportThemeIcons}function k(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function h(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function f(r){const s=[],_=r.split("|").map(b=>b.trim());r=_[0];const m=_[1];if(m){const b=/height=(\d+)/.exec(m),v=/width=(\d+)/.exec(m),d=b?b[1]:"",u=v?v[1]:"",t=isFinite(parseInt(u)),i=isFinite(parseInt(d));t&&s.push(`width="${u}"`),i&&s.push(`height="${d}"`)}return{href:r,dimensions:s}}e.parseHrefAndDimensions=f}),define(ve[58],_e([0,1,23,8,2]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(n){return JSON.stringify(n,D)}e.stringify=A;function S(n){let T=JSON.parse(n);return T=y(T),T}e.parse=S;function D(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,C.regExpFlags)(T)}:T}function y(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=y(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=y(n[k],T+1))}return n}e.revive=y}),define(ve[18],_e([0,1,2,21]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file"})(P=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,T){this._hosts[y]=n,this._ports[y]=T}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],h=this._connectionTokens[n];let f=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(f+=`&tkn=${encodeURIComponent(h)}`),E.URI.from({scheme:C.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new A;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,T){const k=this.toUri(y,n);return k.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(k):C.isNative&&(T||C.isPreferringBrowserCodeLoad)&&k.scheme===P.file?k.with({scheme:P.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,n){const T=this.toUri(y,n);return T.scheme===P.vscodeFileResource?T.with({scheme:P.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(ve[25],_e([0,1,37,12,2,8,18,21]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,P.uriToFsPath)(f,!0)}e.originalFSPath=y;class n{constructor(r){this._ignorePathCasing=r}compare(r,s,_=!1){return r===s?0:(0,A.compare)(this.getComparisonKey(r,_),this.getComparisonKey(s,_))}isEqual(r,s,_=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,_)===this.getComparisonKey(s,_)}getComparisonKey(r,s=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,s,_=!1){if(r.scheme===s.scheme){if(r.scheme===S.Schemas.file)return E.isEqualOrParent(y(r),y(s),this._ignorePathCasing(r))&&r.query===s.query&&(_||r.fragment===s.fragment);if((0,e.isEqualAuthority)(r.authority,s.authority))return E.isEqualOrParent(r.path,s.path,this._ignorePathCasing(r),"/")&&r.query===s.query&&(_||r.fragment===s.fragment)}return!1}joinPath(r,...s){return P.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return C.posix.basename(r.path)}extname(r){return C.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===S.Schemas.file?s=P.URI.file(C.dirname(y(r))).path:(s=C.posix.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===S.Schemas.file?s=P.URI.file(C.normalize(y(r))).path:s=C.posix.normalize(r.path),r.with({path:s})}relativePath(r,s){if(!(r.scheme!==s.scheme||!(0,e.isEqualAuthority)(r.authority,s.authority))){if(r.scheme===S.Schemas.file){const b=C.relative(y(r),y(s));return D.isWindows?E.toSlashes(b):b}let _=r.path||"/",m=s.path||"/";if(this._ignorePathCasing(r)){let b=0;for(const v=Math.min(_.length,m.length);b<v&&!(_.charCodeAt(b)!==m.charCodeAt(b)&&_.charAt(b).toLowerCase()!==m.charAt(b).toLowerCase());b++);_=m.substr(0,b)+_.substr(b)}return C.posix.relative(_,m)}}resolvePath(r,s){if(r.scheme===S.Schemas.file){const _=P.URI.file(C.resolve(y(r),s));return r.with({authority:_.authority,path:_.path})}return s.indexOf("/")===-1&&(s=E.toSlashes(s),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s)),r.with({path:C.posix.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||(0,A.equalsIgnoreCase)(r,s)}hasTrailingPathSeparator(r,s=C.sep){if(r.scheme===S.Schemas.file){const _=y(r);return _.length>E.getRoot(_).length&&_[_.length-1]===s}else{const _=r.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=C.sep){return(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=C.sep){let _=!1;if(r.scheme===S.Schemas.file){const m=y(r);_=m!==void 0&&m.length===E.getRoot(m).length&&m[m.length-1]===s}else{s="/";const m=r.path;_=m.length===1&&m.charCodeAt(m.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(r,s)?r.with({path:r.path+"/"}):r}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===S.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(f,r){const s=[];for(let _=0;_<f.length;_++){const m=r(f[_]);f.some((b,v)=>v===_?!1:(0,e.isEqualOrParent)(m,r(b)))||s.push(f[_])}return s}e.distinctParents=T;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(s){const _=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(v=>{const[d,u]=v.split(":");d&&u&&_.set(d,u)});const b=s.path.substring(0,s.path.indexOf(";"));return b&&_.set(f.META_DATA_MIME,b),_}f.parseMetaData=r})(k=e.DataUri||(e.DataUri={}));function h(f,r,s){if(r){let _=f.path;return _&&_[0]!==C.posix.sep&&(_=C.posix.sep+_),f.with({scheme:s,authority:r,path:_})}return f.with({scheme:s})}e.toLocalResource=h}),define(ve[14],_e([0,1,20,10,3,6,44,25]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(W){return!!W&&typeof W.then=="function"}e.isThenable=y;function n(W){const Q=new E.CancellationTokenSource,x=W(Q.token),Z=new Promise((re,oe)=>{Q.token.onCancellationRequested(()=>{oe((0,C.canceled)())}),Promise.resolve(x).then(ye=>{Q.dispose(),re(ye)},ye=>{Q.dispose(),oe(ye)})});return new class{cancel(){Q.cancel()}then(re,oe){return Z.then(re,oe)}catch(re){return this.then(void 0,re)}finally(re){return Z.finally(re)}}}e.createCancelablePromise=n;function T(W,Q,x){return Promise.race([W,new Promise(Z=>Q.onCancellationRequested(()=>Z(x)))])}e.raceCancellation=T;async function k(W){let Q=-1;const x=W.map((re,oe)=>re.then(ye=>(Q=oe,ye))),Z=await Promise.race(x);return W.forEach((re,oe)=>{oe!==Q&&re.cancel()}),Z}e.raceCancellablePromises=k;function h(W,Q,x){let Z;const re=setTimeout(()=>{Z==null||Z(void 0),x==null||x()},Q);return Promise.race([W.finally(()=>clearTimeout(re)),new Promise(oe=>Z=oe)])}e.raceTimeout=h;function f(W){return new Promise((Q,x)=>{const Z=W();y(Z)?Z.then(Q,x):Q(Z)})}e.asPromise=f;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(x,x).then(Z)})}return new Promise((x,Z)=>{this.queuedPromise.then(x,Z)})}return this.activePromise=Q(),new Promise((x,Z)=>{this.activePromise.then(re=>{this.activePromise=null,x(re)},re=>{this.activePromise=null,Z(re)})})}}e.Throttler=r;class s{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=s;class _{constructor(){this.promiseMap=new Map}queue(Q,x){var Z;const oe=((Z=this.promiseMap.get(Q))!==null&&Z!==void 0?Z:Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(Q)===oe&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,oe),oe}}e.SequencerByKey=_;class m{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,x=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,re)=>{this.doResolve=Z,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,C.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class b{constructor(Q){this.delayer=new m(Q),this.throttler=new r}trigger(Q,x){return this.delayer.trigger(()=>this.throttler.queue(Q),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class v{constructor(){this._isOpen=!1,this._promise=new Promise((Q,x)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class d extends v{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function u(W,Q){return Q?new Promise((x,Z)=>{const re=setTimeout(x,W);Q.onCancellationRequested(()=>{clearTimeout(re),Z((0,C.canceled)())})}):n(x=>u(W,x))}e.timeout=u;function t(W,Q=0){const x=setTimeout(W,Q);return(0,A.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=t;function i(W){return W.then(void 0,Q=>{})}e.ignoreErrors=i;function c(W){const Q=[];let x=0;const Z=W.length;function re(){return x<Z?W[x++]():null}function oe(ye){ye!=null&&Q.push(ye);const Pe=re();return Pe?Pe.then(oe):Promise.resolve(Q)}return Promise.resolve(null).then(oe)}e.sequence=c;function a(W,Q=Z=>!!Z,x=null){let Z=0;const re=W.length,oe=()=>{if(Z>=re)return Promise.resolve(x);const ye=W[Z++];return Promise.resolve(ye()).then(Be=>Q(Be)?Promise.resolve(Be):oe())};return oe()}e.first=a;function l(W,Q=Z=>!!Z,x=null){if(W.length===0)return Promise.resolve(x);let Z=W.length;const re=()=>{var oe,ye;Z=-1;for(const Pe of W)(ye=(oe=Pe).cancel)===null||ye===void 0||ye.call(oe)};return new Promise((oe,ye)=>{for(const Pe of W)Pe.then(Be=>{--Z>=0&&Q(Be)?(re(),oe(Be)):Z===0&&oe(x)}).catch(Be=>{--Z>=0&&(re(),ye(Be))})})}e.firstParallel=l;class o{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((x,Z)=>{this.outstandingPromises.push({factory:Q,c:x,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const x=Q.factory();x.then(Q.c,Q.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class w extends o{constructor(){super(1)}}e.Queue=w;class I{constructor(){this.queues=new Map}queueFor(Q,x=D.extUri){const Z=x.getComparisonKey(Q);let re=this.queues.get(Z);return re||(re=new w,P.Event.once(re.onFinished)(()=>{re==null||re.dispose(),this.queues.delete(Z)}),this.queues.set(Z,re)),re}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=I;class p{constructor(Q,x){this._token=-1,typeof Q=="function"&&typeof x=="number"&&this.setIfNotSet(Q,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},x)}setIfNotSet(Q,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},x))}}e.TimeoutTimer=p;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,x){this.cancel(),this._token=setInterval(()=>{Q()},x)}}e.IntervalTimer=g;class R{constructor(Q,x){this.timeoutToken=-1,this.runner=Q,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F extends R{constructor(Q,x){super(Q,x);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const x=setTimeout(()=>Q(W));let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout(x))}}}}else e.runWhenIdle=(W,Q)=>{const x=requestIdleCallback(W,typeof Q=="number"?{timeout:Q}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(x))}}}}();class ${constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function ue(W,Q,x){let Z;for(let re=0;re<x;re++)try{return await W()}catch(oe){Z=oe,await u(Q)}throw Z}e.retry=ue;class z{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,x,Z){return this._pending={taskId:Q,cancel:()=>Z==null?void 0:Z(),promise:x},x.then(()=>this.donePending(Q),()=>this.donePending(Q)),x}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let x,Z;const re=new Promise((oe,ye)=>{x=oe,Z=ye});this._next={run:Q,promise:re,promiseResolve:x,promiseReject:Z}}return this._next.promise}}e.TaskSequentializer=z;class B{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,x)=>{this.completeCallback=Q,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(x=>{this.completeCallback(Q),this.resolved=!0,x()})}error(Q){return new Promise(x=>{this.errorCallback(Q),this.rejected=!0,x()})}cancel(){new Promise(Q=>{this.errorCallback((0,C.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=G;class M extends P.Emitter{async fireAsync(Q,x,Z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const re of this._listeners)this._asyncDeliveryQueue.push([re,Q]);for(;this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[re,oe]=this._asyncDeliveryQueue.shift(),ye=[],Pe=Object.assign(Object.assign({},oe),{waitUntil:Be=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");Z&&(Be=Z(Be,typeof re=="function"?re:re[0])),ye.push(Be)}});try{typeof re=="function"?re.call(void 0,Pe):re[0].call(re[1],Pe)}catch(Be){(0,C.onUnexpectedError)(Be);continue}Object.freeze(ye),await N.settled(ye).catch(Be=>(0,C.onUnexpectedError)(Be))}}}}e.AsyncEmitter=M;var N;(function(W){async function Q(oe){return typeof Promise.allSettled=="function"?x(oe):Z(oe)}W.allSettled=Q;async function x(oe){return Promise.allSettled(oe)}async function Z(oe){return Promise.all(oe.map(ye=>ye.then(Pe=>({status:"fulfilled",value:Pe}),Pe=>({status:"rejected",reason:Pe}))))}async function re(oe){let ye;const Pe=await Promise.all(oe.map(Be=>Be.then(Re=>Re,Re=>{ye||(ye=Re)})));if(typeof ye!="undefined")throw ye;return Pe}W.settled=re})(N=e.Promises||(e.Promises={}))}),define(ve[110],_e([0,1,12,14]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new C.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),A=new C.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new C.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(d,u,t=!1){const i=d||"",c=u||"",a=P.value.collator.compare(i,c);return P.value.collatorIsNumeric&&a===0&&i!==c?i<c?-1:1:a}e.compareFileNames=D;function y(d,u){const t=A.value.collator;return d=d||"",u=u||"",s(t,d,u)}e.compareFileNamesDefault=y;function n(d,u,t=!1){t||(d=d&&d.toLowerCase(),u=u&&u.toLowerCase());const[i,c]=f(d),[a,l]=f(u);return i!==a?i<a?-1:1:c===l?0:c<l?-1:1}e.noIntlCompareFileNames=n;function T(d,u){const[t,i]=f(d),[c,a]=f(u);let l=P.value.collator.compare(i,a);if(l===0){if(P.value.collatorIsNumeric&&i!==a)return i<a?-1:1;if(l=P.value.collator.compare(t,c),P.value.collatorIsNumeric&&l===0&&t!==c)return t<c?-1:1}return l}e.compareFileExtensions=T;function k(d,u){d=d||"",u=u||"";const t=r(d),i=r(u),c=A.value.collator,a=S.value.collator;let l;return l=s(a,t,i),l!==0?l:s(c,d,u)}e.compareFileExtensionsDefault=k;const h=/^(.*?)(\.([^.]*))?$/;function f(d,u=!1){const t=d?h.exec(d):[];let i=[t&&t[1]||"",t&&t[3]||""];return u&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(d){const u=d?h.exec(d):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function s(d,u,t){let i=d.compare(u,t);return i!==0?i:u.length!==t.length?u.length<t.length?-1:1:0}function _(d,u,t=!1){return t||(d=d&&d.toLowerCase(),u=u&&u.toLowerCase()),d===u?0:d<u?-1:1}function m(d,u,t=!1){const i=d.split(E.sep),c=u.split(E.sep),a=i.length-1,l=c.length-1;let o,w;for(let I=0;;I++){if(o=a===I,w=l===I,o&&w)return D(i[I],c[I],t);if(o)return-1;if(w)return 1;const p=_(i[I],c[I],t);if(p!==0)return p}}e.comparePaths=m;function b(d,u,t){const i=d.toLowerCase(),c=u.toLowerCase(),a=v(d,u,t);if(a)return a;const l=i.endsWith(t),o=c.endsWith(t);if(l!==o)return l?-1:1;const w=D(i,c);return w!==0?w:i.localeCompare(c)}e.compareAnything=b;function v(d,u,t){const i=d.toLowerCase(),c=u.toLowerCase(),a=i.startsWith(t),l=c.startsWith(t);if(a!==l)return a?-1:1;if(a&&l){if(i.length<c.length)return-1;if(i.length>c.length)return 1}return 0}e.compareByPrefix=v}),define(ve[28],_e([0,1,8,37,12,22,14]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",n="/",T="[/\\\\]",k="[^/\\\\]",h=/\//g;function f(x){switch(x){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function r(x,Z){if(!x)return[];const re=[];let oe=!1,ye=!1,Pe="";for(const Be of x){switch(Be){case Z:if(!oe&&!ye){re.push(Pe),Pe="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Pe+=Be}return Pe&&re.push(Pe),re}e.splitGlobAware=r;function s(x){if(!x)return"";let Z="";const re=r(x,n);if(re.every(oe=>oe===y))Z=".*";else{let oe=!1;re.forEach((ye,Pe)=>{if(ye===y){oe||(Z+=f(2),oe=!0);return}let Be=!1,Re="",ze=!1,U="";for(const K of ye){if(K!=="}"&&Be){Re+=K;continue}if(ze&&(K!=="]"||!U)){let ne;K==="-"?ne=K:(K==="^"||K==="!")&&!U?ne="^":K===n?ne="":ne=E.escapeRegExpCharacters(K),U+=ne;continue}switch(K){case"{":Be=!0;continue;case"[":ze=!0;continue;case"}":Z+=`(?:${r(Re,",").map(fe=>s(fe)).join("|")})`,Be=!1,Re="";break;case"]":Z+="["+U+"]",ze=!1,U="";break;case"?":Z+=k;continue;case"*":Z+=f(1);continue;default:Z+=E.escapeRegExpCharacters(K)}}Pe<re.length-1&&(re[Pe+1]!==y||Pe+2<re.length)&&(Z+=T),oe=!1})}return Z}const _=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),i=function(){return!1},c=function(){return null};function a(x,Z){if(!x)return c;let re;typeof x!="string"?re=x.pattern:re=x,re=re.trim();const oe=`${re}_${!!Z.trimForExclusions}`;let ye=t.get(oe);if(ye)return l(ye,x);let Pe;if(_.test(re)){const Be=re.substr(4);ye=function(Re,ze){return typeof Re=="string"&&Re.endsWith(Be)?re:null}}else(Pe=m.exec(o(re,Z)))?ye=w(Pe[1],re):(Z.trimForExclusions?v:b).test(re)?ye=I(re,Z):(Pe=d.exec(o(re,Z)))?ye=p(Pe[1].substr(1),re,!0):(Pe=u.exec(o(re,Z)))?ye=p(Pe[1],re,!1):ye=g(re);return t.set(oe,ye),l(ye,x)}function l(x,Z){return typeof Z=="string"?x:function(re,oe){return C.isEqualOrParent(re,Z.base)?x(P.relative(Z.base,re),oe):null}}function o(x,Z){return Z.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function w(x,Z){const re=`/${x}`,oe=`\\${x}`,ye=function(Be,Re){return typeof Be!="string"?null:Re?Re===x?Z:null:Be===x||Be.endsWith(re)||Be.endsWith(oe)?Z:null},Pe=[x];return ye.basenames=Pe,ye.patterns=[Z],ye.allBasenames=Pe,ye}function I(x,Z){const re=Q(x.slice(1,-1).split(",").map(Re=>a(Re,Z)).filter(Re=>Re!==c),x),oe=re.length;if(!oe)return c;if(oe===1)return re[0];const ye=function(Re,ze){for(let U=0,K=re.length;U<K;U++)if(re[U](Re,ze))return x;return null},Pe=re.find(Re=>!!Re.allBasenames);Pe&&(ye.allBasenames=Pe.allBasenames);const Be=re.reduce((Re,ze)=>ze.allPaths?Re.concat(ze.allPaths):Re,[]);return Be.length&&(ye.allPaths=Be),ye}function p(x,Z,re){const oe=P.sep===P.posix.sep,ye=oe?x:x.replace(h,P.sep),Pe=P.sep+ye,Be=P.posix.sep+x,Re=re?function(ze,U){return typeof ze=="string"&&(ze===ye||ze.endsWith(Pe)||!oe&&(ze===x||ze.endsWith(Be)))?Z:null}:function(ze,U){return typeof ze=="string"&&(ze===ye||!oe&&ze===x)?Z:null};return Re.allPaths=[(re?"*/":"./")+x],Re}function g(x){try{const Z=new RegExp(`^${s(x)}$`);return function(re){return Z.lastIndex=0,typeof re=="string"&&Z.test(re)?x:null}}catch(Z){return c}}function R(x,Z,re){return!x||typeof Z!="string"?!1:F(x)(Z,void 0,re)}e.match=R;function F(x,Z={}){if(!x)return i;if(typeof x=="string"||B(x)){const re=a(x,Z);if(re===c)return i;const oe=function(ye,Pe){return!!re(ye,Pe)};return re.allBasenames&&(oe.allBasenames=re.allBasenames),re.allPaths&&(oe.allPaths=re.allPaths),oe}return N(x,Z)}e.parse=F;function $(x){if(!!x){let Z;return re=>(Z||(Z=(x()||Promise.resolve([])).then(oe=>oe?z(oe):{})),Z.then(oe=>!!oe[re]))}}e.hasSiblingPromiseFn=$;function ue(x){if(!!x){let Z;return re=>{if(!Z){const oe=x();Z=oe?z(oe):{}}return!!Z[re]}}}e.hasSiblingFn=ue;function z(x){const Z={};for(const re of x)Z[re]=!0;return Z}function B(x){const Z=x;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=B;function G(x){return x.allBasenames||[]}e.getBasenameTerms=G;function M(x){return x.allPaths||[]}e.getPathTerms=M;function N(x,Z){const re=Q(Object.getOwnPropertyNames(x).map(Re=>W(Re,x[Re],Z)).filter(Re=>Re!==c)),oe=re.length;if(!oe)return c;if(!re.some(Re=>!!Re.requiresSiblings)){if(oe===1)return re[0];const Re=function(K,ne){for(let le=0,fe=re.length;le<fe;le++){const De=re[le](K,ne);if(De)return De}return null},ze=re.find(K=>!!K.allBasenames);ze&&(Re.allBasenames=ze.allBasenames);const U=re.reduce((K,ne)=>ne.allPaths?K.concat(ne.allPaths):K,[]);return U.length&&(Re.allPaths=U),Re}const ye=function(Re,ze,U){let K;for(let ne=0,le=re.length;ne<le;ne++){const fe=re[ne];fe.requiresSiblings&&U&&(ze||(ze=P.basename(Re)),K||(K=ze.substr(0,ze.length-P.extname(Re).length)));const De=fe(Re,ze,K,U);if(De)return De}return null},Pe=re.find(Re=>!!Re.allBasenames);Pe&&(ye.allBasenames=Pe.allBasenames);const Be=re.reduce((Re,ze)=>ze.allPaths?Re.concat(ze.allPaths):Re,[]);return Be.length&&(ye.allPaths=Be),ye}function W(x,Z,re){if(Z===!1)return c;const oe=a(x,re);if(oe===c)return c;if(typeof Z=="boolean")return oe;if(Z){const ye=Z.when;if(typeof ye=="string"){const Pe=(Be,Re,ze,U)=>{if(!U||!oe(Be,Re))return null;const K=ye.replace("$(basename)",ze),ne=U(K);return(0,S.isThenable)(ne)?ne.then(le=>le?x:null):ne?x:null};return Pe.requiresSiblings=!0,Pe}}return oe}function Q(x,Z){const re=x.filter(Re=>!!Re.basenames);if(re.length<2)return x;const oe=re.reduce((Re,ze)=>{const U=ze.basenames;return U?Re.concat(U):Re},[]);let ye;if(Z){ye=[];for(let Re=0,ze=oe.length;Re<ze;Re++)ye.push(Z)}else ye=re.reduce((Re,ze)=>{const U=ze.patterns;return U?Re.concat(U):Re},[]);const Pe=function(Re,ze){if(typeof Re!="string")return null;if(!ze){let K;for(K=Re.length;K>0;K--){const ne=Re.charCodeAt(K-1);if(ne===47||ne===92)break}ze=Re.substr(K)}const U=oe.indexOf(ze);return U!==-1?ye[U]:null};Pe.basenames=oe,Pe.patterns=ye,Pe.allBasenames=oe;const Be=x.filter(Re=>!Re.basenames);return Be.push(Pe),Be}}),define(ve[59],_e([0,1,2,12,8,18,21,25,37]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(a,l,o){if(typeof a=="string"&&(a=E.URI.file(a)),o){const I=o.getWorkspaceFolder(a);if(I){const p=o.getWorkspace().folders.length>1;let g;if((0,D.isEqual)(I.uri,a)?g="":g=(0,D.relativePath)(I.uri,a),p){const R=I.name?I.name:(0,D.basename)(I.uri);g=g?R+" \u2022 "+g:R}return g}}if(a.scheme!==A.Schemas.file&&a.scheme!==A.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(a.fsPath))return(0,C.normalize)(k(a.fsPath));let w=(0,C.normalize)(a.fsPath);return!S.isWindows&&(l==null?void 0:l.userHome)&&(w=f(w,l.userHome.fsPath)),w}e.getPathLabel=n;function T(a){if(!!a){typeof a=="string"&&(a=E.URI.file(a));const l=(0,D.basename)(a)||(a.scheme===A.Schemas.file?a.fsPath:a.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(l)?k(l):l}}e.getBaseLabel=T;function k(a){return(0,y.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=k;let h=Object.create(null);function f(a,l){if(S.isWindows||!a||!l)return a;let o=h.original===l?h.normalized:void 0;return o||(o=`${(0,P.rtrim)(l,C.posix.sep)}${C.posix.sep}`,h={original:l,normalized:o}),(S.isLinux?a.startsWith(o):(0,P.startsWithIgnoreCase)(a,o))&&(a=`~/${a.substr(o.length)}`),a}e.tildify=f;function r(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=r;const s="\u2026",_="\\\\",m="~";function b(a,l=C.sep){const o=new Array(a.length);let w=!1;for(let I=0;I<a.length;I++){let p=a[I];if(p===""){o[I]=`.${l}`;continue}if(!p){o[I]=p;continue}w=!0;let g="";p.indexOf(_)===0?(g=p.substr(0,p.indexOf(_)+_.length),p=p.substr(p.indexOf(_)+_.length)):p.indexOf(l)===0?(g=p.substr(0,p.indexOf(l)+l.length),p=p.substr(p.indexOf(l)+l.length)):p.indexOf(m)===0&&(g=p.substr(0,p.indexOf(m)+m.length),p=p.substr(p.indexOf(m)+m.length));const R=p.split(l);for(let F=1;w&&F<=R.length;F++)for(let $=R.length-F;w&&$>=0;$--){w=!1;let ue=R.slice($,$+F).join(l);for(let z=0;!w&&z<a.length;z++)if(z!==I&&a[z]&&a[z].indexOf(ue)>-1){const B=$+F===R.length,G=$>0&&a[z].indexOf(l)>-1?l+ue:ue,M=a[z].endsWith(G);w=!B||M}if(!w){let z="";(R[0].endsWith(":")||g!=="")&&($===1&&($=0,F++,ue=R[0]+l+ue),$>0&&(z=R[0]+l),z=g+z),$>0&&(z=z+s+l),z=z+ue,$+F<R.length&&(z=z+l+s),o[I]=z}}w&&(o[I]=p)}return o}e.shorten=b;var v;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function d(a,l=Object.create(null)){const o=[];let w=!1,I="";for(const p of a)if(p==="$"||w&&p==="{")I&&o.push({value:I,type:v.TEXT}),I="",w=!0;else if(p==="}"&&w){const g=l[I];if(typeof g=="string")g.length&&o.push({value:g,type:v.VARIABLE});else if(g){const R=o[o.length-1];(!R||R.type!==v.SEPARATOR)&&o.push({value:g.label,type:v.SEPARATOR})}I="",w=!1}else I+=p;return I&&!w&&o.push({value:I,type:v.TEXT}),o.filter((p,g)=>{if(p.type===v.SEPARATOR){const R=o[g-1],F=o[g+1];return[R,F].every($=>$&&($.type===v.VARIABLE||$.type===v.TEXT)&&$.value.length>0)}return!0}).map(p=>p.value).join("")}e.template=d;function u(a,l){return S.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):a.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(a,l){return S.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):S.isWindows?a.replace(/&&|&/g,o=>o==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function c(a){const l=a.indexOf("/")!==-1?C.posix:C.win32,o=l.basename(a),w=l.dirname(a);return o.length?{name:o,parentPath:w}:{name:w,parentPath:""}}e.splitName=c}),define(ve[111],_e([0,1,2]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(T){return T.toJSON()}class P{constructor(k){this._uriTransformer=k}transformIncoming(k){const h=this._uriTransformer.transformIncoming(k);return h===k?k:C(E.URI.from(h))}transformOutgoing(k){const h=this._uriTransformer.transformOutgoing(k);return h===k?k:C(E.URI.from(h))}transformOutgoingURI(k){const h=this._uriTransformer.transformOutgoing(k);return h===k?k:E.URI.from(h)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function A(T,k,h){if(!T||h>200)return null;if(typeof T=="object"){if(T instanceof E.URI)return k.transformOutgoing(T);for(let f in T)if(Object.hasOwnProperty.call(T,f)){const r=A(T[f],k,h+1);r!==null&&(T[f]=r)}}return null}function S(T,k){const h=A(T,k,0);return h===null?T:h}e.transformOutgoingURIs=S;function D(T,k,h,f){if(!T||f>200)return null;if(typeof T=="object"){if(T.$mid===1)return h?E.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let r in T)if(Object.hasOwnProperty.call(T,r)){const s=D(T[r],k,h,f+1);s!==null&&(T[r]=s)}}return null}function y(T,k){const h=D(T,k,!1,0);return h===null?T:h}e.transformIncomingURIs=y;function n(T,k){const h=D(T,k,!0,0);return h===null?T:h}e.transformAndReviveIncomingURIs=n}),define(ve[29],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(y){return E.test(y)}e.isUUID=C;const P=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function D(){S(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let y=0,n="";return n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+="-",n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n+=A[P[y++]],n}e.generateUuid=D}),define(ve[82],_e([0,1,80]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class C{constructor(D){let y=(0,E.toUint8)(D);this._defaultValue=y,this._asciiMap=C._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=D;return y}set(D,y){let n=(0,E.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=n:this._map.set(D,n)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=C;var P;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(P||(P={}));class A{constructor(){this._actual=new C(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=A}),define(ve[112],_e([0,1,82]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var C;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(C=e.WordCharacterClass||(e.WordCharacterClass={}));class P extends E.CharacterClassifier{constructor(D){super(0);for(let y=0,n=D.length;y<n;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=P;function A(S){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=S(y)),D[y])}e.getMapForWordSeparators=A(S=>new P(S))}),define(ve[38],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(P,A){this.lineNumber=P,this.column=A}with(P=this.lineNumber,A=this.column){return P===this.lineNumber&&A===this.column?this:new E(P,A)}delta(P=0,A=0){return this.with(this.lineNumber+P,this.column+A)}equals(P){return E.equals(this,P)}static equals(P,A){return!P&&!A?!0:!!P&&!!A&&P.lineNumber===A.lineNumber&&P.column===A.column}isBefore(P){return E.isBefore(this,P)}static isBefore(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<A.column}isBeforeOrEqual(P){return E.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,A){return P.lineNumber<A.lineNumber?!0:A.lineNumber<P.lineNumber?!1:P.column<=A.column}static compare(P,A){let S=P.lineNumber|0,D=A.lineNumber|0;if(S===D){let y=P.column|0,n=A.column|0;return y-n}return S-D}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new E(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=E}),define(ve[32],_e([0,1,38]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class C{constructor(A,S,D,y){A>D||A===D&&S>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=A,this.endColumn=S):(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return C.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return C.containsPosition(this,A)}static containsPosition(A,S){return!(S.lineNumber<A.startLineNumber||S.lineNumber>A.endLineNumber||S.lineNumber===A.startLineNumber&&S.column<A.startColumn||S.lineNumber===A.endLineNumber&&S.column>A.endColumn)}containsRange(A){return C.containsRange(this,A)}static containsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>A.endColumn)}strictContainsRange(A){return C.strictContainsRange(this,A)}static strictContainsRange(A,S){return!(S.startLineNumber<A.startLineNumber||S.endLineNumber<A.startLineNumber||S.startLineNumber>A.endLineNumber||S.endLineNumber>A.endLineNumber||S.startLineNumber===A.startLineNumber&&S.startColumn<=A.startColumn||S.endLineNumber===A.endLineNumber&&S.endColumn>=A.endColumn)}plusRange(A){return C.plusRange(this,A)}static plusRange(A,S){let D,y,n,T;return S.startLineNumber<A.startLineNumber?(D=S.startLineNumber,y=S.startColumn):S.startLineNumber===A.startLineNumber?(D=S.startLineNumber,y=Math.min(S.startColumn,A.startColumn)):(D=A.startLineNumber,y=A.startColumn),S.endLineNumber>A.endLineNumber?(n=S.endLineNumber,T=S.endColumn):S.endLineNumber===A.endLineNumber?(n=S.endLineNumber,T=Math.max(S.endColumn,A.endColumn)):(n=A.endLineNumber,T=A.endColumn),new C(D,y,n,T)}intersectRanges(A){return C.intersectRanges(this,A)}static intersectRanges(A,S){let D=A.startLineNumber,y=A.startColumn,n=A.endLineNumber,T=A.endColumn,k=S.startLineNumber,h=S.startColumn,f=S.endLineNumber,r=S.endColumn;return D<k?(D=k,y=h):D===k&&(y=Math.max(y,h)),n>f?(n=f,T=r):n===f&&(T=Math.min(T,r)),D>n||D===n&&y>T?null:new C(D,y,n,T)}equalsRange(A){return C.equalsRange(this,A)}static equalsRange(A,S){return!!A&&!!S&&A.startLineNumber===S.startLineNumber&&A.startColumn===S.startColumn&&A.endLineNumber===S.endLineNumber&&A.endColumn===S.endColumn}getEndPosition(){return C.getEndPosition(this)}static getEndPosition(A){return new E.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return C.getStartPosition(this)}static getStartPosition(A){return new E.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,S){return new C(this.startLineNumber,this.startColumn,A,S)}setStartPosition(A,S){return new C(A,S,this.endLineNumber,this.endColumn)}collapseToStart(){return C.collapseToStart(this)}static collapseToStart(A){return new C(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,S=A){return new C(A.lineNumber,A.column,S.lineNumber,S.column)}static lift(A){return A?new C(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn)}static areIntersecting(A,S){return!(A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn||S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,S){if(A&&S){const n=A.startLineNumber|0,T=S.startLineNumber|0;if(n===T){const k=A.startColumn|0,h=S.startColumn|0;if(k===h){const f=A.endLineNumber|0,r=S.endLineNumber|0;if(f===r){const s=A.endColumn|0,_=S.endColumn|0;return s-_}return f-r}return k-h}return n-T}return(A?1:0)-(S?1:0)}static compareRangesUsingEnds(A,S){return A.endLineNumber===S.endLineNumber?A.endColumn===S.endColumn?A.startLineNumber===S.startLineNumber?A.startColumn-S.startColumn:A.startLineNumber-S.startLineNumber:A.endColumn-S.endColumn:A.endLineNumber-S.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=C}),define(ve[113],_e([0,1,38,32]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(P=e.SelectionDirection||(e.SelectionDirection={}));class A extends C.Range{constructor(D,y,n,T){super(D,y,n,T);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return A.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,D,y):new A(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new A(D,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new A(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new A(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let n=0,T=D.length;n<T;n++)if(!this.selectionsEqual(D[n],y[n]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,n,T,k){return k===0?new A(D,y,n,T):new A(n,T,D,y)}}e.Selection=A}),define(ve[83],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(r,s){this.range=r,this.matches=s}}e.FindMatch=y;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(r,s,_,m,b,v){this.identifier=r,this.range=s,this.text=_,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=b,this._isTracked=v}}e.ValidAnnotatedEditOperation=k;class h{constructor(r,s,_){this.reverseEdits=r,this.changes=s,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=h}),define(ve[114],_e([0,1,8,112,38,32,83]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(v,d,u,t){this.searchString=v,this.isRegex=d,this.matchCase=u,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=n(this.searchString):v=this.searchString.indexOf(`
`)>=0;let d=null;try{d=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let u=!this.isRegex&&!v;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new T(d,this.wordSeparators?(0,C.getMapForWordSeparators)(this.wordSeparators):null,u?this.searchString:null)}}e.SearchParams=y;function n(b){if(!b||b.length===0)return!1;for(let v=0,d=b.length;v<d;v++)if(b.charCodeAt(v)===92){if(v++,v>=d)break;const t=b.charCodeAt(v);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(v,d,u){this.regex=v,this.wordSeparators=d,this.simpleSearch=u}}e.SearchData=T;function k(b,v,d){if(!d)return new S.FindMatch(b,null);let u=[];for(let t=0,i=v.length;t<i;t++)u[t]=v[t];return new S.FindMatch(b,u)}e.createFindMatch=k;class h{constructor(v){let d=[],u=0;for(let t=0,i=v.length;t<i;t++)v.charCodeAt(t)===10&&(d[u++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(v){const d=this._lineFeedsOffsets;let u=0,t=d.length-1;if(t===-1||v<=d[0])return 0;for(;u<t;){const i=u+((t-u)/2>>0);d[i]>=v?t=i-1:d[i+1]>=v?(u=i,t=i):u=i+1}return u+1}}class f{static findMatches(v,d,u,t,i){const c=d.parseSearchRequest();return c?c.regex.multiline?this._doFindMatchesMultiline(v,u,new m(c.wordSeparators,c.regex),t,i):this._doFindMatchesLineByLine(v,u,c,t,i):[]}static _getMultilineMatchRange(v,d,u,t,i,c){let a,l=0;t?(l=t.findLineFeedCountBeforeOffset(i),a=d+i+l):a=d+i;let o;if(t){let g=t.findLineFeedCountBeforeOffset(i+c.length)-l;o=a+c.length+g}else o=a+c.length;const w=v.getPositionAt(a),I=v.getPositionAt(o);return new A.Range(w.lineNumber,w.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(v,d,u,t,i){const c=v.getOffsetAt(d.getStartPosition()),a=v.getValueInRange(d,1),l=v.getEOL()===`\r
`?new h(a):null,o=[];let w=0,I;for(u.reset(0);I=u.next(a);)if(o[w++]=k(this._getMultilineMatchRange(v,c,a,l,I.index,I[0]),I,t),w>=i)return o;return o}static _doFindMatchesLineByLine(v,d,u,t,i){const c=[];let a=0;if(d.startLineNumber===d.endLineNumber){const o=v.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return a=this._findMatchesInLine(u,o,d.startLineNumber,d.startColumn-1,a,c,t,i),c}const l=v.getLineContent(d.startLineNumber).substring(d.startColumn-1);a=this._findMatchesInLine(u,l,d.startLineNumber,d.startColumn-1,a,c,t,i);for(let o=d.startLineNumber+1;o<d.endLineNumber&&a<i;o++)a=this._findMatchesInLine(u,v.getLineContent(o),o,0,a,c,t,i);if(a<i){const o=v.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);a=this._findMatchesInLine(u,o,d.endLineNumber,0,a,c,t,i)}return c}static _findMatchesInLine(v,d,u,t,i,c,a,l){const o=v.wordSeparators;if(!a&&v.simpleSearch){const p=v.simpleSearch,g=p.length,R=d.length;let F=-g;for(;(F=d.indexOf(p,F+g))!==-1;)if((!o||_(o,d,R,F,g))&&(c[i++]=new S.FindMatch(new A.Range(u,F+1+t,u,F+1+g+t),null),i>=l))return i;return i}const w=new m(v.wordSeparators,v.regex);let I;w.reset(0);do if(I=w.next(d),I&&(c[i++]=k(new A.Range(u,I.index+1+t,u,I.index+1+I[0].length+t),I,a),i>=l))return i;while(I);return i}static findNextMatch(v,d,u,t){const i=d.parseSearchRequest();if(!i)return null;const c=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(v,u,c,t):this._doFindNextMatchLineByLine(v,u,c,t)}static _doFindNextMatchMultiline(v,d,u,t){const i=new P.Position(d.lineNumber,1),c=v.getOffsetAt(i),a=v.getLineCount(),l=v.getValueInRange(new A.Range(i.lineNumber,i.column,a,v.getLineMaxColumn(a)),1),o=v.getEOL()===`\r
`?new h(l):null;u.reset(d.column-1);let w=u.next(l);return w?k(this._getMultilineMatchRange(v,c,l,o,w.index,w[0]),w,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(v,new P.Position(1,1),u,t):null}static _doFindNextMatchLineByLine(v,d,u,t){const i=v.getLineCount(),c=d.lineNumber,a=v.getLineContent(c),l=this._findFirstMatchInLine(u,a,c,d.column,t);if(l)return l;for(let o=1;o<=i;o++){const w=(c+o-1)%i,I=v.getLineContent(w+1),p=this._findFirstMatchInLine(u,I,w+1,1,t);if(p)return p}return null}static _findFirstMatchInLine(v,d,u,t,i){v.reset(t-1);const c=v.next(d);return c?k(new A.Range(u,c.index+1,u,c.index+1+c[0].length),c,i):null}static findPreviousMatch(v,d,u,t){const i=d.parseSearchRequest();if(!i)return null;const c=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(v,u,c,t):this._doFindPreviousMatchLineByLine(v,u,c,t)}static _doFindPreviousMatchMultiline(v,d,u,t){const i=this._doFindMatchesMultiline(v,new A.Range(1,1,d.lineNumber,d.column),u,t,10*D);if(i.length>0)return i[i.length-1];const c=v.getLineCount();return d.lineNumber!==c||d.column!==v.getLineMaxColumn(c)?this._doFindPreviousMatchMultiline(v,new P.Position(c,v.getLineMaxColumn(c)),u,t):null}static _doFindPreviousMatchLineByLine(v,d,u,t){const i=v.getLineCount(),c=d.lineNumber,a=v.getLineContent(c).substring(0,d.column-1),l=this._findLastMatchInLine(u,a,c,t);if(l)return l;for(let o=1;o<=i;o++){const w=(i+c-o-1)%i,I=v.getLineContent(w+1),p=this._findLastMatchInLine(u,I,w+1,t);if(p)return p}return null}static _findLastMatchInLine(v,d,u,t){let i=null,c;for(v.reset(0);c=v.next(d);)i=k(new A.Range(u,c.index+1,u,c.index+1+c[0].length),c,t);return i}}e.TextModelSearch=f;function r(b,v,d,u,t){if(u===0)return!0;const i=v.charCodeAt(u-1);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const c=v.charCodeAt(u);if(b.get(c)!==0)return!0}return!1}function s(b,v,d,u,t){if(u+t===d)return!0;const i=v.charCodeAt(u+t);if(b.get(i)!==0||i===13||i===10)return!0;if(t>0){const c=v.charCodeAt(u+t-1);if(b.get(c)!==0)return!0}return!1}function _(b,v,d,u,t){return r(b,v,d,u,t)&&s(b,v,d,u,t)}e.isValidMatch=_;class m{constructor(v,d){this._wordSeparators=v,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const d=v.length;let u;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(u=this._searchRegex.exec(v),!u))return null;const t=u.index,i=u[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){E.getNextCodePoint(v,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||_(this._wordSeparators,v,d,t,i))return u}while(u);return null}}e.Searcher=m}),define(ve[84],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)D.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function C(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let n="g";D.ignoreCase&&(n+="i"),D.multiline&&(n+="m"),D.unicode&&(n+="u"),y=new RegExp(D.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=C;const P={maxLen:1e3,windowSize:15,timeBudget:150};function A(D,y,n,T,k=P){if(n.length>k.maxLen){let _=D-k.maxLen/2;return _<0?_=0:T+=_,n=n.substring(_,D+k.maxLen/2),A(D,y,n,T,k)}const h=Date.now(),f=D-1-T;let r=-1,s=null;for(let _=1;!(Date.now()-h>=k.timeBudget);_++){const m=f-k.windowSize*_;y.lastIndex=Math.max(0,m);const b=S(y,n,f,r);if(!b&&s||(s=b,m<=0))break;r=m}if(s){let _={word:s[0],startColumn:T+1+s.index,endColumn:T+1+s.index+s[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=A;function S(D,y,n,T){let k;for(;k=D.exec(y);){const h=k.index||0;if(h<=n&&D.lastIndex>=n)return k;if(T>0&&h>T)return null}return null}}),define(ve[115],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class C{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,n=D.notIn.length;y<n;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=C;class P{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=P;function A(S,D,y){S.has(D)?S.get(D).push(y):S.set(D,[y])}}),define(ve[60],_e([0,1,28,12]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(A,S,D,y){if(Array.isArray(A)){let n=0;for(const T of A){const k=P(T,S,D,y);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof A=="string")return y?A==="*"?5:A===D?10:0:0;if(A){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:h}=A;if(!y&&!h)return 0;let f=0;if(k)if(k===S.scheme)f=10;else if(k==="*")f=5;else return 0;if(n)if(n===D)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(T){let r;if(typeof T=="string"?r=T:r=Object.assign(Object.assign({},T),{base:(0,C.normalize)(T.base)}),r===S.fsPath||(0,E.match)(r,S.fsPath))f=10;else return 0}return f}else return 0}}e.score=P}),define(ve[116],_e([0,1,82]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var C;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(C=e.State||(e.State={}));class P{constructor(r,s,_){const m=new Uint8Array(r*s);for(let b=0,v=r*s;b<v;b++)m[b]=_;this._data=m,this.rows=r,this.cols=s}get(r,s){return this._data[r*this.cols+s]}set(r,s,_){this._data[r*this.cols+s]=_}}e.Uint8Matrix=P;class A{constructor(r){let s=0,_=0;for(let b=0,v=r.length;b<v;b++){let[d,u,t]=r[b];u>s&&(s=u),d>_&&(_=d),t>_&&(_=t)}s++,_++;let m=new P(_,s,0);for(let b=0,v=r.length;b<v;b++){let[d,u,t]=r[b];m.set(d,u,t)}this._states=m,this._maxCharCode=s}nextState(r,s){return s<0||s>=this._maxCharCode?0:this._states.get(r,s)}}e.StateMachine=A;let S=null;function D(){return S===null&&(S=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function T(){if(n===null){n=new E.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let s=0;s<f.length;s++)n.set(f.charCodeAt(s),1);const r=".,;";for(let s=0;s<r.length;s++)n.set(r.charCodeAt(s),2)}return n}class k{static _createLink(r,s,_,m,b){let v=b-1;do{const d=s.charCodeAt(v);if(r.get(d)!==2)break;v--}while(v>m);if(m>0){const d=s.charCodeAt(m-1),u=s.charCodeAt(v);(d===40&&u===41||d===91&&u===93||d===123&&u===125)&&v--}return{range:{startLineNumber:_,startColumn:m+1,endLineNumber:_,endColumn:v+2},url:s.substring(m,v+1)}}static computeLinks(r,s=D()){const _=T();let m=[];for(let b=1,v=r.getLineCount();b<=v;b++){const d=r.getLineContent(b),u=d.length;let t=0,i=0,c=0,a=1,l=!1,o=!1,w=!1,I=!1;for(;t<u;){let p=!1;const g=d.charCodeAt(t);if(a===13){let R;switch(g){case 40:l=!0,R=0;break;case 41:R=l?0:1;break;case 91:w=!0,o=!0,R=0;break;case 93:w=!1,R=o?0:1;break;case 123:I=!0,R=0;break;case 125:R=I?0:1;break;case 39:R=c===34||c===96?0:1;break;case 34:R=c===39||c===96?0:1;break;case 96:R=c===39||c===34?0:1;break;case 42:R=c===42?1:0;break;case 124:R=c===124?1:0;break;case 32:R=w?0:1;break;default:R=_.get(g)}R===1&&(m.push(k._createLink(_,d,b,i,t)),p=!0)}else if(a===12){let R;g===91?(o=!0,R=0):R=_.get(g),R===1?p=!0:a=13}else a=s.nextState(a,g),a===0&&(p=!0);p&&(a=1,l=!1,o=!1,I=!1,i=t+1,c=g),t++}a===13&&m.push(k._createLink(_,d,b,i,u))}return m}}e.LinkComputer=k;function h(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:k.computeLinks(f)}e.computeLinks=h}),define(ve[117],_e([0,1,3,6]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class P{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,D){return this._map.set(S,D),this.fire([S]),(0,C.toDisposable)(()=>{this._map.get(S)===D&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,D){let y=null,n=!1;return this._promises.set(S,D.then(T=>{this._promises.delete(S),!(n||!T)&&(y=this.register(S,T))})),(0,C.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const D=this.get(S);if(D)return Promise.resolve(D);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=P}),define(ve[85],_e([0,1,23,21]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(P||(P={}));function A(k){for(let h=0,f=k.length;h<f;h+=4){const r=k[h+0],s=k[h+1],_=k[h+2],m=k[h+3];k[h+0]=m,k[h+1]=_,k[h+2]=s,k[h+3]=r}}function S(k){const h=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return C.isLittleEndian()||A(h),E.VSBuffer.wrap(h)}function D(k){const h=k.buffer;if(C.isLittleEndian()||A(h),h.byteOffset%4==0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const f=new Uint8Array(h.byteLength);return f.set(h),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(k){const h=new Uint32Array(n(k));let f=0;if(h[f++]=k.id,k.type==="full")h[f++]=1,h[f++]=k.data.length,h.set(k.data,f),f+=k.data.length;else{h[f++]=2,h[f++]=k.deltas.length;for(const r of k.deltas)h[f++]=r.start,h[f++]=r.deleteCount,r.data?(h[f++]=r.data.length,h.set(r.data,f),f+=r.data.length):h[f++]=0}return S(h)}e.encodeSemanticTokensDto=y;function n(k){let h=0;if(h+=1+1,k.type==="full")h+=1+k.data.length;else{h+=1,h+=(1+1+1)*k.deltas.length;for(const f of k.deltas)f.data&&(h+=f.data.length)}return h}function T(k){const h=D(k);let f=0;const r=h[f++];if(h[f++]===1){const b=h[f++],v=h.subarray(f,f+b);return f+=b,{id:r,type:"full",data:v}}const _=h[f++];let m=[];for(let b=0;b<_;b++){const v=h[f++],d=h[f++],u=h[f++];let t;u>0&&(t=h.subarray(f,f+u),f+=u),m[b]={start:v,deleteCount:d,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=T}),define(ve[86],_e([0,1,80]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class C{constructor(S,D){this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=C;class P{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,E.toUint32)(S);const y=this.values,n=this.prefixSum,T=D.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+T),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,D){return S=(0,E.toUint32)(S),D=(0,E.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,E.toUint32)(S),D=(0,E.toUint32)(D);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let T=y.length-S;return D>=T&&(D=T),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,E.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let y=D;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let D=0,y=this.values.length-1,n=0,T=0,k=0;for(;D<=y;)if(n=D+(y-D)/2|0,T=this.prefixSum[n],k=T-this.values[n],S<k)y=n-1;else if(S>=T)D=n+1;else break;return new C(n,S-k)}}e.PrefixSumComputer=P}),define(ve[118],_e([0,1,8,38,86]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(D,y,n,T){this._uri=D,this._lines=y,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new C.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let T=0;T<y;T++)n[T]=this._lines[T].length+D;this._lineStarts=new P.PrefixSumComputer(n)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}n[n.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(D.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,T)}}}e.MirrorTextModel=A}),define(ve[119],_e([16,17]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ve[61],_e([0,1,119,13,11]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(n,T){return T&&(n.stack||n.stacktrace)?E.localize(0,null,D(n),S(n.stack)||S(n.stacktrace)):D(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function D(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,T=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const k=P.coalesce(n),h=y(k[0],T);return k.length>1?E.localize(4,null,h,k.length):h}if(C.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return A(k.error,T);if(k.exception)return A(k.exception,T)}return n.stack?A(n,T):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(ve[120],_e([16,17]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(ve[121],_e([0,1,120,21,84]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,ge){this._values[X]=ge}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(X,ge,Me,We){this.id=X,this.name=ge,this.defaultValue=Me,this.schema=We}compute(X,ge,Me){return Me}}class T{constructor(X,ge=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(X){return this.defaultValue}}class k{constructor(X,ge,Me,We){this.id=X,this.name=ge,this.defaultValue=Me,this.schema=We}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,ge,Me){return Me}}function h(V,X){return typeof V=="undefined"?X:V==="false"?!1:Boolean(V)}e.boolean=h;class f extends k{constructor(X,ge,Me,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Me),super(X,ge,Me,We)}validate(X){return h(X,this.defaultValue)}}class r extends k{constructor(X,ge,Me,We,Ue,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Me,Ze.minimum=We,Ze.maximum=Ue),super(X,ge,Me,Ze),this.minimum=We,this.maximum=Ue}static clampedInt(X,ge,Me,We){if(typeof X=="undefined")return ge;let Ue=parseInt(X,10);return isNaN(Ue)?ge:(Ue=Math.max(Me,Ue),Ue=Math.min(We,Ue),Ue|0)}validate(X){return r.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class s extends k{constructor(X,ge,Me,We,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Me),super(X,ge,Me,Ue),this.validationFn=We}static clamp(X,ge,Me){return X<ge?ge:X>Me?Me:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X=="undefined")return ge;const Me=parseFloat(X);return isNaN(Me)?ge:Me}validate(X){return this.validationFn(s.float(X,this.defaultValue))}}class _ extends k{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Me,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Me),super(X,ge,Me,We)}validate(X){return _.string(X,this.defaultValue)}}function m(V,X,ge){return typeof V!="string"||ge.indexOf(V)===-1?X:V}e.stringSet=m;class b extends k{constructor(X,ge,Me,We,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=We,Ue.default=Me),super(X,ge,Me,Ue),this._allowedValues=We}validate(X){return m(X,this.defaultValue,this._allowedValues)}}class v extends n{constructor(X,ge,Me,We,Ue,Ze,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=Ue,H.default=We),super(X,ge,Me,H),this._allowedValues=Ue,this._convert=Ze}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function d(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Me){return Me===0?X.accessibilitySupport:Me}}class t extends n{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:E.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:h(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(V){switch(V){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function o(V){switch(V){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class w extends T{constructor(){super(123,[62,31])}compute(X,ge,Me){const We=["monaco-editor"];return ge.get(31)&&We.push(ge.get(31)),X.extraEditorClassName&&We.push(X.extraEditorClassName),ge.get(62)==="default"?We.push("mouse-default"):ge.get(62)==="copy"&&We.push("mouse-copy"),ge.get(97)&&We.push("showUnused"),ge.get(121)&&We.push("showDeprecated"),We.join(" ")}}class I extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(X,ge,Me){return Me&&X.emptySelectionClipboard}}class p extends n{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:E.localize(13,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:E.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:h(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:h(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":m(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(ge.loop,this.defaultValue.loop)}}}class g extends n{constructor(){super(41,"fontLigatures",g.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?g.OFF:X==="true"?g.ON:X:Boolean(X)?g.ON:g.OFF}}e.EditorFontLigatures=g,g.OFF='"liga" off, "calt" off',g.ON='"liga" on, "calt" on';class R extends T{constructor(){super(40)}compute(X,ge,Me){return X.fontInfo}}class F extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(X){let ge=s.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(ge,6,100)}compute(X,ge,Me){return X.fontInfo.fontSize}}class $ extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(r.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class ue extends n{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(X){var ge,Me,We,Ue,Ze;if(!X||typeof X!="object")return this.defaultValue;const H=X;return{multiple:m(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=H.multipleDefinitions)!==null&&ge!==void 0?ge:m(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=H.multipleTypeDefinitions)!==null&&Me!==void 0?Me:m(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(We=H.multipleDeclarations)!==null&&We!==void 0?We:m(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=H.multipleImplementations)!==null&&Ue!==void 0?Ue:m(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=H.multipleReferences)!==null&&Ze!==void 0?Ze:m(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends n{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(50,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:E.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:h(ge.enabled,this.defaultValue.enabled),delay:r.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:h(ge.sticky,this.defaultValue.sticky)}}}var B;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class G extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(X,ge,Me){return G.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Me=X.scrollBeyondLastLine?ge-1:0,We=(X.viewLineCount+Me)/(X.pixelRatio*X.height),Ue=Math.floor(X.viewLineCount/We);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Me,desiredRatio:We,minimapLineCount:Ue}}static _computeMinimapLayout(X,ge){const Me=X.outerWidth,We=X.outerHeight,Ue=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ze=ge.stableMinimapLayoutInput,H=Ze&&X.outerHeight===Ze.outerHeight&&X.lineHeight===Ze.lineHeight&&X.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ze.pixelRatio&&X.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&X.minimap.enabled===Ze.minimap.enabled&&X.minimap.side===Ze.minimap.side&&X.minimap.size===Ze.minimap.size&&X.minimap.showSlider===Ze.minimap.showSlider&&X.minimap.renderCharacters===Ze.minimap.renderCharacters&&X.minimap.maxColumn===Ze.minimap.maxColumn&&X.minimap.scale===Ze.minimap.scale&&X.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&X.isViewportWrapping===Ze.isViewportWrapping,ie=X.lineHeight,de=X.typicalHalfwidthCharacterWidth,j=X.scrollBeyondLastLine,Y=X.minimap.renderCharacters;let ae=Ue>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const he=X.minimap.maxColumn,Ee=X.minimap.size,Ne=X.minimap.side,Le=X.verticalScrollbarWidth,je=X.viewLineCount,Je=X.remainingWidth,nt=X.isViewportWrapping,rt=Y?2:3;let ot=Math.floor(Ue*We);const it=ot/Ue;let pt=!1,Ve=!1,pe=rt*ae,Se=ae/Ue,se=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:st,extraLinesBeyondLastLine:Qe,desiredRatio:lt,minimapLineCount:bt}=G.computeContainedMinimapLineCount({viewLineCount:je,scrollBeyondLastLine:j,height:We,lineHeight:ie,pixelRatio:Ue});if(je/bt>1)pt=!0,Ve=!0,ae=1,pe=1,Se=ae/Ue;else{let vt=!1,wt=ae+1;if(Ee==="fit"){const yt=Math.ceil((je+Qe)*pe);nt&&H&&Je<=ge.stableFitRemainingWidth?(vt=!0,wt=ge.stableFitMaxMinimapScale):(vt=yt>ot,nt&&vt?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=Je):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0))}if(Ee==="fill"||vt){pt=!0;const yt=ae;pe=Math.min(ie*Ue,Math.max(1,Math.floor(1/lt))),ae=Math.min(wt,Math.max(1,Math.floor(pe/rt))),ae>yt&&(se=Math.min(2,ae/yt)),Se=ae/Ue/se,ot=Math.ceil(Math.max(st,je+Qe)*pe),nt&&vt&&(ge.stableFitMaxMinimapScale=ae)}}}const q=Math.floor(he*Se),Fe=Math.min(q,Math.max(0,Math.floor((Je-Le-2)*Se/(de+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Ue*Fe);const Ye=Ie/Ue;Ie=Math.floor(Ie*se);const Xe=Y?1:2,at=Ne==="left"?0:Me-Fe-Le;return{renderMinimap:Xe,minimapLeft:at,minimapWidth:Fe,minimapHeightIsEditorHeight:pt,minimapIsSampling:Ve,minimapScale:ae,minimapLineHeight:pe,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:Ye,minimapCanvasOuterHeight:it}}static computeLayout(X,ge){const Me=ge.outerWidth|0,We=ge.outerHeight|0,Ue=ge.lineHeight|0,Ze=ge.lineNumbersDigitCount|0,H=ge.typicalHalfwidthCharacterWidth,ie=ge.maxDigitWidth,de=ge.pixelRatio,j=ge.viewLineCount,Y=X.get(118),ae=Y==="inherit"?X.get(117):Y,he=ae==="inherit"?X.get(113):ae,Ee=X.get(116),Ne=X.get(2),Le=ge.isDominatedByLongLines,je=X.get(46),Je=X.get(56).renderType!==0,nt=X.get(57),rt=X.get(91),ot=X.get(61),it=X.get(89),pt=it.verticalScrollbarSize,Ve=it.verticalHasArrows,pe=it.arrowSize,Se=it.horizontalScrollbarSize,se=X.get(54),q=X.get(35);let Fe;if(typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)){const Tt=parseFloat(se.substr(0,se.length-2));Fe=r.clampedInt(Tt*H,0,0,1e3)}else Fe=r.clampedInt(se,0,0,1e3);q&&(Fe+=16);let Ie=0;if(Je){const Tt=Math.max(Ze,nt);Ie=Math.round(Tt*ie)}let Ye=0;je&&(Ye=Ue);let Xe=0,at=Xe+Ye,st=at+Ie,Qe=st+Fe;const lt=Me-Ye-Ie-Fe;let bt=!1,ct=!1,vt=-1;Ne!==2&&(ae==="inherit"&&Le?(bt=!0,ct=!0):he==="on"||he==="bounded"?ct=!0:he==="wordWrapColumn"&&(vt=Ee));const wt=G._computeMinimapLayout({outerWidth:Me,outerHeight:We,lineHeight:Ue,typicalHalfwidthCharacterWidth:H,pixelRatio:de,scrollBeyondLastLine:rt,minimap:ot,verticalScrollbarWidth:pt,viewLineCount:j,remainingWidth:lt,isViewportWrapping:ct},ge.memory||new y);wt.renderMinimap!==0&&wt.minimapLeft===0&&(Xe+=wt.minimapWidth,at+=wt.minimapWidth,st+=wt.minimapWidth,Qe+=wt.minimapWidth);const yt=lt-wt.minimapWidth,_t=Math.max(1,Math.floor((yt-pt-2)/H)),Mt=Ve?pe:0;return ct&&(vt=Math.max(1,_t),he==="bounded"&&(vt=Math.min(vt,Ee))),{width:Me,height:We,glyphMarginLeft:Xe,glyphMarginWidth:Ye,lineNumbersLeft:at,lineNumbersWidth:Ie,decorationsLeft:st,decorationsWidth:Fe,contentLeft:Qe,contentWidth:yt,minimap:wt,viewportColumn:_t,isWordWrapMinified:bt,isViewportWrapping:ct,wrappingColumn:vt,verticalScrollbarWidth:pt,horizontalScrollbarHeight:Se,overviewRuler:{top:Mt,width:pt,height:We-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=G;class M extends n{constructor(){const X={enabled:!0};super(53,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:E.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}class N extends n{constructor(){const X={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",X,{"editor.inlineHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:X.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:X.fontFamily,description:E.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:h(ge.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class W extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(X,ge,Me){return X.fontInfo.lineHeight}}class Q extends n{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:X.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:E.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:h(ge.enabled,this.defaultValue.enabled),size:m(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ge.side,this.defaultValue.side,["right","left"]),showSlider:m(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(ge.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ge.scale,1,1,3),maxColumn:r.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function x(V){return V==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:r.clampedInt(ge.top,0,0,1e3),bottom:r.clampedInt(ge.bottom,0,0,1e3)}}}class re extends n{constructor(){const X={enabled:!0,cycle:!1};super(72,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:E.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:h(ge.enabled,this.defaultValue.enabled),cycle:h(ge.cycle,this.defaultValue.cycle)}}}class oe extends T{constructor(){super(124)}compute(X,ge,Me){return X.pixelRatio}}class ye extends n{constructor(){const X={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:E.localize(58,null)},comments:{type:"boolean",default:X.comments,description:E.localize(59,null)},other:{type:"boolean",default:X.other,description:E.localize(60,null)}}}],default:X,description:E.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const ge=X,Me={other:h(ge.other,this.defaultValue.other),comments:h(ge.comments,this.defaultValue.comments),strings:h(ge.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Pe;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(X){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(ge=4,Me=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function Re(V){const X=V.get(84);return X==="editable"?V.get(77):X!=="on"}e.filterValidationDecorations=Re;class ze extends n{constructor(){const X=[],ge={type:"number",description:E.localize(67,null)};super(88,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:X,description:E.localize(69,null)})}validate(X){if(Array.isArray(X)){let ge=[];for(let Me of X)if(typeof Me=="number")ge.push({column:r.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const We=Me;ge.push({column:r.clampedInt(We.column,0,0,1e4),color:We.color})}return ge.sort((Me,We)=>Me.column-We.column),ge}return this.defaultValue}}function U(V,X){if(typeof V!="string")return X;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Me=r.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=r.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(ge.vertical,this.defaultValue.vertical),horizontal:U(ge.horizontal,this.defaultValue.horizontal),useShadows:h(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:r.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:We,verticalSliderSize:r.clampedInt(ge.verticalSliderSize,We,0,1e3),scrollByPage:h(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends n{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:X.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:m(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(ge.showIcons,this.defaultValue.showIcons),showStatusBar:h(ge.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:h(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(ge.showMethods,this.defaultValue.showMethods),showFunctions:h(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:h(ge.showConstructors,this.defaultValue.showConstructors),showFields:h(ge.showFields,this.defaultValue.showFields),showVariables:h(ge.showVariables,this.defaultValue.showVariables),showClasses:h(ge.showClasses,this.defaultValue.showClasses),showStructs:h(ge.showStructs,this.defaultValue.showStructs),showInterfaces:h(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:h(ge.showModules,this.defaultValue.showModules),showProperties:h(ge.showProperties,this.defaultValue.showProperties),showEvents:h(ge.showEvents,this.defaultValue.showEvents),showOperators:h(ge.showOperators,this.defaultValue.showOperators),showUnits:h(ge.showUnits,this.defaultValue.showUnits),showValues:h(ge.showValues,this.defaultValue.showValues),showConstants:h(ge.showConstants,this.defaultValue.showConstants),showEnums:h(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:h(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(ge.showKeywords,this.defaultValue.showKeywords),showWords:h(ge.showWords,this.defaultValue.showWords),showColors:h(ge.showColors,this.defaultValue.showColors),showFiles:h(ge.showFiles,this.defaultValue.showFiles),showReferences:h(ge.showReferences,this.defaultValue.showReferences),showFolders:h(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:h(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(ge.showSnippets,this.defaultValue.showSnippets),showUsers:h(ge.showUsers,this.defaultValue.showUsers),showIssues:h(ge.showIssues,this.defaultValue.showIssues)}}}class le extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends T{constructor(){super(125,[77])}compute(X,ge,Me){return ge.get(77)?!0:X.tabFocusMode}}var De;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class me extends T{constructor(){super(127,[126])}compute(X,ge,Me){const We=ge.get(126);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ae:C.isLinux?$e:Ce,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(V){return e.editorOptionsRegistry[V.id]=V,V}var Ke;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useTabStops=111]="useTabStops",V[V.wordSeparators=112]="wordSeparators",V[V.wordWrap=113]="wordWrap",V[V.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=116]="wordWrapColumn",V[V.wordWrapOverride1=117]="wordWrapOverride1",V[V.wordWrapOverride2=118]="wordWrapOverride2",V[V.wrappingIndent=119]="wrappingIndent",V[V.wrappingStrategy=120]="wrappingStrategy",V[V.showDeprecated=121]="showDeprecated",V[V.inlineHints=122]="inlineHints",V[V.editorClassName=123]="editorClassName",V[V.pixelRatio=124]="pixelRatio",V[V.tabFocusMode=125]="tabFocusMode",V[V.layoutInfo=126]="layoutInfo",V[V.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:be(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:be(new u),accessibilityPageSize:be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null)})),ariaLabel:be(new _(4,"ariaLabel",E.localize(115,null))),autoClosingBrackets:be(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(116,null),E.localize(117,null),""],description:E.localize(118,null)})),autoClosingDelete:be(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(119,null),""],description:E.localize(120,null)})),autoClosingOvertype:be(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(121,null),""],description:E.localize(122,null)})),autoClosingQuotes:be(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(123,null),E.localize(124,null),""],description:E.localize(125,null)})),autoIndent:be(new v(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[E.localize(126,null),E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null)],description:E.localize(131,null)})),automaticLayout:be(new f(10,"automaticLayout",!1)),autoSurround:be(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(132,null),E.localize(133,null),E.localize(134,null),""],description:E.localize(135,null)})),stickyTabStops:be(new f(101,"stickyTabStops",!1,{description:E.localize(136,null)})),codeLens:be(new f(12,"codeLens",!0,{description:E.localize(137,null)})),codeLensFontFamily:be(new _(13,"codeLensFontFamily","",{description:E.localize(138,null)})),codeLensFontSize:be(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(139,null)})),colorDecorators:be(new f(15,"colorDecorators",!0,{description:E.localize(140,null)})),columnSelection:be(new f(16,"columnSelection",!1,{description:E.localize(141,null)})),comments:be(new t),contextmenu:be(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(142,null)})),cursorBlinking:be(new v(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:E.localize(143,null)})),cursorSmoothCaretAnimation:be(new f(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(144,null)})),cursorStyle:be(new v(22,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:E.localize(145,null)})),cursorSurroundingLines:be(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(146,null)})),cursorSurroundingLinesStyle:be(new b(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(147,null),E.localize(148,null)],description:E.localize(149,null)})),cursorWidth:be(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(150,null)})),disableLayerHinting:be(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new f(28,"domReadOnly",!1)),dragAndDrop:be(new f(29,"dragAndDrop",!0,{description:E.localize(151,null)})),emptySelectionClipboard:be(new I),extraEditorClassName:be(new _(31,"extraEditorClassName","")),fastScrollSensitivity:be(new s(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:E.localize(152,null)})),find:be(new p),fixedOverflowWidgets:be(new f(34,"fixedOverflowWidgets",!1)),folding:be(new f(35,"folding",!0,{description:E.localize(153,null)})),foldingStrategy:be(new b(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(154,null),E.localize(155,null)],description:E.localize(156,null)})),foldingHighlight:be(new f(37,"foldingHighlight",!0,{description:E.localize(157,null)})),unfoldOnClickAfterEndOfLine:be(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(158,null)})),fontFamily:be(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(159,null)})),fontInfo:be(new R),fontLigatures2:be(new g),fontSize:be(new F),fontWeight:be(new $),formatOnPaste:be(new f(44,"formatOnPaste",!1,{description:E.localize(160,null)})),formatOnType:be(new f(45,"formatOnType",!1,{description:E.localize(161,null)})),glyphMargin:be(new f(46,"glyphMargin",!0,{description:E.localize(162,null)})),gotoLocation:be(new ue),hideCursorInOverviewRuler:be(new f(48,"hideCursorInOverviewRuler",!1,{description:E.localize(163,null)})),highlightActiveIndentGuide:be(new f(49,"highlightActiveIndentGuide",!0,{description:E.localize(164,null)})),hover:be(new z),inDiffEditor:be(new f(51,"inDiffEditor",!1)),letterSpacing:be(new s(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>s.clamp(V,-5,20),{description:E.localize(165,null)})),lightbulb:be(new M),lineDecorationsWidth:be(new k(54,"lineDecorationsWidth",10)),lineHeight:be(new W),lineNumbers:be(new Be),lineNumbersMinChars:be(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(58,"linkedEditing",!1,{description:E.localize(166,null)})),links:be(new f(59,"links",!0,{description:E.localize(167,null)})),matchBrackets:be(new b(60,"matchBrackets","always",["always","near","never"],{description:E.localize(168,null)})),minimap:be(new Q),mouseStyle:be(new b(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new s(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:E.localize(169,null)})),mouseWheelZoom:be(new f(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(170,null)})),multiCursorMergeOverlapping:be(new f(65,"multiCursorMergeOverlapping",!0,{description:E.localize(171,null)})),multiCursorModifier:be(new v(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[E.localize(172,null),E.localize(173,null)],markdownDescription:E.localize(174,null)})),multiCursorPaste:be(new b(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(175,null),E.localize(176,null)],markdownDescription:E.localize(177,null)})),occurrencesHighlight:be(new f(68,"occurrencesHighlight",!0,{description:E.localize(178,null)})),overviewRulerBorder:be(new f(69,"overviewRulerBorder",!0,{description:E.localize(179,null)})),overviewRulerLanes:be(new r(70,"overviewRulerLanes",3,0,3)),padding:be(new Z),parameterHints:be(new re),peekWidgetDefaultFocus:be(new b(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(180,null),E.localize(181,null)],description:E.localize(182,null)})),definitionLinkOpensInPeek:be(new f(74,"definitionLinkOpensInPeek",!1,{description:E.localize(183,null)})),quickSuggestions:be(new ye),quickSuggestionsDelay:be(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(184,null)})),readOnly:be(new f(77,"readOnly",!1)),renameOnType:be(new f(78,"renameOnType",!1,{description:E.localize(185,null),markdownDeprecationMessage:E.localize(186,null)})),renderControlCharacters:be(new f(79,"renderControlCharacters",!1,{description:E.localize(187,null)})),renderIndentGuides:be(new f(80,"renderIndentGuides",!0,{description:E.localize(188,null)})),renderFinalNewline:be(new f(81,"renderFinalNewline",!0,{description:E.localize(189,null)})),renderLineHighlight:be(new b(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(190,null)],description:E.localize(191,null)})),renderLineHighlightOnlyWhenFocus:be(new f(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(192,null)})),renderValidationDecorations:be(new b(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new b(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(193,null),E.localize(194,null),E.localize(195,null),""],description:E.localize(196,null)})),revealHorizontalRightPadding:be(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(87,"roundedSelection",!0,{description:E.localize(197,null)})),rulers:be(new ze),scrollbar:be(new K),scrollBeyondLastColumn:be(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(198,null)})),scrollBeyondLastLine:be(new f(91,"scrollBeyondLastLine",!0,{description:E.localize(199,null)})),scrollPredominantAxis:be(new f(92,"scrollPredominantAxis",!0,{description:E.localize(200,null)})),selectionClipboard:be(new f(93,"selectionClipboard",!0,{description:E.localize(201,null),included:C.isLinux})),selectionHighlight:be(new f(94,"selectionHighlight",!0,{description:E.localize(202,null)})),selectOnLineNumbers:be(new f(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new b(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(203,null),E.localize(204,null)],description:E.localize(205,null)})),showUnused:be(new f(97,"showUnused",!0,{description:E.localize(206,null)})),showDeprecated:be(new f(121,"showDeprecated",!0,{description:E.localize(207,null)})),inlineHints:be(new N),snippetSuggestions:be(new b(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(208,null),E.localize(209,null),E.localize(210,null),E.localize(211,null)],description:E.localize(212,null)})),smartSelect:be(new le),smoothScrolling:be(new f(100,"smoothScrolling",!1,{description:E.localize(213,null)})),stopRenderingLineAfter:be(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new ne),suggestFontSize:be(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(214,null)})),suggestLineHeight:be(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestOnTriggerCharacters:be(new f(106,"suggestOnTriggerCharacters",!0,{description:E.localize(216,null)})),suggestSelection:be(new b(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(217,null),E.localize(218,null),E.localize(219,null)],description:E.localize(220,null)})),tabCompletion:be(new b(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(221,null),E.localize(222,null),E.localize(223,null)],description:E.localize(224,null)})),tabIndex:be(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new b(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(225,null),E.localize(226,null),E.localize(227,null)],description:E.localize(228,null)})),useTabStops:be(new f(111,"useTabStops",!0,{description:E.localize(229,null)})),wordSeparators:be(new _(112,"wordSeparators",P.USUAL_WORD_SEPARATORS,{description:E.localize(230,null)})),wordWrap:be(new b(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(231,null),E.localize(232,null),E.localize(233,null),E.localize(234,null)],description:E.localize(235,null)})),wordWrapBreakAfterCharacters:be(new _(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new _(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(236,null)})),wordWrapOverride1:be(new b(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new b(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new v(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[E.localize(237,null),E.localize(238,null),E.localize(239,null),E.localize(240,null)],description:E.localize(241,null)})),wrappingStrategy:be(new b(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(242,null),E.localize(243,null)],description:E.localize(244,null)})),editorClassName:be(new w),pixelRatio:be(new oe),tabFocusMode:be(new fe),layoutInfo:be(new G),wrappingInfo:be(new me)}}),define(ve[122],_e([16,17]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[123],_e([16,17]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[124],_e([16,17]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ve[125],_e([16,17]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ve[126],_e([16,17]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[127],_e([16,17]),function(ee,e){return ee.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[128],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[129],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[130],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ve[131],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[132],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[133],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[134],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[135],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[136],_e([16,17]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[137],_e([16,17]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(ve[138],_e([16,17]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[139],_e([16,17]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[140],_e([16,17]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[141],_e([16,17]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[142],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var C;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(C=e.EditorOverride||(e.EditorOverride={}));var P;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(P=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[143],_e([0,1,123]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(k){return k=k.trim(),k==="*"||C.test(k)}e.isValidVersionStr=P;function A(k){if(!P(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=k.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=A;function S(k){if(!k)return null;let h=k.majorBase,f=k.majorMustEqual,r=k.minorBase,s=k.minorMustEqual,_=k.patchBase,m=k.patchMustEqual;return k.hasCaret&&(h===0||(s=!1),m=!1),{majorBase:h,majorMustEqual:f,minorBase:r,minorMustEqual:s,patchBase:_,patchMustEqual:m,isMinimum:k.hasGreaterEquals}}e.normalizeVersion=S;function D(k,h){let f;typeof k=="string"?f=S(A(k)):f=k;let r;if(typeof h=="string"?r=S(A(h)):r=h,!f||!r)return!1;let s=f.majorBase,_=f.minorBase,m=f.patchBase,b=r.majorBase,v=r.minorBase,d=r.patchBase,u=r.majorMustEqual,t=r.minorMustEqual,i=r.patchMustEqual;return r.isMinimum?s>b?!0:s<b?!1:_>v?!0:_<v?!1:m>=d:(s===1&&b===0&&(!u||!t||!i)&&(b=1,v=0,d=0,u=!0,t=!1,i=!1),s<b?!1:s>b?!u:_<v?!1:_>v?!t:m<d?!1:m>d?!i:!0)}e.isValidVersion=D;function y(k,h,f){return h.isBuiltin||typeof h.main=="undefined"?!0:T(k,h.engines.vscode,f)}e.isValidExtensionVersion=y;function n(k,h){return k==="*"||T(h,k)}e.isEngineValid=n;function T(k,h,f=[]){let r=S(A(h));if(!r)return f.push(E.localize(0,null,h)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return f.push(E.localize(1,null,h)),!1}else if(!r.majorMustEqual)return f.push(E.localize(2,null,h)),!1;return D(k,r)?!0:(f.push(E.localize(3,null,k,h)),!1)}e.isVersionValid=T}),define(ve[87],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(A,S=[],D=!1){this.ctor=A,this.staticArguments=S,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E;const C=(P,...A)=>new E(P,A);e.createSyncDescriptor=C}),define(ve[62],_e([0,1,87]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const C=[];function P(S,D,y){D instanceof E.SyncDescriptor||(D=new E.SyncDescriptor(D,[],y)),C.push([S,D])}e.registerSingleton=P;function A(){return C}e.getSingletonServiceDescriptors=A}),define(ve[144],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=E;class C{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let S of this._nodes.values())S.outgoing.size===0&&A.push(S);return A}insertEdge(A,S){const D=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(S);D.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(A),D)}removeNode(A){const S=this._hashFn(A);this._nodes.delete(S);for(let D of this._nodes.values())D.outgoing.delete(S),D.incoming.delete(S)}lookupOrInsertNode(A){const S=this._hashFn(A);let D=this._nodes.get(S);return D||(D=new E(A),this._nodes.set(S,D)),D}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[S,D]of this._nodes)A.push(`${S}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,S]of this._nodes){const D=new Set([A]),y=this._findCycle(S,D);if(y)return y}}_findCycle(A,S){for(let[D,y]of A.outgoing){if(S.has(D))return[...S,D].join(" -> ");S.add(D);const n=this._findCycle(y,S);if(n)return n;S.delete(D)}}}e.Graph=C}),define(ve[4],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function C(D,y,n,T){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:D,index:n,optional:T}):(y[E.DI_DEPENDENCIES]=[{id:D,index:n,optional:T}],y[E.DI_TARGET]=y)}function P(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const y=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(y,n,k,!1)};return y.toString=()=>D,E.serviceIds.set(D,y),y}e.createDecorator=P;function A(D){return D}e.refineServiceDecorator=A;function S(D){return function(y,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");C(D,y,T,!0)}}e.optional=S}),define(ve[145],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function C(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=C}),define(ve[146],_e([0,1,3,57,6,22,79,60,145]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(n):!!h.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(f,r){let s={selector:f,provider:r,_score:-1,_time:this._clock++};return this._entries.push(s),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,P.toDisposable)(()=>{if(s){let _=this._entries.indexOf(s);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),s=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const r=[];for(let s of this._entries)s._score>0&&r.push(s.provider);return r}ordered(f){const r=[];return this._orderedForEach(f,s=>r.push(s.provider)),r}orderedGroups(f){const r=[];let s,_;return this._orderedForEach(f,m=>{s&&_===m._score?s.push(m.provider):(_=m._score,s=[m.provider],r.push(s))}),r}_orderedForEach(f,r){if(!!f){this._updateScores(f);for(const s of this._entries)s._score>0&&r(s)}}_updateScores(f){let r={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let s of this._entries)if(s._score=(0,D.score)(s.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),n(s.selector)&&s._score>0){for(let _ of this._entries)_._score=0;s._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(f,r){return f._score<r._score?1:f._score>r._score?-1:f._time<r._time?1:f._time>r._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(f,r,s=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=r,this.max=s,this._cache=new A.LRUCache(50,.7)}_key(f){return f.id+(0,C.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const r=this._key(f),s=this._cache.get(r);return this._clamp(s==null?void 0:s.value)}update(f,r){const s=this._key(f);let _=this._cache.get(s);return _||(_=new S.MovingAverage,this._cache.set(s,_)),_.update(r),this.get(f)}}e.LanguageFeatureRequestDelays=k}),define(ve[63],_e([0,1,2,32,146,117,36]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(g,R){this.language=g,this.id=R}}e.LanguageIdentifier=y;var n;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var h;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(h=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(g){return(g&255)>>>0}static getTokenType(g){return(g&1792)>>>8}static getFontStyle(g){return(g&14336)>>>11}static getForeground(g){return(g&8372224)>>>14}static getBackground(g){return(g&4286578688)>>>23}static getClassNameFromMetadata(g){let R=this.getForeground(g),F="mtk"+R,$=this.getFontStyle(g);return $&1&&(F+=" mtki"),$&2&&(F+=" mtkb"),$&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(g,R){const F=this.getForeground(g),$=this.getFontStyle(g);let ue=`color: ${R[F]};`;return $&1&&(ue+="font-style: italic;"),$&2&&(ue+="font-weight: bold;"),$&4&&(ue+="text-decoration: underline;"),ue}}e.TokenMetadata=f;var r;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(g){const R=p[g];let F=R&&S.iconRegistry.get(R);return F||(console.info("No codicon found for CompletionItemKind "+g),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(g,R){let F=p[g];return typeof F=="undefined"&&!R&&(F=9),F}}();var s;(function(p){p[p.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function u(p){return p&&E.URI.isUri(p.uri)&&C.Range.isIRange(p.range)&&(C.Range.isIRange(p.originSelectionRange)||C.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=u;var t;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(p){p[p.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var c;(function(p){const g=new Map;g.set("file",0),g.set("module",1),g.set("namespace",2),g.set("package",3),g.set("class",4),g.set("method",5),g.set("property",6),g.set("field",7),g.set("constructor",8),g.set("enum",9),g.set("interface",10),g.set("function",11),g.set("variable",12),g.set("constant",13),g.set("string",14),g.set("number",15),g.set("boolean",16),g.set("array",17),g.set("object",18),g.set("key",19),g.set("null",20),g.set("enum-member",21),g.set("struct",22),g.set("event",23),g.set("operator",24),g.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function F(z){return g.get(z)}p.fromString=F;function $(z){return R.get(z)}p.toString=$;function ue(z,B){const G=R.get(z);let M=G&&S.iconRegistry.get("symbol-"+G);return M||(console.info("No codicon found for SymbolKind "+z),M=S.Codicon.symbolProperty),`${B?"inline":"block"} ${M.classNames}`}p.toCssClassName=ue})(c=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(g){this.value=g}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var l;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var w;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(w=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new P.LanguageFeatureRegistry,e.RenameProviderRegistry=new P.LanguageFeatureRegistry,e.CompletionProviderRegistry=new P.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new P.LanguageFeatureRegistry,e.HoverProviderRegistry=new P.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new P.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new P.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new P.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new P.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new P.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new P.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.LinkProviderRegistry=new P.LanguageFeatureRegistry,e.ColorProviderRegistry=new P.LanguageFeatureRegistry,e.SelectionRangeRegistry=new P.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var I;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[147],_e([0,1,6,13,4,3,44,55]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,P.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const r=[];for(let _ of y.description.args)r.push(_.constraint);const s=y.handler;y.handler=function(_,...m){return(0,C.validateConstraints)(m,r),s(_,...m)}}const{id:T}=y;let k=this._commands.get(T);k||(k=new S.LinkedList,this._commands.set(T,k));let h=k.unshift(y),f=(0,E.toDisposable)(()=>{h();const r=this._commands.get(T);(r==null?void 0:r.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),f}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return D.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&y.set(n,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ve[64],_e([0,1,8,4,21]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=P.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",P.isMacintosh),S.set("isLinux",P.isLinux),S.set("isWindows",P.isWindows),S.set("isWeb",P.isWeb),S.set("isMacNative",P.isMacintosh&&!P.isWeb),S.set("isEdge",A.indexOf("Edg/")>=0),S.set("isFirefox",A.indexOf("Firefox")>=0),S.set("isChrome",A.indexOf("Chrome")>=0),S.set("isSafari",A.indexOf("Safari")>=0),S.set("isIPad",A.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(p){p[p.False=0]="False",p[p.True=1]="True",p[p.Defined=2]="Defined",p[p.Not=3]="Not",p[p.Equals=4]="Equals",p[p.NotEquals=5]="NotEquals",p[p.And=6]="And",p[p.Regex=7]="Regex",p[p.NotRegex=8]="NotRegex",p[p.Or=9]="Or",p[p.In=10]="In",p[p.NotIn=11]="NotIn",p[p.Greater=12]="Greater",p[p.GreaterEquals=13]="GreaterEquals",p[p.Smaller=14]="Smaller",p[p.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return h.INSTANCE}static has(g){return f.create(g)}static equals(g,R){return r.create(g,R)}static notEquals(g,R){return m.create(g,R)}static regex(g,R){return i.create(g,R)}static in(g,R){return s.create(g,R)}static not(g){return b.create(g)}static and(...g){return a.create(g)}static or(...g){return l.create(g)}static greater(g,R){return v.create(g,R)}static less(g,R){return u.create(g,R)}static deserialize(g,R=!1){if(!!g)return this._deserializeOrExpression(g,R)}static _deserializeOrExpression(g,R){let F=g.split("||");return l.create(F.map($=>this._deserializeAndExpression($,R)))}static _deserializeAndExpression(g,R){let F=g.split("&&");return a.create(F.map($=>this._deserializeOne($,R)))}static _deserializeOne(g,R){if(g=g.trim(),g.indexOf("!=")>=0){let F=g.split("!=");return m.create(F[0].trim(),this._deserializeValue(F[1],R))}if(g.indexOf("==")>=0){let F=g.split("==");return r.create(F[0].trim(),this._deserializeValue(F[1],R))}if(g.indexOf("=~")>=0){let F=g.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],R))}if(g.indexOf(" in ")>=0){let F=g.split(" in ");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const F=g.split(">=");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const F=g.split(">");return v.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const F=g.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const F=g.split("<");return u.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(g)?b.create(g.substr(1).trim()):f.create(g)}static _deserializeValue(g,R){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let F=/^'([^']*)'$/.exec(g);return F?F[1].trim():g}static _deserializeRegexValue(g,R){if((0,E.isFalsyOrWhitespace)(g)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=g.indexOf("/"),$=g.lastIndexOf("/");if(F===$||F<0){if(R)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let ue=g.slice(F+1,$),z=g[$+1]==="i"?"i":"";try{return new RegExp(ue,z)}catch(B){if(R)throw new Error(`bad regexp-value '${g}', parse error: ${B}`);return console.warn(`bad regexp-value '${g}', parse error: ${B}`),null}}}e.ContextKeyExpr=n;function T(p,g){return p.cmp(g)}class k{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class h{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class f{constructor(g){this.key=g,this.type=2}static create(g){const R=S.get(g);return typeof R=="boolean"?R?h.INSTANCE:k.INSTANCE:new f(g)}cmp(g){return g.type!==this.type?this.type-g.type:w(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=f;class r{constructor(g,R){this.key=g,this.value=R,this.type=4}static create(g,R){if(typeof R=="boolean")return R?f.create(g):b.create(g);const F=S.get(g);return typeof F=="boolean"?R===(F?"true":"false")?h.INSTANCE:k.INSTANCE:new r(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class s{constructor(g,R){this.key=g,this.valueKey=R,this.type=10}static create(g,R){return new s(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const R=g.getValue(this.valueKey),F=g.getValue(this.key);return Array.isArray(R)?R.indexOf(F)>=0:typeof F=="string"&&typeof R=="object"&&R!==null?D.call(R,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=s;class _{constructor(g){this._actual=g,this.type=11}static create(g){return new _(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new _(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class m{constructor(g,R){this.key=g,this.value=R,this.type=5}static create(g,R){if(typeof R=="boolean")return R?b.create(g):f.create(g);const F=S.get(g);return typeof F=="boolean"?R===(F?"true":"false")?k.INSTANCE:h.INSTANCE:new m(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class b{constructor(g){this.key=g,this.type=3}static create(g){const R=S.get(g);return typeof R=="boolean"?R?k.INSTANCE:h.INSTANCE:new b(g)}cmp(g){return g.type!==this.type?this.type-g.type:w(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=b;class v{constructor(g,R){this.key=g,this.value=R,this.type=12}static create(g,R){return new v(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class d{constructor(g,R){this.key=g,this.value=R,this.type=13}static create(g,R){return new d(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class u{constructor(g,R){this.key=g,this.value=R,this.type=14}static create(g,R){return new u(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=u;class t{constructor(g,R){this.key=g,this.value=R,this.type=15}static create(g,R){return new t(g,R)}cmp(g){return g.type!==this.type?this.type-g.type:I(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(g,R){this.key=g,this.regexp=R,this.type=7}static create(g,R){return new i(g,R)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const R=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return R<F?-1:R>F?1:0}equals(g){if(g.type===this.type){const R=this.regexp?this.regexp.source:"",F=g.regexp?g.regexp.source:"";return this.key===g.key&&R===F}return!1}evaluate(g){let R=g.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return c.create(this)}}e.ContextKeyRegexExpr=i;class c{constructor(g){this._actual=g,this.type=8}static create(g){return new c(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new c(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=c;class a{constructor(g){this.expr=g,this.type=6}static create(g){return a._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const $=T(this.expr[R],g.expr[R]);if($!==0)return $}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(g.expr[R]))return!1;return!0}return!1}evaluate(g){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(g))return!1;return!0}static _normalizeArr(g){const R=[];let F=!1;for(const $ of g)if(!!$){if($.type===1){F=!0;continue}if($.type===0)return k.INSTANCE;if($.type===6){R.push(...$.expr);continue}R.push($)}if(R.length===0&&F)return h.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(T);R.length>1;){const $=R[R.length-1];if($.type!==9)break;R.pop();const ue=R.pop(),z=l.create($.expr.map(B=>a.create([B,ue])));z&&(R.push(z),R.sort(T))}return R.length===1?R[0]:new a(R)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let R of this.expr)g.push(...R.keys());return g}map(g){return new a(this.expr.map(R=>R.map(g)))}negate(){let g=[];for(let R of this.expr)g.push(R.negate());return l.create(g)}}e.ContextKeyAndExpr=a;class l{constructor(g){this.expr=g,this.type=9}static create(g){const R=l._normalizeArr(g);if(R.length!==0)return R.length===1?R[0]:new l(R)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const $=T(this.expr[R],g.expr[R]);if($!==0)return $}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(g.expr[R]))return!1;return!0}return!1}evaluate(g){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(g))return!0;return!1}static _normalizeArr(g){let R=[],F=!1;if(g){for(let $=0,ue=g.length;$<ue;$++){const z=g[$];if(!!z){if(z.type===0){F=!0;continue}if(z.type===1)return[h.INSTANCE];if(z.type===9){R=R.concat(z.expr);continue}R.push(z)}}if(R.length===0&&F)return[k.INSTANCE];R.sort(T)}return R}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let R of this.expr)g.push(...R.keys());return g}map(g){return new l(this.expr.map(R=>R.map(g)))}negate(){let g=[];for(let F of this.expr)g.push(F.negate());const R=F=>F.type===9?F.expr:[F];for(;g.length>1;){const F=g.shift(),$=g.shift(),ue=[];for(const z of R(F))for(const B of R($))ue.push(n.and(z,B));g.unshift(n.or(...ue))}return g[0]}}e.ContextKeyOrExpr=l;class o extends f{constructor(g,R,F){super(g);this._defaultValue=R,typeof F=="object"?o._info.push(Object.assign(Object.assign({},F),{key:g})):F!==!0&&o._info.push({key:g,description:F,type:R!=null?typeof R:void 0})}static all(){return o._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(g){return n.equals(this.key,g)}notEqualsTo(g){return n.notEquals(this.key,g)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(p,g){return p<g?-1:p>g?1:0}function I(p,g,R,F){return p<R?-1:p>R?1:g<F?-1:g>F?1:0}}),define(ve[148],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],_e([0,1,8,4]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class S{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let h=typeof T=="string"?T:T.value,f=typeof k=="string"?k:k.value;return E.equalsIgnoreCase(h,f)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=S;function D(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[149],_e([0,1,8,26]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(f,r){return f.uuid&&r.uuid?f.uuid===r.uuid:f.id===r.id?!0:(0,E.compareIgnoreCase)(f.id,r.id)===0}e.areSameExtensions=P;class A{constructor(r,s){this.version=s,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof A?P(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=A;function S(f,r){return`${f}.${r}`}e.getExtensionId=S;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(f,r){return D(S(f,r))}e.getGalleryExtensionId=y;function n(f,r){const s=[],_=m=>{for(const b of s)if(b.some(v=>P(r(v),r(m))))return b;return null};for(const m of f){const b=_(m);b?b.push(m):s.push([m])}return s}e.groupByExtension=n;function T(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function h(f){const r=new Set;for(const s of f)s.malicious&&r.add(s.id.id);return r}e.getMaliciousExtensionsSet=h}),define(ve[65],_e([0,1,124,12,2,4,8,13,22]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function n(z){return z.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=h;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function r(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function s(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=s;var _;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(B,G){super(B);this.code=G}}e.FileSystemProviderError=m;function b(z,B){const G=new m(z.toString(),B);return d(G,B),G}e.createFileSystemProviderError=b;function v(z){return z||b((0,E.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=v;function d(z,B){return z.name=B?`${B} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=d;function u(z){if(!z)return _.Unknown;if(z instanceof m)return z.code;const B=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!B)return _.Unknown;switch(B[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=u;function t(z){if(z instanceof w)return z.fileOperationResult;switch(u(z)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class c{constructor(B,G,M){this.resource=B,this.operation=G,this.target=M}isOperation(B){return this.operation===B}}e.FileOperationEvent=c;var a;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,G){this.ignorePathCasing=G,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const M of B)switch(M.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(M.resource,M);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(M.resource,M);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(M.resource,M);break}}contains(B,...G){return this.doContains(B,{includeChildren:!1},...G)}affects(B,...G){return this.doContains(B,{includeChildren:!0},...G)}doContains(B,G,...M){var N,W,Q,x,Z,re;if(!B)return!1;const oe=M.length>0;return!!((!oe||M.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(B))||G.includeChildren&&((W=this.added)===null||W===void 0?void 0:W.findSuperstr(B)))||(!oe||M.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(B))||G.includeChildren&&((x=this.updated)===null||x===void 0?void 0:x.findSuperstr(B)))||(!oe||M.includes(2))&&(((Z=this.deleted)===null||Z===void 0?void 0:Z.findSubstr(B))||G.includeChildren&&((re=this.deleted)===null||re===void 0?void 0:re.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const G=[],M=B===1?this.added:B===0?this.updated:this.deleted;if(M)for(const[,N]of M)G.push(N);return G}filter(B){return new l(this.changes.filter(G=>B(G)),this.ignorePathCasing)}}e.FileChangesEvent=l;function o(z,B,G){return!z||!B||z===B||B.length>z.length?!1:(B.charAt(B.length-1)!==C.sep&&(B+=C.sep),G?(0,S.startsWithIgnoreCase)(z,B):z.indexOf(B)===0)}e.isParent=o;class w extends Error{constructor(B,G,M){super(B);this.fileOperationResult=G,this.options=M}static isFileOperationError(B){return B instanceof Error&&!(0,D.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=w;var I;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var p;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(p=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function g(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=g;async function R(z,B){if(!B.canHandleResource(P.URI.from({scheme:z.scheme})))return new Promise(G=>{const M=B.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===z.scheme&&N.added&&(M.dispose(),G())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(B){return(0,D.isNumber)(B)||(B=0),B<F.KB?(0,E.localize)(1,null,B.toFixed(0)):B<F.MB?(0,E.localize)(2,null,(B/F.KB).toFixed(2)):B<F.GB?(0,E.localize)(3,null,(B/F.MB).toFixed(2)):B<F.TB?(0,E.localize)(4,null,(B/F.GB).toFixed(2)):(0,E.localize)(5,null,(B/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var $;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function ue(z){return{maxFileSize:z===0?300*F.MB:16*F.GB,maxHeapSize:z===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=ue}),define(ve[66],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...P){this._entries=new Map;for(let[A,S]of P)this.set(A,S)}set(P,A){const S=this._entries.get(P);return this._entries.set(P,A),S}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=E}),define(ve[150],_e([0,1,10,144,87,4,66,14]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(r){var s;super("cyclic dependency between services");this.message=(s=r.findCycleSlow())!==null&&s!==void 0?s:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class T{constructor(r=new S.ServiceCollection,s=!1,_){this._activeInstantiations=new Set,this._services=r,this._strict=s,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(r){return new T(r,this._strict,this)}invokeFunction(r,...s){let _=h.traceInvocation(r),m=!1;try{return r({get:(v,d)=>{if(m)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(v,_);if(!u&&d!==A.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return u}},...s)}finally{m=!0,_.stop()}}createInstance(r,...s){let _,m;return r instanceof P.SyncDescriptor?(_=h.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(s),_)):(_=h.traceCreation(r),m=this._createInstance(r,s,_)),_.stop(),m}_createInstance(r,s=[],_){let m=A._util.getServiceDependencies(r).sort((d,u)=>d.index-u.index),b=[];for(const d of m){let u=this._getOrCreateServiceInstance(d.id,_);if(!u&&this._strict&&!d.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${d.id}.`);b.push(u)}let v=m.length>0?m[0].index:s.length;if(s.length!==v){console.warn(`[createInstance] First service dependency of ${r.name} at position ${v+1} conflicts with ${s.length} static arguments`);let d=v-s.length;d>0?s=s.concat(new Array(d)):s=s.slice(0,v)}return new r(...[...s,...b])}_setServiceInstance(r,s){if(this._services.get(r)instanceof P.SyncDescriptor)this._services.set(r,s);else if(this._parent)this._parent._setServiceInstance(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let s=this._services.get(r);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):s}_getOrCreateServiceInstance(r,s){let _=this._getServiceInstanceOrDescriptor(r);return _ instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,_,s.branch(r,!0)):(s.branch(r,!1),_)}_safeCreateAndCacheServiceInstance(r,s,_){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,s,_)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,s,_){const m=new C.Graph(d=>d.id.toString());let b=0;const v=[{id:r,desc:s,_trace:_}];for(;v.length;){const d=v.pop();if(m.lookupOrInsertNode(d),b++>1e3)throw new n(m);for(let u of A._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${r} depends on ${u.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const i={id:u.id,desc:t,_trace:d._trace.branch(u.id,!0)};m.insertEdge(d,i),v.push(i)}}}for(;;){const d=m.roots();if(d.length===0){if(!m.isEmpty())throw new n(m);break}for(const{data:u}of d){if(this._getServiceInstanceOrDescriptor(u.id)instanceof P.SyncDescriptor){const i=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,i)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,s,_=[],m,b){if(this._services.get(r)instanceof P.SyncDescriptor)return this._createServiceInstance(s,_,m,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,s,_,m,b);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(r,s=[],_,m){if(_){const b=new D.IdleValue(()=>this._createInstance(r,s,m));return new Proxy(Object.create(null),{get(v,d){if(d in v)return v[d];let u=b.value,t=u[d];return typeof t!="function"||(t=t.bind(u),v[d]=t),t},set(v,d,u){return b.value[d]=u,!0}})}else return this._createInstance(r,s,m)}}e.InstantiationService=T;var k;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(k||(k={}));class h{constructor(r,s){this.type=r,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new h(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(r){return y?new h(0,r.name):h._None}branch(r,s){let _=new h(2,r.toString());return this._dep.push([r,s,_]),_}stop(){let r=Date.now()-this._start;h._totals+=r;let s=!1;function _(b,v){let d=[],u=new Array(b+1).join("	");for(const[t,i,c]of v._dep)if(i&&c){s=!0,d.push(`${u}CREATES -> ${t}`);let a=_(b+1,c);a&&d.push(a)}else d.push(`${u}uses -> ${t}`);return d.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(r>2||s)&&console.log(m.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ve[19],_e([0,1,4,6,21,3,61]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(y.Error))if(t instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=t.stack,this.log(y.Error,this.format(c))}else this.log(y.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let c=0;c<t.length;c++){let a=t[c];if(typeof a=="object")try{a=JSON.stringify(a)}catch(l){}i+=(c>0?" ":"")+a}return i}}e.AbstractMessageLogger=T;class k extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...i){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}debug(t,...i){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}info(t,...i){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...i):console.log(`[main ${D()}]`,t,...i))}warn(t,...i){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...i):console.warn(`[main ${D()}]`,t,...i))}error(t,...i){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}critical(t,...i){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...i):console.error(`[main ${D()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class h extends n{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=h;class f extends n{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class r extends n{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const c of this.logServices)c.trace(t,...i)}debug(t,...i){for(const c of this.logServices)c.debug(t,...i)}info(t,...i){for(const c of this.logServices)c.info(t,...i)}warn(t,...i){for(const c of this.logServices)c.warn(t,...i)}error(t,...i){for(const c of this.logServices)c.error(t,...i)}critical(t,...i){for(const c of this.logServices)c.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class s extends C.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=s;class _ extends C.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(c))}))}createLogger(t,i){let c=this.loggers.get(t.toString());return c||(c=this.doCreateLogger(t,(i==null?void 0:i.always)?y.Trace:this.logLevel,i),this.loggers.set(t.toString(),c),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class m{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=m;function b(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const t=v(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function v(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function d(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=d}),define(ve[88],_e([0,1,4,125,46]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(r,s){return s-r}y.compare=n;const T=Object.create(null);T[y.Error]=(0,C.localize)(0,null),T[y.Warning]=(0,C.localize)(1,null),T[y.Info]=(0,C.localize)(2,null);function k(r){return T[r]||""}y.toString=k;function h(r){switch(r){case P.default.Error:return y.Error;case P.default.Warning:return y.Warning;case P.default.Info:return y.Info;case P.default.Ignore:return y.Hint}}y.fromSeverity=h;function f(r){switch(r){case y.Error:return P.default.Error;case y.Warning:return P.default.Warning;case y.Info:return P.default.Info;case y.Hint:return P.default.Ignore}}y.toSeverity=f}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const n="";function T(h){return k(h,!0)}y.makeKey=T;function k(h,f){let r=[n];return h.source?r.push(h.source.replace("\xA6","\\\xA6")):r.push(n),h.code?typeof h.code=="string"?r.push(h.code.replace("\xA6","\\\xA6")):r.push(h.code.value.replace("\xA6","\\\xA6")):r.push(n),h.severity!==void 0&&h.severity!==null?r.push(S.toString(h.severity)):r.push(n),h.message&&f?r.push(h.message.replace("\xA6","\\\xA6")):r.push(n),h.startLineNumber!==void 0&&h.startLineNumber!==null?r.push(h.startLineNumber.toString()):r.push(n),h.startColumn!==void 0&&h.startColumn!==null?r.push(h.startColumn.toString()):r.push(n),h.endLineNumber!==void 0&&h.endLineNumber!==null?r.push(h.endLineNumber.toString()):r.push(n),h.endColumn!==void 0&&h.endColumn!==null?r.push(h.endColumn.toString()):r.push(n),r.push(n),r.join("\xA6")}y.makeKeyOptionalMessage=k})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(ve[151],_e([0,1,46,4,3]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,C.createDecorator)("notificationService");var A;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y});var qe=this&&this.__decorate||function(ee,e,E,C){var P=arguments.length,A=P<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,E):C,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ee,e,E,C);else for(var D=ee.length-1;D>=0;D--)(S=ee[D])&&(A=(P<3?S(A):P>3?S(e,E,A):S(e,E))||A);return P>3&&A&&Object.defineProperty(e,E,A),A},Ge=this&&this.__param||function(ee,e){return function(E,C){e(E,C,ee)}};define(ve[152],_e([0,1,4,20,6,14]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var S;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends P.Disposable{constructor(k,h){super();this.deferred=new A.DeferredPromise,h.withProgress(k,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=qe([Ge(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends P.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(k){this.stop();const h=++this.currentOperationId,f=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:f.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(ve[30],_e([0,1,13,42]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(S,D){C.ok(E.isString(S)),C.ok(E.isObject(D)),C.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,D)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new P}),define(ve[89],_e([0,1,30,3]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class A{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[P(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new A;E.Registry.add(e.Extensions.JSONContribution,S)}),define(ve[67],_e([0,1,122,3,30,13,89]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=P.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,b=!0){this.registerConfigurations([m],b)}registerConfigurations(m,b=!0){const v=[];m.forEach(d=>{v.push(...this.validateAndRegisterProperties(d,b,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(m){const b=[],v=d=>{if(d.properties)for(const u in d.properties)b.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,d.properties[u]);d.allOf&&d.allOf.forEach(u=>v(u))};for(const d of m){v(d);const u=this.configurationContributors.indexOf(d);u!==-1&&this.configurationContributors.splice(u,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}registerDefaultConfigurations(m){const b=[],v=[];for(const d of m)for(const u in d)if(b.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]=Object.assign(Object.assign({},this.defaultValues[u]||{}),d[u]);const t={type:"object",default:this.defaultValues[u],description:E.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};v.push(k(u)),this.configurationProperties[u]=t,this.defaultLanguageConfigurationOverridesNode.properties[u]=t}else{this.defaultValues[u]=d[u];const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterDefaultConfigurations(m){const b=[];for(const v of m)for(const d in v)if(b.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const u=this.configurationProperties[d];u&&(this.updatePropertyDefaultValue(d,u),this.updateSchema(d,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const b of m)this.overrideIdentifiers.add(b);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,b=!0,v,d=3){var u;d=A.isUndefinedOrNull(m.scope)?d:m.scope;let t=[],i=m.properties;if(i)for(let a in i){if(b&&r(a)){delete i[a];continue}const l=i[a];if(this.updatePropertyDefaultValue(a,l),e.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=A.isUndefinedOrNull(l.scope)?d:l.scope,l.requireTrust=A.isUndefinedOrNull(l.requireTrust)?!!((u=v==null?void 0:v.requireTrustForConfigurations)===null||u===void 0?void 0:u.includes(a)):l.requireTrust),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),t.push(a)}let c=m.allOf;if(c)for(let a of c)t.push(...this.validateAndRegisterProperties(a,b,v,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const b=v=>{let d=v.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let u=v.allOf;u&&u.forEach(b)};b(m)}updateSchema(m,b){switch(e.allSettings.properties[m]=b,b.scope){case 1:e.applicationSettings.properties[m]=b;break;case 2:e.machineSettings.properties[m]=b;break;case 6:e.machineOverridableSettings.properties[m]=b;break;case 3:e.windowSettings.properties[m]=b;break;case 4:e.resourceSettings.properties[m]=b;break;case 5:e.resourceSettings.properties[m]=b,this.resourceLanguageSettingsSchema.properties[m]=b;break}}removeFromSchema(m,b){switch(delete e.allSettings.properties[m],b.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const b=`[${m}]`,v={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(b,v),e.allSettings.properties[b]=v,e.applicationSettings.properties[b]=v,e.machineSettings.properties[b]=v,e.machineOverridableSettings.properties[b]=v,e.windowSettings.properties[b]=v,e.resourceSettings.properties[b]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,b){let v=this.defaultValues[m];A.isUndefined(v)&&(v=b.default),A.isUndefined(v)&&(v=h(b.type)),b.default=v}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=k;function h(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const f=new n;P.Registry.add(e.Extensions.Configuration,f);function r(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?E.localize(5,null,_):f.getConfigurationProperties()[_]!==void 0?E.localize(6,null,_):null:E.localize(4,null)}e.validateProperty=r;function s(){const _=[],m=f.getConfigurationProperties();for(const b of Object.keys(m))_.push([b,m[b].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=s}),define(ve[90],_e([0,1,24,13,2,30,4,67]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof P.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(i,c){const a=c?i?c.keys.filter(R=>i.keys.indexOf(R)===-1):[...c.keys]:[],l=i?c?i.keys.filter(R=>c.keys.indexOf(R)===-1):[...i.keys]:[],o=[];if(c&&i){for(const R of i.keys)if(c.keys.indexOf(R)!==-1){const F=m(i.contents,R),$=m(c.contents,R);E.equals(F,$)||o.push(R)}}const w=[],I=R=>{const F={};for(const $ of R)for(const ue of $.identifiers)F[u(ue)]=$;return F},p=c?I(c.overrides):{},g=i?I(i.overrides):{};if(Object.keys(p).length)for(const R of a){const F=p[R];F&&w.push([(0,D.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(g).length)for(const R of l){const F=g[R];F&&w.push([(0,D.overrideIdentifierFromKey)(R),F.keys])}if(Object.keys(p).length&&Object.keys(g).length)for(const R of o){const F=g[R],$=p[R];if(F&&$){const ue=k({contents:F.contents,keys:F.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});w.push([(0,D.overrideIdentifierFromKey)(R),[...ue.added,...ue.removed,...ue.updated]])}}return{added:a,removed:l,updated:o,overrides:w}}e.compare=k;function h(i,c){const a=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const o={};for(const w in i[l])o[w]=i[l][w];a.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(o),contents:f(o,c)})}return a}e.toOverrides=h;function f(i,c){const a=Object.create(null);for(let l in i)r(a,l,i[l],c);return a}e.toValuesTree=f;function r(i,c,a,l){const o=c.split("."),w=o.pop();let I=i;for(let p=0;p<o.length;p++){let g=o[p],R=I[g];switch(typeof R){case"undefined":R=I[g]=Object.create(null);break;case"object":break;default:l(`Ignoring ${c} as ${o.slice(0,p+1).join(".")} is ${JSON.stringify(R)}`);return}I=R}if(typeof I=="object"&&I!==null)try{I[w]=a}catch(p){l(`Ignoring ${c} as ${o.join(".")} is ${JSON.stringify(I)}`)}else l(`Ignoring ${c} as ${o.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=r;function s(i,c){const a=c.split(".");_(i,a)}e.removeFromValueTree=s;function _(i,c){const a=c.shift();if(c.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const l=i[a];typeof l=="object"&&!Array.isArray(l)&&(_(l,c),Object.keys(l).length===0&&delete i[a])}}function m(i,c,a){function l(I,p){let g=I;for(const R of p){if(typeof g!="object"||g===null)return;g=g[R]}return g}const o=c.split("."),w=l(i,o);return typeof w=="undefined"?a:w}e.getConfigurationValue=m;function b(i,c,a){Object.keys(c).forEach(l=>{l!=="__proto__"&&(l in i?C.isObject(i[l])&&C.isObject(c[l])?b(i[l],c[l],a):a&&(i[l]=c[l]):i[l]=c[l])})}e.merge=b;function v(){const i=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=v;function d(){const i=Object.create(null),c=A.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let a in c){let l=c[a].default;r(i,a,l,o=>console.error(`Conflict in default settings: ${o}`))}return i}e.getDefaultValues=d;function u(i){return`[${i}]`}e.keyFromOverrideIdentifier=u;function t(i,c,a){const l=i.inspect(c),o=i.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:l.defaultValue}e.getMigratedSettingValue=t}),define(ve[153],_e([0,1,43,22,11,13,24,2,67,90,30,6,3]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},i=[],c=[]){this._contents=t,this._keys=i,this._overrides=c,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const c=this.getContentsForOverrideIdentifer(i);return c?t?(0,n.getConfigurationValue)(c,t):c:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let c={};for(const a of P.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a],o=i[a];o&&(typeof l=="object"&&typeof o=="object"?(l=S.deepClone(l),this.mergeContents(l,o)):l=o),c[a]=l}return new f(c,this.keys,this.overrides)}merge(...t){const i=S.deepClone(this.contents),c=S.deepClone(this.overrides),a=[...this.keys];for(const l of t){this.mergeContents(i,l.contents);for(const o of l.overrides){const[w]=c.filter(I=>P.equals(I.identifiers,o.identifiers));w?this.mergeContents(w.contents,o.contents):c.push(S.deepClone(o))}for(const o of l.keys)a.indexOf(o)===-1&&a.push(o)}return new f(i,a,c)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const c of Object.keys(i)){if(c in t&&A.isObject(t[c])&&A.isObject(i[c])){this.mergeContents(t[c],i[c]);continue}t[c]=S.deepClone(i[c])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,c=>{throw new Error(c)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let c=0;c<i;c++)t.indexOf(this.keys[c])===0&&(i=c);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class r extends f{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),c=[];for(const a of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(a)&&c.push({identifiers:[(0,y.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,n.toValuesTree)(t[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,i,c)}}e.DefaultConfigurationModel=r;class s{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!A.isUndefinedOrNull(t)){const c=this.doParseContent(t);this.parseRaw(c,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:c,keys:a,overrides:l,untrusted:o}=this.doParseRaw(t,i);this._configurationModel=new f(c,a,l),this._untrustedConfigurations=o||[]}doParseContent(t){let i={},c=null,a=[],l=[],o=[];function w(p){Array.isArray(a)?a.push(p):c&&(a[c]=p)}let I={onObjectBegin:()=>{let p={};w(p),l.push(a),a=p,c=null},onObjectProperty:p=>{c=p},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let p=[];w(p),l.push(a),a=p,c=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:w,onError:(p,g,R)=>{o.push({error:p,offset:g,length:R})}};if(t)try{E.visit(t,I),i=a[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(t,i){const c=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,c,!0,i);t=a.raw;const l=(0,n.toValuesTree)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),o=Object.keys(t),w=(0,n.toOverrides)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:l,keys:o,overrides:w,untrusted:a.untrusted}}filter(t,i,c,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.isUntrusted))return{raw:t,untrusted:[]};const l={},o=[];for(let w in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(w)&&c){const I=this.filter(t[w],i,!1,a);l[w]=I.raw,o.push(...I.untrusted)}else{const I=i[w],p=I?typeof I.scope!="undefined"?I.scope:3:void 0;(p===void 0||a.scopes===void 0||a.scopes.includes(p))&&(a.isUntrusted&&(I==null?void 0:I.requireTrust)?o.push(w):l[w]=t[w])}return{raw:l,untrusted:o}}}e.ConfigurationModelParser=s;class _ extends k.Disposable{constructor(t,i,c,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=_;class m{constructor(t,i,c=new f,a=new f,l=new C.ResourceMap,o=new f,w=new C.ResourceMap,I=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=o,this._memoryConfigurationByResource=w,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(t,i,c){return this.getConsolidateConfigurationModel(i,c).getValue(t)}updateValue(t,i,c={}){let a;c.resource?(a=this._memoryConfigurationByResource.get(c.resource),a||(a=new f,this._memoryConfigurationByResource.set(c.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,c){const a=this.getConsolidateConfigurationModel(i,c),l=this.getFolderConfigurationModelForResource(i.resource,c),o=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),I=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=c?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,$=i.overrideIdentifier?o.override(i.overrideIdentifier).getValue(t):o.getValue(t),ue=a.getValue(t),z=P.distinct(P.flatten(a.overrides.map(B=>B.identifiers))).filter(B=>a.getOverrideValue(t,B)!==void 0);return{defaultValue:w,userValue:I,userLocalValue:p,userRemoteValue:g,workspaceValue:R,workspaceFolderValue:F,memoryValue:$,value:ue,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:o.getValue(t),override:i.overrideIdentifier?o.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const c=i.filter(a=>y.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,y.overrideIdentifierFromKey)(a),o=this._defaultConfiguration.getKeysForOverrideIdentifier(l),w=t.getKeysForOverrideIdentifier(l),I=[...w.filter(p=>o.indexOf(p)===-1),...o.filter(p=>w.indexOf(p)===-1),...o.filter(p=>!S.equals(this._defaultConfiguration.override(l).getValue(p),t.override(l).getValue(p)))];return[l,I]});return this.updateDefaultConfiguration(t),{keys:i,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:c,removed:a,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),o=[...i,...c,...a];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:c,removed:a,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let o=[...i,...c,...a];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:c,removed:a,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let o=[...i,...c,...a];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const c=this.folderConfigurations.get(t),{added:a,updated:l,removed:o,overrides:w}=(0,n.compare)(c,i);let I=[...a,...l,...o];return(I.length||!c)&&this.updateFolderConfiguration(t,i),{keys:I,overrides:w}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:c,updated:a,removed:l,overrides:o}=(0,n.compare)(i,void 0);return{keys:[...c,...a,...l],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let c=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?c.override(t.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:t},i){let c=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(c=this.getFolderConsolidatedConfiguration(a.uri)||c);const l=this._memoryConfigurationByResource.get(t);l&&(c=c.merge(l))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const c=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=c.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=c}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const c=i.getFolder(t);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:c,overrides:a,keys:l}=this._folderConfigurations.get(i);return t.push([i,{contents:c,overrides:a,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(c=>t.add(c))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(c=>i.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(c=>i.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(c=>i.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),c=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((o,w)=>(o.set(D.URI.revive(w[0]),this.parseConfigurationModel(w[1])),o),new C.ResourceMap);return new m(i,c,new f,a,l,new f,new C.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function b(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,i=new Map;for(const a of u)a.keys.forEach(l=>t.add(l)),a.overrides.forEach(([l,o])=>{const w=(0,C.getOrSet)(i,l,new Set);o.forEach(I=>w.add(I))});const c=[];return i.forEach((a,l)=>c.push([l,[...a.values()]])),{keys:[...t.values()],overrides:c}}e.mergeChanges=b;class v{constructor(t,i,c,a){this.change=t,this.previous=i,this.currentConfiguraiton=c,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(w=>l.add(w)),t.overrides.forEach(([,w])=>w.forEach(I=>l.add(I))),this.affectedKeys=[...l.values()];const o=new f;this.affectedKeys.forEach(w=>o.setValue(w,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var c;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(c=this.previous)===null||c===void 0?void 0:c.workspace):void 0,l=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!S.equals(a,l)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let c=(0,n.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof c=="object"&&(a=Object.keys(c)[0]);){if(t=t[a],!t)return!1;c=c[a]}return!0}}e.ConfigurationChangeEvent=v;class d extends v{constructor(t,i,c,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=c,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=d}),define(ve[91],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(S,D=C.Unknown,y){super(S);this._message=S,this._code=D,this._detail=y,this.isHandled=D===C.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(S){return S instanceof P&&S._code===C.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof P&&S._code===C.NoResolverFound}static isHandled(S){return S instanceof P&&S.isHandled}}e.RemoteAuthorityResolverError=P}),define(ve[92],_e([0,1,18]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function C(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=C;function P(y){if(!!y){const n=y.indexOf("+");return n<0?y:y.substr(0,n)}}e.getRemoteName=P;function A(y){return y.scheme!==E.Schemas.file&&y.scheme!==E.Schemas.vscodeRemote}function S(y){if(y.folders.length)return y.folders.every(n=>A(n.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function D(y){var n;return(n=S(y))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D}),define(ve[154],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,A,S=5){let D;return D=A(y=>{const n=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(P);if(T){T.data.push(n);return}const k=setTimeout(()=>this.flushBuffer(P),S);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(P),D.dispose()}},this._terminalBufferMap.set(P,T)}),D}stopBuffering(P){const A=this._terminalBufferMap.get(P);A&&A.dispose()}flushBuffer(P){const A=this._terminalBufferMap.get(P);A&&(this._terminalBufferMap.delete(P),this._callback(P,A.data.join("")))}}e.TerminalDataBufferer=E}),define(ve[155],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(C){C.DARK="dark",C.LIGHT="light",C.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(ve[156],_e([0,1,4,6,30,3,155,36]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(_){function m(b){return b&&typeof b=="object"&&typeof b.id=="string"}_.isThemeColor=m})(y=e.ThemeColor||(e.ThemeColor={}));function n(_){return{id:_}}e.themeColorFromId=n;var T;(function(_){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}_.isThemeIcon=m;const b=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(t){const i=b.exec(t);if(!!i){let[,c]=i;return{id:c}}}_.fromString=v;function d(t,i){let c=t.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),i&&(c=`${c}~${i}`),{id:c}}_.modify=d;function u(t,i){var c,a;return t.id===i.id&&((c=t.color)===null||c===void 0?void 0:c.id)===((a=i.color)===null||a===void 0?void 0:a.id)}_.isEqual=u,_.asClassNameArray=D.CSSIcon.asClassNameArray,_.asClassName=D.CSSIcon.asClassName,_.asCSSSelector=D.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function k(_){switch(_){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(m);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new h;P.Registry.add(e.Extensions.ThemingContribution,f);function r(_){return f.onColorThemeChange(_)}e.registerThemingParticipant=r;class s extends C.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,b){let v=this.theme.getColor(m);return v&&b&&(v=b(v,this.theme)),v?v.toString():null}}e.Themable=s}),define(ve[157],_e([0,1,30,156,3,126,89,14,36]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,b,v,d){const u=this.iconsById[m];if(u){if(v&&!u.description){u.description=v,this.iconSchema.properties[m].markdownDescription=`${v} $(${m})`;const c=this.iconReferenceSchema.enum.indexOf(m);c!==-1&&(this.iconReferenceSchema.enumDescriptions[c]=v),this._onDidChange.fire()}return u}let t={id:m,description:v,defaults:b,deprecationMessage:d};this.iconsById[m]=t;let i={$ref:"#/definitions/icons"};return d&&(i.deprecationMessage=d),v&&(i.markdownDescription=`${v}: $(${m})`),this.iconSchema.properties[m]=i,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(v||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const b=this.iconReferenceSchema.enum.indexOf(m);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,b){const v=this.iconFontsById[m];if(v)return v;let d={id:m,definition:b};return this.iconFontsById[m]=d,this._onDidChange.fire(),d}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(u,t)=>u.id.localeCompare(t.id),b=u=>{for(;C.ThemeIcon.isThemeIcon(u.defaults);)u=this.iconsById[u.defaults.id];return`codicon codicon-${u?u.id:""}`};let v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(u=>this.iconsById[u]);for(const u of d.filter(t=>!!t.description).sort(m))v.push(`|<i class="${b(u)}"></i>|${u.id}|${C.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const u of d.filter(t=>!C.ThemeIcon.isThemeIcon(t.defaults)).sort(m))v.push(`|<i class="${b(u)}"></i>|${u.id}|`);return v.join(`
`)}}const T=new n;E.Registry.add(e.Extensions.IconContribution,T);function k(_,m,b,v){return T.registerIcon(_,m,b,v)}e.registerIcon=k;function h(){return T}e.getIconRegistry=h;function f(){for(const _ of y.iconRegistry.all)T.registerIcon(_.id,_.definition,_.description);y.iconRegistry.onDidRegister(_=>T.registerIcon(_.id,_.definition,_.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let r=E.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,T.getIconSchema());const s=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=C.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(ve[47],_e([0,1,2,25,4,22]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var S;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function D(h){const f=h;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function y(h){const f=h;return!!(f&&typeof f=="object"&&E.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(f,r,s,_){this._id=f,this._configuration=s,this._ignorePathCasing=_,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(f,r){this.raw=r,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,C.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(h){return new T({uri:h,index:0,name:(0,C.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=k}),define(ve[158],_e([0,1,4,127,47,2,21,12,25,105,43,18,59,37,92]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const s=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(G){return(typeof G=="string"?(0,D.extname)(G):(0,y.extname)(G))===s}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function m(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function b(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=b;function v(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=v;function d(G){const M=G;return typeof(M==null?void 0:M.id)=="string"&&A.URI.isUri(M.uri)}e.isSingleFolderWorkspaceIdentifier=d;function u(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(G){const M=G;return typeof(M==null?void 0:M.id)=="string"&&A.URI.isUri(M.configPath)}e.isWorkspaceIdentifier=t;function i(G){const M=G;if(M==null?void 0:M.uri)return{id:M.id,uri:A.URI.revive(M.uri)};const N=G;if(N==null?void 0:N.configPath)return{id:N.id,configPath:A.URI.revive(N.configPath)};if(G==null?void 0:G.id)return{id:G.id}}e.reviveIdentifier=i;function c(G,M){return y.extUriBiasedIgnorePathCase.isEqualOrParent(G,M.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function a(G){return l(G)||o(G)}e.isStoredWorkspaceFolder=a;function l(G){const M=G;return typeof(M==null?void 0:M.path)=="string"&&(!M.name||typeof M.name=="string")}e.isRawFileWorkspaceFolder=l;function o(G){const M=G;return typeof(M==null?void 0:M.uri)=="string"&&(!M.name||typeof M.name=="string")}e.isRawUriWorkspaceFolder=o;function w(G,M,N,W,Q=!S.isWindows,x){if(G.scheme!==W.scheme)return{name:N,uri:G.toString(!0)};let Z=M?void 0:x.relativePath(W,G);if(Z!==void 0)Z.length===0?Z=".":S.isWindows&&G.scheme===k.Schemas.file&&!Q&&(Z=Z.replace(/\//g,"\\"));else if(G.scheme===k.Schemas.file)Z=G.fsPath,S.isWindows&&(Z=(0,h.normalizeDriveLetter)(Z),Q&&(Z=(0,f.toSlashes)(Z)));else{if(!x.isEqualAuthority(G.authority,W.authority))return{name:N,uri:G.toString(!0)};Z=G.path}return{name:N,path:Z}}e.getStoredWorkspaceFolder=w;function I(G,M,N){let W=[],Q=new Set;const x=N.dirname(M);for(let Z of G){let re=null;if(l(Z))Z.path&&(re=N.resolvePath(x,Z.path));else if(o(Z))try{re=A.URI.parse(Z.uri),re.path[0]!=="/"&&(re=re.with({path:"/"+re.path}))}catch(oe){console.warn(oe)}if(re){let oe=N.getComparisonKey(re);if(!Q.has(oe)){Q.add(oe);const ye=Z.name||N.basenameOrAuthority(re);W.push(new P.WorkspaceFolder({uri:re,name:ye,index:W.length},Z))}}}return W}e.toWorkspaceFolders=I;function p(G,M,N,W,Q){let x=g(M,G);const Z=Q.dirname(M),re=Q.dirname(W),oe=[],ye=R(x.folders);for(const ze of x.folders){const U=l(ze)?Q.resolvePath(Z,ze.path):A.URI.parse(ze.uri);let K;N?K=!1:K=!l(ze)||(0,D.isAbsolute)(ze.path),oe.push(w(U,K,ze.name,re,ye,Q))}const Pe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Be=n.setProperty(G,["folders"],oe,Pe);let Re=n.applyEdits(G,Be);return x.remoteAuthority===(0,r.getRemoteAuthority)(W)&&(Re=n.applyEdits(Re,n.removeProperty(Re,["remoteAuthority"],Pe))),Re}e.rewriteWorkspaceFileForNewLocation=p;function g(G,M){let N=T.parse(M);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(W=>a(W));else throw new Error(`${G} looks like an invalid workspace file.`);return N}function R(G){return S.isWindows?G.some(M=>l(M)&&M.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function F(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function $(G){return typeof G.folderUri=="string"}function ue(G){return typeof G.fileUri=="string"}function z(G,M){const N={workspaces:[],files:[]};if(G){const W=function(x,Z){for(let re=0;re<x.length;re++)try{Z(x[re],re)}catch(oe){M.warn(`Error restoring recent entry ${JSON.stringify(x[re])}: ${oe.toString()}. Skip entry.`)}},Q=G;if(Array.isArray(Q.entries))W(Q.entries,x=>{const Z=x.label,re=x.remoteAuthority;F(x)?N.workspaces.push({label:Z,remoteAuthority:re,workspace:{id:x.workspace.id,configPath:A.URI.parse(x.workspace.configPath)}}):$(x)?N.workspaces.push({label:Z,remoteAuthority:re,folderUri:A.URI.parse(x.folderUri)}):ue(x)&&N.files.push({label:Z,remoteAuthority:re,fileUri:A.URI.parse(x.fileUri)})});else{const x=G;Array.isArray(x.workspaces3)&&W(x.workspaces3,(Z,re)=>{const oe=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[re]||void 0;typeof Z=="object"&&typeof Z.id=="string"&&typeof Z.configURIPath=="string"?N.workspaces.push({label:oe,workspace:{id:Z.id,configPath:A.URI.parse(Z.configURIPath)}}):typeof Z=="string"&&N.workspaces.push({label:oe,folderUri:A.URI.parse(Z)})}),Array.isArray(x.files2)&&W(x.files2,(Z,re)=>{const oe=Array.isArray(x.fileLabels)&&x.fileLabels[re]||void 0;typeof Z=="string"&&N.files.push({label:oe,fileUri:A.URI.parse(Z)})})}}return N}e.restoreRecentlyOpened=z;function B(G){const M={entries:[]};for(const N of G.workspaces)b(N)?M.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):M.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of G.files)M.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return M}e.toStoreData=B}),define(ve[68],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const A=this._idPool++;return this._data.set(A,P),this.logDebugInfo(),A}get(P,A){return this._data.has(P)?this._data.get(P)[A]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(ve[159],_e([0,1,2,3]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class P{constructor(){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(D=>({name:D.name,group:D.group,resource:E.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=P}),define(ve[48],_e([0,1,18,4]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,D){D===null?this._providerInfo.delete(S):this._providerInfo.set(S,D)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(ve[160],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(A,S,D){this._id=A,this._shared=S,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(A,S){let D=this._value[A];return typeof D=="undefined"&&(D=S),D}update(A,S){return this._value[A]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class C extends E{constructor(A,S){super(A.identifier.value,!0,S);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(ve[15],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class C{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=C});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[161],_e([0,1,26,3]),function(ee,e,E,C){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(D,y){P.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(D.identifier),tt(this,P,y,"f"),xe(this,P,"f").onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(D){return xe(this,P,"f").get(this._id,D)}store(D,y){return xe(this,P,"f").store(this._id,D,y)}delete(D){return xe(this,P,"f").delete(this._id,D)}}e.ExtensionSecrets=A,P=new WeakMap}),define(ve[93],_e([0,1,4,3]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class P{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=P,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(ve[69],_e([0,1,4,3,15]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(D){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}D.fromApiTunnel=y;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}D.fromServiceTunnel=n})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,T,k,h){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=qe([Ge(0,P.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)},$t=this&&this.__rest||function(ee,e){var E={};for(var C in ee)Object.prototype.hasOwnProperty.call(ee,C)&&e.indexOf(C)<0&&(E[C]=ee[C]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,C=Object.getOwnPropertySymbols(ee);P<C.length;P++)e.indexOf(C[P])<0&&Object.prototype.propertyIsEnumerable.call(ee,C[P])&&(E[C[P]]=ee[C[P]]);return E};define(ve[7],_e([0,1,11,10,81,22,13,2,29,65,91]),function(ee,e,E,C,P,A,S,D,y,n,T){"use strict";var k,h,f,r,s,_,m,b,v,d,u,t,i,c,a,l,o,w;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(O){function L(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(L,O),Object.setPrototypeOf(L.prototype,O.prototype),L}let p=s=class{constructor(L){k.set(this,void 0),tt(this,k,L,"f")}static from(...L){let te=L;return new s(function(){if(te){for(const we of te)we&&typeof we.dispose=="function"&&we.dispose();te=void 0}})}dispose(){typeof xe(this,k,"f")=="function"&&(xe(this,k,"f").call(this),tt(this,k,void 0,"f"))}};k=new WeakMap,p=s=qe([I],p),e.Disposable=p;let g=_=class{constructor(L,te){if(L<0)throw(0,C.illegalArgument)("line must be non-negative");if(te<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let we=1;we<L.length;we++){const He=L[we];He.isBefore(te)&&(te=He)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let we=1;we<L.length;we++){const He=L[we];He.isAfter(te)&&(te=He)}return te}static isPosition(L){if(!L)return!1;if(L instanceof _)return!0;let{line:te,character:we}=L;return typeof te=="number"&&typeof we=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,C.illegalArgument)();let we;return typeof L=="undefined"?we=0:typeof L=="number"?we=L:(we=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),we===0&&te===0?this:new _(this.line+we,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,C.illegalArgument)();let we;return typeof L=="undefined"?we=this.line:typeof L=="number"?we=L:(we=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),we===this.line&&te===this.character?this:new _(we,te)}toJSON(){return{line:this.line,character:this.character}}};g=_=qe([I],g),e.Position=g;let R=m=class{constructor(L,te,we,He){let et,ht;if(typeof L=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(et=new g(L,te),ht=new g(we,He)):L instanceof g&&te instanceof g&&(et=L,ht=te),!et||!ht)throw new Error("Invalid arguments");et.isBefore(ht)?(this._start=et,this._end=ht):(this._start=ht,this._end=et)}static isRange(L){return L instanceof m?!0:L?g.isPosition(L.start)&&g.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof m?this.contains(L._start)&&this.contains(L._end):L instanceof g?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=g.Max(L.start,this._start),we=g.Min(L.end,this._end);if(!te.isAfter(we))return new m(te,we)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=g.Min(L.start,this._start),we=g.Max(L.end,this.end);return new m(te,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,C.illegalArgument)();let we;return L?g.isPosition(L)?we=L:(we=L.start||this.start,te=L.end||this.end):we=this.start,we.isEqual(this._start)&&te.isEqual(this.end)?this:new m(we,te)}toJSON(){return[this.start,this.end]}};R=m=qe([I],R),e.Range=R;let F=b=class extends R{constructor(L,te,we,He){let et,ht;if(typeof L=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(et=new g(L,te),ht=new g(we,He)):L instanceof g&&te instanceof g&&(et=L,ht=te),!et||!ht)throw new Error("Invalid arguments");super(et,ht);this._anchor=et,this._active=ht}static isSelection(L){return L instanceof b?!0:L?R.isRange(L)&&g.isPosition(L.anchor)&&g.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=b=qe([I],F),e.Selection=F;class ${constructor(L,te,we){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,C.illegalArgument)("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=we}}e.ResolvedAuthority=$;class ue extends Error{constructor(L,te=T.RemoteAuthorityResolverErrorCode.Unknown,we){super(L);this._message=L,this._code=te,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ue.prototype)}static NotAvailable(L,te){return new ue(L,T.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new ue(L,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ue;var z;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var B;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=v=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof v?!0:L?R.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new v(L,te)}static insert(L,te){return v.replace(new R(L,L),te)}static delete(L){return v.replace(L,"")}static setEndOfLine(L){const te=new v(new R(new g(0,0),new g(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!R.isRange(L))throw(0,C.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,C.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,C.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=v=qe([I],G),e.TextEdit=G;var M;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(M=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,we,He){this._edits.push({_type:1,from:L,to:te,options:we,metadata:He})}createFile(L,te,we){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:we})}deleteFile(L,te,we){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:we})}replaceNotebookMetadata(L,te,we){this._edits.push({_type:3,metadata:we,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,we,He,et){(te!==we||He.length>0)&&this._edits.push({_type:5,uri:L,index:te,count:we-te,cells:He,metadata:et})}replaceNotebookCellOutput(L,te,we,He){this._editNotebookCellOutput(L,te,!1,we,He)}appendNotebookCellOutput(L,te,we,He){this._editNotebookCellOutput(L,te,!0,we,He)}replaceNotebookCellOutputItems(L,te,we,He,et){this._editNotebookCellOutputItems(L,te,we,!1,He,et)}appendNotebookCellOutputItems(L,te,we,He,et){this._editNotebookCellOutputItems(L,te,we,!0,He,et)}_editNotebookCellOutputItems(L,te,we,He,et,ht){this._edits.push({_type:6,metadata:ht,uri:L,index:te,outputId:we,append:He,newOutputItems:et})}_editNotebookCellOutput(L,te,we,He,et){this._edits.push({_type:4,metadata:et,uri:L,index:te,append:we,newOutputs:He,newMetadata:void 0})}replaceNotebookCellMetadata(L,te,we,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:11,index:te,metadata:we}})}replace(L,te,we,He){this._edits.push({_type:2,uri:L,edit:new G(te,we),metadata:He})}insert(L,te,we,He){this.replace(L,new R(te,te),we,He)}delete(L,te,we){this.replace(L,te,"",we)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const we of te)we&&this._edits.push({_type:2,uri:L,edit:we});else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];He._type===2&&He.uri.toString()===L.toString()&&(this._edits[we]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let we of this._edits)we._type===2&&we.uri.toString()===L.toString()&&te.push(we.edit);return te}entries(){const L=new A.ResourceMap;for(let te of this._edits)if(te._type===2){let we=L.get(te.uri);we||(we=[te.uri,[]],L.set(te.uri,we)),we[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=qe([I],N),e.WorkspaceEdit=N;let W=d=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof d?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=d._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const we=new d;we._tabstop=this._tabstop,L(we),this._tabstop=we._tabstop,L=we.value}else L=d._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const we=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const we=new d;we._tabstop=this._tabstop,te(we),this._tabstop=we._tabstop,te=we.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};W=d=qe([I],W),e.SnippetString=W;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=u=class{constructor(L,te){if(this.uri=L,te)if(te instanceof R)this.range=te;else if(te instanceof g)this.range=new R(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof u?!0:L?R.isRange(L.range)&&D.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=u=qe([I],Z),e.Location=Z;let re=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&R.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};re=qe([I],re),e.DiagnosticRelatedInformation=re;let oe=class{constructor(L,te,we=x.Error){if(!R.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=we}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,E.equals)(L.tags,te.tags)&&(0,E.equals)(L.relatedInformation,te.relatedInformation,re.isEqual)}};oe=qe([I],oe),e.Diagnostic=oe;let ye=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,P.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=te}};ye=qe([I],ye),e.Hover=ye;var Pe;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(L,te=Pe.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Pe[this.kind]}}};Be=qe([I],Be),e.DocumentHighlight=Be;var Re;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Re=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let U=t=class{constructor(L,te,we,He,et){this.name=L,this.kind=te,this.containerName=et,typeof we=="string"&&(this.containerName=we),He instanceof Z?this.location=He:we instanceof R&&(this.location=new Z(He,we)),t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};U=t=qe([I],U),e.SymbolInformation=U;let K=i=class{constructor(L,te,we,He,et){this.name=L,this.detail=te,this.kind=we,this.range=He,this.selectionRange=et,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};K=i=qe([I],K),e.DocumentSymbol=K;var ne;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(L,te){this.title=L,this.kind=te}};le=qe([I],le),e.CodeAction=le;let fe=c=class{constructor(L){this.value=L}append(L){return new c(this.value?this.value+c.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+c.sep)}};fe.sep=".",fe=c=qe([I],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let De=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=qe([I],De),e.SelectionRange=De;class Oe{constructor(L,te,we,He,et,ht){this.kind=L,this.name=te,this.detail=we,this.uri=He,this.range=et,this.selectionRange=ht}}e.CallHierarchyItem=Oe;class me{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=me;class Ce{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=Ce;let Ae=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};Ae=qe([I],Ae),e.CodeLens=Ae;let $e=a=class{constructor(L,te=!1){h.set(this,void 0),tt(this,h,new P.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof a?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return xe(this,h,"f").value}set value(L){xe(this,h,"f").value=L}get isTrusted(){return xe(this,h,"f").isTrusted}set isTrusted(L){xe(this,h,"f").isTrusted=L}get supportThemeIcons(){return xe(this,h,"f").supportThemeIcons}appendText(L){return xe(this,h,"f").appendText(L),this}appendMarkdown(L){return xe(this,h,"f").appendMarkdown(L),this}appendCodeblock(L,te){return xe(this,h,"f").appendCodeblock(te!=null?te:"",L),this}};h=new WeakMap,$e=a=qe([I],$e),e.MarkdownString=$e;let be=class{constructor(L,te){this.label=L,this.documentation=te}};be=qe([I],be),e.ParameterInformation=be;let Ke=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};Ke=qe([I],Ke),e.SignatureInformation=Ke;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=qe([I],V),e.SignatureHelp=V;var X;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(ge=e.InlineHintKind||(e.InlineHintKind={}));let Me=class{constructor(L,te,we){this.text=L,this.range=te,this.kind=we}};Me=qe([I],Me),e.InlineHint=Me;var We;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(O){O[O.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let H=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};H=qe([I],H),e.CompletionItem=H;let ie=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};ie=qe([I],ie),e.CompletionList=ie;var de;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(de=e.ViewColumn||(e.ViewColumn={}));var j;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(j=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Y;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(Y=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ee;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(Ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ne;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Ne=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function L(te){switch(te){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=L}(Ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Le=class{constructor(L,te){if(te&&!D.URI.isUri(te))throw(0,C.illegalArgument)("target");if(!R.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.target=te}};Le=qe([I],Le),e.DocumentLink=Le;let je=class{constructor(L,te,we,He){this.red=L,this.green=te,this.blue=we,this.alpha=He}};je=qe([I],je),e.Color=je;let Je=class{constructor(L,te){if(te&&!(te instanceof je))throw(0,C.illegalArgument)("color");if(!R.isRange(L)||L.isEmpty)throw(0,C.illegalArgument)("range");this.range=L,this.color=te}};Je=qe([I],Je),e.ColorInformation=Je;let nt=class{constructor(L){if(!L||typeof L!="string")throw(0,C.illegalArgument)("label");this.label=L}};nt=qe([I],nt),e.ColorPresentation=nt;var rt;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var ot;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var it;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(it=e.TaskRevealKind||(e.TaskRevealKind={}));var pt;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(pt=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=l=class{constructor(L,te){if(typeof L!="string"||typeof te!="string")throw(0,C.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ve.Clean=new l("clean","Clean"),Ve.Build=new l("build","Build"),Ve.Rebuild=new l("rebuild","Rebuild"),Ve.Test=new l("test","Test"),Ve=l=qe([I],Ve),e.TaskGroup=Ve;function pe(O){let L="";for(let te=0;te<O.length;te++)L+=O[te].replace(/,/g,",,")+",";return L}let Se=class{constructor(L,te,we){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=we):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,C.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return pe(L)}};Se=qe([I],Se),e.ProcessExecution=Se;let se=class{constructor(L,te,we){if(this._args=[],Array.isArray(te)){if(!L)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L,this._args=te,this._options=we}else{if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,C.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return pe(L)}};se=qe([I],se),e.ShellExecution=se;var q;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(q=e.ShellQuoting||(e.ShellQuoting={}));var Fe;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Fe=e.TaskScope||(e.TaskScope={}));class Ie{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ie;let Ye=o=class{constructor(L,te,we,He,et,ht){this.__deprecated=!1,this._definition=this.definition=L;let gt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=we,this.execution=He,gt=et,this.__deprecated=!0):te===Fe.Global||te===Fe.Workspace?(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=et,gt=ht):(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=et,gt=ht),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Se?this._definition={type:o.ProcessType,id:this._execution.computeId()}:this._execution instanceof se?this._definition={type:o.ShellType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:o.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:o.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(o.EmptyType===te||o.ProcessType===te||o.ShellType===te||o.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};Ye.ExtensionCallbackType="customExecution",Ye.ProcessType="process",Ye.ShellType="shell",Ye.EmptyType="$empty",Ye=o=qe([I],Ye),e.Task=Ye;var Xe;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(Xe=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor(L,te=st.None){this.collapsibleState=te,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};at=qe([I],at),e.TreeItem=at;var st;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(st=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Qe=class{constructor(L,te){this.id=L,this.color=te}};Qe=qe([I],Qe),e.ThemeIcon=Qe,Qe.File=new Qe("file"),Qe.Folder=new Qe("folder");let lt=class{constructor(L){this.id=L}};lt=qe([I],lt),e.ThemeColor=lt;var bt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(bt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{constructor(L,te){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,C.illegalArgument)("base");if(typeof te!="string")throw(0,C.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=D.URI.file(L),this.base=L):D.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};ct=qe([I],ct),e.RelativePattern=ct;let vt=class{constructor(L,te,we,He){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=qe([I],vt),e.Breakpoint=vt;let wt=class extends vt{constructor(L,te,we,He,et){super(te,we,He,et);if(L===null)throw(0,C.illegalArgument)("location");this.location=L}};wt=qe([I],wt),e.SourceBreakpoint=wt;let yt=class extends vt{constructor(L,te,we,He,et){super(te,we,He,et);this.functionName=L}};yt=qe([I],yt),e.FunctionBreakpoint=yt;let _t=class extends vt{constructor(L,te,we,He,et,ht,gt){super(He,et,ht,gt);if(!te)throw(0,C.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=we}};_t=qe([I],_t),e.DataBreakpoint=_t;let Mt=class{constructor(L,te,we){this.command=L,this.args=te||[],this.options=we}};Mt=qe([I],Mt),e.DebugAdapterExecutable=Mt;let Tt=class{constructor(L,te){this.port=L,this.host=te}};Tt=qe([I],Tt),e.DebugAdapterServer=Tt;let ft=class{constructor(L){this.path=L}};ft=qe([I],ft),e.DebugAdapterNamedPipeServer=ft;let Vt=class{constructor(L){this.implementation=L}};Vt=qe([I],Vt),e.DebugAdapterInlineImplementation=Vt;let Et=class{constructor(L,te){this.range=L,this.expression=te}};Et=qe([I],Et),e.EvaluatableExpression=Et;let Wt=class{constructor(L,te){this.range=L,this.text=te}};Wt=qe([I],Wt),e.InlineValueText=Wt;let jt=class{constructor(L,te,we=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=we}};jt=qe([I],jt),e.InlineValueVariableLookup=jt;let Ot=class{constructor(L,te){this.range=L,this.expression=te}};Ot=qe([I],Ot),e.InlineValueEvaluatableExpression=Ot;let dt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};dt=qe([I],dt),e.InlineValueContext=dt;var dn;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(dn=e.FileChangeType||(e.FileChangeType={}));let kt=w=class extends Error{constructor(L,te=n.FileSystemProviderErrorCode.Unknown,we){var He;super(D.URI.isUri(L)?L.toString(!0):L);this.code=(He=we==null?void 0:we.name)!==null&&He!==void 0?He:"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(L){return new w(L,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(L){return new w(L,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(L){return new w(L,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(L){return new w(L,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(L){return new w(L,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(L){return new w(L,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};kt=w=qe([I],kt),e.FileSystemError=kt;let Rt=class{constructor(L,te,we){this.start=L,this.end=te,this.kind=we}};Rt=qe([I],Rt),e.FoldingRange=Rt;var tn;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(tn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var nn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(nn=e.CommentMode||(e.CommentMode={}));class fn{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=fn;function rn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Pt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,we=L.tokenTypes.length;te<we;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,we=L.tokenModifiers.length;te<we;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,we,He,et){if(typeof L=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,te,we,He,et);if(R.isRange(L)&&typeof te=="string"&&rn(we))return this._push(L,te,we);throw(0,C.illegalArgument)()}_push(L,te,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,et=L.start.character,ht=L.end.character-L.start.character,gt=this._tokenTypeStrToInt.get(te);let St=0;if(we)for(const Ct of we){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);St|=1<<It>>>0}this._pushEncoded(He,et,ht,gt,St)}_pushEncoded(L,te,we,He,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Ct=0,It=0;for(let At=0;At<St;At++){let Ft=this._data[5*At],Zt=this._data[5*At+1];Ft===0?(Ft=Ct,Zt+=It):Ft+=Ct,this._data[5*At]=Ft,this._data[5*At+1]=Zt,Ct=Ft,It=Zt}}let ht=L,gt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const we=L.length/5|0;for(let gt=0;gt<we;gt++)te[gt]=gt;te.sort((gt,St)=>{const Ct=L[5*gt],It=L[5*St];if(Ct===It){const At=L[5*gt+1],Ft=L[5*St+1];return At-Ft}return Ct-It});const He=new Uint32Array(L.length);let et=0,ht=0;for(let gt=0;gt<we;gt++){const St=5*te[gt],Ct=L[St+0],It=L[St+1],At=L[St+2],Ft=L[St+3],Zt=L[St+4],kn=Ct-et,Tn=kn===0?It-ht:It,en=5*gt;He[en+0]=kn,He[en+1]=Tn,He[en+2]=At,He[en+3]=Ft,He[en+4]=Zt,et=Ct,ht=It}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),L):new qt(Pt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Pt;class qt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=qt;class Kt{constructor(L,te,we){this.start=L,this.deleteCount=te,this.data=we}}e.SemanticTokensEdit=Kt;class Gt{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=Gt;var mn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(mn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var gn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(gn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Dt=class{constructor(){}};Dt.Back={iconPath:new Qe("arrow-left")},Dt=qe([I],Dt),e.QuickInputButtons=Dt;var pn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(pn=e.ExtensionKind||(e.ExtensionKind={}));class vn{constructor(L,te,we){this.badge=L,this.tooltip=te,this.color=we}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=vn;let Qt=class{constructor(L){this.kind=L}};Qt=qe([I],Qt),e.ColorTheme=Qt;var bn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(bn=e.ColorThemeKind||(e.ColorThemeKind={}));class Nt{constructor(L,te){if(L<0)throw(0,C.illegalArgument)("start must be positive");if(te<L)throw(0,C.illegalArgument)("end cannot be smaller than start");this._start=L,this._end=te}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,we=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(we=L.end),te===this._start&&we===this._end?this:new Nt(te,we)}}e.NotebookRange=Nt;class Ht{constructor(L,te){typeof L=="object"?Object.assign(this,L):(this.inputCollapsed=L,this.outputCollapsed=te)}with(L){let{inputCollapsed:te,outputCollapsed:we,custom:He}=L,et=$t(L,["inputCollapsed","outputCollapsed","custom"]);return te===void 0?te=this.inputCollapsed:te===null&&(te=void 0),we===void 0?we=this.outputCollapsed:we===null&&(we=void 0),He===void 0?He=this.custom:He===null&&(He=void 0),te===this.inputCollapsed&&we===this.outputCollapsed&&He===this.custom&&Object.keys(et).length===0?this:new Ht(Object.assign({inputCollapsed:te,outputCollapsed:we,custom:He},et))}}e.NotebookCellMetadata=Ht;class Ut{constructor(L=!0,te={}){var we,He;typeof L=="object"?(Object.assign(this,L),this.trusted=(we=L.trusted)!==null&&we!==void 0?we:!0,this.custom=(He=L.custom)!==null&&He!==void 0?He:{}):(this.trusted=L,this.custom=te)}with(L){let{custom:te,trusted:we}=L,He=$t(L,["custom","trusted"]);return te===void 0?te=this.custom:te===null&&(te=void 0),we===void 0?we=this.trusted:we===null&&(we=void 0),te===this.custom&&we===this.trusted&&Object.keys(He).length===0?this:new Ut(Object.assign({trusted:we,custom:te},He))}}e.NotebookDocumentMetadata=Ut;class Jt{constructor(L,te,we,He,et,ht){this.kind=L,this.source=te,this.language=we,this.outputs=He!=null?He:[],this.metadata=et,this.latestExecutionSummary=ht}}e.NotebookCellData=Jt;class Te{constructor(L,te){this.cells=L,this.metadata=te!=null?te:new Ut}}e.NotebookData=Te;class xt{constructor(L,te,we){this.mime=L,this.value=te,this.metadata=we}static isNotebookCellOutputItem(L){return L instanceof xt}}e.NotebookCellOutputItem=xt;class Yt{constructor(L,te,we){this.outputs=L,typeof te=="string"?(this.id=te,this.metadata=we):(this.id=(0,y.generateUuid)(),this.metadata=te!=null?te:we)}}e.NotebookCellOutput=Yt;var mt;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(mt=e.NotebookCellKind||(e.NotebookCellKind={}));var _n;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(_n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(wn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var sn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(sn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class on{constructor(L,te,we,He,et,ht){this.text=L,this.alignment=te,this.command=we,this.tooltip=He,this.priority=et,this.accessibilityInformation=ht}}e.NotebookCellStatusBarItem=on;let Xt=class{constructor(L,te){this.label=L,this.timestamp=te}};Xt=qe([I],Xt),e.TimelineItem=Xt;var En;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(En=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Sn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(Sn=e.StandardTokenType||(e.StandardTokenType={}));class an{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=an;var Dn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Dn=e.TestResultState||(e.TestResultState={}));var ln;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const zt=(O,L,te)=>{let we=te;return{enumerable:!0,configurable:!1,get(){return we},set(He){var et;(et=O[e.TestItemHookProperty])===null||et===void 0||et.setProp(L,He),we=He}}};class un{constructor(L){f.set(this,new Map),r.set(this,void 0),tt(this,r,L,"f")}get size(){return xe(this,f,"f").size}add(L){const te=xe(this,f,"f"),we=xe(this,r,"f").call(this),He=te.get(L.id);He!==L&&(He&&(we==null||we.delete(L.id)),te.set(L.id,L),we==null||we.created(L))}get(L){return xe(this,f,"f").get(L)}clear(){for(const L of xe(this,f,"f").keys())this.delete(L)}delete(L){var te;const we=typeof L=="string"?L:L.id;xe(this,f,"f").has(we)&&(xe(this,f,"f").delete(we),(te=xe(this,r,"f").call(this))===null||te===void 0||te.delete(we))}toJSON(){return[...xe(this,f,"f").values()]}[(f=new WeakMap,r=new WeakMap,Symbol.iterator)](){return xe(this,f,"f").values()}}e.TestChildrenCollection=un;class Cn{constructor(L,te,we,He){this.label=te,this.expandable=He,Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:we,enumerable:!0,writable:!1},children:{value:new un(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},range:zt(this,"range",void 0),description:zt(this,"description",void 0),runnable:zt(this,"runnable",!0),debuggable:zt(this,"debuggable",!0)})}invalidate(){var L;(L=this[e.TestItemHookProperty])===null||L===void 0||L.invalidate(this.id)}discoverChildren(L,te){L.report({busy:!1})}}e.TestItem=Cn;class J{constructor(L){this.message=L,this.severity=ln.Error}static diff(L,te,we){const He=new J(L);return He.expectedOutput=te,He.actualOutput=we,He}}e.TestMessage=J;var ce;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(ce=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ke;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(ke=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ut;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(ut=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[94],_e([0,1,42,18,8,118,84,7,11]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(r,s){s?n.set(r,s):n.delete(r)}e.setWordDefinitionFor=T;function k(r){return n.get(r)}e.getWordDefinitionFor=k;class h extends A.MirrorTextModel{constructor(s,_,m,b,v,d,u,t){super(_,m,b,v);this._proxy=s,this._languageId=d,this._isDirty=u,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,y.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===C.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(_){return _?s._getTextInRange(_):s.getText()},get eol(){return s._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(_){return s._lineAt(_)},offsetAt(_){return s._offsetAt(_)},positionAt(_){return s._positionAt(_)},validateRange(_){return s._validateRange(_)},validatePosition(_){return s._validatePosition(_)},getWordRangeAtPosition(_,m){return s._getWordRangeAtPosition(_,m)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,E.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,E.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const _=this._validateRange(s);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const m=this._eol,b=_.start.line,v=_.end.line,d=[];d.push(this._lines[b].substring(_.start.character));for(let u=b+1;u<v;u++)d.push(this._lines[u]);return d.push(this._lines[v].substring(0,_.end.character)),d.join(m)}_lineAt(s){let _;if(s instanceof D.Position?_=s.line:typeof s=="number"&&(_=s),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new f(_,this._lines[_],_===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(s),m=this._lines[_.index].length;return new D.Position(_.index,Math.min(_.remainder,m))}_validateRange(s){if(!(s instanceof D.Range))throw new Error("Invalid argument");const _=this._validatePosition(s.start),m=this._validatePosition(s.end);return _===s.start&&m===s.end?s:new D.Range(_.line,_.character,m.line,m.character)}_validatePosition(s){if(!(s instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:_,character:m}=s,b=!1;if(_<0)_=0,m=0,b=!0;else if(_>=this._lines.length)_=this._lines.length-1,m=this._lines[_].length,b=!0;else{const v=this._lines[_].length;m<0?(m=0,b=!0):m>v&&(m=v,b=!0)}return b?new D.Position(_,m):s}_getWordRangeAtPosition(s,_){const m=this._validatePosition(s);if(!_)_=k(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const b=(0,S.getWordAtText)(m.character+1,(0,S.ensureValidWordDefinition)(_),this._lines[m.line],0);if(b)return new D.Range(m.line,b.startColumn-1,m.line,b.endColumn-1)}}e.ExtHostDocumentData=h;class f{constructor(s,_,m){this._line=s,this._text=_,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(ve[162],_e([0,1,7,3,86,6,60,22,2,29]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(h,f,r,s){this._notebook=r,this._selector=s,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(m=>{const b=this._cellUris.get(m.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(h.onDidChangeNotebookCells(m=>_(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const h=[],f=[];for(const r of this._notebook.getCells())r.kind===E.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),h.push(r.document.getText().length+1),f.push(r.document.lineCount));this._cellLengths=new P.PrefixSumComputer(new Uint32Array(h)),this._cellLines=new P.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(h){var f,r;if(!h){let v="";for(const d of this._cells)v+=d.document.getText()+`
`;return v=v.slice(0,-1),v}if(h.isEmpty)return"";const s=this.locationAt(h.start),_=this.locationAt(h.end),m=this._cells[(f=this._cellUris.get(s.uri))!==null&&f!==void 0?f:-1],b=this._cells[(r=this._cellUris.get(_.uri))!==null&&r!==void 0?r:-1];if(!m||!b)return"";if(m===b)return m.document.getText(new E.Range(s.range.start,_.range.end));{const v=m.document.getText(new E.Range(s.range.start,new E.Position(m.document.lineCount,0))),d=b.document.getText(new E.Range(new E.Position(0,0),_.range.end));return v+`
`+d}}offsetAt(h){const f=this._cellLines.getIndexOf(h.line),r=this._cellLengths.getAccumulatedValue(f.index-1),s=this._cells[f.index].document.offsetAt(h.with(f.remainder));return r+s}positionAt(h){if(typeof h=="number"){const r=this._cellLengths.getIndexOf(h),s=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(s)}const f=this._cellUris.get(h.uri);if(f!==void 0){const r=this._cellLines.getAccumulatedValue(f-1);return new E.Position(r+h.range.start.line,h.range.start.character)}return new E.Position(0,0)}locationAt(h){E.Range.isRange(h)||(h=new E.Range(h,h));const f=this._cellLines.getIndexOf(h.start.line);let r=f;h.isEmpty||(r=this._cellLines.getIndexOf(h.end.line));const s=new E.Position(f.remainder,h.start.character),_=new E.Position(r.remainder,h.end.character),m=new E.Range(s,_),b=this._cells[f.index];return new E.Location(b.document.uri,b.document.validateRange(m))}contains(h){return this._cellUris.has(h)}validateRange(h){const f=this.validatePosition(h.start),r=this.validatePosition(h.end);return h.with(f,r)}validatePosition(h){const f=this._cellLines.getIndexOf(h.line),r=new E.Position(f.remainder,h.character),s=this._cells[f.index].document.validatePosition(r),_=this._cellLines.getAccumulatedValue(f.index-1);return new E.Position(_+s.line,s.character)}}e.ExtHostNotebookConcatDocument=T}),define(ve[163],_e([0,1,7,15,3]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(D){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?E.ColorThemeKind.Light:D==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=qe([Ge(0,C.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[70],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class C{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=C}),define(ve[164],_e([0,1,23]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let n=this.buffers.indexOf(y);return n<0&&(n=this.buffers.length,this.buffers.push(y)),n}}function P(D,y){if(y){const n=new C,T=(f,r)=>{if(r instanceof ArrayBuffer){const s=n.add(r);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(r)){const s=A(r);if(s){const _=n.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:s,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},k=JSON.stringify(D,T),h=n.buffers.map(f=>{const r=new Uint8Array(f);return E.VSBuffer.wrap(r)});return{message:k,buffers:h}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=P;function A(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(D,y){const n=y.map(h=>{const f=new ArrayBuffer(h.byteLength);return new Uint8Array(f).set(h.buffer),f}),T=y.length?(h,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:s}=r,_=n[s];if(r.view)switch(r.view.type){case 1:return new Int8Array(_,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return f}:void 0;return{message:JSON.parse(D,T),arrayBuffers:n}}e.deserializeWebviewMessage=S}),define(ve[49],_e([0,1,2]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function C(A,S,D){const y=A.webviewResourceRoot.replace("{{resource}}",D.scheme+P(D)).replace("{{uuid}}",S);return E.URI.parse(y)}e.asWebviewUri=C;function P(A){return A.toString().replace(/^\S+?:/,"")}}),define(ve[165],_e([0,1,3,6,49,29]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,T){this._proxy=y,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const h of this._insets.values())k.indexOf(h.editor)<0&&h.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,T,k,h){let f;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===y){f=d;break}if(!f)throw new Error("not a visible editor");const r=this,s=this._handlePool++,_=new E.Emitter,m=new E.Emitter,b=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,P.asWebviewUri)(r._initData,this._uuid,d)}get cspSource(){return r._initData.webviewCspSource}set options(d){this._options=d,r._proxy.$setOptions(s,d)}get options(){return this._options}set html(d){this._html=d,r._proxy.$setHtml(s,d)}get html(){return this._html}get onDidReceiveMessage(){return _.event}postMessage(d){return r._proxy.$postMessage(s,d)}},v=new class{constructor(){this.editor=y,this.line=n,this.height=T,this.webview=b,this.onDidDispose=m.event}dispose(){r._insets.has(s)&&(r._insets.delete(s),r._proxy.$disposeEditorInset(s),m.fire(),m.dispose(),_.dispose())}};return this._proxy.$createEditorInset(s,f.id,f.value.document.uri,n+1,T,k||{},h.identifier,h.extensionLocation),this._insets.set(s,{editor:y,inset:v,onDidReceiveMessage:_}),v}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(ve[166],_e([0,1,3,64,137,4,6,22,30,11,51,24,36,157]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",h.Codicon.window,(0,P.localize)(0,null));var r;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var s;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(s=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function m(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=m;class b extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(o,w,I){var p;const g=this.get(o.id);if(g)return g;const R=o;return R.openCommandActionDescriptor=(I==null?void 0:I.donotRegisterOpenCommand)?void 0:(p=R.openCommandActionDescriptor)!==null&&p!==void 0?p:{id:R.id},(0,D.getOrSet)(this.viewContainers,w,[]).push(R),(I==null?void 0:I.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:w}),R}deregisterViewContainer(o){for(const w of this.viewContainers.keys()){const I=this.viewContainers.get(w),p=I==null?void 0:I.indexOf(o);if(p!==-1){I==null||I.splice(p,1),I.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:w});return}}}get(o){return this.all.filter(w=>w.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(I=>(I==null?void 0:I.id)===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===o)}}y.Registry.add(r.ViewContainersRegistry,new b);var v;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(v=e.ViewContentGroups||(e.ViewContentGroups={}));function d(l,o){var w,I,p,g;const R=(w=l.group)!==null&&w!==void 0?w:v.More,F=(I=o.group)!==null&&I!==void 0?I:v.More;return R!==F?R.localeCompare(F):((p=l.order)!==null&&p!==void 0?p:5)-((g=o.order)!==null&&g!==void 0?g:5)}class u extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(o,w){this.registerViews2([{views:o,viewContainer:w}])}registerViews2(o){o.forEach(({views:w,viewContainer:I})=>this.addViews(w,I)),this._onViewsRegistered.fire(o)}deregisterViews(o,w){const I=this.removeViews(o,w);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:w})}moveViews(o,w){for(const I of this._views.keys())if(I!==w){const p=this.removeViews(o,I);p.length&&(this.addViews(p,w),this._onDidChangeContainer.fire({views:p,from:I,to:w}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const w of this._viewContainers){const I=(this._views.get(w)||[]).filter(p=>p.id===o)[0];if(I)return I}return null}getViewContainer(o){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(p=>p.id===o)[0])return w;return null}registerViewWelcomeContent(o,w){return this._viewWelcomeContents.add(o,w),this._onDidChangeViewWelcomeContent.fire(o),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(o,w),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,w){const I=new Map;for(const[p,g]of w)this._viewWelcomeContents.add(o,g),I.set(p,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(o,g),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),I}getViewWelcomeContent(o){const w=[];return this._viewWelcomeContents.forEach(o,I=>w.push(I)),w.sort(d)}addViews(o,w){let I=this._views.get(w);I||(I=[],this._views.set(w,I),this._viewContainers.push(w));for(const p of o){if(this.getView(p.id)!==null)throw new Error((0,P.localize)(1,null,p.id));I.push(p)}}removeViews(o,w){const I=this._views.get(w);if(!I)return[];const p=[],g=[];for(const R of I)o.includes(R)?p.push(R):g.push(R);return p.length&&(g.length?this._views.set(w,g):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),p}}y.Registry.add(r.ViewsRegistry,new u),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new C.RawContextKey("focusedView","",(0,P.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var i;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var c;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(c=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(o,w){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,o),this._hasResolve=!!w,this.resolve=async I=>{var p,g;if(w&&!this.resolved){const R=await w(I);R&&(this.tooltip=(p=this.tooltip)!==null&&p!==void 0?p:R.tooltip,this.command=(g=this.command)!==null&&g!==void 0?g:R.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(ve[167],_e([0,1,2,147,158,19,148,166]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(s){return(_,...m)=>s(_.get(C.ICommandService),...m)}class n{static execute(_,m){const b={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return _.executeCommand("_files.newWindow",b)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",C.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),C.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(s,_){return s.get(P.IWorkspacesService).removeRecentlyOpened([_])});class T{static execute(_,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?E.URI.parse(m):E.URI.file(m):m=E.URI.revive(m),_.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",C.CommandsRegistry.registerCommand(T.ID,y(T.execute));class k{static execute(_,m){const b=typeof m=="string"?{extensionId:m}:m;return _.executeCommand("workbench.action.openIssueReporter",b)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",C.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(s,_){const m=s.get(P.IWorkspacesService);let b;const v=_.uri,d=_.label,u=_.remoteAuthority;return _.type==="workspace"?b={workspace:await m.getWorkspaceIdentifier(v),label:d,remoteAuthority:u}:_.type==="folder"?b={folderUri:v,label:d,remoteAuthority:u}:b={fileUri:v,label:d,remoteAuthority:u},m.addRecentlyOpened([b])}),C.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(s){return s.get(P.IWorkspacesService).getRecentlyOpened()}),C.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(s,_){const m=s.get(A.ILogService),b=s.get(S.IEnvironmentService);b.isExtensionDevelopment&&!!b.extensionTestsLocationURI&&m.setLevel(_)}),C.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(s){return s.get(A.ILogService).getLevel()}),C.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(s,_){const m=s.get(D.IViewDescriptorService),b=m.getViewContainerById(_.destinationId);if(!!b){for(const v of _.viewIds){const d=m.getViewDescriptorById(v);(d==null?void 0:d.canMoveView)&&m.moveViewsToContainer([d],b,D.ViewVisibilityState.Default)}await s.get(D.IViewsService).openViewContainer(b.id,!0)}});class h{static execute(_,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):_.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=h,h.ID="vscode.moveViews",C.CommandsRegistry.registerCommand({id:h.ID,handler:y(h.execute),description:{description:"Move Views",args:[]}});class f{static execute(_,m){return _.executeCommand("_workbench.open",m)}}f.ID="vscode.open",C.CommandsRegistry.registerCommand(f.ID,y(f.execute));class r{static execute(_,m,b,v,d){return _.executeCommand("_workbench.diff",[m,b,v])}}r.ID="vscode.diff",C.CommandsRegistry.registerCommand(r.ID,y(r.execute))}),define(ve[168],_e([0,1,3,14,138]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,n,T){const k={command:D};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const h=setTimeout(()=>{clearTimeout(h);const f=this.pendingRequests.get(k.seq);if(f){this.pendingRequests.delete(k.seq);const r={type:"response",seq:0,request_seq:k.seq,success:!1,command:D,message:(0,P.localize)(0,null,T,D)};f(r)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,C.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,n)=>D.set(n,y)),await(0,C.timeout)(500),D.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[169],_e([0,1,8,2,12,24,18]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(i,c,a){return i.replace(D,function(l,o){return c&&o.length>0&&o[0]!=="_"?l:a&&a.hasOwnProperty(o)?a[o]:l})}e.formatPII=y;function n(i){const c={};for(const a of Object.keys(i))a.startsWith("!")||(c[a]=i[a]);return c}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=T;function k(i){let c=i.configuration.type;if(!!c)return c==="vslsShare"&&(c=i.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(c,"extensionhost")||(0,E.equalsIgnoreCase)(c,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function h(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=h;function f(i,c,a){let l,o=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=w.exec(i);){let p=I.index+1,g=p+I[0].length;if(p<=c&&g>=a){l=I[0],o=p;break}}if(l){let p=/\w+/g,g=null;for(;(g=p.exec(l))&&!(g.index+1+o+g[0].length>=a););g&&(l=l.substring(0,p.lastIndex))}return l?{start:o,end:o+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(i){return!!(i&&i.match(r))}e.isUri=s;function _(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(s(i.path))return C.URI.parse(i.path);if((0,P.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function m(i){if(typeof i.path=="object"){const c=C.URI.revive(i.path);if(c)return c.scheme===S.Schemas.file?c.fsPath:c.toString()}return i.path}function b(i,c){const a=c?_:m,l=(0,A.deepClone)(i);return d(l,(o,w)=>{o&&w&&(w.path=a(w))}),l}e.convertToDAPaths=b;function v(i,c){const a=c?_:m,l=(0,A.deepClone)(i);return d(l,(o,w)=>{!o&&w&&(w.path=a(w))}),l}e.convertToVSCPaths=v;function d(i,c){switch(i.type){case"event":const a=i;switch(a.event){case"output":c(!1,a.body.source);break;case"loadedSource":c(!1,a.body.source);break;case"breakpoint":c(!1,a.body.breakpoint.source);break;default:break}break;case"request":const l=i;switch(l.command){case"setBreakpoints":c(!0,l.arguments.source);break;case"breakpointLocations":c(!0,l.arguments.source);break;case"source":c(!0,l.arguments.source);break;case"gotoTargets":c(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(w=>c(!1,w));break;default:break}break;case"response":const o=i;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(w=>c(!1,w.source));break;case"loadedSources":o.body.sources.forEach(w=>c(!1,w));break;case"scopes":o.body.scopes.forEach(w=>c(!1,w.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(w=>c(!1,w.source));break;case"setBreakpoints":o.body.breakpoints.forEach(w=>c(!1,w.source));break;default:break}break}}function u(i){return i.filter(c=>{var a;return!((a=c.presentation)===null||a===void 0?void 0:a.hidden)}).sort((c,a)=>c.presentation?a.presentation?c.presentation.group?a.presentation.group?c.presentation.group!==a.presentation.group?c.presentation.group.localeCompare(a.presentation.group):t(c.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(c.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=u;function t(i,c){return typeof i!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:i-c}}),define(ve[71],_e([0,1,28,18,12,21,64]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(F){F[F.Markdown=1]="Markdown",F[F.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var n;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var T;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var k;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.CellClearOutput=3]="CellClearOutput",F[F.CellsClearOutput=4]="CellsClearOutput",F[F.ChangeLanguage=5]="ChangeLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.Unknown=12]="Unknown"})(k=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.OutputsSplice=6]="OutputsSplice",F[F.Move=7]="Move",F[F.Unknown=8]="Unknown",F[F.CellContent=9]="CellContent",F[F.OutputItems=10]="OutputItems",F[F.PartialMetadata=11]="PartialMetadata"})(f=e.CellEditType||(e.CellEditType={}));function r(F){const $=s.parse(F);return $?$.notebook.toString():F.toString()}e.getCellUndoRedoComparisonKey=r;var s;(function(F){F.scheme=C.Schemas.vscodeNotebookCell;const $=/^ch(\d{7,})/;function ue(M,N){return M.with({scheme:F.scheme,fragment:`ch${N.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}F.generate=ue;function z(M){if(M.scheme===F.scheme){const N=$.exec(M.fragment);if(!!N)return{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}}}F.parse=z;function B(M,N){return M.with({scheme:C.Schemas.vscodeNotebookCellMetadata,fragment:`ch${N.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}F.generateCellMetadataUri=B;function G(M){if(M.scheme===C.Schemas.vscodeNotebookCellMetadata){const N=$.exec(M.fragment);if(!!N)return{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}}}F.parseCellMetadataUri=G})(s=e.CellUri||(e.CellUri={}));const _=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(F){var $,ue;return(ue=($=_.get(F))===null||$===void 0?void 0:$.alwaysSecure)!==null&&ue!==void 0?ue:!1}e.mimeTypeIsAlwaysSecure=m;function b(F){var $,ue;return(ue=($=_.get(F))===null||$===void 0?void 0:$.supportedByCore)!==null&&ue!==void 0?ue:!1}e.mimeTypeSupportedByCore=b;function v(F){var $,ue;return(ue=($=_.get(F))===null||$===void 0?void 0:$.mergeable)!==null&&ue!==void 0?ue:!1}e.mimeTypeIsMergeable=v;function d(F,$){return A.isWindows&&(F=F.replace(/\//g,"\\"),$=$.replace(/\//g,"\\")),E.match(F,$)}function u(F,$,ue){let z=0;for(let B=0;B<$.length;B++){if(d($[B],F))return z;z++}for(let B=0;B<ue.length;B++){if(d(ue[B],F))return z;z++}return z}function t(F,$,ue){return F.sort((z,B)=>u(z,$,ue)-u(B,$,ue))}e.sortMimeTypes=t;function i(F,$,ue,z=(B,G)=>B===G){const B=[];function G(W,Q,x){if(!(Q===0&&x.length===0)){const Z=B[B.length-1];Z&&Z.start+Z.deleteCount===W?(Z.deleteCount+=Q,Z.toInsert.push(...x)):B.push({start:W,deleteCount:Q,toInsert:x})}}let M=0,N=0;for(;;){if(M===F.length){G(M,0,$.slice(N));break}if(N===$.length){G(M,F.length-M,[]);break}const W=F[M],Q=$[N];if(z(W,Q)){M+=1,N+=1;continue}ue(Q)?(G(M,1,[]),M+=1):(G(M,0,[Q]),N+=1)}return B}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(F){F.default="default",F.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(F){const $=F;return!!((typeof $.include=="string"||E.isRelativePattern($.include))&&(typeof $.exclude=="string"||E.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=a;function l(F,$,ue){if(Array.isArray(F.viewType)&&F.viewType.indexOf($)>=0||F.viewType===$)return!0;if(F.filenamePattern){let z=a(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,B=a(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(E.match(z,(0,P.basename)(ue.fsPath).toLowerCase()))return!(B&&E.match(B,(0,P.basename)(ue.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class o{constructor($){this.textModel=$}getElements(){const $=new Int32Array(this.textModel.cells.length);for(let ue=0;ue<this.textModel.cells.length;ue++)$[ue]=this.textModel.cells[ue].getHashValue();return $}}e.CellSequence=o,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var w;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function I(F){F.sort((ue,z)=>ue-z);const $=F.shift();return $===void 0?[]:F.reduce(function(ue,z){return z<=ue[0][1]?ue[0][1]=z+1:ue.unshift([z,z+1]),ue},[[$,$+1]]).reverse().map(ue=>({start:ue[0],end:ue[1]}))}e.cellIndexesToRanges=I;function p(F){return F.reduce((ue,z)=>{for(let B=z.start;B<z.end;B++)ue.push(B);return ue},[])}e.cellRangesToIndexes=p;function g(F){const $=F.sort((z,B)=>z.start-B.start),ue=$[0];return ue?$.reduce((z,B)=>{const G=z[z.length-1];return G.end>=B.start?G.end=Math.max(G.end,B.end):z.push(B),z},[ue]):[]}e.reduceRanges=g;function R(F,$){return $.start>=F.start&&$.end<=F.end}e.cellRangeContains=R}),define(ve[170],_e([0,1,140,4,64]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new P.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new P.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new P.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,C.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[171],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=E;function C(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=C}),define(ve[95],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=C;var P;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(P=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=A;class S{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=S;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const k of n)switch(k[0]){case 0:{const h=k[1];if(h.parent){if(this.items.has(h.parent)){const f=this.items.get(h.parent);f.children.add(h.item.extId);const r=this.createItem(h,f);this.items.set(h.item.extId,r),T.add(r)}}else{this.roots.add(h.item.extId);const f=this.createItem(h);this.items.set(h.item.extId,f),T.add(f)}h.expand===2&&this.updateBusyProviders(1);break}case 1:{const h=k[1],f=this.items.get(h.extId);if(!f)break;(0,e.applyTestItemUpdate)(f,h),T.update(f),h.expand!==void 0&&f.expand===2&&h.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const h=this.items.get(k[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h.item.extId);const f=[[k[1]]];for(;f.length;)for(const r of f.pop()){const s=this.items.get(r);s&&(f.push(s.children),this.items.delete(r),T.remove(s,s!==h),s.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}T.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=D}),define(ve[172],_e([0,1,12,45,13,24,21,59,141]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,h,f,r){if(this._contributedVariables=new Map,this._context=k,this._labelService=h,f)if(S.isWindows){const s=Object.create(null);this._envVariables=s,Object.keys(f).forEach(_=>{s[_.toLowerCase()]=f[_]})}else this._envVariables=f}resolveWithEnvironment(k,h,f){return this.recursiveResolve(k,h?h.uri:void 0,f)}async resolveAsync(k,h){return this.recursiveResolve(this._envVariables,k?k.uri:void 0,h)}resolve(k,h){return this.recursiveResolve(this._envVariables,k?k.uri:void 0,h)}resolveAnyBase(k,h,f,r){const s=A.deepClone(h);return S.isWindows&&s.windows?Object.keys(s.windows).forEach(_=>s[_]=s.windows[_]):S.isMacintosh&&s.osx?Object.keys(s.osx).forEach(_=>s[_]=s.osx[_]):S.isLinux&&s.linux&&Object.keys(s.linux).forEach(_=>s[_]=s.linux[_]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(this._envVariables,k?k.uri:void 0,s,f,r)}resolveAny(k,h,f){return this.resolveAnyBase(k,h,f)}async resolveAnyAsync(k,h,f){return this.resolveAnyBase(k,h,f)}resolveAnyMap(k,h,f){const r=new Map;return{newConfig:this.resolveAnyBase(k,h,f,r),resolvedVariables:r}}resolveWithInteractionReplace(k,h,f,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,h,f,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,h){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,h)}recursiveResolve(k,h,f,r,s){if(P.isString(f))return this.resolveString(k,h,f,r,s);if(P.isArray(f))return f.map(_=>this.recursiveResolve(k,h,_,r,s));if(P.isObject(f)){let _=Object.create(null);return Object.keys(f).forEach(m=>{const b=this.resolveString(k,h,m,r,s);_[b]=this.recursiveResolve(k,h,f[m],r,s)}),_}return f}resolveString(k,h,f,r,s){return f.replace(n.VARIABLE_REGEXP,(m,b)=>{if(b.includes(n.VARIABLE_LHS))return m;let v=this.evaluateSingleVariable(k,m,b,h,r);return s&&s.set(b,v),v})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,h,f,r,s){let _;const m=f.split(":");m.length>1&&(f=m[0],_=m[1]);const b=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,y.localize)(0,null,h))},v=()=>{const u=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,h,E.basename(u)))},d=()=>{if(_){const u=this._context.getFolderUri(_);if(u)return u;throw new Error((0,y.localize)(2,null,h,_))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,h)):new Error((0,y.localize)(4,null,h))};switch(f){case"env":if(_){if(k){const u=k[S.isWindows?_.toLowerCase():_];if(P.isString(u))return u}return""}throw new Error((0,y.localize)(5,null,h));case"config":if(_){const u=this._context.getConfigurationValue(r,_);if(P.isUndefinedOrNull(u))throw new Error((0,y.localize)(6,null,h,_));if(P.isObject(u))throw new Error((0,y.localize)(7,null,h,_));return u}throw new Error((0,y.localize)(8,null,h));case"command":return this.resolveFromMap(h,_,s,"command");case"input":return this.resolveFromMap(h,_,s,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return r||_?(0,D.normalizeDriveLetter)(this.fsPath(d())):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(d()));case"lineNumber":const u=this._context.getLineNumber();if(u)return u;throw new Error((0,y.localize)(9,null,h));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,h));case"file":return b();case"fileWorkspaceFolder":return v();case"relativeFile":return r||_?E.relative(this.fsPath(d()),b()):b();case"relativeFileDirname":const i=E.dirname(b());if(r||_){const o=E.relative(this.fsPath(d()),i);return o.length===0?".":o}return i;case"fileDirname":return E.dirname(b());case"fileExtname":return E.extname(b());case"fileBasename":return E.basename(b());case"fileBasenameNoExtension":const c=E.basename(b());return c.slice(0,c.length-E.extname(c).length);case"fileDirnameBasename":return E.basename(E.dirname(b()));case"execPath":const a=this._context.getExecPath();return a||h;case"execInstallFolder":const l=this._context.getAppRoot();return l||h;case"pathSeparator":return E.sep;default:try{const o=_?`${f}:${_}`:f;return this.resolveFromMap(h,o,s,void 0)}catch(o){return h}}}}resolveFromMap(k,h,f,r){if(h&&f){const s=r===void 0?f[h]:f[r+":"+h];if(typeof s=="string")return s;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[173],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var C;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var P;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var S;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.EDITOR_OPEN=2]="EDITOR_OPEN",h[h.EDITOR_CLOSE=3]="EDITOR_CLOSE",h[h.EDITOR_MOVE=4]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=6]="EDITOR_LABEL",h[h.EDITOR_PIN=7]="EDITOR_PIN",h[h.EDITOR_STICKY=8]="EDITOR_STICKY",h[h.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ve[174],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],_e([0,1,11,81,228,58,24,13,2,32,63,142,88,71,174,7]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(pe){function Se(q){const{selectionStartLineNumber:Fe,selectionStartColumn:Ie,positionLineNumber:Ye,positionColumn:Xe}=q,at=new s.Position(Fe-1,Ie-1),st=new s.Position(Ye-1,Xe-1);return new s.Selection(at,st)}pe.to=Se;function se(q){const{anchor:Fe,active:Ie}=q;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}pe.from=se})(_=e.Selection||(e.Selection={}));var m;(function(pe){function Se(q){if(!!q){const{start:Fe,end:Ie}=q;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}pe.from=Se;function se(q){if(!!q){const{startLineNumber:Fe,startColumn:Ie,endLineNumber:Ye,endColumn:Xe}=q;return new s.Range(Fe-1,Ie-1,Ye-1,Xe-1)}}pe.to=se})(m=e.Range||(e.Range={}));var b;(function(pe){function Se(se){switch(se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 4:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}pe.to=Se})(b=e.TokenType||(e.TokenType={}));var v;(function(pe){function Se(q){return new s.Position(q.lineNumber-1,q.column-1)}pe.to=Se;function se(q){return{lineNumber:q.line+1,column:q.character+1}}pe.from=se})(v=e.Position||(e.Position={}));var d;(function(pe){function Se(q){switch(q){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}pe.from=Se;function se(q){switch(q){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}pe.to=se})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(pe){function Se(q){let Fe;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Fe=String(q.code):Fe={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},m.from(q.range)),{message:q.message,source:q.source,code:Fe,severity:i.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,E.coalesce)(q.tags.map(d.from)):void 0})}pe.from=Se;function se(q){var Fe;const Ie=new s.Diagnostic(m.to(q),q.message,i.to(q.severity));return Ie.source=q.source,Ie.code=(0,D.isString)(q.code)?q.code:(Fe=q.code)===null||Fe===void 0?void 0:Fe.value,Ie.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Ie.tags=q.tags&&(0,E.coalesce)(q.tags.map(d.to)),Ie}pe.to=se})(u=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function Se(q){return Object.assign(Object.assign({},m.from(q.location.range)),{message:q.message,resource:q.location.uri})}pe.from=Se;function se(q){return new s.DiagnosticRelatedInformation(new s.Location(q.resource,m.to(q)),q.message)}pe.to=se})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(pe){function Se(q){switch(q){case s.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}pe.from=Se;function se(q){switch(q){case h.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}pe.to=se})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(pe){function Se(q){return typeof q=="number"&&q>=s.ViewColumn.One?q-1:q===s.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}pe.from=Se;function se(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=se})(c=e.ViewColumn||(e.ViewColumn={}));function a(pe){return typeof pe.range!="undefined"}function l(pe){return pe.length===0?!0:!!a(pe[0])}e.isDecorationOptionsArr=l;var o;(function(pe){function Se(Xe){return Xe.map(pe.from)}pe.fromMany=Se;function se(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let at;if(se(Xe)){const{language:bt,value:ct}=Xe;at={value:"```"+bt+`
`+ct+"\n```\n"}}else s.MarkdownString.isMarkdownString(Xe)?at={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons}:typeof Xe=="string"?at={value:Xe}:at={value:""};const st=Object.create(null);at.uris=st;const Qe=bt=>{try{let ct=y.URI.parse(bt,!0);ct=ct.with({query:Fe(ct.query,st)}),st[bt]=ct}catch(ct){}return""},lt=new P.Renderer;return lt.link=Qe,lt.image=bt=>Qe(C.parseHrefAndDimensions(bt).href),P(at.value,{renderer:lt}),at}pe.from=q;function Fe(Xe,at){if(!Xe)return Xe;let st;try{st=(0,A.parse)(Xe)}catch(lt){}if(!st)return Xe;let Qe=!1;return st=(0,S.cloneAndChange)(st,lt=>{if(y.URI.isUri(lt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[bt]=lt,Qe=!0,bt}else return}),Qe?JSON.stringify(st):Xe}function Ie(Xe){const at=new s.MarkdownString(Xe.value,Xe.supportThemeIcons);return at.isTrusted=Xe.isTrusted,at}pe.to=Ie;function Ye(Xe){if(!!Xe)return typeof Xe=="string"?Xe:pe.from(Xe)}pe.fromStrict=Ye})(o=e.MarkdownString||(e.MarkdownString={}));function w(pe){return l(pe)?pe.map(Se=>({range:m.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?o.fromMany(Se.hoverMessage):Se.hoverMessage?o.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):pe.map(Se=>({range:m.from(Se)}))}e.fromRangeOrRangeWithMessage=w;function I(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?y.URI.file(pe):pe}e.pathOrURIToURI=I;var p;(function(pe){function Se(se){return typeof se=="undefined"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?I(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}pe.from=Se})(p=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var g;(function(pe){function Se(se){return typeof se=="undefined"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?I(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?p.from(se.before):void 0,after:se.after?p.from(se.after):void 0}}pe.from=Se})(g=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(pe){function Se(se){if(typeof se=="undefined")return se;switch(se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Se})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(pe){function Se(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?R.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?g.from(se.light):void 0,dark:se.dark?g.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?I(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?p.from(se.before):void 0,after:se.after?p.from(se.after):void 0}}pe.from=Se})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(pe){function Se(q){return{text:q.newText,eol:q.newEol&&X.from(q.newEol),range:m.from(q.range)}}pe.from=Se;function se(q){const Fe=new s.TextEdit(m.to(q.range),q.text);return Fe.newEol=typeof q.eol=="undefined"?void 0:X.to(q.eol),Fe}pe.to=se})($=e.TextEdit||(e.TextEdit={}));var ue;(function(pe){function Se(q,Fe,Ie){var Ye,Xe,at;const st={edits:[]};if(q instanceof s.WorkspaceEdit)for(let Qe of q._allEntries())if(Qe._type===1)st.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const lt=Fe==null?void 0:Fe.getDocument(Qe.uri);st.edits.push({_type:2,resource:Qe.uri,edit:$.from(Qe.edit),modelVersionId:lt==null?void 0:lt.version,metadata:Qe.metadata})}else Qe._type===3?st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Ye=Ie==null?void 0:Ie.lookupNotebookDocument(Qe.uri))===null||Ye===void 0?void 0:Ye.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(Ne.from)}}),Qe.newMetadata&&st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Xe=Ie==null?void 0:Ie.lookupNotebookDocument(Qe.uri))===null||Xe===void 0?void 0:Xe.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(he.from)}}):Qe._type===6&&st.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((at=Qe.newOutputItems)===null||at===void 0?void 0:at.map(Ee.from))||[],append:Qe.append}});return st}pe.from=Se;function se(q){const Fe=new s.WorkspaceEdit;for(const Ie of q.edits)Ie.edit?Fe.replace(y.URI.revive(Ie.resource),m.to(Ie.edit.range),Ie.edit.text):Fe.renameFile(y.URI.revive(Ie.oldUri),y.URI.revive(Ie.newUri),Ie.options);return Fe}pe.to=se})(ue=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(pe){const Se=Object.create(null);Se[s.SymbolKind.File]=0,Se[s.SymbolKind.Module]=1,Se[s.SymbolKind.Namespace]=2,Se[s.SymbolKind.Package]=3,Se[s.SymbolKind.Class]=4,Se[s.SymbolKind.Method]=5,Se[s.SymbolKind.Property]=6,Se[s.SymbolKind.Field]=7,Se[s.SymbolKind.Constructor]=8,Se[s.SymbolKind.Enum]=9,Se[s.SymbolKind.Interface]=10,Se[s.SymbolKind.Function]=11,Se[s.SymbolKind.Variable]=12,Se[s.SymbolKind.Constant]=13,Se[s.SymbolKind.String]=14,Se[s.SymbolKind.Number]=15,Se[s.SymbolKind.Boolean]=16,Se[s.SymbolKind.Array]=17,Se[s.SymbolKind.Object]=18,Se[s.SymbolKind.Key]=19,Se[s.SymbolKind.Null]=20,Se[s.SymbolKind.EnumMember]=21,Se[s.SymbolKind.Struct]=22,Se[s.SymbolKind.Event]=23,Se[s.SymbolKind.Operator]=24,Se[s.SymbolKind.TypeParameter]=25;function se(Fe){return typeof Se[Fe]=="number"?Se[Fe]:6}pe.from=se;function q(Fe){for(const Ie in Se)if(Se[Ie]===Fe)return Number(Ie);return s.SymbolKind.Property}pe.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var B;(function(pe){function Se(q){switch(q){case s.SymbolTag.Deprecated:return 1}}pe.from=Se;function se(q){switch(q){case 1:return s.SymbolTag.Deprecated}}pe.to=se})(B=e.SymbolTag||(e.SymbolTag={}));var G;(function(pe){function Se(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(B.from),containerName:q.containerName,location:x.from(q.location)}}pe.from=Se;function se(q){const Fe=new s.SymbolInformation(q.name,z.to(q.kind),q.containerName,x.to(q.location));return Fe.tags=q.tags&&q.tags.map(B.to),Fe}pe.to=se})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var M;(function(pe){function Se(q){var Fe,Ie;const Ye={name:q.name||"!!MISSING: name!!",detail:q.detail,range:m.from(q.range),selectionRange:m.from(q.selectionRange),kind:z.from(q.kind),tags:(Ie=(Fe=q.tags)===null||Fe===void 0?void 0:Fe.map(B.from))!==null&&Ie!==void 0?Ie:[]};return q.children&&(Ye.children=q.children.map(Se)),Ye}pe.from=Se;function se(q){const Fe=new s.DocumentSymbol(q.name,q.detail,z.to(q.kind),m.to(q.range),m.to(q.selectionRange));return(0,E.isNonEmptyArray)(q.tags)&&(Fe.tags=q.tags.map(B.to)),q.children&&(Fe.children=q.children.map(se)),Fe}pe.to=se})(M=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(pe){function Se(se){const q=new s.CallHierarchyItem(z.to(se.kind),se.name,se.detail||"",y.URI.revive(se.uri),m.to(se.range),m.to(se.selectionRange));return q._sessionId=se._sessionId,q._itemId=se._itemId,q}pe.to=Se})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var W;(function(pe){function Se(se){return new s.CallHierarchyIncomingCall(N.to(se.from),se.fromRanges.map(q=>m.to(q)))}pe.to=Se})(W=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(pe){function Se(se){return new s.CallHierarchyOutgoingCall(N.to(se.to),se.fromRanges.map(q=>m.to(q)))}pe.to=Se})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var x;(function(pe){function Se(q){return{range:q.range&&m.from(q.range),uri:q.uri}}pe.from=Se;function se(q){return new s.Location(y.URI.revive(q.uri),m.to(q.range))}pe.to=se})(x=e.location||(e.location={}));var Z;(function(pe){function Se(q){const Fe=q,Ie=q;return{originSelectionRange:Fe.originSelectionRange?m.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ie.uri,range:m.from(Fe.targetRange?Fe.targetRange:Ie.range),targetSelectionRange:Fe.targetSelectionRange?m.from(Fe.targetSelectionRange):void 0}}pe.from=Se;function se(q){return{targetUri:y.URI.revive(q.uri),targetRange:m.to(q.range),targetSelectionRange:q.targetSelectionRange?m.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?m.to(q.originSelectionRange):void 0}}pe.to=se})(Z=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(pe){function Se(q){return{range:m.from(q.range),contents:o.fromMany(q.contents)}}pe.from=Se;function se(q){return new s.Hover(q.contents.map(o.to),m.to(q.range))}pe.to=se})(re=e.Hover||(e.Hover={}));var oe;(function(pe){function Se(q){return{range:m.from(q.range),expression:q.expression}}pe.from=Se;function se(q){return new s.EvaluatableExpression(m.to(q.range),q.expression)}pe.to=se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(pe){function Se(q){if(q instanceof s.InlineValueText)return{type:"text",range:m.from(q.range),text:q.text};if(q instanceof s.InlineValueVariableLookup)return{type:"variable",range:m.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Se;function se(q){switch(q.type){case"text":return{range:m.to(q.range),text:q.text};case"variable":return{range:m.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:m.to(q.range),expression:q.expression}}}pe.to=se})(ye=e.InlineValue||(e.InlineValue={}));var Pe;(function(pe){function Se(q){return{frameId:q.frameId,stoppedLocation:m.from(q.stoppedLocation)}}pe.from=Se;function se(q){return new s.InlineValueContext(q.frameId,m.to(q.stoppedLocation))}pe.to=se})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(pe){function Se(q){return{range:m.from(q.range),kind:q.kind}}pe.from=Se;function se(q){return new s.DocumentHighlight(m.to(q.range),q.kind)}pe.to=se})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(pe){function Se(se){switch(se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}pe.to=Se})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(pe){function Se(se){return{triggerKind:Re.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}pe.to=Se})(ze=e.CompletionContext||(e.CompletionContext={}));var U;(function(pe){function Se(q){switch(q){case s.CompletionItemTag.Deprecated:return 1}}pe.from=Se;function se(q){switch(q){case 1:return s.CompletionItemTag.Deprecated}}pe.to=se})(U=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(pe){const Se=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function se(Ie){var Ye;return(Ye=Se.get(Ie))!==null&&Ye!==void 0?Ye:9}pe.from=se;const q=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(Ie){var Ye;return(Ye=q.get(Ie))!==null&&Ye!==void 0?Ye:s.CompletionItemKind.Property}pe.to=Fe})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(pe){function Se(se,q){var Fe;const Ie=new s.CompletionItem(typeof se.label=="string"?se.label:se.label.name);return typeof se.label!="string"&&(Ie.label2=se.label),Ie.insertText=se.insertText,Ie.kind=K.to(se.kind),Ie.tags=(Fe=se.tags)===null||Fe===void 0?void 0:Fe.map(U.to),Ie.detail=se.detail,Ie.documentation=C.isMarkdownString(se.documentation)?o.to(se.documentation):se.documentation,Ie.sortText=se.sortText,Ie.filterText=se.filterText,Ie.preselect=se.preselect,Ie.commitCharacters=se.commitCharacters,n.Range.isIRange(se.range)?Ie.range=m.to(se.range):typeof se.range=="object"&&(Ie.range={inserting:m.to(se.range.insert),replacing:m.to(se.range.replace)}),Ie.keepWhitespace=typeof se.insertTextRules=="undefined"?!1:Boolean(se.insertTextRules&1),typeof se.insertTextRules!="undefined"&&se.insertTextRules&4?Ie.insertText=new s.SnippetString(se.insertText):(Ie.insertText=se.insertText,Ie.textEdit=Ie.range instanceof s.Range?new s.TextEdit(Ie.range,Ie.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Ie.additionalTextEdits=se.additionalTextEdits.map(Ye=>$.to(Ye))),Ie.command=q&&se.command?q.fromInternal(se.command):void 0,Ie}pe.to=Se})(ne=e.CompletionItem||(e.CompletionItem={}));var le;(function(pe){function Se(q){return{label:q.label,documentation:q.documentation?o.fromStrict(q.documentation):void 0}}pe.from=Se;function se(q){return{label:q.label,documentation:C.isMarkdownString(q.documentation)?o.to(q.documentation):q.documentation}}pe.to=se})(le=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(pe){function Se(q){return{label:q.label,documentation:q.documentation?o.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(le.from):[],activeParameter:q.activeParameter}}pe.from=Se;function se(q){return{label:q.label,documentation:C.isMarkdownString(q.documentation)?o.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(le.to):[],activeParameter:q.activeParameter}}pe.to=se})(fe=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(pe){function Se(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(fe.from):[]}}pe.from=Se;function se(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(fe.to):[]}}pe.to=se})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(pe){function Se(q){var Fe;return{text:q.text,range:m.from(q.range),kind:me.from((Fe=q.kind)!==null&&Fe!==void 0?Fe:s.InlineHintKind.Other),description:q.description&&o.fromStrict(q.description),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}pe.from=Se;function se(q){const Fe=new s.InlineHint(q.text,m.to(q.range),me.to(q.kind));return Fe.whitespaceAfter=q.whitespaceAfter,Fe.whitespaceBefore=q.whitespaceBefore,Fe.description=C.isMarkdownString(q.description)?o.to(q.description):q.description,Fe}pe.to=se})(Oe=e.InlineHint||(e.InlineHint={}));var me;(function(pe){function Se(q){return q}pe.from=Se;function se(q){return q}pe.to=se})(me=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(pe){function Se(q){return{range:m.from(q.range),url:q.target,tooltip:q.tooltip}}pe.from=Se;function se(q){let Fe;if(q.url)try{Fe=typeof q.url=="string"?y.URI.parse(q.url,!0):y.URI.revive(q.url)}catch(Ie){}return new s.DocumentLink(m.to(q.range),Fe)}pe.to=se})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(pe){function Se(q){const Fe=new s.ColorPresentation(q.label);return q.textEdit&&(Fe.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Fe.additionalTextEdits=q.additionalTextEdits.map(Ie=>$.to(Ie))),Fe}pe.to=Se;function se(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Fe=>$.from(Fe)):void 0}}pe.from=se})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(pe){function Se(q){return new s.Color(q[0],q[1],q[2],q[3])}pe.to=Se;function se(q){return[q.red,q.green,q.blue,q.alpha]}pe.from=se})($e=e.Color||(e.Color={}));var be;(function(pe){function Se(q){return{range:m.from(q.range)}}pe.from=Se;function se(q){return new s.SelectionRange(m.to(q.range))}pe.to=se})(be=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(pe){function Se(se){switch(se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}pe.to=Se})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(pe){function Se(q){switch(q){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Se;function se(q){switch(q){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}pe.to=se})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(pe){function Se(q){if(q===s.EndOfLine.CRLF)return 1;if(q===s.EndOfLine.LF)return 0}pe.from=Se;function se(q){if(q===1)return s.EndOfLine.CRLF;if(q===0)return s.EndOfLine.LF}pe.to=se})(X=e.EndOfLine||(e.EndOfLine={}));var ge;(function(pe){function Se(se){if(typeof se=="object")return se.viewId;switch(se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Se})(ge=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(pe){function Se(se){const q={start:se.start+1,end:se.end+1};return se.kind&&(q.kind=We.from(se.kind)),q}pe.from=Se})(Me=e.FoldingRange||(e.FoldingRange={}));var We;(function(pe){function Se(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return T.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return T.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return T.FoldingRangeKind.Region}}pe.from=Se})(We=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(pe){function Se(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?m.from(se.selection):void 0,override:typeof se.override=="boolean"?k.EditorOverride.DISABLED:void 0}}pe.from=Se})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(pe){function Se(q){return q instanceof s.RelativePattern||typeof q=="string"?q:se(q)?new s.RelativePattern(q.base,q.pattern):q}pe.from=Se;function se(q){const Fe=q;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var H;(function(pe){function Se(se){if(se){if(Array.isArray(se))return se.map(Se);if(typeof se=="string")return se;{const q=se;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ze.from(q.pattern),exclusive:q.exclusive}}}else return}pe.from=Se})(H=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(pe){function Se(q){return{start:q.start,end:q.end}}pe.from=Se;function se(q){return new s.NotebookRange(q.start,q.end)}pe.to=se})(ie=e.NotebookRange||(e.NotebookRange={}));var de;(function(pe){function Se(se){return new s.NotebookCellMetadata(se.inputCollapsed,se.outputCollapsed).with({custom:se.custom})}pe.to=Se})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(pe){function Se(q){return q}pe.from=Se;function se(q){return new s.NotebookDocumentMetadata(q.trusted,q.custom)}pe.to=se})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Y;(function(pe){function Se(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}pe.to=Se;function se(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}pe.from=se})(Y=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(pe){function Se(q){switch(q){case s.NotebookCellKind.Markdown:return f.CellKind.Markdown;case s.NotebookCellKind.Code:default:return f.CellKind.Code}}pe.from=Se;function se(q){switch(q){case f.CellKind.Markdown:return s.NotebookCellKind.Markdown;case f.CellKind.Code:default:return s.NotebookCellKind.Code}}pe.to=se})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(pe){function Se(q){var Fe;return{cellKind:ae.from(q.kind),language:q.language,source:q.source,metadata:Object.assign(Object.assign({},q.metadata),Y.from((Fe=q.latestExecutionSummary)!==null&&Fe!==void 0?Fe:{})),outputs:q.outputs?q.outputs.map(Ne.from):[]}}pe.from=Se;function se(q){return new s.NotebookCellData(ae.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(Ne.to):void 0,q.metadata?de.to(q.metadata):void 0)}pe.to=se})(he=e.NotebookCellData||(e.NotebookCellData={}));var Ee;(function(pe){function Se(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}pe.from=Se;function se(q){return new s.NotebookCellOutputItem(q.mime,q.value,q.metadata)}pe.to=se})(Ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ne;(function(pe){function Se(q){return{outputId:q.id,outputs:q.outputs.map(Ee.from),metadata:q.metadata}}pe.from=Se;function se(q){const Fe=q.outputs.map(Ee.to);return new s.NotebookCellOutput(Fe,q.outputId,q.metadata)}pe.to=se})(Ne=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(pe){function Se(Ie){if(Ie!=null){if(Ie instanceof s.RelativePattern||typeof Ie=="string")return Ie;if(Fe(Ie))return new s.RelativePattern(Ie.base,Ie.pattern);if(q(Ie))return{include:Ze.from(Ie.include)||void 0,exclude:Ze.from(Ie.exclude)||void 0}}}pe.from=Se;function se(Ie){return typeof Ie=="string"?Ie:Fe(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}pe.to=se;function q(Ie){const Ye=Ie,Xe=Ze.from(Ye.include);if(!(Xe&&Xe instanceof s.RelativePattern||typeof Xe=="string"))return!1;const at=Ze.from(Ye.exclude);return!!(at&&at instanceof s.RelativePattern||typeof at=="string")}function Fe(Ie){const Ye=Ie;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var je;(function(pe){function Se(se){return{backgroundColor:se.backgroundColor,borderColor:se.borderColor,top:se.top?p.from(se.top):void 0}}pe.from=Se})(je=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Je;(function(pe){function Se(se,q,Fe){const Ie=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ie,Fe),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}pe.from=Se})(Je=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(pe){function Se(se){var q;return{transientOutputs:(q=se==null?void 0:se.transientOutputs)!==null&&q!==void 0?q:!1,transientMetadata:Object.assign(Object.assign({},se==null?void 0:se.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0})}}pe.from=Se})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(pe){function Se(q){var Fe;return{uri:q.uri,provides:typeof q.provides=="string"?[q.provides]:(Fe=q.provides)!==null&&Fe!==void 0?Fe:[]}}pe.from=Se;function se(q){return{uri:y.URI.revive(q.uri),provides:q.provides}}pe.to=se})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var ot;(function(pe){function Se(q){return{message:o.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?x.from(q.location):void 0}}pe.from=Se;function se(q){const Fe=new s.TestMessage(typeof q.message=="string"?q.message:o.to(q.message));return Fe.severity=q.severity,Fe.actualOutput=q.actualOutput,Fe.expectedOutput=q.expectedOutput,Fe}pe.to=se})(ot=e.TestMessage||(e.TestMessage={}));var it;(function(pe){function Se(Ie){var Ye,Xe;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range),debuggable:(Ye=Ie.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Ie.description,runnable:(Xe=Ie.runnable)!==null&&Xe!==void 0?Xe:!0,expandable:Ie.expandable}}pe.from=Se;function se(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range),debuggable:!1,description:Ie.description,runnable:!0,expandable:!0}}pe.fromResultSnapshot=se;function q(Ie){return{id:Ie.extId,label:Ie.label,uri:y.URI.revive(Ie.uri),range:m.to(Ie.range),expandable:Ie.expandable,debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}pe.toPlain=q;function Fe(Ie){const Ye=new s.TestItem(Ie.extId,Ie.label,y.URI.revive(Ie.uri),Ie.expandable);return Ye.range=m.to(Ie.range),Ye.debuggable=Ie.debuggable,Ye.description=Ie.description,Ye.runnable=Ie.runnable,Ye}pe.to=Fe})(it=e.TestItem||(e.TestItem={}));var pt;(function(pe){function Se(Fe,Ie){var Ye,Xe,at;const st={completedAt:Ie.completedAt,id:Fe,output:Ie.output,items:[]},Qe=[[null,Ie.results]];for(;Qe.length;){const[lt,bt]=Qe.pop();for(const ct of bt){const vt={children:(Xe=(Ye=ct.children)===null||Ye===void 0?void 0:Ye.map(wt=>wt.id))!==null&&Xe!==void 0?Xe:[],computedState:ct.state,item:it.fromResultSnapshot(ct),state:{state:ct.state,duration:ct.duration,messages:ct.messages.map(ot.from)},retired:void 0,expand:3,parent:(at=lt==null?void 0:lt.item.extId)!==null&&at!==void 0?at:null,src:{provider:"",tree:-1},direct:!lt};st.items.push(vt),ct.children&&Qe.push([vt,ct.children])}}return st}pe.from=Se;const se=(Fe,Ie)=>Object.assign(Object.assign({},it.toPlain(Fe.item)),{state:Fe.state.state,duration:Fe.state.duration,messages:Fe.state.messages.map(ot.to),children:Fe.children.map(Ye=>Ie.get(Ye)).filter(D.isDefined).map(Ye=>se(Ye,Ie))});function q(Fe){const Ie=[],Ye=new Map;for(const Xe of Fe.items)Ye.set(Xe.item.extId,Xe),Xe.direct&&Ie.push(Xe);return{completedAt:Fe.completedAt,results:Ie.map(Xe=>se(Xe,Ye))}}pe.to=q})(pt=e.TestResults||(e.TestResults={}));var Ve;(function(pe){function Se(se){switch(se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}pe.to=Se})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[175],_e([0,1,2,10,7,9,44]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(n,T,k,h={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=h,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,h)=>{const r={dispose:this._callbacks.push([T,k,n])};return Array.isArray(h)&&h.push(r),r}}async $participateInSave(n,T){const k=E.URI.revive(n);let h=!1;const f=setTimeout(()=>h=!0,this._thresholds.timeout),r=[];try{for(let s of[...this._callbacks]){if(h)break;const _=this._documents.getDocument(k),m=await this._deliverEventAsyncAndBlameBadListeners(s,{document:_,reason:A.TextDocumentSaveReason.to(T)});r.push(m)}}finally{clearTimeout(f)}return r}_deliverEventAsyncAndBlameBadListeners([n,T,k],h){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,h).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this._badListeners.get(n);this._badListeners.set(n,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,h){const f=[],r=Date.now(),{document:s,reason:_}=h,{version:m}=s,b=Object.freeze({document:s,reason:_,waitUntil(v){if(Object.isFrozen(f))throw(0,C.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(v))}});try{T.apply(k,[b])}catch(v){return Promise.reject(v)}return Object.freeze(f),new Promise((v,d)=>{const u=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(u),v(t)}).catch(t=>{clearTimeout(u),d(t)})}).then(v=>{const d={edits:[]};for(const u of v)if(Array.isArray(u)&&u.every(t=>t instanceof P.TextEdit))for(const{newText:t,newEol:i,range:c}of u)d.edits.push({_type:2,resource:s.uri,edit:{range:c&&A.Range.from(c),text:t,eol:i&&A.EndOfLine.from(i)}});if(d.edits.length!==0)return m===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[176],_e([0,1,3,14,28,2,9,7]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,h,f,r,s){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,f&&(this._config+=1),r&&(this._config+=2),s&&(this._config+=4);const _=(0,P.parse)(h),m=k(b=>{if(!f)for(let v of b.created){const d=A.URI.revive(v);_(d.fsPath)&&this._onDidCreate.fire(d)}if(!r)for(let v of b.changed){const d=A.URI.revive(v);_(d.fsPath)&&this._onDidChange.fire(d)}if(!s)for(let v of b.deleted){const d=A.URI.revive(v);_(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,h,f){this._logService=h,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new C.AsyncEmitter,this._onWillCreateFile=new C.AsyncEmitter,this._onWillDeleteFile=new C.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,h,f,r){return new y(this._onFileSystemEvent.event,k,h,f,r)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,h){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(f=>({oldUri:A.URI.revive(f.source),newUri:A.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(f=>A.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:h.map(f=>A.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,h){return(f,r,s)=>{const _=function(b){f.call(r,b)};return _.extension=k,h.event(_,void 0,s)}}async $onWillRunFileOperation(k,h,f,r){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))},f,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(s=>A.URI.revive(s.target))},f,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(s=>A.URI.revive(s.target))},f,r)}}async _fireWillEvent(k,h,f,r){const s=new Set,_=[];if(await k.fireAsync(h,r,async(b,v)=>{var d;const u=Date.now(),t=await Promise.resolve(b);t instanceof D.WorkspaceEdit&&(_.push(t),s.add((d=v.extension.displayName)!==null&&d!==void 0?d:v.extension.identifier.value)),Date.now()-u>f&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),!r.isCancellationRequested&&_.length!==0){const m={edits:[]};for(let b of _){let{edits:v}=S.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(v)}return{edit:m,extensionNames:Array.from(s)}}}}e.ExtHostFileSystemEventService=n}),define(ve[177],_e([0,1,18,24,2,9,7,71]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(h,f,r,s){this.start=h,this.deletedCount=f,this.deletedItems=r,this.items=s}static asApiEvents(h){return h.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(r=>r.cell)}))}}class n{constructor(h,f,r){var s;this._notebook=h,this._extHostDocument=f,this._cellData=r,this.handle=r.handle,this.uri=P.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(s=r.metadata)!==null&&s!==void 0?s:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(h,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:h}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const h=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return h._notebook.getCellIndex(h)},notebook:h._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get outputs(){return h._outputs.slice(0)},get metadata(){return h._metadata},get latestExecutionSummary(){return h._previousResult}})}return this._cell}setOutputs(h){this._outputs=h.map(A.NotebookCellOutput.to)}setOutputItems(h,f,r){const s=r.map(A.NotebookCellOutputItem.to),_=this._outputs.find(m=>m.id===h);_&&(f||(_.outputs.length=0),_.outputs.push(...s))}setMetadata(h){this._internalMetadata=h,this._metadata=A.NotebookCellMetadata.to(h),this._previousResult=A.NotebookCellPreviousExecutionResult.to(h)}}e.ExtHostCell=n;class T{constructor(h,f,r,s,_,m,b){this._proxy=h,this._textDocumentsAndEditors=f,this._textDocuments=r,this._emitter=s,this._viewType=_,this._metadata=m,this.uri=b,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const h=this;this._notebook={get uri(){return h.uri},get version(){return h._versionId},get viewType(){return h._viewType},get isDirty(){return h._isDirty},get isUntitled(){return h.uri.scheme===E.Schemas.untitled},get isClosed(){return h._disposed},get metadata(){return h._metadata},get cellCount(){return h._cells.length},cellAt(f){return f=h._validateIndex(f),h._cells[f].cell},getCells(f){return(f?h._getCells(f):h._cells).map(s=>s.cell)},save(){return h._save()}}}return this._notebook}updateBackup(h){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=h}disposeBackup(){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(h){h.metadata&&(this._metadata=this._metadata.with(h.metadata))}acceptModelChanged(h,f){this._versionId=h.versionId,this._isDirty=f;for(const r of h.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(h){return h<0?0:h>=this._cells.length?this._cells.length-1:h}_validateRange(h){return h.start<0&&(h=h.with({start:0})),h.end>this._cells.length&&(h=h.with({end:this._cells.length})),h}_getCells(h){h=this._validateRange(h);const f=[];for(let r=h.start;r<h.end;r++)f.push(this._cells[r]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(h,f){if(!this._disposed){const r=[],s=[],_=[];h.reverse().forEach(m=>{const v=m[2].map(t=>{const i=new n(this,this._textDocumentsAndEditors,t);return f||s.push(n.asModelAddData(this.notebookDocument,t)),i}),d=new y(m[0],m[1],[],v),u=this._cells.splice(m[0],m[1],...v);for(let t of u)_.push(t.uri),d.deletedItems.push(t.cell);r.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:_}),f||this._emitter.emitModelChange((0,C.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(r)}))}}_moveCell(h,f){const r=this._cells.splice(h,1);this._cells.splice(f,0,...r);const s=[new y(h,1,r.map(_=>_.cell),[]),new y(f,0,[],r)];this._emitter.emitModelChange((0,C.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(s)}))}_setCellOutputs(h,f){const r=this._cells[h];r.setOutputs(f),this._emitter.emitCellOutputsChange((0,C.deepFreeze)({document:this.notebookDocument,cells:[r.cell]}))}_setCellOutputItems(h,f,r,s){const _=this._cells[h];_.setOutputItems(f,r,s),this._emitter.emitCellOutputsChange((0,C.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_changeCellLanguage(h,f){const r=this._cells[h];r.cell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(r.uri,f)}_changeCellMetadata(h,f){var r;const s=this._cells[h],_=s.internalMetadata,m=s.cell.metadata;s.setMetadata(f);const b=s.cell.metadata;if((0,C.equals)(m,b)||this._emitter.emitCellMetadataChange((0,C.deepFreeze)({document:this.notebookDocument,cell:s.cell})),_.runState!==f.runState){const v=(r=f.runState)!==null&&r!==void 0?r:S.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,C.deepFreeze)({document:this.notebookDocument,cell:s.cell,executionState:v}))}}getCellFromIndex(h){return this._cells[h]}getCell(h){return this._cells.find(f=>f.handle===h)}getCellIndex(h){return this._cells.indexOf(h)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ve[178],_e([0,1,7,9]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:y})}replaceCellOutput(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:D,outputs:y.map(n=>C.NotebookCellOutput.from(n))})}replaceCells(D,y,n){this._throwIfFinalized(),!(D===y&&n.length===0)&&this._collectedEdits.push({editType:1,index:D,count:y-D,cells:n.map(C.NotebookCellData.from)})}}class A{constructor(D,y,n,T,k,h){this.id=D,this._proxy=y,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=k,this._visibleRanges=T,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.notebookDocument},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(y,n){D._proxy.$tryRevealRange(D.id,C.NotebookRange.from(y),n!=null?n:E.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(y){const n=new P(this.document.version);return y(n),D._applyEdit(n.finalize())},get kernel(){return D._kernel},setDecorations(y,n){return D.setDecorations(y,n)}}}return this._editor}_acceptKernel(D){this._kernel=D}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const y=[];let n=-1;for(let T=0;T<D.cellEdits.length;T++){if(n<0){y.push(D.cellEdits[T]),n++;continue}const h=y[n],f=D.cellEdits[T];if(h.editType===1&&f.editType===1&&h.index===f.index){h.cells.push(...D.cellEdits[T].cells),h.count+=D.cellEdits[T].count;continue}y.push(D.cellEdits[T]),n++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,y)}setDecorations(D,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return y.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,C.NotebookRange.from(y),D.key)}}e.ExtHostNotebookEditor=A}),define(ve[179],_e([0,1,9,152,132,20,52]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,h,f){const r=this._handles++,{title:s,location:_,cancellable:m}=h,b={label:(0,P.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(r,{location:E.ProgressLocation.from(_),title:s,source:b,cancellable:m},k),this._withProgress(r,f,!!m)}_withProgress(k,h,f){let r;f&&(r=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,r));const s=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let _;try{_=h(new n(this._proxy,k),f&&r?r.token:A.CancellationToken.None)}catch(m){throw s(k),m}return _.then(m=>s(k),m=>s(k)),_}$acceptProgressCanceled(k){const h=this._mapHandleToCancellationSource.get(k);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=D;function y(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends C.Progress{constructor(k,h){super(f=>this.throttledReport(f));this._proxy=k,this._handle=h}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}qe([(0,S.throttle)(100,(T,k)=>y(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(ve[96],_e([0,1,42,10,54,9,7]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(h,f){const r=D._Keys.nextId();h.$registerTextEditorDecorationType(r,A.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new P.IdGenerator("TextEditorDecorationType");class y{constructor(h,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,f){this._throwIfFinalized();let r=null;if(h instanceof S.Position)r=new S.Range(h,h);else if(h instanceof S.Range)r=h;else throw new Error("Unrecognized location");this._pushEdit(r,f,!1)}insert(h,f){this._throwIfFinalized(),this._pushEdit(new S.Range(h,h),f,!0)}delete(h){this._throwIfFinalized();let f=null;if(h instanceof S.Range)f=h;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(h,f,r){const s=this._document.validateRange(h);this._collectedEdits.push({range:s,text:f,forceMoveMarkers:r})}setEndOfLine(h){if(this._throwIfFinalized(),h!==S.EndOfLine.LF&&h!==S.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=h}}e.TextEditorEdit=y;class n{constructor(h,f,r,s){this._proxy=h,this._id=f,this._accept(r),this._logService=s;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(m){_._setTabSize(m)},get insertSpaces(){return _._insertSpaces},set insertSpaces(m){_._setInsertSpaces(m)},get cursorStyle(){return _._cursorStyle},set cursorStyle(m){_._setCursorStyle(m)},get lineNumbers(){return _._lineNumbers},set lineNumbers(m){_._setLineNumbers(m)}}}_accept(h){this._tabSize=h.tabSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const f=Math.floor(h);return f>0?f:null}if(typeof h=="string"){const f=parseInt(h,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(h){const f=this._validateTabSize(h);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const f=this._validateInsertSpaces(h);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(h)})))}assign(h){const f={};let r=!1;if(typeof h.tabSize!="undefined"){const s=this._validateTabSize(h.tabSize);s==="auto"?(r=!0,f.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,r=!0,f.tabSize=s)}if(typeof h.insertSpaces!="undefined"){const s=this._validateInsertSpaces(h.insertSpaces);s==="auto"?(r=!0,f.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,r=!0,f.insertSpaces=s)}typeof h.cursorStyle!="undefined"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,r=!0,f.cursorStyle=h.cursorStyle),typeof h.lineNumbers!="undefined"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,r=!0,f.lineNumbers=A.TextEditorLineNumbersStyle.from(h.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(h){h.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class T{constructor(h,f,r,s,_,m,b,v){this.id=h,this._proxy=f,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new n(this._proxy,this.id,m,r),this._visibleRanges=b,this._viewColumn=v;const d=this;this.value=Object.freeze({get document(){return s.getValue()},set document(u){throw(0,C.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(u){if(!(u instanceof S.Selection))throw(0,C.illegalArgument)("selection");d._selections=[u],d._trySetSelection()},get selections(){return d._selections},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof S.Selection)))throw(0,C.illegalArgument)("selections");d._selections=u,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(u){throw(0,C.readonly)("visibleRanges")},get options(){return d._options.value},set options(u){d._disposed||d._options.assign(u)},get viewColumn(){return d._viewColumn},set viewColumn(u){throw(0,C.readonly)("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(s.getValue(),t);return u(i),d._applyEdit(i)},insertSnippet(u,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=d._selections.map(a=>A.Range.from(a));else if(t instanceof S.Position){const{lineNumber:a,column:l}=A.Position.from(t);c=[{startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l}]}else if(t instanceof S.Range)c=[A.Range.from(t)];else{c=[];for(const a of t)if(a instanceof S.Range)c.push(A.Range.from(a));else{const{lineNumber:l,column:o}=A.Position.from(a);c.push({startLineNumber:l,startColumn:o,endLineNumber:l,endColumn:o})}}return f.$tryInsertSnippet(h,u.value,c,i)},setDecorations(u,t){const i=t.length===0;i&&!d._hasDecorationsForKey.has(u.key)||(i?d._hasDecorationsForKey.delete(u.key):d._hasDecorationsForKey.add(u.key),d._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return f.$trySetDecorations(h,u.key,A.fromRangeOrRangeWithMessage(t));{const c=new Array(4*t.length);for(let a=0,l=t.length;a<l;a++){const o=t[a];c[4*a]=o.start.line+1,c[4*a+1]=o.start.character+1,c[4*a+2]=o.end.line+1,c[4*a+3]=o.end.character+1}return f.$trySetDecorationsFast(h,u.key,c)}}))},revealRange(u,t){d._runOnProxy(()=>f.$tryRevealRange(h,A.Range.from(u),t||S.TextEditorRevealType.Default))},show(u){f.$tryShowEditor(h,A.ViewColumn.from(u))},hide(){f.$tryHideEditor(h)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,E.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,E.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,E.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,E.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const f=h.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const r=f.edits.map(_=>_.range);r.sort((_,m)=>_.end.line===m.end.line?_.end.character===m.end.character?_.start.line===m.start.line?_.start.character-m.start.character:_.start.line-m.start.line:_.end.character-m.end.character:_.end.line-m.end.line);for(let _=0,m=r.length-1;_<m;_++){const b=r[_].end;if(r[_+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=f.edits.map(_=>({range:A.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,s,{setEndOfLine:typeof f.setEndOfLine=="number"?A.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=T}),define(ve[180],_e([0,1,135,25,2,3,6,14,7,13,11,9,20]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(_,m){if((0,n.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let b;return Array.isArray(_.highlights)&&(b=_.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),b=b.length?b:void 0),{label:_.label,highlights:b}}}class r{constructor(m,b,v){this._proxy=m,this.commands=b,this.logService=v,this.treeViews=new Map;function d(u){return u&&u.$treeViewId&&u.$treeItemHandle}b.registerArgumentProcessor({processArgument:u=>d(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(t=>d(t)?this.convertArgument(t):t):u})}registerTreeDataProvider(m,b,v){const d=this.createTreeView(m,{treeDataProvider:b},v);return{dispose:()=>d.dispose()}}createTreeView(m,b,v){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany}),u=this.createExtHostTreeView(m,b,v);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get message(){return u.message},set message(t){u.message=t},get title(){return u.title},set title(t){u.title=t},get description(){return u.description},set description(t){u.description=t},reveal:(t,i)=>u.reveal(t,i),dispose:async()=>{await d,this.treeViews.delete(m),u.dispose()}}}$getChildren(m,b){const v=this.treeViews.get(m);return v?v.getChildren(b):Promise.reject(new Error((0,E.localize)(0,null,m)))}async $hasResolve(m){const b=this.treeViews.get(m);if(!b)throw new Error((0,E.localize)(1,null,m));return b.hasResolve}$resolve(m,b,v){const d=this.treeViews.get(m);if(!d)throw new Error((0,E.localize)(2,null,m));return d.resolveTreeItem(b,v)}$setExpanded(m,b,v){const d=this.treeViews.get(m);if(!d)throw new Error((0,E.localize)(3,null,m));d.setExpanded(b,v)}$setSelection(m,b){const v=this.treeViews.get(m);if(!v)throw new Error((0,E.localize)(4,null,m));v.setSelection(b)}$setVisible(m,b){const v=this.treeViews.get(m);if(!v)throw new Error((0,E.localize)(5,null,m));v.setVisible(b)}createExtHostTreeView(m,b,v){const d=new s(m,b,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(m,d),d}convertArgument(m){const b=this.treeViews.get(m.$treeViewId);return b?b.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class s extends S.Disposable{constructor(m,b,v,d,u,t){super();if(this.viewId=m,this.proxy=v,this.commands=d,this.logService=u,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const l of t.contributes.views[a])l.id===m&&(this._title=l.name);this.dataProvider=b.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let i,c;this._register(A.Event.debounce(this._onDidChangeData.event,(a,l)=>(a||(a={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(o=>c=o),this.refreshPromise=this.refreshPromise.then(()=>i)),a.elements.push(l.element)),l.message&&(a.message=!0),a),200,!0)(({message:a,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=c;return i=null,this.refresh(l).then(()=>o())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,n.isUndefinedOrNull)(m))}getChildren(m){const b=m?this.getExtensionElement(m):void 0;if(m&&!b)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(m);return(v?Promise.resolve(v):this.fetchChildrenNodes(b)).then(d=>d.map(u=>u.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,b){b=b||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(b.select)?!0:b.select,d=(0,n.isUndefinedOrNull)(b.focus)?!1:b.focus,u=(0,n.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(c=>c.item)},{select:v,focus:d,expand:u})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:d,expand:u})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,b){const v=this.getExtensionElement(m);v&&(b?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(m){(0,T.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,b){var v;if(!!this.dataProvider.resolveTreeItem){const d=this.elements.get(m);if(d){const u=this.nodes.get(d);if(u){const t=(v=await this.dataProvider.resolveTreeItem(u.extensionItem,d,b))!==null&&v!==void 0?v:u.extensionItem;return u.item.tooltip=this.getTooltip(t.tooltip),u.item.command=this.getCommand(u.disposableStore,t.command),u.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(b=>b?this.resolveUnknownParentChain(b).then(v=>this.resolveTreeNode(b,v[v.length-1]).then(d=>(v.push(d),v))):Promise.resolve([]))}resolveParent(m){const b=this.nodes.get(m);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,b){const v=this.nodes.get(m);return v?Promise.resolve(v):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>this.createHandle(m,d,b,!0)).then(d=>this.getChildren(b?b.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const t=this.nodes.get(u);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(m){if(m){let b;if(typeof m=="string"){const v=this.getExtensionElement(m);b=v?this.nodes.get(v):void 0}else b=m;return b&&b.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const b=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=m?this.nodes.get(m):void 0,d=await this.dataProvider.getChildren(m);if(b.token.isCancellationRequested)return[];const u=await Promise.all((0,T.coalesce)(d||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,v):null}));return b.token.isCancellationRequested?[]:(0,T.coalesce)(u)}finally{b.dispose()}}refresh(m){if(m.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(m);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const b=new Set,v=m.map(u=>this.nodes.get(u));for(const u of v)if(u&&!b.has(u.item.handle)){let t=u;for(;t&&t.parent&&v.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&b.add(u.item.handle)}const d=[];return b.forEach(u=>{const t=this.elements.get(u);if(t){const i=this.nodes.get(t);i&&(!i.parent||!b.has(i.parent.item.handle))&&d.push(u)}}),d}refreshHandles(m){const b={};return Promise.all(m.map(v=>this.refreshNode(v).then(d=>{d&&(b[v]=d.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(m){const b=this.getExtensionElement(m);if(b){const v=this.nodes.get(b);if(v)return this.clearChildren(b),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(d=>{if(d){const u=this.createTreeNode(b,d,v.parent);return this.updateNodeCache(b,u,v,v.parent),v.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,b,v){const d=this.createTreeNode(m,b,v);if(b.id&&this.elements.has(d.item.handle))throw new Error((0,E.localize)(6,null,b.id));return this.addNodeToCache(m,d),this.addNodeToParentCache(d,v),d}getTooltip(m){return y.MarkdownString.isMarkdownString(m)?k.MarkdownString.from(m):m}getCommand(m,b){return b?this.commands.toInternal(b,m):void 0}createTreeNode(m,b,v){const d=new S.DisposableStore,u=this.createHandle(m,b,v),t=this.getLightIconPath(b);return{item:{handle:u,parentHandle:v?v.item.handle:void 0,label:f(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(d,b.command),contextValue:b.contextValue,icon:t,iconDark:this.getDarkIconPath(b)||t,themeIcon:this.getThemeIcon(b),collapsibleState:(0,n.isUndefinedOrNull)(b.collapsibleState)?y.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation},extensionItem:b,parent:v,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(m){return m.iconPath instanceof y.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:b,label:v,resourceUri:d},u,t){if(b)return`${s.ID_HANDLE_PREFIX}/${b}`;const i=f(v,this.extension),c=u?u.item.handle:s.LABEL_HANDLE_PREFIX;let a=i?i.label:d?(0,C.basename)(d):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const l=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,o=this.getChildrenNodes(u)||[];let w,I=0;do{if(w=`${c}/${I}:${a}`,t||!this.elements.has(w)||l===w)break;I++}while(I<=o.length);return w}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon))return typeof m.iconPath=="string"||P.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return P.URI.isUri(m)?m:P.URI.file(m)}addNodeToCache(m,b){this.elements.set(b.item.handle,m),this.nodes.set(m,b)}updateNodeCache(m,b,v,d){this.elements.delete(b.item.handle),this.nodes.delete(m),b.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(m,b);const u=this.getChildrenNodes(d)||[],t=u.filter(i=>i.item.handle===v.item.handle)[0];t&&u.splice(u.indexOf(t),1,b)}addNodeToParentCache(m,b){b?(b.children||(b.children=[]),b.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const b=this.nodes.get(m);if(b){if(b.children)for(const v of b.children){const d=this.elements.get(v.item.handle);d&&this.clear(d)}b.children=void 0}}else this.clearAll()}clear(m){const b=this.nodes.get(m);if(b){if(b.children)for(const v of b.children){const d=this.elements.get(v.item.handle);d&&this.clear(d)}this.nodes.delete(m),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}s.LABEL_HANDLE_PREFIX="0",s.ID_HANDLE_PREFIX="1"}),define(ve[181],_e([0,1,11,14,20,9,7,95]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(r,s){if(s!==void 0){const _=this.testIdsToInternal.get(s),m=_==null?void 0:_.get(r);if(m)return[_,m]}return(0,E.mapFind)(this.testIdsToInternal.values(),_=>{const m=_.get(r);return m&&[_,m]})}createForHierarchy(r=()=>{}){return new h(this.createIdMap(T++),r)}createIdMap(r){const s=new k(r);return this.testIdsToInternal.set(s.id,s),{object:s,dispose:()=>this.testIdsToInternal.delete(s.id)}}}e.OwnedTestCollection=y;var n;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let T=0;class k{constructor(r){this.id=r,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(r){if(this.map.has(r.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${r.item.extId}`);this.map.set(r.item.extId,r),r.parent||this._roots.add(r)}has(r){return this.map.has(r)}delete(r){const s=this.map.get(r);return s?(this.map.delete(r),this._roots.delete(s),!0):!1}get(r){return this.map.get(r)}comparePositions(r,s){const _=typeof r=="string"?this.map.get(r):r,m=typeof s=="string"?this.map.get(s):s;if(!_||!m)return 0;if(_===m)return 3;for(let b=this.map.get(m.parent);b;b=this.map.get(b.parent))if(b===_)return 1;for(let b=this.map.get(_.parent);b;b=this.map.get(b.parent))if(b===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=k;class h{constructor(r,s){this.testIdToInternal=r,this.publishDiff=s,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new C.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(r,s){this.addItem(r,s,null)}getTestByReference(r){return this.testItemToInternal.get(r)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const s=this.diff[this.diff.length-1];if(s&&r[0]===1){if(s[0]===1&&s[1].extId===r[1].extId){(0,D.applyTestItemUpdate)(s[1],r[1]);return}if(s[0]===0&&s[1].item.extId===r[1].extId){(0,D.applyTestItemUpdate)(s[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,s){var _;const m=this.testIdToInternal.object.get(r);if(!!m){if((m.expandLevels===void 0||s>m.expandLevels)&&(m.expandLevels=s),m.expand===1){const b=this.refreshChildren(m);return b.isSettled?this.expandChildren(m,s-1):b.p.then(()=>this.expandChildren(m,s-1))}else if(m.expand===3)return((_=m.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?m.initialExpand.p.then(()=>this.expandChildren(m,s-1)):this.expandChildren(m,s-1)}}dispose(){var r;for(const s of this.testItemToInternal.values())(r=s.discoverCts)===null||r===void 0||r.dispose(!0),s.actual[S.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(r,s,_){if(!(r instanceof S.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);if(this.testItemToInternal.has(r))throw new Error(`Attempted to add a single TestItem ${r.id} multiple times to the tree`);if(this.testIdToInternal.object.has(r.id))throw new Error(`Attempted to insert a duplicate test item ID ${r.id}`);const m=_?_.item.extId:null,b=r.expandable?1:0,v=_==null?void 0:_.expandLevels,d={provider:s,tree:this.testIdToInternal.object.id},u={actual:r,parent:m,item:A.TestItem.from(r),expandLevels:v&&b===1?v-1:void 0,expand:b,src:d};this.testIdToInternal.object.add(u),this.testItemToInternal.set(r,u),this.pushDiff([0,{parent:m,src:d,expand:b,item:u.item}]),r[S.TestItemHookProperty]={created:t=>this.addItem(t,s,u),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:r.id,item:{[t]:t==="range"?A.Range.from(i):i}}])};for(const t of r.children)this.addItem(t,s,u)}expandChildren(r,s){if(!(s<0)){const _=[...r.actual.children].map(m=>this.expand(m.id,s-1)).filter(C.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(r){r.discoverCts&&r.discoverCts.dispose(!0),r.expand=2,r.discoverCts=new P.CancellationTokenSource,this.pushExpandStateUpdate(r);const s=new C.DeferredPromise;return r.initialExpand=s,r.actual.discoverChildren({report:_=>{_.busy?(r.expand=2,this.pushExpandStateUpdate(r)):(r.expand=3,s.isSettled||s.complete(),this.pushExpandStateUpdate(r))}},r.discoverCts.token),s}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.actual.id,expand:r.expand}])}removeItembyId(r){var s;this.pushDiff([2,r]);const _=[this.testIdToInternal.object.get(r)];for(;_.length;){const m=_.pop();if(!!m){(s=m.discoverCts)===null||s===void 0||s.dispose(!0),this.testIdToInternal.object.delete(m.item.extId),this.testItemToInternal.delete(m.actual);for(const b of m.actual.children)_.push(this.testIdToInternal.object.get(b.id))}}}flushDiff(){const r=this.collectDiff();r.length&&this.publishDiff(r)}}e.SingleUseTestCollection=h}),define(ve[182],_e([0,1,26,3,12]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=A;class S{constructor(T){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${E.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(h=>k.add(E.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>k.has(E.ExtensionIdentifier.toKey(h.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const h=S._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(h.map(f=>f.identifier)),k.length>0){const f=new Set;k.forEach(r=>f.add(E.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!f.has(E.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(h)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,m){this.addNode(_),this.addNode(m),this._arcs.has(_)?this._arcs.get(_).push(m):this._arcs.set(_,[m])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,m){const b=k.getArcs(_);for(let v=0;v<b.length;v++)if(!m.has(b[v]))return!1;return!0}getNodes(){return this._nodesArr}};let h=new Map;for(let _ of T){const m=E.ExtensionIdentifier.toKey(_.identifier);if(h.set(m,_),_.extensionDependencies)for(let b of _.extensionDependencies){const v=E.ExtensionIdentifier.toKey(b);k.addArc(m,v)}}let f=new Set;k.getNodes().filter(_=>k.getArcs(_).length===0).forEach(_=>f.add(_));let r=k.getNodes().filter(_=>!f.has(_)),s;do{s=!1;for(let _=0;_<r.length;_++){const m=r[_];k.hasOnlyGoodArcs(m,f)&&(r.splice(_,1),_--,f.add(m),s=!0)}}while(s);return r.map(_=>h.get(_))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(E.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=S;var D;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(D||(D={}));function y(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,h=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==h)return k-h;const f=P.posix.basename(n.extensionLocation.path),r=P.posix.basename(T.extensionLocation.path);return f<r?-1:f>r?1:0}}),define(ve[183],_e([0,1,23]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var C;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function A(D){const y=E.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function S(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(ve[33],_e([0,1,3,2,4,26,149]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class D{constructor(b){this.dependency=b}}e.MissingDependencyError=D;var y;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(b,v,d,u){this.codeLoadingTime=b,this.activateCallTime=v,this.activateResolvedTime=d,this.activationReason=u}}e.ActivationTimes=n;class T{constructor(b,v){this.description=b,this.value=v}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function h(m){m.enableProposedApi||f(m)}e.checkProposedApiEnabled=h;function f(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=f;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function s(m){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=s;class _{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(b){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(b,v){}_activateById(b,v){return Promise.resolve()}_onWillActivateExtension(b){}_onDidActivateExtension(b,v,d,u,t){}_onExtensionRuntimeError(b,v){}_onExtensionHostExit(b){}}e.NullExtensionService=_}),define(ve[184],_e([0,1,130,26,33,19]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class D{constructor(s,_,m,b){this.startup=s,this.codeLoadingTime=_,this.activateCallTime=m,this.activateResolvedTime=b}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,_){return s===-1||_===-1?-1:_-s}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(s,_,m,b,v,d){this.activationFailed=s,this.activationFailedError=_,this.activationTimes=m,this.module=b,this.exports=v,this.subscriptions=d}}e.ActivatedExtension=n;class T extends n{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class h extends n{constructor(s){super(!0,s,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=h;let f=class{constructor(s,_,m,b,v){this._logService=v,this._registry=s,this._resolvedExtensionsSet=new Set,_.forEach(d=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,m.forEach(d=>this._hostExtensionsMap.set(C.ExtensionIdentifier.toKey(d),d)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(s){const _=C.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(_)}getActivatedExtension(s){const _=C.ExtensionIdentifier.toKey(s),m=this._activatedExtensions.get(_);if(!m)throw new Error("Extension `"+s.value+"` is not known or not activated");return m}activateByEvent(s,_){if(this._alreadyActivatedEvents[s])return S;const m=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(m.map(b=>({id:b.identifier,reason:{startup:_,extensionId:b.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,_){const m=this._registry.getExtensionDescription(s);if(!m)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:m.identifier,reason:_}])}_handleActivateRequest(s,_,m){if(this._hostExtensionsMap.has(C.ExtensionIdentifier.toKey(s.id))){_[C.ExtensionIdentifier.toKey(s.id)]=s;return}const b=this._registry.getExtensionDescription(s.id);if(!b){this._host.onExtensionActivationError(s.id,new P.MissingDependencyError(s.id.value));const u=new Error(`Unknown dependency '${s.id.value}'`);this._activatedExtensions.set(C.ExtensionIdentifier.toKey(s.id),new h(u));return}const v=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let d=!0;for(let u=0,t=v.length;u<t;u++){const i=v[u];if(!this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(i))){const c=this._activatedExtensions.get(C.ExtensionIdentifier.toKey(i));if(!(c&&!c.activationFailed)){if(c&&c.activationFailed){this._host.onExtensionActivationError(b.identifier,E.localize(0,null,b.displayName||b.identifier.value,i));const o=new Error(`Dependency ${i} failed to activate`);o.detail=c.activationFailedError,this._activatedExtensions.set(C.ExtensionIdentifier.toKey(b.identifier),new h(o));return}if(this._hostExtensionsMap.has(C.ExtensionIdentifier.toKey(i))){d=!1,_[C.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(C.ExtensionIdentifier.toKey(i)),reason:s.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){d=!1,_[C.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:s.reason};continue}this._host.onExtensionActivationError(b.identifier,new P.MissingDependencyError(i));const l=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(C.ExtensionIdentifier.toKey(b.identifier),new h(l));return}}}d?_[C.ExtensionIdentifier.toKey(b.identifier)]=s:m.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(v=>!this._activatedExtensions.has(C.ExtensionIdentifier.toKey(v.id))),s.length===0))return Promise.resolve(void 0);const _=Object.create(null),m=[];for(let v=0,d=s.length;v<d;v++)this._handleActivateRequest(s[v],_,m);for(let v=0,d=m.length;v<d;v++){const u=C.ExtensionIdentifier.toKey(m[v].id);_[u]&&delete _[u]}const b=Object.keys(_).map(v=>_[v]);return m.length===0?Promise.all(b.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(b).then(v=>this._activateExtensions(m))}_activateExtension(s,_){const m=C.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const b=this._activatingExtensions.get(m);if(b)return b;const v=this._host.actualActivateExtension(s,_).then(void 0,d=>(this._host.onExtensionActivationError(s,E.localize(1,null,s.value,d.message)),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(d),new h(d))).then(d=>{this._activatedExtensions.set(m,d),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,v),v}};f=qe([Ge(4,A.ILogService)],f),e.ExtensionsActivator=f}),define(ve[185],_e([0,1,10]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,S)=>{this._actualOk=A,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,E.onUnexpectedError)(A))}then(A,S){return this._ensureActual().then(A,S)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=C}),define(ve[97],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const C=[];function P(D){const y=new E(!0,D);return C[y.nid]=y,y}e.createMainContextProxyIdentifier=P;function A(D){const y=new E(!1,D);return C[y.nid]=y,y}e.createExtHostContextProxyIdentifier=A;function S(D){return C[D].sid}e.getStringIdentifierForProxy=S}),define(ve[5],_e([0,1,2,97,58]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var S;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var n;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(n=e.CellKind||(e.CellKind={}));var T;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var h;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(h=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(d){d.name="$ident";function u(i,c){return Object.defineProperty(i,d.name,{value:c,enumerable:!0}),i}d.mixin=u;function t(i){return i[d.name]}d.of=t})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(u){return u._id=r._n++,u}}e.IdObject=r,r._n=0;var s;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(s=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var _;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(_=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(d){if(d&&d.edits)for(const u of d.edits)typeof u.resource=="object"?u.resource=E.URI.revive(u.resource):(u.newUri=E.URI.revive(u.newUri),u.oldUri=E.URI.revive(u.oldUri)),u.metadata&&u.metadata.iconPath&&(u.metadata=(0,P.revive)(u.metadata));return d}e.reviveWorkspaceEditDto=b;var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[72],_e([0,1,5,3,4]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(D){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,n){return this._proxy.$setPassword(D,y,n)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(ve[73],_e([0,1,4,19,5,15]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(P.MainContext.MainThreadTelemetry)}report(y,n,T){const k=this.getUsageKey(y,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=qe([Ge(0,A.IExtHostRpcService),Ge(1,C.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,n){}})}),define(ve[186],_e([0,1,3,5,7,26]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,T,k={}){const h=A.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(h)||[],r=T.sort().join(" ");let s=f.find(_=>_.scopes===r);if(s)return s.result;{const _=this._getSession(y,h,n,T,k);s={scopes:r,result:_},f.push(s),this._inFlightRequests.set(h,f);try{await _}finally{const m=f.findIndex(b=>b.scopes===r);m>-1&&(f.splice(m),this._inFlightRequests.set(h,f))}return _}}async _getSession(y,n,T,k,h={}){await this._proxy.$ensureProvider(T);const f=y.displayName||y.name;return this._proxy.$getSession(T,k,n,f,h)}async removeSession(y,n){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,T,k){var h;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:n});const f=T.onDidChangeSessions(r=>{var s,_,m;this._proxy.$sendDidChangeSessions(y,{added:(s=r.added)!==null&&s!==void 0?s:[],changed:(_=r.changed)!==null&&_!==void 0?_:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(h=k==null?void 0:k.supportsMultipleAccounts)!==null&&h!==void 0?h:!1),new P.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(s=>s.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(h=>h.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(ve[187],_e([0,1,5,15,9]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=P.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=qe([Ge(0,C.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[188],_e([0,1,5]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(A){const S=A.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(D){return S.$writeText(D)}})}}e.ExtHostClipboard=C}),define(ve[74],_e([0,1,13,7,9,24,5,11,19,58,32,38,2,6,4,15]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=i,this.converter=new m(this,c=>{const a=this._apiCommands.get(c);return(a==null?void 0:a.result)===v.Void?a:void 0},i),this._argumentProcessors=[{processArgument(c){return(0,n.revive)(c)}},{processArgument(c){return(0,A.cloneAndChange)(c,function(a){if(T.Range.isIRange(a))return P.Range.to(a);if(k.Position.isIPosition(a))return P.Position.to(a);if(T.Range.isIRange(a.range)&&h.URI.isUri(a.uri))return P.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...c)=>{const a=t.args.map((o,w)=>{if(!o.validate(c[w]))throw new Error(`Invalid argument '${o.name}' when running '${t.id}', received: ${c[w]}`);return o.convert(c[w])}),l=await this.executeCommand(t.internalId,...a);return t.result.convert(l,c,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new C.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,c,a,l){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:c,thisArg:a,description:l}),t&&this._proxy.$registerCommand(i),new C.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,c){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const a=(0,A.cloneAndChange)(i,function(l){if(l instanceof C.Position)return P.Position.from(l);if(l instanceof C.Range)return P.Range.from(l);if(l instanceof C.Location)return P.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,a,c);return(0,n.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw l}}}async _executeContributedCommand(t,i){const c=this._commands.get(t);if(!c)throw new Error("Unknown command");let{callback:a,thisArg:l,description:o}=c;if(o)for(let w=0;w<o.args.length;w++)try{(0,E.validateConstraint)(i[w],o.args[w].constraint)}catch(I){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${o.args[w].name}' - ${o.args[w].description}`)}try{return await a.apply(l,i)}catch(w){if(t===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...i);I&&(t=I.command)}throw this._logService.error(w,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(c=>this._argumentProcessors.reduce((a,l)=>l.processArgument(a),c)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(c=>c[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,c]of this._commands){let{description:a}=c;a&&(t[i]=a)}return Promise.resolve(t)}};_=qe([Ge(0,s.IExtHostRpcService),Ge(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,i,c){this._commands=t,this._lookupApiCommand=i,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const c={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return c;const a=this._lookupApiCommand(t.command);if(a)c.id=a.internalId,c.arguments=a.args.map((l,o)=>l.convert(t.arguments&&t.arguments[o]));else if((0,D.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),i.add((0,f.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),c.$ident=l,c.id=this.delegatingCommandId,c.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return c}}fromInternal(t){const i=S.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class b{constructor(t,i,c,a){this.name=t,this.description=i,this.validate=c,this.convert=a}optional(){return new b(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new b(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",u=>h.URI.isUri(u),u=>u),b.Position=new b("position","A position in a text document",u=>C.Position.isPosition(u),P.Position.from),b.Range=new b("range","A range in a text document",u=>C.Range.isRange(u),P.Range.from),b.Selection=new b("selection","A selection in a text document",u=>C.Selection.isSelection(u),P.Selection.from),b.Number=new b("number","",u=>typeof u=="number",u=>u),b.String=new b("string","",u=>typeof u=="string",u=>u),b.CallHierarchyItem=new b("item","A call hierarchy item",u=>u instanceof C.CallHierarchyItem,P.CallHierarchyItem.to);class v{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=v,v.Void=new v("no result",u=>u);class d{constructor(t,i,c,a,l){this.id=t,this.internalId=i,this.description=c,this.args=a,this.result=l}}e.ApiCommand=d}),define(ve[189],_e([0,1,6,9,7,63,74,167,11,85]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",h(C.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(r,s)=>{if(!(0,y.isFalsyOrEmpty)(r)){class _ extends P.SymbolInformation{static to(b){const v=new _(b.name,C.SymbolKind.to(b.kind),b.containerName||"",new P.Location(s[0],C.Range.to(b.range)));return v.detail=b.detail,v.range=v.location.range,v.selectionRange=C.Range.to(b.selectionRange),v.children=b.children?b.children.map(_.to):[],v}}return r.map(_.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(C.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",h(C.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",h(C.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>P.Position.isPosition(s)),r=>r.map(C.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(s=>{let _;for(const m of s.reverse())_=new P.SelectionRange(C.Range.to(m),_);return _}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const s=[];if(Array.isArray(r))for(let _ of r)s.push(..._[1].map(C.WorkspaceSymbol.to));return s})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(C.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(C.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(C.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return C.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(C.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new P.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const s=(0,n.decodeSemanticTokensDto)(r);if(s.type==="full")return new P.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new P.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const s=(0,n.decodeSemanticTokensDto)(r);if(s.type==="full")return new P.SemanticTokens(s.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,s,_)=>{if(!r)return new P.CompletionList([]);const m=r.suggestions.map(b=>C.CompletionItem.to(b,_));return new P.CompletionList(m,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return C.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,s,_)=>h(m=>new P.CodeLens(C.Range.to(m.range),m.command&&_.fromInternal(m.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>P.Range.isRange(r),r=>P.Selection.isSelection(r)?C.Selection.from(r):C.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,s,_)=>h(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(m.command)}else{const b=new P.CodeAction(m.title,m.kind?new P.CodeActionKind(m.kind):void 0);return m.edit&&(b.edit=C.WorkspaceEdit.to(m.edit)),m.command&&(b.command=_.fromInternal(m.command)),b.isPreferred=m.isPreferred,b}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new P.ColorInformation(C.Range.to(s.range),C.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof P.Color,C.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:C.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(C.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(C.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",h(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientMetadata},filenamePattern:r.filenamePattern.map(s=>C.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(C.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class k{constructor(s){this._disposables=new E.DisposableStore,this._commands=s}static register(s){return T.forEach(s.registerApiCommand,s),new k(s).registerCommands()}registerCommands(){const s=_=>(...m)=>_(this._commands,...m);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,s(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:_=>typeof _=="string"}]}),this._register(D.OpenIssueReporter.ID,s(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:_=>typeof _=="string"||typeof _=="object"&&typeof _.extensionId=="string"}]})}_register(s,_,m){const b=this._commands.registerCommand(!1,s,_,this,m);this._disposables.add(b)}}e.ExtHostApiCommands=k;function h(r){return s=>{if(Array.isArray(s))return s.map(r)}}function f(r){if(!!Array.isArray(r)){const s=[];for(const _ of r)A.isLocationLink(_)?s.push(C.DefinitionLink.to(_)):s.push(C.location.to(_));return s}}}),define(ve[190],_e([0,1,14,52,3,6,2,63,26,9,7,5]),function(ee,e,E,C,P,A,S,D,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class h{constructor(d,u,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(k.MainContext.MainThreadComments),u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const a=c.getCommentThread(i.commentThreadHandle);return a||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const a=c.getCommentThread(i.thread.commentThreadHandle);return a?{thread:a,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const a=c.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let l=i.commentUniqueId,o=a.getCommentByUniqueId(l);return o||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const a=c.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let l=i.text,o=i.commentUniqueId,w=a.getCommentByUniqueId(o);return w?(w.body=l,w):i}return i}})}createCommentController(d,u,t){const i=h.handlePool++,c=new r(d,i,this._proxy,u,t);this._commentControllers.set(c.handle,c);const a=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(d.identifier))||[];return a.push(c),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(d.identifier),a),c}$createCommentThreadTemplate(d,u,t){const i=this._commentControllers.get(d);!i||i.$createCommentThreadTemplate(u,t)}async $updateCommentThreadTemplate(d,u,t){const i=this._commentControllers.get(d);!i||i.$updateCommentThreadTemplate(u,t)}$deleteCommentThread(d,u){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(u)}$provideCommentingRanges(d,u,t){const i=this._commentControllers.get(d);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const c=this._documents.getDocument(S.URI.revive(u));return(0,E.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(c,t)).then(a=>a?a.map(l=>n.Range.from(l)):void 0)}$toggleReaction(d,u,t,i,c){const a=this._commentControllers.get(d);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const l=a.getCommentThread(u);if(l){const o=l.getCommentByUniqueId(i.uniqueIdInThread);if(a!==void 0&&o&&a.reactionHandler)return a.reactionHandler(o,m(c))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=h,h.handlePool=0;class f{constructor(d,u,t,i,c,a,l){this._proxy=d,this._commentController=u,this._id=t,this._uri=i,this._range=c,this._comments=a,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${u.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),u={};d("range")&&(u.range=n.Range.from(this._range)),d("label")&&(u.label=this.label),d("contextValue")&&(u.contextValue=this.contextValue),d("comments")&&(u.comments=this._comments.map(t=>s(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(u.collapseState=b(this._collapseState)),d("canReply")&&(u.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,u)}}getCommentByUniqueId(d){for(let u of this._commentsMap){let t=u[0],i=u[1];if(d===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,qe([(0,C.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class r{constructor(d,u,t,i,c){this._extension=d,this._handle=u,this._proxy=t,this._id=i,this._label=c,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,c)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,u,t,i){if(typeof d=="string"){const c=new f(this._proxy,this,d,u,t,i,this._extension.identifier);return this._threads.set(c.handle,c),c}else{const c=new f(this._proxy,this,void 0,d,u,t,this._extension.identifier);return this._threads.set(c.handle,c),c}}$createCommentThreadTemplate(d,u){const t=new f(this._proxy,this,void 0,S.URI.revive(d),n.Range.to(u),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,u){let t=this._threads.get(d);t&&(t.range=n.Range.to(u))}$deleteCommentThread(d){let u=this._threads.get(d);u&&u.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function s(v,d,u,t){let i=t.get(u);i||(i=++v.commentHandle,t.set(u,i));const c=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(u.body),userName:u.author.name,userIconPath:c,label:u.label,commentReactions:u.reactions?u.reactions.map(a=>_(a)):void 0}}function _(v){return{label:v.label,iconPath:v.iconPath?n.pathOrURIToURI(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function m(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?S.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function b(v){if(v!==void 0)switch(v){case T.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(ve[98],_e([0,1,2,5,7,4,15,19,11,8,12]),function(ee,e,E,C,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class cn{constructor(f,r){this._logService=r,this._provider=new Map,this._proxy=f.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,r){const s=cn._handlePool++;this._provider.set(s,{provider:f,extensionId:r}),this._proxy.$registerDecorationProvider(s,r.value);const _=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(s,null);return}let b=(0,y.asArray)(m);if(b.length<=cn._maxEventSize){this._proxy.$onDidChange(s,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,b.length);const v=b.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),d=(0,y.groupBy)(v,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let u=[];e:for(let t of d){let i;for(let c of t){let a=(0,T.dirname)(c.uri.path);if(i!==a&&(i=a,u.push(c.uri)>=cn._maxEventSize))break e}}this._proxy.$onDidChange(s,u)});return new P.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(f,r,s){if(!this._provider.has(f))return Object.create(null);const _=Object.create(null),{provider:m,extensionId:b}=this._provider.get(f);return await Promise.all(r.map(async v=>{try{const{uri:d,id:u}=v,t=await Promise.resolve(m.provideFileDecoration(E.URI.revive(d),s));if(!t)return;try{P.FileDecoration.validate(t),_[u]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${b.value}': ${i}`)}}catch(d){this._logService.error(d)}})),_}};k._handlePool=0,k._maxEventSize=250,k=qe([Ge(0,S.IExtHostRpcService),Ge(1,D.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ve[191],_e([0,1,129,88,2,5,7,9,3,19,22]),function(ee,e,E,C,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(r,s,_,m,b){this._name=r,this._owner=s,this._maxDiagnosticsPerFile=_,this._proxy=m,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,s){if(!r){this.clear();return}this._checkDisposed();let _=[];if(P.URI.isUri(r)){if(!s){this.delete(r);return}this._data.set(r,s.slice()),_=[r]}else if(Array.isArray(r)){_=[];let b;r=[...r].sort(k._compareIndexedTuplesByUri);for(const v of r){const[d,u]=v;if((!b||d.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=d,_.push(d),this._data.set(d,[])),u){const t=this._data.get(d);t&&t.push(...u)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!!this._proxy){const m=[];for(let b of _){let v=[];const d=this._data.get(b);if(d)if(d.length>this._maxDiagnosticsPerFile){v=[];const u=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of d)if(i.severity===u[t]&&v.push(D.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;v.push({severity:C.MarkerSeverity.Info,message:(0,E.localize)(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:v[v.length-1].startLineNumber,startColumn:v[v.length-1].startColumn,endLineNumber:v[v.length-1].endLineNumber,endColumn:v[v.length-1].endColumn})}else v=d.map(u=>D.Diagnostic.from(u));m.push([b,v])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,s){this._checkDisposed();for(let _ of this._data.keys())r.apply(s,[_,this.get(_),this])}get(r){this._checkDisposed();const s=this._data.get(r);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,s){return r[0].toString()<s[0].toString()?-1:r[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=k;let h=class Bt{constructor(r,s){this._logService=s,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Bt._debouncer,50),Bt._mapper),this._proxy=r.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(r,s){return r?r.concat(s):s}static _mapper(r){const s=[],_=new Set;for(const m of r)typeof m=="string"?_.has(m)||(_.add(m),s.push(P.URI.parse(m))):_.has(m.toString())||(_.add(m.toString()),s.push(m));return Object.freeze(s),{uris:s}}createDiagnosticCollection(r,s){const{_collections:_,_proxy:m,_onDidChangeDiagnostics:b,_logService:v}=this,d=new class{$changeMany(i,c){m.$changeMany(i,c),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,c.length===0?"CLEARING":c)}$clear(i){m.$clear(i),v.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){m.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+Bt._idPool++,u=s;else if(!_.has(s))u=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+Bt._idPool++;while(_.has(u))}return new class extends k{constructor(){super(s,u,Bt._maxDiagnosticsPerFile,d,b);_.set(u,this)}dispose(){super.dispose(),_.delete(u)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const s=new Map,_=[];for(const m of this._collections.values())m.forEach((b,v)=>{let d=s.get(b.toString());typeof d=="undefined"&&(d=_.length,s.set(b.toString(),d),_.push([b,[]])),_[d][1]=_[d][1].concat(...v)});return _}}_getDiagnostics(r){let s=[];for(let _ of this._collections.values())_.has(r)&&(s=s.concat(_.get(r)));return s}$acceptMarkersChange(r){if(!this._mirrorCollection){const s="_generated_mirror",_=new k(s,s,Bt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(s,_),this._mirrorCollection=_}for(const[s,_]of r)this._mirrorCollection.set(P.URI.revive(s),_.map(D.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=qe([Ge(1,n.ILogService)],h),e.ExtHostDiagnostics=h}),define(ve[192],_e([0,1,2,5]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(S){this._proxy=S.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(D=>D?D.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(D=>D?E.URI.revive(D):void 0)}}e.ExtHostDialogs=P}),define(ve[193],_e([0,1,10,2,7,5,18,20,8]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,h,f){this._documentsAndEditors=h,this._logService=f,this._documentContentProviders=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,h){if(Object.keys(S.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,h),this._proxy.$registerTextContentProvider(f,k);let r;return typeof h.onDidChange=="function"&&(r=h.onDidChange(s=>{if(s.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(f,s).then(_=>{if(!(!_&&typeof _!="string")){const m=this._documentsAndEditors.getDocument(s);if(!!m){const b=(0,y.splitLines)(_);if(!m.equalLines(b))return this._proxy.$onVirtualDocumentChange(s,_)}}},E.onUnexpectedError)})),new P.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(k,h){const f=this._documentContentProviders.get(k);return f?Promise.resolve(f.provideTextDocumentContent(C.URI.revive(h),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(ve[194],_e([0,1,3,6,2,5,94,9,13,24]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(h,f){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const s of r)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const s of r)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!!h){const f=this._documentsAndEditors.getDocument(h);if(f)return f}}getDocument(h){const f=this.getDocumentData(h);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${h}'`);return f.document}ensureDocumentData(h){const f=this._documentsAndEditors.getDocument(h);if(f)return Promise.resolve(f);let r=this._documentLoader.get(h.toString());return r||(r=this._proxy.$tryOpenDocument(h).then(s=>{this._documentLoader.delete(h.toString());const _=P.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(_))},s=>(this._documentLoader.delete(h.toString()),Promise.reject(s))),this._documentLoader.set(h.toString(),r)),r}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(f=>P.URI.revive(f))}$acceptModelModeChanged(h,f){const r=P.URI.revive(h),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(f),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(h){const f=P.URI.revive(h),r=this._documentsAndEditors.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(h,f){const r=P.URI.revive(h),s=this._documentsAndEditors.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this._onDidChangeDocument.fire({document:s.document,contentChanges:[]})}$acceptModelChanged(h,f,r){const s=P.URI.revive(h),_=this._documentsAndEditors.getDocument(s);if(!_)throw new Error("unknown document");_._acceptIsDirty(r),_.onEvents(f),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:_.document,contentChanges:f.changes.map(m=>({range:D.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(h,f){(0,S.setWordDefinitionFor)(h,f)}}e.ExtHostDocuments=T}),define(ve[39],_e([0,1,42,3,6,2,4,5,94,15,96,9,19,22,18,55,106]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(d,u){this._extHostRpc=d,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const u=[],t=[],i=[];if(d.removedDocuments)for(const c of d.removedDocuments){const a=A.URI.revive(c),l=this._documents.get(a);(l==null?void 0:l.unref())&&(this._documents.delete(a),u.push(l.value))}if(d.addedDocuments)for(const c of d.addedDocuments){const a=A.URI.revive(c.uri);let l=this._documents.get(a);if(l&&a.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);l||(l=new m(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),a,c.lines,c.EOL,c.versionId,c.modeId,c.isDirty,c.notebook)),this._documents.set(a,l),t.push(l.value)),l.ref()}if(d.removedEditors)for(const c of d.removedEditors){const a=this._editors.get(c);this._editors.delete(c),a&&i.push(a)}if(d.addedEditors)for(const c of d.addedEditors){const a=A.URI.revive(c.documentUri);E.ok(this._documents.has(a),`document '${a}' does not exist`),E.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const l=this._documents.get(a).value,o=new T.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>l.document),c.selections.map(k.Selection.to),c.options,c.visibleRanges.map(w=>k.Range.to(w)),typeof c.editorPosition=="number"?k.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,o)}d.newActiveEditor!==void 0&&(E.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,P.dispose)(u),(0,P.dispose)(i),d.removedDocuments&&this._onDidRemoveDocuments.fire(u),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var u;return(u=this._documents.get(d))===null||u===void 0?void 0:u.value}allDocuments(){return s.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!!this._activeEditorId){const u=this._editors.get(this._activeEditorId);return d?u:u==null?void 0:u.value}}allEditors(){return[...this._editors.values()]}};b=qe([Ge(0,n.IExtHostRpcService),Ge(1,h.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[195],_e([0,1,2,5,6,7,9,116,8,23]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const r=this._schemes.indexOf(f);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),r=[];let s,_,m=14,b=14;for(const v of f){let d=s?(0,y.commonPrefixLength)(s,v):0;for(d===0?_=1:_=b;d<v.length;d++)d+1===v.length?(m=b,b=9):b+=1,r.push([_,v.toUpperCase().charCodeAt(d),b]),r.push([_,v.toLowerCase().charCodeAt(d),b]),_=b;s=v,b=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(f){this._initStateMachine();const r=[],s=D.LinkComputer.computeLinks({getLineContent(_){return f.lineAt(_-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const _ of s){const m=S.DocumentLink.to(_);m.target&&r.push(m)}return r}}class k{constructor(f,r){this._extHostLanguageFeatures=r,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,r,s,_={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,s);let b=2;_.isCaseSensitive&&(b+=1024),_.isReadonly&&(b+=2048),typeof s.copy=="function"&&(b+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(m,r,b).catch(d=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${r}`),console.error(d)});const v=s.onDidChangeFile(d=>{const u=[];for(const t of d){let{uri:i,type:c}=t;if(i.scheme===r){let a;switch(c){case A.FileChangeType.Changed:a=0;break;case A.FileChangeType.Created:a=1;break;case A.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:i,type:a})}}this._proxy.$onFileSystemChange(m,u)});return(0,P.toDisposable)(()=>{v.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(f){const{type:r,ctime:s,mtime:_,size:m}=f;return{type:r,ctime:s,mtime:_,size:m}}$stat(f,r){return Promise.resolve(this._getFsProvider(f).stat(E.URI.revive(r))).then(k._asIStat)}$readdir(f,r){return Promise.resolve(this._getFsProvider(f).readDirectory(E.URI.revive(r)))}$readFile(f,r){return Promise.resolve(this._getFsProvider(f).readFile(E.URI.revive(r))).then(s=>n.VSBuffer.wrap(s))}$writeFile(f,r,s,_){return Promise.resolve(this._getFsProvider(f).writeFile(E.URI.revive(r),s.buffer,_))}$delete(f,r,s){return Promise.resolve(this._getFsProvider(f).delete(E.URI.revive(r),s))}$rename(f,r,s,_){return Promise.resolve(this._getFsProvider(f).rename(E.URI.revive(r),E.URI.revive(s),_))}$copy(f,r,s,_){const m=this._getFsProvider(f);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(E.URI.revive(r),E.URI.revive(s),_))}$mkdir(f,r){return Promise.resolve(this._getFsProvider(f).createDirectory(E.URI.revive(r)))}$watch(f,r,s,_){const m=this._getFsProvider(f).watch(E.URI.revive(s),_);this._watches.set(r,m)}$unwatch(f,r){const s=this._watches.get(r);s&&(s.dispose(),this._watches.delete(r))}$open(f,r,s){const _=this._getFsProvider(f);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(E.URI.revive(r),s))}$close(f,r){const s=this._getFsProvider(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(f,r,s,_){const m=this._getFsProvider(f);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const b=n.VSBuffer.alloc(_);return Promise.resolve(m.read(r,s,b.buffer,0,_)).then(v=>b.slice(0,v))}$write(f,r,s,_){const m=this._getFsProvider(f);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,s,_.buffer,0,_.byteLength))}_getFsProvider(f){const r=this._fsProvider.get(f);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.ExtHostFileSystem=k}),define(ve[75],_e([0,1,5,65,7,23,4,15,48]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Lt{constructor(k,h){const f=k.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return f.$stat(r).catch(Lt._handleError)},readDirectory(r){return f.$readdir(r).catch(Lt._handleError)},createDirectory(r){return f.$mkdir(r).catch(Lt._handleError)},async readFile(r){return f.$readFile(r).then(s=>s.buffer).catch(Lt._handleError)},writeFile(r,s){return f.$writeFile(r,A.VSBuffer.wrap(s)).catch(Lt._handleError)},delete(r,s){return f.$delete(r,Object.assign({recursive:!1,useTrash:!1},s)).catch(Lt._handleError)},rename(r,s,_){return f.$rename(r,s,Object.assign({overwrite:!1},_)).catch(Lt._handleError)},copy(r,s,_){return f.$copy(r,s,Object.assign({overwrite:!1},_)).catch(Lt._handleError)},isWritableFileSystem(r){const s=h.getCapabilities(r);if(typeof s=="number")return!(s&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new P.FileSystemError(String(k));if(k.name==="ENOPRO")throw P.FileSystemError.Unavailable(k.message);switch(k.name){case C.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(k.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(k.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(k.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(k.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(k.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(k.message);default:throw new P.FileSystemError(k.message,k.name)}}};n=qe([Ge(0,D.IExtHostRpcService),Ge(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[196],_e([0,1,6,5]),function(ee,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(S){this._handlePool=0,this._proxy=S.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,S),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=P}),define(ve[197],_e([0,1,2,24,9,7,14,5,8,32,11,13,113,6,85,54,68,56,10]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class v{constructor(U,K){this._documents=U,this._provider=K}provideDocumentSymbols(U,K){const ne=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(ne,K)).then(le=>{if(!(0,T.isFalsyOrEmpty)(le))return le[0]instanceof A.DocumentSymbol?le.map(P.DocumentSymbol.from):v._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(U){var K;U=U.slice(0).sort((fe,De)=>{let Oe=fe.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(fe.location.range.end)),Oe});const ne=[],le=[];for(const fe of U){const De={name:fe.name||"!!MISSING: name!!",kind:P.SymbolKind.from(fe.kind),tags:((K=fe.tags)===null||K===void 0?void 0:K.map(P.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:P.Range.from(fe.location.range),selectionRange:P.Range.from(fe.location.range),children:[]};for(;;){if(le.length===0){le.push(De),ne.push(De);break}const Oe=le[le.length-1];if(n.Range.containsRange(Oe.range,De.range)&&!n.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),le.push(De);break}le.pop()}}return ne}}class d{constructor(U,K,ne){this._documents=U,this._commands=K,this._provider=ne,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,K){const ne=this._documents.getDocument(U),le=await this._provider.provideCodeLenses(ne,K);if(!(!le||K.isCancellationRequested)){const fe=this._cache.add(le),De=new f.DisposableStore;this._disposables.set(fe,De);const Oe={cacheId:fe,lenses:[]};for(let me=0;me<le.length;me++)Oe.lenses.push({cacheId:[fe,me],range:P.Range.from(le[me].range),command:this._commands.toInternal(le[me].command,De)});return Oe}}async resolveCodeLens(U,K){var ne;const le=U.cacheId&&this._cache.get(...U.cacheId);if(!!le){let fe;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?fe=le:fe=await this._provider.resolveCodeLens(le,K),fe||(fe=le),!K.isCancellationRequested){const De=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!De)return U.command=this._commands.toInternal((ne=fe.command)!==null&&ne!==void 0?ne:d._badCmd,De),U}}}releaseCodeLenses(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function u(ze){return Array.isArray(ze)?ze.map(P.DefinitionLink.from):ze?[P.DefinitionLink.from(ze)]:[]}class t{constructor(U,K){this._documents=U,this._provider=K}provideDefinition(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDefinition(le,fe,ne)).then(u)}}class i{constructor(U,K){this._documents=U,this._provider=K}provideDeclaration(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDeclaration(le,fe,ne)).then(u)}}class c{constructor(U,K){this._documents=U,this._provider=K}provideImplementation(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideImplementation(le,fe,ne)).then(u)}}class a{constructor(U,K){this._documents=U,this._provider=K}provideTypeDefinition(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(le,fe,ne)).then(u)}}class l{constructor(U,K){this._documents=U,this._provider=K}provideHover(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideHover(le,fe,ne)).then(De=>{if(!(!De||(0,T.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=le.getWordRangeAtPosition(fe)),De.range||(De.range=new A.Range(fe,fe)),P.Hover.from(De)})}}class o{constructor(U,K){this._documents=U,this._provider=K}provideEvaluatableExpression(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(le,fe,ne)).then(De=>{if(De)return P.EvaluatableExpression.from(De)})}}class w{constructor(U,K){this._documents=U,this._provider=K}provideInlineValues(U,K,ne,le){const fe=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideInlineValues(fe,P.Range.to(K),P.InlineValueContext.to(ne),le)).then(De=>{if(Array.isArray(De))return De.map(Oe=>P.InlineValue.from(Oe))})}}class I{constructor(U,K){this._documents=U,this._provider=K}provideDocumentHighlights(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(le,fe,ne)).then(De=>{if(Array.isArray(De))return De.map(P.DocumentHighlight.from)})}}class p{constructor(U,K){this._documents=U,this._provider=K}provideLinkedEditingRanges(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,fe,ne)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,T.coalesce)(De.ranges.map(P.Range.from)),wordPattern:De.wordPattern}})}}class g{constructor(U,K){this._documents=U,this._provider=K}provideReferences(U,K,ne,le){const fe=this._documents.getDocument(U),De=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideReferences(fe,De,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(P.location.from)})}}class R{constructor(U,K,ne,le,fe,De,Oe){this._documents=U,this._commands=K,this._diagnostics=ne,this._provider=le,this._logService=fe,this._extension=De,this._apiDeprecation=Oe,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(U,K,ne,le){const fe=this._documents.getDocument(U),De=h.Selection.isISelection(K)?P.Selection.to(K):P.Range.to(K),Oe=[];for(const Ce of this._diagnostics.getDiagnostics(U))if(De.intersection(Ce.range)&&Oe.push(Ce)>R._maxCodeActionsPerFile)break;const me={diagnostics:Oe,only:ne.only?new A.CodeActionKind(ne.only):void 0,triggerKind:P.CodeActionTriggerKind.to(ne.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(fe,De,me,le)).then(Ce=>{var Ae;if(!(!(0,T.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const $e=this._cache.add(Ce),be=new f.DisposableStore;this._disposables.set($e,be);const Ke=[];for(let V=0;V<Ce.length;V++){const X=Ce[V];!X||(R._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,be)})):(me.only&&(X.kind?me.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[$e,V],title:X.title,command:X.command&&this._commands.toInternal(X.command,be),diagnostics:X.diagnostics&&X.diagnostics.map(P.Diagnostic.from),edit:X.edit&&P.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:(Ae=X.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:$e,actions:Ke}}})}async resolveCodeAction(U,K){var ne;const[le,fe]=U,De=this._cache.get(le,fe);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(ne=await this._provider.resolveCodeAction(De,K))!==null&&ne!==void 0?ne:De;return(Oe==null?void 0:Oe.edit)?P.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}R._maxCodeActionsPerFile=1e3;class F{constructor(U,K){this._documents=U,this._provider=K}provideDocumentFormattingEdits(U,K,ne){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,K,ne)).then(fe=>{if(Array.isArray(fe))return fe.map(P.TextEdit.from)})}}class ${constructor(U,K){this._documents=U,this._provider=K}provideDocumentRangeFormattingEdits(U,K,ne,le){const fe=this._documents.getDocument(U),De=P.Range.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,De,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)})}}class ue{constructor(U,K){this._documents=U,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(U,K,ne,le,fe){const De=this._documents.getDocument(U),Oe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,ne,le,fe)).then(me=>{if(Array.isArray(me))return me.map(P.TextEdit.from)})}}class z{constructor(U,K){this._provider=U,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(U,K){const ne=D.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(U,K)).then(le=>{if((0,T.isNonEmptyArray)(le)){for(const fe of le)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const De=D.IdObject.mixin(P.WorkspaceSymbol.from(fe));this._symbolCache.set(De._id,fe),ne.symbols.push(De)}}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(U,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const ne=this._symbolCache.get(U._id);if(ne){const le=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,K));return le&&(0,C.mixin)(U,P.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(U){const K=this._resultCache.get(U);if(K){for(let[ne,le]=K;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(U)}}}class B{constructor(U,K,ne){this._documents=U,this._provider=K,this._logService=ne}static supportsResolving(U){return typeof U.prepareRename=="function"}provideRenameEdits(U,K,ne,le){const fe=this._documents.getDocument(U),De=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(fe,De,ne,le)).then(Oe=>{if(!!Oe)return P.WorkspaceEdit.from(Oe)},Oe=>{const me=B._asMessage(Oe);return me?{rejectReason:me,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(U,K,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(U),fe=P.Position.to(K);return(0,S.asPromise)(()=>this._provider.prepareRename(le,fe,ne)).then(De=>{let Oe,me;if(A.Range.isRange(De)?(Oe=De,me=le.getText(De)):(0,k.isObject)(De)&&(Oe=De.range,me=De.placeholder),!!Oe){if(Oe.start.line>fe.line||Oe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Oe),text:me}}},De=>{const Oe=B._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class G{constructor(U,K){this.resultId=U,this.tokens=K}}class M{constructor(U,K){this._documents=U,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(U,K,ne){const le=this._documents.getDocument(U),fe=K!==0?this._previousResults.get(K):null;return(0,S.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,fe.resultId,ne):this._provider.provideDocumentSemanticTokens(le,ne)).then(De=>(fe&&this._previousResults.delete(K),De?(De=M._fixProvidedSemanticTokens(De),this._send(M._convertToEdits(fe,De),De)):null))}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return M._isSemanticTokens(U)?M._isCorrectSemanticTokens(U)?U:new A.SemanticTokens(new Uint32Array(U.data),U.resultId):M._isSemanticTokensEdits(U)?M._isCorrectSemanticTokensEdits(U)?U:new A.SemanticTokensEdits(U.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const K of U.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,K){if(!M._isSemanticTokens(K)||!U||!U.tokens)return K;const ne=U.tokens,le=ne.length,fe=K.data,De=fe.length;let Oe=0;const me=Math.min(le,De);for(;Oe<me&&ne[Oe]===fe[Oe];)Oe++;if(Oe===le&&Oe===De)return new A.SemanticTokensEdits([],K.resultId);let Ce=0;const Ae=me-Oe;for(;Ce<Ae&&ne[le-Ce-1]===fe[De-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Ce,data:fe.subarray(Oe,De-Ce)}],K.resultId)}_send(U,K){if(M._isSemanticTokens(U)){const ne=this._nextResultId++;return this._previousResults.set(ne,new G(U.resultId,U.data)),(0,r.encodeSemanticTokensDto)({id:ne,type:"full",data:U.data})}if(M._isSemanticTokensEdits(U)){const ne=this._nextResultId++;return M._isSemanticTokens(K)?this._previousResults.set(ne,new G(K.resultId,K.data)):this._previousResults.set(ne,new G(U.resultId)),(0,r.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(U.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class N{constructor(U,K){this._documents=U,this._provider=K}provideDocumentRangeSemanticTokens(U,K,ne){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,P.Range.to(K),ne)).then(fe=>fe?this._send(fe):null)}_send(U){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=N;class W{constructor(U,K,ne,le,fe){this._documents=U,this._commands=K,this._provider=ne,this._apiDeprecation=le,this._extension=fe,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,K,ne,le){const fe=this._documents.getDocument(U),De=P.Position.to(K),Oe=fe.getWordRangeAtPosition(De)||new A.Range(De,De),me=Oe.with({end:De}),Ce=new m.StopWatch(!0),Ae=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(fe,De,le,P.CompletionContext.to(ne)));if(!!Ae&&!le.isCancellationRequested){const $e=Array.isArray(Ae)?new A.CompletionList(Ae):Ae,be=W.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),Ke=new f.DisposableStore;this._disposables.set(be,Ke);const V=[],X={x:be,b:V,a:{replace:P.Range.from(Oe),insert:P.Range.from(me)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ge=0;ge<$e.items.length;ge++){const Me=$e.items[ge],We=this._convertCompletionItem(Me,[be,ge],me,Oe);V.push(We)}return X}}async resolveCompletionItem(U,K){if(typeof this._provider.resolveCompletionItem=="function"){const ne=this._cache.get(...U);if(!!ne){const le=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(ne,K));if(!!le)return this._convertCompletionItem(le,U)}}}releaseCompletionItems(U){var K;(K=this._disposables.get(U))===null||K===void 0||K.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,K,ne,le){var fe;const De=this._disposables.get(K[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:K,a:(fe=U.label)!==null&&fe!==void 0?fe:"",o:U.label2,b:U.kind!==void 0?P.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(P.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:P.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(P.TextEdit.from),m:this._commands.toInternal(U.command,De)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof A.SnippetString&&(Oe.h=U.insertText.value,Oe.i|=4);let me;return U.textEdit?me=U.textEdit.range:U.range&&(me=U.range),A.Range.isRange(me)?Oe.j=P.Range.from(me):me&&(!(ne==null?void 0:ne.isEqual(me.inserting))||!(le==null?void 0:le.isEqual(me.replacing)))&&(Oe.j={insert:P.Range.from(me.inserting),replace:P.Range.from(me.replacing)}),Oe}}class Q{constructor(U,K){this._documents=U,this._provider=K,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(U,K,ne,le){const fe=this._documents.getDocument(U),De=P.Position.to(K),Oe=this.reviveContext(ne);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(fe,De,le,Oe)).then(me=>{if(me){const Ce=this._cache.add([me]);return Object.assign(Object.assign({},P.SignatureHelp.from(me)),{id:Ce})}})}reviveContext(U){let K;if(U.activeSignatureHelp){const ne=P.SignatureHelp.to(U.activeSignatureHelp),le=this._cache.get(U.activeSignatureHelp.id,0);le?(K=le,K.activeSignature=ne.activeSignature,K.activeParameter=ne.activeParameter):K=ne}return Object.assign(Object.assign({},U),{activeSignatureHelp:K})}releaseSignatureHelp(U){this._cache.delete(U)}}class x{constructor(U,K){this._documents=U,this._provider=K}provideInlineHints(U,K,ne){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideInlineHints(le,P.Range.to(K),ne)).then(fe=>fe?{hints:fe.map(P.InlineHint.from)}:void 0)}}class Z{constructor(U,K){this._documents=U,this._provider=K,this._cache=new _.Cache("DocumentLink")}provideLinks(U,K){const ne=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(ne,K)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(P.DocumentLink.from)};{const fe=this._cache.add(le),De={links:[],id:fe};for(let Oe=0;Oe<le.length;Oe++){const me=P.DocumentLink.from(le[Oe]);me.cacheId=[fe,Oe],De.links.push(me)}return De}}})}resolveLink(U,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...U);return ne?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(ne,K)).then(le=>le&&P.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(U){this._cache.delete(U)}}class re{constructor(U,K){this._documents=U,this._provider=K}provideColors(U,K){const ne=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(ne,K)).then(le=>Array.isArray(le)?le.map(De=>({color:P.Color.from(De.color),range:P.Range.from(De.range)})):[])}provideColorPresentations(U,K,ne){const le=this._documents.getDocument(U),fe=P.Range.to(K.range),De=P.Color.to(K.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(De,{document:le,range:fe},ne)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(P.ColorPresentation.from)})}}class oe{constructor(U,K){this._documents=U,this._provider=K}provideFoldingRanges(U,K,ne){const le=this._documents.getDocument(U);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(le,K,ne)).then(fe=>{if(!!Array.isArray(fe))return fe.map(P.FoldingRange.from)})}}class ye{constructor(U,K,ne){this._documents=U,this._provider=K,this._logService=ne}provideSelectionRanges(U,K,ne){const le=this._documents.getDocument(U),fe=K.map(P.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(le,fe,ne)).then(De=>{if(!(0,T.isNonEmptyArray)(De))return[];if(De.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let me=0;me<fe.length;me++){const Ce=[];Oe.push(Ce);let Ae=fe[me],$e=De[me];for(;;){if(!$e.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(P.SelectionRange.from($e)),!$e.parent)break;Ae=$e.range,$e=$e.parent}}return Oe})}}class Pe{constructor(U,K){this._documents=U,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(U,K,ne){const le=this._documents.getDocument(U),fe=P.Position.to(K),De=await this._provider.prepareCallHierarchy(le,fe,ne);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(me=>this._cacheAndConvertItem(Oe,me)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(U,K,ne){const le=this._itemFromCache(U,K);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!fe)return fe.map(De=>({from:this._cacheAndConvertItem(U,De.from),fromRanges:De.fromRanges.map(Oe=>P.Range.from(Oe))}))}async provideCallsFrom(U,K,ne){const le=this._itemFromCache(U,K);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!fe)return fe.map(De=>({to:this._cacheAndConvertItem(U,De.to),fromRanges:De.fromRanges.map(Oe=>P.Range.from(Oe))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,K){var ne;const le=this._cache.get(U),fe={_sessionId:U,_itemId:le.size.toString(36),name:K.name,detail:K.detail,kind:P.SymbolKind.from(K.kind),uri:K.uri,range:P.Range.from(K.range),selectionRange:P.Range.from(K.selectionRange),tags:(ne=K.tags)===null||ne===void 0?void 0:ne.map(P.SymbolTag.from)};return le.set(fe._itemId,K),fe}_itemFromCache(U,K){const ne=this._cache.get(U);return ne==null?void 0:ne.get(K)}}class Be{constructor(U,K){this.adapter=U,this.extension=K}}class Re{constructor(U,K,ne,le,fe,De,Oe){this._adapter=new Map,this._uriTransformer=K,this._proxy=U.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=fe,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(U){return(0,T.coalesce)((0,T.asArray)(U).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:P.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new A.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Re._handlePool++}_withAdapter(U,K,ne,le,fe=!1){const De=this._adapter.get(U);if(!De)return Promise.resolve(le);if(De.adapter instanceof K){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${K.name}'`));const me=ne(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(me).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Ae=>{fe&&Ae instanceof b.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,K){const ne=this._nextHandle();return this._adapter.set(ne,new Be(U,K)),ne}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,K,ne,le){const fe=this._addNewAdapter(new v(this._documents,ne),U),De=le&&le.label||Re._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(K),De),this._createDisposable(fe)}$provideDocumentSymbols(U,K,ne){return this._withAdapter(U,v,le=>le.provideDocumentSymbols(E.URI.revive(K),ne),void 0)}registerCodeLensProvider(U,K,ne){const le=this._nextHandle(),fe=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new d(this._documents,this._commands.converter,ne),U)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(K),fe);let De=this._createDisposable(le);if(fe!==void 0){const Oe=ne.onDidChangeCodeLenses(me=>this._proxy.$emitCodeLensEvent(fe));De=A.Disposable.from(De,Oe)}return De}$provideCodeLenses(U,K,ne){return this._withAdapter(U,d,le=>le.provideCodeLenses(E.URI.revive(K),ne),void 0)}$resolveCodeLens(U,K,ne){return this._withAdapter(U,d,le=>le.resolveCodeLens(K,ne),void 0)}$releaseCodeLenses(U,K){this._withAdapter(U,d,ne=>Promise.resolve(ne.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(U,K,ne){const le=this._addNewAdapter(new t(this._documents,ne),U);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDefinition(U,K,ne,le){return this._withAdapter(U,t,fe=>fe.provideDefinition(E.URI.revive(K),ne,le),[])}registerDeclarationProvider(U,K,ne){const le=this._addNewAdapter(new i(this._documents,ne),U);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDeclaration(U,K,ne,le){return this._withAdapter(U,i,fe=>fe.provideDeclaration(E.URI.revive(K),ne,le),[])}registerImplementationProvider(U,K,ne){const le=this._addNewAdapter(new c(this._documents,ne),U);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideImplementation(U,K,ne,le){return this._withAdapter(U,c,fe=>fe.provideImplementation(E.URI.revive(K),ne,le),[])}registerTypeDefinitionProvider(U,K,ne){const le=this._addNewAdapter(new a(this._documents,ne),U);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideTypeDefinition(U,K,ne,le){return this._withAdapter(U,a,fe=>fe.provideTypeDefinition(E.URI.revive(K),ne,le),[])}registerHoverProvider(U,K,ne,le){const fe=this._addNewAdapter(new l(this._documents,ne),U);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(K)),this._createDisposable(fe)}$provideHover(U,K,ne,le){return this._withAdapter(U,l,fe=>fe.provideHover(E.URI.revive(K),ne,le),void 0)}registerEvaluatableExpressionProvider(U,K,ne,le){const fe=this._addNewAdapter(new o(this._documents,ne),U);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(K)),this._createDisposable(fe)}$provideEvaluatableExpression(U,K,ne,le){return this._withAdapter(U,o,fe=>fe.provideEvaluatableExpression(E.URI.revive(K),ne,le),void 0)}registerInlineValuesProvider(U,K,ne,le){const fe=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new w(this._documents,ne),U);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(K),fe);let Oe=this._createDisposable(De);if(fe!==void 0){const me=ne.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Oe=A.Disposable.from(Oe,me)}return Oe}$provideInlineValues(U,K,ne,le,fe){return this._withAdapter(U,w,De=>De.provideInlineValues(E.URI.revive(K),ne,le,fe),void 0)}registerDocumentHighlightProvider(U,K,ne){const le=this._addNewAdapter(new I(this._documents,ne),U);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentHighlights(U,K,ne,le){return this._withAdapter(U,I,fe=>fe.provideDocumentHighlights(E.URI.revive(K),ne,le),void 0)}registerLinkedEditingRangeProvider(U,K,ne){const le=this._addNewAdapter(new p(this._documents,ne),U);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideLinkedEditingRanges(U,K,ne,le){return this._withAdapter(U,p,async fe=>{const De=await fe.provideLinkedEditingRanges(E.URI.revive(K),ne,le);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Re._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(U,K,ne){const le=this._addNewAdapter(new g(this._documents,ne),U);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideReferences(U,K,ne,le,fe){return this._withAdapter(U,g,De=>De.provideReferences(E.URI.revive(K),ne,le,fe),void 0)}registerCodeActionProvider(U,K,ne,le){var fe,De;const Oe=new f.DisposableStore,me=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(K),{providedKinds:(fe=le==null?void 0:le.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(De=le==null?void 0:le.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Oe)}))},Re._extLabel(U),Boolean(ne.resolveCodeAction)),Oe.add(this._createDisposable(me)),Oe}$provideCodeActions(U,K,ne,le,fe){return this._withAdapter(U,R,De=>De.provideCodeActions(E.URI.revive(K),ne,le,fe),void 0)}$resolveCodeAction(U,K,ne){return this._withAdapter(U,R,le=>le.resolveCodeAction(K,ne),void 0)}$releaseCodeActions(U,K){this._withAdapter(U,R,ne=>Promise.resolve(ne.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(U,K,ne){const le=this._addNewAdapter(new F(this._documents,ne),U);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(le)}$provideDocumentFormattingEdits(U,K,ne,le){return this._withAdapter(U,F,fe=>fe.provideDocumentFormattingEdits(E.URI.revive(K),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(U,K,ne){const le=this._addNewAdapter(new $(this._documents,ne),U);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(K),U.identifier,U.displayName||U.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(U,K,ne,le,fe){return this._withAdapter(U,$,De=>De.provideDocumentRangeFormattingEdits(E.URI.revive(K),ne,le,fe),void 0)}registerOnTypeFormattingEditProvider(U,K,ne,le){const fe=this._addNewAdapter(new ue(this._documents,ne),U);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(K),le,U.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(U,K,ne,le,fe,De){return this._withAdapter(U,ue,Oe=>Oe.provideOnTypeFormattingEdits(E.URI.revive(K),ne,le,fe,De),void 0)}registerWorkspaceSymbolProvider(U,K){const ne=this._addNewAdapter(new z(K,this._logService),U);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(U,K,ne){return this._withAdapter(U,z,le=>le.provideWorkspaceSymbols(K,ne),{symbols:[]})}$resolveWorkspaceSymbol(U,K,ne){return this._withAdapter(U,z,le=>le.resolveWorkspaceSymbol(K,ne),void 0)}$releaseWorkspaceSymbols(U,K){this._withAdapter(U,z,ne=>ne.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(U,K,ne){const le=this._addNewAdapter(new B(this._documents,ne,this._logService),U);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(K),B.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(U,K,ne,le,fe){return this._withAdapter(U,B,De=>De.provideRenameEdits(E.URI.revive(K),ne,le,fe),void 0)}$resolveRenameLocation(U,K,ne,le){return this._withAdapter(U,B,fe=>fe.resolveRenameLocation(E.URI.revive(K),ne,le),void 0)}registerDocumentSemanticTokensProvider(U,K,ne,le){const fe=this._nextHandle(),De=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Be(new M(this._documents,ne),U)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(K),le,De);let Oe=this._createDisposable(fe);if(De){const me=ne.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=A.Disposable.from(Oe,me)}return Oe}$provideDocumentSemanticTokens(U,K,ne,le){return this._withAdapter(U,M,fe=>fe.provideDocumentSemanticTokens(E.URI.revive(K),ne,le),null,!0)}$releaseDocumentSemanticTokens(U,K){this._withAdapter(U,M,ne=>ne.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(U,K,ne,le){const fe=this._addNewAdapter(new N(this._documents,ne),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(K),le),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(U,K,ne,le){return this._withAdapter(U,N,fe=>fe.provideDocumentRangeSemanticTokens(E.URI.revive(K),ne,le),null,!0)}registerCompletionItemProvider(U,K,ne,le){const fe=this._addNewAdapter(new W(this._documents,this._commands.converter,ne,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(K),le,W.supportsResolving(ne),`${U.identifier.value}(${le.join("")})`),this._createDisposable(fe)}$provideCompletionItems(U,K,ne,le,fe){return this._withAdapter(U,W,De=>De.provideCompletionItems(E.URI.revive(K),ne,le,fe),void 0)}$resolveCompletionItem(U,K,ne){return this._withAdapter(U,W,le=>le.resolveCompletionItem(K,ne),void 0)}$releaseCompletionItems(U,K){this._withAdapter(U,W,ne=>ne.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(U,K,ne,le){const fe=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,De=this._addNewAdapter(new Q(this._documents,ne),U);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(K),fe),this._createDisposable(De)}$provideSignatureHelp(U,K,ne,le,fe){return this._withAdapter(U,Q,De=>De.provideSignatureHelp(E.URI.revive(K),ne,le,fe),void 0)}$releaseSignatureHelp(U,K){this._withAdapter(U,Q,ne=>ne.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(U,K,ne){const le=typeof ne.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new x(this._documents,ne),U);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(K),le);let De=this._createDisposable(fe);if(le!==void 0){const Oe=ne.onDidChangeInlineHints(me=>this._proxy.$emitInlineHintsEvent(le));De=A.Disposable.from(De,Oe)}return De}$provideInlineHints(U,K,ne,le){return this._withAdapter(U,x,fe=>fe.provideInlineHints(E.URI.revive(K),ne,le),void 0)}registerDocumentLinkProvider(U,K,ne){const le=this._addNewAdapter(new Z(this._documents,ne),U);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(K),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(U,K,ne){return this._withAdapter(U,Z,le=>le.provideLinks(E.URI.revive(K),ne),void 0)}$resolveDocumentLink(U,K,ne){return this._withAdapter(U,Z,le=>le.resolveLink(K,ne),void 0)}$releaseDocumentLinks(U,K){this._withAdapter(U,Z,ne=>ne.releaseLinks(K),void 0)}registerColorProvider(U,K,ne){const le=this._addNewAdapter(new re(this._documents,ne),U);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentColors(U,K,ne){return this._withAdapter(U,re,le=>le.provideColors(E.URI.revive(K),ne),[])}$provideColorPresentations(U,K,ne,le){return this._withAdapter(U,re,fe=>fe.provideColorPresentations(E.URI.revive(K),ne,le),void 0)}registerFoldingRangeProvider(U,K,ne){const le=this._nextHandle(),fe=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new oe(this._documents,ne),U)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(K),fe);let De=this._createDisposable(le);if(fe!==void 0){const Oe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));De=A.Disposable.from(De,Oe)}return De}$provideFoldingRanges(U,K,ne,le){return this._withAdapter(U,oe,fe=>fe.provideFoldingRanges(E.URI.revive(K),ne,le),void 0)}registerSelectionRangeProvider(U,K,ne){const le=this._addNewAdapter(new ye(this._documents,ne,this._logService),U);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideSelectionRanges(U,K,ne,le){return this._withAdapter(U,ye,fe=>fe.provideSelectionRanges(E.URI.revive(K),ne,le),[])}registerCallHierarchyProvider(U,K,ne){const le=this._addNewAdapter(new Pe(this._documents,ne),U);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$prepareCallHierarchy(U,K,ne,le){return this._withAdapter(U,Pe,fe=>Promise.resolve(fe.prepareSession(E.URI.revive(K),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(U,K,ne,le){return this._withAdapter(U,Pe,fe=>fe.provideCallsTo(K,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(U,K,ne,le){return this._withAdapter(U,Pe,fe=>fe.provideCallsFrom(K,ne,le),void 0)}$releaseCallHierarchy(U,K){this._withAdapter(U,Pe,ne=>Promise.resolve(ne.releaseSession(K)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,y.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Re._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Re._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Re._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Re._serializeRegExp(U.beforeText),afterText:U.afterText?Re._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Re._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Re._serializeOnEnterRule)}setLanguageConfiguration(U,K,ne){let{wordPattern:le}=ne;if(le&&(0,y.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(K,le):this._documents.setWordDefinitionFor(K,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const fe=this._nextHandle(),De={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Re._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Re._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Re._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,K,De),this._createDisposable(fe)}$setWordDefinitions(U){for(const K of U)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Re,Re._handlePool=0}),define(ve[198],_e([0,1,5,9,7]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(D,y){this._proxy=D.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,y){await this._proxy.$changeLanguage(D,y);const n=this._documents.getDocumentData(D);if(!n)throw new Error(`document '${D.toString}' NOT found`);return n.document}async tokenAtPosition(D,y){var n;const T=D.version,k=C.Position.from(y),h=await this._proxy.$tokensAtPosition(D.uri,k),f={type:P.StandardTokenType.Other,range:(n=D.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new P.Range(y.line,y.character,y.line,y.character)};if(!h)return f;const r={range:C.Range.to(h.range),type:C.TokenType.to(h.type)};return!r.range.contains(y)||T!==D.version?f:r}}e.ExtHostLanguages=A}),define(ve[199],_e([0,1,5,19,33]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(D){return D&&D.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,T,k,h){const f={extension:y};let r;typeof k=="string"||A(k)?r=[k,...h]:(f.modal=k&&k.modal,f.useCustom=k&&k.useCustom,r=h),f.useCustom&&(0,P.checkProposedApiEnabled)(y);const s=[];for(let _=0;_<r.length;_++){const m=r[_];if(typeof m=="string")s.push({title:m,handle:_,isCloseAffordance:!1});else if(typeof m=="object"){let{title:b,isCloseAffordance:v}=m;s.push({title:b,isCloseAffordance:!!v,handle:_})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(n,T,f,s).then(_=>{if(typeof _=="number")return r[_]})}};S=qe([Ge(1,C.ILogService)],S),e.ExtHostMessageService=S}),define(ve[200],_e([0,1,20,3,6,2,29,5,9,7,49,71,22,177,178,54,13,23,57,68]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class d extends P.Disposable{constructor(o,w,I,p,g){super();this._editorId=o,this.uri=w,this._proxy=I,this._webviewInitData=p,this.document=g,this._onDidReceiveDocumentMessage=new C.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:R=>this._proxy.$postMessage(this._editorId,void 0,R),asWebviewUri:R=>this._asWebviewUri(R)}}onDidReceiveMessage(o,w){var I;this._onDidReceiveDocumentMessage.fire(w),o!==void 0&&((I=this._rendererIdToEmitters.get(o))===null||I===void 0||I.fire(w))}getRendererComm(o){const w=new C.Emitter;return this._rendererIdToEmitters.set(o,w),{editorId:this._editorId,onDidReceiveMessage:w.event,postMessage:I=>this._proxy.$postMessage(this._editorId,o,I),asWebviewUri:I=>this._asWebviewUri(I)}}_asWebviewUri(o){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,o)}}class u extends P.Disposable{constructor(o,w,I,p){super();this._proxy=o,this._handle=w,this._extension=I,this._provider=p,this._kernelToFriendlyId=new h.ResourceMap,this._friendlyIdToKernel=new h.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(g=>{const R=g==null?void 0:g.uri;this._proxy.$onNotebookKernelChange(this._handle,R)}))}async provideKernels(o,w){const I=await this._provider.provideKernels(o.notebookDocument,w)||[],p=new Map;let g=0;const R=new Set,F=this._kernelToFriendlyId.get(o.uri),$=I.map(z=>{var B;let G=F==null?void 0:F.get(z);return G===void 0&&(z.id&&R.has(z.id)?G=`${this._extension.identifier.value}_${z.id}_${g++}`:G=`${this._extension.identifier.value}_${z.id||S.generateUuid()}`),p.set(z,G),{id:z.id,friendlyId:G,label:z.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:z.description,detail:z.detail,isPreferred:z.isPreferred,preloads:(B=z.preloads)===null||B===void 0?void 0:B.map(M=>(A.URI.isUri(M)&&(M={uri:M,provides:[]}),{uri:M.uri,provides:typeof M.provides=="string"?[M.provides]:M.provides===void 0?[]:M.provides})),supportedLanguages:z.supportedLanguages,implementsInterrupt:!!z.interrupt}});this._kernelToFriendlyId.set(o.uri,p);const ue=new Map;return p.forEach((z,B)=>{ue.set(z,B)}),this._friendlyIdToKernel.set(o.uri,ue),$}getKernelByFriendlyId(o,w){var I;return(I=this._friendlyIdToKernel.get(o))===null||I===void 0?void 0:I.get(w)}async resolveNotebook(o,w,I,p){var g;const R=(g=this._friendlyIdToKernel.get(w.uri))===null||g===void 0?void 0:g.get(o);if(R&&this._provider.resolveKernel)return this._provider.resolveKernel(R,w.notebookDocument,I,p)}async executeNotebook(o,w,I){var p;const g=(p=this._friendlyIdToKernel.get(w.uri))===null||p===void 0?void 0:p.get(o);if(!!g){const R=I.map(F=>y.NotebookRange.to(F));return g.executeCellsRequest(w.notebookDocument,R)}}async interruptNotebookExecution(o,w){var I;const p=(I=this._friendlyIdToKernel.get(w.uri))===null||I===void 0?void 0:I.get(o);if(!(!p||!p.interrupt))return p.interrupt(w.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=u;class t{constructor(o,w){const I=t._Keys.nextId();o.$registerNotebookEditorDecorationType(I,y.NotebookDecorationRenderOptions.from(w)),this.value={key:I,dispose(){o.$removeNotebookEditorDecorationType(I)}}}}e.NotebookEditorDecorationType=t,t._Keys=new s.IdGenerator("NotebookEditorDecorationType");class i{constructor(o,w,I,p,g,R,F){this._textDocumentsAndEditors=I,this._textDocuments=p,this._webviewInitData=g,this.logService=R,this._extensionStoragePaths=F,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new h.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new C.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new C.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new C.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new C.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new C.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new C.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new C.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new C.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new C.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new h.ResourceMap,this._statusBarCache=new v.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=w.converter,w.registerArgumentProcessor({processArgument:$=>{var ue;if($&&$.$mid===12){const z=(ue=$.notebookEditor)===null||ue===void 0?void 0:ue.notebookUri,B=$.cell.handle,G=this._documents.get(z),M=G==null?void 0:G.getCell(B);if(M)return M.cell}return $}})}get activeNotebookEditor(){var o;return(o=this._activeNotebookEditor)===null||o===void 0?void 0:o.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){return this._editors.get(o)}getIdByEditor(o){for(const[w,I]of this._editors)if(I.apiEditor===o)return w}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(o){return this._documents.get(o)}_getNotebookDocument(o){const w=this._documents.get(o);if(!w)throw new Error(`NO notebook document for '${o}'`);return w}_getProviderData(o){const w=this._notebookContentProviders.get(o);if(!w)throw new Error(`NO provider for '${o}'`);return w}registerNotebookContentProvider(o,w,I,p){var g,R,F;if(this._notebookContentProviders.has(w))throw new Error(`Notebook provider for '${w}' already registered`);this._notebookContentProviders.set(w,{extension:o,provider:I});let $;I.onDidChangeNotebookContentOptions&&($=I.onDidChangeNotebookContentOptions(()=>{const B=y.NotebookDocumentContentOptions.from(I.options);this._notebookProxy.$updateNotebookProviderOptions(w,B)}));const ue=(g=p==null?void 0:p.viewOptions)===null||g===void 0?void 0:g.filenamePattern.map(B=>y.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);((R=p==null?void 0:p.viewOptions)===null||R===void 0?void 0:R.filenamePattern)&&!ue&&console.warn(`Notebook content provider view options file name pattern is invalid ${(F=p==null?void 0:p.viewOptions)===null||F===void 0?void 0:F.filenamePattern}`);const z=y.NotebookDocumentContentOptions.from(p);return this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation,description:o.description},w,{transientOutputs:z.transientOutputs,transientMetadata:z.transientMetadata,viewOptions:(p==null?void 0:p.viewOptions)&&ue?{displayName:p.viewOptions.displayName,filenamePattern:ue,exclusive:p.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{$==null||$.dispose(),this._notebookContentProviders.delete(w),this._notebookProxy.$unregisterNotebookProvider(w)})}registerNotebookKernelProvider(o,w,I){const p=i._notebookKernelProviderHandlePool++,g=new u(this._notebookProxy,p,o,I);return this._notebookKernelProviders.set(p,g),this._notebookProxy.$registerNotebookKernelProvider({id:o.identifier,location:o.extensionLocation,description:o.description},p,{viewType:w.viewType,filenamePattern:w.filenamePattern?y.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0}),new n.Disposable(()=>{g.dispose(),this._notebookKernelProviders.delete(p),this._notebookProxy.$unregisterNotebookKernelProvider(p)})}registerNotebookCellStatusBarItemProvider(o,w,I){const p=i._notebookStatusBarItemProviderHandlePool++,g=typeof I.onDidChangeCellStatusBarItems=="function"?i._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,I),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,g,{viewType:w.viewType,filenamePattern:w.filenamePattern?y.NotebookExclusiveDocumentPattern.from(w.filenamePattern):void 0});let R;return g!==void 0&&(R=I.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(g))),new n.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,g),R&&R.dispose()})}createNotebookEditorDecorationType(o){return new t(this._notebookEditorsProxy,o).value}async openNotebookDocument(o){const w=this._documents.get(o);if(w)return w.notebookDocument;const I=await this._notebookDocumentsProxy.$tryOpenDocument(o),p=this._documents.get(A.URI.revive(I));return(0,_.assertIsDefined)(p==null?void 0:p.notebookDocument)}_withAdapter(o,w,I){const p=this._documents.get(A.URI.revive(w));if(!p)return[];const g=this._notebookKernelProviders.get(o);return g?I(g,p):[]}async showNotebookDocument(o,w){var I;A.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let p;typeof w=="object"?p={position:y.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(y.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:p={preserveFocus:!1};const g=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.viewType,p),R=g&&((I=this._editors.get(g))===null||I===void 0?void 0:I.apiEditor);if(R)return R;throw g?new Error(`Could NOT open editor for "${o.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.toString()}".`)}async $provideNotebookKernels(o,w,I){return this._withAdapter(o,w,(p,g)=>p.provideKernels(g,I))}async $resolveNotebookKernel(o,w,I,p,g){await this._withAdapter(o,I,async(R,F)=>{const $=this._webviewComm.get(w);$&&await R.resolveNotebook(p,F,$.contentProviderComm,g)})}async $provideNotebookCellStatusBarItems(o,w,I,p){var g;const R=this._notebookStatusBarItemProviders.get(o),F=A.URI.revive(w),$=this._documents.get(F);if(!(!$||!R)){const ue=$.getCellFromIndex(I);if(!!ue){const z=await R.provideCellStatusBarItems(ue.cell,p);if(!!z){const B=new P.DisposableStore,G=this._statusBarCache.add([B]),M=(g=z&&z.map(N=>y.NotebookStatusBarItem.from(N,this._commandsConverter,B)))!==null&&g!==void 0?g:void 0;return{cacheId:G,items:M}}}}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}async $resolveNotebookEditor(o,w,I){const p=this._notebookContentProviders.get(o),g=A.URI.revive(w),R=this._documents.get(g);if(!(!R||!p)){let F=this._webviewComm.get(I);F||(F=new d(I,g,this._notebookProxy,this._webviewInitData,R),this._webviewComm.set(I,F))}}async $executeNotebookKernelFromProvider(o,w,I,p){await this._withAdapter(o,w,async(g,R)=>g.executeNotebook(I,R,p))}registerNotebookSerializer(o,w,I,p){const g=this._handlePool++;this._notebookSerializer.set(g,I);const R=y.NotebookDocumentContentOptions.from(p);return this._notebookProxy.$registerNotebookSerializer(g,{id:o.identifier,location:o.extensionLocation,description:o.description},w,R),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(g)})}async $dataToNotebook(o,w,I){const p=this._notebookSerializer.get(o);if(!p)throw new Error("NO serializer found");const g=await p.deserializeNotebook(w.buffer,I);return{metadata:y.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(y.NotebookCellData.from)}}async $notebookToData(o,w,I){const p=this._notebookSerializer.get(o);if(!p)throw new Error("NO serializer found");const g=await p.serializeNotebook({metadata:y.NotebookDocumentMetadata.to(w.metadata),cells:w.cells.map(y.NotebookCellData.to)},I);return m.VSBuffer.wrap(g)}async $cancelNotebookCellExecution(o,w,I,p){await this._withAdapter(o,w,async(R,F)=>R.interruptNotebookExecution(I,F));const g=this._documents.get(A.URI.revive(w));if(!!g)for(let R of p)for(let F=R.start;F<R.end;F++){const $=g.getCellFromIndex(F);$&&this.cancelOneNotebookCellExecution($)}}cancelOneNotebookCellExecution(o){const w=this._activeExecutions.get(o.uri);w==null||w.cancel()}async $openNotebook(o,w,I,p,g){const{provider:R}=this._getProviderData(o),F=await R.openNotebook(A.URI.revive(w),{backupId:I,untitledDocumentData:p==null?void 0:p.buffer},g);return{metadata:y.NotebookDocumentMetadata.from(F.metadata),cells:F.cells.map(y.NotebookCellData.from)}}async $saveNotebook(o,w,I){const p=this._getNotebookDocument(A.URI.revive(w)),{provider:g}=this._getProviderData(o);return await g.saveNotebook(p.notebookDocument,I),!0}async $saveNotebookAs(o,w,I,p){const g=this._getNotebookDocument(A.URI.revive(w)),{provider:R}=this._getProviderData(o);return await R.saveNotebookAs(A.URI.revive(I),g.notebookDocument,p),!0}async $backupNotebook(o,w,I){var p;const g=this._getNotebookDocument(A.URI.revive(w)),R=this._getProviderData(o),F=(p=this._extensionStoragePaths.workspaceValue(R.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(R.extension),$=String((0,b.hash)([g.uri.toString(),this._backupIdPool++])),ue=A.URI.joinPath(F,$),z=await R.provider.backupNotebook(g.notebookDocument,{destination:ue},I);return g.updateBackup(z),z.id}$acceptNotebookActiveKernelChange(o){o.providerHandle!==void 0&&this._withAdapter(o.providerHandle,o.uri,async(w,I)=>{const p=o.kernelFriendlyId?w.getKernelByFriendlyId(A.URI.revive(o.uri),o.kernelFriendlyId):void 0;this._editors.forEach(g=>{g.notebookData===I&&g._acceptKernel(p)}),this._onDidChangeActiveNotebookKernel.fire({document:I.notebookDocument,kernel:p})})}$onDidReceiveMessage(o,w,I){var p;(p=this._webviewComm.get(o))===null||p===void 0||p.onDidReceiveMessage(w,I)}$acceptModelChanged(o,w,I){this._getNotebookDocument(A.URI.revive(o)).acceptModelChanged(w,I)}$acceptDirtyStateChanged(o,w){const I=this._getNotebookDocument(A.URI.revive(o));I.acceptModelChanged({rawEvents:[],versionId:I.notebookDocument.version},w)}$acceptModelSaved(o){const w=this._getNotebookDocument(A.URI.revive(o));this._onDidSaveNotebookDocument.fire(w.notebookDocument)}$acceptEditorPropertiesChanged(o,w){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",o,w);const I=this._editors.get(o);if(!I)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);w.visibleRanges&&I._acceptVisibleRanges(w.visibleRanges.ranges.map(y.NotebookRange.to)),w.selections&&I._acceptSelections(w.selections.selections.map(y.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(o){for(const w in o){const I=this._editors.get(w);if(!I)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);I._acceptViewColumn(y.ViewColumn.to(o[w]))}}$acceptDocumentPropertiesChanged(o,w){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",o.path,w);const I=this._getNotebookDocument(A.URI.revive(o));I.acceptDocumentPropertiesChanged(w),w.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.notebookDocument})}_createExtHostEditor(o,w,I){if(this._editors.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const p=o.uri;let g=this._webviewComm.get(w);g||(g=new d(w,p,this._notebookProxy,this._webviewInitData,o),this._webviewComm.set(w,g));const R=new r.ExtHostNotebookEditor(w,this._notebookEditorsProxy,o,I.visibleRanges.map(y.NotebookRange.to),I.selections.map(y.NotebookRange.to),typeof I.viewColumn=="number"?y.ViewColumn.to(I.viewColumn):void 0);this._editors.set(w,R)}$acceptDocumentAndEditorsDelta(o){var w,I,p;if(o.removedDocuments)for(const R of o.removedDocuments){const F=A.URI.revive(R),$=this._documents.get(F);$&&($.dispose(),this._documents.delete(F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:$.notebookDocument.getCells().map(ue=>ue.document.uri)}),this._onDidCloseNotebookDocument.fire($.notebookDocument));for(const ue of this._editors.values())ue.notebookData.uri.toString()===F.toString()&&this._editors.delete(ue.id)}if(o.addedDocuments){const R=[];for(const F of o.addedDocuments){const $=A.URI.revive(F.uri),ue=F.viewType;if(this._documents.has($))throw new Error(`adding EXISTING notebook ${$} `);const z=this,B=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(G){z._onDidChangeNotebookCells.fire(G)},emitCellOutputsChange(G){z._onDidChangeCellOutputs.fire(G)},emitCellMetadataChange(G){z._onDidChangeCellMetadata.fire(G)},emitCellExecutionStateChange(G){z._onDidChangeCellExecutionState.fire(G)}},ue,F.metadata?y.NotebookDocumentMetadata.to(F.metadata):new n.NotebookDocumentMetadata,$);B.acceptModelChanged({versionId:F.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,F.cells]]}]},!1),R.push(...F.cells.map(G=>f.ExtHostCell.asModelAddData(B.notebookDocument,G))),(w=this._documents.get($))===null||w===void 0||w.dispose(),this._documents.set($,B),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(B.notebookDocument)}}if(o.addedEditors)for(const R of o.addedEditors){if(this._editors.has(R.id))return;const F=A.URI.revive(R.documentUri),$=this._documents.get(F);$&&this._createExtHostEditor($,R.id,R)}const g=[];if(o.removedEditors)for(const R of o.removedEditors){const F=this._editors.get(R);F&&(this._editors.delete(R),((I=this._activeNotebookEditor)===null||I===void 0?void 0:I.id)===F.id&&(this._activeNotebookEditor=void 0),g.push(F))}if(o.visibleEditors){this._visibleNotebookEditors=o.visibleEditors.map(F=>this._editors.get(F)).filter(F=>!!F);const R=new Set;this._visibleNotebookEditors.forEach(F=>R.add(F.id));for(const F of this._editors.values()){const $=R.has(F.id);F._acceptVisibility($)}this._visibleNotebookEditors=[...this._editors.values()].map(F=>F).filter(F=>F.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.newActiveEditor===null?this._activeNotebookEditor=void 0:o.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.newActiveEditor)),o.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.apiEditor)}createNotebookCellExecution(o,w,I){const p=this.lookupNotebookDocument(o);if(!p)throw new Error(`Invalid cell uri / index: ${o}, ${w} `);const g=p.getCellFromIndex(w);if(!g)throw new Error(`Invalid cell uri / index: ${o}, ${w} `);if(!this._activeExecutions.has(g.uri)){const R=new a(o,p,g,this._notebookDocumentsProxy);this._activeExecutions.set(g.uri,R);const F=R.onDidChangeState(()=>{R.state===c.Resolved&&(R.dispose(),F.dispose(),this._activeExecutions.delete(g.uri))});return R.asApiObject()}}}e.ExtHostNotebookController=i,i._notebookKernelProviderHandlePool=0,i._notebookStatusBarItemProviderHandlePool=0;var c;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(c||(c={}));class a extends P.Disposable{constructor(o,w,I,p){super();this._uri=o,this._document=w,this._cell=I,this._proxy=p,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=I.internalMetadata.executionOrder,this.mixinMetadata({runState:n.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(o){return this._proxy.$applyEdits(this._uri,o,!1)}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(o){const w=[{editType:11,handle:this._cell.handle,metadata:o}];this.applyEdits(w)}cellIndexToHandle(o){const w=typeof o=="number"?this._document.getCellFromIndex(o):this._cell;if(!!w)return w.handle}asApiObject(){const o=this;return Object.freeze({get document(){return o._document.notebookDocument},get cell(){return o._cell.cell},get executionOrder(){return o._executionOrder},set executionOrder(w){o._executionOrder=w,o.mixinMetadata({executionOrder:w})},start(w){if(o._state===c.Resolved||o._state===c.Started)throw new Error("Cannot call start again");o._state=c.Started,o._onDidChangeState.fire(),o.mixinMetadata({runState:n.NotebookCellExecutionState.Executing,runStartTime:w==null?void 0:w.startTime})},end(w){var I,p;if(o._state===c.Resolved)throw new Error("Cannot call resolve twice");o._state=c.Resolved,o._onDidChangeState.fire(),o.mixinMetadata({runState:n.NotebookCellExecutionState.Idle,lastRunSuccess:(I=w==null?void 0:w.success)!==null&&I!==void 0?I:null,runEndTime:(p=w==null?void 0:w.endTime)!==null&&p!==void 0?p:null})},clearOutput(w){return o.verifyStateForOutput(),this.replaceOutput([],w)},async appendOutput(w,I){o.verifyStateForOutput();const p=o.cellIndexToHandle(I);if(typeof p=="number")return w=Array.isArray(w)?w:[w],o.applyEdits([{editType:2,handle:p,append:!0,outputs:w.map(y.NotebookCellOutput.from)}])},async replaceOutput(w,I){o.verifyStateForOutput();const p=o.cellIndexToHandle(I);if(typeof p=="number")return w=Array.isArray(w)?w:[w],o.applyEdits([{editType:2,handle:p,outputs:w.map(y.NotebookCellOutput.from)}])},async appendOutputItems(w,I){return o.verifyStateForOutput(),w=Array.isArray(w)?w:[w],o.applyEdits([{editType:10,append:!0,items:w.map(y.NotebookCellOutputItem.from),outputId:I}])},async replaceOutputItems(w,I){return o.verifyStateForOutput(),w=Array.isArray(w)?w:[w],o.applyEdits([{editType:10,items:w.map(y.NotebookCellOutputItem.from),outputId:I}])},token:o._tokenSource.token})}}}),define(ve[201],_e([0,1,3,6,5,2,9,11,49]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class n{constructor(k,h,f){this._initData=h,this._extHostNotebook=f,this._kernelData=new Map,this._handlePool=0,this._proxy=k.getProxy(P.MainContext.MainThreadNotebookKernels)}createKernel(k,h){var f,r;const s=this._handlePool++,_=this;let m=!1;const b=new C.DisposableStore,v=new E.Emitter,d=new E.Emitter,u={id:h.id,selector:h.selector,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:h.label,supportedLanguages:[]};let t=h.executeHandler,i=h.interruptHandler;this._proxy.$addKernel(s,u);let c=0;const a=()=>{if(!m){const o=++c;Promise.resolve().then(()=>{o===c&&this._proxy.$updateKernel(s,u)})}},l={get id(){return u.id},get selector(){return u.selector},onDidChangeNotebookAssociation:v.event,get label(){return u.label},set label(o){u.label=o,a()},get description(){var o;return(o=u.description)!==null&&o!==void 0?o:""},set description(o){u.description=o,a()},get isPreferred(){var o;return(o=u.isPreferred)!==null&&o!==void 0?o:!1},set isPreferred(o){u.isPreferred=o,a()},get supportedLanguages(){return u.supportedLanguages},set supportedLanguages(o){u.supportedLanguages=(0,D.isNonEmptyArray)(o)?o:["plaintext"],a()},get hasExecutionOrder(){var o;return(o=u.hasExecutionOrder)!==null&&o!==void 0?o:!1},set hasExecutionOrder(o){u.hasExecutionOrder=o,a()},get preloads(){return u.preloads&&u.preloads.map(S.NotebookKernelPreload.to)},set preloads(o){u.preloads=o&&o.map(S.NotebookKernelPreload.from),a()},get executeHandler(){return t},get interruptHandler(){return i},set interruptHandler(o){i=o,u.supportsInterrupt=Boolean(o),a()},createNotebookCellExecutionTask(o){if(m)throw new Error("notebook controller is DISPOSED");return _._extHostNotebook.createNotebookCellExecution(o.notebook.uri,o.index,u.id)},dispose:()=>{m||(m=!0,this._kernelData.delete(s),b.dispose(),v.dispose(),d.dispose(),this._proxy.$removeKernel(s))},onDidReceiveMessage:d.event,postMessage(o,w){return _._proxy.$postMessage(s,w&&_._extHostNotebook.getIdByEditor(w),o)},asWebviewUri(o,w){return(0,y.asWebviewUri)(_._initData.environment,_._extHostNotebook.getIdByEditor(w),o)}};return this._kernelData.set(s,{controller:l,onDidChangeSelection:v,onDidReceiveMessage:d}),l.supportedLanguages=(f=h.supportedLanguages)!==null&&f!==void 0?f:[],l.interruptHandler=h.interruptHandler,l.hasExecutionOrder=(r=h.hasExecutionOrder)!==null&&r!==void 0?r:!1,l}$acceptSelection(k,h,f){const r=this._kernelData.get(k);r&&r.onDidChangeSelection.fire({selected:f,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(h)).notebookDocument})}$executeCells(k,h,f){const r=this._kernelData.get(k);if(!!r){const s=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(h));if(!s)throw new Error("MISSING notebook");const _=[];for(let m of f)_.push(...s.notebookDocument.getCells(S.NotebookRange.to(m)));try{r.controller.executeHandler(_,r.controller)}catch(m){console.error(m)}}}$cancelCells(k,h,f){const r=this._kernelData.get(k);if(!!r){const s=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(h));if(!s)throw new Error("MISSING notebook");r.controller.interruptHandler&&r.controller.interruptHandler(s.notebookDocument)}}$acceptRendererMessage(k,h,f){const r=this._kernelData.get(k);if(!!r){const s=this._extHostNotebook.getEditorById(h);if(!s)throw new Error(`send message for UNKNOWN editor: ${h}`);r.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:f}))}}}e.ExtHostNotebookKernels=n}),define(ve[99],_e([0,1,5,3,6,23,4,15]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends P.Disposable{constructor(r,s,_,m){super();this._onDidAppend=this._register(new C.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,s,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?A.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(s=>this._proxy.$clear(s,r))}show(r,s){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof r=="boolean"?r:s)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(r,s){super(r,!1,void 0,s)}append(r){super.append(r),this._id.then(s=>this._proxy.$append(s,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends y{constructor(r,s,_){super(r,!0,s,_)}append(r){throw new Error("Not supported")}}class k{constructor(r,s){this.name=r,this._channel=s}append(r){this._channel.then(s=>s.append(r))}appendLine(r){this._channel.then(s=>s.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,s){this._channel.then(_=>_.show(r,s))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=k;let h=class{constructor(r){this._proxy=r.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new n(r,this._proxy)}createOutputChannelFromLogFile(r,s){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!s)throw new Error("illegal argument `file`. must not be falsy");return new T(r,s,this._proxy)}};h=qe([Ge(0,D.IExtHostRpcService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(ve[202],_e([0,1,14,20,3,6,5,2,7,10,11,46]),function(ee,e,E,C,P,A,S,D,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(f,r,s){const _=f.getProxy(S.MainContext.MainThreadQuickOpen);class m{constructor(a,l){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=l}showQuickPick(a,l,o,w=C.CancellationToken.None){this._onDidSelectItem=void 0;const I=Promise.resolve(a),p=++this._instances,g=_.$show(p,{title:o==null?void 0:o.title,placeHolder:o==null?void 0:o.placeHolder,matchOnDescription:o==null?void 0:o.matchOnDescription,matchOnDetail:o==null?void 0:o.matchOnDetail,ignoreFocusLost:o==null?void 0:o.ignoreFocusOut,canPickMany:o==null?void 0:o.canPickMany},w),R={},F=g.then(()=>R);return Promise.race([F,I]).then($=>{if($!==R)return I.then(ue=>{const z=[];for(let B=0;B<ue.length;B++){const G=ue[B];let M,N,W,Q,x;typeof G=="string"?M=G:(M=G.label,N=G.description,W=G.detail,Q=G.picked,x=G.alwaysShow),z.push({label:M,description:N,handle:B,detail:W,picked:Q,alwaysShow:x})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{o.onDidSelectItem(ue[B])}),_.$setItems(p,z),g.then(B=>{if(typeof B=="number")return ue[B];if(Array.isArray(B))return B.map(G=>ue[G])})})}).then(void 0,$=>{if(!(0,n.isPromiseCanceledError)($))return _.$setError(p,$),Promise.reject($)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,l=C.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,_.$input(a,typeof this._validateInput=="function",l).then(void 0,o=>{if(!(0,n.isPromiseCanceledError)(o))return Promise.reject(o)})}$validateInput(a){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,l=C.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!o){const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(I=>I.uri.toString()===o.uri.toString())}}createQuickPick(a,l){const o=new t(a,l,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(a){const l=new i(a,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(a,l){const o=this._sessions.get(a);o&&o._fireDidChangeValue(l)}$onDidAccept(a){const l=this._sessions.get(a);l&&l._fireDidAccept()}$onDidChangeActive(a,l){const o=this._sessions.get(a);o instanceof t&&o._fireDidChangeActive(l)}$onDidChangeSelection(a,l){const o=this._sessions.get(a);o instanceof t&&o._fireDidChangeSelection(l)}$onDidTriggerButton(a,l){const o=this._sessions.get(a);o&&o._fireDidTriggerButton(l)}$onDidHide(a){const l=this._sessions.get(a);l&&l._fireDidHide()}}class b{constructor(a,l){this._extensionId=a,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((l,o)=>{const w=l===y.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(w,l)}),this.update({buttons:a.map((l,o)=>({iconPath:v(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const l=this._handlesToButtons.get(a);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(a){if(!this._disposed){for(const l of Object.keys(a)){const o=a[l];this._pendingUpdate[l]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}b._nextId=1;function v(c){if(c instanceof y.ThemeIcon)return{id:c.id};const a=u(c),l=d(c);return{dark:typeof a=="string"?D.URI.file(a):a,light:typeof l=="string"?D.URI.file(l):l}}function d(c){return typeof c=="object"&&"light"in c?c.light:c}function u(c){return typeof c=="object"&&"dark"in c?c.dark:c}class t extends b{constructor(a,l,o){super(a,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((l,o)=>{this._handlesToItems.set(o,l),this._itemsToHandles.set(l,o)}),this.update({items:a.map((l,o)=>({label:l.label,description:l.description,handle:o,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(a){const l=(0,T.coalesce)(a.map(o=>this._handlesToItems.get(o)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(a){const l=(0,T.coalesce)(a.map(o=>this._handlesToItems.get(o)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class i extends b{constructor(a,l){super(a,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?k.default.Error:k.default.Ignore})}}return new m(r,s)}e.createExtHostQuickOpen=h}),define(ve[203],_e([0,1,2,3,52,6,14,5,11,110,19,26,33]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(a){if(a)return typeof a.iconPath=="string"?E.URI.file(a.iconPath):a.iconPath}function r(a,l){if(!a.iconPath&&!l.iconPath)return 0;if(a.iconPath){if(!l.iconPath)return 1}else return-1;const o=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,w=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,n.comparePaths)(o,w)}function s(a,l){let o=0;if(a.strikeThrough!==l.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==l.faded)return a.faded?1:-1;if(a.tooltip!==l.tooltip)return(a.tooltip||"").localeCompare(l.tooltip||"");if(o=r(a,l),o!==0)return o;if(a.light&&l.light)o=r(a.light,l.light);else{if(a.light)return 1;if(l.light)return-1}if(o!==0)return o;if(a.dark&&l.dark)o=r(a.dark,l.dark);else{if(a.dark)return 1;if(l.dark)return-1}return o}function _(a,l){if(a.command!==l.command)return a.command<l.command?-1:1;if(a.title!==l.title)return a.title<l.title?-1:1;if(a.tooltip!==l.tooltip){if(a.tooltip!==void 0&&l.tooltip!==void 0)return a.tooltip<l.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(a.arguments===l.arguments)return 0;if(a.arguments)if(l.arguments){if(a.arguments.length!==l.arguments.length)return a.arguments.length-l.arguments.length}else return 1;else return-1;for(let o=0;o<a.arguments.length;o++){const w=a.arguments[o],I=l.arguments[o];if(w!==I)return w<I?-1:1}return 0}function m(a,l){let o=(0,n.comparePaths)(a.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(o!==0)return o;if(a.command&&l.command)o=_(a.command,l.command);else{if(a.command)return 1;if(l.command)return-1}if(o!==0)return o;if(a.decorations&&l.decorations)o=s(a.decorations,l.decorations);else{if(a.decorations)return 1;if(l.decorations)return-1}return o}function b(a,l){for(let o=0;o<a.length;o++)if(a[o]!==l[o])return!1;return!0}function v(a,l){return a.command===l.command&&a.title===l.title&&a.tooltip===l.tooltip&&(a.arguments&&l.arguments?b(a.arguments,l.arguments):a.arguments===l.arguments)}function d(a,l){return(0,y.equals)(a,l,v)}class u{constructor(l,o,w){this._extension=l,this._proxy=o,this._sourceControlHandle=w,this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,h.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){(0,h.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,o){(0,h.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,o)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=u;class t{constructor(l,o,w,I,p){this._proxy=l,this._commands=o,this._sourceControlHandle=w,this._id=I,this._label=p,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,o){const w=this._resourceStatesCommandsMap.get(l);return w?(0,S.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],o)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const o=[...this._resourceStates].sort(m),I=(0,y.sortedDiff)(this._resourceSnapshot,o,m).map(R=>{const F=R.toInsert.map($=>{const ue=this._resourceHandlePool++;this._resourceStatesMap.set(ue,$);const z=$.resourceUri,B=f($.decorations),G=$.decorations&&f($.decorations.light)||B,M=$.decorations&&f($.decorations.dark)||B,N=[];let W;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ye=new A.DisposableStore;W=this._commands.converter.toInternal($.command,ye),this._resourceStatesDisposablesMap.set(ue,ye)}else this._resourceStatesCommandsMap.set(ue,$.command);G&&N.push(G),M&&M.toString()!==(G==null?void 0:G.toString())&&N.push(M);const Q=$.decorations&&$.decorations.tooltip||"",x=$.decorations&&!!$.decorations.strikeThrough,Z=$.decorations&&!!$.decorations.faded,re=$.contextValue||"";return{rawResource:[ue,z,N,Q,x,Z,re,W],handle:ue}});return{start:R.start,deleteCount:R.deleteCount,toInsert:F}}),p=I.map(({start:R,deleteCount:F,toInsert:$})=>[R,F,$.map(ue=>ue.rawResource)]),g=I.reverse();for(const{start:R,deleteCount:F,toInsert:$}of g){const ue=$.map(B=>B.handle),z=this._handlesSnapshot.splice(R,F,...ue);for(const B of z)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(l=this._resourceStatesDisposablesMap.get(B))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=o,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(l,o,w,I,p,g){this._proxy=o,this._commands=w,this._id=I,this._label=p,this._rootUri=g,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,I,p,g)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=l;const o=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:o})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&d(this._statusBarCommands,l))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=l;const o=(l||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:o})}}get selected(){return this._selected}createResourceGroup(l,o){const w=new t(this._proxy,this._commands,this.handle,l,o),I=C.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,I),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const l=[],o=[];for(const[w,I]of this.createdResourceGroups){I.dispose();const p=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});C.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),p.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),l.push([w.handle,w.id,w.label,w.features]);const g=w._takeResourceStateSnapshot();g.length>0&&o.push([w.handle,g]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,l,o),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(o=>{const w=o._takeResourceStateSnapshot();w.length!==0&&l.push([o.handle,w])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,qe([(0,P.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),qe([(0,P.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let c=class In{constructor(l,o,w){this._commands=o,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=l.getProxy(D.MainContext.MainThreadSCM),this._telemetry=l.getProxy(D.MainContext.MainThreadTelemetry),o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const p=this._sourceControls.get(I.sourceControlHandle);if(!p)return I;const g=p.getResourceGroup(I.groupHandle);return g?g.getResourceState(I.handle):I}else if(I&&I.$mid===4){const p=this._sourceControls.get(I.sourceControlHandle);return p?p.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const p=this._sourceControls.get(I.handle);return p||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,o,w,I){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,o,w,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const p=In._handlePool++,g=new i(l,this._proxy,this._commands,o,w,I);this._sourceControls.set(p,g);const R=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier))||[];return R.push(g),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(l.identifier),R),g}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const o=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier)),w=o&&o[o.length-1];return w&&w.inputBox}$provideOriginalResource(l,o,w){const I=E.URI.revive(o);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,I.toString());const p=this._sourceControls.get(l);return!p||!p.quickDiffProvider||!p.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>p.quickDiffProvider.provideOriginalResource(I,w)).then(g=>g||null)}$onInputBoxValueChange(l,o){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const w=this._sourceControls.get(l);return w&&w.inputBox.$onInputBoxValueChange(o),Promise.resolve(void 0)}$executeResourceCommand(l,o,w,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,o,w);const p=this._sourceControls.get(l);if(!p)return Promise.resolve(void 0);const g=p.getResourceGroup(o);return g?g.$executeResourceCommand(w,I):Promise.resolve(void 0)}$validateInput(l,o,w){this.logService.trace("ExtHostSCM#$validateInput",l);const I=this._sourceControls.get(l);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>I.inputBox.validateInput(o,w)).then(p=>p?Promise.resolve([p.message,p.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var o,w;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((o=this._sourceControls.get(l))===null||o===void 0||o.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((w=this._sourceControls.get(this._selectedSourceControlHandle))===null||w===void 0||w.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};c._handlePool=0,c=qe([Ge(2,T.ILogService)],c),e.ExtHostSCM=c});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[204],_e([0,1,7,5,133,6]),function(ee,e,E,C,P,A){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(h,f,r,s,_=E.StatusBarAlignment.Left,m,b){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,S,h,"f"),tt(this,D,f,"f"),this._id=y.ID_GEN++,this._statusId=r,this._statusName=s,this._alignment=_,this._priority=m,this._accessibilityInformation=b}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!y.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:xe(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:xe(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),xe(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(h=this._command)===null||h===void 0?void 0:h.internal,f,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,D=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry("status.extensionMessage",(0,P.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const f={message:h};return this._messages.unshift(f),this._update(),new E.Disposable(()=>{const r=this._messages.indexOf(f);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(h,f){this._proxy=h.getProxy(C.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new n(this)}createStatusBarEntry(h,f,r,s,_){return new y(this._proxy,this._commands,h,f,r,s,_)}setStatusBarMessage(h,f){const r=this._statusMessage.setMessage(h);let s;return typeof f=="number"?s=setTimeout(()=>r.dispose(),f):typeof f!="undefined"&&f.then(()=>r.dispose(),()=>r.dispose()),new E.Disposable(()=>{r.dispose(),clearTimeout(s)})}}e.ExtHostStatusBar=T}),define(ve[76],_e([0,1,5,3,4]),function(ee,e,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(D){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,n){return this._proxy.$getValue(D,y).then(T=>T||n)}setValue(D,y,n){return this._proxy.$setValue(D,y,n)}$acceptValue(D,y,n){this._onDidChangeStorage.fire({shared:D,key:y,value:n})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(ve[77],_e([0,1,4,27,19,75,2]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let D=class{constructor(n,T,k){var h;this._logService=T,this._extHostFileSystem=k,this._workspace=(h=n.workspace)!==null&&h!==void 0?h:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=S.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(h){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(h){this._logService.error("[ExtHostStorage]",h);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};D=qe([Ge(0,C.IExtHostInitDataService),Ge(1,P.ILogService),Ge(2,A.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[40],_e([0,1,3,5,4,2,15,6,7,134,10,171,20,29,154]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class s{constructor(t,i,c,a){this._proxy=t,this._id=i,this._creationOptions=c,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(o=>this._pidPromiseComplete=o);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(o,w=!0){l._checkDisposed(),l._proxy.$sendText(l._id,o,w)},show(o){l._checkDisposed(),l._proxy.$show(l._id,o)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,i,c,a,l,o,w,I,p,g,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:c,env:a,icon:l,initialText:o,waitOnExit:w,strictEnv:I,hideFromUser:p,isFeatureTerminal:g,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=s;class _{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let m=1,b=class extends D.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=i.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[c,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new s(this._proxy,(0,f.generateUuid)(),t,t.name),c=new _(t.pty);return i.createExtensionTerminal().then(a=>{const l=this._setupExtHostProcessListeners(a,c);this._terminalProcessDisposables[a]=l}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new _(i),l=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const c=this._getTerminalById(t);c&&(this._activeTerminal=c,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const c=this._getTerminalById(t);c&&this._onDidWriteTerminalData.fire({terminal:c.value,data:i})}async $acceptTerminalDimensions(t,i,c){const a=this._getTerminalById(t);a&&a.setDimensions(i,c)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,c){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,c)}async $acceptTerminalTitleChange(t,i){const c=this._getTerminalById(t);c&&(c.name=i)}async $acceptTerminalClosed(t,i){const c=this._getTerminalObjectIndexById(this._terminals,t);if(c!==null){const a=this._terminals.splice(c,1)[0];a.setExitCode(i),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,i,c,a){if(i){const w=this._getTerminalObjectIndexById(this._terminals,i);if(w!==null){this._terminals[w]._id=t,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const l={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:A.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},o=new s(this._proxy,t,l,c);this._terminals.push(o),this._onDidOpenTerminal.fire(o.value),o.isOpen=!0}async $acceptTerminalProcessId(t,i){const c=this._getTerminalById(t);c&&c._setProcessId(i)}async $startExtensionTerminal(t,i){const c=this._getTerminalById(t);if(!c)return{message:(0,n.localize)(0,null,t)};c.isOpen||await new Promise(l=>{const o=this.onDidOpenTerminal(async w=>{w===c.value&&(o.dispose(),l())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const c=new D.DisposableStore;c.add(i.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),c.add(i.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,i.onProcessData),c.add(i.onProcessExit(l=>this._onProcessExit(t,l))),i.onProcessOverrideDimensions&&c.add(i.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,i);const a=this._extensionTerminalAwaitingStart[t];return a&&i instanceof _&&(i.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),c}$acceptProcessAckDataEvent(t,i){var c;(c=this._terminalProcesses.get(t))===null||c===void 0||c.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var c;(c=this._terminalProcesses.get(t))===null||c===void 0||c.input(i)}$acceptProcessResize(t,i,c){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,c)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,i){var c;(c=this._terminalProcesses.get(t))===null||c===void 0||c.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(t,c))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(c=>this._proxy.$sendProcessCwd(t,c))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const c=this._getTerminalById(t);if(!c)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const l=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const o=[],w={terminal:c.value,line:i},I=[];for(const R of this._linkProviders)I.push(new Promise(async F=>{l.token.onCancellationRequested(()=>F({provider:R,links:[]}));const $=await R.provideTerminalLinks(w,l.token)||[];l.token.isCancellationRequested||F({provider:R,links:$})}));const p=await Promise.all(I);if(l.token.isCancellationRequested)return[];const g=new Map;for(const R of p)R&&R.links.length>0&&o.push(...R.links.map(F=>{const $={id:m++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return g.set($.id,{provider:R.provider,link:F}),$}));return this._terminalLinkCache.set(t,g),o}$activateLink(t,i){var c;const a=(c=this._terminalLinkCache.get(t))===null||c===void 0?void 0:c.get(i);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const c=this._terminalProcessDisposables[t];c&&(c.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const c=this._getTerminalObjectIndexById(t,i);return c!==null?t[c]:null}_getTerminalObjectIndexById(t,i){let c=null;return t.some((a,l)=>a._id===i?(c=l,!0):!1),c}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new v,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const c=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,c.length===0?void 0:c)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const c=i[0],a=new v(i[1]);this._setEnvironmentVariableCollection(c,a)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};b=qe([Ge(1,S.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class v{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const c=this.map.get(t);(!c||c.value!==i.value||c.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((c,a)=>t.call(i,a,c,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let d=class extends b{constructor(t){super(!1,t)}createTerminal(t,i,c){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){throw new T.NotSupportedError}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){throw new T.NotSupportedError}};d=qe([Ge(0,S.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d}),define(ve[205],_e([0,1,3,11,5,96,9,7]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(h=>h.value)}async showTextDocument(T,k,h){let f;typeof k=="number"?f={position:S.ViewColumn.from(k),preserveFocus:h}:typeof k=="object"?f={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?S.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:f={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(T.uri,f),s=r&&this._extHostDocumentsAndEditors.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new A.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const h=this._extHostDocumentsAndEditors.getEditor(T);if(!h)throw new Error("unknown text editor");if(k.options&&h._acceptOptions(k.options),k.selections){const f=k.selections.selections.map(S.Selection.to);h._acceptSelections(f)}if(k.visibleRanges){const f=C.coalesce(k.visibleRanges.map(S.Range.to));h._acceptVisibleRanges(f)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const f=D.TextEditorSelectionChangeKind.fromValue(k.selections.source),r=k.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:r,kind:f})}if(k.visibleRanges){const f=C.coalesce(k.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:f})}}$acceptEditorPositionData(T){for(const k in T){const h=this._extHostDocumentsAndEditors.getEditor(k);if(!h)throw new Error("Unknown text editor");const f=S.ViewColumn.to(T[k]);h.value.viewColumn!==f&&(h._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:f}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var $t=this&&this.__rest||function(ee,e){var E={};for(var C in ee)Object.prototype.hasOwnProperty.call(ee,C)&&e.indexOf(C)<0&&(E[C]=ee[C]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,C=Object.getOwnPropertySymbols(ee);P<C.length;P++)e.indexOf(C[P])<0&&Object.prototype.propertyIsEnumerable.call(ee,C[P])&&(E[C[P]]=ee[C[P]]);return E};define(ve[206],_e([0,1,2,4,5,6,7]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class D{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:h=>{var f,r;if(h&&h.$mid===11){const s=h.uri===void 0?void 0:E.URI.revive(h.uri);return(r=(f=this._itemsBySourceAndUriMap.get(h.source))===null||f===void 0?void 0:f.get(y(s)))===null||r===void 0?void 0:r.get(h.handle)}return h}})}async $getTimeline(T,k,h,f,r){const s=this._providers.get(T);return s==null?void 0:s.provideTimeline(E.URI.revive(k),h,f,r)}registerTimelineProvider(T,k,h,f){const r=new A.DisposableStore,s=this.convertTimelineItem(k.id,f,r).bind(this);let _;k.onDidChange&&(_=k.onDidChange(b=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},b),{id:k.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(b,v,d,u){var t;(u==null?void 0:u.resetCache)&&(r.clear(),(t=m.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(b,v,d);if(i!=null){const c=s(b,u);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(c)})}},dispose(){var b;for(const v of m.values())(b=v.get(k.id))===null||b===void 0||b.clear();_==null||_.dispose(),r.dispose()}}))}convertTimelineItem(T,k,h){return(f,r)=>{let s;if(r==null?void 0:r.cacheResults){let _=this._itemsBySourceAndUriMap.get(T);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(T,_));const m=y(f);s=_.get(m),s===void 0&&(s=new Map,_.set(m,s))}return _=>{var m,b;const{iconPath:v}=_,d=$t(_,["iconPath"]),u=`${T}|${(m=_.id)!==null&&m!==void 0?m:_.timestamp}`;s==null||s.set(u,_);let t,i,c;return _.iconPath&&(v instanceof S.ThemeIcon?c={id:v.id}:E.URI.isUri(v)?(t=v,i=v):{light:t,dark:i}=v),Object.assign(Object.assign({},d),{id:(b=d.id)!==null&&b!==void 0?b:void 0,handle:u,source:T,command:_.command?k.toInternal(_.command,h):void 0,icon:t,iconDark:i,themeIcon:c,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,A.toDisposable)(()=>{var h;for(const f of this._itemsBySourceAndUriMap.values())(h=f.get(T.id))===null||h===void 0||h.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=D;function y(n){return n==null?void 0:n.toString()}}),define(ve[207],_e([0,1,6,18,2,5]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const h=k.schemes.find(f=>!S.supportedSchemes.has(f));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,y,k.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const h=P.URI.revive(n);return k.canOpenExternalUri(h,T)}async $openUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(P.URI.revive(n.resolvedUri),{sourceUri:P.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(ve[208],_e([0,1,5,2,6,10,26]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=D.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,P.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(C.URI.revive(T))}catch(h){(0,A.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(n){return C.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[50],_e([0,1,23,3,2,143,164,49,5]),function(ee,e,E,C,P,A,S,D,y){"use strict";var n,T,k,h,f,r,s,_,m,b,v,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(p,g,R,F,$,ue,z){n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),h.set(this,void 0),f.set(this,void 0),r.set(this,void 0),s.set(this,""),_.set(this,void 0),m.set(this,!1),b.set(this,!1),v.set(this,!1),this._onMessageEmitter=new C.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new C.Emitter),this._onDidDispose=xe(this,d,"f").event,tt(this,n,p,"f"),tt(this,T,g,"f"),tt(this,_,R,"f"),tt(this,h,F,"f"),tt(this,f,$,"f"),tt(this,r,ue,"f"),tt(this,v,t(ue),"f"),tt(this,k,z,"f")}dispose(){tt(this,m,!0,"f"),xe(this,d,"f").fire(),xe(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return tt(this,b,!0,"f"),(0,D.asWebviewUri)(xe(this,h,"f"),xe(this,n,"f"),p)}get cspSource(){return xe(this,h,"f").webviewCspSource.replace("{{uuid}}",xe(this,n,"f"))}get html(){return this.assertNotDisposed(),xe(this,s,"f")}set html(p){this.assertNotDisposed(),xe(this,s,"f")!==p&&(tt(this,s,p,"f"),!xe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(tt(this,b,!0,"f"),xe(this,k,"f").report("Webview vscode-resource: uris",xe(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,T,"f").$setHtml(xe(this,n,"f"),p))}get options(){return this.assertNotDisposed(),xe(this,_,"f")}set options(p){this.assertNotDisposed(),xe(this,T,"f").$setOptions(xe(this,n,"f"),l(xe(this,r,"f"),xe(this,f,"f"),p)),tt(this,_,p,"f")}async postMessage(p){if(xe(this,m,"f"))return!1;const g=i(p,{serializeBuffersForPostMessage:xe(this,v,"f")});return xe(this,T,"f").$postMessage(xe(this,n,"f"),g.message,...g.buffers)}assertNotDisposed(){if(xe(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,n=new WeakMap,T=new WeakMap,k=new WeakMap,h=new WeakMap,f=new WeakMap,r=new WeakMap,s=new WeakMap,_=new WeakMap,m=new WeakMap,b=new WeakMap,v=new WeakMap,d=new WeakMap;function t(I){if(!I.enableProposedApi)return!1;try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(I.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=56}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(I,p){if(p.serializeBuffersForPostMessage){const g=[],R=($,ue)=>{if(ue&&ue instanceof ArrayBuffer){let z=g.findIndex(B=>B.original===ue);if(z===-1){const B=new Uint8Array(ue),G=E.VSBuffer.wrap(B);z=g.length,g.push({original:ue,vsBuffer:G})}return{$$vscode_array_buffer_reference$$:!0,index:z}}return ue};return{message:JSON.stringify(I,R),buffers:g.map($=>$.vsBuffer)}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeMessage=i;class c{constructor(p,g,R,F,$){this.initData=g,this.workspace=R,this._logService=F,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,g,...R){const F=this.getWebview(p);if(F){const{message:$}=(0,S.deserializeWebviewMessage)(g,R);F._onMessageEmitter.fire($)}}$onMissingCsp(p,g){this._logService.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,g,R){const F=new u(p,this._webviewProxy,o(g),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(p,F),F._onDidDispose(()=>{this._webviews.delete(p)}),F}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=c;function a(I){return{id:I.identifier,location:I.extensionLocation}}e.toExtensionData=a;function l(I,p,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||w(I,p)}}e.serializeWebviewOptions=l;function o(I){var p;return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,portMapping:I.portMapping,localResourceRoots:(p=I.localResourceRoots)===null||p===void 0?void 0:p.map(g=>P.URI.from(g))}}e.reviveOptions=o;function w(I,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(g=>g.uri),I.extensionLocation]}}),define(ve[209],_e([0,1,20,57,6,18,25,2,9,50,68,5,7]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,c){const a=this.key(t,i.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const l=new f(i,c);return this._documents.set(a,l),l}delete(t,i){const c=this.key(t,i.uri);this._documents.delete(c)}key(t,i){return`${t}@@@${i}`}}var s;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(s||(s={}));class _{constructor(){this._providers=new Map}addTextProvider(t,i,c){return this.add(0,t,i,c)}addCustomProvider(t,i,c){return this.add(1,t,i,c)}get(t){return this._providers.get(t)}add(t,i,c,a){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:c,provider:a}),new h.Disposable(()=>this._providers.delete(i))}}class m{constructor(t,i,c,a,l){this._extHostDocuments=i,this._extensionStoragePaths=c,this._extHostWebview=a,this._extHostWebviewPanels=l,this._editorProviders=new _,this._documents=new r,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,c,a){const l=new P.DisposableStore;return b(c)?(l.add(this._editorProviders.addTextProvider(i,t,c)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,a.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,n.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(i,t,c)),this.supportEditing(c)&&l.add(c.onDidChangeCustomDocument(o=>{const w=this.getCustomDocumentEntry(i,o.document.uri);if(v(o)){const I=w.addEdit(o);this._proxy.$onDidEdit(o.document.uri,i,I,o.label)}else this._proxy.$onContentChange(o.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,n.shouldSerializeBuffersForPostMessage)(t))),h.Disposable.from(l,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,c,a,l){var o;const w=this._editorProviders.get(i);if(!w)throw new Error(`No provider found for '${i}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${i}'`);const I=D.URI.revive(t),p=await w.provider.openCustomDocument(I,{backupId:c,untitledDocumentData:a==null?void 0:a.buffer},l);let g;return this.supportEditing(w.provider)&&this._extensionStoragePaths&&(g=(o=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&o!==void 0?o:this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(i,p,g),{editable:this.supportEditing(w.provider)}}async $disposeCustomDocument(t,i){const c=this._editorProviders.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${i}'`);const a=D.URI.revive(t),{document:l}=this.getCustomDocumentEntry(i,a);this._documents.delete(i,l),l.dispose()}async $resolveWebviewEditor(t,i,c,a,l,o){const w=this._editorProviders.get(c);if(!w)throw new Error(`No provider found for '${c}'`);const I=y.ViewColumn.to(l),p=this._extHostWebview.createNewWebview(i,a.webviewOptions,w.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(i,c,a.title,I,a.panelOptions,p),R=D.URI.revive(t);switch(w.type){case 1:{const{document:F}=this.getCustomDocumentEntry(c,R);return w.provider.resolveCustomEditor(F,g,o)}case 0:{const F=this._extHostDocuments.getDocument(R);return w.provider.resolveCustomTextEditor(F,g,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,c){this.getCustomDocumentEntry(i,t).disposeEdits(c)}async $onMoveCustomEditor(t,i,c){const a=this._editorProviders.get(c);if(!a)throw new Error(`No provider found for '${c}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const o=D.URI.revive(i),w=this._extHostDocuments.getDocument(o);await a.provider.moveCustomTextEditor(w,l,E.CancellationToken.None)}async $undo(t,i,c,a){return this.getCustomDocumentEntry(i,t).undo(c,a)}async $redo(t,i,c,a){return this.getCustomDocumentEntry(i,t).redo(c,a)}async $revert(t,i,c){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(a.document,c),a.disposeBackup()}async $onSave(t,i,c){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(a.document,c),a.disposeBackup()}async $onSaveAs(t,i,c,a){const l=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(l.document,D.URI.revive(c),a)}async $backup(t,i,c){const a=this.getCustomDocumentEntry(i,t),o=await this.getCustomEditorProvider(i).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},c);return a.updateBackup(o),o.id}getCustomDocumentEntry(t,i){const c=this._documents.get(t,D.URI.revive(i));if(!c)throw new Error("No custom document found");return c}getCustomEditorProvider(t){const i=this._editorProviders.get(t),c=i==null?void 0:i.provider;if(!c||!this.supportEditing(c))throw new Error("Custom document is not editable");return c}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function b(u){return typeof u.resolveCustomTextEditor=="function"}function v(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function d(u){const t=u.scheme===A.Schemas.file||u.scheme===A.Schemas.untitled?u.fsPath:u.toString();return(0,C.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[210],_e([0,1,3,6,2,29,9,50,5,7]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";var T,k,h,f,r,s,_,m,b,v,d,u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends C.Disposable{constructor(o,w,I,p,g,R,F){super();T.set(this,void 0),k.set(this,void 0),h.set(this,void 0),f.set(this,void 0),r.set(this,void 0),s.set(this,void 0),_.set(this,void 0),m.set(this,void 0),b.set(this,!0),v.set(this,!0),d.set(this,!1),u.set(this,this._register(new E.Emitter)),this.onDidDispose=xe(this,u,"f").event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,tt(this,T,o,"f"),tt(this,k,w,"f"),tt(this,h,I,"f"),tt(this,r,R,"f"),tt(this,m,g,"f"),tt(this,s,p,"f"),tt(this,f,F,"f")}dispose(){xe(this,d,"f")||(tt(this,d,!0,"f"),xe(this,u,"f").fire(),xe(this,k,"f").$disposeWebview(xe(this,T,"f")),xe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,f,"f")}get viewType(){return this.assertNotDisposed(),xe(this,h,"f")}get title(){return this.assertNotDisposed(),xe(this,s,"f")}set title(o){this.assertNotDisposed(),xe(this,s,"f")!==o&&(tt(this,s,o,"f"),xe(this,k,"f").$setTitle(xe(this,T,"f"),o))}get iconPath(){return this.assertNotDisposed(),xe(this,_,"f")}set iconPath(o){this.assertNotDisposed(),xe(this,_,"f")!==o&&(tt(this,_,o,"f"),xe(this,k,"f").$setIconPath(xe(this,T,"f"),P.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return xe(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,m,"f")=="number"&&xe(this,m,"f")<0))return xe(this,m,"f")}get active(){return this.assertNotDisposed(),xe(this,v,"f")}get visible(){return this.assertNotDisposed(),xe(this,b,"f")}_updateViewState(o){xe(this,d,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(tt(this,v,o.active,"f"),tt(this,b,o.visible,"f"),tt(this,m,o.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(o,w){this.assertNotDisposed(),xe(this,k,"f").$reveal(xe(this,T,"f"),{viewColumn:o?S.ViewColumn.from(o):void 0,preserveFocus:!!w})}assertNotDisposed(){if(xe(this,d,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,h=new WeakMap,f=new WeakMap,r=new WeakMap,s=new WeakMap,_=new WeakMap,m=new WeakMap,b=new WeakMap,v=new WeakMap,d=new WeakMap,u=new WeakMap,t=new WeakMap;class c{constructor(o,w,I){this.webviews=w,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(o,w,I,p,g={}){const R=typeof p=="object"?p.viewColumn:p,F={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof p=="object"&&!!p.preserveFocus},$=(0,D.shouldSerializeBuffersForPostMessage)(o),ue=c.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(o),ue,w,{title:I,panelOptions:a(g),webviewOptions:(0,D.serializeWebviewOptions)(o,this.workspace,g),serializeBuffersForPostMessage:$},F);const z=this.webviews.createNewWebview(ue,g,o);return this.createNewWebviewPanel(ue,w,I,R,g,z)}$onDidChangeWebviewPanelViewStates(o){const w=Object.keys(o);w.sort((I,p)=>{const g=o[I],R=o[p];return g.active?1:R.active?-1:+g.visible-+R.visible});for(const I of w){const p=this.getWebviewPanel(I);if(!!p){const g=o[I];p._updateViewState({active:g.active,visible:g.visible,viewColumn:S.ViewColumn.to(g.position)})}}}async $onDidDisposeWebviewPanel(o){const w=this.getWebviewPanel(o);w==null||w.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,w,I){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:I,extension:o}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(o)}),new n.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(o,w,I,p){const g=this._serializers.get(w);if(!g)throw new Error(`No serializer found for '${w}'`);const{serializer:R,extension:F}=g,$=this.webviews.createNewWebview(o,I.webviewOptions,F),ue=this.createNewWebviewPanel(o,w,I.title,p,I.panelOptions,$);await R.deserializeWebviewPanel(ue,I.state)}createNewWebviewPanel(o,w,I,p,g,R){const F=new i(o,this._proxy,w,I,p,g,R);return this._webviewPanels.set(o,F),F}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=c;function a(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[211],_e([0,1,3,6,50,5,7]),function(ee,e,E,C,P,A,S){"use strict";var D,y,n,T,k,h,f,r,s,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends C.Disposable{constructor(d,u,t,i,c,a){super();D.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),h.set(this,void 0),f.set(this,void 0),r.set(this,void 0),s.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=xe(this,s,"f").event,_.set(this,this._register(new E.Emitter)),this.onDidDispose=xe(this,_,"f").event,tt(this,n,t,"f"),tt(this,f,i,"f"),tt(this,D,d,"f"),tt(this,y,u,"f"),tt(this,T,c,"f"),tt(this,h,a,"f")}dispose(){xe(this,k,"f")||(tt(this,k,!0,"f"),xe(this,_,"f").fire(),xe(this,T,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,f,"f")}set title(d){this.assertNotDisposed(),xe(this,f,"f")!==d&&(tt(this,f,d,"f"),xe(this,y,"f").$setWebviewViewTitle(xe(this,D,"f"),d))}get description(){return this.assertNotDisposed(),xe(this,r,"f")}set description(d){this.assertNotDisposed(),xe(this,r,"f")!==d&&(tt(this,r,d,"f"),xe(this,y,"f").$setWebviewViewDescription(xe(this,D,"f"),d))}get visible(){return xe(this,h,"f")}get webview(){return xe(this,T,"f")}get viewType(){return xe(this,n,"f")}_setVisible(d){d===xe(this,h,"f")||xe(this,k,"f")||(tt(this,h,d,"f"),xe(this,s,"f").fire())}show(d){this.assertNotDisposed(),xe(this,y,"f").$show(xe(this,D,"f"),!!d)}assertNotDisposed(){if(xe(this,k,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,h=new WeakMap,f=new WeakMap,r=new WeakMap,s=new WeakMap,_=new WeakMap;class b{constructor(d,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,u,t,i){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(d),u,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(d,u,t,i,c){const a=this._viewProviders.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:l,extension:o}=a,w=this._extHostWebview.createNewWebview(d,{},o),I=new m(d,this._proxy,u,t,w,!0);this._webviewViews.set(d,I),await l.resolveWebviewView(I,{state:i},c)}async $onDidChangeWebviewViewVisibility(d,u){this.getWebviewView(d)._setVisible(u)}async $disposeWebviewView(d){const u=this.getWebviewView(d);this._webviewViews.delete(d),u.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const u=this._webviewViews.get(d);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=b}),define(ve[100],_e([0,1,3,5,2,18,8,4,15]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Pn{constructor(k){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Pn.InitialState,this._proxy=k.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,h){let f;if(typeof k=="string"){f=k;try{k=P.URI.parse(k)}catch(r){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,S.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,f,h)}async asExternalUri(k,h){if((0,S.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const f=await this._proxy.$asExternalUri(k,h);return P.URI.from(f)}};n.InitialState={focused:!0},n=qe([Ge(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[212],_e([0,1,19,5,27,15]),function(ee,e,E,C,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends E.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(C.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=E.LogLevel.Trace&&this._proxy.$log(this._logFile,E.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=E.LogLevel.Debug&&this._proxy.$log(this._logFile,E.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=E.LogLevel.Info&&this._proxy.$log(this._logFile,E.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=E.LogLevel.Warning&&this._proxy.$log(this._logFile,E.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=E.LogLevel.Error&&this._proxy.$log(this._logFile,E.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=E.LogLevel.Critical&&this._proxy.$log(this._logFile,E.LogLevel.Critical,Array.from(arguments))}flush(){}};S=qe([Ge(0,A.IExtHostRpcService),Ge(1,P.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(ve[213],_e([0,1,14,20,10,3,6,111,185,97,23]),function(ee,e,E,C,P,A,S,D,y,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function h(a,l){try{return JSON.stringify(a,l)}catch(o){return"null"}}function f(a,l){return JSON.stringify(a,l)}function r(a){return a?(l,o)=>o&&o.$mid===1?a.transformOutgoing(o):o:null}var s;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},b=Symbol.for("rpcProtocol"),v=Symbol.for("rpcProxy");class d extends S.Disposable{constructor(l,o=null,w=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=o,this._uriTransformer=w,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let I=0,p=n.ProxyIdentifier.count;I<p;I++)this._locals[I]=null,this._proxies[I]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(I=>this._receiveOneMessage(I))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,D.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:o,sid:w}=l;return this._proxies[o]||(this._proxies[o]=this._createProxy(o,w)),this._proxies[o]}_createProxy(l,o){let w={get:(I,p)=>(typeof p=="string"&&!I[p]&&p.charCodeAt(0)===36&&(I[p]=(...g)=>this._remoteCall(l,p,g)),p===v?o:I[p])};return new Proxy(Object.create(null),w)}set(l,o){return this._locals[l.nid]=o,o}assertRegistered(l){for(let o=0,w=l.length;o<w;o++){const I=l[o];if(!this._locals[I.nid])throw new Error(`Missing actor ${I.sid} (isMain: ${I.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const o=l.byteLength,w=u.read(l,0),I=w.readUInt8(),p=w.readUInt32();switch(I){case 1:case 2:{let{rpcId:g,method:R,args:F}=t.deserializeRequestJSONArgs(w);this._uriTransformer&&(F=(0,D.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(o,p,g,R,F,I===2);break}case 3:case 4:{let{rpcId:g,method:R,args:F}=t.deserializeRequestMixedArgs(w);this._uriTransformer&&(F=(0,D.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(o,p,g,R,F,I===4);break}case 5:{this._logger&&this._logger.logIncoming(o,p,0,"ack"),this._onDidReceiveAcknowledge(p);break}case 6:{this._receiveCancel(o,p);break}case 7:{this._receiveReply(o,p,void 0);break}case 9:{let g=t.deserializeReplyOKJSON(w);this._uriTransformer&&(g=(0,D.transformIncomingURIs)(g,this._uriTransformer)),this._receiveReply(o,p,g);break}case 8:{let g=t.deserializeReplyOKVSBuffer(w);this._receiveReply(o,p,g);break}case 10:{let g=t.deserializeReplyErrError(w);this._uriTransformer&&(g=(0,D.transformIncomingURIs)(g,this._uriTransformer)),this._receiveReplyErr(o,p,g);break}case 11:{this._receiveReplyErr(o,p,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,o,w,I,p,g){this._logger&&this._logger.logIncoming(l,o,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(w)}.${I}(`,p);const R=String(o);let F,$;if(g){const z=new C.CancellationTokenSource;p.push(z.token),F=this._invokeHandler(w,I,p),$=()=>z.cancel()}else F=this._invokeHandler(w,I,p),$=m;this._cancelInvokedHandlers[R]=$;const ue=t.serializeAcknowledged(o);this._logger&&this._logger.logOutgoing(ue.byteLength,o,1,"ack"),this._protocol.send(ue),F.then(z=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyOK(o,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,o,1,"reply:",z),this._protocol.send(B)},z=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyErr(o,z);this._logger&&this._logger.logOutgoing(B.byteLength,o,1,"replyErr:",z),this._protocol.send(B)})}_receiveCancel(l,o){this._logger&&this._logger.logIncoming(l,o,1,"receiveCancel");const w=String(o);this._cancelInvokedHandlers[w]&&this._cancelInvokedHandlers[w]()}_receiveReply(l,o,w){this._logger&&this._logger.logIncoming(l,o,0,"receiveReply:",w);const I=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const p=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I],p.resolveOk(w)}}_receiveReplyErr(l,o,w){this._logger&&this._logger.logIncoming(l,o,0,"receiveReplyErr:",w);const I=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const p=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I];let g;w&&(w.$isError?(g=new Error,g.name=w.name,g.message=w.message,g.stack=w.stack):g=w),p.resolveErr(g)}}_invokeHandler(l,o,w){try{return Promise.resolve(this._doInvokeHandler(l,o,w))}catch(I){return Promise.reject(I)}}_doInvokeHandler(l,o,w){const I=this._locals[l];if(!I)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(l));let p=I[o];if(typeof p!="function")throw new Error("Unknown method "+o+" on actor "+(0,n.getStringIdentifierForProxy)(l));return p.apply(I,w)}_remoteCall(l,o,w){if(this._isDisposed)return Promise.reject(P.canceled());let I=null;if(w.length>0&&C.CancellationToken.isCancellationToken(w[w.length-1])&&(I=w.pop()),I&&I.isCancellationRequested)return Promise.reject(P.canceled());const p=t.serializeRequestArguments(w,this._uriReplacer),g=++this._lastMessageId,R=String(g),F=new y.LazyPromise;I&&I.onCancellationRequested(()=>{const ue=t.serializeCancel(g);this._logger&&this._logger.logOutgoing(ue.byteLength,g,0,"cancel"),this._protocol.send(t.serializeCancel(g))}),this._pendingRPCReplies[R]=F,this._onWillSendRequest(g);const $=t.serializeRequest(g,l,o,p,!!I);return this._logger&&this._logger.logOutgoing($.byteLength,g,0,`request: ${(0,n.getStringIdentifierForProxy)(l)}.${o}(`,w),this._protocol.send($),F}}e.RPCProtocol=d,k=b,d.UNRESPONSIVE_TIME=3*1e3;class u{constructor(l,o){this._buff=l,this._offset=o}static alloc(l,o,w){let I=new u(T.VSBuffer.alloc(w+1+4),0);return I.writeUInt8(l),I.writeUInt32(o),I}static read(l,o){return new u(l,o)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const w=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,w}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,w}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const o=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,o}static sizeMixedArray(l,o){let w=0;w+=1;for(let I=0,p=l.length;I<p;I++){const g=l[I],R=o[I];switch(w+=1,R){case 1:w+=this.sizeLongString(g);break;case 2:w+=this.sizeVSBuffer(g);break;case 3:break}}return w}writeMixedArray(l,o){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let w=0,I=l.length;w<I;w++){const p=l[w];switch(o[w]){case 1:this.writeUInt8(1),this.writeLongString(p);break;case 2:this.writeUInt8(2),this.writeVSBuffer(p);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let o=new Array(l);for(let w=0;w<l;w++)switch(this.readUInt8()){case 1:o[w]=this.readLongString();break;case 2:o[w]=this.readVSBuffer();break;case 3:o[w]=void 0;break}return o}}class t{static _arrayContainsBufferOrUndefined(l){for(let o=0,w=l.length;o<w;o++)if(l[o]instanceof T.VSBuffer||typeof l[o]=="undefined")return!0;return!1}static serializeRequestArguments(l,o){if(this._arrayContainsBufferOrUndefined(l)){let w=[],I=[];for(let p=0,g=l.length;p<g;p++){const R=l[p];R instanceof T.VSBuffer?(w[p]=R,I[p]=2):typeof R=="undefined"?(w[p]=T.VSBuffer.alloc(0),I[p]=3):(w[p]=T.VSBuffer.fromString(f(R,o)),I[p]=1)}return{type:"mixed",args:w,argsType:I}}return{type:"simple",args:f(l,o)}}static serializeRequest(l,o,w,I,p){return I.type==="mixed"?this._requestMixedArgs(l,o,w,I.args,I.argsType,p):this._requestJSONArgs(l,o,w,I.args,p)}static _requestJSONArgs(l,o,w,I,p){const g=T.VSBuffer.fromString(w),R=T.VSBuffer.fromString(I);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(g),F+=u.sizeLongString(R);let $=u.alloc(p?2:1,l,F);return $.writeUInt8(o),$.writeShortString(g),$.writeLongString(R),$.buffer}static deserializeRequestJSONArgs(l){const o=l.readUInt8(),w=l.readShortString(),I=l.readLongString();return{rpcId:o,method:w,args:JSON.parse(I)}}static _requestMixedArgs(l,o,w,I,p,g){const R=T.VSBuffer.fromString(w);let F=0;F+=u.sizeUInt8(),F+=u.sizeShortString(R),F+=u.sizeMixedArray(I,p);let $=u.alloc(g?4:3,l,F);return $.writeUInt8(o),$.writeShortString(R),$.writeMixedArray(I,p),$.buffer}static deserializeRequestMixedArgs(l){const o=l.readUInt8(),w=l.readShortString(),I=l.readMixedArray(),p=new Array(I.length);for(let g=0,R=I.length;g<R;g++){const F=I[g];typeof F=="string"?p[g]=JSON.parse(F):p[g]=F}return{rpcId:o,method:w,args:p}}static serializeAcknowledged(l){return u.alloc(5,l,0).buffer}static serializeCancel(l){return u.alloc(6,l,0).buffer}static serializeReplyOK(l,o,w){return typeof o=="undefined"?this._serializeReplyOKEmpty(l):o instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(l,o):this._serializeReplyOKJSON(l,h(o,w))}static _serializeReplyOKEmpty(l){return u.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,o){let w=0;w+=u.sizeVSBuffer(o);let I=u.alloc(8,l,w);return I.writeVSBuffer(o),I.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,o){const w=T.VSBuffer.fromString(o);let I=0;I+=u.sizeLongString(w);let p=u.alloc(9,l,I);return p.writeLongString(w),p.buffer}static deserializeReplyOKJSON(l){const o=l.readLongString();return JSON.parse(o)}static serializeReplyErr(l,o){return o?this._serializeReplyErrEror(l,o):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,o){const w=T.VSBuffer.fromString(h(P.transformErrorForSerialization(o),null));let I=0;I+=u.sizeLongString(w);let p=u.alloc(10,l,I);return p.writeLongString(w),p.buffer}static deserializeReplyErrError(l){const o=l.readLongString();return JSON.parse(o)}static _serializeReplyErrEmpty(l){return u.alloc(11,l,0).buffer}}var i;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var c;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(c||(c={}))}),define(ve[214],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const E=function(A){const S=D=>{self.removeEventListener("message",S);const y=D.data;Object.defineProperties(self,{postMessage:{value(n,T){y.postMessage(n,T)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",S)}.toString();class C extends EventTarget{constructor(A,S,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${E})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),T=URL.createObjectURL(n),k=new MessageChannel,h=T,f={type:"_newWorker",id:h,port:k.port2,url:T,options:D};A(f,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:h};k.port1.postMessage(r),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(r){k.port1.onmessage=r}},onmessageerror:{get(){return k.port1.onmessageerror},set(r){k.port1.onmessageerror=r}}}),k.port1.addEventListener("messageerror",r=>{const s=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",r=>{const s=new MessageEvent("message",{data:r.data});this.dispatchEvent(s)}),k.port1.start()}}e.NestedWorker=C}),define(ve[215],_e([0,1,4]),function(ee,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ve[216],_e([0,1,18,12,21,2,4,215]),function(ee,e,E,C,P,A,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const h=await this.remoteAgentService.getEnvironment();return(h==null?void 0:h.os)||P.OS})(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(h==null?void 0:h.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?C.win32:C.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const f=T.indexOf("/",2);f===-1?(k=T.substring(2),T="/"):(k=T.substring(2,f),T=T.substring(f)||"/")}return A.URI.from({scheme:E.Schemas.file,authority:k,path:T,query:"",fragment:""})}};y=qe([Ge(1,D.IRemoteAgentService)],y),e.AbstractPathService=y}),define(ve[41],_e([0,1,11,28,24,37,8,4,12,10]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",h=(T.length+k.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var f;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function s(M){return!!M.preview}e.resultIsMatch=s;function _(M){return!!M.resource}e.isFileMatch=_;function m(M){return!!M.message}e.isProgressMessage=m;var b;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=v;class d{constructor(N,W,Q){this.ranges=W;const x=Array.isArray(W)?W:[W];if(Q&&Q.matchLines===1&&u(x)){N=(0,S.getNLines)(N,Q.matchLines);let Z="",re=0,oe=0;const ye=Math.floor(Q.charsPerLine/5),Pe=[];for(const Be of x){const Re=Math.max(Be.startColumn-ye,0),ze=Be.startColumn+Q.charsPerLine;if(Re>oe+ye+h){const U=T+(Re-oe)+k;Z+=U+N.slice(Re,ze),re+=Re-(oe+U.length)}else Z+=N.slice(oe,ze);Pe.push(new i(0,Be.startColumn-re,Be.endColumn-re)),oe=ze}this.preview={text:Z,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const Z=Array.isArray(W)?W[0].startLineNumber:W.startLineNumber;this.preview={text:N,matches:(0,E.mapArrayOrNot)(W,re=>new t(re.startLineNumber-Z,re.startColumn,re.endLineNumber-Z,re.endColumn))}}}}e.TextSearchMatch=d;function u(M){const N=M[0].startLineNumber;for(const W of M)if(W.startLineNumber!==N||W.endLineNumber!==N)return!1;return!0}class t{constructor(N,W,Q,x){this.startLineNumber=N,this.startColumn=W,this.endLineNumber=Q,this.endColumn=x}}e.SearchRange=t;class i extends t{constructor(N,W,Q){super(N,W,N,Q)}}e.OneLineRange=i;var c;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function a(M,N=!0){const W=M&&M.files&&M.files.exclude,Q=N&&M&&M.search&&M.search.exclude;if(!(!W&&!Q)){if(!W||!Q)return W||Q;let x=Object.create(null);return x=P.mixin(x,P.deepClone(W)),x=P.mixin(x,P.deepClone(Q),!0),x}}e.getExcludes=a;function l(M,N){return M.excludePattern&&C.match(M.excludePattern,N)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&C.match(M.includePattern,N)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(W=>{const Q=W.folder.fsPath;if(A.isEqualOrParent(N,Q)){const x=y.relative(Q,N);return!W.includePattern||!!C.match(W.includePattern,x)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var o;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(o=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(N,W){super(N);this.code=W}}e.SearchError=w;function I(M){const N=M.message;if((0,n.isPromiseCanceledError)(M))return new w(N,o.canceled);try{const W=JSON.parse(N);return new w(W.message,W.code)}catch(W){return new w(N,o.other)}}e.deserializeSearchError=I;function p(M){const N={message:M.message,code:M.code};return new Error(JSON.stringify(N))}e.serializeSearchError=p;function g(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=g;function R(M){return M.type==="success"}e.isSerializedSearchSuccess=R;function F(M){return!!M.path}e.isSerializedFileMatch=F;function $(M,N){const W=M.searchPath?M.searchPath:M.relativePath;return(0,S.fuzzyContains)(W,N)}e.isFilePatternMatch=$;class ue{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ue;function z(M,N){const W=Object.assign(Object.assign({},M||{}),N||{});return Object.keys(W).filter(Q=>{const x=W[Q];return typeof x=="boolean"&&x})}e.resolvePatternsForProvider=z;class B{constructor(N,W){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),W.excludePattern||{}),this._parsedExcludeExpression=C.parse(this._excludeExpression);let Q=N.includePattern;W.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),W.includePattern):Q=W.includePattern),Q&&(this._parsedIncludeExpression=C.parse(Q))}includedInQuerySync(N,W,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,W,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,W,Q))}includedInQuery(N,W,Q){return Promise.resolve(this._parsedExcludeExpression(N,W,Q)).then(Z=>!!Z).then(Z=>Z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,W,Q)).then(re=>!!re):Promise.resolve(!0)).then(Z=>Z)}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=B;function G(M){for(const N in M)if(typeof M[N]!="boolean")return!0;return!1}}),define(ve[31],_e([0,1,11,14,20,3,22,18,79,25,8,13,2,136,4,19,151,47,48,27,15,7,41,5]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v,d,u,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(R,F,$){return new n.ExtUri(ue=>w(ue,$)).isEqual(R,F)}function a(R,F,$){return c(R.uri,F.uri,$)?0:(0,T.compare)(R.uri.toString(),F.uri.toString())}function l(R,F,$){return R.index!==F.index?R.index<F.index?-1:1:c(R.uri,F.uri,$)?(0,T.compare)(R.name,F.name):(0,T.compare)(R.uri.toString(),F.uri.toString())}function o(R,F,$,ue){const z=R.slice(0).sort((G,M)=>$(G,M,ue)),B=F.slice(0).sort((G,M)=>$(G,M,ue));return(0,E.delta)(z,B,(G,M)=>$(G,M,ue))}function w(R,F){const $=F.getCapabilities(R.scheme);return!($&&$&1024)}class I extends m.Workspace{constructor(F,$,ue,z,B,G){super(F,ue.map(M=>new m.WorkspaceFolder(M)),z,G);this._name=$,this._isUntitled=B,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(G),ue.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(F,$,ue,z){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:G,folders:M,configuration:N,isUntitled:W}=F,Q=[],x=$;$?M.forEach((ye,Pe)=>{const Be=h.URI.revive(ye.uri),Re=I._findFolder(ue||$,Be,z);Re?(Re.name=ye.name,Re.index=ye.index,Q.push(Re)):Q.push({uri:Be,name:ye.name,index:Pe})}):Q.push(...M.map(({uri:ye,name:Pe,index:Be})=>({uri:h.URI.revive(ye),name:Pe,index:Be}))),Q.sort((ye,Pe)=>ye.index<Pe.index?-1:1);const Z=new I(B,G,Q,N?h.URI.revive(N):null,!!W,ye=>w(ye,z)),{added:re,removed:oe}=o(x?x.workspaceFolders:[],Z.workspaceFolders,a,z);return{workspace:Z,added:re,removed:oe}}static _findFolder(F,$,ue){for(let z=0;z<F.folders.length;z++){const B=F.workspaceFolders[z];if(c(B.uri,$,ue))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,$){return $&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let p=class{constructor(F,$,ue,z){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new A.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=ue,this._requestIdProvider=new y.Counter,this._barrier=new C.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const B=$.workspace;this._confirmedWorkspace=B?new I(B.id,B.name,[],B.configuration?h.URI.revive(B.configuration):null,!!B.isUntitled,G=>w(G,ue)):void 0}$initializeWorkspace(F,$){this._trusted=$,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?h.URI.from({scheme:D.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,$,ue,...z){const B=[];if(Array.isArray(z)&&z.forEach(Q=>{h.URI.isUri(Q.uri)&&!B.some(x=>c(x.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[$,ue].some(Q=>typeof Q!="number"||Q<0)||ue===0&&B.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+ue>G.length)return!1;const M=G.slice(0);M.splice($,ue,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<M.length;Q++){const x=M[Q];if(M.some((Z,re)=>re!==Q&&c(x.uri,Z.uri,this._extHostFileSystemInfo)))return!1}M.forEach((Q,x)=>Q.index=x);const{added:N,removed:W}=o(G,M,l,this._extHostFileSystemInfo);if(N.length===0&&W.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,$,ue,B).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,f.localize)(0,null,Q,x.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(M),!0}getWorkspaceFolder(F,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async getWorkspaceFolder2(F,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,$){let ue,z="";if(typeof F=="string"?(ue=h.URI.file(F),z=F):typeof F!="undefined"&&(ue=F,z=F.fsPath),!ue)return z;const B=this.getWorkspaceFolder(ue,!0);if(!B)return z;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let G=(0,n.relativePath)(B.uri,ue);return $&&B.name&&(G=`${B.name}/${G}`),G}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:$,added:ue,removed:z}=I.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ue,removed:z}))}findFiles(F,$,ue,z,B=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let G;if($===null?G=!1:$&&(typeof $=="string"?G=$:G=$.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:M,folder:N}=g(F);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(M),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(G),(0,k.withUndefinedAsNull)(ue),B).then(W=>Array.isArray(W)?W.map(Q=>h.URI.revive(Q)):[])}async findTextInFiles(F,$,ue,z,B=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),M=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:N,folder:W}=g($.include),Q=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,x={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:M,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:N,excludePattern:Q},Z=!1;if(this._activeSearchCallbacks[G]=re=>{if(!Z){const oe=h.URI.revive(re.resource);re.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?ue({uri:oe,preview:{text:ye.preview.text,matches:(0,E.mapArrayOrNot)(ye.preview.matches,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,E.mapArrayOrNot)(ye.ranges,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):ue({uri:oe,text:ye.text,lineNumber:ye.lineNumber})})}},B.isCancellationRequested)return{};try{const re=await this._proxy.$startTextSearch(F,(0,k.withUndefinedAsNull)(W),x,G,B);return delete this._activeSearchCallbacks[G],re||{}}catch(re){throw delete this._activeSearchCallbacks[G],re}}$handleTextSearchResult(F,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};p=qe([Ge(0,d.IExtHostRpcService),Ge(1,v.IExtHostInitDataService),Ge(2,b.IExtHostFileSystemInfo),Ge(3,s.ILogService)],p),e.ExtHostWorkspace=p,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function g(R){let F,$;return R&&(typeof R=="string"?F=R:(F=R.pattern,$=R.baseFolder||h.URI.file(R.base))),{includePattern:F,folder:$}}}),define(ve[34],_e([0,1,24,3,31,5,7,153,67,13,14,4,15,19,2]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(i,c){if(c){const a=c.split(".");let l=i;for(let o=0;l&&o<a.length;o++)l=l[a[o]];return l}}function _(i){return i instanceof r.URI}function m(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function b(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function v(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function d(i){if(_(i))return{resource:i};if(m(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(b(i))return{overrideIdentifier:i.languageId};if(v(i))return{resource:i.uri};if(i===null)return{resource:null}}let u=class{constructor(c,a,l){this._proxy=c.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=l,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new t(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,a){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(c,a))}};u=qe([Ge(0,h.IExtHostRpcService),Ge(1,P.IExtHostWorkspace),Ge(2,f.ILogService)],u),e.ExtHostConfiguration=u;class t{constructor(c,a,l,o){this._onDidChangeConfiguration=new C.Emitter,this._proxy=c,this._logService=o,this._extHostWorkspace=a,this._configuration=D.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,a){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,l))}getConfiguration(c,a,l){const o=d(a)||{},w=this._toReadonlyValue(c?s(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,o,l==null?void 0:l.identifier);function I(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const p={has(g){return typeof s(w,g)!="undefined"},get:(g,R)=>{this._validateConfigurationAccess(c?`${c}.${g}`:g,o,l==null?void 0:l.identifier);let F=s(w,g);if(typeof F=="undefined")F=R;else{let $;const ue=(z,B)=>{let G;const M=()=>{$=$||(0,E.deepClone)(w),G=G||s($,B)};return(0,n.isObject)(z)?new Proxy(z,{get:(N,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return M(),()=>G;if($)return G=G||s($,B),G[W];const Q=N[W];return typeof W=="string"?ue(Q,`${B}.${W}`):Q},set:(N,W,Q)=>(M(),G&&(G[W]=Q),!0),deleteProperty:(N,W)=>(M(),G&&delete G[W],!0),defineProperty:(N,W,Q)=>(M(),G&&Object.defineProperty(G,W,Q),!0)}):z};F=ue(F,g)}return F},update:(g,R,F,$)=>{g=c?`${c}.${g}`:g;const ue=I(F);return R!==void 0?this._proxy.$updateConfigurationOption(ue,g,R,o,$):this._proxy.$removeConfigurationOption(ue,g,o,$)},inspect:g=>{var R,F,$,ue,z,B,G,M;g=c?`${c}.${g}`:g;const N=(0,E.deepClone)(this._configuration.inspect(g,o,this._extHostWorkspace.workspace));if(N)return{key:g,defaultValue:(R=N.default)===null||R===void 0?void 0:R.value,globalValue:(F=N.user)===null||F===void 0?void 0:F.value,workspaceValue:($=N.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(ue=N.workspaceFolder)===null||ue===void 0?void 0:ue.value,defaultLanguageValue:(z=N.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(B=N.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:(G=N.workspace)===null||G===void 0?void 0:G.override,workspaceFolderLanguageValue:(M=N.workspaceFolder)===null||M===void 0?void 0:M.override,languageIds:N.overrideIdentifiers}}};return typeof w=="object"&&(0,E.mixin)(p,w,!1),Object.freeze(p)}_toReadonlyValue(c){const a=l=>(0,n.isObject)(l)?new Proxy(l,{get:(o,w)=>a(o[w]),set:(o,w,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(o,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(o,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return a(c)}_validateConfigurationAccess(c,a,l){const o=y.OVERRIDE_PROPERTY_PATTERN.test(c)?4:this._configurationScopes.get(c),w=l?`[${l.value}] `:"";if(o===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){(a==null?void 0:a.resource)&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,a){const l=new D.ConfigurationChangeEvent(c,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,w)=>l.affectsConfiguration(o,d(w))})}_toMap(c){return c.reduce((a,l)=>(a.set(l[0],l[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[101],_e([0,1,2,14,3,5,7,31,39,34,20,40,15,27,4,18,21,19,73,170,10]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v,d){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var c;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(c=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(z){function B(N){if(N){const W=N;return W&&!!W.process}else return!1}z.is=B;function G(N){if(N!=null){const W={process:N.process,args:N.args};return N.options&&(W.options=c.from(N.options)),W}}z.from=G;function M(N){if(N!=null)return new S.ProcessExecution(N.process,N.args,N.options)}z.to=M})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(z){function B(M){if(M!=null)return M}z.from=B;function G(M){if(M!=null)return M}z.to=G})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(z){function B(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}z.is=B;function G(N){if(N!=null){const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=l.from(N.options)),W}}z.from=G;function M(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new S.ShellExecution(N.commandLine,N.options):new S.ShellExecution(N.command,N.args?N.args:[],N.options)}z.to=M})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(z){function B(N){if(N){let W=N;return W&&W.customExecution==="customExecution"}else return!1}z.is=B;function G(N){return{customExecution:"customExecution"}}z.from=G;function M(N,W){return W.get(N)}z.to=M})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(z){function B(G,M){let N;return G.scope!==void 0&&typeof G.scope!="number"?N=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===S.TaskScope.Workspace&&M&&M.workspaceFile?N=M.workspaceFile:N=v.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:N}}z.from=B})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(z){function B(N,W){if(N==null)return[];const Q=[];for(let x of N){const Z=G(x,W);Z&&Q.push(Z)}return Q}z.fromMany=B;function G(N,W){if(N!=null){let Q;N.execution instanceof S.ProcessExecution?Q=a.from(N.execution):N.execution instanceof S.ShellExecution?Q=o.from(N.execution):N.execution&&N.execution instanceof S.CustomExecution&&(Q=w.from(N.execution));const x=t.from(N.definition);let Z;if(N.scope?typeof N.scope=="number"?Z=N.scope:Z=N.scope.uri:Z=S.TaskScope.Workspace,!(!x||!Z)){const re=N.group?N.group.id:void 0;return{_id:N._id,definition:x,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:Z},execution:Q,isBackground:N.isBackground,group:re,presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}}}z.from=G;async function M(N,W,Q){if(N!=null){let x;a.is(N.execution)?x=a.to(N.execution):o.is(N.execution)?x=o.to(N.execution):w.is(N.execution)&&(x=w.to(N._id,Q));const Z=t.to(N.definition);let re;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?re=N.source.scope:re=await W.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):re=S.TaskScope.Workspace),!(!Z||!re)){const oe=new S.Task(Z,re,N.name,N.source.label,x,N.problemMatchers);return N.isBackground!==void 0&&(oe.isBackground=N.isBackground),N.group!==void 0&&(oe.group=S.TaskGroup.from(N.group)),N.presentationOptions&&(oe.presentationOptions=i.to(N.presentationOptions)),N._id&&(oe._id=N._id),N.detail&&(oe.detail=N.detail),oe}}}z.to=M})(p=e.TaskDTO||(e.TaskDTO={}));var g;(function(z){function B(M){return M}z.from=B;function G(M){if(!!M)return Object.assign(Object.create(null),M)}z.to=G})(g=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(B,G,M){this._id=G,this._task=M,u.set(this,void 0),tt(this,u,B,"f")}get task(){return this._task}terminate(){xe(this,u,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}u=new WeakMap;var F;(function(z){function B(G){return{id:G._id,task:void 0}}z.from=B})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(B,G,M,N,W,Q,x,Z){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=N,this._configurationService=W,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,M){if(!M)return new S.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:G,provider:M,extension:B}),this._proxy.$registerTaskProvider(N,G),new S.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(B,G){this._proxy.$registerTaskSystem(B,G)}fetchTasks(B){return this._proxy.$fetchTasks(g.from(B)).then(async G=>{const M=[];for(let N of G){const W=await p.to(N,this._workspaceProvider,this._providedCustomExecutions2);W&&M.push(W)}return M})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,G,M){const N=this._providedCustomExecutions2.get(B.id);if(N){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,N),this._terminalService.attachPtyToTerminal(G,await N.callback(M))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const G=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const M=this._handlers.get(B);if(!M)return Promise.reject(new Error("no handler found"));const N=[],W=(0,C.asPromise)(()=>M.provider.provideTasks(T.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,N,M,Q));return new Promise(Q=>{W.then(x=>{Promise.all(N).then(()=>{Q(x)})})})}async $resolveTask(B,G){const M=this._handlers.get(B);if(!M)return Promise.reject(new Error("no handler found"));if(G.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${M.type}].`);const N=await p.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await M.provider.resolveTask(N,T.CancellationToken.None);if(!!W){this.checkDeprecation(W,M);const Q=p.from(W,M.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(Q.execution)&&await this.addCustomExecution(Q,W,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,G,M){const N=await this._proxy.$createTaskId(B);!M&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,G.execution)}async getTaskExecution(B,G){if(typeof B=="string"){const W=this._taskExecutionPromises.get(B);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let M=this._taskExecutionPromises.get(B.id);if(M)return M;const N=new Promise(async(W,Q)=>{const x=G||await p.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);x?W(new R(this,B.id,x)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,N),N.then(W=>(this._taskExecutions.set(B.id,W),W),W=>Promise.reject(W))}checkDeprecation(B,G){B._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let M=this._notProvidedCustomExecutions.values(),N=M.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=M.next()}};$=qe([Ge(0,h.IExtHostRpcService),Ge(1,f.IExtHostInitDataService),Ge(2,D.IExtHostWorkspace),Ge(3,y.IExtHostDocumentsAndEditors),Ge(4,n.IExtHostConfiguration),Ge(5,k.IExtHostTerminalService),Ge(6,m.ILogService),Ge(7,b.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let ue=class extends ${constructor(B,G,M,N,W,Q,x,Z){super(B,G,M,N,W,Q,x,Z);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const M=p.from(G,B);if(M===void 0)throw new Error("Task is not valid");if(w.is(M.execution))await this.addCustomExecution(M,G,!1);else throw new d.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),G);return this._proxy.$executeTask(M).catch(W=>{throw new Error(W)}),N}provideTasksInternal(B,G,M,N){const W=[];if(N)for(let Q of N){this.checkDeprecation(Q,M),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const x=p.from(Q,M.extension);x&&w.is(x.execution)?(W.push(x),G.push(this.addCustomExecution(x,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:M.extension}}async resolveTaskInternal(B){if(w.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,M){}};ue=qe([Ge(0,h.IExtHostRpcService),Ge(1,f.IExtHostInitDataService),Ge(2,D.IExtHostWorkspace),Ge(3,y.IExtHostDocumentsAndEditors),Ge(4,n.IExtHostConfiguration),Ge(5,k.IExtHostTerminalService),Ge(6,m.ILogService),Ge(7,b.IExtHostApiDeprecationService)],ue),e.WorkerExtHostTask=ue,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var $t=this&&this.__rest||function(ee,e){var E={};for(var C in ee)Object.prototype.hasOwnProperty.call(ee,C)&&e.indexOf(C)<0&&(E[C]=ee[C]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,C=Object.getOwnPropertySymbols(ee);P<C.length;P++)e.indexOf(C[P])<0&&Object.prototype.propertyIsEnumerable.call(ee,C[P])&&(E[C[P]]=ee[C[P]]);return E};define(ve[217],_e([0,1,11,14,23,20,3,53,6,24,13,2,29,5,39,15,9,7,31,181,95]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=(p,g)=>`${p}:${g.toString()}`;let t=class{constructor(g,R,F){this.documents=R,this.workspace=F,this.resultsChangedEmitter=new S.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=g.getProxy(f.MainContext.MainThreadTesting),this.workspaceObservers=new w(this.proxy),this.textDocumentObservers=new I(this.proxy,R)}registerTestProvider(g){const R=(0,h.generateUuid)();this.providers.set(R,g),this.proxy.$registerTestProvider(R);const F=[...this.testSubscriptions.keys()];return setTimeout(()=>{var $;for(const ue of F)($=this.testSubscriptions.get(ue))===null||$===void 0||$.subscribeFn(R,g)},0),new m.Disposable(()=>{this.providers.delete(R),this.proxy.$unregisterTestProvider(R)})}createTextDocumentTestObserver(g){return this.textDocumentObservers.checkout(g.uri)}createWorkspaceTestObserver(g){return this.workspaceObservers.checkout(g.uri)}async runTests(g,R=A.CancellationToken.None){const F=$=>$.map(this.getInternalTestForReference,this).filter(T.isDefined).map(ue=>({src:ue.src,testId:ue.item.extId}));await this.proxy.$runTests({exclude:g.exclude?F(g.exclude).map($=>$.testId):void 0,tests:F(g.tests),debug:g.debug},R)}publishExtensionProvidedResults(g,R){this.proxy.$publishExtensionProvidedResults(_.TestResults.from((0,h.generateUuid)(),g),R)}$publishTestResults(g){this.results=Object.freeze(g.map(R=>(0,n.deepFreeze)(_.TestResults.to(R))).concat(this.results).sort((R,F)=>F.completedAt-R.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(g,R){const F=k.URI.revive(R),$=u(g,F);if(!this.testSubscriptions.has($)){const ue=new A.CancellationTokenSource;let z;if(g===1){let N=this.documents.getDocument(F);if(!N){const W=new y.DisposableStore;N=await new Promise(Q=>{W.add((0,C.disposableTimeout)(()=>Q(void 0),5e3)),W.add(this.documents.onDidAddDocuments(x=>{const Z=x.find(re=>re.document.uri.toString()===F.toString());Z&&Q(Z)}))}).finally(()=>W.dispose())}if(N){const W=await this.workspace.getWorkspaceFolder2(F,!1);z=Q=>Q.provideDocumentTestRoot?Q.provideDocumentTestRoot(N.document,ue.token):(0,e.createDefaultDocumentTestRoot)(Q,N.document,W,ue.token)}}else{const N=await this.workspace.getWorkspaceFolder2(F,!1);N&&(z=W=>W.provideWorkspaceTestRoot(N,ue.token))}if(!!z){const B=async(N,W)=>{try{const Q=await z(W);Q&&M.addRoot(Q,N)}catch(Q){console.error(Q)}},G=new y.DisposableStore,M=G.add(this.ownedTests.createForHierarchy(N=>this.proxy.$publishDiff(g,R,N)));G.add((0,y.toDisposable)(()=>ue.dispose(!0)));for(const[N,W]of this.providers)B(N,W);M.pushDiff([3,-1]),this.testSubscriptions.set($,{store:G,collection:M,subscribeFn:B})}}}async $expandTest(g,R){const F=(0,E.mapFind)(this.testSubscriptions.values(),$=>$.collection.treeId===g.src.tree?$:void 0);await(F==null?void 0:F.collection.expand(g.testId,R<0?Infinity:R)),this.flushCollectionDiffs()}$unsubscribeFromTests(g,R){var F;const $=k.URI.revive(R),ue=u(g,$);(F=this.testSubscriptions.get(ue))===null||F===void 0||F.store.dispose(),this.testSubscriptions.delete(ue)}$acceptDiff(g,R,F){g===1?this.textDocumentObservers.acceptDiff(k.URI.revive(R),F):this.workspaceObservers.acceptDiff(k.URI.revive(R),F)}async $runTestsForProvider(g,R){const F=this.providers.get(g.tests[0].src.provider);if(!!F){const $=g.tests.map(({testId:B,src:G})=>this.ownedTests.getTestById(B,G.tree)).filter(T.isDefined).map(([B,G])=>G),ue=g.excludeExtIds.map(B=>this.ownedTests.getTestById(B)).filter(T.isDefined).filter(([B,G])=>$.some(M=>B.comparePositions(M,G)===1));if(!!$.length){const z=B=>{for(const[G,M]of ue){const N=G.comparePositions(M,B.id);if(N===1||N===3)return!0}return!1};try{await F.runTests({appendOutput:B=>{this.proxy.$appendOutputToRun(g.runId,P.VSBuffer.fromString(B))},appendMessage:(B,G)=>{z(B)||(this.flushCollectionDiffs(),this.proxy.$appendTestMessageInRun(g.runId,B.id,_.TestMessage.from(G)))},setState:(B,G,M)=>{z(B)||(this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(g.runId,B.id,G,M))},tests:$.map(B=>c.unwrap(B.actual)),exclude:ue.map(([,B])=>c.unwrap(B.actual)),debug:g.debug},R);for(const{collection:B}of this.testSubscriptions.values())B.flushDiff();return}catch(B){throw console.error(B),B}}}}$lookupTest(g){const R=this.ownedTests.getTestById(g.testId);if(!R)return Promise.resolve(void 0);const F=R[1],{actual:$,discoverCts:ue,expandLevels:z}=F,B=$t(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(B)}flushCollectionDiffs(){for(const{collection:g}of this.testSubscriptions.values())g.flushDiff()}getInternalTestForReference(g){var R,F;return(F=(R=this.workspaceObservers.getMirroredTestDataByReference(g))!==null&&R!==void 0?R:(0,E.mapFind)(this.testSubscriptions.values(),$=>$.collection.getTestByReference(g)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(g)}};t=qe([Ge(0,s.IExtHostRpcService),Ge(1,r.IExtHostDocumentsAndEditors),Ge(2,b.IExtHostWorkspace)],t),e.ExtHostTesting=t;const i=async(p,g,R,F)=>{if(!!R){const $=await p.provideWorkspaceTestRoot(R,F);if(!!$)return F.onCancellationRequested(()=>{c.removeFilter(g)}),c.getWrapperForTestItem($,g)}};e.createDefaultDocumentTestRoot=i;class c extends m.TestItem{constructor(g,R,F){super(g.id,g.label,g.uri,g.expandable);if(this.actual=g,this.filterDocument=R,this.parent=F,!(g instanceof m.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);g[m.TestItemHookProperty]={setProp:($,ue)=>this[$]=ue,created:$=>c.getWrapperForTestItem($,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:$=>this.children.delete($)}}static removeFilter(g){this.wrapperMap.delete(g)}static getWrapperForTestItem(g,R,F){let $=this.wrapperMap.get(R);if($==null?void 0:$.has(g))return $.get(g);$||($=new WeakMap,this.wrapperMap.set(R,$));const ue=new c(g,R,F);return $.set(g,ue),ue}static unwrap(g){return g instanceof c?g.actual:g}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var g;const R=this._cachedMatchesFilter;for(const $ of this.actual.children){const ue=c.getWrapperForTestItem($,this.filterDocument,this);ue.hasNodeMatchingFilter?this.children.add(ue):this.children.delete(ue)}const F=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=F,F!==R&&((g=this.parent)===null||g===void 0||g.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=c,c.wrapperMap=new WeakMap;class a extends d.IncrementalChangeCollector{constructor(g){super();this.emitter=g,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(g){this.added.add(g)}update(g){Object.assign(g.revived,_.TestItem.toPlain(g.item)),this.added.has(g)||this.updated.add(g)}remove(g){if(this.added.has(g)){this.added.delete(g);return}if(this.updated.delete(g),g.parent&&this.alreadyRemoved.has(g.parent)){this.alreadyRemoved.add(g.item.extId);return}this.removed.add(g)}getChangeEvent(){const{added:g,updated:R,removed:F}=this;return{get added(){return[...g].map($=>$.revived)},get updated(){return[...R].map($=>$.revived)},get removed(){return[...F].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(g){let R=[];for(const F of g){const $=this.items.get(F);$&&R.push($.revived)}return R}getMirroredTestDataById(g){return this.items.get(g)}getMirroredTestDataByReference(g){return this.items.get(g.id)}createItem(g,R){return Object.assign(Object.assign({},g),{revived:_.TestItem.toPlain(g.item),depth:R?R.depth+1:0,children:new Set})}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=l;class o{constructor(){this.resources=new Map}checkout(g){var R,F;const $=g.toString(),ue=(R=this.resources.get($))!==null&&R!==void 0?R:this.createObserverData(g);return(F=ue.pendingDeletion)===null||F===void 0||F.dispose(),ue.observers++,{onDidChangeTest:ue.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return ue.tests.rootTestItems},dispose:(0,D.once)(()=>{--ue.observers||(ue.pendingDeletion=this.eventuallyDispose(g))})}}getMirroredTestDataByReference(g){for(const{tests:R}of this.resources.values()){const F=R.getMirroredTestDataByReference(g);if(F)return F}}eventuallyDispose(g){return(0,C.disposableTimeout)(()=>this.unlisten(g),10*1e3)}createObserverData(g){const R=new l,F=this.listen(g,ue=>R.apply(ue)),$={observers:0,tests:R,listener:F};return this.resources.set(g.toString(),$),$}unlisten(g){var R;const F=g.toString(),$=this.resources.get(F);$&&($.observers=-1,(R=$.pendingDeletion)===null||R===void 0||R.dispose(),$.listener.dispose(),this.resources.delete(F))}}class w extends o{constructor(g){super();this.proxy=g,this.diffListeners=new Map}acceptDiff(g,R){var F;(F=this.diffListeners.get(g.toString()))===null||F===void 0||F(R)}listen(g,R){this.proxy.$subscribeToDiffs(0,g);const F=g.toString();return this.diffListeners.set(F,R),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,g),this.diffListeners.delete(F)})}}class I extends o{constructor(g,R){super();this.proxy=g,this.documents=R,this.diffListeners=new Map}acceptDiff(g,R){var F;(F=this.diffListeners.get(g.toString()))===null||F===void 0||F(R)}listen(g,R){if(!this.documents.getDocument(g))return new m.Disposable(()=>{});const $=g.toString();return this.diffListeners.set($,R),this.proxy.$subscribeToDiffs(1,g),new m.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,g),this.diffListeners.delete($)})}}}),define(ve[218],_e([0,1,11,51,28,59,22,18,12,25,8,13,2,114,139,90,47,173,216,41]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(I,p,g,R){this.configurationService=I,this.workspaceContextService=p,this.editorGroupsService=g,this.pathService=R}text(I,p,g={}){I=this.getContentPattern(I,g);const R=this.configurationService.getValue(),F=p&&p.some(ue=>!this.configurationService.getValue({resource:ue}).search.useRipgrep),$=this.commonQuery(p==null?void 0:p.map(_.toWorkspaceFolder),g);return Object.assign(Object.assign({},$),{type:2,contentPattern:I,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:R.search.usePCRE2||F||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles})}getContentPattern(I,p){const g=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},I),{wordSeparators:g.editor.wordSeparators});return this.isCaseSensitive(I,p)&&(R.isCaseSensitive=!0),this.isMultiline(I)&&(R.isMultiline=!0),R}file(I,p={}){const g=this.commonQuery(I,p);return Object.assign(Object.assign({},g),{type:1,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey})}handleIncludeExclude(I,p){return I?(I=Array.isArray(I)?I.map(a):a(I),p?this.parseSearchPaths(I):{pattern:t(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],p={}){const g=this.handleIncludeExclude(p.includePattern,p.expandPatterns),R=this.handleIncludeExclude(p.excludePattern,p.expandPatterns),F=I.length>1,$=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,p,R)):I.map(B=>this.getFolderQueryForRoot(B,p,R,F))).filter(B=>!!B),ue={_reason:p._reason,folderQueries:$,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:R.pattern,includePattern:g.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const G=E.coalesce(E.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(W=>W.resource)))).filter(N=>(0,v.pathIncludedInQuery)(ue,N.fsPath)),M=this.commonQueryFromFileList(G);return Object.assign(Object.assign({},ue),M)}const z=p.extraFileResources&&p.extraFileResources.filter(B=>(0,v.pathIncludedInQuery)(ue,B.fsPath));return ue.extraFileResources=z&&z.length?z:void 0,ue}commonQueryFromFileList(I){const p=[],g=new S.ResourceMap,R={};let F=!1;return I.forEach($=>{var ue,z;if($.scheme!==D.Schemas.walkThrough)if((0,n.isAbsolutePath)($)){const G=(z=(ue=this.workspaceContextService.getWorkspaceFolder($))===null||ue===void 0?void 0:ue.uri)!==null&&z!==void 0?z:$.with({path:y.dirname($.fsPath)});let M=g.get(G);M||(F=!0,M={folder:G,includePattern:{}},p.push(M),g.set(G,M));const N=y.relative(G.fsPath,$.fsPath);(0,k.assertIsDefined)(M.includePattern)[N.replace(/\\/g,"/")]=!0}else $.fsPath&&(F=!0,R[$.fsPath]=!0)}),{folderQueries:p,includePattern:R,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(I,p){if(p.isSmartCase){if(I.isRegExp){if(T.containsUppercaseCharacter(I.pattern,!0))return!0}else if(T.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,f.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const p=M=>y.isAbsolute(M)||/^\.\.?([\/\\]|$)/.test(M),R=(Array.isArray(I)?I:i(I)).map(M=>{const N=this.pathService.resolvedUserHome;return N?(0,A.untildify)(M,N.scheme===D.Schemas.file?N.fsPath:N.path):M}),F=C.groupBy(R,M=>p(M)?"searchPaths":"exprSegments"),$=(F.exprSegments||[]).map(M=>T.rtrim(M,"/")).map(M=>T.rtrim(M,"\\")).map(M=>(M[0]==="."&&(M="*"+M),c(M))),ue={},z=this.expandSearchPathPatterns(F.searchPaths||[]);z&&z.length&&(ue.searchPaths=z);const B=E.flatten($),G=t(...B);return G&&(ue.pattern=G),ue}getExcludesForFolder(I,p){return p.disregardExcludeSettings?void 0:(0,v.getExcludes)(I,!p.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const p=E.flatten(I.map(R=>{let{pathPortion:F,globPortion:$}=u(R);$&&($=l($));const ue=this.expandOneSearchPath(F);return E.flatten(ue.map(z=>this.resolveOneSearchPathPattern(z,$)))})),g=new Map;return p.forEach(R=>{const F=R.searchPath.toString(),$=g.get(F);$?R.pattern&&($.pattern=$.pattern||{},$.pattern[R.pattern]=!0):g.set(F,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(I){if(y.isAbsolute(I)){const p=this.workspaceContextService.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==D.Schemas.file?[{searchPath:p[0].uri.with({path:I})}]:[{searchPath:h.URI.file(y.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const p=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=a(I),I.startsWith("../")||I===".."){const R=y.posix.resolve(p.path,I);return[{searchPath:p.with({path:R})}]}const g=l(I);return[{searchPath:p,pattern:g}]}else{if(I==="./"||I===".\\")return[];{const p=I.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(p){const g=p[1],R=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===g);if(R.length)return R.map(F=>{const $=p[2];return{searchPath:F.uri,pattern:$&&l($)}});{const F=r.localize(0,null,g);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(I,p){const g=I.pattern&&p?`${I.pattern}/${p}`:I.pattern||p,R=[{searchPath:I.searchPath,pattern:g}];return g&&!g.endsWith("**")&&R.push({searchPath:I.searchPath,pattern:g+"/**"}),R}getFolderQueryForSearchPath(I,p,g){const R=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(I.searchPath),p,g,!1);return R?Object.assign(Object.assign({},R),{includePattern:I.pattern}):null}getFolderQueryForRoot(I,p,g,R){let F;const $=h.URI.isUri(I)?I:I.uri;if(g.searchPaths){const M=g.searchPaths.filter(N=>(0,n.isEqual)(N.searchPath,$))[0];if(M&&!M.pattern)return null;M&&(F=M.pattern)}const ue=this.configurationService.getValue({resource:$}),z=this.getExcludesForFolder(ue,p),B=Object.assign(Object.assign({},z||{}),F||{}),G=h.URI.isUri(I)?(0,n.basename)(I):I.name;return{folder:$,folderName:R?G:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ue.files&&ue.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!ue.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!ue.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!ue.search.followSymlinks}}};d=qe([Ge(0,s.IConfigurationService),Ge(1,_.IWorkspaceContextService),Ge(2,m.IEditorGroupsService),Ge(3,b.IPathService)],d),e.QueryBuilder=d;function u(w){const I=w.match(/[\*\{\}\(\)\[\]\?]/);if(I){const p=I.index,g=w.substr(0,p).match(/[/|\\][^/\\]*$/);if(g){let R=w.substr(0,g.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:w.substr((g.index||0)+1)}}}return{pathPortion:w}}function t(...w){return w.length?w.reduce((I,p)=>(I[p]=!0,I),Object.create(null)):void 0}function i(w){return P.splitGlobAware(w,",").map(I=>I.trim()).filter(I=>!!I.length)}function c(w){return[`**/${w}/**`,`**/${w}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function a(w){return w.replace(/\\/g,"/")}function l(w){return a(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(w,I){w=E.distinct(w,R=>R.toString());const p=[],g=I.getWorkspace();return w&&w.forEach(R=>{let F;if(I.getWorkbenchState()===2)F=(0,n.relativePath)(g.folders[0].uri,R),F&&F!=="."&&(F="./"+F);else{const $=I.getWorkspaceFolder(R);if($){const ue=$.name;if(g.folders.filter(B=>B.name===ue).length===1){const B=(0,n.relativePath)($.uri,R);B===""?F=`./${$.name}`:F=`./${$.name}/${B}`}else F=R.fsPath}}F&&p.push(F)}),p}e.resolveResourcesForSearchIncludes=o}),define(ve[219],_e([0,1,25,2,20,10,4,218,41,47]),function(ee,e,E,C,P,A,S,D,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(s,_){const m=_.activationEvents;if(!m)return Promise.resolve(void 0);const b=[],v=[];for(const a of m)if(/^workspaceContains:/.test(a)){const l=a.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||s.forceUsingSearch?v.push(l):b.push(l)}if(b.length===0&&v.length===0)return Promise.resolve(void 0);let d;const u=new Promise((a,l)=>{d=a}),t=a=>d({activationEvent:a}),i=Promise.all(b.map(a=>h(s,a,t))).then(()=>{}),c=f(s,_.identifier,v,t);return Promise.all([i,c]).then(()=>{d(void 0)}),u}e.checkActivateWorkspaceContainsExtension=k;async function h(s,_,m){for(const b of s.folders)if(await s.exists(E.joinPath(C.URI.revive(b),_))){m(`workspaceContains:${_}`);return}}async function f(s,_,m,b){if(m.length===0)return Promise.resolve(void 0);const v=new P.CancellationTokenSource,d=s.checkExists(s.folders,m,v.token),u=setTimeout(async()=>{v.cancel(),b(`workspaceContainsTimeout:${m.join(",")}`)},T);let t=!1;try{t=await d}catch(i){A.isPromiseCanceledError(i)||A.onUnexpectedError(i)}v.dispose(),clearTimeout(u),t&&b(`workspaceContains:${m.join(",")}`)}function r(s,_,m,b){const v=s.get(S.IInstantiationService),d=s.get(y.ISearchService),t=v.createInstance(D.QueryBuilder).file(_.map(i=>(0,n.toWorkspaceFolder)(C.URI.revive(i))),{_reason:"checkExists",includePattern:m,exists:!0});return d.fileSearch(t,b).then(i=>!!i.limitHit,i=>A.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(ee,e,E,C,P){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!P:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?P.call(ee,E):P?P.value=E:e.set(ee,E),E},xe=this&&this.__classPrivateFieldGet||function(ee,e,E,C){if(E==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?C:E==="a"?C.call(ee):C?C.value:e.get(ee)};define(ve[35],_e([0,1,131,12,78,25,14,6,22,2,19,5,34,184,76,31,33,182,10,26,18,23,160,7,91,4,27,77,15,66,69,40,3,219,72,161]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v,d,u,t,i,c,a,l,o,w,I,p,g,R,F,$,ue){"use strict";var z,B,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let M=class An extends D.Disposable{constructor(x,Z,re,oe,ye,Pe,Be,Re,ze,U){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=re,this._initData=Be,this._extHostWorkspace=oe,this._extHostConfiguration=ye,this._logService=Pe,this._extHostTunnelService=ze,this._extHostTerminalService=U,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=x.createChild(new I.ServiceCollection([r.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const K=new Set;this._initData.hostExtensions.forEach(ne=>K.add(v.ExtensionIdentifier.toKey(ne))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ne,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ne,le)},actualActivateExtension:async(ne,le)=>{if(K.has(v.ExtensionIdentifier.toKey(ne)))return await this._mainThreadExtensionsProxy.$activateExtension(ne,le),new f.HostExtension;const fe=this._registry.getExtensionDescription(ne);return this._activateExtension(fe,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){b.onUnexpectedError(x)}}async deactivateAll(){let x=[];try{x=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(Z){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,Z){return this._activator.activateByEvent(x,Z)}_activateById(x,Z){return this._activator.activateById(x,Z)}activateByIdWithErrors(x,Z){return this._activateById(x,Z).then(()=>{const re=this._activator.getActivatedExtension(x);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=y.TernarySearchTree.forPaths(),Z=this._registry.getAllExtensionDescriptions().map(re=>{if(!!this._getEntryPoint(re))return this._hostUtils.realpath(re.extensionLocation.fsPath).then(oe=>x.set(n.URI.file(oe).fsPath,re))});this._extensionPathIndex=Promise.all(Z).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return Z;const re=this._activator.getActivatedExtension(x);if(!re)return Z;try{typeof re.module.deactivate=="function"&&(Z=Promise.resolve(re.module.deactivate()).then(void 0,oe=>Promise.resolve(void 0)))}catch(oe){}try{(0,D.dispose)(re.subscriptions)}catch(oe){}return Z}async _activateExtension(x,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,Z).then(re=>{const oe=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,Z),this._logExtensionActivationTimes(x,Z,"success",oe),re},re=>{throw this._logExtensionActivationTimes(x,Z,"failure"),re})}_logExtensionActivationTimes(x,Z,re,oe){const ye=N(x,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),oe||{}),{outcome:re}))}_doActivateExtension(x,Z){const re=N(x,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const oe=this._getEntryPoint(x);if(!oe)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(Z)}`),this._logService.flush();const ye=new f.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,A.joinPath)(x.extensionLocation,oe),ye),this._loadExtensionContext(x)]).then(Pe=>(P.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),An._callActivate(this._logService,x.identifier,Pe[0],Pe[1],ye))).then(Pe=>(P.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Pe))}_loadExtensionContext(x){const Z=new t.ExtensionGlobalMemento(x,this._storage),re=new t.ExtensionMemento(x.identifier.value,!1,this._storage),oe=new ue.ExtensionSecrets(x,this._secretState),ye=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([Z.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Re;return Object.freeze({globalState:Z,workspaceState:re,secrets:oe,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(ze){return C.join(x.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=Be._storagePath.workspaceValue(x))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(x).fsPath},get logPath(){return C.join(Be._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return n.URI.joinPath(Be._initData.logsLocation,x.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(x)},get globalStorageUri(){return Be._storagePath.globalValue(x)},get extensionMode(){return ye},get extension(){return Re===void 0&&(Re=new W(Be,x.identifier,x,Pe)),Re},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(x),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,Z,re,oe,ye){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,Z,re,oe,ye).then(Pe=>new f.ActivatedExtension(!1,null,ye.build(),re,Pe,oe.subscriptions))}static _callActivateOptional(x,Z,re,oe,ye){if(typeof re.activate=="function")try{ye.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Pe=typeof global=="object"?global:self,Be=re.activate.apply(Pe,[oe]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(Be).then(Re=>(ye.activateResolveStop(),Re))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(re)}_activateOneStartupFinished(x,Z){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:Z}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const Z of x.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(x,Z)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(Z),oe=Promise.all([x,re]).then(()=>{});return Promise.race([oe,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),oe}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(x,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,Z){if(!this.isActivated(Z.identifier)){const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,oe={folders:x.map(Pe=>Pe.uri),forceUsingSearch:re,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Be,Re)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Be,Re)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(oe,Z);if(!!ye)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ye.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:Z}=this._initData.environment;if(!x||!Z||Z.scheme!==d.Schemas.file)throw new Error(E.localize(0,null));const re=(0,A.originalFSPath)(Z),oe=await this._loadCommonJSModule(null,Z,new f.ExtensionActivationTimesBuilder(!1));if(!oe||typeof oe.run!="function")throw new Error(E.localize(1,null,re));return new Promise((ye,Pe)=>{const Be=(ze,U)=>{ze?Pe(ze):ye(typeof U=="number"&&U>0?1:0)},Re=oe.run(re,Be);Re&&Re.then&&Re.then(()=>{ye(0)}).catch(ze=>{Pe(ze.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,Z){return this._resolvers[x]=Z,(0,D.toDisposable)(()=>{delete this._resolvers[x]})}async $resolveAuthority(x,Z){const re=x.indexOf("+");if(re===-1)throw new Error("Not an authority that can be resolved!");const oe=x.substr(0,re);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${oe}`,!1);const ye=this._resolvers[oe];if(!ye)return{type:"error",error:{code:c.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${oe}.`,detail:void 0}};try{P.mark(`code/extHost/willResolveAuthority/${oe}`);const Pe=await ye.resolve(x,{resolveAttempt:Z});P.mark(`code/extHost/didResolveAuthorityOK/${oe}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const Be={authority:x,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},Re={extensionHostEnv:Pe.extensionHostEnv};return{type:"ok",value:{authority:Be,options:Re,tunnelInformation:{environmentTunnels:Pe.environmentTunnels}}}}catch(Pe){if(P.mark(`code/extHost/didResolveAuthorityError/${oe}`),Pe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,Z){return Z===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(x,!1))}async $activate(x,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,Z),!0):!1}async $deltaExtensions(x,Z){x.forEach(oe=>oe.extensionLocation=n.URI.revive(oe.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(Z.map(async oe=>{const ye=this._registry.getExtensionDescription(oe);if(!!ye){const Pe=await this._hostUtils.realpath(ye.extensionLocation.fsPath);re.delete(n.URI.file(Pe).fsPath)}})),await Promise.all(x.map(async oe=>{const ye=await this._hostUtils.realpath(oe.extensionLocation.fsPath);re.set(n.URI.file(ye).fsPath,oe)})),this._registry.deltaExtensions(x,Z),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let Z=u.VSBuffer.alloc(x),re=Math.random()%256;for(let oe=0;oe<x;oe++)Z.writeUInt8(re,oe);return Z}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};M=qe([Ge(0,a.IInstantiationService),Ge(1,e.IHostUtils),Ge(2,w.IExtHostRpcService),Ge(3,s.IExtHostWorkspace),Ge(4,h.IExtHostConfiguration),Ge(5,T.ILogService),Ge(6,l.IExtHostInitDataService),Ge(7,o.IExtensionStoragePaths),Ge(8,p.IExtHostTunnelService),Ge(9,g.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function N(Q,x){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class W{constructor(x,Z,re,oe){z.set(this,void 0),B.set(this,void 0),G.set(this,void 0),tt(this,z,x,"f"),tt(this,B,Z,"f"),tt(this,G,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=C.normalize((0,A.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=oe}get isActive(){return xe(this,z,"f").isActivated(xe(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,z,"f").getExtensionExports(xe(this,G,"f"))}activate(){return xe(this,z,"f").activateByIdWithErrors(xe(this,G,"f"),{startup:!1,extensionId:xe(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,z=new WeakMap,B=new WeakMap,G=new WeakMap}),define(ve[102],_e([0,1,12,2,3,14,5,7,168,31,35,39,172,34,169,15,4,13,45]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let v=class{constructor(o,w,I,p,g){this._workspaceService=w,this._extensionService=I,this._editorsService=p,this._configurationService=g,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=o.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new u(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(F=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,w){const I=o;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let p=`debug:${encodeURIComponent(I.path||"")}`,g="?";return w&&(p+=`${g}session=${encodeURIComponent(w.id)}`,g="&"),p+=`${g}ref=${I.sourceReference}`,C.URI.parse(p)}else{if(I.path)return C.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const w=[];for(const I of o.getAllExtensionDescriptions())if(I.contributes){const p=I.contributes.debuggers;if(p&&p.length>0)for(const g of p)(0,r.isDebuggerMainContribution)(g)&&w.push(g.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(w=>o.push(w)),o}addBreakpoints(o){this.startBreakpoints();const w=o.filter(g=>{const R=g.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,g),!0)});this.fireBreakpointChanges(w,[],[]);const I=[],p=new Map;for(const g of w)if(g instanceof D.SourceBreakpoint){let R=p.get(g.location.uri.toString());R||(R={type:"sourceMulti",uri:g.location.uri,lines:[]},p.set(g.location.uri.toString(),R),I.push(R)),R.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof D.FunctionBreakpoint&&I.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this._debugServiceProxy.$registerBreakpoints(I)}removeBreakpoints(o){this.startBreakpoints();const w=o.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const I=w.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),p=w.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),g=w.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(I,p,g)}startDebugging(o,w,I){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,w,{parentSessionID:I.parentSession?I.parentSession.id:void 0,repl:I.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,w,I){if(!w)return new D.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:p,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,I,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,p),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(g=>g.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(o,w,I){if(!I)return new D.Disposable(()=>{});if(!this.definesDebugType(o,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:p,factory:I}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,p),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(g=>g.factory!==I),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(o,w){if(!w)return new D.Disposable(()=>{});const I=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:I,factory:w}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==w)})}async $runInTerminal(o,w){return Promise.resolve(void 0)}async $substituteVariables(o,w){if(!this._variableResolver){const[g,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(g||[],this._editorsService,R)}let I;const p=await this.getFolder(o);return p&&(I={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(I,w)}createDebugAdapter(o,w){if(o.type==="implementation")return new c(o.implementation)}createSignService(){}async $startDASession(o,w){const I=this,p=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const R=this.convertToDto(g),F=this.createDebugAdapter(R,p);if(!F)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const $=F;return this._debugAdapters.set(o,$),this.getDebugAdapterTrackers(p).then(ue=>(ue&&this._debugAdaptersTrackers.set(o,ue),$.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const B=z,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(B.arguments.value);G.body={signature:M},$.sendResponse(G)}else throw new Error("no signer")}catch(M){G.success=!1,G.message=M.message,$.sendResponse(G)}}else ue&&ue.onDidSendMessage&&ue.onDidSendMessage(z),z=(0,r.convertToVSCPaths)(z,!0),I._debugServiceProxy.$acceptDAMessage(o,z)}),$.onError(z=>{ue&&ue.onError&&ue.onError(z),this._debugServiceProxy.$acceptDAError(o,z.name,z.message,z.stack)}),$.onExit(z=>{ue&&ue.onExit&&ue.onExit((0,m.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,m.withNullAsUndefined)(z),void 0)}),ue&&ue.onWillStartSession&&ue.onWillStartSession(),$.startSession()))})}$sendDAMessage(o,w){w=(0,r.convertToDAPaths)(w,!1);const I=this._debugAdaptersTrackers.get(o);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(w);const p=this._debugAdapters.get(o);p&&p.sendMessage(w)}$stopDASession(o){const w=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),w&&w.onWillStopSession&&w.onWillStopSession();const I=this._debugAdapters.get(o);return this._debugAdapters.delete(o),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const w=[],I=[],p=[];if(o.added)for(const g of o.added){const R=g.id;if(R&&!this._breakpoints.has(R)){let F;if(g.type==="function")F=new D.FunctionBreakpoint(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")F=new D.DataBreakpoint(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const $=C.URI.revive(g.uri);F=new D.SourceBreakpoint(new D.Location($,new D.Position(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}F._id=R,this._breakpoints.set(R,F),w.push(F)}}if(o.removed)for(const g of o.removed){const R=this._breakpoints.get(g);R&&(this._breakpoints.delete(g),I.push(R))}if(o.changed){for(const g of o.changed)if(g.id){const R=this._breakpoints.get(g.id);if(R){if(R instanceof D.FunctionBreakpoint&&g.type==="function"){const F=R;F.enabled=g.enabled,F.condition=g.condition,F.hitCondition=g.hitCondition,F.logMessage=g.logMessage,F.functionName=g.functionName}else if(R instanceof D.SourceBreakpoint&&g.type==="source"){const F=R;F.enabled=g.enabled,F.condition=g.condition,F.hitCondition=g.hitCondition,F.logMessage=g.logMessage,F.location=new D.Location(C.URI.revive(g.uri),new D.Position(g.line,g.character))}p.push(R)}}}this.fireBreakpointChanges(w,I,p)}$provideDebugConfigurations(o,w,I){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(o);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.getFolder(w);return p.provideDebugConfigurations(g,I)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(o,w,I,p){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(o);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return g.resolveDebugConfiguration(R,I,p)})}$resolveDebugConfigurationWithSubstitutedVariables(o,w,I,p){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(o);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return g.resolveDebugConfigurationWithSubstitutedVariables(R,I,p)})}async $provideDebugAdapter(o,w){const I=this.getAdapterDescriptorFactoryByHandle(o);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(w);return this.getAdapterDescriptor(I,p).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(g)})}async $acceptDebugSessionStarted(o){const w=await this.getSession(o);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(o){const w=await this.getSession(o);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,w){const I=await this.getSession(o);I&&I._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(o,w){const p={session:await this.getSession(o),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(o){if(o instanceof D.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof D.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const w=this._adapterFactories.filter(I=>I.type===o);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(o){const w=this._adapterFactories.filter(I=>I.handle===o);if(w.length>0)return w[0].factory}getConfigProviderByHandle(o){const w=this._configProviders.filter(I=>I.handle===o);if(w.length>0)return w[0].provider}definesDebugType(o,w){if(o.contributes){const I=o.contributes.debuggers;if(I&&I.length>0){for(const p of I)if(p.label&&p.type&&p.type===w)return!0}}return!1}getDebugAdapterTrackers(o){const I=o.configuration.type,p=this._trackerFactories.filter(g=>g.type===I||g.type==="*").map(g=>(0,A.asPromise)(()=>g.factory.createDebugAdapterTracker(o)).then(R=>R,R=>null));return Promise.race([Promise.all(p).then(g=>{const R=g.filter(F=>!!F);if(R.length>0)return new i(R)}),new Promise((g,R)=>{const F=setTimeout(()=>{clearTimeout(F),R(new Error("timeout"))},1e3)})]).catch(g=>{})}async getAdapterDescriptor(o,w){const I=w.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new D.DebugAdapterServer(I));if(o){const g=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>o.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,g))).then(R=>{if(R)return R})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,p))}daExecutableFromPackage(o,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,w,I){(o.length>0||w.length>0||I.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:w,changed:I}))}async getSession(o){if(o)if(typeof o=="string"){const w=this._debugSessions.get(o);if(w)return w}else{let w=this._debugSessions.get(o.id);if(!w){const I=await this.getFolder(o.folderUri);w=new d(this._debugServiceProxy,o.id,o.type,o.name,I,o.configuration),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(o){if(o){const w=C.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};v=qe([Ge(0,s.IExtHostRpcService),Ge(1,n.IExtHostWorkspace),Ge(2,T.IExtHostExtensionService),Ge(3,k.IExtHostDocumentsAndEditors),Ge(4,f.IExtHostConfiguration)],v),e.ExtHostDebugServiceBase=v;class d{constructor(o,w,I,p,g,R){this._debugServiceProxy=o,this._id=w,this._type=I,this._name=p,this._workspaceFolder=g,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,w)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=d;class u{constructor(o){this.value=Object.freeze({append(w){o.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=u;class t extends h.AbstractVariableResolverService{constructor(o,w,I,p){super({getFolderUri:g=>{const R=o.filter(F=>F.name===g);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(g,R)=>I.getConfiguration(void 0,g).get(R),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(w){const g=w.activeEditor();if(g)return E.normalize(g.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(w&&p){const g=w.activeEditor();if(g){const R=p.getWorkspaceFolder(g.document.uri);if(R)return E.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(w){const g=w.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(w){const g=w.activeEditor();if(g)return String(g.selection.end.line+1)}}},void 0,b.env)}}e.ExtHostVariableResolverService=t;class i{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(w=>w.onError?w.onError(o):void 0)}onExit(o,w){this.trackers.forEach(I=>I.onExit?I.onExit(o,w):void 0)}}class c extends y.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends v{constructor(o,w,I,p,g){super(o,w,I,p,g)}createVariableResolver(o,w,I){return new t(o,w,I)}};a=qe([Ge(0,s.IExtHostRpcService),Ge(1,n.IExtHostWorkspace),Ge(2,T.IExtHostExtensionService),Ge(3,k.IExtHostDocumentsAndEditors),Ge(4,f.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(ve[220],_e([0,1,78,2,5,34,33,26,15,27,4,35,45,19]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(v,d,u,t,i,c,a){this._apiFactory=v,this._extensionRegistry=d,this._instaService=u,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=c,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,d,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,d,this._initData.environment.appUriScheme))}register(v){if(Array.isArray(v.nodeModuleName))for(let d of v.nodeModuleName)this._factories.set(d,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(d=>v.alternativeModuleName(d))}};r=qe([Ge(2,T.IInstantiationService),Ge(3,A.IExtHostConfiguration),Ge(4,k.IExtHostExtensionService),Ge(5,n.IExtHostInitDataService),Ge(6,f.ILogService)],r),e.RequireInterceptor=r;class s{constructor(v,d,u,t,i){this._apiFactory=v,this._extensionPaths=d,this._extensionRegistry=u,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,d){const u=this._extensionPaths.findSubstr(d.fsPath);if(u){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(u.identifier));return t||(t=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(u.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,c)=>t+=`	${c} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(v,d){this.nodeModuleName="keytar";const{environment:u}=d,t=v.getProxy(P.MainContext.MainThreadKeytar);if(u.appRoot){let i=u.appRoot.fsPath;h.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,c)=>t.$getPassword(i,c),setPassword:(i,c,a)=>t.$setPassword(i,c,a),deletePassword:(i,c)=>t.$deletePassword(i,c),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(v,d){return this._impl}alternativeModuleName(v){const d=v.length;if(!(d<=7||!this.alternativeNames)){const u=d-7;if((v.charAt(u)==="/"||v.charAt(u)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}}};_=qe([Ge(0,y.IExtHostRpcService),Ge(1,n.IExtHostInitDataService)],_);let m=class{constructor(v,d,u){this._extensionPaths=v,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(P.MainContext.MainThreadTelemetry);const t=u.getProxy(P.MainContext.MainThreadWindow);this._impl=(i,c)=>{const a=C.URI.parse(i);return c?this.callOriginal(i,c):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,i,{}):this.callOriginal(i,c)}}load(v,d,u){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=u(v),this._impl}callOriginal(v,d){return this.sendNoForwardTelemetry(),this._original(v,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=qe([Ge(2,y.IExtHostRpcService)],m)}),define(ve[221],_e([0,1,14,10,78,6,2,5,213,19,62,66,27,150,15,70,35,40]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(d,u,t,i){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const c=new y.RPCProtocol(d,null,i);u=b._transform(u,c);const a=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());a.set(h.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},u)),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(c)),a.set(s.IURITransformerService,new s.URITransformerService(i)),a.set(_.IHostUtils,t);const l=new f.InstantiationService(a,!0),o=l.invokeFunction(g=>g.get(m.IExtHostTerminalService));this._disposables.add(o),this._logService=l.invokeFunction(g=>g.get(n.ILogService)),P.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",u),this._extensionService=l.invokeFunction(g=>g.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(g=>{Error.prepareStackTrace=(R,F)=>{let $="",ue,z;for(const B of F)$+=`
	at ${B.toString()}`,z=B.getFileName(),!ue&&z&&(ue=g.findSubstr(z));return w.set(R,ue),`${R.name||"Error"}: ${R.message||""}${$}`}});const I=c.getProxy(D.MainContext.MainThreadExtensionService),p=c.getProxy(D.MainContext.MainThreadErrors);C.setUnexpectedErrorHandler(g=>{const R=C.transformErrorForSerialization(g),F=w.get(g);F?I.$onExtensionRuntimeError(F.identifier,R):p.$onUnexpectedError(R)})}terminate(d){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),C.setUnexpectedErrorHandler(t=>{});const u=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),u]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(d,u){d.extensions.forEach(i=>i.extensionLocation=S.URI.revive(u.transformIncomingURIs(i.extensionLocation))),d.environment.appRoot=S.URI.revive(u.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(i=>S.URI.revive(u.transformIncomingURIs(i)))),d.environment.extensionTestsLocationURI=S.URI.revive(u.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=S.URI.revive(u.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=S.URI.revive(u.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=S.URI.revive(u.transformIncomingURIs(d.logsLocation)),d.logFile=S.URI.revive(u.transformIncomingURIs(d.logFile)),d.workspace=u.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=b}),define(ve[222],_e([0,1,12,20,61,28,25,56,41]),function(ee,e,E,C,P,A,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class n{constructor(h,f,r){this.config=h,this.provider=f,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&A.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&A.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const f=this.config.folderQueries||[];return new Promise((r,s)=>{const _=m=>{this.resultCount++,h(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const b=m.toString(),v=E.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,v)||this.matchFile(_,{base:m,basename:v})}),Promise.all(f.map(m=>this.searchInFolder(m,_))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{s(new Error((0,P.toErrorMessage)(m)))})})}async searchInFolder(h,f){const r=new C.CancellationTokenSource,s=this.getSearchOptionsForFolder(h),_=this.initDirectoryTree(),m=new y.QueryGlobTester(this.config,h),b=!m.hasSiblingExcludeClauses();let v;try{this.activeCancellationTokens.add(r),v=D.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,r.token),u=v.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(i=>{const c=E.posix.relative(h.folder.path,i.path);if(b){const a=E.basename(i.path);this.matchFile(f,{base:h.folder,relativePath:c,basename:a});return}this.addDirectoryEntries(_,h.folder,c,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,m,f),{providerTime:u,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(h){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),r=(0,y.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:r,includes:f,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},f,r,s){if(r===this.filePattern){const m=E.basename(this.filePattern);this.matchFile(s,{base:f,relativePath:this.filePattern,basename:m})}function _(m){const b=E.basename(m),v=E.dirname(m);let d=h[v];d||(d=h[v]=[],_(v)),d.push({base:f,relativePath:m,basename:b})}_(r)}matchDirectoryTree({rootEntries:h,pathToEntries:f},r,s){const _=this,m=this.filePattern;function b(v){const d=A.hasSiblingFn(()=>v.map(u=>u.basename));for(let u=0,t=v.length;u<t;u++){const i=v[u],{relativePath:c,basename:a}=i;if(!!r.includedInQuerySync(c,a,m!==a?d:void 0)){const l=f[c];if(l)b(l);else{if(c===m)continue;_.matchFile(s,i)}if(_.isLimitHit)break}}}b(h)}matchFile(h,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(f))}}class T{constructor(){this.sessions=new Map}fileSearch(h,f,r,s){const _=this.getSessionTokenSource(h.cacheKey),m=new n(h,f,_&&_.token);let b=0;const v=d=>{b+=d.length,r(d.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(m,T.BATCH_SIZE,v,s).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:d.stats}}))}clearCache(h){const f=this.getSessionTokenSource(h);f&&f.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new C.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:S.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,f,r,s){s.onCancellationRequested(()=>{h.cancel()});const _=b=>{b&&(m.push(b),f>0&&m.length>=f&&(r(m),m=[]))};let m=[];return h.search(_).then(b=>(m.length&&r(m),b),b=>(m.length&&r(m),Promise.reject(b)))}}e.FileSearchManager=T,T.BATCH_SIZE=512}),define(ve[223],_e([0,1,12,11,20,61,25,28,2,41,18]),function(ee,e,E,C,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(b,v,d){this.query=b,this.provider=v,this.fileUtils=d,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,v){const d=this.query.folderQueries||[],u=new P.CancellationTokenSource;return v.onCancellationRequested(()=>u.cancel()),new Promise((t,i)=>{this.collector=new f(b);let c=!1;const a=(l,o)=>{if(!c&&!this.isLimitHit){const w=this.resultSize(l);s(l)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,c=!0,u.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const I=this.resultSize(l);this.resultCount+=I,(I>0||!s(l))&&this.collector.add(l,o)}};Promise.all(d.map((l,o)=>this.searchInFolder(l,w=>a(w,o),u.token))).then(l=>{u.dispose(),this.collector.flush();const o=l.some(w=>!!w&&!!w.limitHit);t({limitHit:this.isLimitHit||o,stats:{type:"textSearchProvider"}})},l=>{u.dispose();const o=(0,A.toErrorMessage)(l);i(new Error(o))})})}resultSize(b){return s(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,v){const d=Array.isArray(b.ranges)?b.ranges:[b.ranges],u=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:d.slice(0,v),preview:{matches:u.slice(0,v),text:b.preview.text},uri:b.uri}}async searchInFolder(b,v,d){const u=new n.QueryGlobTester(this.query,b),t=[],i={report:l=>{if(!!this.validateProviderResult(l)){const o=b.folder.scheme===T.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(l.uri))):void 0,w=S.relativePath(b.folder,l.uri);w&&t.push(u.includedInQuery(w,E.basename(w),o).then(I=>{I&&v(l)}))}}},c=this.getSearchOptionsForFolder(b),a=await this.provider.provideTextSearchResults(h(this.query.contentPattern),c,i,d);return await Promise.all(t),a}validateProviderResult(b){if(s(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const v=(0,n.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),d=(0,n.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),u={folder:y.URI.from(b.folder),excludes:d,includes:v,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return u.usePCRE2=this.query.usePCRE2,u}}e.TextSearchManager=k;function h(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class f{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,v=>this.sendItems(v))}add(b,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!S.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(r(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=f;function r(m){return s(m)?{preview:{matches:(0,C.mapArrayOrNot)(m.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:m.preview.text},ranges:(0,C.mapArrayOrNot)(m.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function s(m){return!!m.preview}e.extensionResultIsMatch=s;class _{constructor(b,v){this.maxBatchSize=b,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,v){!b||this.addItemToBatch(b,v)}addItems(b,v){!b||this.addItemsToBatch(b,v)}addItemToBatch(b,v){this.batch.push(b),this.batchSize+=v,this.onUpdate()}addItemsToBatch(b,v){this.batch=this.batch.concat(b),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(ve[103],_e([0,1,6,5,4,222,15,70,19,2,223]),function(ee,e,E,C,P,A,S,D,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let k=class{constructor(s,_,m){this.extHostRpc=s,this._uriTransformer=_,this._logService=m,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,_){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const m=this._handlePool++;return this._textSearchProvider.set(m,_),this._proxy.$registerTextSearchProvider(m,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(s,_){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const m=this._handlePool++;return this._fileSearchProvider.set(m,_),this._proxy.$registerFileSearchProvider(m,this._transformScheme(s)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(s,_,m,b){const v=h(m),d=this._fileSearchProvider.get(s);if(d)return this._fileSearchManager.fileSearch(v,d,u=>{this._proxy.$handleFileMatch(s,_,u.map(t=>t.resource))},b);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,_,m,b){const v=this._textSearchProvider.get(s);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const d=h(m);return this.createTextSearchManager(d,v).search(t=>this._proxy.$handleTextMatch(s,_,t),b)}createTextSearchManager(s,_){return new T.TextSearchManager(s,_,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};k=qe([Ge(0,S.IExtHostRpcService),Ge(1,D.IURITransformerService),Ge(2,y.ILogService)],k),e.ExtHostSearch=k;function h(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(f),extraFileResources:r.extraFileResources&&r.extraFileResources.map(s=>n.URI.revive(s))})}e.reviveQuery=h;function f(r){return Object.assign(Object.assign({},r),{folder:n.URI.revive(r.folder)})}}),define(ve[224],_e([0,1,128,20,10,3,46,2,121,83,115,60,65,5,189,188,74,190,34,191,192,193,175,194,39,35,195,176,197,198,199,99,179,202,203,204,76,40,205,180,9,7,208,50,100,31,33,51,165,196,92,98,101,102,103,19,70,15,27,200,163,69,73,186,206,162,77,75,211,209,210,187,48,217,207,72,159,93,201]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v,d,u,t,i,c,a,l,o,w,I,p,g,R,F,$,ue,z,B,G,M,N,W,Q,x,Z,re,oe,ye,Pe,Be,Re,ze,U,K,ne,le,fe,De,Oe,me,Ce,Ae,$e,be,Ke,V,X,ge,Me,We,Ue,Ze,H,ie,de,j,Y,ae,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ee(Ne){const Le=Ne.get(Oe.IExtHostInitDataService),je=Ne.get(H.IExtHostFileSystemInfo),Je=Ne.get(ge.IExtHostConsumerFileSystem),nt=Ne.get(a.IExtHostExtensionService),rt=Ne.get(re.IExtHostWorkspace),ot=Ne.get(ae.IExtHostTelemetry),it=Ne.get(b.IExtHostConfiguration),pt=Ne.get(fe.IURITransformerService),Ve=Ne.get(De.IExtHostRpcService),pe=Ne.get(z.IExtHostStorage),Se=Ne.get(X.IExtensionStoragePaths),se=Ne.get(le.ILogService),q=Ne.get(Ae.IExtHostTunnelService),Fe=Ne.get($e.IExtHostApiDeprecationService),Ie=Ne.get(Z.IExtHostWindow),Ye=Ne.get(j.IExtHostSecretState);Ve.set(f.ExtHostContext.ExtHostFileSystemInfo,je),Ve.set(f.ExtHostContext.ExtHostLogService,se),Ve.set(f.ExtHostContext.ExtHostWorkspace,rt),Ve.set(f.ExtHostContext.ExtHostConfiguration,it),Ve.set(f.ExtHostContext.ExtHostExtensionService,nt),Ve.set(f.ExtHostContext.ExtHostStorage,pe),Ve.set(f.ExtHostContext.ExtHostTunnelService,q),Ve.set(f.ExtHostContext.ExtHostWindow,Ie),Ve.set(f.ExtHostContext.ExtHostSecretState,Ye),Ve.set(f.ExtHostContext.ExtHostTelemetry,ot);const Xe=Ve.set(f.ExtHostContext.ExtHostDecorations,Ne.get(ze.IExtHostDecorations)),at=Ve.set(f.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(c.IExtHostDocumentsAndEditors)),st=Ve.set(f.ExtHostContext.ExtHostCommands,Ne.get(_.IExtHostCommands)),Qe=Ve.set(f.ExtHostContext.ExtHostTerminalService,Ne.get(B.IExtHostTerminalService)),lt=Ve.set(f.ExtHostContext.ExtHostDebugService,Ne.get(K.IExtHostDebugService)),bt=Ve.set(f.ExtHostContext.ExtHostSearch,Ne.get(ne.IExtHostSearch)),ct=Ve.set(f.ExtHostContext.ExtHostTask,Ne.get(U.IExtHostTask)),vt=Ve.set(f.ExtHostContext.ExtHostOutputService,Ne.get(g.IExtHostOutputService)),wt=Ve.set(f.ExtHostContext.ExtHostEditorTabs,new Y.ExtHostEditorTabs),yt=Ve.set(f.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(Ve)),_t=Ve.set(f.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Ve,at)),Mt=Ve.set(f.ExtHostContext.ExtHostDocumentContentProviders,new u.ExtHostDocumentContentProvider(Ve,at,se)),Tt=Ve.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(se,_t,Ve.getProxy(f.MainContext.MainThreadBulkEdits))),ft=Ve.set(f.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(Ve,st,at,_t,Le.environment,se,Se)),Vt=Ve.set(f.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(Ve,Le,ft)),Et=Ve.set(f.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(Ve,at)),Wt=Ve.set(f.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(Ve.getProxy(f.MainContext.MainThreadTreeViews),st,se)),jt=Ve.set(f.ExtHostContext.ExtHostEditorInsets,new Pe.ExtHostEditorInsets(Ve.getProxy(f.MainContext.MainThreadEditorInsets),Et,Le.environment)),Ot=Ve.set(f.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Ve,se)),dt=Ve.set(f.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(Ve,pt,_t,st,Ot,se,Fe)),dn=Ve.set(f.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ve,dt)),kt=Ve.set(f.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(Ve,se,at)),Rt=Ve.set(f.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Ve,rt,st)),tn=Ve.set(f.ExtHostContext.ExtHostSCM,new $.ExtHostSCM(Ve,st,se)),hn=Ve.set(f.ExtHostContext.ExtHostComments,new m.ExtHostComments(Ve,st,_t)),nn=Ve.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Ve.getProxy(f.MainContext.MainThreadProgress))),fn=Ve.set(f.ExtHostContext.ExtHosLabelService,new Be.ExtHostLabelService(Ve)),rn=Ve.set(f.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(Ve)),Pt=Ve.set(f.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(Ve)),qt=Ve.set(f.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(Ve,st)),Kt=Ve.set(f.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Ve,Le.environment,rt,se,Fe)),Gt=Ve.set(f.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(Ve,Kt,rt)),mn=Ve.set(f.ExtHostContext.ExtHostCustomEditors,new We.ExtHostCustomEditors(Ve,_t,Se,Kt,Gt)),gn=Ve.set(f.ExtHostContext.ExtHostWebviewViews,new Me.ExtHostWebviewViews(Ve,Kt)),Dt=Ve.set(f.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(Ve,at,rt)),pn=Ve.set(f.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(Ve)),vn=(0,ye.values)(f.ExtHostContext);Ve.assertRegistered(vn);const Qt=new Ze.ExtHostBulkEdits(Ve,at),bn=new s.ExtHostClipboard(Ve),Nt=new p.ExtHostMessageService(Ve,se),Ht=new d.ExtHostDialogs(Ve),Ut=new ue.ExtHostStatusBar(Ve,st.converter),Jt=new I.ExtHostLanguages(Ve,_t);return r.ExtHostApiCommands.register(st),function(Te,xt,Yt){const mt=function(){let J=!Te.isUnderDevelopment;function ce(ke){J||(se.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")ce(ut);else{const O=ut;typeof O.scheme=="undefined"&&ce(ut),!Te.enableProposedApi&&typeof O.exclusive=="boolean"&&(0,oe.throwProposedApiError)(Te)}return ut}}(),_n={getSession(J,ce,ke){return Pt.getSession(Te,J,ce,ke)},get onDidChangeSessions(){return Pt.onDidChangeSessions},registerAuthenticationProvider(J,ce,ke,ut){return Pt.registerAuthenticationProvider(J,ce,ke,ut)},get onDidChangeAuthenticationProviders(){return(0,oe.checkProposedApiEnabled)(Te),Pt.onDidChangeAuthenticationProviders},get providers(){return(0,oe.checkProposedApiEnabled)(Te),Pt.providers},logout(J,ce){return(0,oe.checkProposedApiEnabled)(Te),Pt.removeSession(J,ce)}},wn={registerCommand(J,ce,ke){return st.registerCommand(!0,J,ce,ke)},registerTextEditorCommand(J,ce,ke){return st.registerCommand(!0,J,(...ut)=>{const O=Et.getActiveTextEditor();if(!O){se.warn("Cannot execute "+J+" because there is no active text editor.");return}return O.edit(L=>{ce.apply(ke,[O,L,...ut])}).then(L=>{L||se.warn("Edits from command "+J+" were not applied.")},L=>{se.warn("An error occurred while running command "+J,L)})})},registerDiffInformationCommand:(J,ce,ke)=>((0,oe.checkProposedApiEnabled)(Te),st.registerCommand(!0,J,async(...ut)=>{const O=at.activeEditor(!0);if(!O){se.warn("Cannot execute "+J+" because there is no active text editor.");return}const L=await Et.getDiffInformation(O.id);ce.apply(ke,[L,...ut])})),executeCommand(J,...ce){return st.executeCommand(J,...ce)},getCommands(J=!1){return st.getCommands(J)}},sn={get machineId(){return Le.telemetryInfo.machineId},get sessionId(){return Le.telemetryInfo.sessionId},get language(){return Le.environment.appLanguage},get appName(){return Le.environment.appName},get appRoot(){var J,ce;return(ce=(J=Le.environment.appRoot)===null||J===void 0?void 0:J.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Le.environment.appUriScheme},get clipboard(){return bn.value},get shell(){return Qe.getDefaultShell(!1,Yt)},get isTelemetryEnabled(){return ot.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ot.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Le.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return Ie.openUri(J,{allowTunneling:!!Le.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(J){return J.scheme===Le.environment.appUriScheme?yt.createAppUri(J):Ie.asExternalUri(J,{allowTunneling:!!Le.remote.authority})},get remoteName(){return(0,Re.getRemoteName)(Le.remote.authority)},get uiKind(){return Le.uiKind}};Le.environment.extensionTestsLocationURI||Object.freeze(sn);const on=Le.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Xt={registerTestProvider(J){return(0,oe.checkProposedApiEnabled)(Te),Dt.registerTestProvider(J)},createDocumentTestObserver(J){return(0,oe.checkProposedApiEnabled)(Te),Dt.createTextDocumentTestObserver(J)},createWorkspaceTestObserver(J){return(0,oe.checkProposedApiEnabled)(Te),Dt.createWorkspaceTestObserver(J)},runTests(J){return(0,oe.checkProposedApiEnabled)(Te),Dt.runTests(J)},publishTestResult(J,ce=!0){return(0,oe.checkProposedApiEnabled)(Te),Dt.publishExtensionProvidedResults(J,ce)},get onDidChangeTestResults(){return(0,oe.checkProposedApiEnabled)(Te),Dt.onResultsChanged},get testResults(){return(0,oe.checkProposedApiEnabled)(Te),Dt.results}},En={getExtension(J){const ce=xt.getExtensionDescription(J);if(ce)return new a.Extension(nt,Te.identifier,ce,on)},get all(){return xt.getAllExtensionDescriptions().map(J=>new a.Extension(nt,Te.identifier,J,on))},get onDidChange(){return xt.onDidChange}},yn={createDiagnosticCollection(J){return Ot.createDiagnosticCollection(Te.identifier,J)},get onDidChangeDiagnostics(){return Ot.onDidChangeDiagnostics},getDiagnostics:J=>Ot.getDiagnostics(J),getLanguages(){return Jt.getLanguages()},setTextDocumentLanguage(J,ce){return Jt.changeLanguage(J.uri,ce)},match(J,ce){return(0,k.score)(N.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,ke){return dt.registerCodeActionProvider(Te,mt(J),ce,ke)},registerCodeLensProvider(J,ce){return dt.registerCodeLensProvider(Te,mt(J),ce)},registerDefinitionProvider(J,ce){return dt.registerDefinitionProvider(Te,mt(J),ce)},registerDeclarationProvider(J,ce){return dt.registerDeclarationProvider(Te,mt(J),ce)},registerImplementationProvider(J,ce){return dt.registerImplementationProvider(Te,mt(J),ce)},registerTypeDefinitionProvider(J,ce){return dt.registerTypeDefinitionProvider(Te,mt(J),ce)},registerHoverProvider(J,ce){return dt.registerHoverProvider(Te,mt(J),ce,Te.identifier)},registerEvaluatableExpressionProvider(J,ce){return dt.registerEvaluatableExpressionProvider(Te,mt(J),ce,Te.identifier)},registerInlineValuesProvider(J,ce){return dt.registerInlineValuesProvider(Te,mt(J),ce,Te.identifier)},registerDocumentHighlightProvider(J,ce){return dt.registerDocumentHighlightProvider(Te,mt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return dt.registerLinkedEditingRangeProvider(Te,mt(J),ce)},registerReferenceProvider(J,ce){return dt.registerReferenceProvider(Te,mt(J),ce)},registerRenameProvider(J,ce){return dt.registerRenameProvider(Te,mt(J),ce)},registerDocumentSymbolProvider(J,ce,ke){return dt.registerDocumentSymbolProvider(Te,mt(J),ce,ke)},registerWorkspaceSymbolProvider(J){return dt.registerWorkspaceSymbolProvider(Te,J)},registerDocumentFormattingEditProvider(J,ce){return dt.registerDocumentFormattingEditProvider(Te,mt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return dt.registerDocumentRangeFormattingEditProvider(Te,mt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,ke,...ut){return dt.registerOnTypeFormattingEditProvider(Te,mt(J),ce,[ke].concat(ut))},registerDocumentSemanticTokensProvider(J,ce,ke){return dt.registerDocumentSemanticTokensProvider(Te,mt(J),ce,ke)},registerDocumentRangeSemanticTokensProvider(J,ce,ke){return dt.registerDocumentRangeSemanticTokensProvider(Te,mt(J),ce,ke)},registerSignatureHelpProvider(J,ce,ke,...ut){return typeof ke=="object"?dt.registerSignatureHelpProvider(Te,mt(J),ce,ke):dt.registerSignatureHelpProvider(Te,mt(J),ce,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(J,ce,...ke){return dt.registerCompletionItemProvider(Te,mt(J),ce,ke)},registerDocumentLinkProvider(J,ce){return dt.registerDocumentLinkProvider(Te,mt(J),ce)},registerColorProvider(J,ce){return dt.registerColorProvider(Te,mt(J),ce)},registerFoldingRangeProvider(J,ce){return dt.registerFoldingRangeProvider(Te,mt(J),ce)},registerSelectionRangeProvider(J,ce){return dt.registerSelectionRangeProvider(Te,J,ce)},registerCallHierarchyProvider(J,ce){return dt.registerCallHierarchyProvider(Te,J,ce)},setLanguageConfiguration:(J,ce)=>dt.setLanguageConfiguration(Te,J,ce),getTokenInformationAtPosition(J,ce){return(0,oe.checkProposedApiEnabled)(Te),Jt.tokenAtPosition(J,ce)},registerInlineHintsProvider(J,ce){return(0,oe.checkProposedApiEnabled)(Te),dt.registerInlineHintsProvider(Te,J,ce)}},Sn={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return Qe.activeTerminal},get terminals(){return Qe.terminals},async showTextDocument(J,ce,ke){const ut=await(D.URI.isUri(J)?Promise.resolve(an.openTextDocument(J)):Promise.resolve(J));return Et.showTextDocument(ut,ce,ke)},createTextEditorDecorationType(J){return Et.createTextEditorDecorationType(J)},onDidChangeActiveTextEditor(J,ce,ke){return Et.onDidChangeActiveTextEditor(J,ce,ke)},onDidChangeVisibleTextEditors(J,ce,ke){return Et.onDidChangeVisibleTextEditors(J,ce,ke)},onDidChangeTextEditorSelection(J,ce,ke){return Et.onDidChangeTextEditorSelection(J,ce,ke)},onDidChangeTextEditorOptions(J,ce,ke){return Et.onDidChangeTextEditorOptions(J,ce,ke)},onDidChangeTextEditorVisibleRanges(J,ce,ke){return Et.onDidChangeTextEditorVisibleRanges(J,ce,ke)},onDidChangeTextEditorViewColumn(J,ce,ke){return Et.onDidChangeTextEditorViewColumn(J,ce,ke)},onDidCloseTerminal(J,ce,ke){return Qe.onDidCloseTerminal(J,ce,ke)},onDidOpenTerminal(J,ce,ke){return Qe.onDidOpenTerminal(J,ce,ke)},onDidChangeActiveTerminal(J,ce,ke){return Qe.onDidChangeActiveTerminal(J,ce,ke)},onDidChangeTerminalDimensions(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),Qe.onDidChangeTerminalDimensions(J,ce,ke)},onDidWriteTerminalData(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),Qe.onDidWriteTerminalData(J,ce,ke)},get state(){return Ie.state},onDidChangeWindowState(J,ce,ke){return Ie.onDidChangeWindowState(J,ce,ke)},showInformationMessage(J,...ce){return Nt.showMessage(Te,S.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return Nt.showMessage(Te,S.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return Nt.showMessage(Te,S.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,ke){return Rt.showQuickPick(J,!!Te.enableProposedApi,ce,ke)},showWorkspaceFolderPick(J){return Rt.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Rt.showInput(J,ce)},showOpenDialog(J){return Ht.showOpenDialog(J)},showSaveDialog(J){return Ht.showSaveDialog(J)},createStatusBarItem(J,ce){let ke,ut,O,L;return J&&typeof J!="number"?(ke=J.id,ut=J.name,O=J.alignment,ce=J.priority,L=J.accessibilityInformation):(ke=Te.identifier.value,ut=E.localize(0,null,Te.displayName||Te.name),O=J),Ut.createStatusBarEntry(ke,ut,O,ce,L)},setStatusBarMessage(J,ce){return Ut.setStatusBarMessage(J,ce)},withScmProgress(J){return Fe.report("window.withScmProgress",Te,"Use 'withProgress' instead."),nn.withProgress(Te,{location:W.ProgressLocation.SourceControl},(ce,ke)=>J({report(ut){}}))},withProgress(J,ce){return nn.withProgress(Te,J,ce)},createOutputChannel(J){return vt.createOutputChannel(J)},createWebviewPanel(J,ce,ke,ut){return Gt.createWebviewPanel(Te,J,ce,ke,ut)},createWebviewTextEditorInset(J,ce,ke,ut){return(0,oe.checkProposedApiEnabled)(Te),jt.createWebviewEditorInset(J,ce,ke,ut,Te)},createTerminal(J,ce,ke){return typeof J=="object"?"pty"in J?Qe.createExtensionTerminal(J):(J.message&&(0,oe.checkProposedApiEnabled)(Te),J.icon&&(0,oe.checkProposedApiEnabled)(Te),Qe.createTerminalFromOptions(J)):Qe.createTerminal(J,ce,ke)},registerTerminalLinkProvider(J){return Qe.registerLinkProvider(J)},registerTreeDataProvider(J,ce){return Wt.registerTreeDataProvider(J,ce,Te)},createTreeView(J,ce){return Wt.createTreeView(J,ce,Te)},registerWebviewPanelSerializer:(J,ce)=>Gt.registerWebviewPanelSerializer(Te,J,ce),registerCustomEditorProvider:(J,ce,ke={})=>mn.registerCustomEditorProvider(Te,J,ce,ke),registerFileDecorationProvider(J){return Xe.registerFileDecorationProvider(J,Te.identifier)},registerUriHandler(J){return yt.registerUriHandler(Te.identifier,J)},createQuickPick(){return Rt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Rt.createInputBox(Te.identifier)},get activeColorTheme(){return rn.activeColorTheme},onDidChangeActiveColorTheme(J,ce,ke){return rn.onDidChangeActiveColorTheme(J,ce,ke)},registerWebviewViewProvider(J,ce,ke){return gn.registerWebviewViewProvider(Te,J,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,oe.checkProposedApiEnabled)(Te),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeActiveNotebookEditor(J,ce,ke)},get visibleNotebookEditors(){return(0,oe.checkProposedApiEnabled)(Te),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookEditorSelection(J,ce,ke)},onDidChangeNotebookEditorVisibleRanges(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookEditorVisibleRanges(J,ce,ke)},showNotebookDocument(J,ce){return(0,oe.checkProposedApiEnabled)(Te),ft.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),pn.registerExternalUriOpener(Te.identifier,J,ce,ke)},get openEditors(){return(0,oe.checkProposedApiEnabled)(Te),wt.tabs},get onDidChangeOpenEditors(){return(0,oe.checkProposedApiEnabled)(Te),wt.onDidChangeTabs}},an={get rootPath(){return Fe.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),rt.getPath()},set rootPath(J){throw P.readonly()},getWorkspaceFolder(J){return rt.getWorkspaceFolder(J)},get workspaceFolders(){return rt.getWorkspaceFolders()},get name(){return rt.name},set name(J){throw P.readonly()},get workspaceFile(){return rt.workspaceFile},set workspaceFile(J){throw P.readonly()},updateWorkspaceFolders:(J,ce,...ke)=>rt.updateWorkspaceFolders(Te,J,ce||0,...ke),onDidChangeWorkspaceFolders:function(J,ce,ke){return rt.onDidChangeWorkspace(J,ce,ke)},asRelativePath:(J,ce)=>rt.getRelativePath(J,ce),findFiles:(J,ce,ke,ut)=>rt.findFiles(N.GlobPattern.from(J),N.GlobPattern.from(ce),ke,Te.identifier,ut),findTextInFiles:(J,ce,ke,ut)=>{let O,L;return typeof ce=="object"?(O=ce,L=ke):(O={},L=ce,ut=ke),rt.findTextInFiles(J,O||{},L,Te.identifier,ut)},saveAll:J=>rt.saveAll(J),applyEdit(J){return Qt.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,ke,ut)=>kt.createFileSystemWatcher(N.GlobPattern.from(J),ce,ke,ut),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw P.readonly()},openTextDocument(J){let ce;const ke=J;if(typeof J=="string")ce=Promise.resolve(D.URI.file(J));else if(D.URI.isUri(J))ce=Promise.resolve(J);else if(!ke||typeof ke=="object")ce=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(ut=>_t.ensureDocumentData(ut).then(O=>O.document))},onDidOpenTextDocument:(J,ce,ke)=>_t.onDidAddDocument(J,ce,ke),onDidCloseTextDocument:(J,ce,ke)=>_t.onDidRemoveDocument(J,ce,ke),onDidChangeTextDocument:(J,ce,ke)=>_t.onDidChangeDocument(J,ce,ke),onDidSaveTextDocument:(J,ce,ke)=>_t.onDidSaveDocument(J,ce,ke),onWillSaveTextDocument:(J,ce,ke)=>Tt.getOnWillSaveTextDocumentEvent(Te)(J,ce,ke),onDidChangeConfiguration:(J,ce,ke)=>Yt.onDidChangeConfiguration(J,ce,ke),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,Yt.getConfiguration(J,ce,Te)},registerTextDocumentContentProvider(J,ce){return Mt.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(Fe.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),ct.registerTaskProvider(Te,J,ce)),registerFileSystemProvider(J,ce,ke){return dn.registerFileSystemProvider(Te.identifier,J,ce,ke)},get fs(){return Je.value},registerFileSearchProvider:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),bt.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),bt.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),nt.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>((0,oe.checkProposedApiEnabled)(Te),fn.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,ke)=>kt.onDidCreateFile(J,ce,ke),onDidDeleteFiles:(J,ce,ke)=>kt.onDidDeleteFile(J,ce,ke),onDidRenameFiles:(J,ce,ke)=>kt.onDidRenameFile(J,ce,ke),onWillCreateFiles:(J,ce,ke)=>kt.getOnWillCreateFileEvent(Te)(J,ce,ke),onWillDeleteFiles:(J,ce,ke)=>kt.getOnWillDeleteFileEvent(Te)(J,ce,ke),onWillRenameFiles:(J,ce,ke)=>kt.getOnWillRenameFileEvent(Te)(J,ce,ke),openTunnel:J=>((0,oe.checkProposedApiEnabled)(Te),q.openTunnel(Te,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,oe.checkProposedApiEnabled)(Te),q.getTunnels()},onDidChangeTunnels:(J,ce,ke)=>((0,oe.checkProposedApiEnabled)(Te),q.onDidChangeTunnels(J,ce,ke)),registerPortAttributesProvider:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),q.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),qt.registerTimelineProvider(J,ce,Te.identifier,st.converter)),get isTrusted(){return(0,oe.checkProposedApiEnabled)(Te),rt.trusted},requestWorkspaceTrust:J=>((0,oe.checkProposedApiEnabled)(Te),rt.requestWorkspaceTrust(J)),onDidReceiveWorkspaceTrust:(J,ce,ke)=>rt.onDidReceiveWorkspaceTrust(J,ce,ke)},Dn={get inputBox(){return Fe.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),tn.getLastInputBox(Te)},createSourceControl(J,ce,ke){return tn.createSourceControl(Te,J,ce,ke)}},ln={createCommentController(J,ce){return hn.createCommentController(Te,J,ce)}},zt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(J,ce,ke){return lt.onDidStartDebugSession(J,ce,ke)},onDidTerminateDebugSession(J,ce,ke){return lt.onDidTerminateDebugSession(J,ce,ke)},onDidChangeActiveDebugSession(J,ce,ke){return lt.onDidChangeActiveDebugSession(J,ce,ke)},onDidReceiveDebugSessionCustomEvent(J,ce,ke){return lt.onDidReceiveDebugSessionCustomEvent(J,ce,ke)},onDidChangeBreakpoints(J,ce,ke){return lt.onDidChangeBreakpoints(J,ce,ke)},registerDebugConfigurationProvider(J,ce,ke){return lt.registerDebugConfigurationProvider(J,ce,ke||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return lt.registerDebugAdapterDescriptorFactory(Te,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return lt.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(J,ce,{parentSession:ke}):lt.startDebugging(J,ce,ke||{})},stopDebugging(J){return lt.stopDebugging(J)},addBreakpoints(J){return lt.addBreakpoints(J)},removeBreakpoints(J){return lt.removeBreakpoints(J)},asDebugSourceUri(J,ce){return lt.asDebugSourceUri(J,ce)}},un={registerTaskProvider:(J,ce)=>ct.registerTaskProvider(Te,J,ce),fetchTasks:J=>ct.fetchTasks(J),executeTask:J=>ct.executeTask(Te,J),get taskExecutions(){return ct.taskExecutions},onDidStartTask:(J,ce,ke)=>ct.onDidStartTask(J,ce,ke),onDidEndTask:(J,ce,ke)=>ct.onDidEndTask(J,ce,ke),onDidStartTaskProcess:(J,ce,ke)=>ct.onDidStartTaskProcess(J,ce,ke),onDidEndTaskProcess:(J,ce,ke)=>ct.onDidEndTaskProcess(J,ce,ke)},Cn={openNotebookDocument:J=>((0,oe.checkProposedApiEnabled)(Te),ft.openNotebookDocument(J)),get onDidOpenNotebookDocument(){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,oe.checkProposedApiEnabled)(Te),ft.notebookDocuments.map(J=>J.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.registerNotebookSerializer(Te,J,ce,ke)},registerNotebookContentProvider:(J,ce,ke)=>((0,oe.checkProposedApiEnabled)(Te),ft.registerNotebookContentProvider(Te,J,ce,ke)),registerNotebookKernelProvider:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),ft.registerNotebookKernelProvider(Te,J,ce)),registerNotebookCellStatusBarItemProvider:(J,ce)=>((0,oe.checkProposedApiEnabled)(Te),ft.registerNotebookCellStatusBarItemProvider(Te,J,ce)),createNotebookEditorDecorationType(J){return(0,oe.checkProposedApiEnabled)(Te),ft.createNotebookEditorDecorationType(J)},onDidChangeNotebookDocumentMetadata(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookDocumentMetadata(J,ce,ke)},onDidChangeNotebookCells(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookCells(J,ce,ke)},onDidChangeCellExecutionState(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeNotebookCellExecutionState(J,ce,ke)},onDidChangeCellOutputs(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeCellOutputs(J,ce,ke)},onDidChangeCellMetadata(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.onDidChangeCellMetadata(J,ce,ke)},createConcatTextDocument(J,ce){return(0,oe.checkProposedApiEnabled)(Te),new V.ExtHostNotebookConcatDocument(ft,_t,J,ce)},createNotebookCellExecutionTask(J,ce,ke){return(0,oe.checkProposedApiEnabled)(Te),ft.createNotebookCellExecution(J,ce,ke)},createNotebookController(J){return(0,oe.checkProposedApiEnabled)(Te),Vt.createKernel(Te,J)}};return{version:Le.version,authentication:_n,commands:wn,comments:ln,debug:zt,env:sn,extensions:En,languages:yn,notebook:Cn,scm:Dn,tasks:un,test:Xt,window:Sn,workspace:an,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:C.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:h.FileType,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,Hover:W.Hover,IndentAction:T.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:D.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlineHint:W.InlineHint,InlineHintKind:W.InlineHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookDocumentMetadata:W.NotebookDocumentMetadata,NotebookCellMetadata:W.NotebookCellMetadata,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,LinkedEditingRanges:W.LinkedEditingRanges,TestItem:W.TestItem,TestResultState:W.TestResultState,TestMessage:W.TestMessage,TestMessageSeverity:W.TestMessageSeverity,WorkspaceTrustState:W.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ee}),define(ve[225],_e([0,1,62,99,31,98,34,74,39,40,101,102,103,77,76,69,73,100,75,48,72,93]),function(ee,e,E,C,P,A,S,D,y,n,T,k,h,f,r,s,_,m,b,v,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,E.registerSingleton)(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),(0,E.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,E.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,E.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,E.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,E.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,E.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService),(0,E.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch),(0,E.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,E.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,E.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,E.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace),(0,E.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,E.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry)}),define(ve[226],_e([0,1,224,35,220,7,14,5]),function(ee,e,E,C,P,A,S,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(r){var s;const _=(s=self.trustedTypes)===null||s===void 0?void 0:s.createPolicy("TrustedFunctionWorkaround",{createScript:(b,...v)=>{v.forEach(i=>{var c;if(!((c=self.trustedTypes)===null||c===void 0?void 0:c.isScript(i)))throw new Error("TrustedScripts only, please")});const d=v.slice(0,-1).join(","),u=v.pop().toString();return`(function anonymous(${d}) {
${u}
})`}});function m(...b){return _?self.eval(_.createScript("",...b)):new Function(...b)}r.create=m})(n||(n={}));class T extends P.RequireInterceptor{_installInterceptor(){}getModule(s,_){for(let m of this._alternatives){let b=m(s);if(b){s=b;break}}if(this._factories.has(s))return this._factories.get(s).load(s,_,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);f(s,this._initData.environment.isExtensionDevelopmentDebug);const _=this._instaService.invokeFunction(E.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,_,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,_,m){var b,v,d,u,t,i,c,a;_=_.with({path:h(_.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const l=await fetch(_.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),l.status!==200)throw new Error(l.statusText);const o=await l.text(),w=`${_.toString(!0)}#vscode-extension`,I=`${o}
//# sourceURL=${w}`;let p;try{p=n.create((v=(b=k._ttpExtensionScripts)===null||b===void 0?void 0:b.createScript("module"))!==null&&v!==void 0?v:"module",(u=(d=k._ttpExtensionScripts)===null||d===void 0?void 0:d.createScript("exports"))!==null&&u!==void 0?u:"exports",(i=(t=k._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(a=(c=k._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript(I))!==null&&a!==void 0?a:I)}catch($){throw s?console.error(`Loading code for extension ${s.value} failed: ${$.message}`):console.error(`Loading code failed: ${$.message}`),console.error(`${_.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}const g={},R={exports:g},F=$=>{const ue=this._fakeModules.getModule($,_);if(ue===void 0)throw new Error(`Cannot load module '${$}'`);return ue};try{return m.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),p(R,g,F),R.exports!==g?R.exports:g}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(s){throw new Error("Not supported")}async _waitForDebuggerAttachment(s=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const _=Date.now()+s;for(;Date.now()<_&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function h(r,s){return r.endsWith(s)?r:r+s}function f(r,s){_("info","log"),_("log","log"),_("warn","warn"),_("error","error");function _(v,d){const u=console[v];console[v]=function(){r.$logExtensionHostMessage({type:"__$console",severity:d,arguments:b(arguments)}),s&&u.apply(console,arguments)}}const m=1e5;function b(v){const d=[],u=[];if(v.length)for(let t=0;t<v.length;t++){if(typeof v[t]=="undefined")v[t]="undefined";else if(v[t]instanceof Error){const i=v[t];i.stack?v[t]=i.stack:v[t]=i.toString()}u.push(v[t])}try{const t=JSON.stringify(u,function(i,c){if(c&&typeof c=="object"){if(d.indexOf(c)!==-1)return"[Circular]";d.push(c)}return c});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[227],_e([0,1,62,19,35,226,212]),function(ee,e,E,C,P,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(P.IExtHostExtensionService,A.ExtHostExtensionService),(0,E.registerSingleton)(C.ILogService,S.ExtHostLogService)}),define(ve[229],_e([0,1,23,3,183,221,214,12,78,225,227]),function(ee,e,E,C,P,A,S,D,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const k=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const _=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:b=>b}),m=self.Worker;Worker=function(b,v){const d=`importScripts('${b}');`;v=v||{},v.name=v.name||D.basename(b.toString());const u=new Blob([d],{type:"application/javascript"}),t=URL.createObjectURL(u);return new m(_?_.createScriptURL(t):t,v)}}else self.Worker=class extends S.NestedWorker{constructor(_,m){super(k,_,Object.assign({name:D.basename(_.toString())},m))}};const h=new class{exit(_){T()}async exists(_){return!0}async realpath(_){return _}};class f{constructor(){const m=new MessageChannel,b=new C.Emitter;let v=!1;k(m.port2,[m.port2]),m.port1.onmessage=d=>{const{data:u}=d;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const t=E.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,P.isMessageOfType)(t,2)){v=!0,s("received terminate message from renderer");return}b.fire(t)},this.protocol={onMessage:b.event,send:d=>{if(!v){const u=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);m.port1.postMessage(u,[u])}}}}}function r(_){return new Promise(m=>{const b=_.onMessage(v=>{b.dispose();const d=JSON.parse(v.toString());_.send((0,P.createMessageOfType)(0)),m({protocol:_,initData:d})});_.send((0,P.createMessageOfType)(1))})}let s=_=>T();(function(){const m=new f;y.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(b=>{y.mark("code/extHost/didWaitForInitData");const v=new A.ExtensionHostMain(b.protocol,b.initData,h,null);s=d=>v.terminate(d)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ce791d27dc9889a392f4d29abefe9c53eb0b5129/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
